-- ud_101_20150727.sql
-- ud_104_20150805.sql
-- ud_105_20150807.sql
-- CE0510694B74C7DCA2AC09BDDC402B4F 

ALTER TABLE KARTA 
    ADD PR_NOV INTEGER,
    ADD HARD_LINK INTEGER; @

CREATE OR ALTER VIEW KARTA_VIEWER(
    IDK,
    ID_REP,
    NHISTORY,
    SPOLIS,
    NPOLIS,
    SMO,
    MCOD,
    FAM,
    IM,
    OT,
    W,
    DR,
    STAGE,
    DATE_ENTER,
    DATE_1,
    DATE_2,
    RSLT,
    MD5_HASH,
    TD,
    GD,
    MON,
    IN_REP,
    DOCTYPE,
    DOCSER,
    DOCNUM,
    SNILS,
    IS_MD,
    ISOUT,
    SANK_MEK,
    IS_MEK,
    HARD_LINK)
AS
select K.IDK, K.ID_REP, K.NHISTORY, K.SPOLIS, K.NPOLIS, K.SMO, K.MCOD, K.FAM, K.IM, K.OT, K.W, K.DR, K.STAGE,
       K.DATE_ENTER, K.DATE_1, K.DATE_2, K.RSLT, K.MD5_HASH, K.TD, extract(year from K.DATE_ENTER) as GD,
       extract(month from K.DATE_ENTER) as MON, iif(K.ID_REP is null, 0, 1) as IN_REP, K.DOCTYPE, K.DOCSER, K.DOCNUM,
       K.SNILS,
       (iif((select count(*)
             from KARTA_USL KU
             inner join USL U on ((U.ID = KU.ID_USL) and
                   (U.IS_DOP_TARIF = '1'))
             where (KU.IDK = K.IDK) and
                   (U.IS_FINAL_MD = '1') and
                   (not KU.ID_MD is null) and
                   (KU.ID_MD <> 0)) = 0, '', '')) as IS_MD,
       (select P.ISOUT
        from P_KARTA P
        where P.IDK = K.IDK) as ISOUT,
        k.sank_mek, (iif(k.sank_mek is null, '','')),
        k.hard_link
from KARTA K
order by K.DATE_ENTER, upper(K.FAM collate PXW_CYRL), upper(K.IM collate PXW_CYRL), upper(K.OT collate PXW_CYRL), K.DR, K.TD, K.STAGE, K.IDK; @

CREATE OR ALTER procedure DROP_KARTA (
    DID integer)
as
begin
  delete from KARTA_USL U
  where U.IDK = :DID; 

  delete from KARTA K
  where K.IDK = :DID; 

  delete from DS D
  where D.IDK = :DID; 

  delete from KARTA_RSLT R
  where R.IDK = :DID; 

  delete from KARTA_RISK R
  where R.IDK = :DID; 

  delete from KARTA_TO_TWO T
  where T.IDK = :DID; 

  delete from P_KARTA_USL PU
  where PU.IDK = :DID; 

  delete from P_DS PD
  where PD.IDK = :DID; 

  delete from P_KARTA PK
  where PK.IDK = :DID;

  delete from sank s
  where s.idk=:DID;

  update karta k
  set k.hard_link=null
  where k.hard_link=:DID;
end; @