-- ud_074_20141008.sql       
-- ud_075_20141020.sql
-- ud_076_20141021.sql
-- ud_078_20141031.sql
-- ud_081_20141119.sql   
-- ud_084_20141209.sql
-- BD4A99EE667C446481F9B57308232366

CREATE TABLE FLAG_RSLT (
    ID_RSLT INTEGER,
    NAME_RSLT VARCHAR(150)); @

CREATE TABLE KARTA_RISK (
    IDK      INTEGER,
    ID_RISK  INTEGER); @
CREATE INDEX KARTA_RISK_IDK ON KARTA_RISK (IDK); @

CREATE TABLE KARTA_TO_TWO (
    IDK     INTEGER,
    ID_USL  INTEGER); @
CREATE INDEX KARTA_TO_TWO_IDK ON KARTA_TO_TWO (IDK); @

CREATE TABLE KARTA_RSLT (
    IDK      INTEGER,
    ID_RSLT  INTEGER); @
CREATE INDEX KARTA_RSLT_IDK ON KARTA_RSLT (IDK); @

CREATE TABLE U131 (
    USL_CODE VARCHAR(16),
    NPP INTEGER,
    TD CHAR(1),
    IS_OK_USL CHAR(1)); @
CREATE INDEX U131_USL_CODE ON U131 (USL_CODE,TD); @

CREATE TABLE UNIONDB (
    FILE_NAME  VARCHAR(20),
    SQL_TEXT   VARCHAR(500),
    IS_PARAMS  INTEGER,
    IS_LOAD    INTEGER); @

CREATE GLOBAL TEMPORARY TABLE TMP_COMPARE (
    TIP           INTEGER,
    ID_OLD_FIELD  INTEGER,
    ID_NEW_FIELD  INTEGER,
    FLAG_FIELD    INTEGER
) ON COMMIT PRESERVE ROWS; @
CREATE INDEX TMP_COMPARE_IDX_MAIN ON TMP_COMPARE (TIP, ID_OLD_FIELD); @

CREATE TABLE GROUP_MKB10 (
    NUM           INTEGER NOT NULL,
    RANGE         VARCHAR(20),
    DS1           VARCHAR(5),
    DS2           VARCHAR(5),
    PRECISION_DS  INTEGER); @
CREATE INDEX GROUP_MKB10_NUM ON GROUP_MKB10 (NUM); @

CREATE TABLE HOLIDAY (
    HDAY DATE,
    HTYPE CHAR(1)); @

CREATE TABLE N382 (
    NAME_TABLE  INTEGER,
    NUM_LINE    INTEGER,
    USL_CODE    VARCHAR(16),
    FRISK       INTEGER,
    STAGE       INTEGER); @
CREATE INDEX N382_MAIN ON N382 (NAME_TABLE,NUM_LINE,USL_CODE); @

drop index DS_IDX1; @
drop index P_DS_IDX1; @
drop index USL_IDX1; @
drop index USL_IDX2; @
drop index FYS_IDX1; @
drop index PLAN_D_IDX1; @
DROP INDEX KARTA_USL_IDX1; @
DROP INDEX KARTA_USL_IDX2; @
DROP INDEX KARTA_USL_IDX3; @

DROP TABLE LOG_IDENT; @
DROP TABLE PLAN_D; @

alter table USL alter USL_CODE type varchar (16); @

alter table TMP_USL alter USL_CODE type varchar (16); @ 

alter table TMP_TO_TWO alter USL_CODE type varchar (16); @ 

alter table FYS alter USL_CODE type varchar (16); @ 

ALTER TABLE USL DROP NPP; @

ALTER TABLE USL
    ADD IS_FINAL_MD ONE_CHAR; @

ALTER TABLE DS
    ADD IDK INTEGER; @   

ALTER TABLE P_DS
    ADD IDK INTEGER; @

ALTER TABLE KARTA
    ADD INVALID ONE_CHAR; @    

COMMIT WORK; @     

update DS D
set D.IDK = D.ID_KARTA; @   

update P_DS D
set D.IDK = D.ID_KARTA; @ 

CREATE OR ALTER VIEW KARTA_VIEWER(
    IDK,
    ID_REP,
    NHISTORY,
    SPOLIS,
    NPOLIS,
    SMO,
    MCOD,
    FAM,
    IM,
    OT,
    W,
    DR,
    STAGE,
    DATE_ENTER,
    DATE_1,
    DATE_2,
    RSLT,
    MD5_HASH,
    TD,
    GD,
    MON,
    IN_REP,
    DOCTYPE,
    DOCSER,
    DOCNUM,
    SNILS,
    IS_MD,
    ISOUT)
AS
select K.IDK, K.ID_REP, K.NHISTORY, K.SPOLIS, K.NPOLIS, K.SMO, K.MCOD, K.FAM, K.IM, K.OT, K.W, K.DR, K.STAGE,
       K.DATE_ENTER, K.DATE_1, K.DATE_2, K.RSLT, K.MD5_HASH, K.TD, extract(year from K.DATE_ENTER) as GD,
       extract(month from K.DATE_ENTER) as MON, iif(K.ID_REP is null, 0, 1) as IN_REP, K.DOCTYPE, K.DOCSER, K.DOCNUM,
       K.SNILS,
       (iif((select count(*)
             from KARTA_USL KU
             inner join USL U on ((U.ID = KU.ID_USL) and
                   (U.IS_DOP_TARIF = '1'))
             where (KU.IDK = K.IDK) and
                   (U.IS_FINAL_MD = '1') and
                   (not KU.ID_MD is null) and
                   (KU.ID_MD <> 0)) = 0, '', '')) as IS_MD,
       (select P.ISOUT
        from P_KARTA P
        where P.IDK = K.IDK) as ISOUT
from KARTA K
order by K.DATE_ENTER, upper(K.FAM collate PXW_CYRL), upper(K.IM collate PXW_CYRL), upper(K.OT collate PXW_CYRL), K.DR, K.TD, K.STAGE, K.IDK; @

DROP PROCEDURE UPDATE_DATE_KARTA; @

CREATE OR ALTER procedure DROP_KARTA (
    DID integer)
as
begin
  delete from KARTA_USL U
  where U.IDK = :DID; 

  delete from KARTA K
  where K.IDK = :DID; 

  delete from DS D
  where D.IDK = :DID; 

  delete from KARTA_RSLT R
  where R.IDK = :DID; 

  delete from KARTA_RISK R
  where R.IDK = :DID; 

  delete from KARTA_TO_TWO T
  where T.IDK = :DID; 

  delete from P_KARTA_USL PU
  where PU.IDK = :DID; 

  delete from P_DS PD
  where PD.IDK = :DID; 

  delete from P_KARTA PK
  where PK.IDK = :DID; 
end; @


CREATE OR ALTER trigger karta_bi0 for karta
active before insert position 0
AS
begin
  if (new.id_operator is null) then new.id_operator=0; 
end; @

CREATE OR ALTER trigger karta_bu0 for karta
active before update position 0
AS
begin
  if (new.coment_ident='') then new.coment_ident=null; 
  if (new.md5_hash='') then new.md5_hash=null; 

  if (new.id_operator is null) then new.id_operator=0; 
end; @

CREATE OR ALTER trigger karta_usl_bi0 for karta_usl
active before insert position 0
as
begin
  if (new.id_md is null) then new.id_md=0; 
  if (new.id_md_asist is null) then new.id_md_asist=0; 
end; @

COMMIT WORK; @

ALTER TABLE KARTA DROP CONSTRAINT PK_KARTA; @

ALTER TABLE KARTA DROP ID; @

ALTER TABLE KARTA DROP DS; @

ALTER TABLE KARTA DROP HEIGHT; @

ALTER TABLE KARTA DROP WEIGHT; @

ALTER TABLE KARTA DROP HOLEST; @

ALTER TABLE KARTA DROP GLUCOSE; @

ALTER TABLE KARTA DROP AD; @

ALTER TABLE DS DROP ID_KARTA; @

ALTER TABLE P_DS DROP ID_KARTA; @

ALTER TABLE KARTA_USL DROP ID_KARTA; @

COMMIT WORK; @

CREATE INDEX USL_IDX_MAIN ON USL (TD, STAGE, W); @
CREATE INDEX USL_IDX_DATE ON USL (DATE_1, DATE_2); @

CREATE INDEX KARTA_USL_MAIN ON KARTA_USL (IDK, ID_USL); @

CREATE INDEX DS_IDX_IDK ON DS (IDK); @

CREATE INDEX P_DS_IDX_IDK ON P_DS (IDK); @

CREATE INDEX KARTA_IDX_FAM ON KARTA COMPUTED BY (upper(FAM)); @

CREATE INDEX FYS_IDX_USL_DATE ON FYS (USL_CODE,DATE_1,DATE_2); @

COMMIT WORK; @


INSERT INTO SMO (TF, TF_OKATO, SMOCOD, NAM_SMOP, NAM_SMOK, INN, KPP, ADDR, BIK, RASH_SH, BANK)
         VALUES ('35000', '35000', '35000', '  ', '    ', NULL, NULL, NULL, NULL, NULL, NULL); @
INSERT INTO SMO (TF, TF_OKATO, SMOCOD, NAM_SMOP, NAM_SMOK, INN, KPP, ADDR, BIK, RASH_SH, BANK)
         VALUES ('67000', '67000', '67000', '  ', '   .', NULL, NULL, NULL, NULL, NULL, NULL); @

INSERT INTO HOLIDAY (HDAY, HTYPE)
             VALUES ('2014-01-01', '0'); @
INSERT INTO HOLIDAY (HDAY, HTYPE)
             VALUES ('2014-01-02', '0'); @
INSERT INTO HOLIDAY (HDAY, HTYPE)
             VALUES ('2014-01-03', '0'); @
INSERT INTO HOLIDAY (HDAY, HTYPE)
             VALUES ('2014-01-06', '0'); @
INSERT INTO HOLIDAY (HDAY, HTYPE)
             VALUES ('2014-01-07', '0'); @
INSERT INTO HOLIDAY (HDAY, HTYPE)
             VALUES ('2014-01-08', '0'); @
INSERT INTO HOLIDAY (HDAY, HTYPE)
             VALUES ('2014-03-10', '0'); @
INSERT INTO HOLIDAY (HDAY, HTYPE)
             VALUES ('2014-05-01', '0'); @
INSERT INTO HOLIDAY (HDAY, HTYPE)
             VALUES ('2014-05-02', '0'); @
INSERT INTO HOLIDAY (HDAY, HTYPE)
             VALUES ('2014-05-09', '0'); @
INSERT INTO HOLIDAY (HDAY, HTYPE)
             VALUES ('2014-06-12', '0'); @
INSERT INTO HOLIDAY (HDAY, HTYPE)
             VALUES ('2014-06-13', '0'); @
INSERT INTO HOLIDAY (HDAY, HTYPE)
             VALUES ('2014-11-03', '0'); @
INSERT INTO HOLIDAY (HDAY, HTYPE)
             VALUES ('2014-11-04', '0'); @
INSERT INTO HOLIDAY (HDAY, HTYPE)
             VALUES ('2015-01-01', '0'); @
INSERT INTO HOLIDAY (HDAY, HTYPE)
             VALUES ('2015-01-02', '0'); @
INSERT INTO HOLIDAY (HDAY, HTYPE)
             VALUES ('2015-01-05', '0'); @
INSERT INTO HOLIDAY (HDAY, HTYPE)
             VALUES ('2015-01-06', '0'); @
INSERT INTO HOLIDAY (HDAY, HTYPE)
             VALUES ('2015-01-07', '0'); @
INSERT INTO HOLIDAY (HDAY, HTYPE)
             VALUES ('2015-01-08', '0'); @
INSERT INTO HOLIDAY (HDAY, HTYPE)
             VALUES ('2015-01-09', '0'); @
INSERT INTO HOLIDAY (HDAY, HTYPE)
             VALUES ('2015-02-23', '0'); @
INSERT INTO HOLIDAY (HDAY, HTYPE)
             VALUES ('2015-03-09', '0'); @
INSERT INTO HOLIDAY (HDAY, HTYPE)
             VALUES ('2015-05-01', '0'); @
INSERT INTO HOLIDAY (HDAY, HTYPE)
             VALUES ('2015-05-04', '0'); @
INSERT INTO HOLIDAY (HDAY, HTYPE)
             VALUES ('2015-05-11', '0'); @
INSERT INTO HOLIDAY (HDAY, HTYPE)
             VALUES ('2015-06-12', '0'); @
INSERT INTO HOLIDAY (HDAY, HTYPE)
             VALUES ('2015-11-04', '0'); @

INSERT INTO U131 (USL_CODE, NPP, TD, IS_OK_USL)
          VALUES ('0400102', 45, '0', '1'); @
INSERT INTO U131 (USL_CODE, NPP, TD, IS_OK_USL)
          VALUES ('0102301', 46, '0', '1'); @
INSERT INTO U131 (USL_CODE, NPP, TD, IS_OK_USL)
          VALUES ('0402302', 46, '0', '1'); @
INSERT INTO U131 (USL_CODE, NPP, TD, IS_OK_USL)
          VALUES ('0404702', 47, '0', '1'); @
INSERT INTO U131 (USL_CODE, NPP, TD, IS_OK_USL)
          VALUES ('0404702', 48, '0', '1'); @
INSERT INTO U131 (USL_CODE, NPP, TD, IS_OK_USL)
          VALUES ('0404702', 48, '3', '1'); @
INSERT INTO U131 (USL_CODE, NPP, TD, IS_OK_USL)
          VALUES ('0105701', 49, '0', '1'); @
INSERT INTO U131 (USL_CODE, NPP, TD, IS_OK_USL)
          VALUES ('0105301', 50, '0', '1'); @
INSERT INTO U131 (USL_CODE, NPP, TD, IS_OK_USL)
          VALUES ('0101801', 51, '0', '1'); @
INSERT INTO U131 (USL_CODE, NPP, TD, IS_OK_USL)
          VALUES ('0100101', 52, '0', '1'); @
INSERT INTO U131 (USL_CODE, NPP, TD, IS_OK_USL)
          VALUES ('0102901', 53, '0', '1'); @
INSERT INTO U131 (USL_CODE, NPP, TD, IS_OK_USL)
          VALUES ('0104701', 54, '0', '1'); @
INSERT INTO U131 (USL_CODE, NPP, TD, IS_OK_USL)
          VALUES ('0104701', 55, '0', '1'); @
INSERT INTO U131 (USL_CODE, NPP, TD, IS_OK_USL)
          VALUES ('0131009', 61, '0', '1'); @
INSERT INTO U131 (USL_CODE, NPP, TD, IS_OK_USL)
          VALUES ('0131009', 61, '3', '1'); @
INSERT INTO U131 (USL_CODE, NPP, TD, IS_OK_USL)
          VALUES ('0905026', 64, '0', '1'); @
INSERT INTO U131 (USL_CODE, NPP, TD, IS_OK_USL)
          VALUES ('0905026', 64, '3', '1'); @
INSERT INTO U131 (USL_CODE, NPP, TD, IS_OK_USL)
          VALUES ('0905023', 65, '0', '1'); @
INSERT INTO U131 (USL_CODE, NPP, TD, IS_OK_USL)
          VALUES ('0905023', 65, '0', '1'); @
INSERT INTO U131 (USL_CODE, NPP, TD, IS_OK_USL)
          VALUES ('0404702', 66, '0', '1'); @
INSERT INTO U131 (USL_CODE, NPP, TD, IS_OK_USL)
          VALUES ('0510007', 67, '0', '1'); @
INSERT INTO U131 (USL_CODE, NPP, TD, IS_OK_USL)
          VALUES ('0510007', 67, '0', '1'); @
INSERT INTO U131 (USL_CODE, NPP, TD, IS_OK_USL)
          VALUES ('0400102', 68, '0', '1'); @
INSERT INTO U131 (USL_CODE, NPP, TD, IS_OK_USL)
          VALUES ('0609007', 69, '0', '1'); @
INSERT INTO U131 (USL_CODE, NPP, TD, IS_OK_USL)
          VALUES ('0609007', 69, '3', '1'); @
INSERT INTO U131 (USL_CODE, NPP, TD, IS_OK_USL)
          VALUES ('0620006', 70, '0', '1'); @
INSERT INTO U131 (USL_CODE, NPP, TD, IS_OK_USL)
          VALUES ('0620006', 70, '3', '1'); @
INSERT INTO U131 (USL_CODE, NPP, TD, IS_OK_USL)
          VALUES ('0301602', 71, '0', '1'); @
INSERT INTO U131 (USL_CODE, NPP, TD, IS_OK_USL)
          VALUES ('0301602', 71, '3', '1'); @
INSERT INTO U131 (USL_CODE, NPP, TD, IS_OK_USL)
          VALUES ('0301603', 72, '0', '1'); @
INSERT INTO U131 (USL_CODE, NPP, TD, IS_OK_USL)
          VALUES ('0301604', 73, '0', '1'); @
INSERT INTO U131 (USL_CODE, NPP, TD, IS_OK_USL)
          VALUES ('0301606', 74, '0', '1'); @
INSERT INTO U131 (USL_CODE, NPP, TD, IS_OK_USL)
          VALUES ('0919002', 75, '0', '1'); @
INSERT INTO U131 (USL_CODE, NPP, TD, IS_OK_USL)
          VALUES ('0919002', 75, '3', '1'); @
INSERT INTO U131 (USL_CODE, NPP, TD, IS_OK_USL)
          VALUES ('0905135', 76, '0', '1'); @
INSERT INTO U131 (USL_CODE, NPP, TD, IS_OK_USL)
          VALUES ('0406001', 77, '0', '1'); @
INSERT INTO U131 (USL_CODE, NPP, TD, IS_OK_USL)
          VALUES ('0414001', 77, '0', '1'); @
INSERT INTO U131 (USL_CODE, NPP, TD, IS_OK_USL)
          VALUES ('0414002', 77, '0', '1'); @
INSERT INTO U131 (USL_CODE, NPP, TD, IS_OK_USL)
          VALUES ('0415001', 77, '0', '1'); @
INSERT INTO U131 (USL_CODE, NPP, TD, IS_OK_USL)
          VALUES ('0428001', 77, '0', '1'); @
INSERT INTO U131 (USL_CODE, NPP, TD, IS_OK_USL)
          VALUES ('0226015', 78, '0', '1'); @
INSERT INTO U131 (USL_CODE, NPP, TD, IS_OK_USL)
          VALUES ('0412005', 79, '0', '1'); @
INSERT INTO U131 (USL_CODE, NPP, TD, IS_OK_USL)
          VALUES ('0316001', 80, '0', '1'); @
INSERT INTO U131 (USL_CODE, NPP, TD, IS_OK_USL)
          VALUES ('0319002', 81, '0', '1'); @
INSERT INTO U131 (USL_CODE, NPP, TD, IS_OK_USL)
          VALUES ('0905027', 82, '0', '1'); @
INSERT INTO U131 (USL_CODE, NPP, TD, IS_OK_USL)
          VALUES ('0905028', 82, '0', '1'); @
INSERT INTO U131 (USL_CODE, NPP, TD, IS_OK_USL)
          VALUES ('0905084', 83, '0', '1'); @
INSERT INTO U131 (USL_CODE, NPP, TD, IS_OK_USL)
          VALUES ('0412005', 89, '0', '2'); @
INSERT INTO U131 (USL_CODE, NPP, TD, IS_OK_USL)
          VALUES ('0316001', 90, '0', '2'); @
INSERT INTO U131 (USL_CODE, NPP, TD, IS_OK_USL)
          VALUES ('0102301', 91, '0', '2'); @
INSERT INTO U131 (USL_CODE, NPP, TD, IS_OK_USL)
          VALUES ('0105301', 92, '0', '2'); @
INSERT INTO U131 (USL_CODE, NPP, TD, IS_OK_USL)
          VALUES ('0105701', 92, '0', '2'); @
INSERT INTO U131 (USL_CODE, NPP, TD, IS_OK_USL)
          VALUES ('0101801', 93, '0', '2'); @
INSERT INTO U131 (USL_CODE, NPP, TD, IS_OK_USL)
          VALUES ('0319002', 94, '0', '2'); @
INSERT INTO U131 (USL_CODE, NPP, TD, IS_OK_USL)
          VALUES ('0905027', 95, '0', '2'); @
INSERT INTO U131 (USL_CODE, NPP, TD, IS_OK_USL)
          VALUES ('0905028', 95, '0', '2'); @
INSERT INTO U131 (USL_CODE, NPP, TD, IS_OK_USL)
          VALUES ('0100101', 96, '0', '2'); @
INSERT INTO U131 (USL_CODE, NPP, TD, IS_OK_USL)
          VALUES ('0905084', 97, '0', '2'); @
INSERT INTO U131 (USL_CODE, NPP, TD, IS_OK_USL)
          VALUES ('0102901', 98, '0', '2'); @
INSERT INTO U131 (USL_CODE, NPP, TD, IS_OK_USL)
          VALUES ('0104701', 99, '0', '2'); @
INSERT INTO U131 (USL_CODE, NPP, TD, IS_OK_USL)
          VALUES ('0104701', 100, '0', '2'); @
INSERT INTO U131 (USL_CODE, NPP, TD, IS_OK_USL)
          VALUES ('0104701', 101, '0', '2'); @
INSERT INTO U131 (USL_CODE, NPP, TD, IS_OK_USL)
          VALUES ('B04.001.002', 45, '0', '1'); @
INSERT INTO U131 (USL_CODE, NPP, TD, IS_OK_USL)
          VALUES ('B01.023.001', 46, '0', '1'); @
INSERT INTO U131 (USL_CODE, NPP, TD, IS_OK_USL)
          VALUES ('B04.023.002', 46, '0', '1'); @
INSERT INTO U131 (USL_CODE, NPP, TD, IS_OK_USL)
          VALUES ('B04.047.002', 47, '0', '1'); @
INSERT INTO U131 (USL_CODE, NPP, TD, IS_OK_USL)
          VALUES ('B04.047.002', 48, '0', '1'); @
INSERT INTO U131 (USL_CODE, NPP, TD, IS_OK_USL)
          VALUES ('B04.047.002', 48, '3', '1'); @
INSERT INTO U131 (USL_CODE, NPP, TD, IS_OK_USL)
          VALUES ('B01.057.001', 49, '0', '1'); @
INSERT INTO U131 (USL_CODE, NPP, TD, IS_OK_USL)
          VALUES ('B01.053.001', 50, '0', '1'); @
INSERT INTO U131 (USL_CODE, NPP, TD, IS_OK_USL)
          VALUES ('B01.018.001', 51, '0', '1'); @
INSERT INTO U131 (USL_CODE, NPP, TD, IS_OK_USL)
          VALUES ('B01.001.001', 52, '0', '1'); @
INSERT INTO U131 (USL_CODE, NPP, TD, IS_OK_USL)
          VALUES ('B01.029.001', 53, '0', '1'); @
INSERT INTO U131 (USL_CODE, NPP, TD, IS_OK_USL)
          VALUES ('B01.047.001', 54, '0', '1'); @
INSERT INTO U131 (USL_CODE, NPP, TD, IS_OK_USL)
          VALUES ('B01.047.001', 55, '0', '1'); @
INSERT INTO U131 (USL_CODE, NPP, TD, IS_OK_USL)
          VALUES ('A01.31.009', 61, '0', '1'); @
INSERT INTO U131 (USL_CODE, NPP, TD, IS_OK_USL)
          VALUES ('A01.31.009', 61, '3', '1'); @
INSERT INTO U131 (USL_CODE, NPP, TD, IS_OK_USL)
          VALUES ('A09.05.026', 64, '0', '1'); @
INSERT INTO U131 (USL_CODE, NPP, TD, IS_OK_USL)
          VALUES ('A09.05.026', 64, '3', '1'); @
INSERT INTO U131 (USL_CODE, NPP, TD, IS_OK_USL)
          VALUES ('A09.05.023', 65, '0', '1'); @
INSERT INTO U131 (USL_CODE, NPP, TD, IS_OK_USL)
          VALUES ('A09.05.023', 65, '0', '1'); @
INSERT INTO U131 (USL_CODE, NPP, TD, IS_OK_USL)
          VALUES ('B04.047.002', 66, '0', '1'); @
INSERT INTO U131 (USL_CODE, NPP, TD, IS_OK_USL)
          VALUES ('A05.10.004', 67, '0', '1'); @
INSERT INTO U131 (USL_CODE, NPP, TD, IS_OK_USL)
          VALUES ('A05.10.004', 67, '0', '1'); @
INSERT INTO U131 (USL_CODE, NPP, TD, IS_OK_USL)
          VALUES ('B04.001.002', 68, '0', '1'); @
INSERT INTO U131 (USL_CODE, NPP, TD, IS_OK_USL)
          VALUES ('A06.09.006', 69, '0', '1'); @
INSERT INTO U131 (USL_CODE, NPP, TD, IS_OK_USL)
          VALUES ('A06.09.006', 69, '3', '1'); @
INSERT INTO U131 (USL_CODE, NPP, TD, IS_OK_USL)
          VALUES ('A06.20.004', 70, '0', '1'); @
INSERT INTO U131 (USL_CODE, NPP, TD, IS_OK_USL)
          VALUES ('A06.20.004', 70, '3', '1'); @
INSERT INTO U131 (USL_CODE, NPP, TD, IS_OK_USL)
          VALUES ('B03.016.002', 71, '0', '1'); @
INSERT INTO U131 (USL_CODE, NPP, TD, IS_OK_USL)
          VALUES ('B03.016.002', 71, '3', '1'); @
INSERT INTO U131 (USL_CODE, NPP, TD, IS_OK_USL)
          VALUES ('B03.016.003', 72, '0', '1'); @
INSERT INTO U131 (USL_CODE, NPP, TD, IS_OK_USL)
          VALUES ('B03.016.004', 73, '0', '1'); @
INSERT INTO U131 (USL_CODE, NPP, TD, IS_OK_USL)
          VALUES ('B03.016.006', 74, '0', '1'); @
INSERT INTO U131 (USL_CODE, NPP, TD, IS_OK_USL)
          VALUES ('A09.19.001', 75, '0', '1'); @
INSERT INTO U131 (USL_CODE, NPP, TD, IS_OK_USL)
          VALUES ('A09.19.001', 75, '3', '1'); @
INSERT INTO U131 (USL_CODE, NPP, TD, IS_OK_USL)
          VALUES ('A09.05.130', 76, '0', '1'); @
INSERT INTO U131 (USL_CODE, NPP, TD, IS_OK_USL)
          VALUES ('A04.06.001', 77, '0', '1'); @
INSERT INTO U131 (USL_CODE, NPP, TD, IS_OK_USL)
          VALUES ('A04.14.001', 77, '0', '1'); @
INSERT INTO U131 (USL_CODE, NPP, TD, IS_OK_USL)
          VALUES ('A04.14.002', 77, '0', '1'); @
INSERT INTO U131 (USL_CODE, NPP, TD, IS_OK_USL)
          VALUES ('A04.15.001', 77, '0', '1'); @
INSERT INTO U131 (USL_CODE, NPP, TD, IS_OK_USL)
          VALUES ('A04.28.002.001', 77, '0', '1'); @
INSERT INTO U131 (USL_CODE, NPP, TD, IS_OK_USL)
          VALUES ('A02.26.015', 78, '0', '1'); @
INSERT INTO U131 (USL_CODE, NPP, TD, IS_OK_USL)
          VALUES ('A04.12.005.002', 79, '0', '1'); @
INSERT INTO U131 (USL_CODE, NPP, TD, IS_OK_USL)
          VALUES ('A03.16.001', 80, '0', '1'); @
INSERT INTO U131 (USL_CODE, NPP, TD, IS_OK_USL)
          VALUES ('A03.19.002', 81, '0', '1'); @
INSERT INTO U131 (USL_CODE, NPP, TD, IS_OK_USL)
          VALUES ('A09.05.027', 82, '0', '1'); @
INSERT INTO U131 (USL_CODE, NPP, TD, IS_OK_USL)
          VALUES ('A09.05.028', 82, '0', '1'); @
INSERT INTO U131 (USL_CODE, NPP, TD, IS_OK_USL)
          VALUES ('A09.05.083', 83, '0', '1'); @
INSERT INTO U131 (USL_CODE, NPP, TD, IS_OK_USL)
          VALUES ('A04.12.005.002', 89, '0', '2'); @
INSERT INTO U131 (USL_CODE, NPP, TD, IS_OK_USL)
          VALUES ('A03.16.001', 90, '0', '2'); @
INSERT INTO U131 (USL_CODE, NPP, TD, IS_OK_USL)
          VALUES ('B01.023.001', 91, '0', '2'); @
INSERT INTO U131 (USL_CODE, NPP, TD, IS_OK_USL)
          VALUES ('B01.053.001', 92, '0', '2'); @
INSERT INTO U131 (USL_CODE, NPP, TD, IS_OK_USL)
          VALUES ('B01.057.001', 92, '0', '2'); @
INSERT INTO U131 (USL_CODE, NPP, TD, IS_OK_USL)
          VALUES ('B01.018.001', 93, '0', '2'); @
INSERT INTO U131 (USL_CODE, NPP, TD, IS_OK_USL)
          VALUES ('A03.19.002', 94, '0', '2'); @
INSERT INTO U131 (USL_CODE, NPP, TD, IS_OK_USL)
          VALUES ('A09.05.027', 95, '0', '2'); @
INSERT INTO U131 (USL_CODE, NPP, TD, IS_OK_USL)
          VALUES ('A09.05.028', 95, '0', '2'); @
INSERT INTO U131 (USL_CODE, NPP, TD, IS_OK_USL)
          VALUES ('B01.001.001', 96, '0', '2'); @
INSERT INTO U131 (USL_CODE, NPP, TD, IS_OK_USL)
          VALUES ('A09.05.083', 97, '0', '2'); @
INSERT INTO U131 (USL_CODE, NPP, TD, IS_OK_USL)
          VALUES ('B01.029.001', 98, '0', '2'); @
INSERT INTO U131 (USL_CODE, NPP, TD, IS_OK_USL)
          VALUES ('B01.047.001', 99, '0', '2'); @
INSERT INTO U131 (USL_CODE, NPP, TD, IS_OK_USL)
          VALUES ('B01.047.001', 100, '0', '2'); @
INSERT INTO U131 (USL_CODE, NPP, TD, IS_OK_USL)
          VALUES ('B01.047.001', 101, '0', '2'); @

INSERT INTO FLAG_RSLT (ID_RSLT, NAME_RSLT)
               VALUES (1, '   -'); @
INSERT INTO FLAG_RSLT (ID_RSLT, NAME_RSLT)
               VALUES (2, '     '); @
INSERT INTO FLAG_RSLT (ID_RSLT, NAME_RSLT)
               VALUES (3, '     '); @
INSERT INTO FLAG_RSLT (ID_RSLT, NAME_RSLT)
               VALUES (4, '     ,     '); @
INSERT INTO FLAG_RSLT (ID_RSLT, NAME_RSLT)
               VALUES (5, ' '); @
INSERT INTO FLAG_RSLT (ID_RSLT, NAME_RSLT)
               VALUES (6, '     ,     '); @
INSERT INTO FLAG_RSLT (ID_RSLT, NAME_RSLT)
               VALUES (7, '    ,    ,  '); @
INSERT INTO FLAG_RSLT (ID_RSLT, NAME_RSLT)
               VALUES (8, '   - '); @
INSERT INTO FLAG_RSLT (ID_RSLT, NAME_RSLT)
               VALUES (9, '  '); @
INSERT INTO FLAG_RSLT (ID_RSLT, NAME_RSLT)
               VALUES (10, '       '); @
INSERT INTO FLAG_RSLT (ID_RSLT, NAME_RSLT)
               VALUES (11, '   '); @

INSERT INTO UNIONDB (FILE_NAME, SQL_TEXT, IS_PARAMS, IS_LOAD)
             VALUES ('karta.xml', 'select * from KARTA K where (K.DATE_ENTER >= :D1) and (K.DATE_ENTER <= :D2)', 1, 0); @
INSERT INTO UNIONDB (FILE_NAME, SQL_TEXT, IS_PARAMS, IS_LOAD)
             VALUES ('karta_rslt.xml', 'select K.* from KARTA_RSLT K inner join KARTA KR on KR.IDK = K.IDK where (KR.DATE_ENTER >= :D1) and (KR.DATE_ENTER <= :D2)', 1, 0); @
INSERT INTO UNIONDB (FILE_NAME, SQL_TEXT, IS_PARAMS, IS_LOAD)
             VALUES ('karta_risk.xml', 'select K.* from KARTA_RISK K inner join KARTA KR on KR.IDK = K.IDK where (KR.DATE_ENTER >= :D1) and (KR.DATE_ENTER <= :D2)', 1, 0); @
INSERT INTO UNIONDB (FILE_NAME, SQL_TEXT, IS_PARAMS, IS_LOAD)
             VALUES ('karta_to_two.xml', 'select K.* from KARTA_TO_TWO K inner join KARTA KR on KR.IDK = K.IDK where (KR.DATE_ENTER >= :D1) and (KR.DATE_ENTER <= :D2)', 1, 0); @
INSERT INTO UNIONDB (FILE_NAME, SQL_TEXT, IS_PARAMS, IS_LOAD)
             VALUES ('karta_usl.xml', 'select K.* from KARTA_USL K inner join KARTA KR on KR.IDK = K.IDK where (KR.DATE_ENTER >= :D1) and (KR.DATE_ENTER <= :D2)', 1, 0); @
INSERT INTO UNIONDB (FILE_NAME, SQL_TEXT, IS_PARAMS, IS_LOAD)
             VALUES ('ds.xml', 'select K.* from DS K inner join KARTA KR on KR.IDK = K.IDK where (KR.DATE_ENTER >= :D1) and (KR.DATE_ENTER <= :D2)', 1, 0); @
INSERT INTO UNIONDB (FILE_NAME, SQL_TEXT, IS_PARAMS, IS_LOAD)
             VALUES ('pkarta.xml', 'select K.* from P_KARTA K inner join KARTA KR on KR.IDK = K.IDK where (KR.DATE_ENTER >= :D1) and (KR.DATE_ENTER <= :D2)', 1, 0); @
INSERT INTO UNIONDB (FILE_NAME, SQL_TEXT, IS_PARAMS, IS_LOAD)
             VALUES ('pusl.xml', 'select K.* from P_USL K inner join KARTA KR on KR.IDK = K.ID where (KR.DATE_ENTER >= :D1) and (KR.DATE_ENTER <= :D2)', 1, 0); @
INSERT INTO UNIONDB (FILE_NAME, SQL_TEXT, IS_PARAMS, IS_LOAD)
             VALUES ('pds.xml', 'select K.* from P_DS K inner join KARTA KR on KR.IDK = K.IDK where (KR.DATE_ENTER >= :D1) and (KR.DATE_ENTER <= :D2)', 1, 0); @
INSERT INTO UNIONDB (FILE_NAME, SQL_TEXT, IS_PARAMS, IS_LOAD)
             VALUES ('operator.xml', 'select K.* from OPERATOR K where (K.ID_OP <> 0) order by K.ID_OP', 0, 0); @
INSERT INTO UNIONDB (FILE_NAME, SQL_TEXT, IS_PARAMS, IS_LOAD)
             VALUES ('md.xml', 'select K.* from MD K where (K.ID_NPP <> 0) order by K.ID_NPP', 0, 0); @
INSERT INTO UNIONDB (FILE_NAME, SQL_TEXT, IS_PARAMS, IS_LOAD)
             VALUES ('karta_rslt.xml', 'insert into KARTA_RSLT (IDK, ID_RSLT) values (:IDK, :ID_RSLT)', 1, 1); @
INSERT INTO UNIONDB (FILE_NAME, SQL_TEXT, IS_PARAMS, IS_LOAD)
             VALUES ('karta_risk.xml', 'insert into KARTA_RISK (IDK, ID_RISK) values (:IDK, :ID_RISK)', 1, 1); @
INSERT INTO UNIONDB (FILE_NAME, SQL_TEXT, IS_PARAMS, IS_LOAD)
             VALUES ('karta_to_two.xml', 'insert into KARTA_TO_TWO (IDK, ID_USL) values (:IDK, :ID_USL)', 1, 1); @
INSERT INTO UNIONDB (FILE_NAME, SQL_TEXT, IS_PARAMS, IS_LOAD)
             VALUES ('ds.xml', 'insert into DS (IDK, DS_COD, DS_DATE, IS_IN_DD, IS_BEGIN, IS_FIND) values (:IDK, :DS_COD, :DS_DATE, :IS_IN_DD, :IS_BEGIN, :IS_FIND)', 1, 1); @
INSERT INTO UNIONDB (FILE_NAME, SQL_TEXT, IS_PARAMS, IS_LOAD)
             VALUES ('pusl.xml', 'insert into P_KARTA_USL (IDK, ID_P_USL, DATE_1, RESULT_PORTAL) values (:IDK, :ID_P_USL, :DATE_1, :RESULT_PORTAL)', 1, 1); @
INSERT INTO UNIONDB (FILE_NAME, SQL_TEXT, IS_PARAMS, IS_LOAD)
             VALUES ('pds.xml', 'insert into P_DS (IDK, BA_TYPE, MKB, FIRSTTIME, DISPNABLUD, LE_CONDITION, LE_ORGAN, LE_REASON, LE_REASONOTHER, RE_CONDITION, RE_ORGAN, RE_REASON, RE_REASONOTHER, CON_CONDITION, CON_ORGAN, CON_STATE, VMP, SMP, SLK, RECOMMENDNEXT) values (:IDK, :BA_TYPE, :MKB, :FIRSTTIME, :DISPNABLUD, :LE_CONDITION, :LE_ORGAN, :LE_REASON, :LE_REASONOTHER, :RE_CONDITION, :RE_ORGAN, :RE_REASON, :RE_REASONOTHER, :CON_CONDITION, :CON_ORGAN, :CON_STATE, :VMP, :SMP, :SLK, :RECOMMENDNEXT)', 1, 1); @

INSERT INTO GROUP_MKB10 (NUM, RANGE, DS1, DS2, PRECISION_DS)
                 VALUES (1, 'A00-B99', 'A00', 'B99', 3); @
INSERT INTO GROUP_MKB10 (NUM, RANGE, DS1, DS2, PRECISION_DS)
                 VALUES (2, 'A15-A19', 'A15', 'A19', 3); @
INSERT INTO GROUP_MKB10 (NUM, RANGE, DS1, DS2, PRECISION_DS)
                 VALUES (3, 'C00-D48', 'C00', 'D48', 3); @
INSERT INTO GROUP_MKB10 (NUM, RANGE, DS1, DS2, PRECISION_DS)
                 VALUES (4, 'C00-D48', 'C00', 'D48', 3); @
INSERT INTO GROUP_MKB10 (NUM, RANGE, DS1, DS2, PRECISION_DS)
                 VALUES (5, 'C15', 'C15', 'C15', 3); @
INSERT INTO GROUP_MKB10 (NUM, RANGE, DS1, DS2, PRECISION_DS)
                 VALUES (6, 'C16', 'C16', 'C16', 3); @
INSERT INTO GROUP_MKB10 (NUM, RANGE, DS1, DS2, PRECISION_DS)
                 VALUES (7, 'C18', 'C18', 'C18', 3); @
INSERT INTO GROUP_MKB10 (NUM, RANGE, DS1, DS2, PRECISION_DS)
                 VALUES (8, 'C19-C21', 'C19', 'C21', 3); @
INSERT INTO GROUP_MKB10 (NUM, RANGE, DS1, DS2, PRECISION_DS)
                 VALUES (9, 'C25', 'C25', 'C25', 3); @
INSERT INTO GROUP_MKB10 (NUM, RANGE, DS1, DS2, PRECISION_DS)
                 VALUES (10, 'C33, 34', 'C33', 'C34', 3); @
INSERT INTO GROUP_MKB10 (NUM, RANGE, DS1, DS2, PRECISION_DS)
                 VALUES (11, 'C50', 'C50', 'C50', 3); @
INSERT INTO GROUP_MKB10 (NUM, RANGE, DS1, DS2, PRECISION_DS)
                 VALUES (12, 'C53', 'C53', 'C53', 3); @
INSERT INTO GROUP_MKB10 (NUM, RANGE, DS1, DS2, PRECISION_DS)
                 VALUES (13, 'C54', 'C54', 'C54', 3); @
INSERT INTO GROUP_MKB10 (NUM, RANGE, DS1, DS2, PRECISION_DS)
                 VALUES (14, 'C56', 'C56', 'C56', 3); @
INSERT INTO GROUP_MKB10 (NUM, RANGE, DS1, DS2, PRECISION_DS)
                 VALUES (15, 'C61', 'C61', 'C61', 3); @
INSERT INTO GROUP_MKB10 (NUM, RANGE, DS1, DS2, PRECISION_DS)
                 VALUES (16, 'C64', 'C64', 'C64', 3); @
INSERT INTO GROUP_MKB10 (NUM, RANGE, DS1, DS2, PRECISION_DS)
                 VALUES (17, 'D50-D89', 'D50', 'D89', 3); @
INSERT INTO GROUP_MKB10 (NUM, RANGE, DS1, DS2, PRECISION_DS)
                 VALUES (18, 'D50-D64', 'D50', 'D64', 3); @
INSERT INTO GROUP_MKB10 (NUM, RANGE, DS1, DS2, PRECISION_DS)
                 VALUES (19, 'E00-E89', 'E00', 'E89', 3); @
INSERT INTO GROUP_MKB10 (NUM, RANGE, DS1, DS2, PRECISION_DS)
                 VALUES (20, 'E10-E14', 'E10', 'E14', 3); @
INSERT INTO GROUP_MKB10 (NUM, RANGE, DS1, DS2, PRECISION_DS)
                 VALUES (21, 'E66', 'E66', 'E66', 3); @
INSERT INTO GROUP_MKB10 (NUM, RANGE, DS1, DS2, PRECISION_DS)
                 VALUES (22, 'G00-G98', 'G00', 'G98', 3); @
INSERT INTO GROUP_MKB10 (NUM, RANGE, DS1, DS2, PRECISION_DS)
                 VALUES (23, 'G45', 'G45', 'G45', 3); @
INSERT INTO GROUP_MKB10 (NUM, RANGE, DS1, DS2, PRECISION_DS)
                 VALUES (24, 'H00-H59', 'H00', 'H59', 3); @
INSERT INTO GROUP_MKB10 (NUM, RANGE, DS1, DS2, PRECISION_DS)
                 VALUES (25, 'H25, H26', 'H25', 'H26', 3); @
INSERT INTO GROUP_MKB10 (NUM, RANGE, DS1, DS2, PRECISION_DS)
                 VALUES (26, 'H40', 'H40', 'H40', 3); @
INSERT INTO GROUP_MKB10 (NUM, RANGE, DS1, DS2, PRECISION_DS)
                 VALUES (27, 'H54', 'H54', 'H54', 3); @
INSERT INTO GROUP_MKB10 (NUM, RANGE, DS1, DS2, PRECISION_DS)
                 VALUES (28, 'I00-I99', 'I00', 'I99', 3); @
INSERT INTO GROUP_MKB10 (NUM, RANGE, DS1, DS2, PRECISION_DS)
                 VALUES (29, 'I10-I13', 'I10', 'I13', 3); @
INSERT INTO GROUP_MKB10 (NUM, RANGE, DS1, DS2, PRECISION_DS)
                 VALUES (30, 'I20-I25', 'I20', 'I25', 3); @
INSERT INTO GROUP_MKB10 (NUM, RANGE, DS1, DS2, PRECISION_DS)
                 VALUES (31, 'I20', 'I20', 'I20', 3); @
INSERT INTO GROUP_MKB10 (NUM, RANGE, DS1, DS2, PRECISION_DS)
                 VALUES (32, 'I20.0', 'I20.0', 'I20.0', 5); @
INSERT INTO GROUP_MKB10 (NUM, RANGE, DS1, DS2, PRECISION_DS)
                 VALUES (33, 'I25', 'I25', 'I25', 3); @
INSERT INTO GROUP_MKB10 (NUM, RANGE, DS1, DS2, PRECISION_DS)
                 VALUES (34, 'I30-I52', 'I30', 'I52', 3); @
INSERT INTO GROUP_MKB10 (NUM, RANGE, DS1, DS2, PRECISION_DS)
                 VALUES (35, 'I60-I69', 'I60', 'I69', 3); @
INSERT INTO GROUP_MKB10 (NUM, RANGE, DS1, DS2, PRECISION_DS)
                 VALUES (36, 'I65, I66', 'I65', 'I66', 3); @
INSERT INTO GROUP_MKB10 (NUM, RANGE, DS1, DS2, PRECISION_DS)
                 VALUES (37, 'I67', 'I67', 'I67', 3); @
INSERT INTO GROUP_MKB10 (NUM, RANGE, DS1, DS2, PRECISION_DS)
                 VALUES (38, 'J00-J98', 'J00', 'J98', 3); @
INSERT INTO GROUP_MKB10 (NUM, RANGE, DS1, DS2, PRECISION_DS)
                 VALUES (39, 'J12-J18', 'J12', 'J18', 3); @
INSERT INTO GROUP_MKB10 (NUM, RANGE, DS1, DS2, PRECISION_DS)
                 VALUES (40, 'J40-J43', 'J40', 'J43', 3); @
INSERT INTO GROUP_MKB10 (NUM, RANGE, DS1, DS2, PRECISION_DS)
                 VALUES (41, 'J44-J47', 'J44', 'J47', 3); @
INSERT INTO GROUP_MKB10 (NUM, RANGE, DS1, DS2, PRECISION_DS)
                 VALUES (42, 'K00-K92', 'K00', 'K92', 3); @
INSERT INTO GROUP_MKB10 (NUM, RANGE, DS1, DS2, PRECISION_DS)
                 VALUES (43, 'K25, K26', 'K25', 'K26', 3); @
INSERT INTO GROUP_MKB10 (NUM, RANGE, DS1, DS2, PRECISION_DS)
                 VALUES (44, 'K29', 'K29', 'K29', 3); @
INSERT INTO GROUP_MKB10 (NUM, RANGE, DS1, DS2, PRECISION_DS)
                 VALUES (45, 'K50-K52', 'K50', 'K52', 3); @
INSERT INTO GROUP_MKB10 (NUM, RANGE, DS1, DS2, PRECISION_DS)
                 VALUES (46, 'K55-K63', 'K55', 'K63', 3); @
INSERT INTO GROUP_MKB10 (NUM, RANGE, DS1, DS2, PRECISION_DS)
                 VALUES (47, 'N00-N99', 'N00', 'N99', 3); @
INSERT INTO GROUP_MKB10 (NUM, RANGE, DS1, DS2, PRECISION_DS)
                 VALUES (48, 'N40-N42', 'N40', 'N42', 3); @
INSERT INTO GROUP_MKB10 (NUM, RANGE, DS1, DS2, PRECISION_DS)
                 VALUES (49, 'N60', 'N60', 'N60', 3); @
INSERT INTO GROUP_MKB10 (NUM, RANGE, DS1, DS2, PRECISION_DS)
                 VALUES (50, 'N70-N77', 'N70', 'N77', 3); @
INSERT INTO GROUP_MKB10 (NUM, RANGE, DS1, DS2, PRECISION_DS)
                 VALUES (51, ' ', 'F00', 'F99', 3); @
INSERT INTO GROUP_MKB10 (NUM, RANGE, DS1, DS2, PRECISION_DS)
                 VALUES (51, ' ', 'H60', 'H95', 3); @
INSERT INTO GROUP_MKB10 (NUM, RANGE, DS1, DS2, PRECISION_DS)
                 VALUES (51, ' ', 'L00', 'M99', 3); @
INSERT INTO GROUP_MKB10 (NUM, RANGE, DS1, DS2, PRECISION_DS)
                 VALUES (51, ' ', 'O00', 'Z99', 3); @

INSERT INTO N382 (NAME_TABLE, NUM_LINE, USL_CODE, FRISK, STAGE)
          VALUES (2, 1, '0404702', 0, 1); @
INSERT INTO N382 (NAME_TABLE, NUM_LINE, USL_CODE, FRISK, STAGE)
          VALUES (2, 2, '0131009', -1, 1); @
INSERT INTO N382 (NAME_TABLE, NUM_LINE, USL_CODE, FRISK, STAGE)
          VALUES (2, 3, '0404702', 9, 1); @
INSERT INTO N382 (NAME_TABLE, NUM_LINE, USL_CODE, FRISK, STAGE)
          VALUES (2, 4, '0404702', 1, 1); @
INSERT INTO N382 (NAME_TABLE, NUM_LINE, USL_CODE, FRISK, STAGE)
          VALUES (2, 5, '0905026', -1, 1); @
INSERT INTO N382 (NAME_TABLE, NUM_LINE, USL_CODE, FRISK, STAGE)
          VALUES (2, 6, '0905023', -1, 1); @
INSERT INTO N382 (NAME_TABLE, NUM_LINE, USL_CODE, FRISK, STAGE)
          VALUES (2, 7, '0404702', 12, 1); @
INSERT INTO N382 (NAME_TABLE, NUM_LINE, USL_CODE, FRISK, STAGE)
          VALUES (2, 7, '0404702', 13, 1); @
INSERT INTO N382 (NAME_TABLE, NUM_LINE, USL_CODE, FRISK, STAGE)
          VALUES (2, 7, '0404702', 14, 1); @
INSERT INTO N382 (NAME_TABLE, NUM_LINE, USL_CODE, FRISK, STAGE)
          VALUES (2, 8, '0510001', -1, 1); @
INSERT INTO N382 (NAME_TABLE, NUM_LINE, USL_CODE, FRISK, STAGE)
          VALUES (2, 8, '0510007', -1, 1); @
INSERT INTO N382 (NAME_TABLE, NUM_LINE, USL_CODE, FRISK, STAGE)
          VALUES (2, 9, '0400102', -1, 1); @
INSERT INTO N382 (NAME_TABLE, NUM_LINE, USL_CODE, FRISK, STAGE)
          VALUES (2, 10, '0400102', -1, 1); @
INSERT INTO N382 (NAME_TABLE, NUM_LINE, USL_CODE, FRISK, STAGE)
          VALUES (2, 11, '0609007', -1, 1); @
INSERT INTO N382 (NAME_TABLE, NUM_LINE, USL_CODE, FRISK, STAGE)
          VALUES (2, 12, '0620006', -1, 1); @
INSERT INTO N382 (NAME_TABLE, NUM_LINE, USL_CODE, FRISK, STAGE)
          VALUES (2, 13, '0301602', -1, 1); @
INSERT INTO N382 (NAME_TABLE, NUM_LINE, USL_CODE, FRISK, STAGE)
          VALUES (2, 14, '0301603', -1, 1); @
INSERT INTO N382 (NAME_TABLE, NUM_LINE, USL_CODE, FRISK, STAGE)
          VALUES (2, 15, '0301604', -1, 1); @
INSERT INTO N382 (NAME_TABLE, NUM_LINE, USL_CODE, FRISK, STAGE)
          VALUES (2, 16, '0301606', -1, 1); @
INSERT INTO N382 (NAME_TABLE, NUM_LINE, USL_CODE, FRISK, STAGE)
          VALUES (2, 17, '0919002', -1, 1); @
INSERT INTO N382 (NAME_TABLE, NUM_LINE, USL_CODE, FRISK, STAGE)
          VALUES (2, 18, '0905135', -1, 1); @
INSERT INTO N382 (NAME_TABLE, NUM_LINE, USL_CODE, FRISK, STAGE)
          VALUES (2, 19, '0406001', -1, 1); @
INSERT INTO N382 (NAME_TABLE, NUM_LINE, USL_CODE, FRISK, STAGE)
          VALUES (2, 19, '0414001', -1, 1); @
INSERT INTO N382 (NAME_TABLE, NUM_LINE, USL_CODE, FRISK, STAGE)
          VALUES (2, 19, '0414002', -1, 1); @
INSERT INTO N382 (NAME_TABLE, NUM_LINE, USL_CODE, FRISK, STAGE)
          VALUES (2, 19, '0415001', -1, 1); @
INSERT INTO N382 (NAME_TABLE, NUM_LINE, USL_CODE, FRISK, STAGE)
          VALUES (2, 19, '0428001', -1, 1); @
INSERT INTO N382 (NAME_TABLE, NUM_LINE, USL_CODE, FRISK, STAGE)
          VALUES (2, 20, '0226015', -1, 1); @
INSERT INTO N382 (NAME_TABLE, NUM_LINE, USL_CODE, FRISK, STAGE)
          VALUES (2, 21, '0402302', -1, 1); @
INSERT INTO N382 (NAME_TABLE, NUM_LINE, USL_CODE, FRISK, STAGE)
          VALUES (2, 22, '0404702', -1, 1); @
INSERT INTO N382 (NAME_TABLE, NUM_LINE, USL_CODE, FRISK, STAGE)
          VALUES (3, 1, '0412005', -1, 2); @
INSERT INTO N382 (NAME_TABLE, NUM_LINE, USL_CODE, FRISK, STAGE)
          VALUES (3, 2, '0316001', -1, 2); @
INSERT INTO N382 (NAME_TABLE, NUM_LINE, USL_CODE, FRISK, STAGE)
          VALUES (3, 3, '0102301', -1, 2); @
INSERT INTO N382 (NAME_TABLE, NUM_LINE, USL_CODE, FRISK, STAGE)
          VALUES (3, 4, '0105301', -1, 2); @
INSERT INTO N382 (NAME_TABLE, NUM_LINE, USL_CODE, FRISK, STAGE)
          VALUES (3, 4, '0105701', -1, 2); @
INSERT INTO N382 (NAME_TABLE, NUM_LINE, USL_CODE, FRISK, STAGE)
          VALUES (3, 5, '0101801', -1, 2); @
INSERT INTO N382 (NAME_TABLE, NUM_LINE, USL_CODE, FRISK, STAGE)
          VALUES (3, 6, '0319002', -1, 2); @
INSERT INTO N382 (NAME_TABLE, NUM_LINE, USL_CODE, FRISK, STAGE)
          VALUES (3, 7, '0905027', -1, 2); @
INSERT INTO N382 (NAME_TABLE, NUM_LINE, USL_CODE, FRISK, STAGE)
          VALUES (3, 7, '0905028', -1, 2); @
INSERT INTO N382 (NAME_TABLE, NUM_LINE, USL_CODE, FRISK, STAGE)
          VALUES (3, 8, '0100101', -1, 2); @
INSERT INTO N382 (NAME_TABLE, NUM_LINE, USL_CODE, FRISK, STAGE)
          VALUES (3, 9, '0905084', -1, 2); @
INSERT INTO N382 (NAME_TABLE, NUM_LINE, USL_CODE, FRISK, STAGE)
          VALUES (3, 10, '0102901', -1, 2); @
INSERT INTO N382 (NAME_TABLE, NUM_LINE, USL_CODE, FRISK, STAGE)
          VALUES (3, 11, '0104701', -1, 2); @
INSERT INTO N382 (NAME_TABLE, NUM_LINE, USL_CODE, FRISK, STAGE)
          VALUES (3, 12, '0104701', -1, 2); @
INSERT INTO N382 (NAME_TABLE, NUM_LINE, USL_CODE, FRISK, STAGE)
          VALUES (3, 13, '0104701', -1, 2); @
INSERT INTO N382 (NAME_TABLE, NUM_LINE, USL_CODE, FRISK, STAGE)
          VALUES (2, 1, 'B04.047.002', 0, 1); @
INSERT INTO N382 (NAME_TABLE, NUM_LINE, USL_CODE, FRISK, STAGE)
          VALUES (2, 2, 'A01.31.009', -1, 1); @
INSERT INTO N382 (NAME_TABLE, NUM_LINE, USL_CODE, FRISK, STAGE)
          VALUES (2, 3, 'B04.047.002', 9, 1); @
INSERT INTO N382 (NAME_TABLE, NUM_LINE, USL_CODE, FRISK, STAGE)
          VALUES (2, 4, 'B04.047.002', 1, 1); @
INSERT INTO N382 (NAME_TABLE, NUM_LINE, USL_CODE, FRISK, STAGE)
          VALUES (2, 5, 'A09.05.026', -1, 1); @
INSERT INTO N382 (NAME_TABLE, NUM_LINE, USL_CODE, FRISK, STAGE)
          VALUES (2, 6, 'A09.05.023', -1, 1); @
INSERT INTO N382 (NAME_TABLE, NUM_LINE, USL_CODE, FRISK, STAGE)
          VALUES (2, 7, 'B04.047.002', 12, 1); @
INSERT INTO N382 (NAME_TABLE, NUM_LINE, USL_CODE, FRISK, STAGE)
          VALUES (2, 7, 'B04.047.002', 13, 1); @
INSERT INTO N382 (NAME_TABLE, NUM_LINE, USL_CODE, FRISK, STAGE)
          VALUES (2, 7, 'B04.047.002', 14, 1); @
INSERT INTO N382 (NAME_TABLE, NUM_LINE, USL_CODE, FRISK, STAGE)
          VALUES (2, 8, 'A05.10.006', -1, 1); @
INSERT INTO N382 (NAME_TABLE, NUM_LINE, USL_CODE, FRISK, STAGE)
          VALUES (2, 8, 'A05.10.004', -1, 1); @
INSERT INTO N382 (NAME_TABLE, NUM_LINE, USL_CODE, FRISK, STAGE)
          VALUES (2, 9, 'B04.001.002', -1, 1); @
INSERT INTO N382 (NAME_TABLE, NUM_LINE, USL_CODE, FRISK, STAGE)
          VALUES (2, 10, 'B04.001.002', -1, 1); @
INSERT INTO N382 (NAME_TABLE, NUM_LINE, USL_CODE, FRISK, STAGE)
          VALUES (2, 11, 'A06.09.006', -1, 1); @
INSERT INTO N382 (NAME_TABLE, NUM_LINE, USL_CODE, FRISK, STAGE)
          VALUES (2, 12, 'A06.20.004', -1, 1); @
INSERT INTO N382 (NAME_TABLE, NUM_LINE, USL_CODE, FRISK, STAGE)
          VALUES (2, 13, 'B03.016.002', -1, 1); @
INSERT INTO N382 (NAME_TABLE, NUM_LINE, USL_CODE, FRISK, STAGE)
          VALUES (2, 14, 'B03.016.003', -1, 1); @
INSERT INTO N382 (NAME_TABLE, NUM_LINE, USL_CODE, FRISK, STAGE)
          VALUES (2, 15, 'B03.016.004', -1, 1); @
INSERT INTO N382 (NAME_TABLE, NUM_LINE, USL_CODE, FRISK, STAGE)
          VALUES (2, 16, 'B03.016.006', -1, 1); @
INSERT INTO N382 (NAME_TABLE, NUM_LINE, USL_CODE, FRISK, STAGE)
          VALUES (2, 17, 'A09.19.001', -1, 1); @
INSERT INTO N382 (NAME_TABLE, NUM_LINE, USL_CODE, FRISK, STAGE)
          VALUES (2, 18, 'A09.05.130', -1, 1); @
INSERT INTO N382 (NAME_TABLE, NUM_LINE, USL_CODE, FRISK, STAGE)
          VALUES (2, 19, 'A04.06.001', -1, 1); @
INSERT INTO N382 (NAME_TABLE, NUM_LINE, USL_CODE, FRISK, STAGE)
          VALUES (2, 19, 'A04.14.001', -1, 1); @
INSERT INTO N382 (NAME_TABLE, NUM_LINE, USL_CODE, FRISK, STAGE)
          VALUES (2, 19, 'A04.14.002', -1, 1); @
INSERT INTO N382 (NAME_TABLE, NUM_LINE, USL_CODE, FRISK, STAGE)
          VALUES (2, 19, 'A04.15.001', -1, 1); @
INSERT INTO N382 (NAME_TABLE, NUM_LINE, USL_CODE, FRISK, STAGE)
          VALUES (2, 19, 'A04.28.002.001', -1, 1); @
INSERT INTO N382 (NAME_TABLE, NUM_LINE, USL_CODE, FRISK, STAGE)
          VALUES (2, 20, 'A02.26.015', -1, 1); @
INSERT INTO N382 (NAME_TABLE, NUM_LINE, USL_CODE, FRISK, STAGE)
          VALUES (2, 21, 'B04.023.002', -1, 1); @
INSERT INTO N382 (NAME_TABLE, NUM_LINE, USL_CODE, FRISK, STAGE)
          VALUES (2, 22, 'B04.047.002', -1, 1); @
INSERT INTO N382 (NAME_TABLE, NUM_LINE, USL_CODE, FRISK, STAGE)
          VALUES (3, 1, 'A04.12.005.002', -1, 2); @
INSERT INTO N382 (NAME_TABLE, NUM_LINE, USL_CODE, FRISK, STAGE)
          VALUES (3, 2, 'A03.16.001', -1, 2); @
INSERT INTO N382 (NAME_TABLE, NUM_LINE, USL_CODE, FRISK, STAGE)
          VALUES (3, 3, 'B01.023.001', -1, 2); @
INSERT INTO N382 (NAME_TABLE, NUM_LINE, USL_CODE, FRISK, STAGE)
          VALUES (3, 4, 'B01.053.001', -1, 2); @
INSERT INTO N382 (NAME_TABLE, NUM_LINE, USL_CODE, FRISK, STAGE)
          VALUES (3, 4, 'B01.057.001', -1, 2); @
INSERT INTO N382 (NAME_TABLE, NUM_LINE, USL_CODE, FRISK, STAGE)
          VALUES (3, 5, 'B01.018.001', -1, 2); @
INSERT INTO N382 (NAME_TABLE, NUM_LINE, USL_CODE, FRISK, STAGE)
          VALUES (3, 6, 'A03.19.002', -1, 2); @
INSERT INTO N382 (NAME_TABLE, NUM_LINE, USL_CODE, FRISK, STAGE)
          VALUES (3, 7, 'A09.05.027', -1, 2); @
INSERT INTO N382 (NAME_TABLE, NUM_LINE, USL_CODE, FRISK, STAGE)
          VALUES (3, 7, 'A09.05.028', -1, 2); @
INSERT INTO N382 (NAME_TABLE, NUM_LINE, USL_CODE, FRISK, STAGE)
          VALUES (3, 8, 'B01.001.001', -1, 2); @
INSERT INTO N382 (NAME_TABLE, NUM_LINE, USL_CODE, FRISK, STAGE)
          VALUES (3, 9, 'A09.05.083', -1, 2); @
INSERT INTO N382 (NAME_TABLE, NUM_LINE, USL_CODE, FRISK, STAGE)
          VALUES (3, 10, 'B01.029.001', -1, 2); @
INSERT INTO N382 (NAME_TABLE, NUM_LINE, USL_CODE, FRISK, STAGE)
          VALUES (3, 11, 'B01.047.001', -1, 2); @
INSERT INTO N382 (NAME_TABLE, NUM_LINE, USL_CODE, FRISK, STAGE)
          VALUES (3, 12, 'B01.047.001', -1, 2); @
INSERT INTO N382 (NAME_TABLE, NUM_LINE, USL_CODE, FRISK, STAGE)
          VALUES (3, 13, 'B01.047.001', -1, 2); @

DELETE FROM MKB10; @          

INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A00', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A00.0', ',    01,  cholerae'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A00.1', ',    01,  eltor'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A00.9', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A01', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A01.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A01.1', ' A'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A01.2', ' B'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A01.3', ' C'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A01.4', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A02', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A02.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A02.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A02.2+', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A02.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A02.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A03', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A03.0', ',  Shigella dysenteriae'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A03.1', ',  Shigella flexneri'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A03.2', ',  Shigella boydii'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A03.3', ',  Shigella sonnei'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A03.8', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A03.9', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A04', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A04.0', ' ,  Escherichia coli'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A04.1', ' ,  Escherichia coli'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A04.2', ' ,  Escherichia coli'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A04.3', ' ,  Escherichia coli'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A04.4', '  ,  Escherichia coli'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A04.5', ',  Campylobacter'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A04.6', ',  Yersinia enterocolitica'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A04.7', ',  Clostridium difficile'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A04.8', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A04.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A05', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A05.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A05.1', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A05.2', ' ,  Clostridium perfringens'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A05.3', ' ,  Vibrio parahaemolyticus'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A05.4', ' ,  Bacillus cereus'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A05.8', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A05.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A06', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A06.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A06.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A06.2', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A06.3', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A06.4', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A06.5+', '   (J99.8*)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A06.6+', '    (G07*)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A06.7', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A06.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A06.9', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A07', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A07.0', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A07.1', ' []'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A07.2', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A07.3', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A07.8', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A07.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A08', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A08.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A08.1', ' ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A08.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A08.3', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A08.4', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A08.5', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A09', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A09.0', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A09.9', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A15', '  ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A15.0', ' ,        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A15.1', ' ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A15.2', ' ,  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A15.3', ' ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A15.4', '   ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A15.5', ' ,   ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A15.6', ' ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A15.7', '   ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A15.8', '   ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A15.9', '    ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A16', '  ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A16.0', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A16.1', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A16.2', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A16.3', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A16.4', ' ,          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A16.5', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A16.7', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A16.8', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A16.9', '           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A17+', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A17.0+', '  (G01*)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A17.1+', '  (G07*)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A17.8+', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A17.9+', '    (G99.8*)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A18', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A18.0+', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A18.1+', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A18.11', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A18.12', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A18.13', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A18.14', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A18.15', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A18.16', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A18.17', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A18.18', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A18.2', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A18.3', ' ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A18.4', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A18.5+', '  :    (A18.4)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A18.51', '  :    (A18.4)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A18.52', '  :    (A18.4)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A18.53', '  :    (A18.4)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A18.54', '  :    (A18.4)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A18.6+', '  :   (A18.0+)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A18.7+', '  (E35.1*)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A18.8+', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A18.81', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A18.82', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A18.83', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A18.84', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A18.85', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A18.86', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A18.87', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A19', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A19.0', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A19.1', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A19.2', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A19.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A19.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A20', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A20.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A20.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A20.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A20.3', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A20.7', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A20.8', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A20.9', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A21', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A21.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A21.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A21.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A21.3', '- '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A21.7', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A21.8', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A21.9', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A22', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A22.0', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A22.1', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A22.2', '-   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A22.7', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A22.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A22.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A23', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A23.0', ',  Brucella melitensis'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A23.1', ',  Brucella abortus'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A23.2', ',  Brucella suis'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A23.3', ',  Brucella canis'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A23.8', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A23.9', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A24', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A24.0', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A24.1', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A24.2', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A24.3', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A24.4', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A25', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A25.0', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A25.1', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A25.9', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A26', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A26.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A26.7', ',  Erysipelothrix'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A26.8', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A26.9', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A27', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A27.0', ' -'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A27.8', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A27.9', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A28', '  ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A28.0', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A28.1', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A28.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A28.8', '   ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A28.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A30', ' [ ]'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A30.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A30.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A30.2', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A30.3', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A30.4', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A30.5', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A30.8', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A30.9', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A31', ',   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A31.0', ' ,  Mycobacterium'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A31.1', ' ,  Mycobacterium'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A31.8', ' ,  Mycobacterium'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A31.9', ',  Mycobacterium, '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A32', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A32.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A32.1+', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A32.7', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A32.8', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A32.9', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A33', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A34', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A35', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A36', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A36.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A36.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A36.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A36.3', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A36.8', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A36.9', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A37', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A37.0', ',  Bordetella pertussis'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A37.1', ',  Bordetella parapertussis'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A37.8', ',      Bordetella'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A37.9', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A38', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A39', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A39.0+', '  (G01*)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A39.1+', ' - (E35.1*)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A39.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A39.3', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A39.4', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A39.5+', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A39.8', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A39.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A40', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A40.0', ',    A'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A40.1', ',    B'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A40.2', ',    D'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A40.3', ',  Streptococcus pneumoniae'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A40.8', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A40.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A41', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A41.0', ',  Staphylococcus aureus'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A41.1', ',    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A41.2', ',   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A41.3', ',  Haemophilus influenzae'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A41.4', ',  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A41.5', ',    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A41.8', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A41.9', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A42', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A42.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A42.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A42.2', '- '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A42.7', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A42.8', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A42.9', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A43', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A43.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A43.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A43.8', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A43.9', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A44', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A44.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A44.1', '  - '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A44.8', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A44.9', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A46', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A48', '  ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A48.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A48.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A48.2', '    [ ]'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A48.3', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A48.4', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A48.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A49', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A49.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A49.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A49.2', ',  Haemophilus influenzae, '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A49.3', ',  , '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A49.8', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A49.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A50', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A50.0', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A50.1', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A50.2', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A50.3', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A50.4', '   [ ]'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A50.5', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A50.6', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A50.7', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A50.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A51', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A51.0', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A51.1', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A51.2', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A51.3', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A51.4', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A51.5', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A51.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A52', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A52.0+', ' - '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A52.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A52.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A52.3', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A52.7', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A52.8', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A52.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A53', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A53.0', ' ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A53.9', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A54', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A54.0', '           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A54.1', '           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A54.2+', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A54.3', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A54.4+', '  - '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A54.5', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A54.6', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A54.8', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A54.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A55', '  ()'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A56', '  ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A56.0', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A56.1+', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A56.2', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A56.3', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A56.4', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A56.8', ' ,   ,  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A57', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A58', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A59', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A59.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A59.8', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A59.9', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A60', '    [herpes simplex]'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A60.0', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A60.1', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A60.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A63', ' ,    ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A63.0', ' () '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A63.8', '  ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A64', ',   , '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A65', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A66', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A66.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A66.1', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A66.2', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A66.3', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A66.4', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A66.5', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A66.6', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A66.7', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A66.8', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A66.9', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A67', ' []'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A67.0', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A67.1', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A67.2', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A67.3', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A67.9', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A68', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A68.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A68.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A68.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A69', ' ,  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A69.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A69.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A69.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A69.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A69.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A70', ',  Chlamydia psittaci'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A71', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A71.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A71.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A71.9', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A74', ' ,  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A74.0+', '  (H13.1*)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A74.8', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A74.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A75', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A75.0', '  ,  Rickettsia prowazekii'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A75.1', '  [ ]'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A75.2', ',  Rickettsia typhi'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A75.3', ',  Rickettsia tsutsugamushi'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A75.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A77', '  [ ]'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A77.0', ' ,  Rickettsia rickettsii'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A77.1', ' ,  Rickettsia conorii'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A77.2', ' ,  Rickettsia siberica'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A77.3', ' ,  Rickettsia australis'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A77.8', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A77.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A78', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A79', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A79.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A79.1', ' ,  Rickettsia akari'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A79.8', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A79.9', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A80', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A80.0', '  ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A80.1', '  ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A80.2', '  ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A80.3', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A80.4', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A80.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A81', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A81.0', ' -'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A81.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A81.2', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A81.8', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A81.9', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A82', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A82.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A82.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A82.9', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A83', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A83.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A83.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A83.2', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A83.3', ' -'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A83.4', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A83.5', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A83.6', ',   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A83.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A83.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A84', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A84.0', '   [ - ]'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A84.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A84.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A84.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A85', '  ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A85.0+', '  (G05.1*)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A85.1+', '  (G05.1*)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A85.2', ' ,  , '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A85.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A86', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A87', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A87.0+', '  (G02.0*)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A87.1+', '  (G02.0*)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A87.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A87.8', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A87.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A88', '     ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A88.0', '   [ ]'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A88.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A88.8', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A89', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A90', '  [  ]'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A91', ' ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A92', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A92.0', ',   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A92.1', ' ''-'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A92.2', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A92.3', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A92.4', ' - [ ]'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A92.8', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A92.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A93', '  ,  ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A93.0', ',   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A93.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A93.2', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A93.8', '   ,  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A94', ' ,  , '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A95', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A95.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A95.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A95.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A96', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A96.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A96.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A96.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A96.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A96.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A98', '   ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A98.0', '   (  )'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A98.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A98.2', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A98.3', ',   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A98.4', ',   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A98.5', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A98.8', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('A99', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B00', ',    [herpes simplex]'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B00.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B00.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B00.2', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B00.3+', '  (G02.0*)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B00.4+', '  (G05.1*)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B00.5+', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B00.7', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B00.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B00.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B01', '  [varicella]'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B01.0+', '    (G02.0*)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B01.1+', '    (G05.1*)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B01.2+', '    (J17.1*)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B01.8', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B01.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B02', '  [herpes zoster]'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B02.0+', '    (G05.1*)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B02.1+', '    (G02.0*)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B02.2+', '        '); @
COMMIT WORK; @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B02.3+', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B02.7', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B02.8', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B02.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B03', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B04', ',    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B05', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B05.0+', ',   (G05.1*)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B05.1+', ',   (G02.0*)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B05.2+', ',   (J17.1*)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B05.3+', ',    (H67.1*)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B05.4', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B05.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B05.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B06', ' [ ]'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B06.0+', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B06.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B06.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B07', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B08', '  ,      ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B08.0', ' ,   orthopoxvirus'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B08.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B08.2', '  ( )'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B08.3', '  ( )'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B08.4', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B08.5', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B08.8', '  ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B09', ' ,      , '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B15', '  A'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B15.0', ' A   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B15.9', ' A   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B16', '  B'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B16.0', '  B  - ()   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B16.1', '  B  - ()   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B16.2', '  B  -   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B16.9', '  B  -    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B17', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B17.0', ' -()-   B'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B17.1', '  C'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B17.2', '  E'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B17.8', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B18', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B18.0', '   B  -'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B18.1', '   B  -'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B18.2', '   C'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B18.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B18.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B19', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B19.0', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B19.9', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B20', ',     [],       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B20.0', ',  ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B20.1', ',  ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B20.2', ',  ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B20.3', ',  ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B20.4', ',  ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B20.5', ',  ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B20.6', ',  ,   ,  Pneumocystis carinii'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B20.7', ',  ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B20.8', ',  ,       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B20.9', ',  ,       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B21', ',     [],     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B21.0', ',  ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B21.1', ',  ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B21.2', ',  ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B21.3', ',  ,      ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B21.7', ',  ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B21.8', ',  ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B21.9', ',  ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B22', ',     [],      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B22.0', ',  ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B22.1', ',  ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B22.2', ',  ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B22.7', ',  ,    ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B23', ',     [],     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B23.0', ' - '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B23.1', ',  ,   ()  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B23.2', ',  ,      ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B23.8', ',  ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B24', ',     [], '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B25', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B25.0+', '  (J17.1*)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B25.1+', '  (K77.0*)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B25.2+', '  (K87.1*)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B25.8', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B25.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B26', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B26.0+', '  (N51.1*)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B26.1+', '  (G02.0*)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B26.2+', '  (G05.1*)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B26.3+', '  (K87.1*)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B26.8', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B26.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B27', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B27.0', ',  - '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B27.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B27.8', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B27.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B30', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B30.0+', ',   (H19.2*)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B30.1+', ',   (H13.1*)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B30.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B30.3+', '    () (H13.1*)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B30.8+', '   (H13.1*)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B30.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B33', '  ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B33.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B33.1', ' -'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B33.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B33.3', ' ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B33.4', ' ()-  (HPS)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B33.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B34', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B34.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B34.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B34.2', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B34.3', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B34.4', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B34.8', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B34.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B35', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B35.0', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B35.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B35.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B35.3', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B35.4', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B35.5', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B35.6', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B35.8', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B35.9', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B36', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B36.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B36.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B36.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B36.3', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B36.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B36.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B37', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B37.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B37.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B37.2', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B37.3+', '    (N77.1*)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B37.4+', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B37.5+', '  (G02.1*)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B37.6+', '  (I39.8*)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B37.7', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B37.8', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B37.9', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B38', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B38.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B38.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B38.2', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B38.3', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B38.4+', '  (G02.1*)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B38.7', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B38.8', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B38.9', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B39', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B39.0', '  ,  Histoplasma capsulatum'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B39.1', '  ,  Histoplasma capsulatum'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B39.2', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B39.3', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B39.4', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B39.5', ',  Histoplasma duboisii'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B39.9', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B40', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B40.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B40.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B40.2', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B40.3', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B40.7', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B40.8', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B40.9', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B41', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B41.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B41.7', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B41.8', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B41.9', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B42', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B42.0+', '  (J99.8*)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B42.1', '- '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B42.7', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B42.8', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B42.9', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B43', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B43.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B43.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B43.2', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B43.8', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B43.9', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B44', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B44.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B44.1', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B44.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B44.7', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B44.8', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B44.9', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B45', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B45.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B45.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B45.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B45.3', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B45.7', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B45.8', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B45.9', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B46', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B46.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B46.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B46.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B46.3', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B46.4', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B46.5', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B46.8', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B46.9', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B47', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B47.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B47.1', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B47.9', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B48', ' ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B48.0', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B48.1', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B48.2', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B48.3', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B48.4', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B48.7', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B48.8', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B49', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B50', ',  Plasmodium falciparum'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B50.0', ',  Plasmodium falciparum,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B50.8', '     ,  Plasmodium falciparum'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B50.9', ',  Plasmodium falciparum, '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B51', ',  Plasmodium vivax'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B51.0', ',  Plasmodium vivax,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B51.8', ',  Plasmodium vivax,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B51.9', ',  Plasmodium vivax,  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B52', ',  Plasmodium malariae'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B52.0', ',  Plasmodium malariae,  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B52.8', ',  Plasmodium malariae,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B52.9', ',  Plasmodium malariae,  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B53', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B53.0', ',  Plasmodium ovale'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B53.1', ',   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B53.8', '   ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B54', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B55', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B55.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B55.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B55.2', '- '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B55.9', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B56', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B56.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B56.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B56.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B57', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B57.0+', '       (I41.2*, I98.1*)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B57.1', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B57.2+', '  ()    (I41.2*, I98.1*)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B57.3', '  ()    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B57.4', '  ()    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B57.5', '  ()    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B58', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B58.0+', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B58.1+', '  (K77.0*)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B58.2+', '  (G05.2*)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B58.3+', '  (J17.3*)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B58.8', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B58.9', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B59', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B60', '  ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B60.0', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B60.1', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B60.2', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B60.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B64', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B65', ' []'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B65.0', ',  Schistosoma haematobium [ ]'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B65.1', ',  Schistosoma mansoni [ ]'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B65.2', ',  Schistosoma japonicum'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B65.3', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B65.8', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B65.9', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B66', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B66.0', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B66.1', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B66.2', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B66.3', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B66.4', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B66.5', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B66.8', ',   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B66.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B67', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B67.0', ' ,  Echinococcus granulosus'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B67.1', ' ,  Echinococcus granulosus'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B67.2', ' ,  Echinococcus granulosus'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B67.3', '     ,  Echinococcus granulosus'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B67.4', ',  Echinococcus granulosus, '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B67.6', '     ,  Echinococcus multilocularis'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B67.7', ',  Echinococcus multilocularis, '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B67.8', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B67.9', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B68', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B68.0', ',  Taenia solium'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B68.1', ',  Taenia saginata'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B68.9', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B69', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B69.0', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B69.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B69.8', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B69.9', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B70', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B70.0', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B70.1', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B71', ' ,  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B71.0', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B71.1', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B71.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B71.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B72', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B73', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B74', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B74.0', ',  Wuchereria bancrofti'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B74.1', ',  Brugia malayi'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B74.2', ',  Brugia timori'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B74.3', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B74.4', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B74.8', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B74.9', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B75', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B76', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B76.0', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B76.1', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B76.8', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B76.9', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B77', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B77.0', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B77.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B77.9', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B78', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B78.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B78.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B78.7', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B78.9', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B79', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B80', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B81', '  ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B81.0', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B81.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B81.2', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B81.3', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B81.4', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B81.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B82', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B82.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B82.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B83', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B83.0', '  ,     [ Larva migrans]'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B83.1', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B83.2', ',  Parastrongylus cantonensis'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B83.3', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B83.4', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B83.8', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B83.9', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B85', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B85.0', ',  Pediculus humanus capitis'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B85.1', ',  Pediculus humanus corporis'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B85.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B85.3', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B85.4', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B86', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B87', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B87.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B87.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B87.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B87.3', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B87.4', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B87.8', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B87.9', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B88', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B88.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B88.1', ' [   ]'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B88.2', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B88.3', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B88.8', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B88.9', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B89', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B90', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B90.0', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B90.1', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B90.2', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B90.8', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B90.9', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B90.91', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B90.92', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B90.93', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B91', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B92', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B94', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B94.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B94.1', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B94.2', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B94.8', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B94.9', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B95', '     ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B95.0', '  A'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B95.1', '  B'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B95.2', '  D'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B95.3', 'Streptococcus pneumoniae'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B95.4', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B95.5', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B95.6', 'Staphylococcus aureus'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B95.7', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B95.8', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B96', '     ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B96.0', 'Mycoplasma pneumoniae [M.pneumoniae]'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B96.1', 'Klebsiella pneumoniae [K.pneumoniae]'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B96.2', 'Escherichia coli [E.coli]'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B96.3', 'Haemophilus influenzae [H.influenzae]'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B96.4', 'Proteus (mirabilis) (morganii)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B96.5', 'Pseudomonas (aeruginosa) (mallei) (pseudomallei)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B96.6', 'Bacillus fragilis [B.fragilis]'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B96.7', 'Clostridium perfringens [C.perfringens]'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B96.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B97', '    ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B97.0', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B97.1', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B97.2', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B97.3', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B97.4', '- '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B97.5', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B97.6', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B97.7', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B97.8', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('B99', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C00', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C00.0', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C00.1', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C00.2', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C00.3', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C00.4', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C00.5', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C00.6', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C00.8', ',         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C00.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C01', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C02', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C02.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C02.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C02.2', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C02.3', ' 2/3   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C02.4', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C02.8', ' ,        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C02.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C03', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C03.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C03.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C03.9', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C04', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C04.0', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C04.1', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C04.8', '   ,        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C04.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C05', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C05.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C05.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C05.2', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C05.8', ' ,        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C05.9', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C06', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C06.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C06.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C06.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C06.8', ' ,        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C06.9', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C07', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C08', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C08.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C08.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C08.8', '   ,        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C08.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C09', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C09.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C09.1', '   () ()'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C09.8', ' ,        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C09.9', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C10', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C10.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C10.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C10.2', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C10.3', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C10.4', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C10.8', ' ,        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C10.9', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C11', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C11.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C11.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C11.2', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C11.3', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C11.8', ' ,        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C11.9', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C12', '   '); @
COMMIT WORK; @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C13', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C13.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C13.1', '     :     (C32.1)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C13.2', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C13.8', '   ,        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C13.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C14', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C14.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C14.2', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C14.8', ' ,    ,        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C15', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C15.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C15.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C15.2', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C15.3', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C15.4', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C15.5', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C15.8', ' ,        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C15.9', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C16', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C16.0', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C16.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C16.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C16.3', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C16.4', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C16.5', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C16.6', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C16.8', ' ,        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C16.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C17', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C17.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C17.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C17.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C17.3', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C17.8', '  ,        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C17.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C18', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C18.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C18.1', '  []'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C18.2', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C18.3', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C18.4', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C18.5', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C18.6', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C18.7', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C18.8', '  ,        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C18.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C19', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C20', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C21', '    []   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C21.0', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C21.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C21.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C21.8', '  ,   []   ,        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C22', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C22.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C22.1', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C22.2', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C22.3', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C22.4', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C22.7', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C22.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C23', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C24', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C24.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C24.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C24.8', '  ,        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C24.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C25', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C25.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C25.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C25.2', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C25.3', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C25.4', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C25.7', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C25.8', '  ,        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C25.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C26', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C26.0', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C26.1', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C26.8', '  ,        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C26.9', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C30', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C30.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C30.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C31', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C31.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C31.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C31.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C31.3', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C31.8', '  ,        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C31.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C32', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C32.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C32.1', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C32.2', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C32.3', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C32.8', ' ,        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C32.9', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C33', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C34', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C34.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C34.1', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C34.2', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C34.3', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C34.8', '   ,        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C34.9', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C37', '    []'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C38', '  ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C38.0', ' :   (C49.3)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C38.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C38.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C38.3', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C38.4', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C38.8', ' ,   ,        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C39', '           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C39.0', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C39.8', '     ,        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C39.9', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C40', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C40.0', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C40.1', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C40.2', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C40.3', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C40.8', '     ,        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C40.9', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C41', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C41.0', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C41.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C41.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C41.3', ',   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C41.4', ' ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C41.8', '    ,        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C41.9', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C43', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C43.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C43.1', '  ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C43.2', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C43.3', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C43.4', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C43.5', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C43.6', '   ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C43.7', '   ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C43.8', '  ,        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C43.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C44', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C44.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C44.1', ' ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C44.2', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C44.3', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C44.4', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C44.5', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C44.6', '  ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C44.7', '  ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C44.8', ' ,        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C44.9', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C45', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C45.0', '  :     (C38.4)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C45.1', '  :     (C48.-)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C45.2', '  :     (C38.0)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C45.7', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C45.9', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C46', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C46.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C46.1', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C46.2', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C46.3', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C46.7', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C46.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C46.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C47', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C47.0', '  ,    :    (C69.6)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C47.1', '   ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C47.2', '   ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C47.3', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C47.4', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C47.5', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C47.6', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C47.8', '      ,        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C47.9', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C48', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C48.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C48.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C48.2', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C48.8', '    ,        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C49', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C49.0', '    ,    :    (C69.6)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C49.1', '     ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C49.2', '     ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C49.3', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C49.4', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C49.5', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C49.6', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C49.8', '    ,        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C49.9', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C50', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C50.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C50.1', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C50.2', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C50.3', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C50.4', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C50.5', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C50.6', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C50.8', '  ,        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C50.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C51', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C51.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C51.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C51.2', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C51.8', ' ,        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C51.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C52', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C53', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C53.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C53.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C53.8', '  ,        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C53.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C54', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C54.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C54.1', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C54.2', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C54.3', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C54.8', '  ,        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C54.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C55', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C56', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C57', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C57.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C57.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C57.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C57.3', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C57.4', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C57.7', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C57.8', '   ,        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C57.9', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C58', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C60', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C60.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C60.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C60.2', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C60.8', '  ,        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C60.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C61', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C62', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C62.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C62.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C62.9', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C63', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C63.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C63.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C63.2', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C63.7', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C63.8', '   ,        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C63.9', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C64', '  ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C65', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C66', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C67', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C67.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C67.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C67.2', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C67.3', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C67.4', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C67.5', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C67.6', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C67.7', '   ()'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C67.8', '  ,        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C67.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C68', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C68.0', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C68.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C68.8', '  ,        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C68.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C69', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C69.0', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C69.1', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C69.2', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C69.3', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C69.4', ' [] '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C69.5', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C69.6', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C69.8', '     ,        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C69.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C70', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C70.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C70.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C70.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C71', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C71.0', ' ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C71.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C71.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C71.3', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C71.4', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C71.5', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C71.6', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C71.7', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C71.8', ',          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C71.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C72', '   ,        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C72.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C72.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C72.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C72.3', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C72.4', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C72.5', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C72.8', '        ,        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C72.9', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C73', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C74', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C74.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C74.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C74.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C75', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C75.0', ' [] '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C75.1', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C75.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C75.3', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C75.4', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C75.5', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C75.8', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C75.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C76', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C76.0', ',   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C76.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C76.2', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C76.3', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C76.4', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C76.5', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C76.7', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C76.8', '     ,        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C77', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C77.0', '  ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C77.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C77.2', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C77.3', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C77.4', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C77.5', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C77.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C77.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C78', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C78.0', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C78.1', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C78.2', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C78.3', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C78.4', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C78.5', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C78.6', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C78.7', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C78.8', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C79', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C79.0', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C79.1', '    ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C79.2', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C79.3', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C79.4', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C79.5', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C79.6', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C79.7', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C79.8', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C79.9', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C80', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C80.0', '    ,  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C80.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C81', '  []'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C81.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C81.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C81.2', '- '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C81.3', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C81.4', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C81.7', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C81.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C82', ' []  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C82.0', '   , '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C82.1', ',      , '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C82.2', ', '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C82.3', '  IIIa '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C82.4', '  IIIb '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C82.5', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C82.6', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C82.7', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C82.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C83', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C83.0', ' ()'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C83.1', '    ()'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C83.3', ' ()'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C83.5', ' ()'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C83.7', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C83.8', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C83.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C84', '   T- '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C84.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C84.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C84.4', ' T- '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C84.5', '   T- '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C84.6', '  , ALK-'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C84.7', '  , ALK-'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C84.8', ' T-  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C84.9', ' T/NK-  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C85', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C85.1', 'B-  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C85.2', ' ()  B- '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C85.7', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C85.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C86', '   T/NK- '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C86.0', ' T/NK- ,  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C86.1', '- T- '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C86.2', 'T-   () '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C86.3', '  T- '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C86.4', ' NK- '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C86.5', ' T- '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C86.6', '  CD30- T- '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C88', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C88.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C88.1', ' - '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C88.2', ' - '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C88.3', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C88.4', ' B-   ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C88.7', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C88.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C90', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C90.0', '  :   (C90.2)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C90.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C90.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C90.3', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C91', '  []'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C91.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C91.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C91.3', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C91.4', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C91.5', 'T-  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C91.6', '  T- '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C91.7', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C91.8', ' B-   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C91.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C92', '  []'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C92.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C92.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C92.2', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C92.3', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C92.4', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C92.5', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C92.6', '     11q23'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C92.7', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C92.8', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C92.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C93', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C93.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C93.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C93.3', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C93.7', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C93.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C94', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C94.0', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C94.2', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C94.3', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C94.4', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C94.6', '   ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C94.7', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C95', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C95.0', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C95.1', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C95.7', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C95.9', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C96', '     ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C96.0', ' -'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C96.2', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C96.4', '   () '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C96.5', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C96.6', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C96.7', '    ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C96.8', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C96.9', '  ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('C97', '   ()  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D00', ' in situ  ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D00.0', ',    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D00.1', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D00.2', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D01', ' in situ     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D01.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D01.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D01.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D01.3', '  []   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D01.4', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D01.5', ',     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D01.7', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D01.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D02', ' in situ     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D02.0', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D02.1', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D02.2', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D02.3', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D02.4', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D03', ' in situ'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D03.0', ' in situ '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D03.1', ' in situ ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D03.2', ' in situ     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D03.3', ' in situ     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D03.4', ' in situ     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D03.5', ' in situ '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D03.6', ' in situ  ,    '); @
COMMIT WORK; @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D03.7', ' in situ  ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D03.8', ' in situ  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D03.9', ' in situ  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D04', ' in situ '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D04.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D04.1', ' ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D04.2', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D04.3', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D04.4', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D04.5', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D04.6', '  ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D04.7', '  ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D04.8', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D04.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D05', ' in situ  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D05.0', '  in situ'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D05.1', '  in situ'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D05.7', '  in situ  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D05.9', ' in situ   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D06', ' in situ  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D06.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D06.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D06.7', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D06.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D07', ' in situ     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D07.0', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D07.1', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D07.2', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D07.3', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D07.4', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D07.5', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D07.6', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D09', ' in situ    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D09.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D09.1', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D09.2', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D09.3', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D09.7', ' in situ   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D09.9', ' in situ  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D10', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D10.0', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D10.1', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D10.2', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D10.3', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D10.4', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D10.5', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D10.6', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D10.7', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D10.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D11', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D11.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D11.7', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D11.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D12', '   ,  ,   []   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D12.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D12.1', '  []'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D12.2', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D12.3', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D12.4', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D12.5', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D12.6', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D12.7', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D12.8', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D12.9', '  []   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D13', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D13.0', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D13.1', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D13.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D13.3', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D13.4', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D13.5', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D13.6', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D13.7', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D13.9', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D14', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D14.0', ' ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D14.1', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D14.2', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D14.3', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D14.4', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D15', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D15.0', '  []'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D15.1', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D15.2', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D15.7', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D15.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D16', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D16.0', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D16.1', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D16.2', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D16.3', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D16.4', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D16.5', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D16.6', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D16.7', ',   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D16.8', ' ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D16.9', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D17', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D17.0', '        ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D17.1', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D17.2', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D17.3', '           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D17.4', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D17.5', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D17.6', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D17.7', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D17.9', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D18', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D18.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D18.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D19', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D19.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D19.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D19.7', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D19.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D20', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D20.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D20.1', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D21', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D21.0', '     ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D21.1', '      ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D21.2', '      ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D21.3', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D21.4', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D21.5', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D21.6', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D21.9', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D22', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D22.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D22.1', '  ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D22.2', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D22.3', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D22.4', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D22.5', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D22.6', '   ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D22.7', '   ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D22.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D23', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D23.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D23.1', ' ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D23.2', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D23.3', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D23.4', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D23.5', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D23.6', '  ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D23.7', '  ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D23.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D24', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D25', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D25.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D25.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D25.2', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D25.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D26', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D26.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D26.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D26.7', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D26.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D27', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D28', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D28.0', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D28.1', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D28.2', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D28.7', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D28.9', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D29', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D29.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D29.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D29.2', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D29.3', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D29.4', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D29.7', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D29.9', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D30', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D30.0', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D30.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D30.2', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D30.3', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D30.4', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D30.7', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D30.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D31', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D31.0', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D31.1', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D31.2', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D31.3', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D31.4', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D31.5', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D31.6', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D31.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D32', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D32.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D32.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D32.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D33', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D33.0', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D33.1', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D33.2', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D33.3', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D33.4', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D33.7', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D33.9', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D34', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D35', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D35.0', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D35.1', ' [] '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D35.2', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D35.3', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D35.4', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D35.5', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D35.6', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D35.7', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D35.8', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D35.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D36', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D36.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D36.1', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D36.7', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D36.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D37', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D37.0', ',    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D37.1', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D37.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D37.3', '  []'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D37.4', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D37.5', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D37.6', ',     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D37.7', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D37.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D38', '      ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D38.0', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D38.1', ',   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D38.2', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D38.3', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D38.4', '  []'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D38.5', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D38.6', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D39', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D39.0', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D39.1', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D39.2', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D39.7', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D39.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D40', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D40.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D40.1', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D40.7', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D40.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D41', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D41.0', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D41.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D41.2', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D41.3', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D41.4', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D41.7', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D41.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D42', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D42.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D42.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D42.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D43', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D43.0', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D43.1', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D43.2', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D43.3', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D43.4', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D43.7', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D43.9', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D44', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D44.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D44.1', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D44.2', ' [] '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D44.3', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D44.4', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D44.5', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D44.6', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D44.7', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D44.8', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D44.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D45', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D46', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D46.0', '   ,  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D46.1', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D46.2', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D46.3', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D46.4', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D46.5', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D46.6', '    del(5q)  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D46.7', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D46.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D47', '      ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D47.0', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D47.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D47.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D47.3', ' () '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D47.4', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D47.5', '   ( )'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D47.7', '       ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D47.9', '     ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D48', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D48.0', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D48.1', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D48.2', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D48.3', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D48.4', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D48.5', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D48.6', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D48.7', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D48.9', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D50', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D50.0', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D50.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D50.8', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D50.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D51', '-B12- '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D51.0', '-B12-     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D51.1', '-B12-       B12  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D51.2', '  II'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D51.3', ' -B12- ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D51.8', ' -B12- '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D51.9', '-B12-  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D52', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D52.0', ' ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D52.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D52.8', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D52.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D53', ' ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D53.0', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D53.1', '  ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D53.2', ',  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D53.8', '  ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D53.9', ',   , '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D55', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D55.0', '   -6- [-6-]'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D55.1', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D55.2', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D55.3', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D55.8', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D55.9', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D56', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D56.0', '-'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D56.1', '-'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D56.2', '--'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D56.3', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D56.4', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D56.8', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D56.9', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D57', '- '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D57.0', '-   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D57.1', '-   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D57.2', '  - '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D57.3', '  -'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D57.8', ' - '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D58', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D58.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D58.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D58.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D58.8', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D58.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D59', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D59.0', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D59.1', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D59.2', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D59.3', '- '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D59.4', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D59.5', '   [-]'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D59.6', '  ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D59.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D59.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D60', '    []'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D60.0', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D60.1', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D60.8', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D60.9', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D61', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D61.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D61.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D61.2', ' ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D61.3', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D61.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D61.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D62', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D63*', '   ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D63.0*', '   (C00-D48+)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D63.8*', '    ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D64', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D64.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D64.1', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D64.2', '  ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D64.3', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D64.4', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D64.8', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D64.9', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D65', '   [ ]'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D66', '   VIII'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D67', '   IX'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D67.5', ' ,  Echinococcus multilocularis'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D68', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D68.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D68.1', '   XI'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D68.2', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D68.3', ' ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D68.4', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D68.5', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D68.6', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D68.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D68.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D69', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D69.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D69.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D69.2', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D69.3', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D69.4', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D69.5', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D69.6', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D69.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D69.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D70', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D71', '  - '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D72', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D72.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D72.1', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D72.8', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D72.9', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D73', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D73.0', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D73.1', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D73.2', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D73.3', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D73.4', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D73.5', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D73.8', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D73.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D74', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D74.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D74.8', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D74.9', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D75', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D75.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D75.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D75.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D75.8', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D75.9', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D76', ' ,        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D76.0', '   ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D76.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D76.2', ' ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D76.3', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D77*', '       ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D80', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D80.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D80.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D80.2', '   A [IgA]'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D80.3', '    G [IgG]'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D80.4', '   M [IgM]'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D80.5', '     M'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D80.6', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D80.7', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D80.8', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D80.9', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D81', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D81.0', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D81.1', '      T-  B-'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D81.2', '        B-'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D81.3', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D81.4', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D81.5', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D81.6', '   I   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D81.7', '   II   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D81.8', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D81.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D82', ',     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D82.0', ' -'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D82.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D82.2', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D82.3', '   ,   -'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D82.4', '  E [IgE]'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D82.8', ',      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D82.9', ',    , '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D83', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D83.0', '           B-'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D83.1', '       T-'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D83.2', '      B-  T-'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D83.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D83.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D84', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D84.0', '  -1  [LFA-1]'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D84.1', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D84.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D84.9', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D86', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D86.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D86.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D86.2', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D86.3', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D86.8', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D86.9', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D89', '     ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D89.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D89.1', ''); @
COMMIT WORK; @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D89.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D89.3', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D89.8', '      ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('D89.9', ',   , '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E00', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E00.0', '   ,  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E00.1', '   ,  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E00.2', '   ,  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E00.9', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E01', '  ,    ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E01.0', ' () ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E01.1', ' () ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E01.2', ' (),    , '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E01.8', '   ,    ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E02', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E03', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E03.0', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E03.1', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E03.2', ',      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E03.3', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E03.4', '   () :     (E03.1)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E03.5', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E03.8', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E03.9', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E04', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E04.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E04.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E04.2', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E04.8', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E04.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E05', ' []'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E05.0', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E05.1', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E05.2', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E05.3', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E05.4', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E05.5', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E05.8', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E05.9', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E06', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E06.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E06.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E06.2', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E06.3', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E06.4', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E06.5', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E06.9', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E07', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E07.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E07.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E07.8', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E07.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E10', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E10.0', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E10.1', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E10.2+', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E10.3+', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E10.4+', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E10.5', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E10.6', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E10.7', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E10.8', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E10.9', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E11', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E11.0', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E11.1', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E11.2+', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E11.3+', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E11.4+', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E11.5', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E11.6', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E11.7', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E11.8', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E11.9', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E12', ' ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E12.0', ' ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E12.1', ' ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E12.2+', ' ,       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E12.3+', ' ,       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E12.4+', ' ,       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E12.5', ' ,        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E12.6', ' ,        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E12.7', ' ,       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E12.8', ' ,       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E12.9', ' ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E13', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E13.0', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E13.1', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E13.2+', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E13.3+', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E13.4+', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E13.5', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E13.6', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E13.7', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E13.8', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E13.9', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E14', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E14.0', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E14.1', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E14.2+', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E14.3+', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E14.4+', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E14.5', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E14.6', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E14.7', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E14.8', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E14.9', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E15', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E16', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E16.0', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E16.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E16.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E16.3', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E16.4', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E16.8', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E16.9', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E20', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E20.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E20.1', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E20.8', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E20.9', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E21', '     [] '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E21.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E21.1', ' ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E21.2', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E21.3', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E21.4', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E21.5', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E22', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E22.0', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E22.1', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E22.2', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E22.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E22.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E23', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E23.0', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E23.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E23.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E23.3', ' ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E23.6', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E23.7', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E24', ' -'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E24.0', ' -  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E24.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E24.2', '  -'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E24.3', ' -'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E24.4', ' ,  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E24.8', ' ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E24.9', ' - '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E25', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E25.0', '  ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E25.8', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E25.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E26', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E26.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E26.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E26.8', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E26.9', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E27', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E27.0', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E27.1', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E27.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E27.3', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E27.4', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E27.5', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E27.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E27.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E28', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E28.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E28.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E28.2', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E28.3', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E28.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E28.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E29', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E29.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E29.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E29.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E29.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E30', '  ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E30.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E30.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E30.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E30.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E31', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E31.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E31.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E31.8', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E31.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E32', '   []'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E32.0', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E32.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E32.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E32.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E34', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E34.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E34.1', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E34.2', '  ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E34.3', ' [],     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E34.4', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E34.5', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E34.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E34.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E35*', '    ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E35.0*', '    ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E35.1*', '   ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E35.8*', '     ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E40', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E41', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E42', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E43', ' -  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E44', '-     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E44.0', ' - '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E44.1', ' - '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E45', ' ,  - '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E46', '-  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E50', '  A'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E50.0', '  A   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E50.1', '  A      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E50.2', '  A   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E50.3', '  A     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E50.4', '  A  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E50.5', '  A   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E50.6', '  A    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E50.7', '     A'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E50.8', '    A'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E50.9', '  A '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E51', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E51.1', '-'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E51.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E51.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E51.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E52', '   []'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E53', '    B'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E53.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E53.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E53.8', '     B'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E53.9', '   B '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E54', '   [ C]'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E55', '  D'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E55.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E55.9', '  D '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E56', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E56.0', '  E'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E56.1', '  K'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E56.8', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E56.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E58', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E59', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E60', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E61', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E61.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E61.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E61.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E61.3', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E61.4', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E61.5', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E61.6', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E61.7', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E61.8', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E61.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E63', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E63.0', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E63.1', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E63.8', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E63.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E64', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E64.0', ' - '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E64.1', '   A'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E64.2', '   C'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E64.3', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E64.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E64.9', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E65', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E66', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E66.0', ',     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E66.1', ',    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E66.2', '  ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E66.8', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E66.9', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E67', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E67.0', ' A'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E67.1', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E67.2', '   B6'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E67.3', ' D'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E67.8', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E68', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E70', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E70.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E70.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E70.2', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E70.3', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E70.8', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E70.9', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E71', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E71.0', ' " "'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E71.1', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E71.2', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E71.3', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E72', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E72.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E72.1', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E72.2', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E72.3', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E72.4', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E72.5', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E72.8', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E72.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E73', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E73.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E73.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E73.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E73.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E74', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E74.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E74.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E74.2', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E74.3', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E74.4', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E74.8', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E74.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E75', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E75.0', '-GM2'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E75.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E75.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E75.3', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E75.4', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E75.5', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E75.6', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E76', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E76.0', ',  I'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E76.1', ',  II'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E76.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E76.3', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E76.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E76.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E77', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E77.0', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E77.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E77.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E77.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E78', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E78.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E78.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E78.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E78.3', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E78.4', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E78.5', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E78.6', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E78.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E78.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E79', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E79.0', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E79.1', ' -'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E79.8', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E79.9', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E80', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E80.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E80.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E80.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E80.3', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E80.4', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E80.5', ' -'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E80.6', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E80.7', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E83', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E83.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E83.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E83.2', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E83.3', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E83.4', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E83.5', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E83.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E83.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E84', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E84.0', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E84.1', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E84.8', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E84.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E85', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E85.0', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E85.1', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E85.2', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E85.3', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E85.4', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E85.8', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E85.9', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E86', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E87', '  -  - '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E87.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E87.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E87.2', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E87.3', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E87.4', '  - '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E87.5', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E87.6', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E87.7', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E87.8', '  - ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E88', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E88.0', '   ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E88.1', ',     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E88.2', ',     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E88.3', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E88.8', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E88.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E89', '   ,    ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E89.0', ',    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E89.1', ',    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E89.2', ',    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E89.3', ',    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E89.4', '  ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E89.5', ' ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E89.6', '   ( ),    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E89.8', '    ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E89.9', '   ,    , '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('E90*', '       ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F00*', '    (G30.-+)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F00.0*', '       (G30.0+)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F00.1*', '       (G30.1+)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F00.2*', '        (G30.8+)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F00.9*', '     (G30.9+)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F01', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F01.0', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F01.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F01.2', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F01.3', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F01.8', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F01.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F02*', '   ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F02.0*', '    (G31.0+)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F02.1*', '   - (A81.0+)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F02.2*', '    (G10+)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F02.3*', '    (G20+)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F02.4*', '  ,     [] (B22.0+)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F02.8*', '    ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F03', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F04', '  ,       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F05', ',       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F05.0', '    ,  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F05.1', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F05.8', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F05.9', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F06', '  ,         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F06.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F06.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F06.2', '  [] '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F06.3', '   []'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F06.4', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F06.5', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F06.6', '   [] '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F06.7', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F06.8', '   ,         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F06.9', ' ,         , '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F07', '   ,  ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F07.0', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F07.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F07.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F07.8', '     ,  ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F07.9', '    ,  ,     , '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F09', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F10', '   ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F10.0', '   ,   .  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F10.00', '   ,   .  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F10.1', '   ,   .  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F10.10', '   ,   .  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F10.2', '   ,   .  ( , ,)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F10.221', '   ,   .  ( , ,)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F10.222', '   ,   .  ( , ,)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F10.233', '   ,   .  ( , ,)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F10.241', '   ,   .  ( , ,)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F10.242', '   ,   .  ( , ,)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F10.243', '   ,   .  ( , ,)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F10.3', '   ,   .  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F10.4', '   ,   .    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F10.40', '   ,   .    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F10.5', '   ,   .  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F10.51', '   ,   .  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F10.52', '   ,   .  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F10.53', '   ,   .  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F10.6', '   ,   .  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F10.7', '   ,   .     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F10.8', '    ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F10.9', '    ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F11.', '-    ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F11.0', '   ,   .  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F11.00', '   ,   .  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F11.1', '   ,   .  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F11.2', '   ,   .  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F11.20', '   ,   .  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F11.21', '   ,   .  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F11.24', '   ,   .  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F11.3', '   ,   .  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F11.4', '   ,   .    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F11.42', '   ,   .    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F11.5', '   ,   .  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F11.6', '   ,   .  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F11.7', '   ,   .     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F11.8', '    ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F11.9', '    ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F12', '   ,   '); @
COMMIT WORK; @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F12.0', '   ,   .  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F12.00', '   ,   .  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F12.1', '   ,   .  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F12.2', '   ,   .  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F12.20', '   ,   .  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F12.24', '   ,   .  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F12.3', '   ,   .  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F12.4', '   ,   .    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F12.5', '   ,   .  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F12.6', '   ,   .  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F12.7', '   ,   .     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F12.8', '    ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F12.9', '    ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F13', '   ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F13.0', '   ,      .  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F13.00', '   ,      .  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F13.1', '   ,      .  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F13.2', '   ,      .  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F13.21', '   ,      .  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F13.223', '   ,      .  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F13.24', '   ,      .  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F13.3', '   ,      .  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F13.4', '   ,      .    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F13.5', '   ,      .  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F13.6', '   ,      .  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F13.7', '   ,      .     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F13.8', '    ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F13.9', '    ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F14', '   ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F14.0', '   ,   .  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F14.00', '   ,   .  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F14.1', '   ,   .  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F14.2', '   ,   .  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F14.20', '   ,   .  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F14.24', '   ,   .  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F14.3', '   ,   .  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F14.4', '   ,   .    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F14.5', '   ,   .  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F14.6', '   ,   .  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F14.7', '   ,   .     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F14.8', '    ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F14.9', '    ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F15', '   ,     ( )'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F15.0', '   ,    .  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F15.00', '   ,    .  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F15.1', '   ,    .  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F15.2', '   ,    .  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F15.20', '   ,    .  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F15.24', '   ,    .  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F15.3', '   ,    .  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F15.4', '   ,    .    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F15.5', '   ,    .  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F15.6', '   ,    .  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F15.7', '   ,    .     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F15.8', '    ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F15.9', '    ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F16', '   ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F16.0', '   ,   .  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F16.00', '   ,   .  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F16.1', '   ,   .  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F16.2', '   ,   .  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F16.3', '   ,   .  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F16.4', '   ,   .    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F16.5', '   ,   .  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F16.6', '   ,   .  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F16.7', '   ,   .     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F16.8', '    ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F16.9', '    ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F17', '   ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F17.0', '   ,   .  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F17.1', '   ,   .  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F17.2', '   ,   .  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F17.3', '   ,   .  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F17.4', '   ,   .    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F17.5', '   ,   .  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F17.6', '   ,   .  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F17.7', '   ,   .     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F17.8', '    ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F17.9', '    ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F18', '   ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F18.0', '   ,    .  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F18.00', '   ,    .  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F18.1', '   ,    .  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F18.2', '   ,    .  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F18.20', '   ,    .  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F18.24', '   ,    .  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F18.3', '   ,    .  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F18.4', '   ,    .    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F18.5', '   ,    .  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F18.6', '   ,    .  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F18.7', '   ,    .     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F18.8', '    ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F18.9', '    ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F19', '   ,           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F19.0', '   ,           .  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F19.00', '   ,           .  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F19.1', '   ,           .  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F19.2', '   ,           .  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F19.3', '   ,           .  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F19.4', '   ,           .    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F19.5', '   ,           .  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F19.6', '   ,           .  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F19.7', '   ,           .     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F19.8', '    ,           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F19.9', '    ,            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F20', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F20.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F20.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F20.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F20.3', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F20.4', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F20.5', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F20.6', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F20.8', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F20.9', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F21', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F22', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F22.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F22.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F22.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F23', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F23.0', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F23.1', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F23.2', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F23.3', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F23.8', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F23.9', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F24', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F25', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F25.0', ' ,  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F25.1', ' ,  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F25.2', ' ,  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F25.8', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F25.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F28', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F29', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F30', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F30.0', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F30.1', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F30.2', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F30.8', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F30.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F31', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F31.0', '  ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F31.1', '  ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F31.2', '  ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F31.3', '  ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F31.4', '  ,       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F31.5', '  ,       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F31.6', '  ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F31.7', '  ,  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F31.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F31.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F32', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F32.0', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F32.1', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F32.2', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F32.3', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F32.8', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F32.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F33', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F33.0', '  ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F33.1', '  ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F33.2', '  ,       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F33.3', '  ,       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F33.4', '  ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F33.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F33.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F34', '   [ ]'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F34.0', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F34.1', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F34.8', '    []'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F34.9', '   [] '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F38', '   []'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F38.0', '    []'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F38.1', '    []'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F38.8', '    []'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F39', '  [] '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F40', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F40.0', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F40.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F40.2', ' ()  :   () (F45.2)  () (F45.2)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F40.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F40.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F41', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F41.0', '  [  ]'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F41.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F41.2', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F41.3', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F41.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F41.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F42', '- '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F42.0', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F42.1', '   [ ]'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F42.2', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F42.8', ' - '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F42.9', '-  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F43', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F43.0', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F43.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F43.2', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F43.8', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F43.9', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F44', ' [] '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F44.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F44.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F44.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F44.3', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F44.4', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F44.5', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F44.6', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F44.7', '  [] '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F44.8', '  [] '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F44.9', ' []  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F45', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F45.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F45.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F45.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F45.3', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F45.4', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F45.8', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F45.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F48', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F48.0', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F48.1', ' -'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F48.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F48.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F50', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F50.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F50.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F50.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F50.3', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F50.4', ',     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F50.5', ',     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F50.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F50.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F51', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F51.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F51.1', ' []  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F51.2', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F51.3', ' []'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F51.4', '    [ ]'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F51.5', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F51.8', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F51.9', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F52', ' ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F52.0', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F52.1', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F52.2', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F52.3', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F52.4', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F52.5', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F52.6', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F52.7', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F52.8', '  ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F52.9', ' ,      , '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F53', '    ,    ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F53.0', '     ,    ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F53.1', '     ,    ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F53.8', '     ,    ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F53.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F54', '   ,     ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F55', ' ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F59', ' ,       , '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F60', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F60.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F60.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F60.2', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F60.3', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F60.4', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F60.5', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F60.6', ' ()  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F60.7', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F60.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F60.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F61', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F62', '  ,        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F62.0', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F62.1', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F62.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F62.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F63', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F63.0', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F63.1', '    []'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F63.2', '    []'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F63.3', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F63.8', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F63.9', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F64', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F64.0', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F64.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F64.2', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F64.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F64.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F65', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F65.0', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F65.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F65.2', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F65.3', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F65.4', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F65.5', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F65.6', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F65.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F65.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F66', '   ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F66.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F66.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F66.2', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F66.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F66.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F68', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F68.0', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F68.1', '           [ ]'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F68.8', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F69', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F70', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F70.0', '            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F70.1', '       ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F70.8', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F70.9', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F71', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F71.0', '           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F71.1', '      ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F71.8', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F71.9', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F72', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F72.0', '           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F72.1', '      ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F72.8', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F72.9', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F73', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F73.0', '           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F73.1', '      ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F73.8', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F73.9', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F78', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F78.0', '            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F78.1', '       ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F78.8', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F78.9', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F79', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F79.0', '           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F79.1', '      ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F79.8', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F79.9', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F80', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F80.0', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F80.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F80.2', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F80.3', '    [-]'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F80.8', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F80.9', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F81', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F81.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F81.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F81.2', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F81.3', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F81.8', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F81.9', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F82', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F83', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F84', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F84.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F84.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F84.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F84.3', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F84.4', ' ,       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F84.5', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F84.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F84.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F88', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F89', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F90', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F90.0', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F90.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F90.8', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F90.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F91', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F91.0', ' ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F91.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F91.2', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F91.3', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F91.8', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F91.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F92', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F92.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F92.8', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F92.9', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F93', ' ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F93.0', '   ,  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F93.1', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F93.2', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F93.3', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F93.8', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F93.9', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F94', '  ,        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F94.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F94.1', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F94.2', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F94.8', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F94.9', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F95', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F95.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F95.1', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F95.2', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F95.8', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F95.9', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F98', '     ,       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F98.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F98.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F98.2', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F98.3', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F98.4', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F98.5', ' []'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F98.6', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F98.8', '        ,       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F98.9', '      ,       , '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('F99', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G00', ' ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G00.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G00.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G00.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G00.3', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G00.8', ',   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G00.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G01*', '   ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G02*', '      ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G02.0*', '   ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G02.1*', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G02.8*', '       ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G03', ',     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G03.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G03.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G03.2', '   []'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G03.8', ',    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G03.9', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G04', ',   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G04.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G04.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G04.2', '   ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G04.8', ' ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G04.9', ',    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G05*', ',     ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G05.0*', ',      ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G05.1*', ',      ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G05.2*', ',         ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G05.8*', ',      ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G06', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G06.0', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G06.1', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G06.2', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G07*', '       ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G08', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G09', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G10', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G11', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G11.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G11.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G11.2', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G11.3', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G11.4', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G11.8', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G11.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G12', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G12.0', '   , I  [-]'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G12.1', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G12.2', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G12.8', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G12.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G13*', ' ,       ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G13.0*', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G13.1*', '  ,      ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G13.2*', '   ,       (E00.1+, E03.-+)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G13.8*', ' ,      ,   ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G14', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G20', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G21', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G21.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G21.1', '   ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G21.2', ' ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G21.3', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G21.4', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G21.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G21.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G22*', '  ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G23', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G23.0', ' -'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G23.1', '   [--]'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G23.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G23.8', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G23.9', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G24', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G24.0', ',   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G24.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G24.2', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G24.3', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G24.4', ' - '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G24.5', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G24.8', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G24.9', ' '); @
COMMIT WORK; @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G25', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G25.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G25.1', ',   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G25.2', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G25.3', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G25.4', ',   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G25.5', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G25.6', ',   ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G25.8', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G25.9', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G26*', '     ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G30', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G30.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G30.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G30.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G30.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G31', '    ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G31.0', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G31.1', '   ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G31.2', '  ,  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G31.8', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G31.9', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G32*', '      ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G32.0*', '      ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G32.8*', '       ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G35', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G35+', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G36', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G36.0', ' [ ]'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G36.1', '     [ ]'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G36.8', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G36.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G37', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G37.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G37.1', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G37.2', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G37.3', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G37.4', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G37.5', '  []'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G37.8', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G37.9', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G40', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G40.0', ' () ()           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G40.1', ' () ()         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G40.2', ' () ()          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G40.3', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G40.4', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G40.5', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G40.6', ' grand mal  (   [petit mal]   )'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G40.7', '  [petit mal]    grand mal'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G40.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G40.9', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G41', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G41.0', '  grand mal ( )'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G41.1', '  petit mal ( )'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G41.2', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G41.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G41.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G43', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G43.0', '   [ ]'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G43.1', '   [ ]'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G43.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G43.3', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G43.8', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G43.9', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G44', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G44.0', ' ""  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G44.1', '  ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G44.2', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G44.3', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G44.4', ' ,    ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G44.8', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G45', '     []   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G45.0', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G45.1', '   ()'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G45.2', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G45.3', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G45.4', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G45.8', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G45.9', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G46*', '      (I60-I67+)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G46.0*', '    (I66.0+)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G46.1*', '    (I66.1+)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G46.2*', '    (I66.2+)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G46.3*', '      (I60-I67+)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G46.4*', '   (I60-I67+)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G46.5*', '    (I60-I67+)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G46.6*', '    (I60-I67+)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G46.7*', '   (I60-I67+)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G46.8*', '        (I60-I67+)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G47', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G47.0', '     []'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G47.1', '     []'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G47.2', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G47.3', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G47.4', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G47.8', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G47.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G50', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G50.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G50.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G50.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G50.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G51', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G51.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G51.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G51.2', ' -'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G51.3', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G51.4', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G51.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G51.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G52', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G52.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G52.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G52.2', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G52.3', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G52.7', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G52.8', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G52.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G53*', '    ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G53.0*', '    (B02.2+)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G53.1*', '        ,     (A00-B99+)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G53.2*', '      (D86.8+)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G53.3*', '      (C00-D48+)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G53.8*', '      ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G54', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G54.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G54.1', ' - '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G54.2', '  ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G54.3', '  ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G54.4', ' - ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G54.5', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G54.6', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G54.7', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G54.8', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G54.9', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G55*', '      ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G55.0*', '       (C00-D48+)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G55.1*', '         (M50-M51+)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G55.2*', '       (M47.-+)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G55.3*', '        (M45-M46+, M48.-+, M53-M54+)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G55.8*', '       ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G56', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G56.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G56.1', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G56.2', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G56.3', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G56.4', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G56.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G56.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G57', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G57.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G57.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G57.2', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G57.3', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G57.4', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G57.5', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G57.6', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G57.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G57.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G58', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G58.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G58.7', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G58.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G58.9', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G59*', '  ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G59.0*', '  (E10-E14+     .4)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G59.8*', '   ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G60', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G60.0', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G60.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G60.2', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G60.3', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G60.8', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G60.9', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G61', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G61.0', ' -'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G61.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G61.8', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G61.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G62', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G62.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G62.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G62.2', ',    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G62.8', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G62.9', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G63*', '  ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G63.0*', '     ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G63.1*', '   (C00-D48+)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G63.2*', '  (E10-E14+     .4)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G63.3*', '         (E00-E07+, E15-E16+, E20-E34+, E70-E89+)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G63.4*', '    (E40-E64+)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G63.5*', '      (M30-M35+)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G63.6*', '   -  (M00-M25+, M40-M96+)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G63.8*', '   ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G64', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G70', 'Myasthenia gravis    - '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G70.0', 'Myasthenia gravis [ ]'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G70.1', '  - '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G70.2', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G70.8', '  - '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G70.9', ' -  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G71', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G71.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G71.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G71.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G71.3', ' ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G71.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G71.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G72', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G72.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G72.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G72.2', ',    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G72.3', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G72.4', ' ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G72.8', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G72.9', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G73*', ' -     ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G73.0*', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G73.1*', ' - (C80+)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G73.2*', '      (C00-D48+)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G73.3*', '    ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G73.4*', '     ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G73.5*', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G73.6*', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G73.7*', '   ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G80', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G80.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G80.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G80.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G80.3', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G80.4', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G80.8', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G80.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G81', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G81.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G81.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G81.9', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G82', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G82.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G82.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G82.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G82.3', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G82.4', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G82.5', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G83', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G83.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G83.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G83.2', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G83.3', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G83.4', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G83.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G83.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G90', '  []  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G90.0', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G90.1', '  [-]'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G90.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G90.3', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G90.4', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G90.8', '   []  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G90.9', '  []   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G91', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G91.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G91.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G91.2', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G91.3', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G91.8', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G91.9', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G92', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G93', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G93.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G93.1', '   ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G93.2', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G93.3', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G93.4', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G93.5', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G93.6', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G93.7', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G93.8', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G93.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G94*', '     ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G94.0*', '     ,     (A00-B99+)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G94.1*', '    (C00-D48+)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G94.2*', '   ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G94.8*', '      ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G95', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G95.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G95.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G95.2', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G95.8', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G95.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G96', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G96.0', '   []'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G96.1', '   ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G96.8', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G96.9', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G97', '     ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G97.0', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G97.1', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G97.2', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G97.8', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G97.9', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G98', '   ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G99*', '     ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G99.0*', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G99.1*', '   []     ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G99.2*', '  ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('G99.8*', '      ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H00', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H00.0', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H00.1', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H01', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H01.0', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H01.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H01.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H01.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H02', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H02.0', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H02.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H02.2', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H02.3', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H02.4', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H02.5', ' ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H02.6', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H02.7', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H02.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H02.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H03*', '   ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H03.0*', '    ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H03.1*', '     ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H03.8*', '    ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H04', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H04.0', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H04.1', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H04.2', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H04.3', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H04.4', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H04.5', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H04.6', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H04.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H04.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H05', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H05.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H05.1', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H05.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H05.3', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H05.4', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H05.5', ',    ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H05.8', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H05.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H06*', '      ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H06.0*', '    ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H06.1*', '    ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H06.2*', '      (E05.-+)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H06.3*', '  ,  ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H10', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H10.0', '- '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H10.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H10.2', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H10.3', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H10.4', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H10.5', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H10.8', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H10.9', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H11', '   :  (H16.2)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H11.0', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H11.1', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H11.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H11.3', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H11.4', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H11.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H11.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H13*', '   ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H13.0*', '   (B74.-+)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H13.1*', '   ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H13.2*', '  ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H13.3*', '  (L12.-+)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H13.8*', '    ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H15', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H15.0', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H15.1', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H15.8', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H15.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H16', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H16.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H16.1', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H16.2', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H16.3', ' ()   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H16.4', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H16.8', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H16.9', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H17', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H17.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H17.1', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H17.8', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H17.9', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H18', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H18.0', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H18.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H18.2', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H18.3', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H18.4', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H18.5', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H18.6', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H18.7', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H18.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H18.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H19*', '     ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H19.0*', '    ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H19.1*', ',    ,   (B00.5+)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H19.2*', '        ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H19.3*', '    ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H19.8*', '      ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H20', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H20.0', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H20.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H20.2', ',  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H20.8', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H20.9', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H21', '       :   (H44.1)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H21.0', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H21.1', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H21.2', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H21.3', '  ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H21.4', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H21.5', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H21.8', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H21.9', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H22*', '       ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H22.0*', '   ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H22.1*', '  ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H22.8*', '        ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H25', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H25.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H25.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H25.2', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H25.8', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H25.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H26', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H26.0', ',    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H26.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H26.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H26.3', ',   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H26.4', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H26.8', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H26.9', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H27', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H27.0', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H27.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H27.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H27.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H28*', '      ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H28.0*', '  (E10-E14+     .3)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H28.1*', '     ,      ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H28.2*', '   ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H28.8*', '    ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H30', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H30.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H30.1', '   :   (H35.0)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H30.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H30.8', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H30.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H31', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H31.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H31.1', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H31.2', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H31.3', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H31.4', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H31.8', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H31.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H32*', '   ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H32.0*', '      ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H32.8*', '    ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H33', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H33.0', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H33.1', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H33.2', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H33.3', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H33.4', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H33.5', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H34', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H34.0', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H34.1', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H34.2', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H34.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H34.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H35', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H35.0', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H35.1', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H35.2', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H35.3', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H35.4', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H35.5', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H35.6', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H35.7', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H35.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H35.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H36*', '   ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H36.0*', '  (E10-E14+     .3)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H36.8*', '    ,    '); @
COMMIT WORK; @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H40', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H40.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H40.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H40.2', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H40.3', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H40.4', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H40.5', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H40.6', ' ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H40.8', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H40.9', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H42*', '  ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H42.0*', '    ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H42.8*', '   ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H43', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H43.0', '   ()'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H43.1', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H43.2', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H43.3', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H43.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H43.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H44', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H44.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H44.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H44.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H44.3', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H44.4', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H44.5', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H44.6', ' (   )   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H44.7', ' (   )   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H44.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H44.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H45*', '       ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H45.0*', '     ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H45.1*', '  ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H45.8*', '        ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H46', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H47', '   [2-]    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H47.0', '  ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H47.1', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H47.2', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H47.3', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H47.4', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H47.5', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H47.6', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H47.7', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H48*', '  [2-]      ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H48.0*', '    ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H48.1*', '   ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H48.8*', '        ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H49', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H49.0', ' 3- [] '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H49.1', ' 4- [] '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H49.2', ' 6- [] '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H49.3', ' () '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H49.4', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H49.8', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H49.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H50', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H50.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H50.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H50.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H50.3', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H50.4', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H50.5', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H50.6', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H50.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H50.9', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H51', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H51.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H51.1', '  [   ]'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H51.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H51.8', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H51.9', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H52', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H52.0', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H52.1', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H52.2', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H52.3', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H52.4', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H52.5', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H52.6', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H52.7', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H53', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H53.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H53.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H53.2', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H53.3', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H53.4', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H53.5', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H53.6', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H53.8', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H53.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H54', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H54.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H54.1', '  ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H54.2', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H54.3', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H54.4', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H54.5', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H54.6', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H54.7', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H54.9', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H55', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H57', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H57.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H57.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H57.8', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H57.9', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H58*', '        ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H58.0*', '    ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H58.1*', '   ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H58.8*', '        ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H59', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H59.0', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H59.8', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H59.9', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H60', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H60.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H60.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H60.2', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H60.3', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H60.4', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H60.5', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H60.8', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H60.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H61', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H61.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H61.1', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H61.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H61.3', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H61.8', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H61.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H62*', '    ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H62.0*', '    ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H62.1*', '    ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H62.2*', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H62.3*', '       ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H62.4*', '    ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H62.8*', '     ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H65', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H65.0', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H65.1', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H65.2', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H65.3', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H65.4', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H65.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H66', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H66.0', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H66.1', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H66.2', ' -   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H66.3', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H66.4', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H66.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H67*', '   ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H67.0*', '    ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H67.1*', '    ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H67.8*', '    ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H68', '    [] '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H68.0', '  [] '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H68.1', '  [] '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H69', '   [] '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H69.0', '  [] '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H69.8', '    [] '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H69.9', '  []  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H70', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H70.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H70.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H70.2', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H70.8', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H70.9', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H71', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H72', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H72.0', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H72.1', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H72.2', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H72.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H72.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H73', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H73.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H73.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H73.8', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H73.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H74', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H74.0', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H74.1', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H74.2', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H74.3', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H74.4', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H74.8', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H74.9', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H75*', '        ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H75.0*', '     ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H75.8*', '         ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H80', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H80.0', ',   , '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H80.1', ',   , '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H80.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H80.8', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H80.9', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H81', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H81.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H81.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H81.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H81.3', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H81.4', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H81.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H81.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H82*', '   ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H83', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H83.0', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H83.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H83.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H83.3', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H83.8', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H83.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H90', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H90.0', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H90.1', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H90.2', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H90.3', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H90.4', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H90.5', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H90.6', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H90.7', '     ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H90.8', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H91', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H91.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H91.1', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H91.2', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H91.3', ' ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H91.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H91.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H92', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H92.0', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H92.1', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H92.2', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H93', '  ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H93.0', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H93.1', '   ()'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H93.2', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H93.3', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H93.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H93.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H94*', '    ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H94.0*', '      ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H94.8*', '     ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H95', '       ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H95.0', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H95.1', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H95.8', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('H95.9', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I00', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I01', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I01.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I01.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I01.2', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I01.8', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I01.9', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I02', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I02.0', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I02.9', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I05', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I05.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I05.1', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I05.2', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I05.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I05.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I06', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I06.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I06.1', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I06.2', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I06.8', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I06.9', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I07', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I07.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I07.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I07.2', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I07.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I07.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I08', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I08.0', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I08.1', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I08.2', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I08.3', '  ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I08.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I08.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I09', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I09.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I09.1', '  ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I09.2', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I09.8', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I09.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I10', ' [] '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I11', '   [     ]'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I11.0', ' []       ()  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I11.9', ' []       ()  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I12', ' []     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I12.0', ' []        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I12.9', ' []        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I13', ' []       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I13.0', ' []         ()  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I13.1', ' []        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I13.2', ' []         ()     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I13.9', ' []        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I15', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I15.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I15.1', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I15.2', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I15.8', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I15.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I20', ' [ ]'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I20.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I20.1', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I20.8', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I20.9', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I21', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I21.0', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I21.1', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I21.2', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I21.3', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I21.4', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I21.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I22', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I22.0', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I22.1', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I22.8', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I22.9', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I23', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I23.0', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I23.1', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I23.2', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I23.3', '           :   (I23.0)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I23.4', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I23.5', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I23.6', ' ,           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I23.8', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I24', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I24.0', ' ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I24.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I24.8', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I24.9', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I25', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I25.0', ' - ,  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I25.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I25.2', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I25.3', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I25.4', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I25.5', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I25.6', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I25.8', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I25.9', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I26', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I26.0', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I26.9', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I27', '  - '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I27.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I27.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I27.2', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I27.8', '   - '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I27.9', '-  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I28', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I28.0', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I28.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I28.8', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I28.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I30', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I30.0', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I30.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I30.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I30.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I31', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I31.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I31.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I31.2', ',     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I31.3', '  ()'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I31.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I31.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I32*', '  ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I32.0*', '   ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I32.1*', '      ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I32.8*', '   ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I33', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I33.0', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I33.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I34', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I34.0', ' () '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I34.1', ' []  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I34.2', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I34.8', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I34.9', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I35', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I35.0', ' () '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I35.1', ' () '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I35.2', ' ()   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I35.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I35.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I36', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I36.0', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I36.1', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I36.2', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I36.8', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I36.9', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I37', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I37.0', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I37.1', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I37.2', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I37.8', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I37.9', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I38', ',   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I39*', '      ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I39.0*', '    ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I39.1*', '    ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I39.2*', '    ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I39.3*', '     ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I39.4*', '    ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I39.8*', ',   ,  ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I40', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I40.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I40.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I40.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I40.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I41*', '  ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I41.0*', '   ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I41.1*', '   ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I41.2*', '      ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I41.8*', '   ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I42', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I42.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I42.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I42.2', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I42.3', ' () '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I42.4', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I42.5', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I42.6', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I42.7', ',        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I42.8', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I42.9', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I43*', '  ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I43.0*', '     ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I43.1*', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I43.2*', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I43.8*', '   ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I44', '- []       []'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I44.0', '-   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I44.1', '-   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I44.2', '-  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I44.3', '   - '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I44.4', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I44.5', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I44.6', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I44.7', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I45', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I45.0', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I45.1', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I45.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I45.3', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I45.4', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I45.5', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I45.6', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I45.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I45.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I46', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I46.0', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I46.1', '  ,  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I46.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I47', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I47.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I47.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I47.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I47.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I48', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I48.0', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I48.1', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I48.2', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I48.3', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I48.4', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I48.9', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I49', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I49.0', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I49.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I49.2', ' ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I49.3', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I49.4', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I49.5', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I49.8', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I49.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I50', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I50.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I50.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I50.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I51', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I51.0', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I51.1', '  ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I51.2', '  ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I51.3', ' ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I51.4', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I51.5', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I51.6', '-   :  - ,   (I25.0)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I51.7', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I51.8', '    '); @
COMMIT WORK; @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I51.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I52*', '    ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I52.0*', '     ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I52.1*', '        ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I52.8*', '     ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I60', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I60.0', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I60.1', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I60.2', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I60.3', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I60.4', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I60.5', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I60.6', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I60.7', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I60.8', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I60.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I61', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I61.0', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I61.1', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I61.2', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I61.3', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I61.4', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I61.5', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I61.6', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I61.8', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I61.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I62', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I62.0', '  () ()'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I62.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I62.9', '  () '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I63', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I63.0', ' ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I63.1', ' ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I63.2', ' ,       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I63.3', ' ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I63.4', ' ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I63.5', ' ,       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I63.6', ' ,    , '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I63.8', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I63.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I64', ',      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I65', '    ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I65.0', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I65.1', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I65.2', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I65.3', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I65.8', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I65.9', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I66', '    ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I66.0', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I66.1', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I66.2', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I66.3', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I66.4', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I66.8', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I66.9', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I67', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I67.0', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I67.1', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I67.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I67.3', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I67.4', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I67.5', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I67.6', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I67.7', ' ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I67.8', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I67.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I68*', '    ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I68.0*', '   (E85.-+)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I68.1*', '      ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I68.2*', '    ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I68.8*', '     ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I69', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I69.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I69.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I69.2', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I69.3', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I69.4', ' ,       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I69.8', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I70', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I70.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I70.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I70.2', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I70.8', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I70.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I71', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I71.0', '  ( )'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I71.1', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I71.2', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I71.3', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I71.4', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I71.5', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I71.6', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I71.8', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I71.9', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I72', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I72.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I72.1', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I72.2', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I72.3', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I72.4', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I72.5', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I72.6', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I72.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I72.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I73', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I73.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I73.1', '  [ ]'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I73.8', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I73.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I74', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I74.0', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I74.1', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I74.2', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I74.3', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I74.4', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I74.5', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I74.8', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I74.9', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I77', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I77.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I77.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I77.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I77.3', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I77.4', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I77.5', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I77.6', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I77.8', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I77.9', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I78', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I78.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I78.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I78.8', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I78.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I79*', ' ,     ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I79.0*', '   ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I79.1*', '  ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I79.2*', '   ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I79.8*', '  ,     ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I80', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I80.0', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I80.1', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I80.2', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I80.3', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I80.8', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I80.9', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I81', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I82', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I82.0', ' -'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I82.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I82.2', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I82.3', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I82.8', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I82.9', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I83', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I83.0', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I83.1', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I83.2', '     c   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I83.9', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I85', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I85.0', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I85.9', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I86', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I86.0', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I86.1', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I86.2', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I86.3', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I86.4', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I86.8', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I87', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I87.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I87.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I87.2', '  () ()'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I87.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I87.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I88', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I88.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I88.1', ' ,  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I88.8', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I88.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I89', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I89.0', ',     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I89.1', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I89.8', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I89.9', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I95', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I95.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I95.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I95.2', ',   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I95.8', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I95.9', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I97', '     ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I97.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I97.1', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I97.2', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I97.8', '      ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I97.9', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I98*', '     , -'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I98.0*', ' - '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I98.1*', ' -       ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I98.2*', '     ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I98.8*', '      ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('I99', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J00', '  []'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J01', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J01.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J01.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J01.2', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J01.3', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J01.4', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J01.8', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J01.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J02', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J02.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J02.8', ' ,    -'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J02.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J03', '  []'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J03.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J03.8', ' ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J03.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J04', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J04.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J04.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J04.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J05', '   []  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J05.0', '   []'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J05.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J06', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J06.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J06.8', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J06.9', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J09', ',     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J10', ',    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J10.0', '  ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J10.1', '    ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J10.8', '   ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J11', ',   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J11.0', '  ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J11.1', '    ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J11.8', '   ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J12', ' ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J12.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J12.1', ',    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J12.2', ',   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J12.3', ',   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J12.8', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J12.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J13', ',  Streptococcus pneumoniae'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J14', ',  Haemophilus influenzae [ -]'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J15', ' ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J15.0', ',  Klebsiella pneumoniae'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J15.1', ',  Pseudomonas ( )'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J15.2', ',  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J15.3', ',    B'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J15.4', ',   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J15.5', ',  Escherichia coli'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J15.6', ',     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J15.7', ',  Mycoplasma pneumoniae'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J15.8', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J15.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J16', ',    ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J16.0', ',  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J16.8', ',     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J17*', '  ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J17.0*', '   ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J17.1*', '   ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J17.2*', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J17.3*', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J17.8*', '   ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J18', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J18.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J18.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J18.2', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J18.8', ' ,  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J18.9', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J20', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J20.0', ' ,  Mycoplasma pneumoniae'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J20.1', ' ,  Haemophilus influenzae [ -]'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J20.2', ' ,  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J20.3', ' ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J20.4', ' ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J20.5', ' ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J20.6', ' ,  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J20.7', ' ,  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J20.8', ' ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J20.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J21', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J21.0', ' ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J21.1', ' ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J21.8', ' ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J21.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J22', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J30', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J30.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J30.1', ' ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J30.2', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J30.3', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J30.4', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J31', ' ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J31.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J31.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J31.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J32', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J32.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J32.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J32.2', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J32.3', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J32.4', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J32.8', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J32.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J33', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J33.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J33.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J33.8', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J33.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J34', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J34.0', ',    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J34.1', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J34.2', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J34.3', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J34.8', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J35', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J35.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J35.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J35.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J35.3', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J35.8', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J35.9', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J36', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J37', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J37.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J37.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J38', '    ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J38.0', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J38.1', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J38.2', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J38.3', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J38.4', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J38.5', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J38.6', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J38.7', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J39', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J39.0', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J39.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J39.2', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J39.3', '     ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J39.8', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J39.9', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J40', ',      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J41', '  -  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J41.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J41.1', '-  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J41.8', ',   -  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J42', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J43', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J43.0', ' -'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J43.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J43.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J43.8', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J43.9', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J44', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J44.0', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J44.1', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J44.8', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J44.9', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J45', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J45.0', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J45.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J45.8', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J45.9', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J46', '  [status asthmaticus]'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J47', '  []'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J60', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J61', ',      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J62', ',  ,  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J62.0', ',   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J62.8', ',   ,  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J63', ',    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J63.0', ' ()'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J63.1', '  ()'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J63.2', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J63.3', '  ()'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J63.4', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J63.5', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J63.8', ',     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J64', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J65', ',   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J66', '  ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J66.0', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J66.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J66.2', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J66.8', '  ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J67', ' ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J67.0', '  [ ]'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J67.1', ' (   )'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J67.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J67.3', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J67.4', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J67.5', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J67.6', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J67.7', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J67.8', ' ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J67.9', ' ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J68', ' ,    , ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J68.0', '  ,   , ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J68.1', '  ,   , ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J68.2', '   ,   , ,   ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J68.3', '     ,   , ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J68.4', '  ,   , ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J68.8', '  ,   , ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J68.9', '  ,   , ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J69', ',     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J69.0', ',     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J69.1', ',     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J69.8', ',      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J70', ' ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J70.0', '  ,  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J70.1', '    ,  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J70.2', '   ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J70.3', '   ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J70.4', '  ,   , '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J70.8', ' ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J70.9', ' ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J80', '   []  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J81', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J82', ' ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J84', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J84.0', '  - '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J84.1', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J84.8', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J84.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J85', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J85.0', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J85.1', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J85.2', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J85.3', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J86', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J86.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J86.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J90', ' ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J91*', '   ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J92', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J92.0', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J92.9', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J93', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J93.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J93.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J93.8', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J93.9', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J94', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J94.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J94.1', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J94.2', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J94.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J94.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J95', '    ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J95.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J95.1', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J95.2', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J95.3', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J95.4', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J95.5', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J95.8', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J95.9', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J96', ' ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J96.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J96.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J96.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J98', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J98.0', ' ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J98.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J98.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J98.3', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J98.4', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J98.5', ' ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J98.6', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J98.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J98.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J99*', '   ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J99.0*', '   (M05.1+)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J99.1*', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('J99.8*', '    ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K00', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K00.0', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K00.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K00.2', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K00.3', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K00.4', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K00.5', '   ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K00.6', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K00.7', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K00.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K00.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K01', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K01.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K01.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K02', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K02.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K02.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K02.2', ' '); @
COMMIT WORK; @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K02.3', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K02.4', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K02.5', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K02.8', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K02.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K03', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K03.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K03.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K03.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K03.3', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K03.4', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K03.5', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K03.6', ' []  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K03.7', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K03.8', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K03.9', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K04', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K04.0', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K04.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K04.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K04.3', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K04.4', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K04.5', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K04.6', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K04.7', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K04.8', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K04.9', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K05', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K05.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K05.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K05.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K05.3', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K05.4', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K05.5', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K05.6', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K06', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K06.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K06.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K06.2', '     ,  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K06.8', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K06.9', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K07', '-  [  ]'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K07.0', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K07.1', ' - '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K07.2', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K07.3', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K07.4', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K07.5', '-   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K07.6', ' - '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K07.8', ' - '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K07.9', '-  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K08', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K08.0', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K08.1', '    ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K08.2', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K08.3', '   [ ]'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K08.8', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K08.9', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K09', '  ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K09.0', ',     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K09.1', ' ()   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K09.2', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K09.8', '    ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K09.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K10', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K10.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K10.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K10.2', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K10.3', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K10.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K10.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K11', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K11.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K11.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K11.2', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K11.3', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K11.4', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K11.5', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K11.6', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K11.7', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K11.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K11.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K12', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K12.0', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K12.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K12.2', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K12.3', '    ()'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K13', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K13.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K13.1', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K13.2', '      ,  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K13.3', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K13.4', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K13.5', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K13.6', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K13.7', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K14', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K14.0', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K14.1', '"" '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K14.2', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K14.3', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K14.4', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K14.5', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K14.6', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K14.8', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K14.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K20', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K21', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K21.0', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K21.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K22', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K22.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K22.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K22.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K22.3', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K22.4', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K22.5', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K22.6', '- - '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K22.7', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K22.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K22.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K23*', '   ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K23.0*', '  (A18.8+)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K23.1*', '     (B57.3+)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K23.8*', '    ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K25', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K25.0', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K25.1', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K25.2', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K25.3', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K25.4', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K25.5', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K25.6', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K25.7', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K25.9', '      ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K26', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K26.0', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K26.1', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K26.2', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K26.3', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K26.4', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K26.5', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K26.6', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K26.7', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K26.9', '       ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K27', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K27.0', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K27.1', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K27.2', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K27.3', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K27.4', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K27.5', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K27.6', '           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K27.7', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K27.9', '        ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K28', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K28.0', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K28.1', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K28.2', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K28.3', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K28.4', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K28.5', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K28.6', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K28.7', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K28.9', '      ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K29', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K29.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K29.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K29.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K29.3', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K29.4', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K29.5', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K29.6', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K29.7', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K29.8', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K29.9', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K30', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K31', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K31.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K31.1', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K31.2', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K31.3', ',     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K31.4', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K31.5', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K31.6', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K31.7', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K31.8', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K31.9', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K35', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K35.2', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K35.3', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K35.8', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K36', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K37', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K38', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K38.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K38.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K38.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K38.3', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K38.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K38.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K40', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K40.0', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K40.1', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K40.2', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K40.3', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K40.4', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K40.9', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K41', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K41.0', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K41.1', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K41.2', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K41.3', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K41.4', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K41.9', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K42', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K42.0', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K42.1', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K42.9', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K43', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K43.0', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K43.1', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K43.2', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K43.3', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K43.4', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K43.5', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K43.7', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K43.9', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K44', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K44.0', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K44.1', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K44.9', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K45', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K45.0', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K45.1', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K45.8', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K46', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K46.0', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K46.1', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K46.9', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K50', '  [ ]'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K50.0', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K50.1', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K50.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K50.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K51', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K51.0', ' () '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K51.1', ' () '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K51.2', ' () '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K51.3', ' () '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K51.4', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K51.5', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K51.8', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K51.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K52', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K52.0', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K52.1', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K52.2', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K52.3', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K52.8', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K52.9', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K55', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K55.0', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K55.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K55.2', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K55.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K55.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K56', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K56.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K56.1', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K56.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K56.3', ',   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K56.4', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K56.5', '  []  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K56.6', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K56.7', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K57', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K57.0', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K57.1', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K57.2', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K57.3', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K57.4', '   ,       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K57.5', '   ,       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K57.8', '  ,  ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K57.9', '  ,  ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K58', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K58.0', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K58.9', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K59', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K59.0', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K59.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K59.2', '  ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K59.3', ',     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K59.4', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K59.8', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K59.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K60', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K60.0', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K60.1', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K60.2', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K60.3', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K60.4', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K60.5', '  (      )'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K61', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K61.0', ' [] '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K61.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K61.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K61.3', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K61.4', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K62', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K62.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K62.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K62.2', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K62.3', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K62.4', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K62.5', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K62.6', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K62.7', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K62.8', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K62.9', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K63', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K63.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K63.1', '  ()'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K63.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K63.3', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K63.4', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K63.5', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K63.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K63.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K64', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K64.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K64.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K64.2', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K64.3', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K64.4', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K64.5', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K64.8', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K64.9', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K65', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K65.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K65.8', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K65.9', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K66', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K66.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K66.1', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K66.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K66.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K67*', '    ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K67.0*', '  (A74.8*)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K67.1*', '  (A54.8+)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K67.2*', '  (A52.7+)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K67.3*', '  (A18.3+)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K67.8*', '     ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K70', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K70.0', '    [ ]'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K70.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K70.2', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K70.3', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K70.4', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K70.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K71', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K71.0', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K71.1', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K71.2', '  ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K71.3', '  ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K71.4', '  ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K71.5', '  ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K71.6', '  ,   ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K71.7', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K71.8', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K71.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K72', ' ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K72.0', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K72.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K72.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K73', ' ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K73.0', '  ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K73.1', '  ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K73.2', '  ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K73.8', '  ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K73.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K74', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K74.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K74.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K74.2', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K74.3', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K74.4', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K74.5', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K74.6', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K75', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K75.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K75.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K75.2', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K75.3', ' ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K75.4', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K75.8', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K75.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K76', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K76.0', '  ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K76.1', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K76.2', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K76.3', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K76.4', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K76.5', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K76.6', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K76.7', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K76.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K76.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K77*', '   ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K77.0*', '      ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K77.8*', '    ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K80', '  []'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K80.0', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K80.1', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K80.2', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K80.3', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K80.4', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K80.5', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K80.8', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K81', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K81.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K81.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K81.8', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K81.9', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K82', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K82.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K82.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K82.2', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K82.3', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K82.4', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K82.8', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K82.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K83', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K83.0', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K83.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K83.2', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K83.3', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K83.4', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K83.5', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K83.8', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K83.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K85', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K85.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K85.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K85.2', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K85.3', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K85.8', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K85.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K86', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K86.0', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K86.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K86.2', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K86.3', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K86.8', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K86.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K87*', '  ,       ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K87.0*', '       ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K87.1*', '    ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K90', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K90.0', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K90.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K90.2', '  ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K90.3', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K90.4', ' ,  ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K90.8', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K90.9', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K91', '     ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K91.0', '     - '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K91.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K91.2', '    ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K91.3', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K91.4', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K91.5', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K91.8', '      ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K91.9', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K92', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K92.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K92.1', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K92.2', '-  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K92.8', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K92.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K93*', '     ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K93.0*', '  ,      (A18.3+)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K93.1*', '    (B57.3+)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('K93.8*', '      ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L00', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L01', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L01.0', ' [  ] [ ]'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L01.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L02', ' ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L02.0', ' ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L02.1', ' ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L02.2', ' ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L02.3', ' ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L02.4', ' ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L02.8', ' ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L02.9', ' ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L03', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L03.0', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L03.1', '   '); @
COMMIT WORK; @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L03.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L03.3', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L03.8', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L03.9', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L04', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L04.0', '  ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L04.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L04.2', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L04.3', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L04.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L04.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L05', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L05.0', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L05.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L08', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L08.0', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L08.1', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L08.8', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L08.9', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L10', ' []'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L10.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L10.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L10.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L10.3', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L10.4', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L10.5', ',   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L10.8', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L10.9', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L11', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L11.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L11.1', '   []'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L11.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L11.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L12', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L12.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L12.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L12.2', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L12.3', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L12.8', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L12.9', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L13', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L13.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L13.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L13.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L13.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L14*', '    ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L20', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L20.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L20.8', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L20.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L21', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L21.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L21.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L21.8', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L21.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L22', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L23', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L23.0', '  ,  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L23.1', '  ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L23.2', '  ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L23.3', '  ,        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L23.4', '  ,  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L23.5', '  ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L23.6', '  ,        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L23.7', '  ,  ,  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L23.8', '  ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L23.9', '  ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L24', '  [irritant]  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L24.0', '   ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L24.1', '   ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L24.2', '   ,  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L24.3', '   ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L24.4', '  ,        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L24.5', '   ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L24.6', '   ,        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L24.7', '   ,  ,  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L24.8', '   ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L24.9', '   ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L25', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L25.0', '  ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L25.1', '  ,        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L25.2', '  ,  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L25.3', '  ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L25.4', '  ,        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L25.5', '  ,  ,  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L25.8', '  ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L25.9', '  ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L26', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L27', ',  ,  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L27.0', '   ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L27.1', '   ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L27.2', ',   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L27.8', ',   ,  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L27.9', ',   ,  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L28', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L28.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L28.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L28.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L29', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L29.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L29.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L29.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L29.3', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L29.8', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L29.9', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L30', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L30.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L30.1', ' []'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L30.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L30.3', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L30.4', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L30.5', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L30.8', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L30.9', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L40', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L40.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L40.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L40.2', '  []'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L40.3', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L40.4', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L40.5+', '  (M07.0-M07.3*, M09.0*)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L40.8', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L40.9', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L41', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L41.0', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L41.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L41.3', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L41.4', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L41.5', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L41.8', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L41.9', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L42', '  []'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L43', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L43.0', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L43.1', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L43.2', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L43.3', '    ()'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L43.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L43.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L44', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L44.0', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L44.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L44.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L44.3', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L44.4', '   [- ]'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L44.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L44.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L45*', '   ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L50', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L50.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L50.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L50.2', ',      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L50.3', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L50.4', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L50.5', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L50.6', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L50.8', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L50.9', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L51', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L51.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L51.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L51.2', '   []'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L51.8', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L51.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L52', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L53', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L53.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L53.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L53.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L53.3', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L53.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L53.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L54*', '  ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L54.0*', '      (I00+)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L54.8*', '   ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L55', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L55.0', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L55.1', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L55.2', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L55.8', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L55.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L56', '   ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L56.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L56.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L56.2', '  [berloque dermatitis]'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L56.3', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L56.4', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L56.8', '    ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L56.9', '  ,   , '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L57', ' ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L57.0', ' [] '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L57.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L57.2', '    ()'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L57.3', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L57.4', '  () '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L57.5', ' [] '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L57.8', '  ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L57.9', ' ,     , '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L58', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L58.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L58.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L58.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L59', '     ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L59.0', '  [ ab igne]'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L59.8', '      ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L59.9', '    ,   , '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L60', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L60.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L60.1', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L60.2', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L60.3', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L60.4', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L60.5', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L60.8', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L60.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L62*', '   ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L62.0*', '    (M89.4+)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L62.8*', '    ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L63', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L63.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L63.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L63.2', '  ( )'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L63.8', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L63.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L64', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L64.0', ' ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L64.8', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L64.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L65', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L65.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L65.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L65.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L65.8', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L65.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L66', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L66.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L66.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L66.2', ',   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L66.3', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L66.4', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L66.8', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L66.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L67', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L67.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L67.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L67.8', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L67.9', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L68', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L68.0', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L68.1', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L68.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L68.3', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L68.8', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L68.9', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L70', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L70.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L70.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L70.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L70.3', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L70.4', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L70.5', 'Acne excoriee des jeunes filles'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L70.8', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L70.9', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L71', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L71.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L71.1', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L71.8', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L71.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L72', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L72.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L72.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L72.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L72.8', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L72.9', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L73', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L73.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L73.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L73.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L73.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L73.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L74', '  []  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L74.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L74.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L74.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L74.3', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L74.4', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L74.8', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L74.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L75', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L75.0', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L75.1', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L75.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L75.8', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L75.9', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L80', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L81', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L81.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L81.1', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L81.2', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L81.3', '  [cafe au lait spots]'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L81.4', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L81.5', ',     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L81.6', ' ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L81.7', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L81.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L81.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L82', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L83', 'Acanthosis nigricans'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L84', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L85', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L85.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L85.1', '  [] -'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L85.2', '  (-)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L85.3', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L85.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L85.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L86*', '  ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L87', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L87.0', '   ,    [ ]'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L87.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L87.2', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L87.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L87.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L88', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L89', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L89.0', ' I     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L89.1', ' II  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L89.2', ' III  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L89.3', ' IV  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L89.9', '    , '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L90', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L90.0', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L90.1', ' -'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L90.2', ' -'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L90.3', ' -'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L90.4', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L90.5', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L90.6', '  [striae atrophicae]'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L90.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L90.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L91', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L91.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L91.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L91.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L92', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L92.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L92.1', ' ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L92.2', '  [  ]'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L92.3', '    ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L92.8', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L92.9', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L93', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L93.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L93.1', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L93.2', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L94', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L94.0', '  [morphea]'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L94.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L94.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L94.3', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L94.4', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L94.5', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L94.6', ' [ ]'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L94.8', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L94.9', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L95', ',  ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L95.0', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L95.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L95.8', ' ,  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L95.9', ',  , '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L97', '  ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L98', '     ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L98.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L98.1', ' [] '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L98.2', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L98.3', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L98.4', '  ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L98.5', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L98.6', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L98.8', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L98.9', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L99', '       ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L99.0*', '  (E85.-+)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('L99.8*', '        ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M00', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M00.0', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M00.1', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M00.2', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M00.8', '  ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M00.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M01*', '       ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M01.0*', '  (A39.8+)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M01.1*', '  (A18.0+)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M01.2*', '    (A69.2+)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M01.3*', '    ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M01.4*', '   (B06.8+)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M01.5*', '    ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M01.6*', '   (B35-B49+)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M01.8*', '      ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M02', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M02.0', ',   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M02.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M02.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M02.3', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M02.8', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M02.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M03*', '     ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M03.0*', '     (A39.8+)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M03.1*', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M03.2*', '    ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M03.6*', '    ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M05', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M05.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M05.1+', '   (J99.0*)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M05.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M05.3+', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M05.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M05.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M06', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M06.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M06.1', ' ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M06.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M06.3', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M06.4', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M06.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M06.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M07*', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M07.0*', '    (L40.5+)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M07.1*', '  (L40.5+)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M07.2*', '  (L40.5+)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M07.3*', '   (L40.5+)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M07.4*', '    [ ] (K50.-+)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M07.5*', '    (K51.-+)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M07.6*', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M08', ' [] '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M08.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M08.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M08.2', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M08.3', '  ()'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M08.4', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M08.8', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M08.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M09*', ' []   ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M09.0*', '    (L40.5+)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M09.1*', '       (K50.-+)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M09.2*', '     (K51.-+)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M09.8*', '    ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M10', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M10.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M10.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M10.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M10.3', ',    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M10.4', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M10.9', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M11', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M11.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M11.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M11.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M11.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M11.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M12', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M12.0', '   []'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M12.1', ' -'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M12.2', '- []  ()'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M12.3', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M12.4', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M12.5', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M12.8', '  ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M13', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M13.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M13.1', ',     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M13.8', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M13.9', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M14*', '   ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M14.0*', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M14.1*', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M14.2*', '  (E10-E14+     .6)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M14.3*', '  (E78.8+)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M14.4*', '   (E85.-+)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M14.5*', '     ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M14.6*', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M14.8*', '    ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M15', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M15.0', '  ()'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M15.1', '  ( )'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M15.2', '  ( )'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M15.3', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M15.4', ' ()'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M15.8', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M15.9', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M16', ' [  ]'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M16.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M16.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M16.2', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M16.3', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M16.4', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M16.5', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M16.6', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M16.7', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M16.9', ' '); @
COMMIT WORK; @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M17', ' [  ]'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M17.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M17.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M17.2', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M17.3', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M17.4', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M17.5', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M17.9', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M18', '  - '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M18.0', '   -  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M18.1', '    - '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M18.2', '   -  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M18.3', '    - '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M18.4', '    -  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M18.5', '    - '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M18.9', '  -  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M19', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M19.0', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M19.1', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M19.2', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M19.8', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M19.9', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M20', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M20.0', ' ()'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M20.1', '    (hallus valgus) ()'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M20.2', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M20.3', '     ()'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M20.4', '    ()'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M20.5', '  ()  ()'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M20.6', '  ()  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M21', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M21.0', ' ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M21.1', ' ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M21.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M21.3', '    ()'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M21.4', '  [pes planus] ()'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M21.5', '  , ,   (  )    ()'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M21.6', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M21.7', '   ()'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M21.8', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M21.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M22', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M22.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M22.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M22.2', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M22.3', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M22.4', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M22.8', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M22.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M23', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M23.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M23.1', '  ()'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M23.2', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M23.3', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M23.4', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M23.5', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M23.6', '   () '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M23.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M23.9', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M24', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M24.0', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M24.1', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M24.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M24.3', '    ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M24.4', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M24.5', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M24.6', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M24.7', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M24.8', '   ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M24.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M25', '  ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M25.0', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M25.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M25.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M25.3', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M25.4', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M25.5', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M25.6', '  ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M25.7', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M25.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M25.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M30', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M30.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M30.1', '    [-]'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M30.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M30.3', '-   []'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M30.8', ' ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M31', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M31.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M31.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M31.2', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M31.3', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M31.4', '   []'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M31.5', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M31.6', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M31.7', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M31.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M31.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M32', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M32.0', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M32.1+', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M32.8', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M32.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M33', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M33.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M33.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M33.2', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M33.9', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M34', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M34.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M34.1', ' CR(E)ST'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M34.2', ' ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M34.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M34.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M35', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M35.0', '  []'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M35.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M35.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M35.3', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M35.4', ' () '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M35.5', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M35.6', '  -'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M35.7', '  ,  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M35.8', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M35.9', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M36*', '     ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M36.0*', '()   (C00-D48+)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M36.1*', '   (C00-D48+)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M36.2*', '   (D66-D68+)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M36.3*', '     (D50-D76+)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M36.4*', '   ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M36.8*', '      ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M40', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M40.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M40.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M40.2', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M40.3', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M40.4', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M40.5', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M41', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M41.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M41.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M41.2', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M41.3', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M41.4', '- '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M41.5', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M41.8', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M41.9', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M42', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M42.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M42.1', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M42.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M43', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M43.0', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M43.1', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M43.2', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M43.3', ' -   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M43.4', '  - '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M43.5', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M43.6', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M43.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M43.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M45', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M46', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M46.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M46.1', ',     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M46.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M46.3', '   ()'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M46.4', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M46.5', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M46.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M46.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M47', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M47.0+', '       (G99.2*)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M47.1', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M47.2', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M47.8', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M47.9', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M48', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M48.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M48.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M48.2', '"" '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M48.3', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M48.4', ' ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M48.5', ' ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M48.8', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M48.9', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M49*', '  ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M49.0*', '  (A18.0+)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M49.1*', '  (A23.-+)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M49.2*', '  (A01-A04+)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M49.3*', '      ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M49.4*', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M49.5*', '   ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M49.8*', '   ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M50', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M50.0+', '       (G99.2*)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M50.1', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M50.2', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M50.3', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M50.8', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M50.9', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M51', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M51.0+', '         (G99.2*)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M51.1', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M51.2', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M51.3', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M51.4', ' [] '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M51.8', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M51.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M53', ' ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M53.0', '- '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M53.1', '- '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M53.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M53.3', '- ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M53.8', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M53.9', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M54', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M54.0', ',     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M54.1', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M54.2', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M54.3', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M54.4', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M54.5', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M54.6', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M54.8', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M54.9', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M60', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M60.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M60.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M60.2', '  ,    ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M60.8', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M60.9', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M61', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M61.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M61.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M61.2', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M61.3', '   ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M61.4', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M61.5', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M61.9', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M62', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M62.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M62.1', '   ()'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M62.2', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M62.3', '  ()'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M62.4', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M62.5', '   ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M62.6', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M62.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M62.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M63*', '   ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M63.0*', '   ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M63.1*', '     ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M63.2*', '    ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M63.3*', '   (D86.8+)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M63.8*', '    ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M65', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M65.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M65.1', '  ()'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M65.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M65.3', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M65.4', '     [  ]'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M65.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M65.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M66', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M66.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M66.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M66.2', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M66.3', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M66.4', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M66.5', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M67', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M67.0', '  []  ()'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M67.1', '   ()'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M67.2', ' ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M67.3', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M67.4', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M67.8', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M67.9', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M68*', '      ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M68.0*', '     ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M68.8*', '       ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M70', '  ,   ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M70.0', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M70.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M70.2', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M70.3', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M70.4', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M70.5', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M70.6', '   ( )'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M70.7', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M70.8', '   ,   ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M70.9', '  ,   ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M71', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M71.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M71.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M71.2', '    []'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M71.3', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M71.4', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M71.5', ' ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M71.8', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M71.9', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M72', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M72.0', '   []'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M72.1', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M72.2', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M72.4', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M72.6', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M72.8', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M72.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M73*', '    ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M73.0*', '  (A54.4+)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M73.1*', '  (A52.7+)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M73.8*', '     ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M75', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M75.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M75.1', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M75.2', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M75.3', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M75.4', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M75.5', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M75.8', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M75.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M76', '  ,  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M76.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M76.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M76.2', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M76.3', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M76.4', '   [-]'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M76.5', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M76.6', '  [] '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M76.7', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M76.8', '   ,  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M76.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M77', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M77.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M77.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M77.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M77.3', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M77.4', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M77.5', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M77.8', ' ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M77.9', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M79', '   ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M79.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M79.1', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M79.2', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M79.3', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M79.4', ' ()  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M79.5', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M79.6', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M79.7', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M79.8', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M79.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M80', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M80.0', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M80.1', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M80.2', '   ,  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M80.3', '    ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M80.4', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M80.5', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M80.8', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M80.9', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M81', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M81.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M81.1', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M81.2', ',  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M81.3', ' ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M81.4', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M81.5', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M81.6', '  []'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M81.8', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M81.9', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M82*', '  ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M82.0*', '    (C90.0+)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M82.1*', '    (E00-E34+)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M82.8*', '   ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M83', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M83.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M83.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M83.2', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M83.3', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M83.4', ' ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M83.5', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M83.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M83.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M84', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M84.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M84.1', '  []'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M84.2', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M84.3', ' ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M84.4', ' ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M84.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M84.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M85', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M85.0', '  (,  )'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M85.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M85.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M85.3', '     ()'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M85.4', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M85.5', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M85.6', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M85.8', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M85.9', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M86', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M86.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M86.1', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M86.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M86.3', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M86.4', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M86.5', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M86.6', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M86.8', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M86.9', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M87', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M87.0', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M87.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M87.2', ',   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M87.3', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M87.8', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M87.9', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M88', '  () [ ]'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M88.0', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M88.8', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M88.9', '  () '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M89', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M89.0', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M89.1', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M89.2', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M89.3', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M89.4', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M89.5', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M89.6', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M89.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M89.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M90*', '  ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M90.0*', '  (A18.0+)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M90.1*', '    ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M90.2*', '    ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M90.3*', '    (T70.3+)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M90.4*', '   (D50-D64+)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M90.5*', '   ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M90.6*', '    (C00-D48+)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M90.7*', '    (C00-D48+)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M90.8*', '   ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M91', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M91.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M91.1', '     [--]'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M91.2', 'Coxa plana'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M91.3', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M91.8', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M91.9', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M92', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M92.0', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M92.1', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M92.2', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M92.3', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M92.4', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M92.5', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M92.6', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M92.7', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M92.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M92.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M93', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M93.0', '     ()'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M93.1', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M93.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M93.8', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M93.9', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M94', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M94.0', '    []'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M94.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M94.2', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M94.3', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M94.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M94.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M95', '   -    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M95.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M95.1', '  ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M95.2', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M95.3', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M95.4', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M95.5', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M95.8', '    - '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M95.9', '  -  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M96', ' -    ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M96.0', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M96.1', ' ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M96.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M96.3', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M96.4', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M96.5', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M96.6', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M96.8', '  -    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M96.9', ' -     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M99', ' ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M99.0', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M99.1', '  ()'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M99.2', '    '); @
COMMIT WORK; @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M99.3', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M99.4', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M99.5', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M99.6', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M99.7', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M99.8', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('M99.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N00', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N00.0', '   c   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N00.1', '   c     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N00.2', '   c   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N00.3', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N00.4', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N00.5', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N00.6', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N00.7', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N00.8', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N00.9', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N01', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N01.0', '    c   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N01.1', '    c     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N01.2', '    c   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N01.3', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N01.4', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N01.5', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N01.6', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N01.7', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N01.8', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N01.9', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N02', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N02.0', '    c   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N02.1', '    c     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N02.2', '    c   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N02.3', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N02.4', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N02.5', '    c   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N02.6', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N02.7', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N02.8', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N02.9', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N03', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N03.0', '   c   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N03.1', '   c     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N03.2', '   c   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N03.3', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N03.4', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N03.5', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N03.6', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N03.7', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N03.8', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N03.9', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N04', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N04.0', '  c   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N04.1', '  c     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N04.2', '  c   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N04.3', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N04.4', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N04.5', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N04.6', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N04.7', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N04.8', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N04.9', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N05', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N05.0', '   c   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N05.1', '   c     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N05.2', '   c   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N05.3', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N05.4', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N05.5', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N05.6', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N05.7', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N05.8', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N05.9', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N06', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N06.0', '      c   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N06.1', '      c     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N06.2', '      c   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N06.3', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N06.4', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N06.5', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N06.6', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N06.7', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N06.8', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N06.9', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N07', ' ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N07.0', ' ,      c   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N07.1', ' ,      c     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N07.2', ' ,      c   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N07.3', ' ,          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N07.4', ' ,          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N07.5', ' ,         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N07.6', ' ,         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N07.7', ' ,         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N07.8', '    ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N07.9', '    ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N08*', '   ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N08.0*', '      ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N08.1*', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N08.2*', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N08.3*', '     (E10-14+     .2)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N08.4*', '      ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N08.5*', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N08.8*', '    ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N10', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N11', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N11.0', '  ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N11.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N11.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N11.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N12', ' ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N13', '   -'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N13.0', '   - '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N13.1', '   ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N13.2', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N13.3', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N13.4', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N13.5', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N13.6', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N13.7', ',  - '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N13.8', '    -'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N13.9', '   - '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N14', '   ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N14.0', ',   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N14.1', ',    ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N14.2', ',    ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N14.3', ',   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N14.4', ' ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N15', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N15.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N15.1', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N15.8', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N15.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N16*', '    ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N16.0*', '       ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N16.1*', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N16.2*', '       ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N16.3*', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N16.4*', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N16.5*', '      (T86.-+)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N16.8*', '     ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N17', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N17.0', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N17.1', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N17.2', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N17.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N17.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N18', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N18.0', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N18.1', '  ,  1'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N18.2', '  ,  2'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N18.3', '  ,  3'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N18.4', '  ,  4'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N18.5', '  ,  5'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N18.8', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N18.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N19', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N20', '    :   (N13.2)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N20.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N20.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N20.2', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N20.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N21', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N21.0', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N21.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N21.8', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N21.9', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N22*', '    ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N22.0*', '    [] (B65.-+)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N22.8*', '     ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N23', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N25', ',      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N25.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N25.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N25.8', ' ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N25.9', ',       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N26', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N27', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N27.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N27.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N27.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N28', '    ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N28.0', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N28.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N28.8', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N28.9', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N29*', '      ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N29.0*', '   (A52.7+)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N29.1*', '         ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N29.8*', '       ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N30', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N30.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N30.1', '  ()'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N30.2', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N30.3', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N30.4', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N30.8', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N30.9', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N31', '-   ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N31.0', '  ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N31.1', '  ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N31.2', '   ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N31.8', ' -   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N31.9', '-    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N32', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N32.0', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N32.1', '- '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N32.2', ' ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N32.3', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N32.4', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N32.8', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N32.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N33*', '    ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N33.0*', '  (A18.1+)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N33.8*', '     ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N34', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N34.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N34.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N34.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N34.3', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N35', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N35.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N35.1', '  ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N35.8', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N35.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N36', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N36.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N36.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N36.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N36.3', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N36.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N36.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N37*', '   ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N37.0*', '  ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N37.8*', '    ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N39', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N39.0', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N39.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N39.2', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N39.3', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N39.4', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N39.8', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N39.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N40', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N41', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N41.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N41.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N41.2', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N41.3', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N41.8', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N41.9', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N42', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N42.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N42.1', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N42.2', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N42.3', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N42.8', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N42.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N43', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N43.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N43.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N43.2', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N43.3', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N43.4', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N44', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N45', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N45.0', ',   -  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N45.9', ',   -    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N46', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N47', '  ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N48', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N48.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N48.1', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N48.2', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N48.3', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N48.4', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N48.5', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N48.6', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N48.8', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N48.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N49', '    ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N49.0', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N49.1', '   ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N49.2', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N49.8', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N49.9', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N50', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N50.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N50.1', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N50.8', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N50.9', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N51*', '     ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N51.0*', '    ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N51.1*', '      ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N51.2*', '  ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N51.8*', '      ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N60', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N60.0', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N60.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N60.2', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N60.3', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N60.4', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N60.8', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N60.9', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N61', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N62', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N63', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N64', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N64.0', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N64.1', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N64.2', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N64.3', ',    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N64.4', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N64.5', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N64.8', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N64.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N70', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N70.0', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N70.1', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N70.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N71', '  ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N71.0', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N71.1', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N71.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N72', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N73', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N73.0', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N73.1', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N73.2', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N73.3', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N73.4', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N73.5', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N73.6', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N73.8', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N73.9', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N74*', '      ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N74.0*', '    (A18.1+)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N74.1*', '       (A18.1+)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N74.2*', '    ,   (A51.4+, A52.7+)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N74.3*', '      (A54.2+)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N74.8*', '       ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N75', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N75.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N75.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N75.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N75.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N76', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N76.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N76.1', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N76.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N76.3', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N76.4', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N76.5', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N76.6', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N76.8', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N77*', '       ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N77.0*', '      ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N77.1*', ',        ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N77.8*', '        ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N80', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N80.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N80.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N80.2', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N80.3', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N80.4', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N80.5', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N80.6', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N80.8', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N80.9', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N81', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N81.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N81.1', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N81.2', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N81.3', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N81.4', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N81.5', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N81.6', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N81.8', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N81.9', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N82', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N82.0', '- '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N82.1', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N82.2', ' -'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N82.3', ' -'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N82.4', ' -   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N82.5', ' -  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N82.8', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N82.9', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N83', '  ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N83.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N83.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N83.2', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N83.3', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N83.4', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N83.5', ' ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N83.6', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N83.7', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N83.8', '   ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N83.9', '  ,       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N84', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N84.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N84.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N84.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N84.3', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N84.8', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N84.9', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N85', '   ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N85.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N85.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N85.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N85.3', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N85.4', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N85.5', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N85.6', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N85.7', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N85.8', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N85.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N86', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N87', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N87.0', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N87.1', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N87.2', '    ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N87.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N88', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N88.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N88.1', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N88.2', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N88.3', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N88.4', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N88.8', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N88.9', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N89', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N89.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N89.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N89.2', '   ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N89.3', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N89.4', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N89.5', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N89.6', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N89.7', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N89.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N89.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N90', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N90.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N90.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N90.2', '   ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N90.3', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N90.4', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N90.5', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N90.6', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N90.7', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N90.8', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N90.9', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N91', ' ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N91.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N91.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N91.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N91.3', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N91.4', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N91.5', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N92', ',    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N92.0', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N92.1', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N92.2', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N92.3', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N92.4', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N92.5', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N92.6', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N93', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N93.0', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N93.8', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N93.9', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N94', '   ,        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N94.0', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N94.1', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N94.2', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N94.3', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N94.4', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N94.5', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N94.6', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N94.8', '  ,        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N94.9', ',        , '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N95', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N95.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N95.1', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N95.2', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N95.3', ',     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N95.8', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N95.9', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N96', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N97', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N97.0', ' ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N97.1', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N97.2', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N97.3', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N97.4', ' ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N97.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N97.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N98', ',    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N98.0', ',    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N98.1', ' '); @
COMMIT WORK; @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N98.2', ',         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N98.3', ',     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N98.8', ' ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N98.9', ',    , '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N99', '     ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N99.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N99.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N99.2', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N99.3', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N99.4', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N99.5', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N99.8', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('N99.9', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O00', ' [] '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O00.0', ' [] '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O00.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O00.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O00.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O00.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O01', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O01.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O01.1', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O01.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O02', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O02.0', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O02.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O02.8', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O02.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O03', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O03.0', '  ,       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O03.1', '  ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O03.2', '  ,  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O03.3', '  ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O03.4', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O03.5', '    ,       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O03.6', '    ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O03.7', '    ,    ,    O08.2'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O03.8', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O03.9', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O04', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O04.0', '  ,       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O04.1', '  ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O04.2', '  ,  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O04.3', '  ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O04.4', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O04.5', '    ,       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O04.6', '    ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O04.7', '    ,    ,    O08.2'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O04.8', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O04.9', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O05', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O05.0', '   ,       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O05.1', '   ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O05.2', '   ,  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O05.3', '   ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O05.4', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O05.5', '     ,       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O05.6', '     ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O05.7', '     ,    ,    O08.2'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O05.8', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O05.9', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O06', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O06.0', '  ,       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O06.1', '  ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O06.2', '  ,  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O06.3', '  ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O06.4', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O06.5', '    ,       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O06.6', '    ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O06.7', '    ,    ,    O08.2'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O06.8', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O06.9', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O07', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O07.0', '  ,       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O07.1', '  ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O07.2', '  ,  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O07.3', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O07.4', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O07.5', '     ,       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O07.6', '     ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O07.7', '     ,  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O07.8', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O07.9', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O08', ',  ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O08.0', '     ,  ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O08.1', '   ,  ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O08.2', ',  ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O08.3', ',  ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O08.4', ' ,  ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O08.5', '  ,  ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O08.6', '    ,  ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O08.7', '  ,  ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O08.8', ' ,  ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O08.9', ',  ,    , '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O10', '  ,  ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O10.0', '   ,  ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O10.1', '   ,  ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O10.2', '   ,  ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O10.3', '     ,  ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O10.4', '   ,  ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O10.9', '  ,  ,    , '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O11', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O12', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O12.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O12.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O12.2', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O13', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O14', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O14.0', ' []  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O14.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O14.9', ' [] '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O15', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O15.0', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O15.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O15.2', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O15.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O16', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O20', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O20.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O20.8', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O20.9', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O21', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O21.0', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O21.1', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O21.2', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O21.8', '  ,  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O21.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O22', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O22.0', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O22.1', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O22.2', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O22.3', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O22.4', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O22.5', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O22.8', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O22.9', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O23', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O23.0', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O23.1', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O23.2', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O23.3', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O23.4', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O23.5', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O23.9', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O24', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O24.0', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O24.1', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O24.2', '   ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O24.3', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O24.4', ' ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O24.9', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O25', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O26', '       ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O26.0', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O26.1', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O26.2', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O26.3', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O26.4', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O26.5', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O26.6', '    ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O26.7', '     ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O26.8', '  ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O26.9', ',   , '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O28', '  ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O28.0', ' ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O28.1', ' ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O28.2', ' ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O28.3', ' ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O28.4', ' ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O28.5', '   ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O28.8', '   ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O28.9', '  ,     , '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O29', ',       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O29.0', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O29.1', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O29.2', '            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O29.3', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O29.4', ' ,         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O29.5', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O29.6', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O29.8', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O29.9', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O30', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O30.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O30.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O30.2', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O30.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O30.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O31', ',    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O31.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O31.1', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O31.2', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O31.8', ' ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O32', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O32.0', '  ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O32.1', '  ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O32.2', '    ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O32.3', ',     ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O32.4', '     ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O32.5', '        ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O32.6', '  ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O32.8', '    ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O32.9', '  ,     , '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O33', '           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O33.0', '  ,   ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O33.1', '  ,   ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O33.2', '  ,   ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O33.3', '  ,   ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O33.4', '     ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O33.5', '  ,   ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O33.6', ' ,   ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O33.7', '  ,   ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O33.8', '   ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O33.9', ',     , '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O34', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O34.0', '  ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O34.1', '  ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O34.2', '  ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O34.3', '- ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O34.4', '   ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O34.5', '   ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O34.6', ' ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O34.7', '   ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O34.8', '    ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O34.9', '  ,     , '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O35', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O35.0', '      ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O35.1', '    (),     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O35.2', '  ()  ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O35.3', '  ()     ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O35.4', '  ()    ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O35.5', '  ()     ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O35.6', '  ()   ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O35.7', '  ()     ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O35.8', '     (),     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O35.9', '   ,     , '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O36', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O36.0', '-,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O36.1', '  ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O36.2', ' ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O36.3', '   ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O36.4', '  ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O36.5', '  ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O36.6', '  ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O36.7', '    ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O36.8', '     ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O36.9', '    ,     , '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O40', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O41', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O41.0', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O41.1', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O41.8', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O41.9', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O42', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O42.0', '   ,     24 '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O42.1', '   ,    24-  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O42.2', '   ,  ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O42.9', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O43', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O43.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O43.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O43.2', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O43.8', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O43.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O44', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O44.0', ' ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O44.1', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O45', '   [abruptio placentae]'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O45.0', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O45.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O45.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O46', ' ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O46.0', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O46.8', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O46.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O47', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O47.0', '     37   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O47.1', '    37   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O47.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O48', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O60', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O60.0', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O60.1', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O60.2', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O60.3', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O61', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O61.0', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O61.1', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O61.8', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O61.9', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O62', '   [ ]'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O62.0', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O62.1', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O62.2', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O62.3', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O62.4', ',     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O62.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O62.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O63', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O63.0', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O63.1', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O63.2', '     ,   . .'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O63.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O64', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O64.0', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O64.1', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O64.2', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O64.3', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O64.4', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O64.5', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O64.8', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O64.9', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O65', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O65.0', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O65.1', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O65.2', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O65.3', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O65.4', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O65.5', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O65.8', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O65.9', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O66', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O66.0', '  []   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O66.1', '    [] '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O66.2', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O66.3', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O66.4', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O66.5', '   -    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O66.8', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O66.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O67', '  ,     ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O67.0', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O67.8', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O67.9', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O68', '  ,    []'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O68.0', ',      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O68.1', ',      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O68.2', ',            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O68.3', ',      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O68.8', ',      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O68.9', ',    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O69', '  ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O69.0', ',   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O69.1', ',       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O69.2', ',   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O69.3', ',   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O69.4', ',    [vasa praevia]'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O69.5', ',    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O69.8', ',     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O69.9', ',     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O70', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O70.0', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O70.1', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O70.2', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O70.3', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O70.9', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O71', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O71.0', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O71.1', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O71.2', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O71.3', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O71.4', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O71.5', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O71.6', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O71.7', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O71.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O71.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O72', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O72.0', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O72.1', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O72.2', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O72.3', '()  , , '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O73', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O73.0', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O73.1', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O74', ',         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O74.0', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O74.1', '           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O74.2', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O74.3', '            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O74.4', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O74.5', ' ,               '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O74.6', '             '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O74.7', '             '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O74.8', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O74.9', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O75', '    ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O75.0', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O75.1', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O75.2', '   ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O75.3', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O75.4', ' ,       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O75.5', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O75.6', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O75.7', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O75.8', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O75.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O80', ' ,  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O80.0', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O80.1', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O80.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O80.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O81', ' ,        -'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O81.0', '  [] '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O81.1', '  [] '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O81.2', '  []   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O81.3', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O81.4', ' -'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O81.5', '      -'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O82', ' ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O82.0', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O82.1', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O82.2', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O82.8', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O82.9', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O83', ' ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O83.0', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O83.1', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O83.2', '     [ ]'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O83.3', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O83.4', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O83.8', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O83.9', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O84', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O84.0', ' ,  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O84.1', ' ,      -'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O84.2', ' ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O84.8', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O84.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O85', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O86', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O86.0', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O86.1', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O86.2', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O86.3', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O86.4', '  ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O86.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O87', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O87.0', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O87.1', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O87.2', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O87.3', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O87.8', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O87.9', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O88', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O88.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O88.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O88.2', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O88.3', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O88.8', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O89', ',       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O89.0', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O89.1', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O89.2', '           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O89.3', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O89.4', ' ,          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O89.5', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O89.6', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O89.8', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O89.9', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O90', '   ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O90.0', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O90.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O90.2', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O90.3', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O90.4', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O90.5', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O90.8', '   ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O90.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O91', '  ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O91.0', ' ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O91.1', '  ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O91.2', ' ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O92', '      ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O92.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O92.1', ' ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O92.2', '     ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O92.3', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O92.4', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O92.5', ' [] '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O92.6', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O92.7', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O94', '  ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O95', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O96', '         42 ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O96.0', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O96.1', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O96.9', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O97', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O97.0', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O97.1', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O97.9', '    , '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O98', '    ,    ,   ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O98.0', ',  ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O98.1', ',  ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O98.2', ',  ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O98.3', ' ,    ,  ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O98.4', ' ,  ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O98.5', '  ,  ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O98.6', ' ,  ,    '); @
COMMIT WORK; @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O98.7', ',     (),  ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O98.8', '     ,  ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O98.9', '    ,  ,    , '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O99', '  ,    ,   ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O99.0', ',  ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O99.1', '            ,  ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O99.2', '  ,      ,  ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O99.3', '     ,  ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O99.4', '  ,  ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O99.5', '  ,  ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O99.6', '  ,  ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O99.7', '    ,  ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('O99.8', '    ,  ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P00', '   ,   ,        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P00.0', '   ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P00.1', '   ,        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P00.2', '   ,       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P00.3', '   ,         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P00.4', '   ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P00.5', '   ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P00.6', '   ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P00.7', '   ,      ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P00.8', '   ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P00.9', '   ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P01', '   ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P01.0', '   ,  - '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P01.1', '   ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P01.2', '   ,  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P01.3', '   ,  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P01.4', '   ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P01.5', '   ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P01.6', '   ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P01.7', '   ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P01.8', '   ,    ,  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P01.9', '   ,   ,  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P02', '   ,     ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P02.0', '   ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P02.1', '   ,   ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P02.2', '   ,         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P02.3', '   ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P02.4', '   ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P02.5', '   ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P02.6', '   ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P02.7', '   ,  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P02.8', '   ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P02.9', '   ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P03', '   ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P03.0', '   ,         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P03.1', '   ,     ,        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P03.2', '   ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P03.3', '   ,   -'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P03.4', '   ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P03.5', '   ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P03.6', '   ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P03.8', '   ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P03.9', '   ,     , '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P04', '   ,    ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P04.0', '   ,           ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P04.1', '   ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P04.2', '   ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P04.3', '   ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P04.4', '   ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P04.5', '   ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P04.6', '   ,      ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P04.8', '   ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P04.9', '   ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P05', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P05.0', '""    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P05.1', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P05.2', '      ""  " "   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P05.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P07', ',           ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P07.0', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P07.1', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P07.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P07.3', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P08', ',           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P08.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P08.1', ' ""   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P08.2', ' ,   ""  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P10', '    ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P10.0', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P10.1', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P10.2', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P10.3', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P10.4', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P10.8', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P10.9', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P11', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P11.0', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P11.1', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P11.2', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P11.3', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P11.4', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P11.5', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P11.9', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P12', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P12.0', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P12.1', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P12.2', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P12.3', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P12.4', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P12.8', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P12.9', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P13', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P13.0', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P13.1', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P13.2', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P13.3', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P13.4', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P13.8', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P13.9', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P14', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P14.0', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P14.1', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P14.2', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P14.3', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P14.8', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P14.9', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P15', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P15.0', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P15.1', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P15.2', ' -    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P15.3', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P15.4', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P15.5', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P15.6', '  ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P15.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P15.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P20', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P20.0', ' ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P20.1', ' ,       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P20.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P21', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P21.0', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P21.1', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P21.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P22', '  []  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P22.0', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P22.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P22.8', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P22.9', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P23', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P23.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P23.1', ' ,  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P23.2', ' ,  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P23.3', ' ,    B'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P23.4', ' ,    [Escherichia coli]'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P23.5', ' ,  Pseudomonas'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P23.6', ' ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P23.8', ' ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P23.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P24', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P24.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P24.1', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P24.2', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P24.3', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P24.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P24.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P25', '    ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P25.0', ' ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P25.1', ',    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P25.2', ',    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P25.3', ',    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P25.8', ' ,    ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P26', ' ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P26.0', ' ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P26.1', '  ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P26.8', '  ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P26.9', ' ,    , '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P27', '   ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P27.0', ' -'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P27.1', ' ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P27.8', '    ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P27.9', '    ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P28', '  ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P28.0', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P28.1', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P28.2', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P28.3', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P28.4', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P28.5', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P28.8', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P28.9', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P29', '- ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P29.0', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P29.1', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P29.2', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P29.3', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P29.4', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P29.8', ' - ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P29.9', '- ,    , '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P35', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P35.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P35.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P35.2', ' ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P35.3', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P35.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P35.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P36', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P36.0', ' ,    B'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P36.1', ' ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P36.2', ' ,    [Staphylococcus aureus]'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P36.3', ' ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P36.4', ' ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P36.5', ' ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P36.8', ' ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P36.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P37', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P37.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P37.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P37.2', ' () '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P37.3', ' ,  Plasmodium falciparum'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P37.4', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P37.5', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P37.8', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P37.9', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P38', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P39', '  ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P39.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P39.1', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P39.2', '  ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P39.3', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P39.4', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P39.8', '  ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P39.9', ',    , '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P50', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P50.0', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P50.1', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P50.2', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P50.3', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P50.4', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P50.5', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P50.8', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P50.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P51', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P51.0', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P51.8', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P51.9', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P52', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P52.0', ' ()  1-     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P52.1', ' ()  2-     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P52.2', ' ()  3-     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P52.3', '  ()     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P52.4', '   ()    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P52.5', ' ()     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P52.6', '       ()    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P52.8', '  ()     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P52.9', ' ()      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P53', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P54', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P54.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P54.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P54.2', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P54.3', '-   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P54.4', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P54.5', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P54.6', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P54.8', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P54.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P55', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P55.0', '-   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P55.1', 'AB0-   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P55.8', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P55.9', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P56', ' ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P56.0', ' ,  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P56.9', ' ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P57', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P57.0', ' ,  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P57.8', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P57.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P58', ' ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P58.0', ' ,  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P58.1', ' ,  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P58.2', ' ,  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P58.3', ' ,  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P58.4', ' ,     ,       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P58.5', ' ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P58.8', ' ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P58.9', ' ,   , '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P59', ' ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P59.0', ' ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P59.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P59.2', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P59.3', ' ,  ,  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P59.8', ' ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P59.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P60', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P61', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P61.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P61.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P61.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P61.3', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P61.4', '  ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P61.5', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P61.6', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P61.8', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P61.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P70', '   ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P70.0', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P70.1', '   ,  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P70.2', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P70.3', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P70.4', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P70.8', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P70.9', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P71', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P71.0', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P71.1', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P71.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P71.3', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P71.4', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P71.8', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P71.9', '      , '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P72', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P72.0', ' ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P72.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P72.2', '      ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P72.8', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P72.9', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P74', '    -  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P74.0', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P74.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P74.2', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P74.3', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P74.4', '   -   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P74.5', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P74.8', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P74.9', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P75*', '  (E84.1+)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P76', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P76.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P76.1', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P76.2', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P76.8', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P76.9', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P77', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P78', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P78.0', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P78.1', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P78.2', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P78.3', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P78.8', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P78.9', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P80', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P80.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P80.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P80.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P81', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P81.0', ' ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P81.8', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P81.9', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P83', '   ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P83.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P83.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P83.2', ' ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P83.3', '   ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P83.4', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P83.5', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P83.6', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P83.8', '    ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P83.9', '  ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P90', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P91', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P91.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P91.1', '  ()  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P91.2', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P91.3', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P91.4', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P91.5', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P91.6', '-  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P91.8', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P91.9', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P92', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P92.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P92.1', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P92.2', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P92.3', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P92.4', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P92.5', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P92.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P92.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P93', '  ,   ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P94', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P94.0', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P94.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P94.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P94.8', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P94.9', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P95', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P96', ' ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P96.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P96.1', '    ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P96.2', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P96.3', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P96.4', ' ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P96.5', ',   ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P96.8', '  ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('P96.9', ',    , '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q00', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q00.0', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q00.1', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q00.2', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q01', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q01.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q01.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q01.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q01.8', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q01.9', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q02', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q03', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q03.0', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q03.1', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q03.8', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q03.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q04', '   [ ] '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q04.0', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q04.1', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q04.2', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q04.3', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q04.4', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q04.5', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q04.6', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q04.8', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q04.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q05', 'Spina bifida [   ]'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q05.0', 'Spina bifida     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q05.1', 'Spina bifida     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q05.2', 'Spina bifida     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q05.3', 'Spina bifida     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q05.4', 'Spina bifida   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q05.5', 'Spina bifida     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q05.6', 'Spina bifida     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q05.7', 'Spina bifida     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q05.8', 'Spina bifida     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q05.9', 'Spina bifida '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q06', '   [ ]  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q06.0', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q06.1', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q06.2', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q06.3', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q06.4', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q06.8', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q06.9', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q07', '   [ ]  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q07.0', ' -'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q07.8', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q07.9', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q10', '  [ ] ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q10.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q10.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q10.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q10.3', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q10.4', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q10.5', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q10.6', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q10.7', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q11', ',   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q11.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q11.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q11.2', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q11.3', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q12', '  [ ] '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q12.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q12.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q12.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q12.3', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q12.4', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q12.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q12.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q13', '  [ ]   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q13.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q13.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q13.2', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q13.3', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q13.4', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q13.5', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q13.8', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q13.9', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q14', '  [ ]   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q14.0', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q14.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q14.2', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q14.3', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q14.8', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q14.9', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q15', '   [ ] '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q15.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q15.8', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q15.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q16', '  [ ] ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q16.0', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q16.1', ' ,      ()'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q16.2', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q16.3', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q16.4', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q16.5', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q16.9', '  ,   , '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q17', '   [ ] '); @
COMMIT WORK; @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q17.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q17.1', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q17.2', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q17.3', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q17.4', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q17.5', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q17.8', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q17.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q18', '   [ ]   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q18.0', ',     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q18.1', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q18.2', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q18.3', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q18.4', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q18.5', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q18.6', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q18.7', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q18.8', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q18.9', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q20', '  [ ]    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q20.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q20.1', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q20.2', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q20.3', ' - '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q20.4', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q20.5', ' - '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q20.6', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q20.8', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q20.9', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q21', '  [ ]  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q21.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q21.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q21.2', ' - '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q21.3', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q21.4', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q21.8', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q21.9', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q22', '  [ ]    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q22.0', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q22.1', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q22.2', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q22.3', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q22.4', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q22.5', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q22.6', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q22.8', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q22.9', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q23', '  [ ]    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q23.0', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q23.1', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q23.2', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q23.3', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q23.4', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q23.8', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q23.9', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q24', '   [ ] '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q24.0', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q24.1', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q24.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q24.3', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q24.4', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q24.5', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q24.6', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q24.8', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q24.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q25', '  [ ]  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q25.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q25.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q25.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q25.3', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q25.4', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q25.5', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q25.6', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q25.7', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q25.8', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q25.9', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q26', '  [ ]  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q26.0', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q26.1', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q26.2', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q26.3', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q26.4', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q26.5', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q26.6', ' -- '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q26.8', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q26.9', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q27', '   [ ]   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q27.0', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q27.1', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q27.2', ' [ ]  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q27.3', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q27.4', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q27.8', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q27.9', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q28', '   [ ]  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q28.0', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q28.1', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q28.2', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q28.3', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q28.8', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q28.9', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q30', '  [ ] '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q30.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q30.1', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q30.2', ', ,  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q30.3', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q30.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q30.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q31', '  [ ] '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q31.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q31.1', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q31.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q31.3', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q31.5', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q31.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q31.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q32', '  [ ]   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q32.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q32.1', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q32.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q32.3', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q32.4', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q33', '  [ ] '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q33.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q33.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q33.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q33.3', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q33.4', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q33.5', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q33.6', '     (P28.0)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q33.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q33.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q34', '   [ ]  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q34.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q34.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q34.8', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q34.9', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q35', '  [ ]'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q35.1', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q35.3', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q35.5', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q35.7', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q35.9', '  [ ]  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q36', '  [ ]'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q36.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q36.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q36.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q37', '    [    ]'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q37.0', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q37.1', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q37.2', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q37.3', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q37.4', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q37.5', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q37.8', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q37.9', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q38', '   [ ] ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q38.0', '  ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q38.1', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q38.2', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q38.3', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q38.4', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q38.5', '  ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q38.6', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q38.7', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q38.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q39', '  [ ] '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q39.0', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q39.1', '   - '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q39.2', ' -   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q39.3', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q39.4', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q39.5', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q39.6', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q39.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q39.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q40', '   [ ]    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q40.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q40.1', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q40.2', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q40.3', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q40.8', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q40.9', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q41', ' ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q41.0', ' ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q41.1', ' ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q41.2', ' ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q41.8', ' ,        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q41.9', ' ,       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q42', ' ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q42.0', ' ,       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q42.1', ' ,       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q42.2', ' ,       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q42.3', ' ,       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q42.8', ' ,       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q42.9', ' ,       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q43', '   [ ] '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q43.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q43.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q43.2', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q43.3', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q43.4', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q43.5', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q43.6', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q43.7', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q43.8', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q43.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q44', '  [ ]  ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q44.0', ',     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q44.1', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q44.2', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q44.3', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q44.4', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q44.5', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q44.6', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q44.7', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q45', '   [ ]  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q45.0', ',     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q45.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q45.2', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q45.3', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q45.8', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q45.9', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q50', '  [ ] ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q50.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q50.1', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q50.2', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q50.3', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q50.4', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q50.5', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q50.6', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q51', '  [ ]    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q51.0', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q51.1', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q51.2', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q51.3', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q51.4', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q51.5', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q51.6', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q51.7', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q51.8', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q51.9', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q52', '   [ ]   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q52.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q52.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q52.2', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q52.3', ' ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q52.4', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q52.5', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q52.6', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q52.7', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q52.8', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q52.9', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q53', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q53.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q53.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q53.2', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q53.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q54', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q54.0', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q54.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q54.2', ' -'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q54.3', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q54.4', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q54.8', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q54.9', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q55', '   [ ]   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q55.0', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q55.1', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q55.2', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q55.3', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q55.4', '    ,  ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q55.5', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q55.6', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q55.8', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q55.9', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q56', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q56.0', ',     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q56.1', ' ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q56.2', ' ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q56.3', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q56.4', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q60', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q60.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q60.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q60.2', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q60.3', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q60.4', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q60.5', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q60.6', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q61', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q61.0', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q61.1', ' ,  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q61.2', ' ,  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q61.3', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q61.4', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q61.5', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q61.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q61.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q62', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q62.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q62.1', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q62.2', '   [ ]'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q62.3', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q62.4', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q62.5', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q62.6', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q62.7', ' -- '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q62.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q63', '   [ ] '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q63.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q63.1', ',    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q63.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q63.3', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q63.8', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q63.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q64', '   [ ]  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q64.0', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q64.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q64.2', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q64.3', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q64.4', '   []'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q64.5', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q64.6', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q64.7', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q64.8', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q64.9', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q65', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q65.0', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q65.1', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q65.2', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q65.3', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q65.4', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q65.5', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q65.6', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q65.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q65.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q66', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q66.0', '- '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q66.1', '- '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q66.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q66.3', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q66.4', '- '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q66.5', '   [pes planus]'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q66.6', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q66.7', '  [pes cavus]'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q66.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q66.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q67', ' -  , ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q67.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q67.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q67.2', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q67.3', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q67.4', '   ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q67.5', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q67.6', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q67.7', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q67.8', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q68', '  - '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q68.0', '  - '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q68.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q68.2', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q68.3', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q68.4', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q68.5', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q68.8', '   - '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q69', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q69.0', '  ()'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q69.1', '   () '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q69.2', '  () '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q69.9', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q70', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q70.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q70.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q70.2', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q70.3', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q70.4', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q70.9', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q71', ',   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q71.0', '   () ()'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q71.1', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q71.2', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q71.3', '    ()'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q71.4', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q71.5', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q71.6', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q71.8', ' ,  () ()'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q71.9', ',   , '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q72', ',   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q72.0', '   () ()'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q72.1', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q72.2', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q72.3', '    () '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q72.4', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q72.5', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q72.6', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q72.7', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q72.8', ' ,  () ()'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q72.9', ',   , '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q73', ',   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q73.0', '  () ()'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q73.1', ' () ()'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q73.8', ' ,  (), ()'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q74', '   [ ] ()'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q74.0', '    (),   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q74.1', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q74.2', '   () (),   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q74.3', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q74.8', '    ()'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q74.9', '  () '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q75', '   [ ]    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q75.0', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q75.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q75.2', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q75.3', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q75.4', '- '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q75.5', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q75.8', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q75.9', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q76', '  [ ]     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q76.0', 'Spina bifida occulta'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q76.1', ' -'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q76.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q76.3', ' ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q76.4', '   ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q76.5', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q76.6', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q76.7', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q76.8', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q76.9', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q77', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q77.0', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q77.1', ' ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q77.2', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q77.3', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q77.4', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q77.5', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q77.6', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q77.7', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q77.8', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q77.9', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q78', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q78.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q78.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q78.2', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q78.3', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q78.4', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q78.5', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q78.6', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q78.8', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q78.9', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q79', '  [ ] - ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q79.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q79.1', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q79.2', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q79.3', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q79.4', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q79.5', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q79.6', ' -'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q79.8', '   - '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q79.9', '  -  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q80', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q80.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q80.1', ',   X- [X- ]'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q80.2', ' [] '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q80.3', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q80.4', '  [" "]'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q80.8', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q80.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q81', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q81.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q81.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q81.2', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q81.8', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q81.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q82', '   [ ] '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q82.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q82.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q82.2', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q82.3', '  [incontinentia pigmenti]'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q82.4', '  ()'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q82.5', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q82.8', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q82.9', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q83', '  [ ]  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q83.0', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q83.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q83.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q83.3', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q83.8', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q83.9', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q84', '   [ ]  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q84.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q84.1', '   ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q84.2', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q84.3', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q84.4', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q84.5', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q84.6', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q84.8', '     '); @
COMMIT WORK; @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q84.9', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q85', ',     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q85.0', ' ()'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q85.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q85.8', ' ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q85.9', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q86', '   [ ],    ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q86.0', '    ()'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q86.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q86.2', ',  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q86.8', '   ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q87', '     [ ],   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q87.0', '  ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q87.1', '  ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q87.2', '  ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q87.3', '  ,    []    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q87.4', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q87.5', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q87.8', '    ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q89', '   [ ],     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q89.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q89.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q89.2', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q89.3', 'Situs inversus'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q89.4', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q89.7', '  ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q89.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q89.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q90', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q90.0', ' 21,  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q90.1', ' 21,  ( )'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q90.2', ' 21, '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q90.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q91', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q91.0', ' 18,  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q91.1', ' 18,  ( )'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q91.2', ' 18, '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q91.3', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q91.4', ' 13,  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q91.5', ' 13,  ( )'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q91.6', ' 13, '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q91.7', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q92', '     ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q92.0', '  ,  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q92.1', '  ,  ( )'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q92.2', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q92.3', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q92.4', ',    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q92.5', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q92.6', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q92.7', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q92.8', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q92.9', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q93', '    ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q93.0', '  ,  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q93.1', '  ,  ( )'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q93.2', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q93.3', '    4'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q93.4', '    5'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q93.5', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q93.6', ',    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q93.7', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q93.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q93.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q95', '    ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q95.0', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q95.1', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q95.2', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q95.3', ' /    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q95.4', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q95.5', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q95.8', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q95.9', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q96', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q96.0', ' 45,X'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q96.1', ' 46,X iso (Xq)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q96.2', ' 46,X    ,   iso (Xq)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q96.3', ' 45,X / 46,XX  XY'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q96.4', ' 45,X /    ()    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q96.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q96.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q97', '   ,  ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q97.0', ' 47,XXX'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q97.1', '     X-'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q97.2', ',     X-'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q97.3', '  46,XY-'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q97.8', '    ,  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q97.9', '  ,  , '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q98', '   ,  ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q98.0', ' ,  47,XXY'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q98.1', ' ,      X-'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q98.2', ' ,   46,XX-'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q98.3', '   46,XX-'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q98.4', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q98.5', ' 47,XYY'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q98.6', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q98.7', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q98.8', '    ,  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q98.9', '  ,  , '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q99', '  ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q99.0', ' [] 46,XX / 46,XY'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q99.1', '46,XX  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q99.2', ' X-'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q99.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Q99.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R00', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R00.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R00.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R00.2', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R00.8', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R01', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R01.0', '""      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R01.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R01.2', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R02', ',     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R03', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R03.0', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R03.1', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R04', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R04.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R04.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R04.2', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R04.8', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R04.9', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R05', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R06', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R06.0', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R06.1', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R06.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R06.3', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R06.4', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R06.5', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R06.6', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R06.7', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R06.8', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R07', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R07.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R07.1', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R07.2', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R07.3', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R07.4', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R09', '   ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R09.0', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R09.1', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R09.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R09.3', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R09.8', '    ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R10', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R10.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R10.1', ',      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R10.2', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R10.3', ',       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R10.4', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R11', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R12', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R13', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R14', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R15', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R16', '  ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R16.0', ',     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R16.1', ',     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R16.2', '  ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R17', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R18', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R19', '   ,       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R19.0', '   ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R19.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R19.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R19.3', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R19.4', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R19.5', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R19.6', '    [ ]'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R19.8', '    ,        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R20', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R20.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R20.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R20.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R20.3', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R20.8', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R21', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R22', ' ,       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R22.0', ' ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R22.1', ' ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R22.2', ' ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R22.3', ' ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R22.4', ' ,       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R22.7', ' ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R22.9', ' ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R23', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R23.0', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R23.1', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R23.2', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R23.3', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R23.4', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R23.8', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R25', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R25.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R25.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R25.2', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R25.3', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R25.8', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R26', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R26.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R26.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R26.2', '  ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R26.3', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R26.8', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R27', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R27.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R27.8', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R29', '   ,     - '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R29.0', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R29.1', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R29.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R29.3', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R29.4', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R29.6', '  ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R29.8', '     ,     - '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R30', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R30.0', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R30.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R30.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R31', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R32', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R33', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R34', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R35', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R36', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R39', '   ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R39.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R39.1', ' ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R39.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R39.8', '     ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R40', ',   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R40.0', ' []'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R40.1', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R40.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R41', '   ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R41.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R41.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R41.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R41.3', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R41.8', '     ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R42', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R43', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R43.0', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R43.1', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R43.2', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R43.8', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R44', '   ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R44.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R44.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R44.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R44.3', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R44.8', '     ,       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R45', '  ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R45.0', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R45.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R45.2', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R45.3', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R45.4', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R45.5', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R45.6', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R45.7', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R45.8', '   ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R46', '  ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R46.0', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R46.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R46.2', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R46.3', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R46.4', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R46.5', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R46.6', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R46.7', '   ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R46.8', '   ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R47', ' ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R47.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R47.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R47.8', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R48', '         ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R48.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R48.1', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R48.2', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R48.8', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R49', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R49.0', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R49.1', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R49.2', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R49.8', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R50', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R50.2', ',    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R50.8', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R50.9', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R51', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R52', ',     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R52.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R52.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R52.2', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R52.9', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R53', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R54', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R55', ' []  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R56', ',     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R56.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R56.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R57', ',     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R57.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R57.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R57.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R57.8', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R57.9', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R58', ',     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R59', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R59.0', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R59.1', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R59.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R60', ',     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R60.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R60.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R60.9', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R61', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R61.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R61.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R61.9', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R62', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R62.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R62.8', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R62.9', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R63', '  ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R63.0', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R63.1', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R63.2', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R63.3', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R63.4', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R63.5', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R63.6', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R63.8', '   ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R64', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R65', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R65.0', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R65.1', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R65.2', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R65.3', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R65.9', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R68', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R68.0', ',       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R68.1', ' ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R68.2', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R68.3', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R68.8', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R69', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R70', '       []'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R70.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R70.1', '   []'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R71', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R72', ' ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R73', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R73.0', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R73.9', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R74', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R74.0', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R74.8', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R74.9', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R75', '     []'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R76', '   ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R76.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R76.1', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R76.2', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R76.8', '    ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R76.9', '  ,     , '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R77', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R77.0', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R77.1', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R77.2', '   -'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R77.8', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R77.9', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R78', '     ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R78.0', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R78.1', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R78.2', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R78.3', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R78.4', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R78.5', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R78.6', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R78.7', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R78.8', '   ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R78.9', '  ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R79', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R79.0', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R79.8', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R79.9', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R80', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R81', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R82', '   ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R82.0', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R82.1', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R82.2', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R82.3', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R82.4', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R82.5', '     ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R82.6', '    ,        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R82.7', '  ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R82.8', '  ,       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R82.9', '     ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R83', '  ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R83.0', '  ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R83.1', '  ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R83.2', '    ,    ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R83.3', '  ,        ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R83.4', '  ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R83.5', '  ,      ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R83.6', '  ,      ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R83.7', '  ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R83.8', '   ,     ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R83.9', '   ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R84', '  ,          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R84.0', '  ,          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R84.1', '  ,          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R84.2', '    ,    ,          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R84.3', '  ,        ,          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R84.4', '  ,           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R84.5', '  ,           ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R84.6', '  ,           ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R84.7', '  ,           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R84.8', '   ,          ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R84.9', '   ,          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R85', '  ,          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R85.0', '  ,          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R85.1', '  ,          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R85.2', '    ,    ,          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R85.3', '  ,        ,          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R85.4', '  ,           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R85.5', '  ,           ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R85.6', '  ,           ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R85.7', '  ,           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R85.8', '   ,          ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R85.9', '   ,          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R86', '  ,        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R86.0', '  ,        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R86.1', '  ,        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R86.2', '    ,    ,        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R86.3', '  ,        ,        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R86.4', '  ,         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R86.5', '  ,         ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R86.6', '  ,         ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R86.7', '  ,         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R86.8', '   ,        ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R86.9', '   ,        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R87', '  ,        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R87.0', '  ,        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R87.1', '  ,        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R87.2', '    ,    ,         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R87.3', '  ,        ,       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R87.4', '  ,        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R87.5', '  ,        ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R87.6', '  ,        ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R87.7', '  ,        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R87.8', '   ,       ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R87.9', '   ,       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R89', '  ,       ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R89.0', '  ,      ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R89.1', '  ,      ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R89.2', '    ,    ,      ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R89.3', '  ,        ,      ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R89.4', '  ,       ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R89.5', '  ,       ,   ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R89.6', '  ,       ,   ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R89.7', '  ,       ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R89.8', '   ,      ,   ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R89.9', '   ,      ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R90', '  ,           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R90.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R90.8', '   ,           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R91', '  ,         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R92', '  ,          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R93', '  ,             '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R93.0', '  ,           ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R93.1', '  ,            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R93.2', '  ,         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R93.3', '  ,         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R93.4', '  ,       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R93.5', '  ,           ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R93.6', '  ,         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R93.7', '  ,           - '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R93.8', '  ,            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R94', '  ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R94.0', '  ,        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R94.1', '  ,            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R94.2', '  ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R94.3', '  ,      - '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R94.4', '  ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R94.5', '  ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R94.6', '  ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R94.7', '  ,       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R94.8', '  ,        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R95', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R95.0', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R95.9', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R96', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R96.0', ' '); @
COMMIT WORK; @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R96.1', ',     24     ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R98', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('R99', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S00', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S00.0', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S00.1', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S00.2', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S00.3', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S00.4', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S00.5', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S00.7', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S00.8', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S00.9', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S01', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S01.0', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S01.1', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S01.2', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S01.3', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S01.4', '    - '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S01.5', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S01.7', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S01.8', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S01.9', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S02', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S02.00', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S02.01', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S02.10', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S02.11', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S02.20', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S02.21', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S02.30', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S02.31', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S02.40', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S02.41', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S02.50', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S02.51', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S02.60', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S02.61', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S02.70', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S02.71', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S02.80', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S02.81', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S02.90', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S02.91', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S03', ',       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S03.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S03.1', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S03.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S03.3', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S03.4', '    () '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S03.5', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S04', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S04.0', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S04.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S04.2', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S04.3', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S04.4', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S04.5', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S04.6', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S04.7', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S04.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S04.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S05', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S05.0', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S05.1', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S05.2', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S05.3', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S05.4', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S05.5', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S05.6', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S05.7', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S05.8', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S05.9', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S06', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S06.00', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S06.01', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S06.10', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S06.11', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S06.20', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S06.21', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S06.30', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S06.31', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S06.40', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S06.41', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S06.50', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S06.51', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S06.60', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S06.61', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S06.70', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S06.71', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S06.80', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S06.81', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S06.90', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S06.91', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S07', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S07.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S07.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S07.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S07.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S08', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S08.0', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S08.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S08.8', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S08.9', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S09', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S09.0', '   ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S09.1', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S09.2', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S09.7', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S09.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S09.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S10', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S10.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S10.1', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S10.7', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S10.8', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S10.9', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S11', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S11.0', ' ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S11.1', ' ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S11.2', ' ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S11.7', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S11.8', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S11.9', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S12', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S12.00', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S12.01', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S12.10', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S12.11', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S12.20', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S12.21', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S12.70', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S12.71', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S12.80', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S12.81', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S12.90', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S12.91', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S13', ',    -    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S13.0', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S13.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S13.2', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S13.3', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S13.4', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S13.5', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S13.6', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S14', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S14.0', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S14.1', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S14.2', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S14.3', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S14.4', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S14.5', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S14.6', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S15', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S15.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S15.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S15.2', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S15.3', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S15.7', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S15.8', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S15.9', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S16', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S17', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S17.0', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S17.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S17.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S18', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S19', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S19.7', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S19.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S19.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S20', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S20.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S20.1', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S20.2', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S20.3', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S20.4', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S20.7', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S20.8', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S21', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S21.0', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S21.1', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S21.2', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S21.7', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S21.8', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S21.9', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S22', '  (),     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S22.00', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S22.01', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S22.10', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S22.11', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S22.20', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S22.21', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S22.30', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S22.31', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S22.40', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S22.41', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S22.50', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S22.51', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S22.80', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S22.81', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S22.90', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S22.91', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S23', ',      -   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S23.0', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S23.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S23.2', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S23.3', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S23.4', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S23.5', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S24', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S24.0', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S24.1', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S24.2', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S24.3', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S24.4', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S24.5', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S24.6', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S25', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S25.0', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S25.1', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S25.2', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S25.3', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S25.4', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S25.5', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S25.7', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S25.8', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S25.9', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S26', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S26.00', '       ()      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S26.01', '       ()      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S26.80', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S26.81', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S26.90', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S26.91', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S27', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S27.00', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S27.01', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S27.10', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S27.11', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S27.20', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S27.21', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S27.30', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S27.31', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S27.40', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S27.41', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S27.50', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S27.51', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S27.60', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S27.61', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S27.70', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S27.71', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S27.80', '           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S27.81', '           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S27.90', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S27.91', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S28', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S28.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S28.1', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S29', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S29.0', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S29.7', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S29.8', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S29.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S30', '  ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S30.0', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S30.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S30.2', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S30.7', '   ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S30.8', '   ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S30.9', '  ,     ,  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S31', '  ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S31.0', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S31.1', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S31.2', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S31.3', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S31.4', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S31.5', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S31.7', '   ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S31.8', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S32', ' -     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S32.00', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S32.01', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S32.10', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S32.11', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S32.20', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S32.21', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S32.30', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S32.31', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S32.40', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S32.41', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S32.50', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S32.51', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S32.70', '  -     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S32.71', '  -     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S32.80', '     -     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S32.81', '     -     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S33', ',    -      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S33.0', '     - '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S33.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S33.2', ' -   - '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S33.3', '     -    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S33.4', '    [ ]'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S33.5', '   -    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S33.6', '   -  - '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S33.7', '   -      -    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S34', '         ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S34.0', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S34.1', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S34.2', '   -  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S34.3', '   [cauda equina]'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S34.4', ' -  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S34.5', ' ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S34.6', ' () () ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S34.8', '       ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S35', '     ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S35.0', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S35.1', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S35.2', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S35.3', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S35.4', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S35.5', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S35.7', '      ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S35.8', '      ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S35.9', '      ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S36', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S36.00', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S36.01', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S36.10', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S36.11', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S36.20', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S36.21', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S36.30', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S36.31', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S36.40', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S36.41', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S36.50', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S36.51', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S36.60', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S36.61', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S36.70', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S36.71', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S36.80', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S36.81', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S36.90', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S36.91', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S37', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S37.00', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S37.01', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S37.10', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S37.11', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S37.20', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S37.21', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S37.30', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S37.31', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S37.40', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S37.41', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S37.50', '  ()       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S37.51', '  ()       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S37.60', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S37.61', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S37.70', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S37.71', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S37.80', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S37.81', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S37.90', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S37.91', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S38', '     ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S38.0', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S38.1', '     ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S38.2', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S38.3', '      ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S39', '    ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S39.0', '    ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S39.6', '  ()  () '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S39.7', '   ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S39.8', ',   ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S39.9', ' ,     , '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S40', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S40.0', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S40.7', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S40.8', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S40.9', '     , '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S41', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S41.0', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S41.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S41.7', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S41.8', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S42', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S42.00', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S42.01', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S42.10', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S42.11', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S42.20', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S42.21', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S42.30', '   ()  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S42.31', '   ()  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S42.40', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S42.41', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S42.70', '   ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S42.71', '   ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S42.80', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S42.81', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S42.90', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S42.91', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S43', ',    -   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S43.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S43.1', ' - '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S43.2', ' - '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S43.3', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S43.4', '   -   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S43.5', '      - '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S43.6', '   -  - '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S43.7', '   -       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S44', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S44.0', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S44.1', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S44.2', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S44.3', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S44.4', ' - '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S44.5', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S44.7', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S44.8', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S44.9', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S45', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S45.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S45.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S45.2', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S45.3', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S45.7', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S45.8', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S45.9', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S46', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S46.0', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S46.1', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S46.2', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S46.3', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S46.7', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S46.8', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S46.9', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S47', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S48', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S48.0', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S48.1', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S48.9', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S49', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S49.7', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S49.8', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S49.9', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S50', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S50.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S50.1', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S50.7', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S50.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S50.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S51', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S51.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S51.7', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S51.8', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S51.9', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S52', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S52.00', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S52.01', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S52.10', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S52.11', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S52.20', '  []  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S52.21', '  []  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S52.30', '  []  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S52.31', '  []  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S52.40', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S52.41', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S52.50', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S52.51', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S52.60', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S52.61', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S52.70', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S52.71', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S52.80', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S52.81', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S52.90', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S52.91', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S53', ',    -   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S53.0', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S53.1', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S53.2', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S53.3', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S53.4', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S54', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S54.0', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S54.1', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S54.2', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S54.3', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S54.7', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S54.8', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S54.9', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S55', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S55.0', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S55.1', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S55.2', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S55.7', '      '); @
COMMIT WORK; @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S55.8', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S55.9', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S56', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S56.0', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S56.1', '  () ()      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S56.2', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S56.3', '            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S56.4', '  () ()      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S56.5', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S56.7', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S56.8', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S57', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S57.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S57.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S57.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S58', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S58.0', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S58.1', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S58.9', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S59', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S59.7', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S59.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S59.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S60', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S60.0', ' ()     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S60.1', ' ()     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S60.2', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S60.7', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S60.8', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S60.9', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S61', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S61.0', '  ()     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S61.1', '  ()     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S61.7', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S61.8', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S61.9', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S62', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S62.00', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S62.01', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S62.10', '  () () '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S62.11', '  () () '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S62.20', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S62.21', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S62.30', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S62.31', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S62.40', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S62.41', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S62.50', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S62.51', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S62.60', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S62.61', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S62.70', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S62.71', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S62.80', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S62.81', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S63', ',    -      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S63.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S63.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S63.2', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S63.3', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S63.4', '         ()'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S63.5', '   -    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S63.6', '   -    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S63.7', '   -      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S64', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S64.0', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S64.1', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S64.2', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S64.3', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S64.4', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S64.7', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S64.8', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S64.9', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S65', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S65.0', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S65.1', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S65.2', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S65.3', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S65.4', '  ()  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S65.5', '  ()  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S65.7', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S65.8', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S65.9', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S66', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S66.0', '            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S66.1', '           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S66.2', '           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S66.3', '           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S66.4', '           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S66.5', '           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S66.6', '  -       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S66.7', '  -       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S66.8', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S66.9', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S67', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S67.0', '    () '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S67.8', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S68', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S68.0', '     ()'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S68.1', '      () ()'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S68.2', '       () ()'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S68.3', '   () ()      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S68.4', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S68.8', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S68.9', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S69', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S69.7', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S69.8', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S69.9', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S70', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S70.0', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S70.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S70.7', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S70.8', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S70.9', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S71', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S71.0', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S71.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S71.7', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S71.8', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S72', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S72.00', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S72.01', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S72.10', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S72.11', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S72.20', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S72.21', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S72.30', '   []  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S72.31', '   []  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S72.40', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S72.41', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S72.70', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S72.71', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S72.80', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S72.81', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S72.90', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S72.91', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S73', ',    -      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S73.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S73.1', '   -   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S74', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S74.0', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S74.1', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S74.2', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S74.7', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S74.8', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S74.9', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S75', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S75.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S75.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S75.2', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S75.7', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S75.8', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S75.9', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S76', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S76.0', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S76.1', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S76.2', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S76.3', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S76.4', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S76.7', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S77', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S77.0', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S77.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S77.2', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S78', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S78.0', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S78.1', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S78.9', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S79', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S79.7', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S79.8', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S79.9', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S80', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S80.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S80.1', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S80.7', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S80.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S80.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S81', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S81.0', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S81.7', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S81.8', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S81.9', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S82', '  ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S82.00', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S82.01', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S82.10', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S82.11', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S82.20', '  []  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S82.21', '  []  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S82.30', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S82.31', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S82.40', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S82.41', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S82.50', '   [] '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S82.51', '   [] '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S82.60', '   [] '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S82.61', '   [] '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S82.70', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S82.71', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S82.80', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S82.81', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S82.90', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S82.91', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S83', ',    -   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S83.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S83.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S83.2', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S83.3', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S83.4', '   () ()    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S83.5', '   () ()    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S83.6', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S83.7', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S84', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S84.0', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S84.1', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S84.2', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S84.7', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S84.8', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S84.9', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S85', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S85.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S85.1', '  () () '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S85.2', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S85.3', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S85.4', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S85.5', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S85.7', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S85.8', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S85.9', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S86', '       :           (S96.-)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S86.0', '  [] '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S86.1', ' () ()  ()      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S86.2', ' ()  ()      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S86.3', ' ()  ()      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S86.7', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S86.8', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S86.9', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S87', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S87.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S87.8', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S88', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S88.0', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S88.1', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S88.9', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S89', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S89.7', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S89.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S89.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S90', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S90.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S90.1', ' ()     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S90.2', ' ()     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S90.3', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S90.7', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S90.8', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S90.9', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S91', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S91.0', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S91.1', '  ()     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S91.2', '  ()     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S91.3', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S91.7', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S92', ' ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S92.00', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S92.01', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S92.10', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S92.11', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S92.20', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S92.21', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S92.30', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S92.31', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S92.40', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S92.41', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S92.50', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S92.51', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S92.70', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S92.71', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S92.90', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S92.91', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S93', ',    -     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S93.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S93.1', ' () '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S93.2', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S93.3', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S93.4', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S93.5', '   -  () '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S93.6', '   -      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S94', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S94.0', '  []  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S94.1', '  []  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S94.2', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S94.3', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S94.7', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S94.8', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S94.9', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S95', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S95.0', '  []  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S95.1', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S95.2', '  []  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S95.7', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S95.8', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S95.9', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S96', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S96.0', '            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S96.1', '            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S96.2', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S96.7', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S96.8', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S96.9', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S97', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S97.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S97.1', ' () '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S97.8', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S98', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S98.0', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S98.1', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S98.2', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S98.3', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S98.4', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S99', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S99.7', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S99.8', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('S99.9', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T00', ' ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T00.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T00.1', '   , ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T00.2', '     ()'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T00.3', '    () ()'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T00.6', '    ()  () '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T00.8', '   ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T00.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T01', ' ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T01.0', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T01.1', '    ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T01.2', '    () ()'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T01.3', '    () ()'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T01.6', '    ()  () '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T01.8', '   ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T01.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T02', ',    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T02.00', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T02.01', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T02.10', '     ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T02.11', '     ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T02.20', ' ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T02.21', ' ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T02.30', ' ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T02.31', ' ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T02.40', ' ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T02.41', ' ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T02.50', ' ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T02.51', ' ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T02.60', ' ,     (),  () '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T02.61', ' ,     (),  () '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T02.70', ' ,   ,   ,   ()'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T02.71', ' ,   ,   ,   ()'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T02.80', '   ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T02.81', '   ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T02.90', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T02.91', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T03', ',    - ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T03.0', ',    -  ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T03.1', ',    -   ,          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T03.2', ',    -     () ()'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T03.3', ',    -     () ()'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T03.4', ',    -      ()  () '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T03.8', '  ,    -     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T03.9', ' ,    -   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T04', ',    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T04.0', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T04.1', '  ,  ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T04.2', ',   () ()'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T04.3', '   () ()'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T04.4', '   ()  () '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T04.7', '  , ,   ,  ()'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T04.8', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T04.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T05', ' ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T05.0', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T05.1', '             ,  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T05.2', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T05.3', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T05.4', '            ,  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T05.5', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T05.6', '     ,   [ ]'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T05.8', ' ,       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T05.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T06', ' ,    ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T06.0', '                 '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T06.1', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T06.2', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T06.3', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T06.4', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T06.5', '            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T06.8', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T07', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T08', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T09', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T09.0', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T09.1', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T09.2', ',    -      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T09.3', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T09.4', '  ,       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T09.5', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T09.6', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T09.8', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T09.9', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T10', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T11', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T11.0', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T11.1', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T11.2', ', ,          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T11.3', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T11.4', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T11.5', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T11.6', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T11.8', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T11.9', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T12', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T13', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T13.0', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T13.1', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T13.2', ', ,  -        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T13.3', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T13.4', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T13.5', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T13.6', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T13.8', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T13.9', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T14', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T14.0', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T14.1', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T14.2', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T14.3', ',    -     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T14.4', '  ()   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T14.5', ' () ()   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T14.6', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T14.7', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T14.8', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T14.9', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T15', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T15.0', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T15.1', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T15.8', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T15.9', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T16', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T17', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T17.0', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T17.1', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T17.2', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T17.3', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T17.4', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T17.5', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T17.8', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T17.9', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T18', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T18.0', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T18.1', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T18.2', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T18.3', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T18.4', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T18.5', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T18.8', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T18.9', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T19', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T19.0', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T19.1', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T19.2', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T19.3', '    ( )'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T19.8', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T19.9', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T20', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T20.0', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T20.1', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T20.2', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T20.3', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T20.4', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T20.5', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T20.6', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T20.7', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T21', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T21.0', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T21.1', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T21.2', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T21.3', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T21.4', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T21.5', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T21.6', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T21.7', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T22', '         ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T22.0', '       ,    ,  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T22.1', '       ,    ,  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T22.2', '       ,    ,  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T22.3', '       ,    ,  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T22.4', '       ,     ,  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T22.5', '       ,     ,  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T22.6', '       ,     ,  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T22.7', '       ,     ,  '); @
COMMIT WORK; @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T23', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T23.0', '    ,  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T23.1', '    ,  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T23.2', '    ,  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T23.3', '    ,  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T23.4', '    ,  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T23.5', '    ,  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T23.6', '    ,  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T23.7', '    ,  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T24', '        ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T24.0', '       ,     ,  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T24.1', '       ,     ,  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T24.2', '       ,     ,  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T24.3', '       ,     ,  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T24.4', '       ,     ,  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T24.5', '       ,     ,  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T24.6', '       ,     ,  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T24.7', '       ,     ,  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T25', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T25.0', '      ,  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T25.1', '      ,  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T25.2', '      ,  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T25.3', '      ,  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T25.4', '      ,  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T25.5', '      ,  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T25.6', '      ,  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T25.7', '      ,  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T26', '   ,       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T26.0', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T26.1', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T26.2', ' ,       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T26.3', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T26.4', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T26.5', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T26.6', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T26.7', ' ,       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T26.8', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T26.9', '      ,  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T27', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T27.0', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T27.1', '  ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T27.2', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T27.3', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T27.4', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T27.5', '  ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T27.6', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T27.7', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T28', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T28.0', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T28.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T28.2', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T28.3', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T28.4', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T28.5', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T28.6', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T28.7', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T28.8', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T28.9', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T29', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T29.0', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T29.1', '             '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T29.2', '             '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T29.3', '             '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T29.4', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T29.5', '              '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T29.6', '              '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T29.7', '              '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T30', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T30.0', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T30.1', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T30.2', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T30.3', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T30.4', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T30.5', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T30.6', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T30.7', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T31', ' ,        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T31.0', '   10%  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T31.1', '  10-19%  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T31.2', '  20-29%  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T31.3', '  30-39%  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T31.4', '  40-49%  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T31.5', '  50-59%  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T31.6', '  60-69%  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T31.7', '  70-79%  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T31.8', '  80-89%  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T31.9', '  90%    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T32', ' ,        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T32.0', '   10%  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T32.1', '  10-19%  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T32.2', '  20-29%  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T32.3', '  30-39%  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T32.4', '  40-49%  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T32.5', '  50-59%  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T32.6', '  60-69%  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T32.7', '  70-79%  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T32.8', '  80-89%  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T32.9', '  90%    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T33', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T33.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T33.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T33.2', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T33.3', '   ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T33.4', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T33.5', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T33.6', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T33.7', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T33.8', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T33.9', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T34', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T34.0', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T34.1', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T34.2', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T34.3', '       ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T34.4', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T34.5', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T34.6', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T34.7', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T34.8', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T34.9', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T35', ',       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T35.0', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T35.1', '   ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T35.2', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T35.3', '  , ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T35.4', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T35.5', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T35.6', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T35.7', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T36', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T36.0', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T36.1', '   - '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T36.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T36.3', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T36.4', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T36.5', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T36.6', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T36.7', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T36.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T36.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T37', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T37.0', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T37.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T37.2', '   ,    ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T37.3', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T37.4', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T37.5', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T37.8', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T37.9', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T38', ' ,     ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T38.0', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T38.1', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T38.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T38.3', '    () '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T38.4', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T38.5', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T38.6', ', , ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T38.7', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T38.8', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T38.9', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T39', '  ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T39.0', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T39.1', ' 4-'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T39.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T39.3', '    (NSAID)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T39.4', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T39.8', '     ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T39.9', ' ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T40', '    ()'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T40.0', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T40.1', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T40.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T40.3', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T40.4', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T40.5', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T40.6', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T40.7', ' ()'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T40.8', ' ()'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T40.9', '    ()'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T41', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T41.0', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T41.1', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T41.2', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T41.3', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T41.4', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T41.5', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T42', ' , ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T42.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T42.1', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T42.2', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T42.3', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T42.4', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T42.5', '  ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T42.6', ' ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T42.7', ',     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T42.8', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T43', '  ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T43.0', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T43.1', '- '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T43.2', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T43.3', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T43.4', '-     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T43.5', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T43.6', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T43.8', '  ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T43.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T44', ' ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T44.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T44.1', '  () '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T44.2', ' ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T44.3', '  (  )   ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T44.4', '  -,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T44.5', '  -,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T44.6', ' -,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T44.7', ' -,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T44.8', '   ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T44.9', '   ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T45', '       ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T45.0', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T45.1', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T45.2', ',     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T45.3', ',     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T45.4', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T45.5', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T45.6', ',   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T45.7', ' ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T45.8', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T45.9', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T46', ' ,    - '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T46.0', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T46.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T46.2', '  ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T46.3', ' ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T46.4', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T46.5', '  ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T46.6', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T46.7', ',   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T46.8', ' ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T46.9', '   ,    - '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T47', ' ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T47.0', '  2 - '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T47.1', '    ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T47.2', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T47.3', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T47.4', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T47.5', ',  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T47.6', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T47.7', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T47.8', ' ,    - '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T47.9', ',     , '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T48', ' ,          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T48.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T48.1', ' ( -  )'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T48.2', '   ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T48.3', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T48.4', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T48.5', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T48.6', ' ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T48.7', '   ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T49', '   ,       ,  ,   ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T49.0', ',      ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T49.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T49.2', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T49.3', ',     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T49.4', ',         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T49.5', '  ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T49.6', '  ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T49.7', ' ,  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T49.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T49.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T50', '      ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T50.0', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T50.1', '"" '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T50.2', ' ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T50.3', ',   ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T50.4', ',     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T50.5', ',  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T50.6', '  ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T50.7', '    "" '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T50.8', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T50.9', '    ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T51', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T51.0', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T51.1', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T51.2', '2-'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T51.3', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T51.8', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T51.9', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T52', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T52.0', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T52.1', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T52.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T52.3', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T52.4', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T52.8', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T52.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T53', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T53.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T53.1', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T53.2', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T53.3', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T53.4', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T53.5', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T53.6', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T53.7', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T53.9', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T54', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T54.0', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T54.1', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T54.2', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T54.3', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T54.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T55', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T56', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T56.0', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T56.1', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T56.2', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T56.3', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T56.4', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T56.5', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T56.6', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T56.7', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T56.8', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T56.9', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T57', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T57.0', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T57.1', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T57.2', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T57.3', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T57.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T57.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T58', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T59', '   ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T59.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T59.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T59.2', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T59.3', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T59.4', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T59.5', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T59.6', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T59.7', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T59.8', '  ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T59.9', ',    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T60', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T60.0', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T60.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T60.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T60.3', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T60.4', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T60.8', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T60.9', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T61', '   ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T61.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T61.1', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T61.2', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T61.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T61.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T62', '    ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T62.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T62.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T62.2', ' () () ()'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T62.8', '  ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T62.9', ' ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T63', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T63.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T63.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T63.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T63.3', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T63.4', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T63.5', ' ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T63.6', ' ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T63.8', ' ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T63.9', '      , '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T64', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T65', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T65.0', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T65.1', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T65.2', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T65.3', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T65.4', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T65.5', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T65.6', '   ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T65.8', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T65.9', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T66', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T67', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T67.0', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T67.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T67.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T67.3', ' , '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T67.4', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T67.5', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T67.6', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T67.7', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T67.8', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T67.9', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T68', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T69', '     :  (T33-T35)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T69.0', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T69.1', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T69.8', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T69.9', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T70', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T70.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T70.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T70.2', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T70.3', '  ( )'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T70.4', '  ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T70.8', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T70.9', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T71', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T73', '    []'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T73.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T73.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T73.2', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T73.3', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T73.8', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T73.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T74', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T74.0', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T74.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T74.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T74.3', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T74.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T74.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T75', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T75.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T75.1', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T75.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T75.3', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T75.4', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T75.8', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T78', ' ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T78.0', ' ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T78.1', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T78.2', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T78.3', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T78.4', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T78.8', '  ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T78.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T79', '   ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T79.0', '  ()'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T79.1', '  ()'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T79.2', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T79.3', '  ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T79.4', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T79.5', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T79.6', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T79.7', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T79.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T79.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T80', '   ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T80.0', '    ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T80.1', '    ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T80.2', ',   ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T80.3', '  -'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T80.4', '  Rh-'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T80.5', ' ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T80.6', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T80.8', ' ,   ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T80.9', ',   ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T81', ' ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T81.0', '  ,  ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T81.1', '     ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T81.2', '      ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T81.3', '   ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T81.4', ',   ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T81.5', ' ,           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T81.6', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T81.7', ' ,   ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T81.8', '  ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T81.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T82', ',      ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T82.0', '  ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T82.1', '  ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T82.2', '  ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T82.3', '  ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T82.4', '  ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T82.5', '  ,         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T82.6', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T82.7', '          ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T82.8', ' ,      ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T82.9', ',      ,   , '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T83', ',     ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T83.0', '  ,   () '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T83.1', '  ,       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T83.2', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T83.3', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T83.4', '  ,      ,  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T83.5', '      ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T83.6', '      ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T83.8', ' ,     ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T83.9', ',     ,   , '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T84', ',      ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T84.0', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T84.1', '  ,    ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T84.2', '  ,    ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T84.3', '  ,     ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T84.4', '  ,      ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T84.5', '     '); @
COMMIT WORK; @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T84.6', '        ( )'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T84.7', '         ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T84.8', ' ,      ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T84.9', ',      ,   , '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T85', ',      ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T85.0', '  ,      ()'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T85.1', '  ,       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T85.2', '  ,     ()'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T85.3', '  ,     ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T85.4', '  ,       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T85.5', '  ,   - ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T85.6', '  ,       ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T85.7', '        ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T85.8', ' ,     ,   ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T85.9', ',     ,   , '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T86', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T86.0', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T86.1', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T86.2', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T86.3', '   - '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T86.4', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T86.8', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T86.9', '    ()   , '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T87', ',     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T87.0', ',    ()  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T87.1', ',    ()  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T87.2', ',      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T87.3', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T87.4', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T87.5', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T87.6', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T88', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T88.0', ',   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T88.1', ' ,   ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T88.2', ',  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T88.3', ' ,  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T88.4', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T88.5', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T88.6', ' ,           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T88.7', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T88.8', '      ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T88.9', '      :    (T78.9)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T90', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T90.0', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T90.1', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T90.2', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T90.3', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T90.4', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T90.5', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T90.8', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T90.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T91', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T91.0', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T91.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T91.2', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T91.3', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T91.4', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T91.5', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T91.8', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T91.9', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T92', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T92.0', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T92.1', '   ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T92.2', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T92.3', ' ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T92.4', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T92.5', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T92.6', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T92.8', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T92.9', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T93', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T93.0', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T93.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T93.2', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T93.3', ' ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T93.4', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T93.5', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T93.6', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T93.8', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T93.9', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T94', ' ,   ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T94.0', ' ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T94.1', ' ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T95', ' ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T95.0', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T95.1', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T95.2', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T95.3', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T95.4', '    ,        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T95.8', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T95.9', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T96', '   ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T97', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T98', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T98.0', '   ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T98.1', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T98.2', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('T98.3', '     ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V01', ',     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V01.0', ',         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V01.1', ',         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V01.9', ',        ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V02', ',     -     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V02.0', ',     -         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V02.1', ',     -         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V02.9', ',     -        ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V03', ',      ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V03.0', ',      -,  -        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V03.1', ',      -,          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V03.9', ',      -,  -       ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V04', ',         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V04.0', ',             '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V04.1', ',             '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V04.9', ',            ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V05', ',          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V05.0', ',              '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V05.1', ',              '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V05.9', ',             ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V06', ',        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V06.0', ',            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V06.1', ',            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V06.9', ',           ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V09', ',         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V09.0', ',      ,       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V09.1', ',       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V09.2', ',      ,       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V09.3', ',       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V09.9', ',       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V10', ',       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V10.0', '-,           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V10.1', '-,           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V10.2', ',   ,           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V10.3', ',           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V10.4', '-,           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V10.5', '-,           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V10.9', ',   ,           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V11', ',      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V11.0', '-          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V11.1', '-,          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V11.2', ',   ,          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V11.3', ',           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V11.4', '-,          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V11.5', '-,          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V11.9', ',   ,          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V12', ',     -     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V12.0', '-,         -     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V12.1', '-,         -     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V12.2', ',   ,         -     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V12.3', ',         -     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V12.4', '-,         -     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V12.5', '-,         -     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V12.9', ',   ,         -     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V13', ',      ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V13.0', '-,          ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V13.1', '-,          ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V13.2', ',   ,          ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V13.3', ',          ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V13.4', '-,          ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V13.5', '-,          ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V13.9', ',   ,          ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V14', ',         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V14.0', '-,             '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V14.1', '-,             '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V14.2', ',   ,             '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V14.3', ',             '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V14.4', '-,             '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V14.5', '-,             '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V14.9', ',   ,             '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V15', ',          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V15.0', '-,              '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V15.1', '-,              '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V15.2', ',   ,              '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V15.3', ',              '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V15.4', '-,              '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V15.5', '-,              '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V15.9', ',   ,              '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V16', ',        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V16.0', '-,            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V16.1', '-,            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V16.2', ',   ,            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V16.3', ',            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V16.4', '-,            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V16.5', '-,            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V16.9', ',   ,            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V17', ',        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V17.0', '-,            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V17.1', '-,            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V17.2', ',   ,            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V17.3', ',            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V17.4', '-,            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V17.5', '-,            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V17.9', ',   ,            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V18', ',        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V18.0', '-,       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V18.1', '-,       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V18.2', ',   ,       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V18.3', ',            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V18.4', '-,       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V18.5', '-,       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V18.9', ',   ,       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V19', ',         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V19.0', '-,               '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V19.1', ',               '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V19.2', ',   ,              '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V19.3', ' (),       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V19.4', '-,              '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V19.5', ',              '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V19.6', ',   ,              '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V19.8', ' (),        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V19.9', ' (),       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V20', ',       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V20.0', '-,           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V20.1', '-,           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V20.2', ',   ,           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V20.3', ',           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V20.4', '-,           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V20.5', '-,           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V20.9', ',   ,           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V21', ',     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V21.0', '-,         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V21.1', '-,         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V21.2', ',   ,         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V21.3', ',         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V21.4', '-,         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V21.5', '-,         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V21.9', ',   ,         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V22', ',     -     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V22.0', '-,         -     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V22.1', '-,         -     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V22.2', ',   ,         -     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V22.3', ',         -     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V22.4', '-,         -     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V22.5', '-,         -     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V22.9', ',   ,         -     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V23', ',      ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V23.0', '-,          ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V23.1', '-,          ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V23.2', ',   ,          ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V23.3', ',          ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V23.4', '-,          ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V23.5', '-,          ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V23.9', ',   ,          ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V24', ',         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V24.0', '-,             '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V24.1', '-,             '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V24.2', ',   ,             '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V24.3', ',             '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V24.4', '-,             '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V24.5', '-,             '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V24.9', ',   ,             '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V25', ',          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V25.0', '-,              '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V25.1', '-,              '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V25.2', ',   ,              '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V25.3', ',              '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V25.4', '-,              '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V25.5', '-,              '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V25.9', ',   ,              '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V26', ',        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V26.0', '-,            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V26.1', '-,            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V26.2', ',   ,            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V26.3', ',            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V26.4', '-,            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V26.5', '-,            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V26.9', ',   ,            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V27', ',        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V27.0', '-,            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V27.1', '-,            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V27.2', ',   ,            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V27.3', ',            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V27.4', '-,            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V27.5', '-,            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V27.9', ',   ,            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V28', ',        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V28.0', '-,       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V28.1', '-,       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V28.2', ',   ,       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V28.3', ',       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V28.4', '-,       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V28.5', '-,       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V28.9', ',   ,       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V29', ',         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V29.0', '-,          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V29.1', '-,          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V29.2', ',   ,          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V29.3', ',          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V29.4', '-,              '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V29.5', '-,              '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V29.6', ',   ,              '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V29.8', ' (),        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V29.9', '(),       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V30', ',               '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V30.0', ',                   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V30.1', ',                   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V30.2', ',                   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V30.3', ',   ,                   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V30.4', ',       () () () () ()         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V30.5', ',                   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V30.6', ',                   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V30.7', ',                   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V30.9', ',   ,                   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V31', ',             '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V31.0', ',                 '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V31.1', ',                 '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V31.2', ',                 '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V31.3', ',   ,                 '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V31.4', ',       () () () () (),     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V31.5', ',                 '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V31.6', ',                 '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V31.7', ',                 '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V31.9', ',   ,                 '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V32', ',              -     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V32.0', ',                      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V32.1', ',                      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V32.2', ',                      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V32.3', ',   ,              -         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V32.4', ',       () () () () ()      -     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V32.5', ',                      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V32.6', ',                      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V32.7', ',                      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V32.9', ',   ,              -     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V33', ',              ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V33.0', ',              ,          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V33.1', ',              ,          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V33.2', ',              ,          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V33.3', ',   ,     .        -,  -       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V33.4', ',       () () () () (),      ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V33.5', ',              -,  -        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V33.6', ',              -,  -        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V33.7', ',              -,  -        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V33.9', ',   ,              -,  -        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V34', ',                 '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V34.0', ',                     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V34.1', ',                     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V34.2', ',                     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V34.3', ',   ,                     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V34.4', ',       () () () () (),         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V34.5', ',                     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V34.6', ',                     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V34.7', ',                     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V34.9', ',   ,                     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V35', ',                  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V35.0', ',                      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V35.1', ',                      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V35.2', ',                      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V35.3', ',   ,                      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V35.4', ',       () () () () (),          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V35.5', ',                      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V35.6', ',                      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V35.7', ',                      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V35.9', ',   ,                      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V36', ',                '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V36.0', ',                    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V36.1', ',                    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V36.2', ',                    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V36.3', ',   ,                    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V36.4', ',       () () () () (),        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V36.5', ',                    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V36.6', ',                    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V36.7', ',                    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V36.9', ',   ,                    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V37', ',                '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V37.0', ',                    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V37.1', ',                    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V37.2', ',                    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V37.3', ',   ,                    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V37.4', ',       () () () () (),        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V37.5', ',                    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V37.6', ',                    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V37.7', ',                    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V37.9', ',   ,                    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V38', ',               '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V38.0', ',                '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V38.1', ',                '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V38.2', ',                '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V38.3', ',   ,                '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V38.4', ',       () () () () (),       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V38.5', ',                '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V38.6', ',                '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V38.7', ',                '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V38.9', ',   ,                '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V39', ',                '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V39.0', ',              '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V39.1', ',              '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V39.2', ',   ,                    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V39.3', ' (),             '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V39.4', ',              '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V39.5', ',              '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V39.6', ',   ,                     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V39.8', ' (),              '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V39.9', ' (),             '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V40', ',            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V40.0', ',                 '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V40.1', ',                 '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V40.2', ',                 '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V40.3', ',   ,                 '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V40.4', ',       () () ()         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V40.5', ',                 '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V40.6', ',                  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V40.7', ',                 '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V40.9', ',   ,                 '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V41', ',          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V41.0', ',               '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V41.1', ',               '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V41.2', ',               '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V41.3', ',   ,               '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V41.4', ',       () () (),     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V41.5', ',               '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V41.6', ',                 '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V41.7', ',               '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V41.9', ',   ,               '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V42', ',          -     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V42.0', ',            -         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V42.1', ',            -         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V42.2', ',            -         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V42.3', ',   ,                    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V42.4', ',       () () ()      -     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V42.5', ',            -         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V42.6', ',            -         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V42.7', ',            -         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V42.9', ',   ,                '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V43', ',           ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V43.0', ',            ,          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V43.1', ',            ,          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V43.2', ',            ,          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V43.3', ',   ,            -,  -       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V43.4', ',       () () (),      ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V43.5', ',            -,  -        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V43.6', ',            -,  -        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V43.7', ',            -,  -        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V43.9', ',   ,            -,  -        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V44', ',              '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V44.0', ',                   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V44.1', ',                   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V44.2', ',                   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V44.3', ',   ,                   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V44.4', ',       () () (),         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V44.5', ',                   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V44.6', ',                   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V44.7', ',                   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V44.9', ',   ,                   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V45', ',               '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V45.0', ',                    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V45.1', ',                    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V45.2', ',                    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V45.3', ',   ,                    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V45.4', ',       () () (),          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V45.5', ',                    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V45.6', ',                    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V45.7', ',                    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V45.9', ',   ,                    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V46', ',             '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V46.0', ',                  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V46.1', ',                  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V46.2', ',                  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V46.3', ',   ,                  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V46.4', ',       () () (),        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V46.5', ',                  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V46.6', ',                  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V46.7', ',                  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V46.9', ',   ,                  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V47', ',             '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V47.0', ',                  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V47.1', ',                  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V47.2', ',                  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V47.3', ',   ,                  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V47.4', ',       () () (),        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V47.5', ',                  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V47.6', ',                  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V47.7', ',                  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V47.9', ',   ,                  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V48', ',             '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V48.0', ',              '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V48.1', ',              '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V48.2', ',              '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V48.3', ',   ,              '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V48.4', ',       () () (),       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V48.5', ',              '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V48.6', ',              '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V48.7', ',              '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V48.9', ',   ,              '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V49', ',              '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V49.0', ',              '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V49.1', ',              '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V49.2', ',   ,                    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V49.3', ',     ()       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V49.4', ',              '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V49.5', ',              '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V49.6', ',   ,                    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V49.8', ',     ()        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V49.9', ',     ()       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V50', ',                 '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V50.0', ',                     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V50.1', ',                     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V50.2', ',                     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V50.3', ',   ,                     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V50.4', ',       () () ()             '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V50.5', ',                     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V50.6', ',                      '); @
COMMIT WORK; @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V50.7', ',                     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V50.9', ',   ,                     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V51', ',               '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V51.0', ',                   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V51.1', ',                   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V51.2', ',                   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V51.3', ',   ,                   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V51.4', ',       ()  () ()    (),     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V51.5', ',                   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V51.6', ',                   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V51.7', ',                   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V51.9', ',   ,                   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V52', ',               -    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V52.0', ',                       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V52.1', ',               -         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V52.2', ',               -         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V52.3', ',   ,               -         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V52.4', ',       () () ()    ()      -     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V52.5', ',                        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V52.6', ',                        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V52.7', ',                        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V52.9', ',   ,                -     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V53', ',                ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V53.0', ',                ,          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V53.1', ',                ,          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V53.2', ',                ,          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V53.3', ',   ,                -,  -       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V53.4', ',       () ()      (),      ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V53.5', ',                -,  -        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V53.6', ',                -,  -        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V53.7', ',                -,  -        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V53.9', ',   ,                -,  -        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V54', ',                   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V54.0', ',                       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V54.1', ',                       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V54.2', ',                        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V54.3', ',   ,                       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V54.4', ',       () () ()    (),         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V54.5', ',                       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V54.6', ',                       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V54.7', ',                       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V54.9', ',   ,                       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V55', ',                    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V55.0', ',                        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V55.1', ',                        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V55.2', ',                        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V55.3', ',   ,                        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V55.4', ',       () () ()    (),          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V55.5', ',                        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V55.6', ',                        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V55.7', ',                        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V55.9', ',   ,                        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V56', ',                  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V56.0', ',                      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V56.1', ',                      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V56.2', ',                      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V56.3', ',   ,                      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V56.4', ',       () () ()    (),       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V56.5', ',                      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V56.6', ',                      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V56.7', ',                      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V56.9', ',   ,                      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V57', ',                  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V57.0', ',                      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V57.1', ',                      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V57.2', ',                      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V57.3', ',   ,                      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V57.4', ',       () () ()    (),        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V57.5', ',                      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V57.6', ',                      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V57.7', ',                      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V57.9', ',   ,                      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V58', ',                 '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V58.0', ',                  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V58.1', ',                  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V58.2', ',                  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V58.3', ',   ,                  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V58.4', ',       () () ()    (),       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V58.5', ',                  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V58.6', ',                   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V58.7', ',                  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V58.9', ',   ,                  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V59', ',                  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V59.0', ',              '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V59.1', ',              '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V59.2', ',   ,                     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V59.3', ',      ()       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V59.4', ',              '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V59.5', ',              '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V59.6', ',   ,                     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V59.8', ' (),      ()         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V59.9', ' (),            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V60', ',              '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V60.0', ',                  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V60.1', ',                  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V60.2', ',                  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V60.3', ',   ,                  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V60.4', ',       () () () ()         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V60.5', ',                  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V60.6', ',                  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V60.7', ',                  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V60.9', ',   ,                  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V61', ',            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V61.0', ',                '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V61.1', ',                '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V61.2', ',                '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V61.3', ',   ,                '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V61.4', ',       () () () (),     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V61.5', ',                '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V61.6', ',                '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V61.7', ',                '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V61.9', ',   ,                '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V62', ',            -     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V62.0', ',                     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V62.1', ',                     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V62.2', ',                     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V62.3', ',   ,             -         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V62.4', ',       () () () ()      -     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V62.5', ',                    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V62.6', ',                     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V62.7', ',                      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V62.9', ',   ,            -     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V63', ',             ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V63.0', ',             ,          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V63.1', ',             ,          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V63.2', ',             ,          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V63.3', ',   ,             -,  -       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V63.4', ',       () () () (),      ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V63.5', ',             -,  -        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V63.6', ',             -,  -        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V63.7', ',             -,  -        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V63.9', ',   ,             -,  -        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V64', ',                '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V64.0', ',                    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V64.1', ',                    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V64.2', ',                    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V64.3', ',   ,                    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V64.4', ',       () () () (),         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V64.5', ',                    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V64.6', ',                    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V64.7', ',                    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V64.9', ',   ,                    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V65', ',                 '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V65.0', ',                     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V65.1', ',                     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V65.2', ',                     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V65.3', ',   ,                     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V65.4', ',       () () () ,          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V65.5', ',                     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V65.6', ',                     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V65.7', ',                     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V65.9', ',   ,                     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V66', ',               '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V66.0', ',                  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V66.1', ',                   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V66.2', ',                   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V66.3', ',   ,                   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V66.4', ',       () () () (),        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V66.5', ',                   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V66.6', ',                   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V66.7', ',                   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V66.9', ',   ,                   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V67', ',               '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V67.0', ',                   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V67.1', ',                   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V67.2', ',                   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V67.3', ',   ,                   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V67.4', ',       ()  () () (),        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V67.5', ',                   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V67.6', ',                   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V67.7', ',                   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V67.9', ',   ,                   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V68', ',              '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V68.0', ',               '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V68.1', ',               '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V68.2', ',               '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V68.3', ',   ,               '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V68.4', ',       ()   ,       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V68.5', ',               '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V68.6', ',               '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V68.7', ',               '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V68.9', ',   ,               '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V69', ',               '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V69.0', ',              '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V69.1', ',              '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V69.2', ',   ,     ,                '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V69.3', ' (),     ,       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V69.4', ',              '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V69.5', ',              '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V69.6', ',   ,     ,                '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V69.8', ' (),     ,        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V69.9', ',     ,       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V70', ',           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V70.0', ',                '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V70.1', ',                '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V70.2', ',                 '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V70.3', ',   ,                '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V70.4', ',       () ()         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V70.5', ',                '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V70.6', ',                '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V70.7', ',                '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V70.9', ',   ,                '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V71', ',          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V71.0', ',              '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V71.1', ',              '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V71.2', ',              '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V71.3', ',   ,              '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V71.4', ',       () (),     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V71.5', ',              '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V71.6', ',              '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V71.7', ',              '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V71.9', ',   ,              '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V72', ',          -     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V72.0', ',          -         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V72.1', ',           -         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V72.2', ',           -         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V72.3', ',   ,           -         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V72.4', ',       () (a)      -     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V72.5', ',           -         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V72.6', ',           -         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V72.7', ',           -         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V72.9', ',   ,          -     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V73', ',           ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V73.0', ',           ,          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V73.1', ',           ,          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V73.2', ',           ,          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V73.3', ',   ,           -,  -       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V73.4', ',       () (a),      ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V73.5', ',           -,  -        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V73.6', ',             -,  -        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V73.7', ',   a        -,  -        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V73.9', ',   ,           -,  -        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V74', ',              '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V74.0', ',                  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V74.1', ',                  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V74.2', ',   a               '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V74.3', ',   ,                 c '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V74.4', ',       () (a),         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V74.5', ',                  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V74.6', ',                  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V74.7', ',   a               '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V74.9', ',   ,                  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V75', ',               '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V75.0', ',                   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V75.1', ',                   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V75.2', ',   a                '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V75.3', ',   ,                   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V75.4', ',       () (a),          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V75.5', ',                   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V75.6', ',                   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V75.7', ',   a                '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V75.9', ',   ,                   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V76', ',             '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V76.0', ',                 '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V76.1', ',                 '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V76.2', ',   a              '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V76.3', ',   ,                 '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V76.4', ',       () (a),        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V76.5', ',                 '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V76.6', ',                 '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V76.7', ',   a              '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V76.9', ',   ,                 '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V77', ',             '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V77.0', ',                 '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V77.1', ',                 '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V77.2', ',   a              '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V77.3', ',   ,                 '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V77.4', ',       () (a),        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V77.5', ',                 '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V77.6', ',                 '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V77.7', ',   a              '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V77.9', ',   ,                 '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V78', ',            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V78.0', ',             '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V78.1', ',             '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V78.2', ',             '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V78.3', ',   ,             '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V78.4', ',       () (a),       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V78.5', ',             '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V78.6', ',             '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V78.7', ',   a          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V78.9', ',   ,             '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V79', ',             '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V79.0', ',              '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V79.1', ',              '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V79.2', ',   ,                   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V79.3', ' (),           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V79.4', ',              '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V79.5', ',              '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V79.6', ',   ,                   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V79.8', ' (),           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V79.9', ' (),          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V80', ',       ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V80.0', '  ,   ,                '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V80.1', '  ,   ,       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V80.2', '  ,   ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V80.3', '  ,   ,     -    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V80.4', '  ,   ,     , , ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V80.5', '  ,   ,        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V80.6', '  ,   ,         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V80.7', '  ,   ,        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V80.8', '  ,   ,        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V80.9', '  ,   ,        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V81', ',               '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V81.0', ',                   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V81.1', ',                   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V81.2', ',                    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V81.3', ',               '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V81.4', ',                  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V81.5', ',                  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V81.6', ',                  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V81.7', ',                 '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V81.8', ',               '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V81.9', ',              '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V82', ',          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V82.0', ',                '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V82.1', ',                '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V82.2', ',                '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V82.3', ',           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V82.4', ',       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V82.5', ',         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V82.6', ' ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V82.7', ',             '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V82.8', ',           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V82.9', ',          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V83', ',     ,       ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V83.0', '    ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V83.1', '    ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V83.2', ',      ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V83.3', ',   ,      ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V83.4', ',          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V83.5', '    ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V83.6', '    ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V83.7', ',      ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V83.9', '   ,     ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V84', ',     ,     ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V84.0', '  -  ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V84.1', '  -  ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V84.2', ',      ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V84.3', ',   ,      ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V84.4', ',          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V84.5', '    ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V84.6', '    ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V84.7', ',      ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V84.9', ',   ,      ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V85', ',      ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V85.0', '    ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V85.1', '    ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V85.2', ',      ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V85.3', ',   ,      ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V85.4', ',          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V85.5', '    ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V85.6', '    ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V85.7', ',      ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V85.9', ',      ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V86', ',         , ,  ,    ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V86.0', '      ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V86.1', '      ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V86.2', ',        ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V86.3', '   ,        ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V86.4', ',            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V86.5', '      ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V86.6', '      ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V86.7', ',        ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V86.9', ',   ,        ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V87', '    ,      .'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V87.0', ',    ()   -     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V87.1', ',    ()     -    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V87.2', ',    ()     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V87.3', ',    ()   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V87.4', ',    ()     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V87.5', ',    ()     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V87.6', ',    ()       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V87.7', ',    ()    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V87.8', ',      ()    ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V87.9', ',      ()   ( ) ( ),     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V88', '    ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V88.0', ',    ()        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V88.1', ',    ()         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V88.2', ',    ()      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V88.3', ',    ()    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V88.4', ',    ()      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V88.5', ',    ()     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V88.6', ',    ()         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V88.7', ',    ()    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V88.8', ',          ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V88.9', ',        ( ) ( ),     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V89', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V89.0', ',         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V89.1', ',          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V89.2', ',       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V89.3', ',          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V89.9', ',      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V90', '           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V90.0', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V90.1', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V90.2', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V90.3', '              '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V90.4', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V90.5', '           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V90.6', '           ( )'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V90.7', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V90.8', '             '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V90.9', '            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V91', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V91.0', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V91.1', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V91.2', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V91.3', '           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V91.4', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V91.5', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V91.6', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V91.7', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V91.8', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V91.9', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V92', '    ,     ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V92.0', '    ,    ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V92.1', '    ,    ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V92.2', '    ,    ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V92.3', '    ,        ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V92.4', '    ,    ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V92.5', '    ,     ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V92.6', '    ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V92.7', '    ,    ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V92.8', '    ,       ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V92.9', '    ,      ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V93', '      ,       ,        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V93.0', '     ,       ,        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V93.1', '     ,       ,        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V93.2', '     ,       ,        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V93.3', '         ,       ,        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V93.4', '     ,       ,        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V93.5', '      ,       ,        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V93.6', '      ( ),       ,        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V93.7', '    ,       ,        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V93.8', '        ,       ,        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V93.9', '       ,       ,        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V94', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V94.0', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V94.1', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V94.2', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V94.3', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V94.4', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V94.5', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V94.6', '       ( )'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V94.7', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V94.8', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V94.9', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V95', '        ,       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V95.0', '   ,    ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V95.1', '   -, -   ,    ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V95.2', '     ,    ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V95.3', '     ,    ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V95.4', '     ,    ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V95.8', '       ,    ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V95.9', '      ,    ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V96', '        ,       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V96.0', '    ,    ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V96.1', '   ,    ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V96.2', '    (   ),    ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V96.8', '      ,    ,    ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V96.9', '      ,    ,    ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V97', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V97.0', ',   - ,     -  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V97.1', ',         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V97.2', ',   -  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V97.3', ',   ,    - '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V97.8', '  ,   - ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V98', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('V99', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W00', '    ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W00.0', '    ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W00.1', '    ,         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W00.2', '    ,       ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W00.3', '    ,          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W00.4', '    ,        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W00.5', '    ,            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W00.6', '    ,           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W00.7', '    ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W00.8', '    ,        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W00.9', '    ,       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W01', '       ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W01.0', '       ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W01.1', '       ,         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W01.2', '       ,       ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W01.3', '       ,           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W01.4', '       ,        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W01.5', '       ,            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W01.6', '       ,            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W01.7', '       ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W01.8', '       ,        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W01.9', '       ,       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W02', '    , ,     ( )'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W02.0', '    , ,     ( ) '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W02.1', '    , ,     ( )     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W02.2', '    , ,     ( )   ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W02.3', '    , ,     ( )       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W02.4', '    , ,     ( )    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W02.5', '    , ,     ( )        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W02.6', '    , ,     ( )        '); @
COMMIT WORK; @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W02.7', '    , ,     ( )  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W02.8', '    , ,     ( )    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W02.9', '    , ,     ( )   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W03', '               '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W03.0', '                '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W03.1', '                    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W03.2', '                  ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W03.3', '                      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W03.4', '                   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W03.5', '                       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W03.6', '                       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W03.7', '                 '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W03.8', '                   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W03.9', '                  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W04', '               '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W04.0', '                '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W04.1', '                    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W04.2', '                  ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W04.3', '                      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W04.4', '                   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W04.5', '                       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W04.6', '                       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W04.7', '                 '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W04.8', '                   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W04.9', '                  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W05', ',    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W05.0', ',     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W05.1', ',         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W05.2', ',       ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W05.3', ',           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W05.4', ',        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W05.5', ',            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W05.6', ',            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W05.7', ',      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W05.8', ',        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W05.9', ',       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W06', ',   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W06.0', ',    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W06.1', ',        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W06.2', ',      ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W06.3', ',          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W06.4', ',       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W06.5', ',           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W06.6', ',           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W06.7', ',     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W06.8', ',       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W06.9', ',      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W07', ',   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W07.0', ',    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W07.1', ',        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W07.2', ',      ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W07.3', ',          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W07.4', ',       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W07.5', ',           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W07.6', ',           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W07.7', ',     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W07.8', ',       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W07.9', ',      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W08', ',    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W08.0', ',     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W08.1', ',         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W08.2', ',       ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W08.3', ',           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W08.4', ',        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W08.5', ',            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W08.6', ',            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W08.7', ',      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W08.8', ',        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W08.9', ',       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W09', ',     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W09.0', ',      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W09.1', ',          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W09.2', ',        ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W09.3', ',            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W09.4', ',         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W09.5', ',             '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W09.6', ',             '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W09.7', ',       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W09.8', ',         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W09.9', ',        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W10', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W10.0', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W10.1', '            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W10.2', '          ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W10.3', '              '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W10.4', '           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W10.5', '               '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W10.6', '               '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W10.7', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W10.8', '           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W10.9', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W11', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W11.0', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W11.1', '           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W11.2', '         ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W11.3', '             '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W11.4', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W11.5', '              '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W11.6', '              '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W11.7', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W11.8', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W11.9', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W12', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W12.0', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W12.1', '           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W12.2', '         ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W12.3', '             '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W12.4', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W12.5', '              '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W12.6', '              '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W12.7', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W12.8', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W12.9', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W13', ' ,    ()  ()'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W13.0', ' ,    ()  () '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W13.1', ' ,    ()  ()     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W13.2', ' ,    ()  ()   ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W13.3', ' ,    ()  ()       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W13.4', ' ,    ()  ()    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W13.5', ' ,    ()  ()        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W13.6', ' ,    ()  ()        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W13.7', ' ,    ()  ()  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W13.8', ' ,    ()  ()    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W13.9', ' ,    ()  ()   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W14', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W14.0', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W14.1', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W14.2', '     ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W14.3', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W14.4', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W14.5', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W14.6', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W14.7', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W14.8', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W14.9', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W15', '   ( )'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W15.0', '   ( ) '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W15.1', '   ( )     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W15.2', '   ( )   ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W15.3', '   ( )       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W15.4', '   ( )    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W15.5', '   ( )        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W15.6', '   ( )        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W15.7', '   ( )  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W15.8', '   ( )    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W15.9', '   ( )   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W16', '    ,   ,       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W16.0', '    ,   ,        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W16.1', '    ,   ,            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W16.2', '    ,   ,          ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W16.3', '    ,   ,              '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W16.4', '    ,   ,           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W16.5', '    ,   ,               '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W16.6', '    ,   ,               '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W16.7', '    ,   ,         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W16.8', '    ,   ,           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W16.9', '    ,   ,          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W17', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W17.0', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W17.1', '           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W17.2', '         ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W17.3', '             '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W17.4', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W17.5', '              '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W17.6', '              '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W17.7', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W17.8', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W17.9', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W18', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W18.0', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W18.1', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W18.2', '        ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W18.3', '            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W18.4', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W18.5', '             '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W18.6', '             '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W18.7', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W18.8', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W18.9', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W19', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W19.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W19.1', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W19.2', '    ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W19.3', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W19.4', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W19.5', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W19.6', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W19.7', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W19.8', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W19.9', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W20', ' ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W20.0', ' ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W20.1', ' ,         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W20.2', ' ,       ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W20.3', ' ,           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W20.4', ' ,        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W20.5', ' ,            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W20.6', ' ,            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W20.7', ' ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W20.8', ' ,        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W20.9', ' ,       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W21', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W21.0', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W21.1', '           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W21.2', '         ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W21.3', '             '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W21.4', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W21.5', '              '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W21.6', '              '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W21.7', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W21.8', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W21.9', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W22', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W22.0', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W22.1', '           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W22.2', '         ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W22.3', '             '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W22.4', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W22.5', '              '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W22.6', '              '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W22.7', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W22.8', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W22.9', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W23', ', ,        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W23.0', ', ,         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W23.1', ', ,             '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W23.2', ', ,           ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W23.3', ', ,               '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W23.4', ', ,            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W23.5', ', ,                '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W23.6', ', ,                '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W23.7', ', ,          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W23.8', ', ,            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W23.9', ', ,           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W24', '     ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W24.0', '     ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W24.1', '     ,          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W24.2', '     ,        ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W24.3', '     ,            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W24.4', '     ,         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W24.5', '     ,             '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W24.6', '     ,             '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W24.7', '     ,       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W24.8', '     ,         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W24.9', '     ,        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W25', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W25.0', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W25.1', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W25.2', '      ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W25.3', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W25.4', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W25.5', '           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W25.6', '           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W25.7', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W25.8', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W25.9', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W26', '  ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W26.0', '  ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W26.1', '  ,        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W26.2', '  ,      ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W26.3', '  ,          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W26.4', '  ,       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W26.5', '  ,           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W26.6', '  ,           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W26.7', '  ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W26.8', '  ,       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W26.9', '  ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W27', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W27.0', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W27.1', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W27.2', '       ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W27.3', '           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W27.4', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W27.5', '            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W27.6', '            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W27.7', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W27.8', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W27.9', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W28', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W28.0', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W28.1', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W28.2', '      ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W28.3', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W28.4', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W28.5', '           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W28.6', '           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W28.7', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W28.8', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W28.9', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W29', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W29.0', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W29.1', '             '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W29.2', '           ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W29.3', '               '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W29.4', '            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W29.5', '                '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W29.6', '                '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W29.7', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W29.8', '            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W29.9', '           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W30', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W30.0', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W30.1', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W30.2', '      ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W30.3', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W30.4', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W30.5', '           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W30.6', '           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W30.7', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W30.8', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W30.9', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W31', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W31.0', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W31.1', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W31.2', '        ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W31.3', '            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W31.4', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W31.5', '             '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W31.6', '             '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W31.7', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W31.8', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W31.9', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W32', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W32.0', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W32.1', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W32.2', '       ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W32.3', '           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W32.4', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W32.5', '            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W32.6', '            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W32.7', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W32.8', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W32.9', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W33', '  ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W33.0', '  ,       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W33.1', '  ,           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W33.2', '  ,         ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W33.3', '  ,             '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W33.4', '  ,          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W33.5', '  ,              '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W33.6', '  ,              '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W33.7', '  ,        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W33.8', '  ,          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W33.9', '  ,         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W34', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W34.0', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W34.1', '           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W34.2', '         ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W34.3', '             '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W34.4', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W34.5', '              '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W34.6', '              '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W34.7', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W34.8', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W34.9', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W35', ',   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W35.0', ',    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W35.1', ',        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W35.2', ',      ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W35.3', ',          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W35.4', ',       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W35.5', ',           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W35.6', ',           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W35.7', ',     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W35.8', ',       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W35.9', ',      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W36', ',   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W36.0', ',    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W36.1', ',        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W36.2', ',      ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W36.3', ',          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W36.4', ',       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W36.5', ',           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W36.6', ',           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W36.7', ',     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W36.8', ',       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W36.9', ',      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W37', '  ,   ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W37.0', '  ,   ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W37.1', '  ,   ,        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W37.2', '  ,   ,      ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W37.3', '  ,   ,          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W37.4', '  ,   ,       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W37.5', '  ,   ,           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W37.6', '  ,   ,           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W37.7', '  ,   ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W37.8', '  ,   ,       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W37.9', '  ,   ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W38', ',    ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W38.0', ',    ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W38.1', ',    ,        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W38.2', ',    ,      ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W38.3', ',    ,          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W38.4', ',    ,       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W38.5', ',    ,           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W38.6', ',    ,           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W38.7', ',    ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W38.8', ',    ,       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W38.9', ',    ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W39', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W39.0', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W39.1', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W39.2', '      ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W39.3', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W39.4', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W39.5', '           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W39.6', '           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W39.7', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W39.8', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W39.9', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W40', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W40.0', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W40.1', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W40.2', '     ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W40.3', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W40.4', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W40.5', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W40.6', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W40.7', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W40.8', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W40.9', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W41', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W41.0', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W41.1', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W41.2', '      ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W41.3', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W41.4', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W41.5', '           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W41.6', '           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W41.7', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W41.8', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W41.9', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W42', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W42.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W42.1', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W42.2', '    ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W42.3', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W42.4', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W42.5', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W42.6', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W42.7', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W42.8', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W42.9', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W43', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W43.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W43.1', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W43.2', '    ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W43.3', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W43.4', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W43.5', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W43.6', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W43.7', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W43.8', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W43.9', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W44', '      ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W44.0', '      ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W44.1', '      ,        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W44.2', '      ,      ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W44.3', '      ,          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W44.4', '      ,       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W44.5', '      ,           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W44.6', '      ,           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W44.7', '      ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W44.8', '      ,       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W44.9', '      ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W45', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W45.0', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W45.1', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W45.2', '       ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W45.3', '           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W45.4', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W45.5', '            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W45.6', '            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W45.7', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W45.8', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W45.9', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W46', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W49', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W49.0', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W49.1', '           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W49.2', '         ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W49.3', '             '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W49.4', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W49.5', '              '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W49.6', '              '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W49.7', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W49.8', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W49.9', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W50', ', , , ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W50.0', ', , , ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W50.1', ', , , ,         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W50.2', ', , , ,       ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W50.3', ', , , ,           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W50.4', ', , , ,        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W50.5', ', , , ,            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W50.6', ', , , ,            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W50.7', ', , , ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W50.8', ', , , ,        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W50.9', ', , , ,       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W51', '     '); @
COMMIT WORK; @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W51.0', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W51.1', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W51.2', '        ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W51.3', '            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W51.4', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W51.5', '             '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W51.6', '             '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W51.7', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W51.8', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W51.9', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W52', ',    ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W52.0', ',    ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W52.1', ',    ,          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W52.2', ',    ,        ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W52.3', ',    ,            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W52.4', ',    ,         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W52.5', ',    ,             '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W52.6', ',    ,             '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W52.7', ',    ,       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W52.8', ',    ,         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W52.9', ',    ,        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W53', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W53.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W53.1', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W53.2', '    ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W53.3', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W53.4', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W53.5', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W53.6', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W53.7', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W53.8', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W53.9', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W54', '  ,  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W54.0', '  ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W54.1', '  ,       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W54.2', '  ,     ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W54.3', '  ,         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W54.4', '  ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W54.5', '  ,          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W54.6', '  ,          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W54.7', '  ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W54.8', '  ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W54.9', '  ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W55', '  ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W55.0', '  ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W55.1', '  ,        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W55.2', '  ,      ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W55.3', '  ,          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W55.4', '  ,       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W55.5', '  ,           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W55.6', '  ,           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W55.7', '  ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W55.8', '  ,       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W55.9', '  ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W56', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W56.0', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W56.1', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W56.2', '      ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W56.3', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W56.4', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W56.5', '           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W56.6', '           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W56.7', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W56.8', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W56.9', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W57', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W57.0', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W57.1', '             '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W57.2', '           ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W57.3', '               '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W57.4', '            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W57.5', '                '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W57.6', '                '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W57.7', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W57.8', '            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W57.9', '           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W58', '  ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W58.0', '  ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W58.1', '  ,         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W58.2', '  ,       ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W58.3', '  ,           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W58.4', '  ,        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W58.5', '  ,            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W58.6', '  ,            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W58.7', '  ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W58.8', '  ,        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W58.9', '  ,       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W59', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W59.0', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W59.1', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W59.2', '       ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W59.3', '           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W59.4', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W59.5', '            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W59.6', '            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W59.7', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W59.8', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W59.9', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W60', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W60.0', '           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W60.1', '               '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W60.2', '             ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W60.3', '                 '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W60.4', '              '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W60.5', '                  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W60.6', '                  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W60.7', '            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W60.8', '              '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W60.9', '             '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W64', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W64.0', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W64.1', '           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W64.2', '         ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W64.3', '             '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W64.4', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W64.5', '              '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W64.6', '              '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W64.7', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W64.8', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W64.9', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W65', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W65.0', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W65.1', '             '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W65.2', '           ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W65.3', '               '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W65.4', '            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W65.5', '                '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W65.6', '                '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W65.7', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W65.8', '            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W65.9', '           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W66', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W66.0', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W66.1', '              '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W66.2', '            ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W66.3', '                '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W66.4', '             '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W66.5', '                 '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W66.6', '                 '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W66.7', '           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W66.8', '             '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W66.9', '            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W67', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W67.0', '           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W67.1', '               '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W67.2', '             ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W67.3', '                 '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W67.4', '              '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W67.5', '                  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W67.6', '                  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W67.7', '            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W67.8', '              '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W67.9', '             '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W68', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W68.0', '           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W68.1', '               '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W68.2', '             ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W68.3', '                 '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W68.4', '              '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W68.5', '                  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W68.6', '                  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W68.7', '            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W68.8', '              '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W68.9', '             '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W69', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W69.0', '           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W69.1', '               '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W69.2', '             ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W69.3', '                 '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W69.4', '              '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W69.5', '                  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W69.6', '                  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W69.7', '            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W69.8', '              '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W69.9', '             '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W70', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W70.0', '           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W70.1', '               '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W70.2', '             ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W70.3', '                 '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W70.4', '              '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W70.5', '                  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W70.6', '                  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W70.7', '            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W70.8', '              '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W70.9', '             '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W73', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W73.0', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W73.1', '            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W73.2', '          ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W73.3', '              '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W73.4', '           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W73.5', '               '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W73.6', '               '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W73.7', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W73.8', '           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W73.9', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W74', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W74.0', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W74.1', '           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W74.2', '         ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W74.3', '             '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W74.4', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W74.5', '              '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W74.6', '              '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W74.7', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W74.8', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W74.9', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W75', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W75.0', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W75.1', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W75.2', '        ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W75.3', '            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W75.4', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W75.5', '             '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W75.6', '             '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W75.7', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W75.8', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W75.9', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W76', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W76.0', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W76.1', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W76.2', '       ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W76.3', '           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W76.4', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W76.5', '            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W76.6', '            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W76.7', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W76.8', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W76.9', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W77', '      ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W77.0', '      ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W77.1', '      ,          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W77.2', '      ,        ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W77.3', '      ,            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W77.4', '      ,         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W77.5', '      ,             '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W77.6', '      ,             '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W77.7', '      ,       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W77.8', '      ,         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W77.9', '      ,        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W78', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W78.0', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W78.1', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W78.2', '     ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W78.3', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W78.4', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W78.5', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W78.6', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W78.7', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W78.8', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W78.9', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W79', '   ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W79.0', '   ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W79.1', '   ,          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W79.2', '   ,        ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W79.3', '   ,            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W79.4', '   ,         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W79.5', '   ,             '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W79.6', '   ,             '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W79.7', '   ,       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W79.8', '   ,         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W79.9', '   ,        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W80', '     ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W80.0', '     ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W80.1', '     ,          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W80.2', '     ,        ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W80.3', '     ,            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W80.4', '     ,         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W80.5', '     ,             '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W80.6', '     ,             '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W80.7', '     ,       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W80.8', '     ,         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W80.9', '     ,        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W81', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W81.0', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W81.1', '              '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W81.2', '            ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W81.3', '                '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W81.4', '             '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W81.5', '                 '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W81.6', '                 '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W81.7', '           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W81.8', '             '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W81.9', '            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W83', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W83.0', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W83.1', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W83.2', '      ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W83.3', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W83.4', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W83.5', '           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W83.6', '           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W83.7', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W83.8', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W83.9', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W84', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W84.0', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W84.1', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W84.2', '     ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W84.3', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W84.4', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W84.5', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W84.6', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W84.7', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W84.8', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W84.9', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W85', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W85.0', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W85.1', '           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W85.2', '         ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W85.3', '             '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W85.4', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W85.5', '              '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W85.6', '              '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W85.7', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W85.8', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W85.9', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W86', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W86.0', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W86.1', '              '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W86.2', '            ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W86.3', '                '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W86.4', '             '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W86.5', '                 '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W86.6', '                 '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W86.7', '           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W86.8', '             '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W86.9', '            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W87', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W87.0', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W87.1', '             '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W87.2', '           ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W87.3', '               '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W87.4', '            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W87.5', '                '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W87.6', '                '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W87.7', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W87.8', '            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W87.9', '           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W88', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W88.0', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W88.1', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W88.2', '     ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W88.3', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W88.4', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W88.5', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W88.6', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W88.7', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W88.8', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W88.9', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W89', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W89.0', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W89.1', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W89.2', '        ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W89.3', '            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W89.4', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W89.5', '             '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W89.6', '             '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W89.7', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W89.8', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W89.9', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W90', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W90.0', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W90.1', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W90.2', '      ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W90.3', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W90.4', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W90.5', '           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W90.6', '           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W90.7', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W90.8', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W90.9', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W91', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W91.0', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W91.1', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W91.2', '      ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W91.3', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W91.4', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W91.5', '           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W91.6', '           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W91.7', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W91.8', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W91.9', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W92', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W92.0', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W92.1', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W92.2', '        ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W92.3', '            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W92.4', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W92.5', '             '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W92.6', '             '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W92.7', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W92.8', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W92.9', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W93', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W93.0', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W93.1', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W93.2', '        ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W93.3', '            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W93.4', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W93.5', '             '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W93.6', '             '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W93.7', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W93.8', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W93.9', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W94', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W94.0', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W94.1', '              '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W94.2', '            ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W94.3', '                '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W94.4', '             '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W94.5', '                 '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W94.6', '                 '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W94.7', '           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W94.8', '             '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W94.9', '            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W99', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W99.0', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W99.1', '             '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W99.2', '           ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W99.3', '               '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W99.4', '            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W99.5', '                '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W99.6', '                '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W99.7', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W99.8', '            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('W99.9', '           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X00', '   ()    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X00.0', '   ()     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X00.1', '   ()         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X00.2', '   ()       ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X00.3', '   ()           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X00.4', '   ()        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X00.5', '   ()            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X00.6', '   ()            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X00.7', '   ()      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X00.8', '   ()        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X00.9', '   ()       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X01', '   ()    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X01.0', '   ()     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X01.1', '   ()         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X01.2', '   ()       ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X01.3', '   ()           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X01.4', '   ()        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X01.5', '   ()            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X01.6', '   ()            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X01.7', '   ()      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X01.8', '   ()        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X01.9', '   ()       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X02', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X02.0', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X02.1', '           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X02.2', '         ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X02.3', '             '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X02.4', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X02.5', '              '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X02.6', '              '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X02.7', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X02.8', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X02.9', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X03', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X03.0', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X03.1', '           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X03.2', '         ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X03.3', '             '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X03.4', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X03.5', '              '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X03.6', '              '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X03.7', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X03.8', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X03.9', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X04', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X04.0', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X04.1', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X04.2', '       ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X04.3', '           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X04.4', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X04.5', '            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X04.6', '            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X04.7', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X04.8', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X04.9', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X05', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X05.0', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X05.1', '             '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X05.2', '           ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X05.3', '               '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X05.4', '            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X05.5', '                '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X05.6', '                '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X05.7', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X05.8', '            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X05.9', '           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X06', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X06.0', '           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X06.1', '               '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X06.2', '             ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X06.3', '                 '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X06.4', '              '); @
COMMIT WORK; @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X06.5', '                  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X06.6', '                  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X06.7', '            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X06.8', '              '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X06.9', '             '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X08', '    ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X08.0', '    ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X08.1', '    ,        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X08.2', '    ,      ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X08.3', '    ,          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X08.4', '    ,       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X08.5', '    ,           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X08.6', '    ,           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X08.7', '    ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X08.8', '    ,       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X08.9', '    ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X09', '   ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X09.0', '   ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X09.1', '   ,        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X09.2', '   ,      ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X09.3', '   ,          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X09.4', '   ,       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X09.5', '   ,           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X09.6', '   ,           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X09.7', '   ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X09.8', '   ,       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X09.9', '   ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X10', '   ,  ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X10.0', '   ,  ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X10.1', '   ,  ,         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X10.2', '   ,  ,       ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X10.3', '   ,  ,           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X10.4', '   ,  ,        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X10.5', '   ,  ,            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X10.6', '   ,  ,            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X10.7', '   ,  ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X10.8', '   ,  ,        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X10.9', '   ,  ,       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X11', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X11.0', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X11.1', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X11.2', '        ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X11.3', '            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X11.4', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X11.5', '             '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X11.6', '             '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X11.7', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X11.8', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X11.9', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X12', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X12.0', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X12.1', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X12.2', '       ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X12.3', '           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X12.4', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X12.5', '            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X12.6', '            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X12.7', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X12.8', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X12.9', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X13', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X13.0', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X13.1', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X13.2', '        ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X13.3', '            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X13.4', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X13.5', '             '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X13.6', '             '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X13.7', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X13.8', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X13.9', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X14', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X14.0', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X14.1', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X14.2', '        ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X14.3', '            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X14.4', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X14.5', '             '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X14.6', '             '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X14.7', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X14.8', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X14.9', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X15', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X15.0', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X15.1', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X15.2', '       ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X15.3', '           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X15.4', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X15.5', '            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X15.6', '            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X15.7', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X15.8', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X15.9', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X16', '    ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X16.0', '    ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X16.1', '    ,         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X16.2', '    ,       ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X16.3', '    ,           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X16.4', '    ,        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X16.5', '    ,            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X16.6', '    ,            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X16.7', '    ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X16.8', '    ,        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X16.9', '    ,       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X17', '   ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X17.0', '   ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X17.1', '   ,        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X17.2', '   ,      ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X17.3', '   ,          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X17.4', '   ,       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X17.5', '   ,           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X17.6', '   ,           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X17.7', '   ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X17.8', '   ,       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X17.9', '   ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X18', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X18.0', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X18.1', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X18.2', '       ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X18.3', '           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X18.4', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X18.5', '            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X18.6', '            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X18.7', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X18.8', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X18.9', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X19', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X19.0', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X19.1', '             '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X19.2', '           ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X19.3', '               '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X19.4', '            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X19.5', '                '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X19.6', '                '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X19.7', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X19.8', '            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X19.9', '           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X20', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X20.0', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X20.1', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X20.2', '        ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X20.3', '            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X20.4', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X20.5', '             '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X20.6', '             '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X20.7', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X20.8', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X20.9', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X21', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X21.0', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X21.1', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X21.2', '      ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X21.3', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X21.4', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X21.5', '           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X21.6', '           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X21.7', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X21.8', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X21.9', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X22', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X22.0', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X22.1', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X22.2', '     ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X22.3', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X22.4', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X22.5', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X22.6', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X22.7', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X22.8', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X22.9', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X23', '  ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X23.0', '  ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X23.1', '  ,        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X23.2', '  ,      ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X23.3', '  ,          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X23.4', '  ,       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X23.5', '  ,           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X23.6', '  ,           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X23.7', '  ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X23.8', '  ,       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X23.9', '  ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X24', '      ()'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X24.0', '      () '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X24.1', '      ()     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X24.2', '      ()   ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X24.3', '      ()       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X24.4', '      ()    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X24.5', '      ()        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X24.6', '      ()        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X24.7', '      ()  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X24.8', '      ()    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X24.9', '      ()   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X25', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X25.0', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X25.1', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X25.2', '        ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X25.3', '            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X25.4', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X25.5', '             '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X25.6', '             '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X25.7', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X25.8', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X25.9', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X26', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X26.0', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X26.1', '           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X26.2', '         ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X26.3', '             '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X26.4', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X26.5', '              '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X26.6', '              '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X26.7', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X26.8', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X26.9', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X27', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X27.0', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X27.1', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X27.2', '        ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X27.3', '            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X27.4', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X27.5', '             '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X27.6', '             '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X27.7', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X27.8', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X27.9', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X28', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X28.0', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X28.1', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X28.2', '        ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X28.3', '            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X28.4', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X28.5', '             '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X28.6', '             '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X28.7', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X28.8', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X28.9', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X29', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X29.0', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X29.1', '           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X29.2', '         ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X29.3', '             '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X29.4', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X29.5', '              '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X29.6', '              '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X29.7', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X29.8', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X29.9', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X30', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X30.0', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X30.1', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X30.2', '       ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X30.3', '           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X30.4', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X30.5', '            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X30.6', '            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X30.7', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X30.8', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X30.9', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X31', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X31.0', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X31.1', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X31.2', '       ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X31.3', '           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X31.4', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X31.5', '            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X31.6', '            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X31.7', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X31.8', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X31.9', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X32', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X32.0', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X32.1', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X32.2', '     ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X32.3', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X32.4', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X32.5', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X32.6', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X32.7', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X32.8', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X32.9', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X33', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X33.0', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X33.1', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X33.2', '     ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X33.3', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X33.4', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X33.5', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X33.6', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X33.7', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X33.8', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X33.9', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X34', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X34.0', '    ,  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X34.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X34.2', '    ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X34.3', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X34.4', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X34.5', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X34.6', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X34.7', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X34.8', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X34.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X35', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X35.0', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X35.1', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X35.2', '     ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X35.3', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X35.4', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X35.5', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X35.6', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X35.7', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X35.8', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X35.9', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X36', '  ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X36.0', '  ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X36.1', '  ,          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X36.2', '  ,        ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X36.3', '  ,            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X36.4', '  ,         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X36.5', '  ,             '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X36.6', '  ,             '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X36.7', '  ,       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X36.8', '  ,         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X36.9', '  ,        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X37', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X37.0', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X37.1', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X37.2', '     ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X37.3', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X37.4', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X37.5', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X37.6', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X37.7', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X37.8', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X37.9', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X38', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X38.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X38.1', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X38.2', '    ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X38.3', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X38.4', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X38.5', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X38.6', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X38.7', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X38.8', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X38.9', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X39', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X39.0', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X39.1', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X39.2', '        ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X39.3', '            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X39.4', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X39.5', '             '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X39.6', '             '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X39.7', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X39.8', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X39.9', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X40', '     ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X40.0', '     ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X40.1', '     ,         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X40.2', '     ,       ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X40.3', '     ,           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X40.4', '     ,        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X40.5', '     ,            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X40.6', '     ,            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X40.7', '     ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X40.8', '     ,        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X40.9', '     ,       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X41', '    , , ,    ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X41.0', '    , , ,    ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X41.1', '    , , ,    ,          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X41.2', '    , , ,    ,        ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X41.3', '    , , ,    ,            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X41.4', '    , , ,    ,         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X41.5', '    , , ,    ,             '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X41.6', '    , , ,    ,             '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X41.7', '    , , ,    ,       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X41.8', '    , , ,    ,         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X41.9', '    , , ,    ,        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X42', '       (),     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X42.0', '       (),      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X42.1', '       (),          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X42.2', '       (),        ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X42.3', '       (),            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X42.4', '       (),         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X42.5', '       (),             '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X42.6', '       (),             '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X42.7', '       (),       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X42.8', '       (),         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X42.9', '       (),        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X43', '      ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X43.0', '      ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X43.1', '      ,          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X43.2', '      ,        ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X43.3', '      ,            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X43.4', '      ,         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X43.5', '      ,             '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X43.6', '      ,             '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X43.7', '      ,       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X43.8', '      ,         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X43.9', '      ,        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X44', '        ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X44.0', '        ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X44.1', '        ,         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X44.2', '        ,       ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X44.3', '        ,           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X44.4', '        ,        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X44.5', '        ,            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X44.6', '        ,            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X44.7', '        ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X44.8', '        ,        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X44.9', '        ,       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X45', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X45.0', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X45.1', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X45.2', '       ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X45.3', '           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X45.4', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X45.5', '            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X45.6', '            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X45.7', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X45.8', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X45.9', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X46', '           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X46.0', '            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X46.1', '                '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X46.2', '              ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X46.3', '                  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X46.4', '               '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X46.5', '                   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X46.6', '                   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X46.7', '             '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X46.8', '               '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X46.9', '              '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X47', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X47.0', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X47.1', '             '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X47.2', '           ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X47.3', '               '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X47.4', '            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X47.5', '                '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X47.6', '                '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X47.7', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X47.8', '            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X47.9', '           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X48', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X48.0', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X48.1', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X48.2', '       ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X48.3', '           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X48.4', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X48.5', '            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X48.6', '            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X48.7', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X48.8', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X48.9', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X49', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X49.0', '           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X49.1', '               '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X49.2', '             ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X49.3', '                 '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X49.4', '              '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X49.5', '                  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X49.6', '                  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X49.7', '            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X49.8', '              '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X49.9', '             '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X50', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X50.0', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X50.1', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X50.2', '        ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X50.3', '            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X50.4', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X50.5', '             '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X50.6', '             '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X50.7', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X50.8', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X50.9', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X51', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X51.0', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X51.1', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X51.2', '     ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X51.3', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X51.4', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X51.5', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X51.6', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X51.7', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X51.8', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X51.9', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X52', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X52.0', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X52.1', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X52.2', '       ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X52.3', '           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X52.4', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X52.5', '            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X52.6', '            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X52.7', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X52.8', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X52.9', '       '); @
COMMIT WORK; @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X53', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X53.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X53.1', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X53.2', '    ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X53.3', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X53.4', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X53.5', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X53.6', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X53.7', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X53.8', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X53.9', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X54', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X54.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X54.1', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X54.2', '    ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X54.3', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X54.4', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X54.5', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X54.6', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X54.7', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X54.8', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X54.9', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X57', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X57.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X57.1', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X57.2', '    ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X57.3', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X57.4', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X57.5', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X57.6', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X57.7', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X57.8', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X57.9', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X58', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X58.0', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X58.1', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X58.2', '      ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X58.3', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X58.4', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X58.5', '           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X58.6', '           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X58.7', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X58.8', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X58.9', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X59', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X59.0', '  ,  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X59.1', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X59.2', '     ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X59.3', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X59.4', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X59.5', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X59.6', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X59.7', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X59.8', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X59.9', '  ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X60', '     ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X60.0', '     ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X60.1', '     ,         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X60.2', '     ,       ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X60.3', '     ,           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X60.4', '     ,        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X60.5', '     ,            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X60.6', '     ,            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X60.7', '     ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X60.8', '     ,        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X60.9', '     ,       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X61', '    , , ,    ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X61.0', '    , , ,    ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X61.1', '    , , ,    ,          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X61.2', '    , , ,    ,        ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X61.3', '    , , ,    ,            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X61.4', '    , , ,    ,         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X61.5', '    , , ,    ,             '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X61.6', '    , , ,    ,             '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X61.7', '    , , ,    ,       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X61.8', '    , , ,    ,         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X61.9', '    , , ,    ,        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X62', '       (),     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X62.0', '       (),      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X62.1', '       (),          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X62.2', '       (),        ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X62.3', '       (),            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X62.4', '       (),         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X62.5', '       (),             '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X62.6', '       (),             '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X62.7', '       (),       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X62.8', '       (),         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X62.9', '       (),        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X63', '      ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X63.0', '      ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X63.1', '      ,          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X63.2', '      ,        ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X63.3', '      ,            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X63.4', '      ,         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X63.5', '      ,             '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X63.6', '      ,             '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X63.7', '      ,       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X63.8', '      ,         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X63.9', '      ,        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X64', '        ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X64.0', '        ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X64.1', '        ,         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X64.2', '        ,       ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X64.3', '        ,           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X64.4', '        ,        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X64.5', '        ,            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X64.6', '        ,            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X64.7', '        ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X64.8', '        ,        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X64.9', '        ,       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X65', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X65.0', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X65.1', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X65.2', '       ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X65.3', '           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X65.4', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X65.5', '            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X65.6', '            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X65.7', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X65.8', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X65.9', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X66', '           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X66.0', '            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X66.1', '                '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X66.2', '              ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X66.3', '                  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X66.4', '               '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X66.5', '                   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X66.6', '                   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X66.7', '             '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X66.8', '               '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X66.9', '              '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X67', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X67.0', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X67.1', '             '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X67.2', '           ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X67.3', '               '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X67.4', '            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X67.5', '                '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X67.6', '                '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X67.7', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X67.8', '            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X67.9', '           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X68', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X68.0', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X68.1', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X68.2', '       ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X68.3', '           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X68.4', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X68.5', '            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X68.6', '            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X68.7', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X68.8', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X68.9', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X69', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X69.0', '           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X69.1', '               '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X69.2', '             ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X69.3', '                 '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X69.4', '              '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X69.5', '                  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X69.6', '                  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X69.7', '            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X69.8', '              '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X69.9', '             '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X70', '   ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X70.0', '   ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X70.1', '   ,        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X70.2', '   ,      ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X70.3', '   ,          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X70.4', '   ,       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X70.5', '   ,           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X70.6', '   ,           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X70.7', '   ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X70.8', '   ,       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X70.9', '   ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X71', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X71.0', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X71.1', '            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X71.2', '          ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X71.3', '              '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X71.4', '           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X71.5', '               '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X71.6', '               '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X71.7', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X71.8', '           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X71.9', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X72', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X72.0', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X72.1', '            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X72.2', '          ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X72.3', '              '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X72.4', '           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X72.5', '               '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X72.6', '               '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X72.7', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X72.8', '           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X72.9', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X73', '     ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X73.0', '     ,       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X73.1', '     ,           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X73.2', '     ,         ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X73.3', '     ,             '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X73.4', '     ,          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X73.5', '     ,              '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X73.6', '     ,              '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X73.7', '     ,        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X73.8', '     ,          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X73.9', '     ,         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X74', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X74.0', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X74.1', '              '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X74.2', '            ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X74.3', '                '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X74.4', '             '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X74.5', '                 '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X74.6', '                 '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X74.7', '           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X74.8', '             '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X74.9', '            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X75', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X75.0', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X75.1', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X75.2', '        ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X75.3', '            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X75.4', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X75.5', '             '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X75.6', '             '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X75.7', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X75.8', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X75.9', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X76', '   ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X76.0', '   ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X76.1', '   ,        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X76.2', '   ,      ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X76.3', '   ,          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X76.4', '   ,       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X76.5', '   ,           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X76.6', '   ,           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X76.7', '   ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X76.8', '   ,       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X76.9', '   ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X77', '   ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X77.0', '   ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X77.1', '   ,          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X77.2', '   ,        ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X77.3', '   ,            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X77.4', '   ,         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X77.5', '   ,             '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X77.6', '   ,             '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X77.7', '   ,       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X77.8', '   ,         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X77.9', '   ,        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X78', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X78.0', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X78.1', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X78.2', '       ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X78.3', '           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X78.4', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X78.5', '            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X78.6', '            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X78.7', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X78.8', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X78.9', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X79', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X79.0', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X79.1', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X79.2', '       ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X79.3', '           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X79.4', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X79.5', '            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X79.6', '            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X79.7', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X79.8', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X79.9', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X80', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X80.0', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X80.1', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X80.2', '        ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X80.3', '            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X80.4', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X80.5', '             '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X80.6', '             '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X80.7', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X80.8', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X80.9', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X81', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X81.0', '           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X81.1', '               '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X81.2', '             ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X81.3', '                 '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X81.4', '              '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X81.5', '                  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X81.6', '                  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X81.7', '            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X81.8', '              '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X81.9', '             '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X82', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X82.0', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X82.1', '           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X82.2', '         ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X82.3', '             '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X82.4', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X82.5', '              '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X82.6', '              '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X82.7', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X82.8', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X82.9', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X83', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X83.0', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X83.1', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X83.2', '        ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X83.3', '            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X83.4', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X83.5', '             '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X83.6', '             '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X83.7', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X83.8', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X83.9', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X84', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X84.0', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X84.1', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X84.2', '       ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X84.3', '           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X84.4', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X84.5', '            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X84.6', '            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X84.7', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X84.8', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X84.9', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X85', '    ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X85.0', '    ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X85.1', '    ,         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X85.2', '    ,       ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X85.3', '    ,           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X85.4', '    ,        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X85.5', '    ,            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X85.6', '    ,            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X85.7', '    ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X85.8', '    ,        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X85.9', '    ,       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X86', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X86.0', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X86.1', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X86.2', '       ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X86.3', '           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X86.4', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X86.5', '            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X86.6', '            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X86.7', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X86.8', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X86.9', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X87', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X87.0', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X87.1', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X87.2', '      ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X87.3', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X87.4', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X87.5', '           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X87.6', '           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X87.7', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X87.8', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X87.9', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X88', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X88.0', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X88.1', '           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X88.2', '         ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X88.3', '             '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X88.4', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X88.5', '              '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X88.6', '              '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X88.7', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X88.8', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X88.9', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X89', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X89.0', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X89.1', '             '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X89.2', '           ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X89.3', '               '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X89.4', '            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X89.5', '                '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X89.6', '                '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X89.7', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X89.8', '            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X89.9', '           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X90', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X90.0', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X90.1', '            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X90.2', '          ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X90.3', '              '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X90.4', '           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X90.5', '               '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X90.6', '               '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X90.7', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X90.8', '           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X90.9', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X91', '  , , '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X91.0', '  , ,  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X91.1', '  , ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X91.2', '  , ,    ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X91.3', '  , ,        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X91.4', '  , ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X91.5', '  , ,         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X91.6', '  , ,         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X91.7', '  , ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X91.8', '  , ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X91.9', '  , ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X92', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X92.0', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X92.1', '           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X92.2', '         ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X92.3', '             '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X92.4', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X92.5', '              '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X92.6', '              '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X92.7', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X92.8', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X92.9', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X93', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X93.0', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X93.1', '           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X93.2', '         ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X93.3', '             '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X93.4', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X93.5', '              '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X93.6', '              '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X93.7', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X93.8', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X93.9', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X94', '    ,       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X94.0', '    ,        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X94.1', '    ,            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X94.2', '    ,          ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X94.3', '    ,              '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X94.4', '    ,           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X94.5', '    ,               '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X94.6', '    ,               '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X94.7', '    ,         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X94.8', '    ,           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X94.9', '    ,          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X95', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X95.0', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X95.1', '             '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X95.2', '           ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X95.3', '               '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X95.4', '            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X95.5', '                '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X95.6', '                '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X95.7', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X95.8', '            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X95.9', '           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X96', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X96.0', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X96.1', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X96.2', '       ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X96.3', '           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X96.4', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X96.5', '            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X96.6', '            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X96.7', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X96.8', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X96.9', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X97', '   ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X97.0', '   ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X97.1', '   ,        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X97.2', '   ,      ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X97.3', '   ,          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X97.4', '   ,       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X97.5', '   ,           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X97.6', '   ,           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X97.7', '   ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X97.8', '   ,       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X97.9', '   ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X98', '   ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X98.0', '   ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X98.1', '   ,          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X98.2', '   ,        ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X98.3', '   ,            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X98.4', '   ,         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X98.5', '   ,             '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X98.6', '   ,             '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X98.7', '   ,       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X98.8', '   ,         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X98.9', '   ,        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X99', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X99.0', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X99.1', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X99.2', '       ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X99.3', '           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X99.4', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X99.5', '            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X99.6', '            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X99.7', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X99.8', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('X99.9', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y00', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y00.0', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y00.1', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y00.2', '       ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y00.3', '           '); @
COMMIT WORK; @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y00.4', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y00.5', '            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y00.6', '            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y00.7', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y00.8', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y00.9', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y01', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y01.0', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y01.1', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y01.2', '       ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y01.3', '           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y01.4', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y01.5', '            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y01.6', '            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y01.7', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y01.8', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y01.9', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y02', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y02.0', '           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y02.1', '               '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y02.2', '             ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y02.3', '                 '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y02.4', '              '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y02.5', '                  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y02.6', '                  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y02.7', '            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y02.8', '              '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y02.9', '             '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y03', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y03.0', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y03.1', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y03.2', '        ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y03.3', '            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y03.4', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y03.5', '             '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y03.6', '             '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y03.7', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y03.8', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y03.9', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y04', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y04.0', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y04.1', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y04.2', '       ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y04.3', '           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y04.4', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y04.5', '            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y04.6', '            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y04.7', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y04.8', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y04.9', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y05', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y05.0', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y05.1', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y05.2', '        ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y05.3', '            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y05.4', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y05.5', '             '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y05.6', '             '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y05.7', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y05.8', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y05.9', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y06', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y06.0', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y06.1', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y06.2', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y06.8', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y06.9', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y07', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y07.0', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y07.1', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y07.2', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y07.3', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y07.8', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y07.9', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y08', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y08.0', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y08.1', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y08.2', '      ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y08.3', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y08.4', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y08.5', '           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y08.6', '           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y08.7', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y08.8', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y08.9', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y09', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y09.0', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y09.1', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y09.2', '     ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y09.3', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y09.4', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y09.5', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y09.6', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y09.7', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y09.8', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y09.9', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y10', '    ,    ,  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y10.0', '    ,    ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y10.1', '    ,    ,       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y10.2', '    ,    ,     ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y10.3', '    ,    ,         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y10.4', '    ,    ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y10.5', '    ,    ,          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y10.6', '    ,    ,          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y10.7', '    ,    ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y10.8', '    ,    ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y10.9', '    ,    ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y11', '   , , ,    ,     ,  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y11.0', '   , , ,    ,     ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y11.1', '   , , ,    ,     ,       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y11.2', '   , , ,    ,     ,     ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y11.3', '   , , ,    ,     ,         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y11.4', '   , , ,    ,     ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y11.5', '   , , ,    ,     ,          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y11.6', '   , , ,    ,     ,          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y11.7', '   , , ,    ,     ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y11.8', '   , , ,    ,     ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y11.9', '   , , ,    ,     ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y12', '      (),     ,  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y12.0', '      (),     ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y12.1', '      (),     ,       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y12.2', '      (),     ,     ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y12.3', '      (),     ,         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y12.4', '      (),     ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y12.5', '      (),     ,          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y12.6', '      (),     ,          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y12.7', '      (),     ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y12.8', '      (),     ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y12.9', '      (),     ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y13', '     ,     ,  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y13.0', '     ,     ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y13.1', '     ,     ,       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y13.2', '     ,     ,     ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y13.3', '     ,     ,         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y13.4', '     ,     ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y13.5', '     ,     ,          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y13.6', '     ,     ,          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y13.7', '     ,     ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y13.8', '     ,     ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y13.9', '     ,     ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y14', '       ,    ,  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y14.0', '       ,    ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y14.1', '       ,    ,       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y14.2', '       ,    ,     ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y14.3', '       ,    ,         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y14.4', '       ,    ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y14.5', '       ,    ,          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y14.6', '       ,    ,          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y14.7', '       ,    ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y14.8', '       ,    ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y14.9', '       ,    ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y15', '   ,  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y15.0', '   ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y15.1', '   ,       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y15.2', '   ,     ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y15.3', '   ,         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y15.4', '   ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y15.5', '   ,          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y15.6', '   ,          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y15.7', '   ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y15.8', '   ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y15.9', '   ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y16', '          ,  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y16.0', '          ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y16.1', '          ,       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y16.2', '          ,     ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y16.3', '          ,         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y16.4', '          ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y16.5', '          ,          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y16.6', '          ,          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y16.7', '          ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y16.8', '          ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y16.9', '          ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y17', '       ,  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y17.0', '       ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y17.1', '       ,       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y17.2', '       ,     ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y17.3', '       ,         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y17.4', '       ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y17.5', '       ,          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y17.6', '       ,          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y17.7', '       ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y17.8', '       ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y17.9', '       ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y18', '   ,  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y18.0', '   ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y18.1', '   ,       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y18.2', '   ,     ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y18.3', '   ,         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y18.4', '   ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y18.5', '   ,          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y18.6', '   ,          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y18.7', '   ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y18.8', '   ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y18.9', '   ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y19', '         ,  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y19.0', '         ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y19.1', '         ,       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y19.2', '         ,     ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y19.3', '         ,         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y19.4', '         ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y19.5', '         ,          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y19.6', '         ,          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y19.7', '         ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y19.8', '         ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y19.9', '         ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y20', ',   ,  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y20.0', ',   ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y20.1', ',   ,       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y20.2', ',   ,     ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y20.3', ',   ,         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y20.4', ',   ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y20.5', ',   ,          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y20.6', ',   ,          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y20.7', ',   ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y20.8', ',   ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y20.9', ',   ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y21', '    ,  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y21.0', '    ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y21.1', '    ,       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y21.2', '    ,     ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y21.3', '    ,         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y21.4', '    ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y21.5', '    ,          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y21.6', '    ,          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y21.7', '    ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y21.8', '    ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y21.9', '    ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y22', '       ,  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y22.0', '       ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y22.1', '       ,       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y22.2', '       ,     ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y22.3', '       ,         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y22.4', '       ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y22.5', '       ,          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y22.6', '       ,          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y22.7', '       ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y22.8', '       ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y22.9', '       ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y23', '     ,  ,    ,  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y23.0', '     ,  ,    ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y23.1', '     ,  ,    ,       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y23.2', '     ,  ,    ,     ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y23.3', '     ,  ,    ,         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y23.4', '     ,  ,    ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y23.5', '     ,  ,    ,          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y23.6', '     ,  ,    ,          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y23.7', '     ,  ,    ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y23.8', '     ,  ,    ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y23.9', '     ,  ,    ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y24', '         ,  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y24.0', '         ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y24.1', '         ,       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y24.2', '         ,     ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y24.3', '         ,         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y24.4', '         ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y24.5', '         ,          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y24.6', '         ,          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y24.7', '         ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y24.8', '         ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y24.9', '         ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y25', '   ,  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y25.0', '   ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y25.1', '   ,       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y25.2', '   ,     ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y25.3', '   ,         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y25.4', '   ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y25.5', '   ,          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y25.6', '   ,          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y25.7', '   ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y25.8', '   ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y25.9', '   ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y26', ' ,   ,  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y26.0', ' ,   ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y26.1', ' ,   ,       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y26.2', ' ,   ,     ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y26.3', ' ,   ,         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y26.4', ' ,   ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y26.5', ' ,   ,          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y26.6', ' ,   ,          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y26.7', ' ,   ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y26.8', ' ,   ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y26.9', ' ,   ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y27', '  ,     ,  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y27.0', '  ,     ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y27.1', '  ,     ,       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y27.2', '  ,     ,     ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y27.3', '  ,     ,         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y27.4', '  ,     ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y27.5', '  ,     ,          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y27.6', '  ,     ,          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y27.7', '  ,     ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y27.8', '  ,     ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y27.9', '  ,     ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y28', '   ,  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y28.0', '   ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y28.1', '   ,       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y28.2', '   ,     ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y28.3', '   ,         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y28.4', '   ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y28.5', '   ,          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y28.6', '   ,          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y28.7', '   ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y28.8', '   ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y28.9', '   ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y29', '   ,  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y29.0', '   ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y29.1', '   ,       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y29.2', '   ,     ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y29.3', '   ,         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y29.4', '   ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y29.5', '   ,          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y29.6', '   ,          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y29.7', '   ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y29.8', '   ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y29.9', '   ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y30', ',     ,  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y30.0', ',     ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y30.1', ',     ,       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y30.2', ',     ,     ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y30.3', ',     ,         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y30.4', ',     ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y30.5', ',     ,          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y30.6', ',     ,          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y30.7', ',     ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y30.8', ',     ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y30.9', ',     ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y31', ',          ,  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y31.0', ',          ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y31.1', ',          ,       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y31.2', ',          ,     ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y31.3', ',          ,         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y31.4', ',          ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y31.5', ',          ,          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y31.6', ',          ,          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y31.7', ',          ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y31.8', ',          ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y31.9', ',          ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y32', '   ,  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y32.0', '   ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y32.1', '   ,       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y32.2', '   ,     ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y32.3', '   ,         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y32.4', '   ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y32.5', '   ,          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y32.6', '   ,          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y32.7', '   ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y32.8', '   ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y32.9', '   ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y33', '  ,  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y33.0', '  ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y33.1', '  ,       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y33.2', '  ,     ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y33.3', '  ,         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y33.4', '  ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y33.5', '  ,          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y33.6', '  ,          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y33.7', '  ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y33.8', '  ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y33.9', '  ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y34', ' ,  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y34.0', ' ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y34.1', ' ,       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y34.2', ' ,     ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y34.3', ' ,         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y34.4', ' ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y34.5', ' ,          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y34.6', ' ,          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y34.7', ' ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y34.8', ' ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y34.9', ' ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y35', ',  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y35.0', '   ,  ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y35.1', '   ,  ,  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y35.2', '   ,  ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y35.3', '   ,  ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y35.4', '   ,  ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y35.5', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y35.6', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y35.7', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y36', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y36.0', '    ,   - '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y36.1', '    ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y36.2', ' ,       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y36.3', '    ,  ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y36.4', '    ,        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y36.5', ' ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y36.6', ' ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y36.7', ' ,         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y36.8', ',     ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y36.9', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y40', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y40.0', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y40.1', '   - '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y40.2', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y40.3', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y40.4', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y40.5', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y40.6', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y40.7', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y40.8', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y40.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y41', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y41.0', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y41.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y41.2', '   ,    ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y41.3', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y41.4', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y41.5', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y41.8', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y41.9', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y42', '      ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y42.0', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y42.1', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y42.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y42.3', '    () '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y42.4', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y42.5', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y42.6', ', , ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y42.7', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y42.8', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y42.9', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y43', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y43.0', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y43.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y43.2', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y43.3', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y43.4', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y43.5', ',    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y43.6', ',     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y43.8', '  ,   ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y43.9', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y44', ',     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y44.0', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y44.1', ' B12,         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y44.2', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y44.3', ' ,  K   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y44.4', '  (  )'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y44.5', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y44.6', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y44.7', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y44.9', '   ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y45', ',    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y45.0', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y45.1', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y45.2', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y45.3', '     (NSAID)'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y45.4', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y45.5', ' 4-'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y45.8', ' ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y45.9', ',     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y46', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y46.0', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y46.1', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y46.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y46.3', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y46.4', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y46.5', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y46.6', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y46.7', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y46.8', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y47', ',    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y47.0', ',     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y47.1', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y47.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y47.3', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y47.4', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y47.5', '    ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y47.8', ' ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y47.9', ',     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y48', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y48.0', ' ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y48.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y48.2', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y48.3', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y48.4', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y48.5', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y49', ' ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y49.0', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y49.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y49.2', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y49.3', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y49.4', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y49.5', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y49.6', ' ()'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y49.7', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y49.8', '  ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y49.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y50', ',    ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y50.0', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y50.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y50.2', ',     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y50.8', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y50.9', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y51', ',      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y51.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y51.1', '  ()'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y51.2', ',   ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y51.3', '  (  )   ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y51.4', ' - ,     '); @
COMMIT WORK; @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y51.5', ' - ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y51.6', ' -,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y51.7', ' -,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y51.8', ',  -   ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y51.9', '   ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y52', ',    - '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y52.0', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y52.1', ',   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y52.2', ' ,   ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y52.3', '  ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y52.4', ' ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y52.5', '  ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y52.6', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y52.7', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y52.8', '  ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y52.9', '   ,    - '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y53', ',     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y53.0', '  H2-'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y53.1', '   ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y53.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y53.3', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y53.4', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y53.5', ',  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y53.6', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y53.7', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y53.8', ' ,    - '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y53.9', ',     , '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y54', ',     ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y54.0', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y54.1', '  ( )'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y54.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y54.3', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y54.4', ' ""'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y54.5', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y54.6', ',         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y54.7', ',    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y54.8', ',     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y54.9', ' ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y55', ',          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y55.0', ',    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y55.1', '   (,  - )'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y55.2', '   ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y55.3', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y55.4', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y55.5', ' ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y55.6', ' ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y55.7', '   ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y56', '  ,       , ,   ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y56.0', ',      ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y56.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y56.2', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y56.3', ',     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y56.4', ',          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y56.5', '   ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y56.6', '       ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y56.7', ' ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y56.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y56.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y57', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y57.0', ',   ( )'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y57.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y57.2', '  ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y57.3', '    ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y57.4', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y57.5', ' ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y57.6', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y57.7', ',     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y57.8', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y57.9', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y58', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y58.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y58.1', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y58.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y58.3', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y58.4', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y58.5', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y58.6', ' ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y58.8', '  ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y58.9', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y59', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y59.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y59.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y59.2', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y59.3', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y59.8', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y59.9', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y60', ' , ,         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y60.0', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y60.1', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y60.2', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y60.3', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y60.4', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y60.5', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y60.6', '    ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y60.7', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y60.8', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y60.9', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y61', '           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y61.0', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y61.1', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y61.2', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y61.3', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y61.4', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y61.5', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y61.6', '    ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y61.7', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y61.8', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y61.9', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y62', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y62.0', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y62.1', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y62.2', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y62.3', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y62.4', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y62.5', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y62.6', '    ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y62.8', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y62.9', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y63', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y63.0', '      ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y63.1', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y63.2', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y63.3', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y63.4', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y63.5', ' (    )       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y63.6', '   ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y63.8', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y63.9', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y64', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y64.0', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y64.1', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y64.8', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y64.9', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y65', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y65.0', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y65.1', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y65.2', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y65.3', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y65.4', '  (  )   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y65.5', ' ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y65.8', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y66', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y69', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y70', '  ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y70.0', '      ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y70.1', ' ()       ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y70.2', '   ,      ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y70.3', ' ,    (  )  ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y70.8', '  ,        ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y71', '        - ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y71.0', '      - ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y71.1', ' ()           - ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y71.2', '   ,          - ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y71.3', ' ,    (  )      - ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y71.8', '  ,            - ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y72', '  ,    ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y72.0', '    ,    ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y72.1', ' ()     ,    ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y72.2', '   ,    ,    ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y72.3', ' ,    (  )'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y72.8', '  ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y73', '  ,      ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y73.0', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y73.1', ' ()     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y73.2', '   ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y73.3', ' ,    (  )'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y73.8', '  ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y74', '       ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y74.0', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y74.1', ' ()     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y74.2', '   ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y74.3', ' ,    (  )'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y74.8', '  ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y75', '  ,    ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y75.0', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y75.1', ' ()     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y75.2', '   ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y75.3', ' ,    (  )'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y75.8', '  ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y76', '  ,      ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y76.0', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y76.1', ' ()     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y76.2', '   ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y76.3', ' ,    (  )'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y76.8', '  ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y77', '  ,    ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y77.0', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y77.1', ' ()     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y77.2', '   ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y77.3', ' ,    (  )'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y77.8', '  ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y78', '   ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y78.0', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y78.1', ' ()     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y78.2', '   ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y78.3', ' ,    (  )'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y78.8', '  ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y79', '   ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y79.0', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y79.1', ' ()     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y79.2', '   ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y79.3', ' ,    (  )'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y79.8', '  ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y80', '   ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y80.0', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y80.1', ' ()     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y80.2', '   ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y80.3', ' ,    (  )'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y80.8', '  ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y81', '  ,      ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y81.0', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y81.1', ' ()     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y81.2', '   ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y81.3', ' ,    (  )'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y81.8', '  ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y82', '      ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y82.0', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y82.1', ' ()     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y82.2', '   ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y82.3', ' ,    (  )'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y82.8', '  ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y83', '                        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y83.0', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y83.1', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y83.2', '    ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y83.3', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y83.4', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y83.5', ' ()'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y83.6', '   () ()'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y83.8', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y83.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y84', '                     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y84.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y84.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y84.2', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y84.3', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y84.4', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y84.5', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y84.6', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y84.7', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y84.8', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y84.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y85', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y85.0', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y85.9', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y86', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y87', '  ,            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y87.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y87.1', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y87.2', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y88', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y88.0', '   ,    ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y88.1', '           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y88.2', '  ,          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y88.3', '                       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y89', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y89.0', '   ,  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y89.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y89.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y90', '  ,       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y90.0', '    ,  20 /100 '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y90.1', '    20-39 /100 '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y90.2', '    40-59 /100 '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y90.3', '    60-79 /100 '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y90.4', '    80-99 /100 '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y90.5', '    100-119 /100 '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y90.6', '    120-199 /100 '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y90.7', '    200-239 /100 '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y90.8', '    240 /100   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y90.9', '   ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y91', '  ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y91.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y91.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y91.2', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y91.3', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y91.9', ' ,  - '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y95', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y96', ',   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y97', ',     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Y98', ',    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z00', '    ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z00.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z00.01', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z00.1', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z00.2', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z00.3', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z00.4', '  ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z00.5', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z00.6', '           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z00.8', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z01', '     ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z01.0', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z01.1', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z01.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z01.3', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z01.4', '  () ()'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z01.5', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z01.6', ' ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z01.7', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z01.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z01.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z02', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z02.0', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z02.1', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z02.12', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z02.13', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z02.14', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z02.15', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z02.16', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z02.2', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z02.3', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z02.4', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z02.5', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z02.6', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z02.7', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z02.8', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z02.9', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z03', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z03.0', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z03.01', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z03.02', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z03.1', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z03.2', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z03.3', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z03.4', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z03.5', '      - '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z03.6', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z03.8', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z03.9', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z04', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z04.0', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z04.1', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z04.2', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z04.3', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z04.4', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z04.5', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z04.6', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z04.8', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z04.9', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z08', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z08.0', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z08.1', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z08.2', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z08.7', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z08.8', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z08.9', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z09', '    ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z09.0', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z09.1', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z09.2', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z09.3', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z09.4', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z09.7', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z09.8', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z09.9', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z10', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z10.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z10.01', '  ,  , , .'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z10.02', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z10.03', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z10.04', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z10.05', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z10.06', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z10.1', '    ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z10.10', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z10.2', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z10.3', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z10.8', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z10.81', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z10.82', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z10.83', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z10.84', '     ,  ""'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z11', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z11.0', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z11.1', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z11.2', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z11.3', '      ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z11.4', '          []'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z11.5', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z11.6', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z11.8', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z11.9', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z12', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z12.0', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z12.1', '       - '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z12.2', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z12.3', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z12.4', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z12.5', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z12.6', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z12.8', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z12.9', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z13', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z13.0', '          ,    ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z13.1', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z13.2', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z13.3', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z13.4', '           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z13.5', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z13.6', '       - '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z13.7', '       ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z13.8', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z13.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z20', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z20.0', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z20.1', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z20.2', '       ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z20.3', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z20.4', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z20.5', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z20.6', '         []'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z20.7', '      ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z20.8', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z20.9', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z21', '  ,     []'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z22', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z22.0', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z22.1', '   - '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z22.2', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z22.3', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z22.4', '   ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z22.5', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z22.6', '  T-   1'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z22.8', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z22.9', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z23', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z23.0', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z23.1', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z23.2', '    []'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z23.3', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z23.4', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z23.5', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z23.6', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z23.7', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z23.8', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z24', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z24.0', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z24.1', '    ,  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z24.2', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z24.3', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z24.4', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z24.5', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z24.6', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z25', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z25.0', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z25.1', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z25.8', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z26', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z26.0', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z26.8', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z26.9', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z27', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z27.0', '      -'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z27.1', '   -- []'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z27.2', '   --   -'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z27.3', '   --  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z27.4', '   - -'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z27.8', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z27.9', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z28', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z28.0', '   -  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z28.1', '   -         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z28.2', '   -       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z28.8', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z28.9', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z29', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z29.0', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z29.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z29.2', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z29.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z29.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z30', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z30.0', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z30.1', ' ()  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z30.2', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z30.3', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z30.4', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z30.5', '   ()  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z30.8', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z30.9', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z31', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z31.0', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z31.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z31.2', ' in vitro'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z31.3', ' ,  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z31.4', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z31.5', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z31.6', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z31.8', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z31.9', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z32', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z32.0', ' ()  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z32.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z33', ',  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z34', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z34.0', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z34.8', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z34.9', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z35', '   ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z35.0', '         '); @
COMMIT WORK; @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z35.1', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z35.2', '         ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z35.3', '           '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z35.4', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z35.5', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z35.6', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z35.7', '    ,       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z35.8', '     ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z35.9', '   ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z36', '        [ ]'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z36.0', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z36.1', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z36.2', '   ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z36.3', '            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z36.4', '             '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z36.5', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z36.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z36.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z37', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z37.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z37.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z37.2', ',  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z37.3', ',  ,  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z37.4', ',  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z37.5', '  ,  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z37.6', '  ,  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z37.7', '  ,  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z37.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z38', ' ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z38.0', ' ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z38.1', ' ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z38.2', ' ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z38.3', ',   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z38.4', ',   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z38.5', ',    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z38.6', '    ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z38.7', '    ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z38.8', '    ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z39', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z39.0', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z39.1', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z39.2', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z40', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z40.0', '     -,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z40.8', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z40.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z41', ',    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z41.0', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z41.1', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z41.2', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z41.3', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z41.8', ' ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z41.9', ',    , '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z42', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z42.0', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z42.1', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z42.2', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z42.3', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z42.4', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z42.8', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z42.9', '     , '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z43', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z43.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z43.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z43.2', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z43.3', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z43.4', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z43.5', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z43.6', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z43.7', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z43.8', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z43.9', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z44', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z44.0', '     () ()'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z44.1', '     () ()'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z44.2', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z44.3', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z44.8', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z44.9', '     , '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z45', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z45.0', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z45.1', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z45.2', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z45.3', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z45.8', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z45.9', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z46', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z46.0', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z46.1', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z46.2', '    ,       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z46.3', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z46.4', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z46.5', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z46.6', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z46.7', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z46.8', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z46.9', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z47', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z47.0', '    ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z47.8', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z47.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z48', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z48.0', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z48.8', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z48.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z49', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z49.0', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z49.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z49.2', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z50', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z50.0', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z50.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z50.2', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z50.3', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z50.4', ',     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z50.5', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z50.6', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z50.7', '    ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z50.8', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z50.9', ',   , '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z51', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z51.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z51.1', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z51.2', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z51.3', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z51.4', '    ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z51.5', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z51.6', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z51.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z51.9', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z52', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z52.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z52.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z52.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z52.3', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z52.4', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z52.5', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z52.6', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z52.7', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z52.8', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z52.9', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z53', '        ,  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z53.0', '   - '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z53.1', '   -      -  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z53.2', '   -       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z53.8', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z53.9', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z54', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z54.0', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z54.1', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z54.2', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z54.3', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z54.4', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z54.7', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z54.8', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z54.9', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z55', ',     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z55.0', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z55.1', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z55.2', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z55.3', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z55.4', '    ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z55.8', ' ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z55.9', ',     , '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z56', ',     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z56.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z56.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z56.2', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z56.3', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z56.4', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z56.5', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z56.6', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z56.7', '   ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z57', '  -'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z57.0', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z57.1', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z57.2', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z57.3', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z57.4', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z57.5', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z57.6', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z57.7', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z57.8', '   -'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z57.9', '   -'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z58', ',      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z58.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z58.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z58.2', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z58.3', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z58.4', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z58.5', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z58.6', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z58.7', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z58.8', ' ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z58.9', ',      , '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z59', ',       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z59.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z59.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z59.2', '  , , '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z59.3', ',         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z59.4', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z59.5', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z59.6', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z59.7', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z59.8', ' ,       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z59.9', ',       , '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z60', ',     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z60.0', ',       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z60.1', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z60.2', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z60.3', ',     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z60.4', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z60.5', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z60.8', ' ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z60.9', ',     , '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z61', ',    ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z61.0', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z61.1', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z61.2', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z61.3', ',     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z61.4', ',             (,     )'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z61.5', ',           (     )'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z61.6', ',         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z61.7', '  ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z61.8', '  ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z61.9', ' ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z62', ' ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z62.0', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z62.1', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z62.2', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z62.3', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z62.4', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z62.5', ' ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z62.6', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z62.8', '  ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z62.9', ',    , '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z63', ' ,    ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z63.0', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z63.1', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z63.2', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z63.3', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z63.4', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z63.5', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z63.6', '  ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z63.7', '    ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z63.8', '  ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z63.9', ',     , '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z64', ',     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z64.0', ',    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z64.1', ',   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z64.2', ' ()   ,    ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z64.3', ' ()      ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z64.4', '   ()'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z65', ',     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z65.0', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z65.1', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z65.2', ',     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z65.3', ',     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z65.4', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z65.5', '  ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z65.8', '  ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z65.9', ',     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z70', ',   ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z70.0', ',   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z70.1', ',      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z70.2', ',       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z70.3', ',   ,    ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z70.8', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z70.9', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z71', '            ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z71.0', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z71.1', '    ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z71.2', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z71.3', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z71.4', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z71.5', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z71.6', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z71.7', '       []'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z71.8', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z71.9', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z72', ',    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z72.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z72.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z72.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z72.3', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z72.4', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z72.5', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z72.6', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z72.8', ' ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z72.9', ',    , '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z73', ',       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z73.0', ''); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z73.1', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z73.2', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z73.3', ' ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z73.4', '  ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z73.5', ',    ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z73.6', ' ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z73.8', ' ,       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z73.9', ',       , '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z74', ',      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z74.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z74.1', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z74.2', '       ,    ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z74.3', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z74.8', ' ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z74.9', ',      , '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z75', ',        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z75.0', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z75.1', ',      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z75.2', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z75.3', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z75.4', '    ,  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z75.5', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z75.8', ' ,        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z75.9', ',        , '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z76', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z76.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z76.1', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z76.2', '            '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z76.3', ' ,  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z76.4', ' ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z76.5', '  ()'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z76.8', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z76.9', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z80', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z80.0', '     - '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z80.1', '     , , '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z80.2', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z80.3', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z80.4', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z80.5', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z80.6', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z80.7', '      ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z80.8', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z80.9', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z81', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z81.0', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z81.1', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z81.2', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z81.3', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z81.4', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z81.8', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z82', '         '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z82.0', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z82.1', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z82.2', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z82.3', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z82.4', '         - '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z82.5', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z82.6', '       -    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z82.7', '    ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z82.8', '         ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z83', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z83.0', '   ,     []'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z83.1', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z83.2', '              '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z83.3', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z83.4', '      ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z83.5', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z83.6', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z83.7', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z84', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z84.0', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z84.1', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z84.2', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z84.3', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z84.8', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z85', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z85.0', '     - '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z85.1', '     ,   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z85.2', '          '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z85.3', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z85.4', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z85.5', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z85.6', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z85.7', '     ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z85.8', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z85.9', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z86', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z86.0', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z86.1', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z86.2', '              '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z86.3', '     ,      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z86.4', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z86.5', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z86.6', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z86.7', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z87', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z87.0', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z87.1', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z87.2', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z87.3', '    -    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z87.4', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z87.5', '    ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z87.6', '    ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z87.7', '    ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z87.8', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z88', '      ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z88.0', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z88.1', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z88.2', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z88.3', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z88.4', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z88.5', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z88.6', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z88.7', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z88.8', '       ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z88.9', '       ,    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z89', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z89.0', '   (),   , '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z89.1', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z89.2', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z89.3', '     (  )'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z89.4', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z89.5', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z89.6', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z89.7', '     (  ,    )'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z89.8', '      (  )'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z89.9', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z90', '  ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z90.0', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z90.1', '    ( )'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z90.2', '   (  )'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z90.3', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z90.4', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z90.5', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z90.6', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z90.7', '    ()'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z90.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z91', '   -,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z91.0', '      ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z91.1', '        '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z91.2', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z91.3', '     -'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z91.4', '    ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z91.5', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z91.6', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z91.8', '     -,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z92', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z92.0', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z92.1', '    ()  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z92.2', '    ()   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z92.3', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z92.4', '    ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z92.5', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z92.6', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z92.8', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z92.9', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z93', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z93.0', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z93.1', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z93.2', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z93.3', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z93.4', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z93.5', ' '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z93.6', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z93.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z93.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z94', ' ()   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z94.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z94.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z94.2', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z94.3', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z94.4', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z94.5', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z94.6', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z94.7', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z94.8', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z94.9', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z95', '      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z95.0', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z95.1', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z95.2', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z95.3', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z95.4', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z95.5', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z95.8', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z95.9', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z96', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z96.0', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z96.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z96.2', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z96.3', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z96.4', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z96.5', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z96.6', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z96.7', '     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z96.8', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z96.9', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z97', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z97.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z97.1', '   () ()'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z97.2', '    () ()'); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z97.3', '    '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z97.4', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z97.5', ' ()  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z97.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z98', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z98.0', ',     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z98.1', ',   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z98.2', ',      '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z98.8', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z99', '      ,     '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z99.0', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z99.1', '  '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z99.2', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z99.3', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z99.4', '   '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z99.8', '       '); @
INSERT INTO MKB10 (DS_COD, DS_NAME)
           VALUES ('Z99.9', '       '); @

COMMIT WORK; @

DELETE FROM USL; @

INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1, '0', '1', '1', 21, NULL, '1', '0131009', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2, '0', '1', '1', 24, NULL, '1', '0131009', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3, '0', '1', '1', 27, NULL, '1', '0131009', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4, '0', '1', '1', 30, NULL, '1', '0131009', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5, '0', '1', '1', 33, NULL, '1', '0131009', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6, '0', '1', '1', 36, NULL, '1', '0131009', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7, '0', '1', '1', 39, NULL, '1', '0131009', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (8, '0', '1', '1', 42, NULL, '1', '0131009', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (9, '0', '1', '1', 45, NULL, '1', '0131009', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (10, '0', '1', '1', 48, NULL, '1', '0131009', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (11, '0', '1', '1', 51, NULL, '1', '0131009', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (12, '0', '1', '1', 54, NULL, '1', '0131009', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (13, '0', '1', '1', 57, NULL, '1', '0131009', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (14, '0', '1', '1', 60, NULL, '1', '0131009', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (15, '0', '1', '1', 63, NULL, '1', '0131009', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (16, '0', '1', '1', 66, NULL, '1', '0131009', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (17, '0', '1', '1', 69, NULL, '1', '0131009', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (18, '0', '1', '1', 72, NULL, '1', '0131009', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (19, '0', '1', '1', 75, NULL, '1', '0131009', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (20, '0', '1', '1', 78, NULL, '1', '0131009', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (21, '0', '1', '1', 81, NULL, '1', '0131009', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (22, '0', '1', '1', 84, NULL, '1', '0131009', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (23, '0', '1', '1', 87, NULL, '1', '0131009', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (24, '0', '1', '1', 90, NULL, '1', '0131009', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (25, '0', '1', '1', 93, NULL, '1', '0131009', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (26, '0', '1', '1', 96, NULL, '1', '0131009', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (27, '0', '1', '1', 99, NULL, '1', '0131009', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (28, '0', '1', '1', 21, NULL, '0', '0905026', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (29, '0', '1', '1', 24, NULL, '0', '0905026', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (30, '0', '1', '1', 27, NULL, '0', '0905026', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (31, '0', '1', '1', 30, NULL, '0', '0905026', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (32, '0', '1', '1', 33, NULL, '0', '0905026', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (33, '0', '1', '1', 36, NULL, '0', '0905026', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (34, '0', '1', '1', 42, NULL, '0', '0905026', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (35, '0', '1', '1', 48, NULL, '0', '0905026', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (36, '0', '1', '1', 54, NULL, '0', '0905026', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (37, '0', '1', '1', 60, NULL, '0', '0905026', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (38, '0', '1', '1', 66, NULL, '0', '0905026', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (39, '0', '1', '1', 72, NULL, '0', '0905026', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (40, '0', '1', '1', 78, NULL, '0', '0905026', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (41, '0', '1', '1', 84, NULL, '0', '0905026', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (42, '0', '1', '1', 90, NULL, '0', '0905026', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (43, '0', '1', '1', 96, NULL, '0', '0905026', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (44, '0', '1', '1', 21, NULL, '0', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (45, '0', '1', '1', 24, NULL, '0', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (46, '0', '1', '1', 27, NULL, '0', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (47, '0', '1', '1', 30, NULL, '0', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (48, '0', '1', '1', 33, NULL, '0', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (49, '0', '1', '1', 36, NULL, '0', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (50, '0', '1', '1', 42, NULL, '0', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (51, '0', '1', '1', 48, NULL, '0', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (52, '0', '1', '1', 54, NULL, '0', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (53, '0', '1', '1', 60, NULL, '0', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (54, '0', '1', '1', 66, NULL, '0', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (55, '0', '1', '1', 72, NULL, '0', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (56, '0', '1', '1', 78, NULL, '0', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (57, '0', '1', '1', 84, NULL, '0', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (58, '0', '1', '1', 90, NULL, '0', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (59, '0', '1', '1', 96, NULL, '0', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (60, '0', '1', '1', 36, NULL, '0', '0510001', ' ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (61, '0', '1', '1', 39, NULL, '0', '0510001', ' ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (62, '0', '1', '1', 42, NULL, '0', '0510001', ' ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (63, '0', '1', '1', 45, NULL, '0', '0510001', ' ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (64, '0', '1', '1', 48, NULL, '0', '0510001', ' ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (65, '0', '1', '1', 51, NULL, '0', '0510001', ' ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (66, '0', '1', '1', 54, NULL, '0', '0510001', ' ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (67, '0', '1', '1', 57, NULL, '0', '0510001', ' ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (68, '0', '1', '1', 60, NULL, '0', '0510001', ' ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (69, '0', '1', '1', 63, NULL, '0', '0510001', ' ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (70, '0', '1', '1', 66, NULL, '0', '0510001', ' ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (71, '0', '1', '1', 69, NULL, '0', '0510001', ' ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (72, '0', '1', '1', 72, NULL, '0', '0510001', ' ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (73, '0', '1', '1', 75, NULL, '0', '0510001', ' ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (74, '0', '1', '1', 78, NULL, '0', '0510001', ' ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (75, '0', '1', '1', 81, NULL, '0', '0510001', ' ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (76, '0', '1', '1', 84, NULL, '0', '0510001', ' ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (77, '0', '1', '1', 87, NULL, '0', '0510001', ' ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (78, '0', '1', '1', 90, NULL, '0', '0510001', ' ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (79, '0', '1', '1', 93, NULL, '0', '0510001', ' ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (80, '0', '1', '1', 96, NULL, '0', '0510001', ' ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (81, '0', '1', '1', 99, NULL, '0', '0510001', ' ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (82, '0', '1', '1', 36, NULL, '0', '0510007', ',     ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (83, '0', '1', '1', 39, NULL, '0', '0510007', ',     ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (84, '0', '1', '1', 42, NULL, '0', '0510007', ',     ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (85, '0', '1', '1', 45, NULL, '0', '0510007', ',     ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (86, '0', '1', '1', 48, NULL, '0', '0510007', ',     ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (87, '0', '1', '1', 51, NULL, '0', '0510007', ',     ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (88, '0', '1', '1', 54, NULL, '0', '0510007', ',     ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (89, '0', '1', '1', 57, NULL, '0', '0510007', ',     ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (90, '0', '1', '1', 60, NULL, '0', '0510007', ',     ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (91, '0', '1', '1', 63, NULL, '0', '0510007', ',     ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (92, '0', '1', '1', 66, NULL, '0', '0510007', ',     ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (93, '0', '1', '1', 69, NULL, '0', '0510007', ',     ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (94, '0', '1', '1', 72, NULL, '0', '0510007', ',     ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (95, '0', '1', '1', 75, NULL, '0', '0510007', ',     ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (96, '0', '1', '1', 78, NULL, '0', '0510007', ',     ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (97, '0', '1', '1', 81, NULL, '0', '0510007', ',     ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (98, '0', '1', '1', 84, NULL, '0', '0510007', ',     ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (99, '0', '1', '1', 87, NULL, '0', '0510007', ',     ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (100, '0', '1', '1', 90, NULL, '0', '0510007', ',     ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (101, '0', '1', '1', 93, NULL, '0', '0510007', ',     ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (102, '0', '1', '1', 96, NULL, '0', '0510007', ',     ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (103, '0', '1', '1', 99, NULL, '0', '0510007', ',     ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (104, '0', '1', '1', 21, NULL, '0', '0609007', ' ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (105, '0', '1', '1', 24, NULL, '0', '0609007', ' ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (106, '0', '1', '1', 27, NULL, '0', '0609007', ' ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (107, '0', '1', '1', 30, NULL, '0', '0609007', ' ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (108, '0', '1', '1', 33, NULL, '0', '0609007', ' ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (109, '0', '1', '1', 36, NULL, '0', '0609007', ' ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (110, '0', '1', '1', 39, NULL, '0', '0609007', ' ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (111, '0', '1', '1', 42, NULL, '0', '0609007', ' ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (112, '0', '1', '1', 45, NULL, '0', '0609007', ' ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (113, '0', '1', '1', 48, NULL, '0', '0609007', ' ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (114, '0', '1', '1', 51, NULL, '0', '0609007', ' ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (115, '0', '1', '1', 54, NULL, '0', '0609007', ' ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (116, '0', '1', '1', 57, NULL, '0', '0609007', ' ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (117, '0', '1', '1', 60, NULL, '0', '0609007', ' ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (118, '0', '1', '1', 63, NULL, '0', '0609007', ' ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (119, '0', '1', '1', 66, NULL, '0', '0609007', ' ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (120, '0', '1', '1', 69, NULL, '0', '0609007', ' ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (121, '0', '1', '1', 72, NULL, '0', '0609007', ' ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (122, '0', '1', '1', 75, NULL, '0', '0609007', ' ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (123, '0', '1', '1', 78, NULL, '0', '0609007', ' ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (124, '0', '1', '1', 81, NULL, '0', '0609007', ' ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (125, '0', '1', '1', 84, NULL, '0', '0609007', ' ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (126, '0', '1', '1', 87, NULL, '0', '0609007', ' ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (127, '0', '1', '1', 90, NULL, '0', '0609007', ' ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (128, '0', '1', '1', 93, NULL, '0', '0609007', ' ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (129, '0', '1', '1', 96, NULL, '0', '0609007', ' ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (130, '0', '1', '1', 99, NULL, '0', '0609007', ' ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (131, '0', '1', '1', 21, NULL, '0', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (132, '0', '1', '1', 24, NULL, '0', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (133, '0', '1', '1', 27, NULL, '0', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (134, '0', '1', '1', 30, NULL, '0', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (135, '0', '1', '1', 33, NULL, '0', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (136, '0', '1', '1', 36, NULL, '0', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (137, '0', '1', '1', 42, NULL, '0', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (138, '0', '1', '1', 48, NULL, '0', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (139, '0', '1', '1', 54, NULL, '0', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (140, '0', '1', '1', 60, NULL, '0', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (141, '0', '1', '1', 66, NULL, '0', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (142, '0', '1', '1', 72, NULL, '0', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (143, '0', '1', '1', 78, NULL, '0', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (144, '0', '1', '1', 84, NULL, '0', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (145, '0', '1', '1', 90, NULL, '0', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (146, '0', '1', '1', 96, NULL, '0', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (147, '0', '1', '1', 21, NULL, '0', '0805004', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (148, '0', '1', '1', 24, NULL, '0', '0805004', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (149, '0', '1', '1', 27, NULL, '0', '0805004', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (150, '0', '1', '1', 30, NULL, '0', '0805004', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (151, '0', '1', '1', 33, NULL, '0', '0805004', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (152, '0', '1', '1', 36, NULL, '0', '0805004', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (153, '0', '1', '1', 42, NULL, '0', '0805004', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (154, '0', '1', '1', 48, NULL, '0', '0805004', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (155, '0', '1', '1', 54, NULL, '0', '0805004', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (156, '0', '1', '1', 60, NULL, '0', '0805004', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (157, '0', '1', '1', 66, NULL, '0', '0805004', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (158, '0', '1', '1', 72, NULL, '0', '0805004', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (159, '0', '1', '1', 78, NULL, '0', '0805004', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (160, '0', '1', '1', 84, NULL, '0', '0805004', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (161, '0', '1', '1', 90, NULL, '0', '0805004', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (162, '0', '1', '1', 96, NULL, '0', '0805004', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (163, '0', '1', '1', 21, NULL, '0', '0905003', '     ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (164, '0', '1', '1', 24, NULL, '0', '0905003', '     ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (165, '0', '1', '1', 27, NULL, '0', '0905003', '     ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (166, '0', '1', '1', 30, NULL, '0', '0905003', '     ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (167, '0', '1', '1', 33, NULL, '0', '0905003', '     ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (168, '0', '1', '1', 36, NULL, '0', '0905003', '     ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (169, '0', '1', '1', 42, NULL, '0', '0905003', '     ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (170, '0', '1', '1', 48, NULL, '0', '0905003', '     ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (171, '0', '1', '1', 54, NULL, '0', '0905003', '     ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (172, '0', '1', '1', 60, NULL, '0', '0905003', '     ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (173, '0', '1', '1', 66, NULL, '0', '0905003', '     ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (174, '0', '1', '1', 72, NULL, '0', '0905003', '     ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (175, '0', '1', '1', 78, NULL, '0', '0905003', '     ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (176, '0', '1', '1', 84, NULL, '0', '0905003', '     ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (177, '0', '1', '1', 90, NULL, '0', '0905003', '     ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (178, '0', '1', '1', 96, NULL, '0', '0905003', '     ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (179, '0', '1', '1', 21, NULL, '0', '1205001', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (180, '0', '1', '1', 24, NULL, '0', '1205001', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (181, '0', '1', '1', 27, NULL, '0', '1205001', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (182, '0', '1', '1', 30, NULL, '0', '1205001', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (183, '0', '1', '1', 33, NULL, '0', '1205001', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (184, '0', '1', '1', 36, NULL, '0', '1205001', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (185, '0', '1', '1', 42, NULL, '0', '1205001', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (186, '0', '1', '1', 48, NULL, '0', '1205001', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (187, '0', '1', '1', 54, NULL, '0', '1205001', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (188, '0', '1', '1', 60, NULL, '0', '1205001', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (189, '0', '1', '1', 66, NULL, '0', '1205001', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (190, '0', '1', '1', 72, NULL, '0', '1205001', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (191, '0', '1', '1', 78, NULL, '0', '1205001', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (192, '0', '1', '1', 84, NULL, '0', '1205001', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (193, '0', '1', '1', 90, NULL, '0', '1205001', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (194, '0', '1', '1', 96, NULL, '0', '1205001', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (195, '0', '1', '1', 39, NULL, '0', '0301603', ' ()   ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (196, '0', '1', '1', 45, NULL, '0', '0301603', ' ()   ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (197, '0', '1', '1', 51, NULL, '0', '0301603', ' ()   ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (198, '0', '1', '1', 57, NULL, '0', '0301603', ' ()   ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (199, '0', '1', '1', 63, NULL, '0', '0301603', ' ()   ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (200, '0', '1', '1', 69, NULL, '0', '0301603', ' ()   ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (201, '0', '1', '1', 75, NULL, '0', '0301603', ' ()   ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (202, '0', '1', '1', 81, NULL, '0', '0301603', ' ()   ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (203, '0', '1', '1', 87, NULL, '0', '0301603', ' ()   ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (204, '0', '1', '1', 93, NULL, '0', '0301603', ' ()   ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (205, '0', '1', '1', 99, NULL, '0', '0301603', ' ()   ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (206, '0', '1', '1', 39, NULL, '0', '0301604', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (207, '0', '1', '1', 45, NULL, '0', '0301604', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (208, '0', '1', '1', 51, NULL, '0', '0301604', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (209, '0', '1', '1', 57, NULL, '0', '0301604', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (210, '0', '1', '1', 63, NULL, '0', '0301604', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (211, '0', '1', '1', 69, NULL, '0', '0301604', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (212, '0', '1', '1', 75, NULL, '0', '0301604', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (213, '0', '1', '1', 81, NULL, '0', '0301604', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (214, '0', '1', '1', 87, NULL, '0', '0301604', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (215, '0', '1', '1', 93, NULL, '0', '0301604', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (216, '0', '1', '1', 99, NULL, '0', '0301604', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (217, '0', '1', '1', 21, NULL, '0', '0301606', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (218, '0', '1', '1', 24, NULL, '0', '0301606', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (219, '0', '1', '1', 27, NULL, '0', '0301606', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (220, '0', '1', '1', 30, NULL, '0', '0301606', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (221, '0', '1', '1', 33, NULL, '0', '0301606', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (222, '0', '1', '1', 36, NULL, '0', '0301606', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (223, '0', '1', '1', 39, NULL, '0', '0301606', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (224, '0', '1', '1', 42, NULL, '0', '0301606', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (225, '0', '1', '1', 45, NULL, '0', '0301606', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (226, '0', '1', '1', 48, NULL, '0', '0301606', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (227, '0', '1', '1', 51, NULL, '0', '0301606', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (228, '0', '1', '1', 54, NULL, '0', '0301606', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (229, '0', '1', '1', 57, NULL, '0', '0301606', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (230, '0', '1', '1', 60, NULL, '0', '0301606', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (231, '0', '1', '1', 63, NULL, '0', '0301606', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (232, '0', '1', '1', 66, NULL, '0', '0301606', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (233, '0', '1', '1', 69, NULL, '0', '0301606', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (234, '0', '1', '1', 72, NULL, '0', '0301606', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (235, '0', '1', '1', 75, NULL, '0', '0301606', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (236, '0', '1', '1', 78, NULL, '0', '0301606', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (237, '0', '1', '1', 81, NULL, '0', '0301606', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (238, '0', '1', '1', 84, NULL, '0', '0301606', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (239, '0', '1', '1', 87, NULL, '0', '0301606', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (240, '0', '1', '1', 90, NULL, '0', '0301606', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (241, '0', '1', '1', 93, NULL, '0', '0301606', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (242, '0', '1', '1', 96, NULL, '0', '0301606', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (243, '0', '1', '1', 99, NULL, '0', '0301606', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (244, '0', '1', '1', 45, NULL, '0', '0919002', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (245, '0', '1', '1', 48, NULL, '0', '0919002', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (246, '0', '1', '1', 51, NULL, '0', '0919002', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (247, '0', '1', '1', 54, NULL, '0', '0919002', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (248, '0', '1', '1', 57, NULL, '0', '0919002', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (249, '0', '1', '1', 60, NULL, '0', '0919002', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (250, '0', '1', '1', 63, NULL, '0', '0919002', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (251, '0', '1', '1', 66, NULL, '0', '0919002', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (252, '0', '1', '1', 69, NULL, '0', '0919002', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (253, '0', '1', '1', 72, NULL, '0', '0919002', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (254, '0', '1', '1', 75, NULL, '0', '0919002', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (255, '0', '1', '1', 78, NULL, '0', '0919002', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (256, '0', '1', '1', 81, NULL, '0', '0919002', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (257, '0', '1', '1', 84, NULL, '0', '0919002', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (258, '0', '1', '1', 87, NULL, '0', '0919002', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (259, '0', '1', '1', 90, NULL, '0', '0919002', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (260, '0', '1', '1', 93, NULL, '0', '0919002', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (261, '0', '1', '1', 96, NULL, '0', '0919002', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (262, '0', '1', '1', 99, NULL, '0', '0919002', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (263, '0', '1', '1', 51, NULL, '0', '0905135', '     ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (264, '0', '1', '1', 54, NULL, '0', '0905135', '     ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (265, '0', '1', '1', 57, NULL, '0', '0905135', '     ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (266, '0', '1', '1', 60, NULL, '0', '0905135', '     ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (267, '0', '1', '1', 63, NULL, '0', '0905135', '     ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (268, '0', '1', '1', 66, NULL, '0', '0905135', '     ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (269, '0', '1', '1', 69, NULL, '0', '0905135', '     ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (270, '0', '1', '1', 72, NULL, '0', '0905135', '     ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (271, '0', '1', '1', 75, NULL, '0', '0905135', '     ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (272, '0', '1', '1', 78, NULL, '0', '0905135', '     ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (273, '0', '1', '1', 81, NULL, '0', '0905135', '     ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (274, '0', '1', '1', 84, NULL, '0', '0905135', '     ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (275, '0', '1', '1', 87, NULL, '0', '0905135', '     ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (276, '0', '1', '1', 90, NULL, '0', '0905135', '     ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (277, '0', '1', '1', 93, NULL, '0', '0905135', '     ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (278, '0', '1', '1', 96, NULL, '0', '0905135', '     ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (279, '0', '1', '1', 99, NULL, '0', '0905135', '     ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (280, '0', '1', '1', 39, NULL, '0', '0414001', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (281, '0', '1', '1', 45, NULL, '0', '0414001', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (282, '0', '1', '1', 51, NULL, '0', '0414001', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (283, '0', '1', '1', 57, NULL, '0', '0414001', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (284, '0', '1', '1', 63, NULL, '0', '0414001', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (285, '0', '1', '1', 69, NULL, '0', '0414001', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (286, '0', '1', '1', 75, NULL, '0', '0414001', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (287, '0', '1', '1', 81, NULL, '0', '0414001', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (288, '0', '1', '1', 87, NULL, '0', '0414001', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (289, '0', '1', '1', 93, NULL, '0', '0414001', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (290, '0', '1', '1', 99, NULL, '0', '0414001', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (291, '0', '1', '1', 39, NULL, '0', '0414002', '   ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (292, '0', '1', '1', 45, NULL, '0', '0414002', '   ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (293, '0', '1', '1', 51, NULL, '0', '0414002', '   ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (294, '0', '1', '1', 57, NULL, '0', '0414002', '   ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (295, '0', '1', '1', 63, NULL, '0', '0414002', '   ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (296, '0', '1', '1', 69, NULL, '0', '0414002', '   ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (297, '0', '1', '1', 75, NULL, '0', '0414002', '   ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (298, '0', '1', '1', 81, NULL, '0', '0414002', '   ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (299, '0', '1', '1', 87, NULL, '0', '0414002', '   ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (300, '0', '1', '1', 93, NULL, '0', '0414002', '   ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (301, '0', '1', '1', 99, NULL, '0', '0414002', '   ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (302, '0', '1', '1', 39, NULL, '0', '0415001', '   ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (303, '0', '1', '1', 45, NULL, '0', '0415001', '   ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (304, '0', '1', '1', 51, NULL, '0', '0415001', '   ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (305, '0', '1', '1', 57, NULL, '0', '0415001', '   ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (306, '0', '1', '1', 63, NULL, '0', '0415001', '   ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (307, '0', '1', '1', 69, NULL, '0', '0415001', '   ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (308, '0', '1', '1', 75, NULL, '0', '0415001', '   ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (309, '0', '1', '1', 81, NULL, '0', '0415001', '   ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (310, '0', '1', '1', 87, NULL, '0', '0415001', '   ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (311, '0', '1', '1', 93, NULL, '0', '0415001', '   ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (312, '0', '1', '1', 99, NULL, '0', '0415001', '   ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (313, '0', '1', '1', 39, NULL, '0', '0428001', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (314, '0', '1', '1', 45, NULL, '0', '0428001', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (315, '0', '1', '1', 51, NULL, '0', '0428001', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (316, '0', '1', '1', 57, NULL, '0', '0428001', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (317, '0', '1', '1', 63, NULL, '0', '0428001', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (318, '0', '1', '1', 69, NULL, '0', '0428001', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (319, '0', '1', '1', 75, NULL, '0', '0428001', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (320, '0', '1', '1', 81, NULL, '0', '0428001', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (321, '0', '1', '1', 87, NULL, '0', '0428001', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (322, '0', '1', '1', 93, NULL, '0', '0428001', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (323, '0', '1', '1', 99, NULL, '0', '0428001', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (324, '0', '1', '1', 39, NULL, '0', '0226015', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (325, '0', '1', '1', 42, NULL, '0', '0226015', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (326, '0', '1', '1', 45, NULL, '0', '0226015', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (327, '0', '1', '1', 48, NULL, '0', '0226015', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (328, '0', '1', '1', 51, NULL, '0', '0226015', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (329, '0', '1', '1', 54, NULL, '0', '0226015', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (330, '0', '1', '1', 57, NULL, '0', '0226015', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (331, '0', '1', '1', 60, NULL, '0', '0226015', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (332, '0', '1', '1', 63, NULL, '0', '0226015', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (333, '0', '1', '1', 66, NULL, '0', '0226015', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (334, '0', '1', '1', 69, NULL, '0', '0226015', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (335, '0', '1', '1', 72, NULL, '0', '0226015', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (336, '0', '1', '1', 75, NULL, '0', '0226015', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (337, '0', '1', '1', 78, NULL, '0', '0226015', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (338, '0', '1', '1', 81, NULL, '0', '0226015', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (339, '0', '1', '1', 84, NULL, '0', '0226015', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (340, '0', '1', '1', 87, NULL, '0', '0226015', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (341, '0', '1', '1', 90, NULL, '0', '0226015', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (342, '0', '1', '1', 93, NULL, '0', '0226015', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (343, '0', '1', '1', 96, NULL, '0', '0226015', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (344, '0', '1', '1', 99, NULL, '0', '0226015', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (345, '0', '1', '1', 51, NULL, '0', '0402302', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (346, '0', '1', '1', 57, NULL, '0', '0402302', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (347, '0', '1', '1', 63, NULL, '0', '0402302', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (348, '0', '1', '1', 69, NULL, '0', '0402302', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (349, '0', '1', '1', 75, NULL, '0', '0402302', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (350, '0', '1', '1', 81, NULL, '0', '0402302', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (351, '0', '1', '1', 87, NULL, '0', '0402302', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (352, '0', '1', '1', 93, NULL, '0', '0402302', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (353, '0', '1', '1', 99, NULL, '0', '0402302', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (354, '0', '1', '1', 21, NULL, '1', '0404702', '  (, ) -', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (355, '0', '1', '1', 24, NULL, '1', '0404702', '  (, ) -', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (356, '0', '1', '1', 27, NULL, '1', '0404702', '  (, ) -', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (357, '0', '1', '1', 30, NULL, '1', '0404702', '  (, ) -', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (358, '0', '1', '1', 33, NULL, '1', '0404702', '  (, ) -', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (359, '0', '1', '1', 36, NULL, '1', '0404702', '  (, ) -', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (360, '0', '1', '1', 39, NULL, '1', '0404702', '  (, ) -', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (361, '0', '1', '1', 42, NULL, '1', '0404702', '  (, ) -', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (362, '0', '1', '1', 45, NULL, '1', '0404702', '  (, ) -', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (363, '0', '1', '1', 48, NULL, '1', '0404702', '  (, ) -', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (364, '0', '1', '1', 51, NULL, '1', '0404702', '  (, ) -', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (365, '0', '1', '1', 54, NULL, '1', '0404702', '  (, ) -', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (366, '0', '1', '1', 57, NULL, '1', '0404702', '  (, ) -', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (367, '0', '1', '1', 60, NULL, '1', '0404702', '  (, ) -', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (368, '0', '1', '1', 63, NULL, '1', '0404702', '  (, ) -', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (369, '0', '1', '1', 66, NULL, '1', '0404702', '  (, ) -', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (370, '0', '1', '1', 69, NULL, '1', '0404702', '  (, ) -', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (371, '0', '1', '1', 72, NULL, '1', '0404702', '  (, ) -', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (372, '0', '1', '1', 75, NULL, '1', '0404702', '  (, ) -', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (373, '0', '1', '1', 78, NULL, '1', '0404702', '  (, ) -', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (374, '0', '1', '1', 81, NULL, '1', '0404702', '  (, ) -', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (375, '0', '1', '1', 84, NULL, '1', '0404702', '  (, ) -', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (376, '0', '1', '1', 87, NULL, '1', '0404702', '  (, ) -', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (377, '0', '1', '1', 90, NULL, '1', '0404702', '  (, ) -', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (378, '0', '1', '1', 93, NULL, '1', '0404702', '  (, ) -', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (379, '0', '1', '1', 96, NULL, '1', '0404702', '  (, ) -', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (380, '0', '1', '1', 99, NULL, '1', '0404702', '  (, ) -', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (381, '0', '1', '2', 21, NULL, '1', '0131009', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (382, '0', '1', '2', 24, NULL, '1', '0131009', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (383, '0', '1', '2', 27, NULL, '1', '0131009', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (384, '0', '1', '2', 30, NULL, '1', '0131009', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (385, '0', '1', '2', 33, NULL, '1', '0131009', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (386, '0', '1', '2', 36, NULL, '1', '0131009', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (387, '0', '1', '2', 39, NULL, '1', '0131009', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (388, '0', '1', '2', 42, NULL, '1', '0131009', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (389, '0', '1', '2', 45, NULL, '1', '0131009', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (390, '0', '1', '2', 48, NULL, '1', '0131009', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (391, '0', '1', '2', 51, NULL, '1', '0131009', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (392, '0', '1', '2', 54, NULL, '1', '0131009', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (393, '0', '1', '2', 57, NULL, '1', '0131009', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (394, '0', '1', '2', 60, NULL, '1', '0131009', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (395, '0', '1', '2', 63, NULL, '1', '0131009', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (396, '0', '1', '2', 66, NULL, '1', '0131009', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (397, '0', '1', '2', 69, NULL, '1', '0131009', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (398, '0', '1', '2', 72, NULL, '1', '0131009', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (399, '0', '1', '2', 75, NULL, '1', '0131009', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (400, '0', '1', '2', 78, NULL, '1', '0131009', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (401, '0', '1', '2', 81, NULL, '1', '0131009', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (402, '0', '1', '2', 84, NULL, '1', '0131009', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (403, '0', '1', '2', 87, NULL, '1', '0131009', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (404, '0', '1', '2', 90, NULL, '1', '0131009', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (405, '0', '1', '2', 93, NULL, '1', '0131009', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (406, '0', '1', '2', 96, NULL, '1', '0131009', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (407, '0', '1', '2', 99, NULL, '1', '0131009', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (408, '0', '1', '2', 21, NULL, '0', '0905026', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (409, '0', '1', '2', 24, NULL, '0', '0905026', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (410, '0', '1', '2', 27, NULL, '0', '0905026', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (411, '0', '1', '2', 30, NULL, '0', '0905026', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (412, '0', '1', '2', 33, NULL, '0', '0905026', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (413, '0', '1', '2', 36, NULL, '0', '0905026', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (414, '0', '1', '2', 42, NULL, '0', '0905026', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (415, '0', '1', '2', 48, NULL, '0', '0905026', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (416, '0', '1', '2', 54, NULL, '0', '0905026', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (417, '0', '1', '2', 60, NULL, '0', '0905026', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (418, '0', '1', '2', 66, NULL, '0', '0905026', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (419, '0', '1', '2', 72, NULL, '0', '0905026', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (420, '0', '1', '2', 78, NULL, '0', '0905026', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (421, '0', '1', '2', 84, NULL, '0', '0905026', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (422, '0', '1', '2', 90, NULL, '0', '0905026', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (423, '0', '1', '2', 96, NULL, '0', '0905026', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (424, '0', '1', '2', 21, NULL, '0', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (425, '0', '1', '2', 24, NULL, '0', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (426, '0', '1', '2', 27, NULL, '0', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (427, '0', '1', '2', 30, NULL, '0', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (428, '0', '1', '2', 33, NULL, '0', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (429, '0', '1', '2', 36, NULL, '0', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (430, '0', '1', '2', 42, NULL, '0', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (431, '0', '1', '2', 48, NULL, '0', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (432, '0', '1', '2', 54, NULL, '0', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (433, '0', '1', '2', 60, NULL, '0', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (434, '0', '1', '2', 66, NULL, '0', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (435, '0', '1', '2', 72, NULL, '0', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (436, '0', '1', '2', 78, NULL, '0', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (437, '0', '1', '2', 84, NULL, '0', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (438, '0', '1', '2', 90, NULL, '0', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (439, '0', '1', '2', 96, NULL, '0', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (440, '0', '1', '2', 45, NULL, '0', '0510001', ' ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (441, '0', '1', '2', 48, NULL, '0', '0510001', ' ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (442, '0', '1', '2', 51, NULL, '0', '0510001', ' ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (443, '0', '1', '2', 54, NULL, '0', '0510001', ' ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (444, '0', '1', '2', 57, NULL, '0', '0510001', ' ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (445, '0', '1', '2', 60, NULL, '0', '0510001', ' ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (446, '0', '1', '2', 63, NULL, '0', '0510001', ' ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (447, '0', '1', '2', 66, NULL, '0', '0510001', ' ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (448, '0', '1', '2', 69, NULL, '0', '0510001', ' ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (449, '0', '1', '2', 72, NULL, '0', '0510001', ' ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (450, '0', '1', '2', 75, NULL, '0', '0510001', ' ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (451, '0', '1', '2', 78, NULL, '0', '0510001', ' ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (452, '0', '1', '2', 81, NULL, '0', '0510001', ' ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (453, '0', '1', '2', 84, NULL, '0', '0510001', ' ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (454, '0', '1', '2', 87, NULL, '0', '0510001', ' ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (455, '0', '1', '2', 90, NULL, '0', '0510001', ' ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (456, '0', '1', '2', 93, NULL, '0', '0510001', ' ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (457, '0', '1', '2', 96, NULL, '0', '0510001', ' ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (458, '0', '1', '2', 99, NULL, '0', '0510001', ' ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (459, '0', '1', '2', 45, NULL, '0', '0510007', ',     ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (460, '0', '1', '2', 48, NULL, '0', '0510007', ',     ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (461, '0', '1', '2', 51, NULL, '0', '0510007', ',     ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (462, '0', '1', '2', 54, NULL, '0', '0510007', ',     ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (463, '0', '1', '2', 57, NULL, '0', '0510007', ',     ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (464, '0', '1', '2', 60, NULL, '0', '0510007', ',     ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (465, '0', '1', '2', 63, NULL, '0', '0510007', ',     ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (466, '0', '1', '2', 66, NULL, '0', '0510007', ',     ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (467, '0', '1', '2', 69, NULL, '0', '0510007', ',     ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (468, '0', '1', '2', 72, NULL, '0', '0510007', ',     ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (469, '0', '1', '2', 75, NULL, '0', '0510007', ',     ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (470, '0', '1', '2', 78, NULL, '0', '0510007', ',     ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (471, '0', '1', '2', 81, NULL, '0', '0510007', ',     ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (472, '0', '1', '2', 84, NULL, '0', '0510007', ',     ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (473, '0', '1', '2', 87, NULL, '0', '0510007', ',     ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (474, '0', '1', '2', 90, NULL, '0', '0510007', ',     ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (475, '0', '1', '2', 93, NULL, '0', '0510007', ',     ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (476, '0', '1', '2', 96, NULL, '0', '0510007', ',     ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (477, '0', '1', '2', 99, NULL, '0', '0510007', ',     ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (478, '0', '1', '2', 21, NULL, '0', '0400102', ' /          ( )', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (479, '0', '1', '2', 24, NULL, '0', '0400102', ' /          ( )', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (480, '0', '1', '2', 27, NULL, '0', '0400102', ' /          ( )', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (481, '0', '1', '2', 30, NULL, '0', '0400102', ' /          ( )', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (482, '0', '1', '2', 33, NULL, '0', '0400102', ' /          ( )', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (483, '0', '1', '2', 36, NULL, '0', '0400102', ' /          ( )', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (484, '0', '1', '2', 39, NULL, '0', '0400102', ' /          ( )', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (485, '0', '1', '2', 42, NULL, '0', '0400102', ' /          ( )', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (486, '0', '1', '2', 45, NULL, '0', '0400102', ' /          ( )', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (487, '0', '1', '2', 48, NULL, '0', '0400102', ' /          ( )', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (488, '0', '1', '2', 51, NULL, '0', '0400102', ' /          ( )', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (489, '0', '1', '2', 54, NULL, '0', '0400102', ' /          ( )', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (490, '0', '1', '2', 57, NULL, '0', '0400102', ' /          ( )', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (491, '0', '1', '2', 60, NULL, '0', '0400102', ' /          ( )', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (492, '0', '1', '2', 63, NULL, '0', '0400102', ' /          ( )', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (493, '0', '1', '2', 66, NULL, '0', '0400102', ' /          ( )', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (494, '0', '1', '2', 69, NULL, '0', '0400102', ' /          ( )', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (495, '0', '1', '2', 72, NULL, '0', '0400102', ' /          ( )', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (496, '0', '1', '2', 75, NULL, '0', '0400102', ' /          ( )', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (497, '0', '1', '2', 78, NULL, '0', '0400102', ' /          ( )', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (498, '0', '1', '2', 81, NULL, '0', '0400102', ' /          ( )', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (499, '0', '1', '2', 84, NULL, '0', '0400102', ' /          ( )', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (500, '0', '1', '2', 87, NULL, '0', '0400102', ' /          ( )', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (501, '0', '1', '2', 90, NULL, '0', '0400102', ' /          ( )', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (502, '0', '1', '2', 93, NULL, '0', '0400102', ' /          ( )', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (503, '0', '1', '2', 96, NULL, '0', '0400102', ' /          ( )', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (504, '0', '1', '2', 99, NULL, '0', '0400102', ' /          ( )', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (505, '0', '1', '2', 21, NULL, '0', '0609007', ' ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (506, '0', '1', '2', 24, NULL, '0', '0609007', ' ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (507, '0', '1', '2', 27, NULL, '0', '0609007', ' ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (508, '0', '1', '2', 30, NULL, '0', '0609007', ' ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (509, '0', '1', '2', 33, NULL, '0', '0609007', ' ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (510, '0', '1', '2', 36, NULL, '0', '0609007', ' ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (511, '0', '1', '2', 39, NULL, '0', '0609007', ' ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (512, '0', '1', '2', 42, NULL, '0', '0609007', ' ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (513, '0', '1', '2', 45, NULL, '0', '0609007', ' ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (514, '0', '1', '2', 48, NULL, '0', '0609007', ' ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (515, '0', '1', '2', 51, NULL, '0', '0609007', ' ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (516, '0', '1', '2', 54, NULL, '0', '0609007', ' ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (517, '0', '1', '2', 57, NULL, '0', '0609007', ' ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (518, '0', '1', '2', 60, NULL, '0', '0609007', ' ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (519, '0', '1', '2', 63, NULL, '0', '0609007', ' ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (520, '0', '1', '2', 66, NULL, '0', '0609007', ' ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (521, '0', '1', '2', 69, NULL, '0', '0609007', ' ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (522, '0', '1', '2', 72, NULL, '0', '0609007', ' ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (523, '0', '1', '2', 75, NULL, '0', '0609007', ' ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (524, '0', '1', '2', 78, NULL, '0', '0609007', ' ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (525, '0', '1', '2', 81, NULL, '0', '0609007', ' ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (526, '0', '1', '2', 84, NULL, '0', '0609007', ' ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (527, '0', '1', '2', 87, NULL, '0', '0609007', ' ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (528, '0', '1', '2', 90, NULL, '0', '0609007', ' ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (529, '0', '1', '2', 93, NULL, '0', '0609007', ' ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (530, '0', '1', '2', 96, NULL, '0', '0609007', ' ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (531, '0', '1', '2', 99, NULL, '0', '0609007', ' ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (532, '0', '1', '2', 39, NULL, '0', '0620006', '', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (533, '0', '1', '2', 42, NULL, '0', '0620006', '', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (534, '0', '1', '2', 45, NULL, '0', '0620006', '', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (535, '0', '1', '2', 48, NULL, '0', '0620006', '', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (536, '0', '1', '2', 51, NULL, '0', '0620006', '', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (537, '0', '1', '2', 54, NULL, '0', '0620006', '', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (538, '0', '1', '2', 57, NULL, '0', '0620006', '', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (539, '0', '1', '2', 60, NULL, '0', '0620006', '', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (540, '0', '1', '2', 63, NULL, '0', '0620006', '', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (541, '0', '1', '2', 66, NULL, '0', '0620006', '', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (542, '0', '1', '2', 69, NULL, '0', '0620006', '', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (543, '0', '1', '2', 72, NULL, '0', '0620006', '', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (544, '0', '1', '2', 75, NULL, '0', '0620006', '', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (545, '0', '1', '2', 78, NULL, '0', '0620006', '', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (546, '0', '1', '2', 81, NULL, '0', '0620006', '', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (547, '0', '1', '2', 84, NULL, '0', '0620006', '', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (548, '0', '1', '2', 87, NULL, '0', '0620006', '', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (549, '0', '1', '2', 90, NULL, '0', '0620006', '', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (550, '0', '1', '2', 93, NULL, '0', '0620006', '', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (551, '0', '1', '2', 96, NULL, '0', '0620006', '', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (552, '0', '1', '2', 99, NULL, '0', '0620006', '', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (553, '0', '1', '2', 21, NULL, '0', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (554, '0', '1', '2', 24, NULL, '0', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (555, '0', '1', '2', 27, NULL, '0', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (556, '0', '1', '2', 30, NULL, '0', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (557, '0', '1', '2', 33, NULL, '0', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (558, '0', '1', '2', 36, NULL, '0', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (559, '0', '1', '2', 42, NULL, '0', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (560, '0', '1', '2', 48, NULL, '0', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (561, '0', '1', '2', 54, NULL, '0', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (562, '0', '1', '2', 60, NULL, '0', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (563, '0', '1', '2', 66, NULL, '0', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (564, '0', '1', '2', 72, NULL, '0', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (565, '0', '1', '2', 78, NULL, '0', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (566, '0', '1', '2', 84, NULL, '0', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (567, '0', '1', '2', 90, NULL, '0', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (568, '0', '1', '2', 96, NULL, '0', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (569, '0', '1', '2', 21, NULL, '0', '0805004', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (570, '0', '1', '2', 24, NULL, '0', '0805004', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (571, '0', '1', '2', 27, NULL, '0', '0805004', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (572, '0', '1', '2', 30, NULL, '0', '0805004', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (573, '0', '1', '2', 33, NULL, '0', '0805004', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (574, '0', '1', '2', 36, NULL, '0', '0805004', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (575, '0', '1', '2', 42, NULL, '0', '0805004', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (576, '0', '1', '2', 48, NULL, '0', '0805004', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (577, '0', '1', '2', 54, NULL, '0', '0805004', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (578, '0', '1', '2', 60, NULL, '0', '0805004', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (579, '0', '1', '2', 66, NULL, '0', '0805004', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (580, '0', '1', '2', 72, NULL, '0', '0805004', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (581, '0', '1', '2', 78, NULL, '0', '0805004', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (582, '0', '1', '2', 84, NULL, '0', '0805004', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (583, '0', '1', '2', 90, NULL, '0', '0805004', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (584, '0', '1', '2', 96, NULL, '0', '0805004', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (585, '0', '1', '2', 21, NULL, '0', '0905003', '     ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (586, '0', '1', '2', 24, NULL, '0', '0905003', '     ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (587, '0', '1', '2', 27, NULL, '0', '0905003', '     ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (588, '0', '1', '2', 30, NULL, '0', '0905003', '     ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (589, '0', '1', '2', 33, NULL, '0', '0905003', '     ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (590, '0', '1', '2', 36, NULL, '0', '0905003', '     ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (591, '0', '1', '2', 42, NULL, '0', '0905003', '     ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (592, '0', '1', '2', 48, NULL, '0', '0905003', '     ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (593, '0', '1', '2', 54, NULL, '0', '0905003', '     ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (594, '0', '1', '2', 60, NULL, '0', '0905003', '     ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (595, '0', '1', '2', 66, NULL, '0', '0905003', '     ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (596, '0', '1', '2', 72, NULL, '0', '0905003', '     ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (597, '0', '1', '2', 78, NULL, '0', '0905003', '     ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (598, '0', '1', '2', 84, NULL, '0', '0905003', '     ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (599, '0', '1', '2', 90, NULL, '0', '0905003', '     ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (600, '0', '1', '2', 96, NULL, '0', '0905003', '     ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (601, '0', '1', '2', 21, NULL, '0', '1205001', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (602, '0', '1', '2', 24, NULL, '0', '1205001', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (603, '0', '1', '2', 27, NULL, '0', '1205001', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (604, '0', '1', '2', 30, NULL, '0', '1205001', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (605, '0', '1', '2', 33, NULL, '0', '1205001', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (606, '0', '1', '2', 36, NULL, '0', '1205001', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (607, '0', '1', '2', 42, NULL, '0', '1205001', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (608, '0', '1', '2', 48, NULL, '0', '1205001', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (609, '0', '1', '2', 54, NULL, '0', '1205001', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (610, '0', '1', '2', 60, NULL, '0', '1205001', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (611, '0', '1', '2', 66, NULL, '0', '1205001', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (612, '0', '1', '2', 72, NULL, '0', '1205001', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (613, '0', '1', '2', 78, NULL, '0', '1205001', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (614, '0', '1', '2', 84, NULL, '0', '1205001', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (615, '0', '1', '2', 90, NULL, '0', '1205001', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (616, '0', '1', '2', 96, NULL, '0', '1205001', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (617, '0', '1', '2', 39, NULL, '0', '0301603', ' ()   ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (618, '0', '1', '2', 45, NULL, '0', '0301603', ' ()   ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (619, '0', '1', '2', 51, NULL, '0', '0301603', ' ()   ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (620, '0', '1', '2', 57, NULL, '0', '0301603', ' ()   ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (621, '0', '1', '2', 63, NULL, '0', '0301603', ' ()   ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (622, '0', '1', '2', 69, NULL, '0', '0301603', ' ()   ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (623, '0', '1', '2', 75, NULL, '0', '0301603', ' ()   ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (624, '0', '1', '2', 81, NULL, '0', '0301603', ' ()   ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (625, '0', '1', '2', 87, NULL, '0', '0301603', ' ()   ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (626, '0', '1', '2', 93, NULL, '0', '0301603', ' ()   ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (627, '0', '1', '2', 99, NULL, '0', '0301603', ' ()   ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (628, '0', '1', '2', 39, NULL, '0', '0301604', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (629, '0', '1', '2', 45, NULL, '0', '0301604', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (630, '0', '1', '2', 51, NULL, '0', '0301604', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (631, '0', '1', '2', 57, NULL, '0', '0301604', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (632, '0', '1', '2', 63, NULL, '0', '0301604', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (633, '0', '1', '2', 69, NULL, '0', '0301604', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (634, '0', '1', '2', 75, NULL, '0', '0301604', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (635, '0', '1', '2', 81, NULL, '0', '0301604', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (636, '0', '1', '2', 87, NULL, '0', '0301604', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (637, '0', '1', '2', 93, NULL, '0', '0301604', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (638, '0', '1', '2', 99, NULL, '0', '0301604', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (639, '0', '1', '2', 21, NULL, '0', '0301606', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (640, '0', '1', '2', 24, NULL, '0', '0301606', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (641, '0', '1', '2', 27, NULL, '0', '0301606', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (642, '0', '1', '2', 30, NULL, '0', '0301606', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (643, '0', '1', '2', 33, NULL, '0', '0301606', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (644, '0', '1', '2', 36, NULL, '0', '0301606', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (645, '0', '1', '2', 39, NULL, '0', '0301606', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (646, '0', '1', '2', 42, NULL, '0', '0301606', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (647, '0', '1', '2', 45, NULL, '0', '0301606', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (648, '0', '1', '2', 48, NULL, '0', '0301606', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (649, '0', '1', '2', 51, NULL, '0', '0301606', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (650, '0', '1', '2', 54, NULL, '0', '0301606', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (651, '0', '1', '2', 57, NULL, '0', '0301606', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (652, '0', '1', '2', 60, NULL, '0', '0301606', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (653, '0', '1', '2', 63, NULL, '0', '0301606', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (654, '0', '1', '2', 66, NULL, '0', '0301606', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (655, '0', '1', '2', 69, NULL, '0', '0301606', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (656, '0', '1', '2', 72, NULL, '0', '0301606', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (657, '0', '1', '2', 75, NULL, '0', '0301606', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (658, '0', '1', '2', 78, NULL, '0', '0301606', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (659, '0', '1', '2', 81, NULL, '0', '0301606', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (660, '0', '1', '2', 84, NULL, '0', '0301606', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (661, '0', '1', '2', 87, NULL, '0', '0301606', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (662, '0', '1', '2', 90, NULL, '0', '0301606', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (663, '0', '1', '2', 93, NULL, '0', '0301606', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (664, '0', '1', '2', 96, NULL, '0', '0301606', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (665, '0', '1', '2', 99, NULL, '0', '0301606', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (666, '0', '1', '2', 45, NULL, '0', '0919002', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (667, '0', '1', '2', 48, NULL, '0', '0919002', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (668, '0', '1', '2', 51, NULL, '0', '0919002', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (669, '0', '1', '2', 54, NULL, '0', '0919002', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (670, '0', '1', '2', 57, NULL, '0', '0919002', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (671, '0', '1', '2', 60, NULL, '0', '0919002', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (672, '0', '1', '2', 63, NULL, '0', '0919002', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (673, '0', '1', '2', 66, NULL, '0', '0919002', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (674, '0', '1', '2', 69, NULL, '0', '0919002', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (675, '0', '1', '2', 72, NULL, '0', '0919002', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (676, '0', '1', '2', 75, NULL, '0', '0919002', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (677, '0', '1', '2', 78, NULL, '0', '0919002', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (678, '0', '1', '2', 81, NULL, '0', '0919002', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (679, '0', '1', '2', 84, NULL, '0', '0919002', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (680, '0', '1', '2', 87, NULL, '0', '0919002', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (681, '0', '1', '2', 90, NULL, '0', '0919002', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (682, '0', '1', '2', 93, NULL, '0', '0919002', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (683, '0', '1', '2', 96, NULL, '0', '0919002', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (684, '0', '1', '2', 99, NULL, '0', '0919002', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (685, '0', '1', '2', 39, NULL, '0', '0414001', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (686, '0', '1', '2', 45, NULL, '0', '0414001', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (687, '0', '1', '2', 51, NULL, '0', '0414001', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (688, '0', '1', '2', 57, NULL, '0', '0414001', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (689, '0', '1', '2', 63, NULL, '0', '0414001', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (690, '0', '1', '2', 69, NULL, '0', '0414001', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (691, '0', '1', '2', 75, NULL, '0', '0414001', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (692, '0', '1', '2', 81, NULL, '0', '0414001', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (693, '0', '1', '2', 87, NULL, '0', '0414001', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (694, '0', '1', '2', 93, NULL, '0', '0414001', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (695, '0', '1', '2', 99, NULL, '0', '0414001', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (696, '0', '1', '2', 39, NULL, '0', '0414002', '   ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (697, '0', '1', '2', 45, NULL, '0', '0414002', '   ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (698, '0', '1', '2', 51, NULL, '0', '0414002', '   ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (699, '0', '1', '2', 57, NULL, '0', '0414002', '   ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (700, '0', '1', '2', 63, NULL, '0', '0414002', '   ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (701, '0', '1', '2', 69, NULL, '0', '0414002', '   ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (702, '0', '1', '2', 75, NULL, '0', '0414002', '   ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (703, '0', '1', '2', 81, NULL, '0', '0414002', '   ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (704, '0', '1', '2', 87, NULL, '0', '0414002', '   ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (705, '0', '1', '2', 93, NULL, '0', '0414002', '   ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (706, '0', '1', '2', 99, NULL, '0', '0414002', '   ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (707, '0', '1', '2', 39, NULL, '0', '0415001', '   ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (708, '0', '1', '2', 45, NULL, '0', '0415001', '   ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (709, '0', '1', '2', 51, NULL, '0', '0415001', '   ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (710, '0', '1', '2', 57, NULL, '0', '0415001', '   ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (711, '0', '1', '2', 63, NULL, '0', '0415001', '   ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (712, '0', '1', '2', 69, NULL, '0', '0415001', '   ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (713, '0', '1', '2', 75, NULL, '0', '0415001', '   ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (714, '0', '1', '2', 81, NULL, '0', '0415001', '   ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (715, '0', '1', '2', 87, NULL, '0', '0415001', '   ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (716, '0', '1', '2', 93, NULL, '0', '0415001', '   ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (717, '0', '1', '2', 99, NULL, '0', '0415001', '   ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (718, '0', '1', '2', 39, NULL, '0', '0428001', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (719, '0', '1', '2', 45, NULL, '0', '0428001', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (720, '0', '1', '2', 51, NULL, '0', '0428001', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (721, '0', '1', '2', 57, NULL, '0', '0428001', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (722, '0', '1', '2', 63, NULL, '0', '0428001', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (723, '0', '1', '2', 69, NULL, '0', '0428001', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (724, '0', '1', '2', 75, NULL, '0', '0428001', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (725, '0', '1', '2', 81, NULL, '0', '0428001', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (726, '0', '1', '2', 87, NULL, '0', '0428001', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (727, '0', '1', '2', 93, NULL, '0', '0428001', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (728, '0', '1', '2', 99, NULL, '0', '0428001', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (729, '0', '1', '2', 39, NULL, '0', '0226015', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (730, '0', '1', '2', 42, NULL, '0', '0226015', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (731, '0', '1', '2', 45, NULL, '0', '0226015', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (732, '0', '1', '2', 48, NULL, '0', '0226015', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (733, '0', '1', '2', 51, NULL, '0', '0226015', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (734, '0', '1', '2', 54, NULL, '0', '0226015', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (735, '0', '1', '2', 57, NULL, '0', '0226015', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (736, '0', '1', '2', 60, NULL, '0', '0226015', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (737, '0', '1', '2', 63, NULL, '0', '0226015', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (738, '0', '1', '2', 66, NULL, '0', '0226015', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (739, '0', '1', '2', 69, NULL, '0', '0226015', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (740, '0', '1', '2', 72, NULL, '0', '0226015', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (741, '0', '1', '2', 75, NULL, '0', '0226015', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (742, '0', '1', '2', 78, NULL, '0', '0226015', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (743, '0', '1', '2', 81, NULL, '0', '0226015', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (744, '0', '1', '2', 84, NULL, '0', '0226015', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (745, '0', '1', '2', 87, NULL, '0', '0226015', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (746, '0', '1', '2', 90, NULL, '0', '0226015', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (747, '0', '1', '2', 93, NULL, '0', '0226015', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (748, '0', '1', '2', 96, NULL, '0', '0226015', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (749, '0', '1', '2', 99, NULL, '0', '0226015', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (750, '0', '1', '2', 51, NULL, '0', '0402302', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (751, '0', '1', '2', 57, NULL, '0', '0402302', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (752, '0', '1', '2', 63, NULL, '0', '0402302', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (753, '0', '1', '2', 69, NULL, '0', '0402302', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (754, '0', '1', '2', 75, NULL, '0', '0402302', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (755, '0', '1', '2', 81, NULL, '0', '0402302', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (756, '0', '1', '2', 87, NULL, '0', '0402302', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (757, '0', '1', '2', 93, NULL, '0', '0402302', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (758, '0', '1', '2', 99, NULL, '0', '0402302', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (759, '0', '1', '2', 21, NULL, '1', '0404702', '  (, ) -', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (760, '0', '1', '2', 24, NULL, '1', '0404702', '  (, ) -', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (761, '0', '1', '2', 27, NULL, '1', '0404702', '  (, ) -', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (762, '0', '1', '2', 30, NULL, '1', '0404702', '  (, ) -', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (763, '0', '1', '2', 33, NULL, '1', '0404702', '  (, ) -', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (764, '0', '1', '2', 36, NULL, '1', '0404702', '  (, ) -', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (765, '0', '1', '2', 39, NULL, '1', '0404702', '  (, ) -', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (766, '0', '1', '2', 42, NULL, '1', '0404702', '  (, ) -', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (767, '0', '1', '2', 45, NULL, '1', '0404702', '  (, ) -', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (768, '0', '1', '2', 48, NULL, '1', '0404702', '  (, ) -', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (769, '0', '1', '2', 51, NULL, '1', '0404702', '  (, ) -', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (770, '0', '1', '2', 54, NULL, '1', '0404702', '  (, ) -', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (771, '0', '1', '2', 57, NULL, '1', '0404702', '  (, ) -', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (772, '0', '1', '2', 60, NULL, '1', '0404702', '  (, ) -', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (773, '0', '1', '2', 63, NULL, '1', '0404702', '  (, ) -', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (774, '0', '1', '2', 66, NULL, '1', '0404702', '  (, ) -', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (775, '0', '1', '2', 69, NULL, '1', '0404702', '  (, ) -', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (776, '0', '1', '2', 72, NULL, '1', '0404702', '  (, ) -', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (777, '0', '1', '2', 75, NULL, '1', '0404702', '  (, ) -', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (778, '0', '1', '2', 78, NULL, '1', '0404702', '  (, ) -', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (779, '0', '1', '2', 81, NULL, '1', '0404702', '  (, ) -', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (780, '0', '1', '2', 84, NULL, '1', '0404702', '  (, ) -', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (781, '0', '1', '2', 87, NULL, '1', '0404702', '  (, ) -', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (782, '0', '1', '2', 90, NULL, '1', '0404702', '  (, ) -', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (783, '0', '1', '2', 93, NULL, '1', '0404702', '  (, ) -', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (784, '0', '1', '2', 96, NULL, '1', '0404702', '  (, ) -', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (785, '0', '1', '2', 99, NULL, '1', '0404702', '  (, ) -', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (786, '0', '1', '1', NULL, 35, '0', '0510001', ' ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (787, '0', '1', '1', NULL, 35, '0', '0510007', ',     ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (788, '0', '2', '1', 21, NULL, '0', '0412005', '   ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (789, '0', '2', '1', 24, NULL, '0', '0412005', '   ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (790, '0', '2', '1', 27, NULL, '0', '0412005', '   ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (791, '0', '2', '1', 30, NULL, '0', '0412005', '   ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (792, '0', '2', '1', 33, NULL, '0', '0412005', '   ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (793, '0', '2', '1', 36, NULL, '0', '0412005', '   ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (794, '0', '2', '1', 39, NULL, '0', '0412005', '   ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (795, '0', '2', '1', 42, NULL, '0', '0412005', '   ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (796, '0', '2', '1', 45, NULL, '0', '0412005', '   ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (797, '0', '2', '1', 48, NULL, '0', '0412005', '   ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (798, '0', '2', '1', 51, NULL, '0', '0412005', '   ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (799, '0', '2', '1', 54, NULL, '0', '0412005', '   ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (800, '0', '2', '1', 57, NULL, '0', '0412005', '   ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (801, '0', '2', '1', 60, NULL, '0', '0412005', '   ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (802, '0', '2', '1', 63, NULL, '0', '0412005', '   ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (803, '0', '2', '1', 66, NULL, '0', '0412005', '   ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (804, '0', '2', '1', 69, NULL, '0', '0412005', '   ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (805, '0', '2', '1', 72, NULL, '0', '0412005', '   ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (806, '0', '2', '1', 75, NULL, '0', '0412005', '   ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (807, '0', '2', '1', 78, NULL, '0', '0412005', '   ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (808, '0', '2', '1', 81, NULL, '0', '0412005', '   ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (809, '0', '2', '1', 84, NULL, '0', '0412005', '   ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (810, '0', '2', '1', 87, NULL, '0', '0412005', '   ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (811, '0', '2', '1', 90, NULL, '0', '0412005', '   ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (812, '0', '2', '1', 93, NULL, '0', '0412005', '   ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (813, '0', '2', '1', 96, NULL, '0', '0412005', '   ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (814, '0', '2', '1', 99, NULL, '0', '0412005', '   ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (815, '0', '2', '1', 51, NULL, '0', '0316001', '', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (816, '0', '2', '1', 54, NULL, '0', '0316001', '', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (817, '0', '2', '1', 57, NULL, '0', '0316001', '', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (818, '0', '2', '1', 60, NULL, '0', '0316001', '', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (819, '0', '2', '1', 63, NULL, '0', '0316001', '', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (820, '0', '2', '1', 66, NULL, '0', '0316001', '', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (821, '0', '2', '1', 69, NULL, '0', '0316001', '', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (822, '0', '2', '1', 72, NULL, '0', '0316001', '', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (823, '0', '2', '1', 75, NULL, '0', '0316001', '', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (824, '0', '2', '1', 78, NULL, '0', '0316001', '', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (825, '0', '2', '1', 81, NULL, '0', '0316001', '', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (826, '0', '2', '1', 84, NULL, '0', '0316001', '', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (827, '0', '2', '1', 87, NULL, '0', '0316001', '', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (828, '0', '2', '1', 90, NULL, '0', '0316001', '', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (829, '0', '2', '1', 93, NULL, '0', '0316001', '', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (830, '0', '2', '1', 96, NULL, '0', '0316001', '', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (831, '0', '2', '1', 99, NULL, '0', '0316001', '', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (832, '0', '2', '1', 21, NULL, '0', '0102301', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (833, '0', '2', '1', 24, NULL, '0', '0102301', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (834, '0', '2', '1', 27, NULL, '0', '0102301', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (835, '0', '2', '1', 30, NULL, '0', '0102301', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (836, '0', '2', '1', 33, NULL, '0', '0102301', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (837, '0', '2', '1', 36, NULL, '0', '0102301', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (838, '0', '2', '1', 39, NULL, '0', '0102301', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (839, '0', '2', '1', 42, NULL, '0', '0102301', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (840, '0', '2', '1', 45, NULL, '0', '0102301', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (841, '0', '2', '1', 48, NULL, '0', '0102301', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (842, '0', '2', '1', 51, NULL, '0', '0102301', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (843, '0', '2', '1', 54, NULL, '0', '0102301', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (844, '0', '2', '1', 57, NULL, '0', '0102301', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (845, '0', '2', '1', 60, NULL, '0', '0102301', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (846, '0', '2', '1', 63, NULL, '0', '0102301', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (847, '0', '2', '1', 66, NULL, '0', '0102301', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (848, '0', '2', '1', 69, NULL, '0', '0102301', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (849, '0', '2', '1', 72, NULL, '0', '0102301', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (850, '0', '2', '1', 75, NULL, '0', '0102301', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (851, '0', '2', '1', 78, NULL, '0', '0102301', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (852, '0', '2', '1', 81, NULL, '0', '0102301', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (853, '0', '2', '1', 84, NULL, '0', '0102301', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (854, '0', '2', '1', 87, NULL, '0', '0102301', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (855, '0', '2', '1', 90, NULL, '0', '0102301', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (856, '0', '2', '1', 93, NULL, '0', '0102301', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (857, '0', '2', '1', 96, NULL, '0', '0102301', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (858, '0', '2', '1', 99, NULL, '0', '0102301', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (859, '0', '2', '1', 45, NULL, '0', '0105701', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (860, '0', '2', '1', 48, NULL, '0', '0105701', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (861, '0', '2', '1', 51, NULL, '0', '0105701', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (862, '0', '2', '1', 54, NULL, '0', '0105701', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (863, '0', '2', '1', 57, NULL, '0', '0105701', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (864, '0', '2', '1', 60, NULL, '0', '0105701', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (865, '0', '2', '1', 63, NULL, '0', '0105701', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (866, '0', '2', '1', 66, NULL, '0', '0105701', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (867, '0', '2', '1', 69, NULL, '0', '0105701', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (868, '0', '2', '1', 72, NULL, '0', '0105701', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (869, '0', '2', '1', 75, NULL, '0', '0105701', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (870, '0', '2', '1', 78, NULL, '0', '0105701', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (871, '0', '2', '1', 81, NULL, '0', '0105701', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (872, '0', '2', '1', 84, NULL, '0', '0105701', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (873, '0', '2', '1', 87, NULL, '0', '0105701', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (874, '0', '2', '1', 90, NULL, '0', '0105701', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (875, '0', '2', '1', 93, NULL, '0', '0105701', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (876, '0', '2', '1', 96, NULL, '0', '0105701', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (877, '0', '2', '1', 99, NULL, '0', '0105701', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (878, '0', '2', '1', 45, NULL, '0', '0101801', ' (, ) - ', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (879, '0', '2', '1', 48, NULL, '0', '0101801', ' (, ) - ', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (880, '0', '2', '1', 51, NULL, '0', '0101801', ' (, ) - ', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (881, '0', '2', '1', 54, NULL, '0', '0101801', ' (, ) - ', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (882, '0', '2', '1', 57, NULL, '0', '0101801', ' (, ) - ', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (883, '0', '2', '1', 60, NULL, '0', '0101801', ' (, ) - ', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (884, '0', '2', '1', 63, NULL, '0', '0101801', ' (, ) - ', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (885, '0', '2', '1', 66, NULL, '0', '0101801', ' (, ) - ', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (886, '0', '2', '1', 69, NULL, '0', '0101801', ' (, ) - ', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (887, '0', '2', '1', 72, NULL, '0', '0101801', ' (, ) - ', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (888, '0', '2', '1', 75, NULL, '0', '0101801', ' (, ) - ', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (889, '0', '2', '1', 78, NULL, '0', '0101801', ' (, ) - ', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (890, '0', '2', '1', 81, NULL, '0', '0101801', ' (, ) - ', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (891, '0', '2', '1', 84, NULL, '0', '0101801', ' (, ) - ', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (892, '0', '2', '1', 87, NULL, '0', '0101801', ' (, ) - ', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (893, '0', '2', '1', 90, NULL, '0', '0101801', ' (, ) - ', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (894, '0', '2', '1', 93, NULL, '0', '0101801', ' (, ) - ', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (895, '0', '2', '1', 96, NULL, '0', '0101801', ' (, ) - ', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (896, '0', '2', '1', 99, NULL, '0', '0101801', ' (, ) - ', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (897, '0', '2', '1', 51, NULL, '0', '0105301', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (898, '0', '2', '1', 54, NULL, '0', '0105301', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (899, '0', '2', '1', 57, NULL, '0', '0105301', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (900, '0', '2', '1', 60, NULL, '0', '0105301', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (901, '0', '2', '1', 63, NULL, '0', '0105301', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (902, '0', '2', '1', 66, NULL, '0', '0105301', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (903, '0', '2', '1', 69, NULL, '0', '0105301', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (904, '0', '2', '1', 72, NULL, '0', '0105301', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (905, '0', '2', '1', 75, NULL, '0', '0105301', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (906, '0', '2', '1', 78, NULL, '0', '0105301', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (907, '0', '2', '1', 81, NULL, '0', '0105301', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (908, '0', '2', '1', 84, NULL, '0', '0105301', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (909, '0', '2', '1', 87, NULL, '0', '0105301', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (910, '0', '2', '1', 90, NULL, '0', '0105301', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (911, '0', '2', '1', 93, NULL, '0', '0105301', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (912, '0', '2', '1', 96, NULL, '0', '0105301', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (913, '0', '2', '1', 99, NULL, '0', '0105301', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (914, '0', '2', '1', 45, NULL, '0', '0319002', '', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (915, '0', '2', '1', 48, NULL, '0', '0319002', '', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (916, '0', '2', '1', 51, NULL, '0', '0319002', '', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (917, '0', '2', '1', 54, NULL, '0', '0319002', '', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (918, '0', '2', '1', 57, NULL, '0', '0319002', '', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (919, '0', '2', '1', 60, NULL, '0', '0319002', '', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (920, '0', '2', '1', 63, NULL, '0', '0319002', '', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (921, '0', '2', '1', 66, NULL, '0', '0319002', '', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (922, '0', '2', '1', 69, NULL, '0', '0319002', '', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (923, '0', '2', '1', 72, NULL, '0', '0319002', '', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (924, '0', '2', '1', 75, NULL, '0', '0319002', '', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (925, '0', '2', '1', 78, NULL, '0', '0319002', '', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (926, '0', '2', '1', 81, NULL, '0', '0319002', '', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (927, '0', '2', '1', 84, NULL, '0', '0319002', '', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (928, '0', '2', '1', 87, NULL, '0', '0319002', '', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (929, '0', '2', '1', 90, NULL, '0', '0319002', '', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (930, '0', '2', '1', 93, NULL, '0', '0319002', '', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (931, '0', '2', '1', 96, NULL, '0', '0319002', '', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (932, '0', '2', '1', 99, NULL, '0', '0319002', '', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (933, '0', '2', '1', 21, NULL, '0', '0905084', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (934, '0', '2', '1', 24, NULL, '0', '0905084', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (935, '0', '2', '1', 27, NULL, '0', '0905084', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (936, '0', '2', '1', 30, NULL, '0', '0905084', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (937, '0', '2', '1', 33, NULL, '0', '0905084', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (938, '0', '2', '1', 36, NULL, '0', '0905084', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (939, '0', '2', '1', 39, NULL, '0', '0905084', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (940, '0', '2', '1', 42, NULL, '0', '0905084', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (941, '0', '2', '1', 45, NULL, '0', '0905084', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (942, '0', '2', '1', 48, NULL, '0', '0905084', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (943, '0', '2', '1', 51, NULL, '0', '0905084', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (944, '0', '2', '1', 54, NULL, '0', '0905084', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (945, '0', '2', '1', 57, NULL, '0', '0905084', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (946, '0', '2', '1', 60, NULL, '0', '0905084', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (947, '0', '2', '1', 63, NULL, '0', '0905084', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (948, '0', '2', '1', 66, NULL, '0', '0905084', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (949, '0', '2', '1', 69, NULL, '0', '0905084', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (950, '0', '2', '1', 72, NULL, '0', '0905084', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (951, '0', '2', '1', 75, NULL, '0', '0905084', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (952, '0', '2', '1', 78, NULL, '0', '0905084', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (953, '0', '2', '1', 81, NULL, '0', '0905084', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (954, '0', '2', '1', 84, NULL, '0', '0905084', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (955, '0', '2', '1', 87, NULL, '0', '0905084', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (956, '0', '2', '1', 90, NULL, '0', '0905084', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (957, '0', '2', '1', 93, NULL, '0', '0905084', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (958, '0', '2', '1', 96, NULL, '0', '0905084', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (959, '0', '2', '1', 99, NULL, '0', '0905084', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (960, '0', '2', '1', 39, NULL, '0', '0102901', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (961, '0', '2', '1', 42, NULL, '0', '0102901', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (962, '0', '2', '1', 45, NULL, '0', '0102901', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (963, '0', '2', '1', 48, NULL, '0', '0102901', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (964, '0', '2', '1', 51, NULL, '0', '0102901', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (965, '0', '2', '1', 54, NULL, '0', '0102901', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (966, '0', '2', '1', 57, NULL, '0', '0102901', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (967, '0', '2', '1', 60, NULL, '0', '0102901', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (968, '0', '2', '1', 63, NULL, '0', '0102901', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (969, '0', '2', '1', 66, NULL, '0', '0102901', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (970, '0', '2', '1', 69, NULL, '0', '0102901', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (971, '0', '2', '1', 72, NULL, '0', '0102901', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (972, '0', '2', '1', 75, NULL, '0', '0102901', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (973, '0', '2', '1', 78, NULL, '0', '0102901', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (974, '0', '2', '1', 81, NULL, '0', '0102901', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (975, '0', '2', '1', 84, NULL, '0', '0102901', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (976, '0', '2', '1', 87, NULL, '0', '0102901', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (977, '0', '2', '1', 90, NULL, '0', '0102901', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (978, '0', '2', '1', 93, NULL, '0', '0102901', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (979, '0', '2', '1', 96, NULL, '0', '0102901', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (980, '0', '2', '1', 99, NULL, '0', '0102901', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (981, '0', '2', '1', 21, NULL, '1', '0104701', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (982, '0', '2', '1', 24, NULL, '1', '0104701', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (983, '0', '2', '1', 27, NULL, '1', '0104701', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (984, '0', '2', '1', 30, NULL, '1', '0104701', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (985, '0', '2', '1', 33, NULL, '1', '0104701', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (986, '0', '2', '1', 36, NULL, '1', '0104701', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (987, '0', '2', '1', 39, NULL, '1', '0104701', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (988, '0', '2', '1', 42, NULL, '1', '0104701', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (989, '0', '2', '1', 45, NULL, '1', '0104701', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (990, '0', '2', '1', 48, NULL, '1', '0104701', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (991, '0', '2', '1', 51, NULL, '1', '0104701', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (992, '0', '2', '1', 54, NULL, '1', '0104701', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (993, '0', '2', '1', 57, NULL, '1', '0104701', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (994, '0', '2', '1', 60, NULL, '1', '0104701', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (995, '0', '2', '1', 63, NULL, '1', '0104701', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (996, '0', '2', '1', 66, NULL, '1', '0104701', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (997, '0', '2', '1', 69, NULL, '1', '0104701', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (998, '0', '2', '1', 72, NULL, '1', '0104701', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (999, '0', '2', '1', 75, NULL, '1', '0104701', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1000, '0', '2', '1', 78, NULL, '1', '0104701', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, '1'); @
COMMIT WORK; @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1001, '0', '2', '1', 81, NULL, '1', '0104701', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1002, '0', '2', '1', 84, NULL, '1', '0104701', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1003, '0', '2', '1', 87, NULL, '1', '0104701', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1004, '0', '2', '1', 90, NULL, '1', '0104701', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1005, '0', '2', '1', 93, NULL, '1', '0104701', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1006, '0', '2', '1', 96, NULL, '1', '0104701', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1007, '0', '2', '1', 99, NULL, '1', '0104701', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1008, '0', '2', '1', 21, NULL, '0', '0905027', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1009, '0', '2', '1', 24, NULL, '0', '0905027', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1010, '0', '2', '1', 27, NULL, '0', '0905027', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1011, '0', '2', '1', 30, NULL, '0', '0905027', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1012, '0', '2', '1', 33, NULL, '0', '0905027', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1013, '0', '2', '1', 36, NULL, '0', '0905027', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1014, '0', '2', '1', 39, NULL, '0', '0905027', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1015, '0', '2', '1', 42, NULL, '0', '0905027', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1016, '0', '2', '1', 45, NULL, '0', '0905027', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1017, '0', '2', '1', 48, NULL, '0', '0905027', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1018, '0', '2', '1', 51, NULL, '0', '0905027', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1019, '0', '2', '1', 54, NULL, '0', '0905027', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1020, '0', '2', '1', 57, NULL, '0', '0905027', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1021, '0', '2', '1', 60, NULL, '0', '0905027', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1022, '0', '2', '1', 63, NULL, '0', '0905027', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1023, '0', '2', '1', 66, NULL, '0', '0905027', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1024, '0', '2', '1', 69, NULL, '0', '0905027', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1025, '0', '2', '1', 72, NULL, '0', '0905027', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1026, '0', '2', '1', 75, NULL, '0', '0905027', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1027, '0', '2', '1', 78, NULL, '0', '0905027', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1028, '0', '2', '1', 81, NULL, '0', '0905027', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1029, '0', '2', '1', 84, NULL, '0', '0905027', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1030, '0', '2', '1', 87, NULL, '0', '0905027', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1031, '0', '2', '1', 90, NULL, '0', '0905027', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1032, '0', '2', '1', 93, NULL, '0', '0905027', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1033, '0', '2', '1', 96, NULL, '0', '0905027', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1034, '0', '2', '1', 99, NULL, '0', '0905027', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1035, '0', '2', '1', 21, NULL, '0', '0905028', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1036, '0', '2', '1', 24, NULL, '0', '0905028', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1037, '0', '2', '1', 27, NULL, '0', '0905028', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1038, '0', '2', '1', 30, NULL, '0', '0905028', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1039, '0', '2', '1', 33, NULL, '0', '0905028', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1040, '0', '2', '1', 36, NULL, '0', '0905028', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1041, '0', '2', '1', 39, NULL, '0', '0905028', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1042, '0', '2', '1', 42, NULL, '0', '0905028', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1043, '0', '2', '1', 45, NULL, '0', '0905028', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1044, '0', '2', '1', 48, NULL, '0', '0905028', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1045, '0', '2', '1', 51, NULL, '0', '0905028', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1046, '0', '2', '1', 54, NULL, '0', '0905028', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1047, '0', '2', '1', 57, NULL, '0', '0905028', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1048, '0', '2', '1', 60, NULL, '0', '0905028', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1049, '0', '2', '1', 63, NULL, '0', '0905028', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1050, '0', '2', '1', 66, NULL, '0', '0905028', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1051, '0', '2', '1', 69, NULL, '0', '0905028', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1052, '0', '2', '1', 72, NULL, '0', '0905028', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1053, '0', '2', '1', 75, NULL, '0', '0905028', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1054, '0', '2', '1', 78, NULL, '0', '0905028', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1055, '0', '2', '1', 81, NULL, '0', '0905028', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1056, '0', '2', '1', 84, NULL, '0', '0905028', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1057, '0', '2', '1', 87, NULL, '0', '0905028', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1058, '0', '2', '1', 90, NULL, '0', '0905028', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1059, '0', '2', '1', 93, NULL, '0', '0905028', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1060, '0', '2', '1', 96, NULL, '0', '0905028', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1061, '0', '2', '1', 99, NULL, '0', '0905028', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1062, '0', '2', '1', 21, NULL, '0', '0905025', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1063, '0', '2', '1', 24, NULL, '0', '0905025', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1064, '0', '2', '1', 27, NULL, '0', '0905025', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1065, '0', '2', '1', 30, NULL, '0', '0905025', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1066, '0', '2', '1', 33, NULL, '0', '0905025', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1067, '0', '2', '1', 36, NULL, '0', '0905025', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1068, '0', '2', '1', 39, NULL, '0', '0905025', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1069, '0', '2', '1', 42, NULL, '0', '0905025', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1070, '0', '2', '1', 45, NULL, '0', '0905025', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1071, '0', '2', '1', 48, NULL, '0', '0905025', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1072, '0', '2', '1', 51, NULL, '0', '0905025', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1073, '0', '2', '1', 54, NULL, '0', '0905025', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1074, '0', '2', '1', 57, NULL, '0', '0905025', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1075, '0', '2', '1', 60, NULL, '0', '0905025', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1076, '0', '2', '1', 63, NULL, '0', '0905025', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1077, '0', '2', '1', 66, NULL, '0', '0905025', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1078, '0', '2', '1', 69, NULL, '0', '0905025', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1079, '0', '2', '1', 72, NULL, '0', '0905025', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1080, '0', '2', '1', 75, NULL, '0', '0905025', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1081, '0', '2', '1', 78, NULL, '0', '0905025', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1082, '0', '2', '1', 81, NULL, '0', '0905025', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1083, '0', '2', '1', 84, NULL, '0', '0905025', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1084, '0', '2', '1', 87, NULL, '0', '0905025', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1085, '0', '2', '1', 90, NULL, '0', '0905025', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1086, '0', '2', '1', 93, NULL, '0', '0905025', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1087, '0', '2', '1', 96, NULL, '0', '0905025', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1088, '0', '2', '1', 99, NULL, '0', '0905025', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1089, '0', '2', '1', 21, NULL, '0', '0107401', '    /    ( )   ()     ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1090, '0', '2', '1', 24, NULL, '0', '0107401', '    /    ( )   ()     ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1091, '0', '2', '1', 27, NULL, '0', '0107401', '    /    ( )   ()     ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1092, '0', '2', '1', 30, NULL, '0', '0107401', '    /    ( )   ()     ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1093, '0', '2', '1', 33, NULL, '0', '0107401', '    /    ( )   ()     ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1094, '0', '2', '1', 36, NULL, '0', '0107401', '    /    ( )   ()     ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1095, '0', '2', '1', 39, NULL, '0', '0107401', '    /    ( )   ()     ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1096, '0', '2', '1', 42, NULL, '0', '0107401', '    /    ( )   ()     ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1097, '0', '2', '1', 45, NULL, '0', '0107401', '    /    ( )   ()     ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1098, '0', '2', '1', 48, NULL, '0', '0107401', '    /    ( )   ()     ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1099, '0', '2', '1', 51, NULL, '0', '0107401', '    /    ( )   ()     ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1100, '0', '2', '1', 54, NULL, '0', '0107401', '    /    ( )   ()     ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1101, '0', '2', '1', 57, NULL, '0', '0107401', '    /    ( )   ()     ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1102, '0', '2', '1', 60, NULL, '0', '0107401', '    /    ( )   ()     ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1103, '0', '2', '1', 63, NULL, '0', '0107401', '    /    ( )   ()     ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1104, '0', '2', '1', 66, NULL, '0', '0107401', '    /    ( )   ()     ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1105, '0', '2', '1', 69, NULL, '0', '0107401', '    /    ( )   ()     ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1106, '0', '2', '1', 72, NULL, '0', '0107401', '    /    ( )   ()     ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1107, '0', '2', '1', 75, NULL, '0', '0107401', '    /    ( )   ()     ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1108, '0', '2', '1', 78, NULL, '0', '0107401', '    /    ( )   ()     ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1109, '0', '2', '1', 81, NULL, '0', '0107401', '    /    ( )   ()     ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1110, '0', '2', '1', 84, NULL, '0', '0107401', '    /    ( )   ()     ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1111, '0', '2', '1', 87, NULL, '0', '0107401', '    /    ( )   ()     ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1112, '0', '2', '1', 90, NULL, '0', '0107401', '    /    ( )   ()     ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1113, '0', '2', '1', 93, NULL, '0', '0107401', '    /    ( )   ()     ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1114, '0', '2', '1', 96, NULL, '0', '0107401', '    /    ( )   ()     ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1115, '0', '2', '1', 99, NULL, '0', '0107401', '    /    ( )   ()     ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1116, '0', '2', '2', 21, NULL, '0', '0412005', '   ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1117, '0', '2', '2', 24, NULL, '0', '0412005', '   ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1118, '0', '2', '2', 27, NULL, '0', '0412005', '   ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1119, '0', '2', '2', 30, NULL, '0', '0412005', '   ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1120, '0', '2', '2', 33, NULL, '0', '0412005', '   ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1121, '0', '2', '2', 36, NULL, '0', '0412005', '   ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1122, '0', '2', '2', 39, NULL, '0', '0412005', '   ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1123, '0', '2', '2', 42, NULL, '0', '0412005', '   ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1124, '0', '2', '2', 45, NULL, '0', '0412005', '   ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1125, '0', '2', '2', 48, NULL, '0', '0412005', '   ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1126, '0', '2', '2', 51, NULL, '0', '0412005', '   ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1127, '0', '2', '2', 54, NULL, '0', '0412005', '   ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1128, '0', '2', '2', 57, NULL, '0', '0412005', '   ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1129, '0', '2', '2', 60, NULL, '0', '0412005', '   ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1130, '0', '2', '2', 63, NULL, '0', '0412005', '   ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1131, '0', '2', '2', 66, NULL, '0', '0412005', '   ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1132, '0', '2', '2', 69, NULL, '0', '0412005', '   ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1133, '0', '2', '2', 72, NULL, '0', '0412005', '   ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1134, '0', '2', '2', 75, NULL, '0', '0412005', '   ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1135, '0', '2', '2', 78, NULL, '0', '0412005', '   ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1136, '0', '2', '2', 81, NULL, '0', '0412005', '   ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1137, '0', '2', '2', 84, NULL, '0', '0412005', '   ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1138, '0', '2', '2', 87, NULL, '0', '0412005', '   ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1139, '0', '2', '2', 90, NULL, '0', '0412005', '   ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1140, '0', '2', '2', 93, NULL, '0', '0412005', '   ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1141, '0', '2', '2', 96, NULL, '0', '0412005', '   ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1142, '0', '2', '2', 99, NULL, '0', '0412005', '   ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1143, '0', '2', '2', 51, NULL, '0', '0316001', '', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1144, '0', '2', '2', 54, NULL, '0', '0316001', '', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1145, '0', '2', '2', 57, NULL, '0', '0316001', '', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1146, '0', '2', '2', 60, NULL, '0', '0316001', '', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1147, '0', '2', '2', 63, NULL, '0', '0316001', '', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1148, '0', '2', '2', 66, NULL, '0', '0316001', '', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1149, '0', '2', '2', 69, NULL, '0', '0316001', '', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1150, '0', '2', '2', 72, NULL, '0', '0316001', '', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1151, '0', '2', '2', 75, NULL, '0', '0316001', '', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1152, '0', '2', '2', 78, NULL, '0', '0316001', '', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1153, '0', '2', '2', 81, NULL, '0', '0316001', '', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1154, '0', '2', '2', 84, NULL, '0', '0316001', '', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1155, '0', '2', '2', 87, NULL, '0', '0316001', '', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1156, '0', '2', '2', 90, NULL, '0', '0316001', '', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1157, '0', '2', '2', 93, NULL, '0', '0316001', '', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1158, '0', '2', '2', 96, NULL, '0', '0316001', '', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1159, '0', '2', '2', 99, NULL, '0', '0316001', '', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1160, '0', '2', '2', 21, NULL, '0', '0102301', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1161, '0', '2', '2', 24, NULL, '0', '0102301', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1162, '0', '2', '2', 27, NULL, '0', '0102301', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1163, '0', '2', '2', 30, NULL, '0', '0102301', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1164, '0', '2', '2', 33, NULL, '0', '0102301', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1165, '0', '2', '2', 36, NULL, '0', '0102301', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1166, '0', '2', '2', 39, NULL, '0', '0102301', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1167, '0', '2', '2', 42, NULL, '0', '0102301', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1168, '0', '2', '2', 45, NULL, '0', '0102301', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1169, '0', '2', '2', 48, NULL, '0', '0102301', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1170, '0', '2', '2', 51, NULL, '0', '0102301', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1171, '0', '2', '2', 54, NULL, '0', '0102301', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1172, '0', '2', '2', 57, NULL, '0', '0102301', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1173, '0', '2', '2', 60, NULL, '0', '0102301', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1174, '0', '2', '2', 63, NULL, '0', '0102301', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1175, '0', '2', '2', 66, NULL, '0', '0102301', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1176, '0', '2', '2', 69, NULL, '0', '0102301', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1177, '0', '2', '2', 72, NULL, '0', '0102301', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1178, '0', '2', '2', 75, NULL, '0', '0102301', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1179, '0', '2', '2', 78, NULL, '0', '0102301', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1180, '0', '2', '2', 81, NULL, '0', '0102301', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1181, '0', '2', '2', 84, NULL, '0', '0102301', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1182, '0', '2', '2', 87, NULL, '0', '0102301', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1183, '0', '2', '2', 90, NULL, '0', '0102301', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1184, '0', '2', '2', 93, NULL, '0', '0102301', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1185, '0', '2', '2', 96, NULL, '0', '0102301', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1186, '0', '2', '2', 99, NULL, '0', '0102301', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1187, '0', '2', '2', 45, NULL, '0', '0105701', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1188, '0', '2', '2', 48, NULL, '0', '0105701', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1189, '0', '2', '2', 51, NULL, '0', '0105701', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1190, '0', '2', '2', 54, NULL, '0', '0105701', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1191, '0', '2', '2', 57, NULL, '0', '0105701', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1192, '0', '2', '2', 60, NULL, '0', '0105701', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1193, '0', '2', '2', 63, NULL, '0', '0105701', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1194, '0', '2', '2', 66, NULL, '0', '0105701', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1195, '0', '2', '2', 69, NULL, '0', '0105701', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1196, '0', '2', '2', 72, NULL, '0', '0105701', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1197, '0', '2', '2', 75, NULL, '0', '0105701', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1198, '0', '2', '2', 78, NULL, '0', '0105701', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1199, '0', '2', '2', 81, NULL, '0', '0105701', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1200, '0', '2', '2', 84, NULL, '0', '0105701', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1201, '0', '2', '2', 87, NULL, '0', '0105701', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1202, '0', '2', '2', 90, NULL, '0', '0105701', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1203, '0', '2', '2', 93, NULL, '0', '0105701', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1204, '0', '2', '2', 96, NULL, '0', '0105701', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1205, '0', '2', '2', 99, NULL, '0', '0105701', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1206, '0', '2', '2', 45, NULL, '0', '0101801', ' (, ) - ', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1207, '0', '2', '2', 48, NULL, '0', '0101801', ' (, ) - ', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1208, '0', '2', '2', 51, NULL, '0', '0101801', ' (, ) - ', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1209, '0', '2', '2', 54, NULL, '0', '0101801', ' (, ) - ', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1210, '0', '2', '2', 57, NULL, '0', '0101801', ' (, ) - ', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1211, '0', '2', '2', 60, NULL, '0', '0101801', ' (, ) - ', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1212, '0', '2', '2', 63, NULL, '0', '0101801', ' (, ) - ', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1213, '0', '2', '2', 66, NULL, '0', '0101801', ' (, ) - ', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1214, '0', '2', '2', 69, NULL, '0', '0101801', ' (, ) - ', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1215, '0', '2', '2', 72, NULL, '0', '0101801', ' (, ) - ', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1216, '0', '2', '2', 75, NULL, '0', '0101801', ' (, ) - ', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1217, '0', '2', '2', 78, NULL, '0', '0101801', ' (, ) - ', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1218, '0', '2', '2', 81, NULL, '0', '0101801', ' (, ) - ', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1219, '0', '2', '2', 84, NULL, '0', '0101801', ' (, ) - ', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1220, '0', '2', '2', 87, NULL, '0', '0101801', ' (, ) - ', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1221, '0', '2', '2', 90, NULL, '0', '0101801', ' (, ) - ', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1222, '0', '2', '2', 93, NULL, '0', '0101801', ' (, ) - ', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1223, '0', '2', '2', 96, NULL, '0', '0101801', ' (, ) - ', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1224, '0', '2', '2', 99, NULL, '0', '0101801', ' (, ) - ', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1225, '0', '2', '2', 45, NULL, '0', '0319002', '', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1226, '0', '2', '2', 48, NULL, '0', '0319002', '', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1227, '0', '2', '2', 51, NULL, '0', '0319002', '', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1228, '0', '2', '2', 54, NULL, '0', '0319002', '', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1229, '0', '2', '2', 57, NULL, '0', '0319002', '', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1230, '0', '2', '2', 60, NULL, '0', '0319002', '', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1231, '0', '2', '2', 63, NULL, '0', '0319002', '', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1232, '0', '2', '2', 66, NULL, '0', '0319002', '', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1233, '0', '2', '2', 69, NULL, '0', '0319002', '', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1234, '0', '2', '2', 72, NULL, '0', '0319002', '', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1235, '0', '2', '2', 75, NULL, '0', '0319002', '', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1236, '0', '2', '2', 78, NULL, '0', '0319002', '', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1237, '0', '2', '2', 81, NULL, '0', '0319002', '', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1238, '0', '2', '2', 84, NULL, '0', '0319002', '', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1239, '0', '2', '2', 87, NULL, '0', '0319002', '', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1240, '0', '2', '2', 90, NULL, '0', '0319002', '', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1241, '0', '2', '2', 93, NULL, '0', '0319002', '', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1242, '0', '2', '2', 96, NULL, '0', '0319002', '', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1243, '0', '2', '2', 99, NULL, '0', '0319002', '', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1244, '0', '2', '2', 21, NULL, '0', '0100101', ' (, ) - ', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1245, '0', '2', '2', 24, NULL, '0', '0100101', ' (, ) - ', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1246, '0', '2', '2', 27, NULL, '0', '0100101', ' (, ) - ', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1247, '0', '2', '2', 30, NULL, '0', '0100101', ' (, ) - ', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1248, '0', '2', '2', 33, NULL, '0', '0100101', ' (, ) - ', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1249, '0', '2', '2', 36, NULL, '0', '0100101', ' (, ) - ', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1250, '0', '2', '2', 39, NULL, '0', '0100101', ' (, ) - ', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1251, '0', '2', '2', 42, NULL, '0', '0100101', ' (, ) - ', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1252, '0', '2', '2', 45, NULL, '0', '0100101', ' (, ) - ', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1253, '0', '2', '2', 48, NULL, '0', '0100101', ' (, ) - ', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1254, '0', '2', '2', 51, NULL, '0', '0100101', ' (, ) - ', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1255, '0', '2', '2', 54, NULL, '0', '0100101', ' (, ) - ', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1256, '0', '2', '2', 57, NULL, '0', '0100101', ' (, ) - ', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1257, '0', '2', '2', 60, NULL, '0', '0100101', ' (, ) - ', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1258, '0', '2', '2', 63, NULL, '0', '0100101', ' (, ) - ', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1259, '0', '2', '2', 66, NULL, '0', '0100101', ' (, ) - ', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1260, '0', '2', '2', 69, NULL, '0', '0100101', ' (, ) - ', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1261, '0', '2', '2', 72, NULL, '0', '0100101', ' (, ) - ', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1262, '0', '2', '2', 75, NULL, '0', '0100101', ' (, ) - ', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1263, '0', '2', '2', 78, NULL, '0', '0100101', ' (, ) - ', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1264, '0', '2', '2', 81, NULL, '0', '0100101', ' (, ) - ', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1265, '0', '2', '2', 84, NULL, '0', '0100101', ' (, ) - ', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1266, '0', '2', '2', 87, NULL, '0', '0100101', ' (, ) - ', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1267, '0', '2', '2', 90, NULL, '0', '0100101', ' (, ) - ', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1268, '0', '2', '2', 93, NULL, '0', '0100101', ' (, ) - ', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1269, '0', '2', '2', 96, NULL, '0', '0100101', ' (, ) - ', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1270, '0', '2', '2', 99, NULL, '0', '0100101', ' (, ) - ', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1271, '0', '2', '2', 21, NULL, '0', '0905084', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1272, '0', '2', '2', 24, NULL, '0', '0905084', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1273, '0', '2', '2', 27, NULL, '0', '0905084', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1274, '0', '2', '2', 30, NULL, '0', '0905084', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1275, '0', '2', '2', 33, NULL, '0', '0905084', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1276, '0', '2', '2', 36, NULL, '0', '0905084', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1277, '0', '2', '2', 39, NULL, '0', '0905084', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1278, '0', '2', '2', 42, NULL, '0', '0905084', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1279, '0', '2', '2', 45, NULL, '0', '0905084', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1280, '0', '2', '2', 48, NULL, '0', '0905084', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1281, '0', '2', '2', 51, NULL, '0', '0905084', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1282, '0', '2', '2', 54, NULL, '0', '0905084', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1283, '0', '2', '2', 57, NULL, '0', '0905084', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1284, '0', '2', '2', 60, NULL, '0', '0905084', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1285, '0', '2', '2', 63, NULL, '0', '0905084', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1286, '0', '2', '2', 66, NULL, '0', '0905084', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1287, '0', '2', '2', 69, NULL, '0', '0905084', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1288, '0', '2', '2', 72, NULL, '0', '0905084', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1289, '0', '2', '2', 75, NULL, '0', '0905084', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1290, '0', '2', '2', 78, NULL, '0', '0905084', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1291, '0', '2', '2', 81, NULL, '0', '0905084', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1292, '0', '2', '2', 84, NULL, '0', '0905084', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1293, '0', '2', '2', 87, NULL, '0', '0905084', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1294, '0', '2', '2', 90, NULL, '0', '0905084', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1295, '0', '2', '2', 93, NULL, '0', '0905084', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1296, '0', '2', '2', 96, NULL, '0', '0905084', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1297, '0', '2', '2', 99, NULL, '0', '0905084', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1298, '0', '2', '2', 39, NULL, '0', '0102901', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1299, '0', '2', '2', 42, NULL, '0', '0102901', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1300, '0', '2', '2', 45, NULL, '0', '0102901', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1301, '0', '2', '2', 48, NULL, '0', '0102901', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1302, '0', '2', '2', 51, NULL, '0', '0102901', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1303, '0', '2', '2', 54, NULL, '0', '0102901', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1304, '0', '2', '2', 57, NULL, '0', '0102901', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1305, '0', '2', '2', 60, NULL, '0', '0102901', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1306, '0', '2', '2', 63, NULL, '0', '0102901', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1307, '0', '2', '2', 66, NULL, '0', '0102901', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1308, '0', '2', '2', 69, NULL, '0', '0102901', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1309, '0', '2', '2', 72, NULL, '0', '0102901', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1310, '0', '2', '2', 75, NULL, '0', '0102901', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1311, '0', '2', '2', 78, NULL, '0', '0102901', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1312, '0', '2', '2', 81, NULL, '0', '0102901', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1313, '0', '2', '2', 84, NULL, '0', '0102901', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1314, '0', '2', '2', 87, NULL, '0', '0102901', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1315, '0', '2', '2', 90, NULL, '0', '0102901', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1316, '0', '2', '2', 93, NULL, '0', '0102901', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1317, '0', '2', '2', 96, NULL, '0', '0102901', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1318, '0', '2', '2', 99, NULL, '0', '0102901', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1319, '0', '2', '2', 21, NULL, '1', '0104701', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1320, '0', '2', '2', 24, NULL, '1', '0104701', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1321, '0', '2', '2', 27, NULL, '1', '0104701', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1322, '0', '2', '2', 30, NULL, '1', '0104701', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1323, '0', '2', '2', 33, NULL, '1', '0104701', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1324, '0', '2', '2', 36, NULL, '1', '0104701', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1325, '0', '2', '2', 39, NULL, '1', '0104701', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1326, '0', '2', '2', 42, NULL, '1', '0104701', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1327, '0', '2', '2', 45, NULL, '1', '0104701', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1328, '0', '2', '2', 48, NULL, '1', '0104701', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1329, '0', '2', '2', 51, NULL, '1', '0104701', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1330, '0', '2', '2', 54, NULL, '1', '0104701', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1331, '0', '2', '2', 57, NULL, '1', '0104701', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1332, '0', '2', '2', 60, NULL, '1', '0104701', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1333, '0', '2', '2', 63, NULL, '1', '0104701', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1334, '0', '2', '2', 66, NULL, '1', '0104701', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1335, '0', '2', '2', 69, NULL, '1', '0104701', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1336, '0', '2', '2', 72, NULL, '1', '0104701', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1337, '0', '2', '2', 75, NULL, '1', '0104701', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1338, '0', '2', '2', 78, NULL, '1', '0104701', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1339, '0', '2', '2', 81, NULL, '1', '0104701', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1340, '0', '2', '2', 84, NULL, '1', '0104701', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1341, '0', '2', '2', 87, NULL, '1', '0104701', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1342, '0', '2', '2', 90, NULL, '1', '0104701', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1343, '0', '2', '2', 93, NULL, '1', '0104701', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1344, '0', '2', '2', 96, NULL, '1', '0104701', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1345, '0', '2', '2', 99, NULL, '1', '0104701', ' (, ) -', 0, '1', NULL, '2014-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1346, '0', '2', '2', 21, NULL, '0', '0905027', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1347, '0', '2', '2', 24, NULL, '0', '0905027', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1348, '0', '2', '2', 27, NULL, '0', '0905027', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1349, '0', '2', '2', 30, NULL, '0', '0905027', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1350, '0', '2', '2', 33, NULL, '0', '0905027', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1351, '0', '2', '2', 36, NULL, '0', '0905027', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1352, '0', '2', '2', 39, NULL, '0', '0905027', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1353, '0', '2', '2', 42, NULL, '0', '0905027', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1354, '0', '2', '2', 45, NULL, '0', '0905027', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1355, '0', '2', '2', 48, NULL, '0', '0905027', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1356, '0', '2', '2', 51, NULL, '0', '0905027', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1357, '0', '2', '2', 54, NULL, '0', '0905027', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1358, '0', '2', '2', 57, NULL, '0', '0905027', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1359, '0', '2', '2', 60, NULL, '0', '0905027', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1360, '0', '2', '2', 63, NULL, '0', '0905027', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1361, '0', '2', '2', 66, NULL, '0', '0905027', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1362, '0', '2', '2', 69, NULL, '0', '0905027', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1363, '0', '2', '2', 72, NULL, '0', '0905027', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1364, '0', '2', '2', 75, NULL, '0', '0905027', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1365, '0', '2', '2', 78, NULL, '0', '0905027', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1366, '0', '2', '2', 81, NULL, '0', '0905027', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1367, '0', '2', '2', 84, NULL, '0', '0905027', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1368, '0', '2', '2', 87, NULL, '0', '0905027', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1369, '0', '2', '2', 90, NULL, '0', '0905027', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1370, '0', '2', '2', 93, NULL, '0', '0905027', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1371, '0', '2', '2', 96, NULL, '0', '0905027', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1372, '0', '2', '2', 99, NULL, '0', '0905027', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1373, '0', '2', '2', 21, NULL, '0', '0905028', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1374, '0', '2', '2', 24, NULL, '0', '0905028', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1375, '0', '2', '2', 27, NULL, '0', '0905028', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1376, '0', '2', '2', 30, NULL, '0', '0905028', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1377, '0', '2', '2', 33, NULL, '0', '0905028', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1378, '0', '2', '2', 36, NULL, '0', '0905028', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1379, '0', '2', '2', 39, NULL, '0', '0905028', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1380, '0', '2', '2', 42, NULL, '0', '0905028', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1381, '0', '2', '2', 45, NULL, '0', '0905028', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1382, '0', '2', '2', 48, NULL, '0', '0905028', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1383, '0', '2', '2', 51, NULL, '0', '0905028', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1384, '0', '2', '2', 54, NULL, '0', '0905028', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1385, '0', '2', '2', 57, NULL, '0', '0905028', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1386, '0', '2', '2', 60, NULL, '0', '0905028', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1387, '0', '2', '2', 63, NULL, '0', '0905028', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1388, '0', '2', '2', 66, NULL, '0', '0905028', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1389, '0', '2', '2', 69, NULL, '0', '0905028', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1390, '0', '2', '2', 72, NULL, '0', '0905028', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1391, '0', '2', '2', 75, NULL, '0', '0905028', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1392, '0', '2', '2', 78, NULL, '0', '0905028', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1393, '0', '2', '2', 81, NULL, '0', '0905028', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1394, '0', '2', '2', 84, NULL, '0', '0905028', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1395, '0', '2', '2', 87, NULL, '0', '0905028', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1396, '0', '2', '2', 90, NULL, '0', '0905028', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1397, '0', '2', '2', 93, NULL, '0', '0905028', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1398, '0', '2', '2', 96, NULL, '0', '0905028', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1399, '0', '2', '2', 99, NULL, '0', '0905028', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1400, '0', '2', '2', 21, NULL, '0', '0905025', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1401, '0', '2', '2', 24, NULL, '0', '0905025', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1402, '0', '2', '2', 27, NULL, '0', '0905025', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1403, '0', '2', '2', 30, NULL, '0', '0905025', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1404, '0', '2', '2', 33, NULL, '0', '0905025', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1405, '0', '2', '2', 36, NULL, '0', '0905025', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1406, '0', '2', '2', 39, NULL, '0', '0905025', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1407, '0', '2', '2', 42, NULL, '0', '0905025', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1408, '0', '2', '2', 45, NULL, '0', '0905025', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1409, '0', '2', '2', 48, NULL, '0', '0905025', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1410, '0', '2', '2', 51, NULL, '0', '0905025', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1411, '0', '2', '2', 54, NULL, '0', '0905025', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1412, '0', '2', '2', 57, NULL, '0', '0905025', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1413, '0', '2', '2', 60, NULL, '0', '0905025', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1414, '0', '2', '2', 63, NULL, '0', '0905025', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1415, '0', '2', '2', 66, NULL, '0', '0905025', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1416, '0', '2', '2', 69, NULL, '0', '0905025', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1417, '0', '2', '2', 72, NULL, '0', '0905025', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1418, '0', '2', '2', 75, NULL, '0', '0905025', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1419, '0', '2', '2', 78, NULL, '0', '0905025', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1420, '0', '2', '2', 81, NULL, '0', '0905025', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1421, '0', '2', '2', 84, NULL, '0', '0905025', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1422, '0', '2', '2', 87, NULL, '0', '0905025', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1423, '0', '2', '2', 90, NULL, '0', '0905025', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1424, '0', '2', '2', 93, NULL, '0', '0905025', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1425, '0', '2', '2', 96, NULL, '0', '0905025', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1426, '0', '2', '2', 99, NULL, '0', '0905025', '    ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1427, '0', '2', '2', 21, NULL, '0', '0107401', '    /    ( )   ()     ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1428, '0', '2', '2', 24, NULL, '0', '0107401', '    /    ( )   ()     ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1429, '0', '2', '2', 27, NULL, '0', '0107401', '    /    ( )   ()     ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1430, '0', '2', '2', 30, NULL, '0', '0107401', '    /    ( )   ()     ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1431, '0', '2', '2', 33, NULL, '0', '0107401', '    /    ( )   ()     ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1432, '0', '2', '2', 36, NULL, '0', '0107401', '    /    ( )   ()     ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1433, '0', '2', '2', 39, NULL, '0', '0107401', '    /    ( )   ()     ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1434, '0', '2', '2', 42, NULL, '0', '0107401', '    /    ( )   ()     ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1435, '0', '2', '2', 45, NULL, '0', '0107401', '    /    ( )   ()     ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1436, '0', '2', '2', 48, NULL, '0', '0107401', '    /    ( )   ()     ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1437, '0', '2', '2', 51, NULL, '0', '0107401', '    /    ( )   ()     ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1438, '0', '2', '2', 54, NULL, '0', '0107401', '    /    ( )   ()     ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1439, '0', '2', '2', 57, NULL, '0', '0107401', '    /    ( )   ()     ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1440, '0', '2', '2', 60, NULL, '0', '0107401', '    /    ( )   ()     ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1441, '0', '2', '2', 63, NULL, '0', '0107401', '    /    ( )   ()     ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1442, '0', '2', '2', 66, NULL, '0', '0107401', '    /    ( )   ()     ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1443, '0', '2', '2', 69, NULL, '0', '0107401', '    /    ( )   ()     ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1444, '0', '2', '2', 72, NULL, '0', '0107401', '    /    ( )   ()     ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1445, '0', '2', '2', 75, NULL, '0', '0107401', '    /    ( )   ()     ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1446, '0', '2', '2', 78, NULL, '0', '0107401', '    /    ( )   ()     ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1447, '0', '2', '2', 81, NULL, '0', '0107401', '    /    ( )   ()     ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1448, '0', '2', '2', 84, NULL, '0', '0107401', '    /    ( )   ()     ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1449, '0', '2', '2', 87, NULL, '0', '0107401', '    /    ( )   ()     ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1450, '0', '2', '2', 90, NULL, '0', '0107401', '    /    ( )   ()     ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1451, '0', '2', '2', 93, NULL, '0', '0107401', '    /    ( )   ()     ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1452, '0', '2', '2', 96, NULL, '0', '0107401', '    /    ( )   ()     ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1453, '0', '2', '2', 99, NULL, '0', '0107401', '    /    ( )   ()     ', 0, '0', NULL, '2014-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1454, '0', '1', '2', NULL, 44, '0', '0510001', ' ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1455, '0', '1', '2', NULL, 44, '0', '0510007', ',     ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1456, '1', '1', '1', 0, NULL, '1', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1457, '1', '1', '1', 1, NULL, '1', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1458, '1', '1', '1', 2, NULL, '1', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1459, '1', '1', '1', 3, NULL, '1', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1460, '1', '1', '1', 4, NULL, '1', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1461, '1', '1', '1', 5, NULL, '1', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1462, '1', '1', '1', 6, NULL, '1', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1463, '1', '1', '1', 7, NULL, '1', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1464, '1', '1', '1', 8, NULL, '1', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1465, '1', '1', '1', 9, NULL, '1', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1466, '1', '1', '1', 10, NULL, '1', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1467, '1', '1', '1', 11, NULL, '1', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1468, '1', '1', '1', 12, NULL, '1', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1469, '1', '1', '1', 13, NULL, '1', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1470, '1', '1', '1', 14, NULL, '1', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1471, '1', '1', '1', 15, NULL, '1', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1472, '1', '1', '1', 16, NULL, '1', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1473, '1', '1', '1', 17, NULL, '1', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1474, '1', '1', '1', 0, NULL, '1', '0301606', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1475, '1', '1', '1', 1, NULL, '1', '0301606', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1476, '1', '1', '1', 2, NULL, '1', '0301606', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1477, '1', '1', '1', 3, NULL, '1', '0301606', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1478, '1', '1', '1', 4, NULL, '1', '0301606', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1479, '1', '1', '1', 5, NULL, '1', '0301606', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1480, '1', '1', '1', 6, NULL, '1', '0301606', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1481, '1', '1', '1', 7, NULL, '1', '0301606', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1482, '1', '1', '1', 8, NULL, '1', '0301606', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1483, '1', '1', '1', 9, NULL, '1', '0301606', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1484, '1', '1', '1', 10, NULL, '1', '0301606', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1485, '1', '1', '1', 11, NULL, '1', '0301606', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1486, '1', '1', '1', 12, NULL, '1', '0301606', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1487, '1', '1', '1', 13, NULL, '1', '0301606', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1488, '1', '1', '1', 14, NULL, '1', '0301606', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1489, '1', '1', '1', 15, NULL, '1', '0301606', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1490, '1', '1', '1', 16, NULL, '1', '0301606', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1491, '1', '1', '1', 17, NULL, '1', '0301606', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1492, '1', '1', '1', 0, NULL, '1', '0510001', ' ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1493, '1', '1', '1', 1, NULL, '1', '0510001', ' ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1494, '1', '1', '1', 2, NULL, '1', '0510001', ' ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1495, '1', '1', '1', 3, NULL, '1', '0510001', ' ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1496, '1', '1', '1', 4, NULL, '1', '0510001', ' ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1498, '1', '1', '1', 6, NULL, '1', '0510001', ' ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1499, '1', '1', '1', 7, NULL, '1', '0510001', ' ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1500, '1', '1', '1', 8, NULL, '1', '0510001', ' ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1501, '1', '1', '1', 9, NULL, '1', '0510001', ' ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1502, '1', '1', '1', 10, NULL, '1', '0510001', ' ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1503, '1', '1', '1', 11, NULL, '1', '0510001', ' ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1504, '1', '1', '1', 12, NULL, '1', '0510001', ' ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1505, '1', '1', '1', 13, NULL, '1', '0510001', ' ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1506, '1', '1', '1', 14, NULL, '1', '0510001', ' ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1507, '1', '1', '1', 15, NULL, '1', '0510001', ' ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1508, '1', '1', '1', 16, NULL, '1', '0510001', ' ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1509, '1', '1', '1', 17, NULL, '1', '0510001', ' ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1510, '1', '1', '1', 0, NULL, '1', '0404001', '   ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1511, '1', '1', '1', 0, NULL, '1', '0428001', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1512, '1', '1', '1', 1, NULL, '1', '0428001', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1513, '1', '1', '1', 2, NULL, '1', '0428001', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1514, '1', '1', '1', 3, NULL, '1', '0428001', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1515, '1', '1', '1', 4, NULL, '1', '0428001', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1516, '1', '1', '1', 5, NULL, '1', '0428001', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1517, '1', '1', '1', 6, NULL, '1', '0428001', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1518, '1', '1', '1', 7, NULL, '1', '0428001', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1519, '1', '1', '1', 8, NULL, '1', '0428001', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1520, '1', '1', '1', 9, NULL, '1', '0428001', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1521, '1', '1', '1', 10, NULL, '1', '0428001', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1522, '1', '1', '1', 11, NULL, '1', '0428001', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1523, '1', '1', '1', 12, NULL, '1', '0428001', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1524, '1', '1', '1', 13, NULL, '1', '0428001', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1525, '1', '1', '1', 14, NULL, '1', '0428001', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1526, '1', '1', '1', 15, NULL, '1', '0428001', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1527, '1', '1', '1', 16, NULL, '1', '0428001', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1528, '1', '1', '1', 17, NULL, '1', '0428001', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1529, '1', '1', '1', 0, NULL, '1', '0414000', '     ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1530, '1', '1', '1', 1, NULL, '1', '0414000', '     ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1531, '1', '1', '1', 2, NULL, '1', '0414000', '     ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1532, '1', '1', '1', 3, NULL, '1', '0414000', '     ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1533, '1', '1', '1', 4, NULL, '1', '0414000', '     ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1534, '1', '1', '1', 5, NULL, '1', '0414000', '     ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1535, '1', '1', '1', 6, NULL, '1', '0414000', '     ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1536, '1', '1', '1', 7, NULL, '1', '0414000', '     ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1537, '1', '1', '1', 8, NULL, '1', '0414000', '     ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1538, '1', '1', '1', 9, NULL, '1', '0414000', '     ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1539, '1', '1', '1', 10, NULL, '1', '0414000', '     ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1540, '1', '1', '1', 11, NULL, '1', '0414000', '     ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1541, '1', '1', '1', 12, NULL, '1', '0414000', '     ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1542, '1', '1', '1', 13, NULL, '1', '0414000', '     ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1543, '1', '1', '1', 14, NULL, '1', '0414000', '     ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1544, '1', '1', '1', 15, NULL, '1', '0414000', '     ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1545, '1', '1', '1', 16, NULL, '1', '0414000', '     ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1546, '1', '1', '1', 17, NULL, '1', '0414000', '     ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1547, '1', '1', '1', 0, NULL, '1', '0410002', '', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1548, '1', '1', '1', 1, NULL, '1', '0410002', '', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1549, '1', '1', '1', 2, NULL, '1', '0410002', '', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1550, '1', '1', '1', 3, NULL, '1', '0410002', '', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1551, '1', '1', '1', 4, NULL, '1', '0410002', '', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1552, '1', '1', '1', 5, NULL, '1', '0410002', '', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1553, '1', '1', '1', 6, NULL, '1', '0410002', '', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1554, '1', '1', '1', 7, NULL, '1', '0410002', '', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1555, '1', '1', '1', 8, NULL, '1', '0410002', '', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1556, '1', '1', '1', 9, NULL, '1', '0410002', '', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1557, '1', '1', '1', 10, NULL, '1', '0410002', '', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1558, '1', '1', '1', 11, NULL, '1', '0410002', '', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1559, '1', '1', '1', 12, NULL, '1', '0410002', '', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1560, '1', '1', '1', 13, NULL, '1', '0410002', '', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1561, '1', '1', '1', 14, NULL, '1', '0410002', '', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1562, '1', '1', '1', 15, NULL, '1', '0410002', '', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1563, '1', '1', '1', 16, NULL, '1', '0410002', '', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1564, '1', '1', '1', 17, NULL, '1', '0410002', '', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1565, '1', '1', '1', 0, NULL, '1', '0403102', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1566, '1', '1', '1', 1, NULL, '1', '0403102', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1567, '1', '1', '1', 2, NULL, '1', '0403102', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1568, '1', '1', '1', 3, NULL, '1', '0403102', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1569, '1', '1', '1', 4, NULL, '1', '0403102', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1570, '1', '1', '1', 5, NULL, '1', '0403102', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1571, '1', '1', '1', 6, NULL, '1', '0403102', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1572, '1', '1', '1', 7, NULL, '1', '0403102', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1573, '1', '1', '1', 8, NULL, '1', '0403102', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1574, '1', '1', '1', 9, NULL, '1', '0403102', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1575, '1', '1', '1', 10, NULL, '1', '0403102', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1576, '1', '1', '1', 11, NULL, '1', '0403102', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1577, '1', '1', '1', 12, NULL, '1', '0403102', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1578, '1', '1', '1', 13, NULL, '1', '0403102', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1579, '1', '1', '1', 14, NULL, '1', '0403102', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1580, '1', '1', '1', 15, NULL, '1', '0403102', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1581, '1', '1', '1', 16, NULL, '1', '0403102', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1582, '1', '1', '1', 17, NULL, '1', '0403102', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1583, '1', '1', '1', 0, NULL, '1', '0402302', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1584, '1', '1', '1', 1, NULL, '1', '0402302', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1585, '1', '1', '1', 2, NULL, '1', '0402302', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1586, '1', '1', '1', 3, NULL, '1', '0402302', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1587, '1', '1', '1', 4, NULL, '1', '0402302', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1588, '1', '1', '1', 5, NULL, '1', '0402302', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1589, '1', '1', '1', 6, NULL, '1', '0402302', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1590, '1', '1', '1', 7, NULL, '1', '0402302', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1591, '1', '1', '1', 8, NULL, '1', '0402302', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1592, '1', '1', '1', 9, NULL, '1', '0402302', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1593, '1', '1', '1', 10, NULL, '1', '0402302', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1594, '1', '1', '1', 11, NULL, '1', '0402302', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1595, '1', '1', '1', 12, NULL, '1', '0402302', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1596, '1', '1', '1', 13, NULL, '1', '0402302', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1597, '1', '1', '1', 14, NULL, '1', '0402302', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1598, '1', '1', '1', 15, NULL, '1', '0402302', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1599, '1', '1', '1', 16, NULL, '1', '0402302', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1600, '1', '1', '1', 17, NULL, '1', '0402302', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1601, '1', '1', '1', 0, NULL, '1', '0402902', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1602, '1', '1', '1', 1, NULL, '1', '0402902', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1603, '1', '1', '1', 2, NULL, '1', '0402902', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1604, '1', '1', '1', 3, NULL, '1', '0402902', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1605, '1', '1', '1', 4, NULL, '1', '0402902', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1606, '1', '1', '1', 5, NULL, '1', '0402902', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1607, '1', '1', '1', 6, NULL, '1', '0402902', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1608, '1', '1', '1', 7, NULL, '1', '0402902', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1609, '1', '1', '1', 8, NULL, '1', '0402902', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1610, '1', '1', '1', 9, NULL, '1', '0402902', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1611, '1', '1', '1', 10, NULL, '1', '0402902', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1612, '1', '1', '1', 11, NULL, '1', '0402902', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1613, '1', '1', '1', 12, NULL, '1', '0402902', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1614, '1', '1', '1', 13, NULL, '1', '0402902', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1615, '1', '1', '1', 14, NULL, '1', '0402902', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1616, '1', '1', '1', 15, NULL, '1', '0402902', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1617, '1', '1', '1', 16, NULL, '1', '0402902', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1618, '1', '1', '1', 17, NULL, '1', '0402902', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1619, '1', '1', '1', 0, NULL, '1', '0401002', ' (, ) -  ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1620, '1', '1', '1', 1, NULL, '1', '0401002', ' (, ) -  ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1621, '1', '1', '1', 2, NULL, '1', '0401002', ' (, ) -  ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1622, '1', '1', '1', 3, NULL, '1', '0401002', ' (, ) -  ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1623, '1', '1', '1', 4, NULL, '1', '0401002', ' (, ) -  ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1624, '1', '1', '1', 5, NULL, '1', '0401002', ' (, ) -  ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1625, '1', '1', '1', 6, NULL, '1', '0401002', ' (, ) -  ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1626, '1', '1', '1', 7, NULL, '1', '0401002', ' (, ) -  ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1627, '1', '1', '1', 8, NULL, '1', '0401002', ' (, ) -  ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1628, '1', '1', '1', 9, NULL, '1', '0401002', ' (, ) -  ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1629, '1', '1', '1', 10, NULL, '1', '0401002', ' (, ) -  ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1630, '1', '1', '1', 11, NULL, '1', '0401002', ' (, ) -  ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1631, '1', '1', '1', 12, NULL, '1', '0401002', ' (, ) -  ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1632, '1', '1', '1', 13, NULL, '1', '0401002', ' (, ) -  ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1633, '1', '1', '1', 14, NULL, '1', '0401002', ' (, ) -  ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1634, '1', '1', '1', 15, NULL, '1', '0401002', ' (, ) -  ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1635, '1', '1', '1', 16, NULL, '1', '0401002', ' (, ) -  ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1636, '1', '1', '1', 17, NULL, '1', '0401002', ' (, ) -  ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1637, '1', '1', '1', 0, NULL, '1', '0402802', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1638, '1', '1', '1', 1, NULL, '1', '0402802', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1639, '1', '1', '1', 2, NULL, '1', '0402802', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1640, '1', '1', '1', 3, NULL, '1', '0402802', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1641, '1', '1', '1', 4, NULL, '1', '0402802', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1642, '1', '1', '1', 5, NULL, '1', '0402802', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1643, '1', '1', '1', 6, NULL, '1', '0402802', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1644, '1', '1', '1', 7, NULL, '1', '0402802', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1645, '1', '1', '1', 8, NULL, '1', '0402802', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1646, '1', '1', '1', 9, NULL, '1', '0402802', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1647, '1', '1', '1', 10, NULL, '1', '0402802', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1648, '1', '1', '1', 11, NULL, '1', '0402802', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1649, '1', '1', '1', 12, NULL, '1', '0402802', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1650, '1', '1', '1', 13, NULL, '1', '0402802', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1651, '1', '1', '1', 14, NULL, '1', '0402802', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1652, '1', '1', '1', 15, NULL, '1', '0402802', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1653, '1', '1', '1', 16, NULL, '1', '0402802', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1654, '1', '1', '1', 17, NULL, '1', '0402802', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1655, '1', '1', '1', 3, NULL, '1', '0406402', ' (, ) -  ', NULL, '1', 2.5, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1656, '1', '1', '1', 4, NULL, '1', '0406402', ' (, ) -  ', NULL, '1', 2.5, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1657, '1', '1', '1', 5, NULL, '1', '0406402', ' (, ) -  ', NULL, '1', 2.5, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1658, '1', '1', '1', 6, NULL, '1', '0406402', ' (, ) -  ', NULL, '1', 2.5, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1659, '1', '1', '1', 7, NULL, '1', '0406402', ' (, ) -  ', NULL, '1', 2.5, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1660, '1', '1', '1', 8, NULL, '1', '0406402', ' (, ) -  ', NULL, '1', 2.5, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1661, '1', '1', '1', 9, NULL, '1', '0406402', ' (, ) -  ', NULL, '1', 2.5, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1662, '1', '1', '1', 10, NULL, '1', '0406402', ' (, ) -  ', NULL, '1', 2.5, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1663, '1', '1', '1', 11, NULL, '1', '0406402', ' (, ) -  ', NULL, '1', 2.5, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1664, '1', '1', '1', 12, NULL, '1', '0406402', ' (, ) -  ', NULL, '1', 2.5, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1665, '1', '1', '1', 13, NULL, '1', '0406402', ' (, ) -  ', NULL, '1', 2.5, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1666, '1', '1', '1', 14, NULL, '1', '0406402', ' (, ) -  ', NULL, '1', 2.5, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1667, '1', '1', '1', 15, NULL, '1', '0406402', ' (, ) -  ', NULL, '1', 2.5, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1668, '1', '1', '1', 16, NULL, '1', '0406402', ' (, ) -  ', NULL, '1', 2.5, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1669, '1', '1', '1', 17, NULL, '1', '0406402', ' (, ) -  ', NULL, '1', 2.5, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1670, '1', '1', '1', 0, NULL, '1', '0405002', ' (, ) -,  ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1671, '1', '1', '1', 1, NULL, '1', '0405002', ' (, ) -,  ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1672, '1', '1', '1', 2, NULL, '1', '0405002', ' (, ) -,  ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1673, '1', '1', '1', 3, NULL, '1', '0405002', ' (, ) -,  ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1674, '1', '1', '1', 4, NULL, '1', '0405002', ' (, ) -,  ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1675, '1', '1', '1', 5, NULL, '1', '0405002', ' (, ) -,  ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1676, '1', '1', '1', 6, NULL, '1', '0405002', ' (, ) -,  ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1677, '1', '1', '1', 7, NULL, '1', '0405002', ' (, ) -,  ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1678, '1', '1', '1', 8, NULL, '1', '0405002', ' (, ) -,  ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1679, '1', '1', '1', 9, NULL, '1', '0405002', ' (, ) -,  ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1680, '1', '1', '1', 10, NULL, '1', '0405002', ' (, ) -,  ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1681, '1', '1', '1', 11, NULL, '1', '0405002', ' (, ) -,  ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1682, '1', '1', '1', 12, NULL, '1', '0405002', ' (, ) -,  ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1683, '1', '1', '1', 13, NULL, '1', '0405002', ' (, ) -,  ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1684, '1', '1', '1', 14, NULL, '1', '0405002', ' (, ) -,  ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1685, '1', '1', '1', 15, NULL, '1', '0405002', ' (, ) -,  ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1686, '1', '1', '1', 16, NULL, '1', '0405002', ' (, ) -,  ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1687, '1', '1', '1', 17, NULL, '1', '0405002', ' (, ) -,  ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1688, '1', '1', '1', 0, NULL, '1', '0403502', ' (, ) - ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1689, '1', '1', '1', 1, NULL, '1', '0403502', ' (, ) - ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1690, '1', '1', '1', 2, NULL, '1', '0403502', ' (, ) - ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1691, '1', '1', '1', 3, NULL, '1', '0403502', ' (, ) - ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1692, '1', '1', '1', 4, NULL, '1', '0403502', ' (, ) - ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1693, '1', '1', '1', 5, NULL, '1', '0403502', ' (, ) - ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1694, '1', '1', '1', 6, NULL, '1', '0403502', ' (, ) - ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1695, '1', '1', '1', 7, NULL, '1', '0403502', ' (, ) - ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1696, '1', '1', '1', 8, NULL, '1', '0403502', ' (, ) - ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1697, '1', '1', '1', 9, NULL, '1', '0403502', ' (, ) - ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1698, '1', '1', '1', 10, NULL, '1', '0403502', ' (, ) - ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1699, '1', '1', '1', 11, NULL, '1', '0403502', ' (, ) - ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1700, '1', '1', '1', 12, NULL, '1', '0403502', ' (, ) - ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1701, '1', '1', '1', 13, NULL, '1', '0403502', ' (, ) - ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1702, '1', '1', '1', 14, NULL, '1', '0403502', ' (, ) - ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1703, '1', '1', '1', 15, NULL, '1', '0403502', ' (, ) - ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1704, '1', '1', '1', 16, NULL, '1', '0403502', ' (, ) - ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1705, '1', '1', '1', 17, NULL, '1', '0403502', ' (, ) - ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1706, '1', '1', '1', 0, NULL, '1', '0405302', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1707, '1', '1', '1', 1, NULL, '1', '0405302', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1708, '1', '1', '1', 2, NULL, '1', '0405302', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1709, '1', '1', '1', 3, NULL, '1', '0405302', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1710, '1', '1', '1', 4, NULL, '1', '0405302', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1711, '1', '1', '1', 5, NULL, '1', '0405302', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1712, '1', '1', '1', 6, NULL, '1', '0405302', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1713, '1', '1', '1', 7, NULL, '1', '0405302', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1714, '1', '1', '1', 8, NULL, '1', '0405302', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1715, '1', '1', '1', 9, NULL, '1', '0405302', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1716, '1', '1', '1', 10, NULL, '1', '0405302', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1717, '1', '1', '1', 11, NULL, '1', '0405302', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1718, '1', '1', '1', 12, NULL, '1', '0405302', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1719, '1', '1', '1', 13, NULL, '1', '0405302', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1720, '1', '1', '1', 14, NULL, '1', '0405302', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1721, '1', '1', '1', 15, NULL, '1', '0405302', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1722, '1', '1', '1', 16, NULL, '1', '0405302', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1723, '1', '1', '1', 17, NULL, '1', '0405302', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1724, '1', '1', '1', 5, NULL, '1', '0101101', ' (, ) -  ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1725, '1', '1', '1', 6, NULL, '1', '0101101', ' (, ) -  ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1726, '1', '1', '1', 7, NULL, '1', '0101101', ' (, ) -  ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1727, '1', '1', '1', 8, NULL, '1', '0101101', ' (, ) -  ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1728, '1', '1', '1', 9, NULL, '1', '0101101', ' (, ) -  ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1729, '1', '1', '1', 10, NULL, '1', '0101101', ' (, ) -  ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1730, '1', '1', '1', 11, NULL, '1', '0101101', ' (, ) -  ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1731, '1', '1', '1', 12, NULL, '1', '0101101', ' (, ) -  ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1732, '1', '1', '1', 13, NULL, '1', '0101101', ' (, ) -  ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1733, '1', '1', '1', 14, NULL, '1', '0101101', ' (, ) -  ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1734, '1', '1', '1', 15, NULL, '1', '0101101', ' (, ) -  ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1735, '1', '1', '1', 16, NULL, '1', '0101101', ' (, ) -  ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1736, '1', '1', '1', 17, NULL, '1', '0101101', ' (, ) -  ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1737, '1', '1', '1', 0, NULL, '1', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1738, '1', '1', '1', 1, NULL, '1', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1739, '1', '1', '1', 2, NULL, '1', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1740, '1', '1', '1', 3, NULL, '1', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1741, '1', '1', '1', 4, NULL, '1', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1742, '1', '1', '1', 5, NULL, '1', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1743, '1', '1', '1', 6, NULL, '1', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1744, '1', '1', '1', 7, NULL, '1', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1745, '1', '1', '1', 8, NULL, '1', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1746, '1', '1', '1', 9, NULL, '1', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1747, '1', '1', '1', 10, NULL, '1', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1748, '1', '1', '1', 11, NULL, '1', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1749, '1', '1', '1', 12, NULL, '1', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1750, '1', '1', '1', 13, NULL, '1', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1751, '1', '1', '1', 14, NULL, '1', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1752, '1', '1', '1', 15, NULL, '1', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1753, '1', '1', '1', 16, NULL, '1', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1754, '1', '1', '1', 17, NULL, '1', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1755, '1', '1', '1', 15, NULL, '0', '0609007', ' ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1756, '1', '1', '1', 16, NULL, '0', '0609007', ' ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1757, '1', '1', '1', 17, NULL, '0', '0609007', ' ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1758, '1', '1', '1', 7, NULL, '1', '0422001', '   ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1759, '1', '1', '1', 8, NULL, '1', '0422001', '   ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1760, '1', '1', '1', 9, NULL, '1', '0422001', '   ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1761, '1', '1', '1', 10, NULL, '1', '0422001', '   ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1762, '1', '1', '1', 11, NULL, '1', '0422001', '   ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1763, '1', '1', '1', 12, NULL, '1', '0422001', '   ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1764, '1', '1', '1', 13, NULL, '1', '0422001', '   ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1765, '1', '1', '1', 14, NULL, '1', '0422001', '   ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1766, '1', '1', '1', 15, NULL, '1', '0422001', '   ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1767, '1', '1', '1', 16, NULL, '1', '0422001', '   ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1768, '1', '1', '1', 17, NULL, '1', '0422001', '   ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1769, '1', '1', '1', 0, NULL, '1', '0423001', '   ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1770, '1', '1', '1', 7, NULL, '1', '0421001', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1771, '1', '1', '1', 8, NULL, '1', '0421001', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1772, '1', '1', '1', 9, NULL, '1', '0421001', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1773, '1', '1', '1', 10, NULL, '1', '0421001', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1774, '1', '1', '1', 11, NULL, '1', '0421001', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1775, '1', '1', '1', 12, NULL, '1', '0421001', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1776, '1', '1', '1', 13, NULL, '1', '0421001', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1777, '1', '1', '1', 14, NULL, '1', '0421001', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1778, '1', '1', '1', 15, NULL, '1', '0421001', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1779, '1', '1', '1', 16, NULL, '1', '0421001', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1780, '1', '1', '1', 17, NULL, '1', '0421001', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1781, '1', '1', '1', 7, NULL, '1', '0421002', '   (, )', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1782, '1', '1', '1', 8, NULL, '1', '0421002', '   (, )', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1783, '1', '1', '1', 9, NULL, '1', '0421002', '   (, )', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1784, '1', '1', '1', 10, NULL, '1', '0421002', '   (, )', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1785, '1', '1', '1', 11, NULL, '1', '0421002', '   (, )', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1786, '1', '1', '1', 12, NULL, '1', '0421002', '   (, )', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1787, '1', '1', '1', 13, NULL, '1', '0421002', '   (, )', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1788, '1', '1', '1', 14, NULL, '1', '0421002', '   (, )', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1789, '1', '1', '1', 15, NULL, '1', '0421002', '   (, )', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1790, '1', '1', '1', 16, NULL, '1', '0421002', '   (, )', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1791, '1', '1', '1', 17, NULL, '1', '0421002', '   (, )', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1792, '1', '1', '1', 7, NULL, '1', '0421003', '   ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1793, '1', '1', '1', 8, NULL, '1', '0421003', '   ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1794, '1', '1', '1', 9, NULL, '1', '0421003', '   ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1795, '1', '1', '1', 10, NULL, '1', '0421003', '   ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1796, '1', '1', '1', 11, NULL, '1', '0421003', '   ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1797, '1', '1', '1', 12, NULL, '1', '0421003', '   ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1798, '1', '1', '1', 13, NULL, '1', '0421003', '   ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1799, '1', '1', '1', 14, NULL, '1', '0421003', '   ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1800, '1', '1', '1', 15, NULL, '1', '0421003', '   ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1801, '1', '1', '1', 16, NULL, '1', '0421003', '   ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1802, '1', '1', '1', 17, NULL, '1', '0421003', '   ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1803, '1', '1', '2', 0, NULL, '1', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1804, '1', '1', '2', 1, NULL, '1', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1805, '1', '1', '2', 2, NULL, '1', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1806, '1', '1', '2', 3, NULL, '1', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1807, '1', '1', '2', 4, NULL, '1', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1808, '1', '1', '2', 5, NULL, '1', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1809, '1', '1', '2', 6, NULL, '1', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1810, '1', '1', '2', 7, NULL, '1', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1811, '1', '1', '2', 8, NULL, '1', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1812, '1', '1', '2', 9, NULL, '1', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1813, '1', '1', '2', 10, NULL, '1', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1814, '1', '1', '2', 11, NULL, '1', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1815, '1', '1', '2', 12, NULL, '1', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1816, '1', '1', '2', 13, NULL, '1', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1817, '1', '1', '2', 14, NULL, '1', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1818, '1', '1', '2', 15, NULL, '1', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1819, '1', '1', '2', 16, NULL, '1', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1820, '1', '1', '2', 17, NULL, '1', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1821, '1', '1', '2', 0, NULL, '1', '0301606', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1822, '1', '1', '2', 1, NULL, '1', '0301606', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1823, '1', '1', '2', 2, NULL, '1', '0301606', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1824, '1', '1', '2', 3, NULL, '1', '0301606', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1825, '1', '1', '2', 4, NULL, '1', '0301606', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1826, '1', '1', '2', 5, NULL, '1', '0301606', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1827, '1', '1', '2', 6, NULL, '1', '0301606', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1828, '1', '1', '2', 7, NULL, '1', '0301606', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1829, '1', '1', '2', 8, NULL, '1', '0301606', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1830, '1', '1', '2', 9, NULL, '1', '0301606', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1831, '1', '1', '2', 10, NULL, '1', '0301606', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1832, '1', '1', '2', 11, NULL, '1', '0301606', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1833, '1', '1', '2', 12, NULL, '1', '0301606', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1834, '1', '1', '2', 13, NULL, '1', '0301606', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1835, '1', '1', '2', 14, NULL, '1', '0301606', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1836, '1', '1', '2', 15, NULL, '1', '0301606', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1837, '1', '1', '2', 16, NULL, '1', '0301606', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1838, '1', '1', '2', 17, NULL, '1', '0301606', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1839, '1', '1', '2', 0, NULL, '1', '0510001', ' ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1840, '1', '1', '2', 1, NULL, '1', '0510001', ' ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1841, '1', '1', '2', 2, NULL, '1', '0510001', ' ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1842, '1', '1', '2', 3, NULL, '1', '0510001', ' ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1843, '1', '1', '2', 4, NULL, '1', '0510001', ' ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1844, '1', '1', '2', 5, NULL, '1', '0510001', ' ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1845, '1', '1', '2', 6, NULL, '1', '0510001', ' ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1846, '1', '1', '2', 7, NULL, '1', '0510001', ' ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1847, '1', '1', '2', 8, NULL, '1', '0510001', ' ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1848, '1', '1', '2', 9, NULL, '1', '0510001', ' ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1849, '1', '1', '2', 10, NULL, '1', '0510001', ' ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1850, '1', '1', '2', 11, NULL, '1', '0510001', ' ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1851, '1', '1', '2', 12, NULL, '1', '0510001', ' ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1852, '1', '1', '2', 13, NULL, '1', '0510001', ' ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1853, '1', '1', '2', 14, NULL, '1', '0510001', ' ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1854, '1', '1', '2', 15, NULL, '1', '0510001', ' ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1855, '1', '1', '2', 16, NULL, '1', '0510001', ' ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1856, '1', '1', '2', 17, NULL, '1', '0510001', ' ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1857, '1', '1', '2', 0, NULL, '1', '0404001', '   ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1858, '1', '1', '2', 0, NULL, '1', '0428001', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1859, '1', '1', '2', 1, NULL, '1', '0428001', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1860, '1', '1', '2', 2, NULL, '1', '0428001', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1861, '1', '1', '2', 3, NULL, '1', '0428001', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1862, '1', '1', '2', 4, NULL, '1', '0428001', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1863, '1', '1', '2', 5, NULL, '1', '0428001', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1864, '1', '1', '2', 6, NULL, '1', '0428001', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1865, '1', '1', '2', 7, NULL, '1', '0428001', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1866, '1', '1', '2', 8, NULL, '1', '0428001', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1867, '1', '1', '2', 9, NULL, '1', '0428001', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1868, '1', '1', '2', 10, NULL, '1', '0428001', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1869, '1', '1', '2', 11, NULL, '1', '0428001', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1870, '1', '1', '2', 12, NULL, '1', '0428001', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1871, '1', '1', '2', 13, NULL, '1', '0428001', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1872, '1', '1', '2', 14, NULL, '1', '0428001', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1873, '1', '1', '2', 15, NULL, '1', '0428001', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1874, '1', '1', '2', 16, NULL, '1', '0428001', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1875, '1', '1', '2', 17, NULL, '1', '0428001', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1876, '1', '1', '2', 0, NULL, '1', '0414000', '     ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1877, '1', '1', '2', 1, NULL, '1', '0414000', '     ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1878, '1', '1', '2', 2, NULL, '1', '0414000', '     ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1879, '1', '1', '2', 3, NULL, '1', '0414000', '     ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1880, '1', '1', '2', 4, NULL, '1', '0414000', '     ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1881, '1', '1', '2', 5, NULL, '1', '0414000', '     ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1882, '1', '1', '2', 6, NULL, '1', '0414000', '     ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1883, '1', '1', '2', 7, NULL, '1', '0414000', '     ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1884, '1', '1', '2', 8, NULL, '1', '0414000', '     ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1885, '1', '1', '2', 9, NULL, '1', '0414000', '     ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1886, '1', '1', '2', 10, NULL, '1', '0414000', '     ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1887, '1', '1', '2', 11, NULL, '1', '0414000', '     ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1888, '1', '1', '2', 12, NULL, '1', '0414000', '     ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1889, '1', '1', '2', 13, NULL, '1', '0414000', '     ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1890, '1', '1', '2', 14, NULL, '1', '0414000', '     ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1891, '1', '1', '2', 15, NULL, '1', '0414000', '     ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1892, '1', '1', '2', 16, NULL, '1', '0414000', '     ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1893, '1', '1', '2', 17, NULL, '1', '0414000', '     ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1894, '1', '1', '2', 0, NULL, '1', '0410002', '', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1895, '1', '1', '2', 1, NULL, '1', '0410002', '', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1896, '1', '1', '2', 2, NULL, '1', '0410002', '', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1897, '1', '1', '2', 3, NULL, '1', '0410002', '', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1898, '1', '1', '2', 4, NULL, '1', '0410002', '', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1899, '1', '1', '2', 5, NULL, '1', '0410002', '', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1900, '1', '1', '2', 6, NULL, '1', '0410002', '', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1901, '1', '1', '2', 7, NULL, '1', '0410002', '', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1902, '1', '1', '2', 8, NULL, '1', '0410002', '', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1903, '1', '1', '2', 9, NULL, '1', '0410002', '', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1904, '1', '1', '2', 10, NULL, '1', '0410002', '', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1905, '1', '1', '2', 11, NULL, '1', '0410002', '', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1906, '1', '1', '2', 12, NULL, '1', '0410002', '', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1907, '1', '1', '2', 13, NULL, '1', '0410002', '', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1908, '1', '1', '2', 14, NULL, '1', '0410002', '', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1909, '1', '1', '2', 15, NULL, '1', '0410002', '', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1910, '1', '1', '2', 16, NULL, '1', '0410002', '', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1911, '1', '1', '2', 17, NULL, '1', '0410002', '', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1912, '1', '1', '2', 0, NULL, '1', '0403102', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1913, '1', '1', '2', 1, NULL, '1', '0403102', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1914, '1', '1', '2', 2, NULL, '1', '0403102', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1915, '1', '1', '2', 3, NULL, '1', '0403102', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1916, '1', '1', '2', 4, NULL, '1', '0403102', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1917, '1', '1', '2', 5, NULL, '1', '0403102', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1918, '1', '1', '2', 6, NULL, '1', '0403102', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1919, '1', '1', '2', 7, NULL, '1', '0403102', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1920, '1', '1', '2', 8, NULL, '1', '0403102', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1921, '1', '1', '2', 9, NULL, '1', '0403102', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1922, '1', '1', '2', 10, NULL, '1', '0403102', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1923, '1', '1', '2', 11, NULL, '1', '0403102', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1924, '1', '1', '2', 12, NULL, '1', '0403102', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1925, '1', '1', '2', 13, NULL, '1', '0403102', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1926, '1', '1', '2', 14, NULL, '1', '0403102', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1927, '1', '1', '2', 15, NULL, '1', '0403102', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1928, '1', '1', '2', 16, NULL, '1', '0403102', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1929, '1', '1', '2', 17, NULL, '1', '0403102', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1930, '1', '1', '2', 0, NULL, '1', '0402302', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1931, '1', '1', '2', 1, NULL, '1', '0402302', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1932, '1', '1', '2', 2, NULL, '1', '0402302', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1933, '1', '1', '2', 3, NULL, '1', '0402302', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1934, '1', '1', '2', 4, NULL, '1', '0402302', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1935, '1', '1', '2', 5, NULL, '1', '0402302', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1936, '1', '1', '2', 6, NULL, '1', '0402302', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1937, '1', '1', '2', 7, NULL, '1', '0402302', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1938, '1', '1', '2', 8, NULL, '1', '0402302', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1939, '1', '1', '2', 9, NULL, '1', '0402302', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1940, '1', '1', '2', 10, NULL, '1', '0402302', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1941, '1', '1', '2', 11, NULL, '1', '0402302', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1942, '1', '1', '2', 12, NULL, '1', '0402302', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1943, '1', '1', '2', 13, NULL, '1', '0402302', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1944, '1', '1', '2', 14, NULL, '1', '0402302', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1945, '1', '1', '2', 15, NULL, '1', '0402302', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1946, '1', '1', '2', 16, NULL, '1', '0402302', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1947, '1', '1', '2', 17, NULL, '1', '0402302', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1948, '1', '1', '2', 0, NULL, '1', '0402902', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1949, '1', '1', '2', 1, NULL, '1', '0402902', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1950, '1', '1', '2', 2, NULL, '1', '0402902', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1951, '1', '1', '2', 3, NULL, '1', '0402902', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1952, '1', '1', '2', 4, NULL, '1', '0402902', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1953, '1', '1', '2', 5, NULL, '1', '0402902', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1954, '1', '1', '2', 6, NULL, '1', '0402902', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1955, '1', '1', '2', 7, NULL, '1', '0402902', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1956, '1', '1', '2', 8, NULL, '1', '0402902', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1957, '1', '1', '2', 9, NULL, '1', '0402902', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1958, '1', '1', '2', 10, NULL, '1', '0402902', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1959, '1', '1', '2', 11, NULL, '1', '0402902', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1960, '1', '1', '2', 12, NULL, '1', '0402902', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1961, '1', '1', '2', 13, NULL, '1', '0402902', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1962, '1', '1', '2', 14, NULL, '1', '0402902', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1963, '1', '1', '2', 15, NULL, '1', '0402902', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1964, '1', '1', '2', 16, NULL, '1', '0402902', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1965, '1', '1', '2', 17, NULL, '1', '0402902', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1966, '1', '1', '2', 0, NULL, '1', '0401002', ' (, ) -  ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1967, '1', '1', '2', 1, NULL, '1', '0401002', ' (, ) -  ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1968, '1', '1', '2', 2, NULL, '1', '0401002', ' (, ) -  ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1969, '1', '1', '2', 3, NULL, '1', '0401002', ' (, ) -  ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1970, '1', '1', '2', 4, NULL, '1', '0401002', ' (, ) -  ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1971, '1', '1', '2', 5, NULL, '1', '0401002', ' (, ) -  ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1972, '1', '1', '2', 6, NULL, '1', '0401002', ' (, ) -  ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1973, '1', '1', '2', 7, NULL, '1', '0401002', ' (, ) -  ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1974, '1', '1', '2', 8, NULL, '1', '0401002', ' (, ) -  ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1975, '1', '1', '2', 9, NULL, '1', '0401002', ' (, ) -  ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1976, '1', '1', '2', 10, NULL, '1', '0401002', ' (, ) -  ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1977, '1', '1', '2', 11, NULL, '1', '0401002', ' (, ) -  ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1978, '1', '1', '2', 12, NULL, '1', '0401002', ' (, ) -  ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1979, '1', '1', '2', 13, NULL, '1', '0401002', ' (, ) -  ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1980, '1', '1', '2', 14, NULL, '1', '0401002', ' (, ) -  ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1981, '1', '1', '2', 15, NULL, '1', '0401002', ' (, ) -  ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1982, '1', '1', '2', 16, NULL, '1', '0401002', ' (, ) -  ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1983, '1', '1', '2', 17, NULL, '1', '0401002', ' (, ) -  ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1984, '1', '1', '2', 0, NULL, '1', '0402802', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1985, '1', '1', '2', 1, NULL, '1', '0402802', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1986, '1', '1', '2', 2, NULL, '1', '0402802', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1987, '1', '1', '2', 3, NULL, '1', '0402802', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1988, '1', '1', '2', 4, NULL, '1', '0402802', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1989, '1', '1', '2', 5, NULL, '1', '0402802', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1990, '1', '1', '2', 6, NULL, '1', '0402802', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1991, '1', '1', '2', 7, NULL, '1', '0402802', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1992, '1', '1', '2', 8, NULL, '1', '0402802', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1993, '1', '1', '2', 9, NULL, '1', '0402802', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1994, '1', '1', '2', 10, NULL, '1', '0402802', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1995, '1', '1', '2', 11, NULL, '1', '0402802', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1996, '1', '1', '2', 12, NULL, '1', '0402802', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1997, '1', '1', '2', 13, NULL, '1', '0402802', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1998, '1', '1', '2', 14, NULL, '1', '0402802', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (1999, '1', '1', '2', 15, NULL, '1', '0402802', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2000, '1', '1', '2', 16, NULL, '1', '0402802', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2001, '1', '1', '2', 17, NULL, '1', '0402802', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
COMMIT WORK; @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2002, '1', '1', '2', 0, NULL, '1', '0400102', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2003, '1', '1', '2', 1, NULL, '1', '0400102', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2004, '1', '1', '2', 2, NULL, '1', '0400102', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2005, '1', '1', '2', 3, NULL, '1', '0400102', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2006, '1', '1', '2', 4, NULL, '1', '0400102', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2007, '1', '1', '2', 5, NULL, '1', '0400102', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2008, '1', '1', '2', 6, NULL, '1', '0400102', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2009, '1', '1', '2', 7, NULL, '1', '0400102', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2010, '1', '1', '2', 8, NULL, '1', '0400102', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2011, '1', '1', '2', 9, NULL, '1', '0400102', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2012, '1', '1', '2', 10, NULL, '1', '0400102', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2013, '1', '1', '2', 11, NULL, '1', '0400102', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2014, '1', '1', '2', 12, NULL, '1', '0400102', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2015, '1', '1', '2', 13, NULL, '1', '0400102', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2016, '1', '1', '2', 14, NULL, '1', '0400102', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2017, '1', '1', '2', 15, NULL, '1', '0400102', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2018, '1', '1', '2', 16, NULL, '1', '0400102', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2019, '1', '1', '2', 17, NULL, '1', '0400102', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2020, '1', '1', '2', 3, NULL, '1', '0406402', ' (, ) -  ', NULL, '1', 2.5, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2021, '1', '1', '2', 4, NULL, '1', '0406402', ' (, ) -  ', NULL, '1', 2.5, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2022, '1', '1', '2', 5, NULL, '1', '0406402', ' (, ) -  ', NULL, '1', 2.5, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2023, '1', '1', '2', 6, NULL, '1', '0406402', ' (, ) -  ', NULL, '1', 2.5, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2024, '1', '1', '2', 7, NULL, '1', '0406402', ' (, ) -  ', NULL, '1', 2.5, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2025, '1', '1', '2', 8, NULL, '1', '0406402', ' (, ) -  ', NULL, '1', 2.5, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2026, '1', '1', '2', 9, NULL, '1', '0406402', ' (, ) -  ', NULL, '1', 2.5, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2027, '1', '1', '2', 10, NULL, '1', '0406402', ' (, ) -  ', NULL, '1', 2.5, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2028, '1', '1', '2', 11, NULL, '1', '0406402', ' (, ) -  ', NULL, '1', 2.5, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2029, '1', '1', '2', 12, NULL, '1', '0406402', ' (, ) -  ', NULL, '1', 2.5, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2030, '1', '1', '2', 13, NULL, '1', '0406402', ' (, ) -  ', NULL, '1', 2.5, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2031, '1', '1', '2', 14, NULL, '1', '0406402', ' (, ) -  ', NULL, '1', 2.5, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2032, '1', '1', '2', 15, NULL, '1', '0406402', ' (, ) -  ', NULL, '1', 2.5, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2033, '1', '1', '2', 16, NULL, '1', '0406402', ' (, ) -  ', NULL, '1', 2.5, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2034, '1', '1', '2', 17, NULL, '1', '0406402', ' (, ) -  ', NULL, '1', 2.5, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2035, '1', '1', '2', 0, NULL, '1', '0405002', ' (, ) -,  ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2036, '1', '1', '2', 1, NULL, '1', '0405002', ' (, ) -,  ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2037, '1', '1', '2', 2, NULL, '1', '0405002', ' (, ) -,  ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2038, '1', '1', '2', 3, NULL, '1', '0405002', ' (, ) -,  ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2039, '1', '1', '2', 4, NULL, '1', '0405002', ' (, ) -,  ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2040, '1', '1', '2', 5, NULL, '1', '0405002', ' (, ) -,  ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2041, '1', '1', '2', 6, NULL, '1', '0405002', ' (, ) -,  ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2042, '1', '1', '2', 7, NULL, '1', '0405002', ' (, ) -,  ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2043, '1', '1', '2', 8, NULL, '1', '0405002', ' (, ) -,  ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2044, '1', '1', '2', 9, NULL, '1', '0405002', ' (, ) -,  ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2045, '1', '1', '2', 10, NULL, '1', '0405002', ' (, ) -,  ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2046, '1', '1', '2', 11, NULL, '1', '0405002', ' (, ) -,  ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2047, '1', '1', '2', 12, NULL, '1', '0405002', ' (, ) -,  ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2048, '1', '1', '2', 13, NULL, '1', '0405002', ' (, ) -,  ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2049, '1', '1', '2', 14, NULL, '1', '0405002', ' (, ) -,  ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2050, '1', '1', '2', 15, NULL, '1', '0405002', ' (, ) -,  ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2051, '1', '1', '2', 16, NULL, '1', '0405002', ' (, ) -,  ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2052, '1', '1', '2', 17, NULL, '1', '0405002', ' (, ) -,  ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2053, '1', '1', '2', 0, NULL, '1', '0403502', ' (, ) - ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2054, '1', '1', '2', 1, NULL, '1', '0403502', ' (, ) - ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2055, '1', '1', '2', 2, NULL, '1', '0403502', ' (, ) - ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2056, '1', '1', '2', 3, NULL, '1', '0403502', ' (, ) - ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2057, '1', '1', '2', 4, NULL, '1', '0403502', ' (, ) - ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2058, '1', '1', '2', 5, NULL, '1', '0403502', ' (, ) - ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2059, '1', '1', '2', 6, NULL, '1', '0403502', ' (, ) - ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2060, '1', '1', '2', 7, NULL, '1', '0403502', ' (, ) - ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2061, '1', '1', '2', 8, NULL, '1', '0403502', ' (, ) - ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2062, '1', '1', '2', 9, NULL, '1', '0403502', ' (, ) - ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2063, '1', '1', '2', 10, NULL, '1', '0403502', ' (, ) - ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2064, '1', '1', '2', 11, NULL, '1', '0403502', ' (, ) - ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2065, '1', '1', '2', 12, NULL, '1', '0403502', ' (, ) - ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2066, '1', '1', '2', 13, NULL, '1', '0403502', ' (, ) - ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2067, '1', '1', '2', 14, NULL, '1', '0403502', ' (, ) - ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2068, '1', '1', '2', 15, NULL, '1', '0403502', ' (, ) - ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2069, '1', '1', '2', 16, NULL, '1', '0403502', ' (, ) - ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2070, '1', '1', '2', 17, NULL, '1', '0403502', ' (, ) - ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2071, '1', '1', '2', 5, NULL, '1', '0101101', ' (, ) -  ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2072, '1', '1', '2', 6, NULL, '1', '0101101', ' (, ) -  ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2073, '1', '1', '2', 7, NULL, '1', '0101101', ' (, ) -  ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2074, '1', '1', '2', 8, NULL, '1', '0101101', ' (, ) -  ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2075, '1', '1', '2', 9, NULL, '1', '0101101', ' (, ) -  ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2076, '1', '1', '2', 10, NULL, '1', '0101101', ' (, ) -  ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2077, '1', '1', '2', 11, NULL, '1', '0101101', ' (, ) -  ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2078, '1', '1', '2', 12, NULL, '1', '0101101', ' (, ) -  ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2079, '1', '1', '2', 13, NULL, '1', '0101101', ' (, ) -  ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2080, '1', '1', '2', 14, NULL, '1', '0101101', ' (, ) -  ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2081, '1', '1', '2', 15, NULL, '1', '0101101', ' (, ) -  ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2082, '1', '1', '2', 16, NULL, '1', '0101101', ' (, ) -  ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2083, '1', '1', '2', 17, NULL, '1', '0101101', ' (, ) -  ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2084, '1', '1', '2', 0, NULL, '1', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2085, '1', '1', '2', 1, NULL, '1', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2086, '1', '1', '2', 2, NULL, '1', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2087, '1', '1', '2', 3, NULL, '1', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2088, '1', '1', '2', 4, NULL, '1', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2089, '1', '1', '2', 5, NULL, '1', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2090, '1', '1', '2', 6, NULL, '1', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2091, '1', '1', '2', 7, NULL, '1', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2092, '1', '1', '2', 8, NULL, '1', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2093, '1', '1', '2', 9, NULL, '1', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2094, '1', '1', '2', 10, NULL, '1', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2095, '1', '1', '2', 11, NULL, '1', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2096, '1', '1', '2', 12, NULL, '1', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2097, '1', '1', '2', 13, NULL, '1', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2098, '1', '1', '2', 14, NULL, '1', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2099, '1', '1', '2', 15, NULL, '1', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2100, '1', '1', '2', 16, NULL, '1', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2101, '1', '1', '2', 17, NULL, '1', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2102, '1', '1', '2', 15, NULL, '0', '0609007', ' ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2103, '1', '1', '2', 16, NULL, '0', '0609007', ' ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2104, '1', '1', '2', 17, NULL, '0', '0609007', ' ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2105, '1', '1', '2', 7, NULL, '1', '0422001', '   ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2106, '1', '1', '2', 8, NULL, '1', '0422001', '   ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2107, '1', '1', '2', 9, NULL, '1', '0422001', '   ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2108, '1', '1', '2', 10, NULL, '1', '0422001', '   ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2109, '1', '1', '2', 11, NULL, '1', '0422001', '   ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2110, '1', '1', '2', 12, NULL, '1', '0422001', '   ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2111, '1', '1', '2', 13, NULL, '1', '0422001', '   ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2112, '1', '1', '2', 14, NULL, '1', '0422001', '   ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2113, '1', '1', '2', 15, NULL, '1', '0422001', '   ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2114, '1', '1', '2', 16, NULL, '1', '0422001', '   ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2115, '1', '1', '2', 17, NULL, '1', '0422001', '   ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2116, '1', '1', '2', 0, NULL, '1', '0423001', '   ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2117, '1', '1', '2', 7, NULL, '1', '0420001', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2118, '1', '1', '2', 8, NULL, '1', '0420001', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2119, '1', '1', '2', 9, NULL, '1', '0420001', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2120, '1', '1', '2', 10, NULL, '1', '0420001', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2121, '1', '1', '2', 11, NULL, '1', '0420001', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2122, '1', '1', '2', 12, NULL, '1', '0420001', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2123, '1', '1', '2', 13, NULL, '1', '0420001', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2124, '1', '1', '2', 14, NULL, '1', '0420001', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2125, '1', '1', '2', 15, NULL, '1', '0420001', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2126, '1', '1', '2', 16, NULL, '1', '0420001', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2127, '1', '1', '2', 17, NULL, '1', '0420001', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2128, '0', '1', '1', 39, NULL, '0', '0406001', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2129, '0', '1', '1', 45, NULL, '0', '0406001', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2130, '0', '1', '1', 51, NULL, '0', '0406001', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2131, '0', '1', '1', 57, NULL, '0', '0406001', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2132, '0', '1', '1', 63, NULL, '0', '0406001', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2133, '0', '1', '1', 69, NULL, '0', '0406001', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2134, '0', '1', '1', 75, NULL, '0', '0406001', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2135, '0', '1', '1', 81, NULL, '0', '0406001', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2136, '0', '1', '1', 87, NULL, '0', '0406001', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2137, '0', '1', '1', 93, NULL, '0', '0406001', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2138, '0', '1', '1', 99, NULL, '0', '0406001', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2139, '0', '1', '2', 39, NULL, '0', '0406001', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2140, '0', '1', '2', 45, NULL, '0', '0406001', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2141, '0', '1', '2', 51, NULL, '0', '0406001', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2142, '0', '1', '2', 57, NULL, '0', '0406001', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2143, '0', '1', '2', 63, NULL, '0', '0406001', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2144, '0', '1', '2', 69, NULL, '0', '0406001', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2145, '0', '1', '2', 75, NULL, '0', '0406001', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2146, '0', '1', '2', 81, NULL, '0', '0406001', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2147, '0', '1', '2', 87, NULL, '0', '0406001', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2148, '0', '1', '2', 93, NULL, '0', '0406001', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2149, '0', '1', '2', 99, NULL, '0', '0406001', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2150, '3', '1', '0', 18, NULL, '0', '0131009', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2151, '3', '1', '0', 19, NULL, '0', '0131009', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2152, '3', '1', '0', 20, NULL, '0', '0131009', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2153, '3', '1', '0', 21, NULL, '0', '0131009', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2154, '3', '1', '0', 22, NULL, '0', '0131009', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2155, '3', '1', '0', 23, NULL, '0', '0131009', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2156, '3', '1', '0', 24, NULL, '0', '0131009', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2157, '3', '1', '0', 25, NULL, '0', '0131009', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2158, '3', '1', '0', 26, NULL, '0', '0131009', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2159, '3', '1', '0', 27, NULL, '0', '0131009', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2160, '3', '1', '0', 28, NULL, '0', '0131009', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2161, '3', '1', '0', 29, NULL, '0', '0131009', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2162, '3', '1', '0', 30, NULL, '0', '0131009', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2163, '3', '1', '0', 31, NULL, '0', '0131009', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2164, '3', '1', '0', 32, NULL, '0', '0131009', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2165, '3', '1', '0', 33, NULL, '0', '0131009', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2166, '3', '1', '0', 34, NULL, '0', '0131009', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2167, '3', '1', '0', 35, NULL, '0', '0131009', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2168, '3', '1', '0', 36, NULL, '0', '0131009', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2169, '3', '1', '0', 37, NULL, '0', '0131009', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2170, '3', '1', '0', 38, NULL, '0', '0131009', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2171, '3', '1', '0', 39, NULL, '0', '0131009', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2172, '3', '1', '0', 40, NULL, '0', '0131009', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2173, '3', '1', '0', 41, NULL, '0', '0131009', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2174, '3', '1', '0', 42, NULL, '0', '0131009', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2175, '3', '1', '0', 43, NULL, '0', '0131009', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2176, '3', '1', '0', 44, NULL, '0', '0131009', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2177, '3', '1', '0', 45, NULL, '0', '0131009', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2178, '3', '1', '0', 46, NULL, '0', '0131009', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2179, '3', '1', '0', 47, NULL, '0', '0131009', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2180, '3', '1', '0', 48, NULL, '0', '0131009', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2181, '3', '1', '0', 49, NULL, '0', '0131009', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2182, '3', '1', '0', 50, NULL, '0', '0131009', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2183, '3', '1', '0', 51, NULL, '0', '0131009', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2184, '3', '1', '0', 52, NULL, '0', '0131009', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2185, '3', '1', '0', 53, NULL, '0', '0131009', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2186, '3', '1', '0', 54, NULL, '0', '0131009', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2187, '3', '1', '0', 55, NULL, '0', '0131009', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2188, '3', '1', '0', 56, NULL, '0', '0131009', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2189, '3', '1', '0', 57, NULL, '0', '0131009', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2190, '3', '1', '0', 58, NULL, '0', '0131009', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2191, '3', '1', '0', 59, NULL, '0', '0131009', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2192, '3', '1', '0', 60, NULL, '0', '0131009', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2193, '3', '1', '0', 61, NULL, '0', '0131009', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2194, '3', '1', '0', 62, NULL, '0', '0131009', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2195, '3', '1', '0', 63, NULL, '0', '0131009', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2196, '3', '1', '0', 64, NULL, '0', '0131009', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2197, '3', '1', '0', 65, NULL, '0', '0131009', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2198, '3', '1', '0', 66, NULL, '0', '0131009', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2199, '3', '1', '0', 67, NULL, '0', '0131009', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2200, '3', '1', '0', 68, NULL, '0', '0131009', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2201, '3', '1', '0', 69, NULL, '0', '0131009', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2202, '3', '1', '0', 70, NULL, '0', '0131009', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2203, '3', '1', '0', 71, NULL, '0', '0131009', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2204, '3', '1', '0', 72, NULL, '0', '0131009', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2205, '3', '1', '0', 73, NULL, '0', '0131009', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2206, '3', '1', '0', 74, NULL, '0', '0131009', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2207, '3', '1', '0', 75, NULL, '0', '0131009', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2208, '3', '1', '0', 76, NULL, '0', '0131009', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2209, '3', '1', '0', 77, NULL, '0', '0131009', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2210, '3', '1', '0', 78, NULL, '0', '0131009', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2211, '3', '1', '0', 79, NULL, '0', '0131009', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2212, '3', '1', '0', 80, NULL, '0', '0131009', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2213, '3', '1', '0', 81, NULL, '0', '0131009', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2214, '3', '1', '0', 82, NULL, '0', '0131009', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2215, '3', '1', '0', 83, NULL, '0', '0131009', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2216, '3', '1', '0', 84, NULL, '0', '0131009', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2217, '3', '1', '0', 85, NULL, '0', '0131009', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2218, '3', '1', '0', 86, NULL, '0', '0131009', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2219, '3', '1', '0', 87, NULL, '0', '0131009', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2220, '3', '1', '0', 88, NULL, '0', '0131009', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2221, '3', '1', '0', 89, NULL, '0', '0131009', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2222, '3', '1', '0', 90, NULL, '0', '0131009', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2223, '3', '1', '0', 91, NULL, '0', '0131009', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2224, '3', '1', '0', 92, NULL, '0', '0131009', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2225, '3', '1', '0', 93, NULL, '0', '0131009', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2226, '3', '1', '0', 94, NULL, '0', '0131009', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2227, '3', '1', '0', 95, NULL, '0', '0131009', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2228, '3', '1', '0', 96, NULL, '0', '0131009', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2229, '3', '1', '0', 97, NULL, '0', '0131009', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2230, '3', '1', '0', 98, NULL, '0', '0131009', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2231, '3', '1', '0', 99, NULL, '0', '0131009', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2232, '3', '1', '0', 18, NULL, '0', '0905026', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2233, '3', '1', '0', 19, NULL, '0', '0905026', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2234, '3', '1', '0', 20, NULL, '0', '0905026', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2235, '3', '1', '0', 21, NULL, '0', '0905026', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2236, '3', '1', '0', 22, NULL, '0', '0905026', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2237, '3', '1', '0', 23, NULL, '0', '0905026', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2238, '3', '1', '0', 24, NULL, '0', '0905026', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2239, '3', '1', '0', 25, NULL, '0', '0905026', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2240, '3', '1', '0', 26, NULL, '0', '0905026', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2241, '3', '1', '0', 27, NULL, '0', '0905026', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2242, '3', '1', '0', 28, NULL, '0', '0905026', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2243, '3', '1', '0', 29, NULL, '0', '0905026', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2244, '3', '1', '0', 30, NULL, '0', '0905026', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2245, '3', '1', '0', 31, NULL, '0', '0905026', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2246, '3', '1', '0', 32, NULL, '0', '0905026', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2247, '3', '1', '0', 33, NULL, '0', '0905026', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2248, '3', '1', '0', 34, NULL, '0', '0905026', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2249, '3', '1', '0', 35, NULL, '0', '0905026', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2250, '3', '1', '0', 36, NULL, '0', '0905026', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2251, '3', '1', '0', 37, NULL, '0', '0905026', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2252, '3', '1', '0', 38, NULL, '0', '0905026', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2253, '3', '1', '0', 39, NULL, '0', '0905026', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2254, '3', '1', '0', 40, NULL, '0', '0905026', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2255, '3', '1', '0', 41, NULL, '0', '0905026', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2256, '3', '1', '0', 42, NULL, '0', '0905026', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2257, '3', '1', '0', 43, NULL, '0', '0905026', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2258, '3', '1', '0', 44, NULL, '0', '0905026', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2259, '3', '1', '0', 45, NULL, '0', '0905026', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2260, '3', '1', '0', 46, NULL, '0', '0905026', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2261, '3', '1', '0', 47, NULL, '0', '0905026', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2262, '3', '1', '0', 48, NULL, '0', '0905026', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2263, '3', '1', '0', 49, NULL, '0', '0905026', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2264, '3', '1', '0', 50, NULL, '0', '0905026', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2265, '3', '1', '0', 51, NULL, '0', '0905026', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2266, '3', '1', '0', 52, NULL, '0', '0905026', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2267, '3', '1', '0', 53, NULL, '0', '0905026', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2268, '3', '1', '0', 54, NULL, '0', '0905026', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2269, '3', '1', '0', 55, NULL, '0', '0905026', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2270, '3', '1', '0', 56, NULL, '0', '0905026', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2271, '3', '1', '0', 57, NULL, '0', '0905026', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2272, '3', '1', '0', 58, NULL, '0', '0905026', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2273, '3', '1', '0', 59, NULL, '0', '0905026', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2274, '3', '1', '0', 60, NULL, '0', '0905026', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2275, '3', '1', '0', 61, NULL, '0', '0905026', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2276, '3', '1', '0', 62, NULL, '0', '0905026', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2277, '3', '1', '0', 63, NULL, '0', '0905026', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2278, '3', '1', '0', 64, NULL, '0', '0905026', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2279, '3', '1', '0', 65, NULL, '0', '0905026', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2280, '3', '1', '0', 66, NULL, '0', '0905026', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2281, '3', '1', '0', 67, NULL, '0', '0905026', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2282, '3', '1', '0', 68, NULL, '0', '0905026', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2283, '3', '1', '0', 69, NULL, '0', '0905026', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2284, '3', '1', '0', 70, NULL, '0', '0905026', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2285, '3', '1', '0', 71, NULL, '0', '0905026', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2286, '3', '1', '0', 72, NULL, '0', '0905026', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2287, '3', '1', '0', 73, NULL, '0', '0905026', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2288, '3', '1', '0', 74, NULL, '0', '0905026', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2289, '3', '1', '0', 75, NULL, '0', '0905026', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2290, '3', '1', '0', 76, NULL, '0', '0905026', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2291, '3', '1', '0', 77, NULL, '0', '0905026', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2292, '3', '1', '0', 78, NULL, '0', '0905026', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2293, '3', '1', '0', 79, NULL, '0', '0905026', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2294, '3', '1', '0', 80, NULL, '0', '0905026', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2295, '3', '1', '0', 81, NULL, '0', '0905026', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2296, '3', '1', '0', 82, NULL, '0', '0905026', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2297, '3', '1', '0', 83, NULL, '0', '0905026', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2298, '3', '1', '0', 84, NULL, '0', '0905026', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2299, '3', '1', '0', 85, NULL, '0', '0905026', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2300, '3', '1', '0', 86, NULL, '0', '0905026', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2301, '3', '1', '0', 87, NULL, '0', '0905026', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2302, '3', '1', '0', 88, NULL, '0', '0905026', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2303, '3', '1', '0', 89, NULL, '0', '0905026', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2304, '3', '1', '0', 90, NULL, '0', '0905026', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2305, '3', '1', '0', 91, NULL, '0', '0905026', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2306, '3', '1', '0', 92, NULL, '0', '0905026', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2307, '3', '1', '0', 93, NULL, '0', '0905026', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2308, '3', '1', '0', 94, NULL, '0', '0905026', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2309, '3', '1', '0', 95, NULL, '0', '0905026', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2310, '3', '1', '0', 96, NULL, '0', '0905026', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2311, '3', '1', '0', 97, NULL, '0', '0905026', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2312, '3', '1', '0', 98, NULL, '0', '0905026', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2313, '3', '1', '0', 99, NULL, '0', '0905026', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2314, '3', '1', '0', 18, NULL, '0', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2315, '3', '1', '0', 19, NULL, '0', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2316, '3', '1', '0', 20, NULL, '0', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2317, '3', '1', '0', 21, NULL, '0', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2318, '3', '1', '0', 22, NULL, '0', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2319, '3', '1', '0', 23, NULL, '0', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2320, '3', '1', '0', 24, NULL, '0', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2321, '3', '1', '0', 25, NULL, '0', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2322, '3', '1', '0', 26, NULL, '0', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2323, '3', '1', '0', 27, NULL, '0', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2324, '3', '1', '0', 28, NULL, '0', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2325, '3', '1', '0', 29, NULL, '0', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2326, '3', '1', '0', 30, NULL, '0', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2327, '3', '1', '0', 31, NULL, '0', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2328, '3', '1', '0', 32, NULL, '0', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2329, '3', '1', '0', 33, NULL, '0', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2330, '3', '1', '0', 34, NULL, '0', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2331, '3', '1', '0', 35, NULL, '0', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2332, '3', '1', '0', 36, NULL, '0', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2333, '3', '1', '0', 37, NULL, '0', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2334, '3', '1', '0', 38, NULL, '0', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2335, '3', '1', '0', 39, NULL, '0', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2336, '3', '1', '0', 40, NULL, '0', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2337, '3', '1', '0', 41, NULL, '0', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2338, '3', '1', '0', 42, NULL, '0', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2339, '3', '1', '0', 43, NULL, '0', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2340, '3', '1', '0', 44, NULL, '0', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2341, '3', '1', '0', 45, NULL, '0', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2342, '3', '1', '0', 46, NULL, '0', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2343, '3', '1', '0', 47, NULL, '0', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2344, '3', '1', '0', 48, NULL, '0', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2345, '3', '1', '0', 49, NULL, '0', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2346, '3', '1', '0', 50, NULL, '0', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2347, '3', '1', '0', 51, NULL, '0', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2348, '3', '1', '0', 52, NULL, '0', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2349, '3', '1', '0', 53, NULL, '0', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2350, '3', '1', '0', 54, NULL, '0', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2351, '3', '1', '0', 55, NULL, '0', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2352, '3', '1', '0', 56, NULL, '0', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2353, '3', '1', '0', 57, NULL, '0', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2354, '3', '1', '0', 58, NULL, '0', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2355, '3', '1', '0', 59, NULL, '0', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2356, '3', '1', '0', 60, NULL, '0', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2357, '3', '1', '0', 61, NULL, '0', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2358, '3', '1', '0', 62, NULL, '0', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2359, '3', '1', '0', 63, NULL, '0', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2360, '3', '1', '0', 64, NULL, '0', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2361, '3', '1', '0', 65, NULL, '0', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2362, '3', '1', '0', 66, NULL, '0', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2363, '3', '1', '0', 67, NULL, '0', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2364, '3', '1', '0', 68, NULL, '0', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2365, '3', '1', '0', 69, NULL, '0', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2366, '3', '1', '0', 70, NULL, '0', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2367, '3', '1', '0', 71, NULL, '0', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2368, '3', '1', '0', 72, NULL, '0', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2369, '3', '1', '0', 73, NULL, '0', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2370, '3', '1', '0', 74, NULL, '0', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2371, '3', '1', '0', 75, NULL, '0', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2372, '3', '1', '0', 76, NULL, '0', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2373, '3', '1', '0', 77, NULL, '0', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2374, '3', '1', '0', 78, NULL, '0', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2375, '3', '1', '0', 79, NULL, '0', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2376, '3', '1', '0', 80, NULL, '0', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2377, '3', '1', '0', 81, NULL, '0', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2378, '3', '1', '0', 82, NULL, '0', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2379, '3', '1', '0', 83, NULL, '0', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2380, '3', '1', '0', 84, NULL, '0', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2381, '3', '1', '0', 85, NULL, '0', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2382, '3', '1', '0', 86, NULL, '0', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2383, '3', '1', '0', 87, NULL, '0', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2384, '3', '1', '0', 88, NULL, '0', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2385, '3', '1', '0', 89, NULL, '0', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2386, '3', '1', '0', 90, NULL, '0', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2387, '3', '1', '0', 91, NULL, '0', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2388, '3', '1', '0', 92, NULL, '0', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2389, '3', '1', '0', 93, NULL, '0', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2390, '3', '1', '0', 94, NULL, '0', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2391, '3', '1', '0', 95, NULL, '0', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2392, '3', '1', '0', 96, NULL, '0', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2393, '3', '1', '0', 97, NULL, '0', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2394, '3', '1', '0', 98, NULL, '0', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2395, '3', '1', '0', 99, NULL, '0', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2396, '3', '1', '0', 18, NULL, '0', '0609007', ' ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2397, '3', '1', '0', 19, NULL, '0', '0609007', ' ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2398, '3', '1', '0', 20, NULL, '0', '0609007', ' ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2399, '3', '1', '0', 21, NULL, '0', '0609007', ' ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2400, '3', '1', '0', 22, NULL, '0', '0609007', ' ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2401, '3', '1', '0', 23, NULL, '0', '0609007', ' ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2402, '3', '1', '0', 24, NULL, '0', '0609007', ' ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2403, '3', '1', '0', 25, NULL, '0', '0609007', ' ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2404, '3', '1', '0', 26, NULL, '0', '0609007', ' ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2405, '3', '1', '0', 27, NULL, '0', '0609007', ' ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2406, '3', '1', '0', 28, NULL, '0', '0609007', ' ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2407, '3', '1', '0', 29, NULL, '0', '0609007', ' ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2408, '3', '1', '0', 30, NULL, '0', '0609007', ' ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2409, '3', '1', '0', 31, NULL, '0', '0609007', ' ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2410, '3', '1', '0', 32, NULL, '0', '0609007', ' ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2411, '3', '1', '0', 33, NULL, '0', '0609007', ' ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2412, '3', '1', '0', 34, NULL, '0', '0609007', ' ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2413, '3', '1', '0', 35, NULL, '0', '0609007', ' ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2414, '3', '1', '0', 36, NULL, '0', '0609007', ' ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2415, '3', '1', '0', 37, NULL, '0', '0609007', ' ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2416, '3', '1', '0', 38, NULL, '0', '0609007', ' ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2417, '3', '1', '0', 39, NULL, '0', '0609007', ' ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2418, '3', '1', '0', 40, NULL, '0', '0609007', ' ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2419, '3', '1', '0', 41, NULL, '0', '0609007', ' ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2420, '3', '1', '0', 42, NULL, '0', '0609007', ' ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2421, '3', '1', '0', 43, NULL, '0', '0609007', ' ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2422, '3', '1', '0', 44, NULL, '0', '0609007', ' ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2423, '3', '1', '0', 45, NULL, '0', '0609007', ' ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2424, '3', '1', '0', 46, NULL, '0', '0609007', ' ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2425, '3', '1', '0', 47, NULL, '0', '0609007', ' ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2426, '3', '1', '0', 48, NULL, '0', '0609007', ' ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2427, '3', '1', '0', 49, NULL, '0', '0609007', ' ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2428, '3', '1', '0', 50, NULL, '0', '0609007', ' ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2429, '3', '1', '0', 51, NULL, '0', '0609007', ' ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2430, '3', '1', '0', 52, NULL, '0', '0609007', ' ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2431, '3', '1', '0', 53, NULL, '0', '0609007', ' ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2432, '3', '1', '0', 54, NULL, '0', '0609007', ' ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2433, '3', '1', '0', 55, NULL, '0', '0609007', ' ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2434, '3', '1', '0', 56, NULL, '0', '0609007', ' ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2435, '3', '1', '0', 57, NULL, '0', '0609007', ' ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2436, '3', '1', '0', 58, NULL, '0', '0609007', ' ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2437, '3', '1', '0', 59, NULL, '0', '0609007', ' ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2438, '3', '1', '0', 60, NULL, '0', '0609007', ' ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2439, '3', '1', '0', 61, NULL, '0', '0609007', ' ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2440, '3', '1', '0', 62, NULL, '0', '0609007', ' ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2441, '3', '1', '0', 63, NULL, '0', '0609007', ' ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2442, '3', '1', '0', 64, NULL, '0', '0609007', ' ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2443, '3', '1', '0', 65, NULL, '0', '0609007', ' ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2444, '3', '1', '0', 66, NULL, '0', '0609007', ' ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2445, '3', '1', '0', 67, NULL, '0', '0609007', ' ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2446, '3', '1', '0', 68, NULL, '0', '0609007', ' ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2447, '3', '1', '0', 69, NULL, '0', '0609007', ' ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2448, '3', '1', '0', 70, NULL, '0', '0609007', ' ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2449, '3', '1', '0', 71, NULL, '0', '0609007', ' ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2450, '3', '1', '0', 72, NULL, '0', '0609007', ' ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2451, '3', '1', '0', 73, NULL, '0', '0609007', ' ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2452, '3', '1', '0', 74, NULL, '0', '0609007', ' ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2453, '3', '1', '0', 75, NULL, '0', '0609007', ' ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2454, '3', '1', '0', 76, NULL, '0', '0609007', ' ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2455, '3', '1', '0', 77, NULL, '0', '0609007', ' ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2456, '3', '1', '0', 78, NULL, '0', '0609007', ' ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2457, '3', '1', '0', 79, NULL, '0', '0609007', ' ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2458, '3', '1', '0', 80, NULL, '0', '0609007', ' ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2459, '3', '1', '0', 81, NULL, '0', '0609007', ' ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2460, '3', '1', '0', 82, NULL, '0', '0609007', ' ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2461, '3', '1', '0', 83, NULL, '0', '0609007', ' ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2462, '3', '1', '0', 84, NULL, '0', '0609007', ' ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2463, '3', '1', '0', 85, NULL, '0', '0609007', ' ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2464, '3', '1', '0', 86, NULL, '0', '0609007', ' ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2465, '3', '1', '0', 87, NULL, '0', '0609007', ' ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2466, '3', '1', '0', 88, NULL, '0', '0609007', ' ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2467, '3', '1', '0', 89, NULL, '0', '0609007', ' ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2468, '3', '1', '0', 90, NULL, '0', '0609007', ' ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2469, '3', '1', '0', 91, NULL, '0', '0609007', ' ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2470, '3', '1', '0', 92, NULL, '0', '0609007', ' ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2471, '3', '1', '0', 93, NULL, '0', '0609007', ' ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2472, '3', '1', '0', 94, NULL, '0', '0609007', ' ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2473, '3', '1', '0', 95, NULL, '0', '0609007', ' ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2474, '3', '1', '0', 96, NULL, '0', '0609007', ' ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2475, '3', '1', '0', 97, NULL, '0', '0609007', ' ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2476, '3', '1', '0', 98, NULL, '0', '0609007', ' ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2477, '3', '1', '0', 99, NULL, '0', '0609007', ' ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2478, '3', '1', '0', 18, NULL, '0', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2479, '3', '1', '0', 19, NULL, '0', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2480, '3', '1', '0', 20, NULL, '0', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2481, '3', '1', '0', 21, NULL, '0', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2482, '3', '1', '0', 22, NULL, '0', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2483, '3', '1', '0', 23, NULL, '0', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2484, '3', '1', '0', 24, NULL, '0', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2485, '3', '1', '0', 25, NULL, '0', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2486, '3', '1', '0', 26, NULL, '0', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2487, '3', '1', '0', 27, NULL, '0', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2488, '3', '1', '0', 28, NULL, '0', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2489, '3', '1', '0', 29, NULL, '0', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2490, '3', '1', '0', 30, NULL, '0', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2491, '3', '1', '0', 31, NULL, '0', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2492, '3', '1', '0', 32, NULL, '0', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2493, '3', '1', '0', 33, NULL, '0', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2494, '3', '1', '0', 34, NULL, '0', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2495, '3', '1', '0', 35, NULL, '0', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2496, '3', '1', '0', 36, NULL, '0', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2497, '3', '1', '0', 37, NULL, '0', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2498, '3', '1', '0', 38, NULL, '0', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2499, '3', '1', '0', 39, NULL, '0', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2500, '3', '1', '0', 40, NULL, '0', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2501, '3', '1', '0', 41, NULL, '0', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2502, '3', '1', '0', 42, NULL, '0', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2503, '3', '1', '0', 43, NULL, '0', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2504, '3', '1', '0', 44, NULL, '0', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2505, '3', '1', '0', 45, NULL, '0', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2506, '3', '1', '0', 46, NULL, '0', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2507, '3', '1', '0', 47, NULL, '0', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2508, '3', '1', '0', 48, NULL, '0', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2509, '3', '1', '0', 49, NULL, '0', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2510, '3', '1', '0', 50, NULL, '0', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2511, '3', '1', '0', 51, NULL, '0', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2512, '3', '1', '0', 52, NULL, '0', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2513, '3', '1', '0', 53, NULL, '0', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2514, '3', '1', '0', 54, NULL, '0', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2515, '3', '1', '0', 55, NULL, '0', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2516, '3', '1', '0', 56, NULL, '0', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2517, '3', '1', '0', 57, NULL, '0', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2518, '3', '1', '0', 58, NULL, '0', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2519, '3', '1', '0', 59, NULL, '0', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2520, '3', '1', '0', 60, NULL, '0', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2521, '3', '1', '0', 61, NULL, '0', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2522, '3', '1', '0', 62, NULL, '0', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2523, '3', '1', '0', 63, NULL, '0', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2524, '3', '1', '0', 64, NULL, '0', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2525, '3', '1', '0', 65, NULL, '0', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2526, '3', '1', '0', 66, NULL, '0', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2527, '3', '1', '0', 67, NULL, '0', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2528, '3', '1', '0', 68, NULL, '0', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2529, '3', '1', '0', 69, NULL, '0', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2530, '3', '1', '0', 70, NULL, '0', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2531, '3', '1', '0', 71, NULL, '0', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2532, '3', '1', '0', 72, NULL, '0', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2533, '3', '1', '0', 73, NULL, '0', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2534, '3', '1', '0', 74, NULL, '0', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2535, '3', '1', '0', 75, NULL, '0', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2536, '3', '1', '0', 76, NULL, '0', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2537, '3', '1', '0', 77, NULL, '0', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2538, '3', '1', '0', 78, NULL, '0', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2539, '3', '1', '0', 79, NULL, '0', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2540, '3', '1', '0', 80, NULL, '0', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2541, '3', '1', '0', 81, NULL, '0', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2542, '3', '1', '0', 82, NULL, '0', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2543, '3', '1', '0', 83, NULL, '0', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2544, '3', '1', '0', 84, NULL, '0', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2545, '3', '1', '0', 85, NULL, '0', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2546, '3', '1', '0', 86, NULL, '0', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2547, '3', '1', '0', 87, NULL, '0', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2548, '3', '1', '0', 88, NULL, '0', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2549, '3', '1', '0', 89, NULL, '0', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2550, '3', '1', '0', 90, NULL, '0', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2551, '3', '1', '0', 91, NULL, '0', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2552, '3', '1', '0', 92, NULL, '0', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2553, '3', '1', '0', 93, NULL, '0', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2554, '3', '1', '0', 94, NULL, '0', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2555, '3', '1', '0', 95, NULL, '0', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2556, '3', '1', '0', 96, NULL, '0', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2557, '3', '1', '0', 97, NULL, '0', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2558, '3', '1', '0', 98, NULL, '0', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2559, '3', '1', '0', 99, NULL, '0', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2560, '3', '1', '0', 45, NULL, '0', '0919002', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2561, '3', '1', '0', 46, NULL, '0', '0919002', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2562, '3', '1', '0', 47, NULL, '0', '0919002', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2563, '3', '1', '0', 48, NULL, '0', '0919002', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2564, '3', '1', '0', 49, NULL, '0', '0919002', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2565, '3', '1', '0', 50, NULL, '0', '0919002', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2566, '3', '1', '0', 51, NULL, '0', '0919002', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2567, '3', '1', '0', 52, NULL, '0', '0919002', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2568, '3', '1', '0', 53, NULL, '0', '0919002', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2569, '3', '1', '0', 54, NULL, '0', '0919002', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2570, '3', '1', '0', 55, NULL, '0', '0919002', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2571, '3', '1', '0', 56, NULL, '0', '0919002', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2572, '3', '1', '0', 57, NULL, '0', '0919002', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2573, '3', '1', '0', 58, NULL, '0', '0919002', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2574, '3', '1', '0', 59, NULL, '0', '0919002', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2575, '3', '1', '0', 60, NULL, '0', '0919002', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2576, '3', '1', '0', 61, NULL, '0', '0919002', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2577, '3', '1', '0', 62, NULL, '0', '0919002', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2578, '3', '1', '0', 63, NULL, '0', '0919002', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2579, '3', '1', '0', 64, NULL, '0', '0919002', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2580, '3', '1', '0', 65, NULL, '0', '0919002', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2581, '3', '1', '0', 66, NULL, '0', '0919002', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2582, '3', '1', '0', 67, NULL, '0', '0919002', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2583, '3', '1', '0', 68, NULL, '0', '0919002', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2584, '3', '1', '0', 69, NULL, '0', '0919002', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2585, '3', '1', '0', 70, NULL, '0', '0919002', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2586, '3', '1', '0', 71, NULL, '0', '0919002', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2587, '3', '1', '0', 72, NULL, '0', '0919002', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2588, '3', '1', '0', 73, NULL, '0', '0919002', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2589, '3', '1', '0', 74, NULL, '0', '0919002', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2590, '3', '1', '0', 75, NULL, '0', '0919002', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2591, '3', '1', '0', 76, NULL, '0', '0919002', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2592, '3', '1', '0', 77, NULL, '0', '0919002', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2593, '3', '1', '0', 78, NULL, '0', '0919002', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2594, '3', '1', '0', 79, NULL, '0', '0919002', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2595, '3', '1', '0', 80, NULL, '0', '0919002', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2596, '3', '1', '0', 81, NULL, '0', '0919002', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2597, '3', '1', '0', 82, NULL, '0', '0919002', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2598, '3', '1', '0', 83, NULL, '0', '0919002', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2599, '3', '1', '0', 84, NULL, '0', '0919002', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2600, '3', '1', '0', 85, NULL, '0', '0919002', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2601, '3', '1', '0', 86, NULL, '0', '0919002', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2602, '3', '1', '0', 87, NULL, '0', '0919002', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2603, '3', '1', '0', 88, NULL, '0', '0919002', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2604, '3', '1', '0', 89, NULL, '0', '0919002', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2605, '3', '1', '0', 90, NULL, '0', '0919002', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2606, '3', '1', '0', 91, NULL, '0', '0919002', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2607, '3', '1', '0', 92, NULL, '0', '0919002', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2608, '3', '1', '0', 93, NULL, '0', '0919002', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2609, '3', '1', '0', 94, NULL, '0', '0919002', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2610, '3', '1', '0', 95, NULL, '0', '0919002', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2611, '3', '1', '0', 96, NULL, '0', '0919002', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2612, '3', '1', '0', 97, NULL, '0', '0919002', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2613, '3', '1', '0', 98, NULL, '0', '0919002', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2614, '3', '1', '0', 99, NULL, '0', '0919002', '    ', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2615, '3', '1', '0', 18, NULL, '1', '0404702', '  (, ) -', NULL, '1', NULL, '2013-01-01', '2014-03-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2616, '3', '1', '0', 19, NULL, '1', '0404702', '  (, ) -', NULL, '1', NULL, '2013-01-01', '2014-03-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2617, '3', '1', '0', 20, NULL, '1', '0404702', '  (, ) -', NULL, '1', NULL, '2013-01-01', '2014-03-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2618, '3', '1', '0', 21, NULL, '1', '0404702', '  (, ) -', NULL, '1', NULL, '2013-01-01', '2014-03-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2619, '3', '1', '0', 22, NULL, '1', '0404702', '  (, ) -', NULL, '1', NULL, '2013-01-01', '2014-03-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2620, '3', '1', '0', 23, NULL, '1', '0404702', '  (, ) -', NULL, '1', NULL, '2013-01-01', '2014-03-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2621, '3', '1', '0', 24, NULL, '1', '0404702', '  (, ) -', NULL, '1', NULL, '2013-01-01', '2014-03-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2622, '3', '1', '0', 25, NULL, '1', '0404702', '  (, ) -', NULL, '1', NULL, '2013-01-01', '2014-03-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2623, '3', '1', '0', 26, NULL, '1', '0404702', '  (, ) -', NULL, '1', NULL, '2013-01-01', '2014-03-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2624, '3', '1', '0', 27, NULL, '1', '0404702', '  (, ) -', NULL, '1', NULL, '2013-01-01', '2014-03-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2625, '3', '1', '0', 28, NULL, '1', '0404702', '  (, ) -', NULL, '1', NULL, '2013-01-01', '2014-03-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2626, '3', '1', '0', 29, NULL, '1', '0404702', '  (, ) -', NULL, '1', NULL, '2013-01-01', '2014-03-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2627, '3', '1', '0', 30, NULL, '1', '0404702', '  (, ) -', NULL, '1', NULL, '2013-01-01', '2014-03-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2628, '3', '1', '0', 31, NULL, '1', '0404702', '  (, ) -', NULL, '1', NULL, '2013-01-01', '2014-03-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2629, '3', '1', '0', 32, NULL, '1', '0404702', '  (, ) -', NULL, '1', NULL, '2013-01-01', '2014-03-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2630, '3', '1', '0', 33, NULL, '1', '0404702', '  (, ) -', NULL, '1', NULL, '2013-01-01', '2014-03-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2631, '3', '1', '0', 34, NULL, '1', '0404702', '  (, ) -', NULL, '1', NULL, '2013-01-01', '2014-03-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2632, '3', '1', '0', 35, NULL, '1', '0404702', '  (, ) -', NULL, '1', NULL, '2013-01-01', '2014-03-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2633, '3', '1', '0', 36, NULL, '1', '0404702', '  (, ) -', NULL, '1', NULL, '2013-01-01', '2014-03-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2634, '3', '1', '0', 37, NULL, '1', '0404702', '  (, ) -', NULL, '1', NULL, '2013-01-01', '2014-03-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2635, '3', '1', '0', 38, NULL, '1', '0404702', '  (, ) -', NULL, '1', NULL, '2013-01-01', '2014-03-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2636, '3', '1', '0', 39, NULL, '1', '0404702', '  (, ) -', NULL, '1', NULL, '2013-01-01', '2014-03-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2637, '3', '1', '0', 40, NULL, '1', '0404702', '  (, ) -', NULL, '1', NULL, '2013-01-01', '2014-03-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2638, '3', '1', '0', 41, NULL, '1', '0404702', '  (, ) -', NULL, '1', NULL, '2013-01-01', '2014-03-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2639, '3', '1', '0', 42, NULL, '1', '0404702', '  (, ) -', NULL, '1', NULL, '2013-01-01', '2014-03-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2640, '3', '1', '0', 43, NULL, '1', '0404702', '  (, ) -', NULL, '1', NULL, '2013-01-01', '2014-03-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2641, '3', '1', '0', 44, NULL, '1', '0404702', '  (, ) -', NULL, '1', NULL, '2013-01-01', '2014-03-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2642, '3', '1', '0', 45, NULL, '1', '0404702', '  (, ) -', NULL, '1', NULL, '2013-01-01', '2014-03-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2643, '3', '1', '0', 46, NULL, '1', '0404702', '  (, ) -', NULL, '1', NULL, '2013-01-01', '2014-03-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2644, '3', '1', '0', 47, NULL, '1', '0404702', '  (, ) -', NULL, '1', NULL, '2013-01-01', '2014-03-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2645, '3', '1', '0', 48, NULL, '1', '0404702', '  (, ) -', NULL, '1', NULL, '2013-01-01', '2014-03-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2646, '3', '1', '0', 49, NULL, '1', '0404702', '  (, ) -', NULL, '1', NULL, '2013-01-01', '2014-03-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2647, '3', '1', '0', 50, NULL, '1', '0404702', '  (, ) -', NULL, '1', NULL, '2013-01-01', '2014-03-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2648, '3', '1', '0', 51, NULL, '1', '0404702', '  (, ) -', NULL, '1', NULL, '2013-01-01', '2014-03-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2649, '3', '1', '0', 52, NULL, '1', '0404702', '  (, ) -', NULL, '1', NULL, '2013-01-01', '2014-03-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2650, '3', '1', '0', 53, NULL, '1', '0404702', '  (, ) -', NULL, '1', NULL, '2013-01-01', '2014-03-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2651, '3', '1', '0', 54, NULL, '1', '0404702', '  (, ) -', NULL, '1', NULL, '2013-01-01', '2014-03-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2652, '3', '1', '0', 55, NULL, '1', '0404702', '  (, ) -', NULL, '1', NULL, '2013-01-01', '2014-03-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2653, '3', '1', '0', 56, NULL, '1', '0404702', '  (, ) -', NULL, '1', NULL, '2013-01-01', '2014-03-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2654, '3', '1', '0', 57, NULL, '1', '0404702', '  (, ) -', NULL, '1', NULL, '2013-01-01', '2014-03-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2655, '3', '1', '0', 58, NULL, '1', '0404702', '  (, ) -', NULL, '1', NULL, '2013-01-01', '2014-03-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2656, '3', '1', '0', 59, NULL, '1', '0404702', '  (, ) -', NULL, '1', NULL, '2013-01-01', '2014-03-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2657, '3', '1', '0', 60, NULL, '1', '0404702', '  (, ) -', NULL, '1', NULL, '2013-01-01', '2014-03-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2658, '3', '1', '0', 61, NULL, '1', '0404702', '  (, ) -', NULL, '1', NULL, '2013-01-01', '2014-03-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2659, '3', '1', '0', 62, NULL, '1', '0404702', '  (, ) -', NULL, '1', NULL, '2013-01-01', '2014-03-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2660, '3', '1', '0', 63, NULL, '1', '0404702', '  (, ) -', NULL, '1', NULL, '2013-01-01', '2014-03-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2661, '3', '1', '0', 64, NULL, '1', '0404702', '  (, ) -', NULL, '1', NULL, '2013-01-01', '2014-03-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2662, '3', '1', '0', 65, NULL, '1', '0404702', '  (, ) -', NULL, '1', NULL, '2013-01-01', '2014-03-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2663, '3', '1', '0', 66, NULL, '1', '0404702', '  (, ) -', NULL, '1', NULL, '2013-01-01', '2014-03-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2664, '3', '1', '0', 67, NULL, '1', '0404702', '  (, ) -', NULL, '1', NULL, '2013-01-01', '2014-03-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2665, '3', '1', '0', 68, NULL, '1', '0404702', '  (, ) -', NULL, '1', NULL, '2013-01-01', '2014-03-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2666, '3', '1', '0', 69, NULL, '1', '0404702', '  (, ) -', NULL, '1', NULL, '2013-01-01', '2014-03-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2667, '3', '1', '0', 70, NULL, '1', '0404702', '  (, ) -', NULL, '1', NULL, '2013-01-01', '2014-03-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2668, '3', '1', '0', 71, NULL, '1', '0404702', '  (, ) -', NULL, '1', NULL, '2013-01-01', '2014-03-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2669, '3', '1', '0', 72, NULL, '1', '0404702', '  (, ) -', NULL, '1', NULL, '2013-01-01', '2014-03-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2670, '3', '1', '0', 73, NULL, '1', '0404702', '  (, ) -', NULL, '1', NULL, '2013-01-01', '2014-03-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2671, '3', '1', '0', 74, NULL, '1', '0404702', '  (, ) -', NULL, '1', NULL, '2013-01-01', '2014-03-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2672, '3', '1', '0', 75, NULL, '1', '0404702', '  (, ) -', NULL, '1', NULL, '2013-01-01', '2014-03-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2673, '3', '1', '0', 76, NULL, '1', '0404702', '  (, ) -', NULL, '1', NULL, '2013-01-01', '2014-03-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2674, '3', '1', '0', 77, NULL, '1', '0404702', '  (, ) -', NULL, '1', NULL, '2013-01-01', '2014-03-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2675, '3', '1', '0', 78, NULL, '1', '0404702', '  (, ) -', NULL, '1', NULL, '2013-01-01', '2014-03-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2676, '3', '1', '0', 79, NULL, '1', '0404702', '  (, ) -', NULL, '1', NULL, '2013-01-01', '2014-03-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2677, '3', '1', '0', 80, NULL, '1', '0404702', '  (, ) -', NULL, '1', NULL, '2013-01-01', '2014-03-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2678, '3', '1', '0', 81, NULL, '1', '0404702', '  (, ) -', NULL, '1', NULL, '2013-01-01', '2014-03-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2679, '3', '1', '0', 82, NULL, '1', '0404702', '  (, ) -', NULL, '1', NULL, '2013-01-01', '2014-03-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2680, '3', '1', '0', 83, NULL, '1', '0404702', '  (, ) -', NULL, '1', NULL, '2013-01-01', '2014-03-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2681, '3', '1', '0', 84, NULL, '1', '0404702', '  (, ) -', NULL, '1', NULL, '2013-01-01', '2014-03-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2682, '3', '1', '0', 85, NULL, '1', '0404702', '  (, ) -', NULL, '1', NULL, '2013-01-01', '2014-03-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2683, '3', '1', '0', 86, NULL, '1', '0404702', '  (, ) -', NULL, '1', NULL, '2013-01-01', '2014-03-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2684, '3', '1', '0', 87, NULL, '1', '0404702', '  (, ) -', NULL, '1', NULL, '2013-01-01', '2014-03-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2685, '3', '1', '0', 88, NULL, '1', '0404702', '  (, ) -', NULL, '1', NULL, '2013-01-01', '2014-03-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2686, '3', '1', '0', 89, NULL, '1', '0404702', '  (, ) -', NULL, '1', NULL, '2013-01-01', '2014-03-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2687, '3', '1', '0', 90, NULL, '1', '0404702', '  (, ) -', NULL, '1', NULL, '2013-01-01', '2014-03-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2688, '3', '1', '0', 91, NULL, '1', '0404702', '  (, ) -', NULL, '1', NULL, '2013-01-01', '2014-03-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2689, '3', '1', '0', 92, NULL, '1', '0404702', '  (, ) -', NULL, '1', NULL, '2013-01-01', '2014-03-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2690, '3', '1', '0', 93, NULL, '1', '0404702', '  (, ) -', NULL, '1', NULL, '2013-01-01', '2014-03-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2691, '3', '1', '0', 94, NULL, '1', '0404702', '  (, ) -', NULL, '1', NULL, '2013-01-01', '2014-03-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2692, '3', '1', '0', 95, NULL, '1', '0404702', '  (, ) -', NULL, '1', NULL, '2013-01-01', '2014-03-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2693, '3', '1', '0', 96, NULL, '1', '0404702', '  (, ) -', NULL, '1', NULL, '2013-01-01', '2014-03-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2694, '3', '1', '0', 97, NULL, '1', '0404702', '  (, ) -', NULL, '1', NULL, '2013-01-01', '2014-03-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2695, '3', '1', '0', 98, NULL, '1', '0404702', '  (, ) -', NULL, '1', NULL, '2013-01-01', '2014-03-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2696, '3', '1', '0', 99, NULL, '1', '0404702', '  (, ) -', NULL, '1', NULL, '2013-01-01', '2014-03-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2697, '3', '1', '2', 39, NULL, '0', '0620006', '', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2698, '3', '1', '2', 40, NULL, '0', '0620006', '', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2699, '3', '1', '2', 41, NULL, '0', '0620006', '', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2700, '3', '1', '2', 42, NULL, '0', '0620006', '', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2701, '3', '1', '2', 43, NULL, '0', '0620006', '', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2702, '3', '1', '2', 44, NULL, '0', '0620006', '', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2703, '3', '1', '2', 45, NULL, '0', '0620006', '', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2704, '3', '1', '2', 46, NULL, '0', '0620006', '', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2705, '3', '1', '2', 47, NULL, '0', '0620006', '', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2706, '3', '1', '2', 48, NULL, '0', '0620006', '', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2707, '3', '1', '2', 49, NULL, '0', '0620006', '', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2708, '3', '1', '2', 50, NULL, '0', '0620006', '', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2709, '3', '1', '2', 51, NULL, '0', '0620006', '', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2710, '3', '1', '2', 52, NULL, '0', '0620006', '', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2711, '3', '1', '2', 53, NULL, '0', '0620006', '', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2712, '3', '1', '2', 54, NULL, '0', '0620006', '', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2713, '3', '1', '2', 55, NULL, '0', '0620006', '', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2714, '3', '1', '2', 56, NULL, '0', '0620006', '', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2715, '3', '1', '2', 57, NULL, '0', '0620006', '', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2716, '3', '1', '2', 58, NULL, '0', '0620006', '', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2717, '3', '1', '2', 59, NULL, '0', '0620006', '', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2718, '3', '1', '2', 60, NULL, '0', '0620006', '', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2719, '3', '1', '2', 61, NULL, '0', '0620006', '', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2720, '3', '1', '2', 62, NULL, '0', '0620006', '', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2721, '3', '1', '2', 63, NULL, '0', '0620006', '', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2722, '3', '1', '2', 64, NULL, '0', '0620006', '', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2723, '3', '1', '2', 65, NULL, '0', '0620006', '', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2724, '3', '1', '2', 66, NULL, '0', '0620006', '', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2725, '3', '1', '2', 67, NULL, '0', '0620006', '', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2726, '3', '1', '2', 68, NULL, '0', '0620006', '', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2727, '3', '1', '2', 69, NULL, '0', '0620006', '', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2728, '3', '1', '2', 70, NULL, '0', '0620006', '', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2729, '3', '1', '2', 71, NULL, '0', '0620006', '', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2730, '3', '1', '2', 72, NULL, '0', '0620006', '', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2731, '3', '1', '2', 73, NULL, '0', '0620006', '', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2732, '3', '1', '2', 74, NULL, '0', '0620006', '', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2733, '3', '1', '2', 75, NULL, '0', '0620006', '', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2734, '3', '1', '2', 76, NULL, '0', '0620006', '', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2735, '3', '1', '2', 77, NULL, '0', '0620006', '', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2736, '3', '1', '2', 78, NULL, '0', '0620006', '', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2737, '3', '1', '2', 79, NULL, '0', '0620006', '', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2738, '3', '1', '2', 80, NULL, '0', '0620006', '', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2739, '3', '1', '2', 81, NULL, '0', '0620006', '', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2740, '3', '1', '2', 82, NULL, '0', '0620006', '', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2741, '3', '1', '2', 83, NULL, '0', '0620006', '', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2742, '3', '1', '2', 84, NULL, '0', '0620006', '', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2743, '3', '1', '2', 85, NULL, '0', '0620006', '', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2744, '3', '1', '2', 86, NULL, '0', '0620006', '', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2745, '3', '1', '2', 87, NULL, '0', '0620006', '', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2746, '3', '1', '2', 88, NULL, '0', '0620006', '', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2747, '3', '1', '2', 89, NULL, '0', '0620006', '', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2748, '3', '1', '2', 90, NULL, '0', '0620006', '', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2749, '3', '1', '2', 91, NULL, '0', '0620006', '', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2750, '3', '1', '2', 92, NULL, '0', '0620006', '', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2751, '3', '1', '2', 93, NULL, '0', '0620006', '', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2752, '3', '1', '2', 94, NULL, '0', '0620006', '', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2753, '3', '1', '2', 95, NULL, '0', '0620006', '', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2754, '3', '1', '2', 96, NULL, '0', '0620006', '', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2755, '3', '1', '2', 97, NULL, '0', '0620006', '', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2756, '3', '1', '2', 98, NULL, '0', '0620006', '', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2757, '3', '1', '2', 99, NULL, '0', '0620006', '', NULL, '0', NULL, '2013-01-01', '2014-03-31', '1', NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2758, '4', '1', '0', 3, NULL, '1', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2759, '4', '1', '0', 6, NULL, '1', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2760, '4', '1', '0', 9, NULL, '1', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2761, '4', '1', '0', 12, NULL, '1', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2762, '4', '1', '0', 18, NULL, '1', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2763, '4', '1', '0', 24, NULL, '1', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2764, '4', '1', '0', 36, NULL, '1', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2765, '4', '1', '0', 48, NULL, '1', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2766, '4', '1', '0', 60, NULL, '1', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2767, '4', '1', '0', 72, NULL, '1', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2768, '4', '1', '0', 84, NULL, '1', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2769, '4', '1', '0', 96, NULL, '1', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2770, '4', '1', '0', 108, NULL, '1', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2771, '4', '1', '0', 120, NULL, '1', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2772, '4', '1', '0', 132, NULL, '1', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2773, '4', '1', '0', 144, NULL, '1', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2774, '4', '1', '0', 156, NULL, '1', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2775, '4', '1', '0', 168, NULL, '1', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2776, '4', '1', '0', 180, NULL, '1', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2777, '4', '1', '0', 192, NULL, '1', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2778, '4', '1', '0', 3, NULL, '1', '0301606', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2779, '4', '1', '0', 6, NULL, '1', '0301606', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2780, '4', '1', '0', 12, NULL, '1', '0301606', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2781, '4', '1', '0', 36, NULL, '1', '0301606', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2782, '4', '1', '0', 48, NULL, '1', '0301606', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2783, '4', '1', '0', 60, NULL, '1', '0301606', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2784, '4', '1', '0', 72, NULL, '1', '0301606', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2785, '4', '1', '0', 84, NULL, '1', '0301606', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2786, '4', '1', '0', 96, NULL, '1', '0301606', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2787, '4', '1', '0', 108, NULL, '1', '0301606', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2788, '4', '1', '0', 120, NULL, '1', '0301606', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2789, '4', '1', '0', 132, NULL, '1', '0301606', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2790, '4', '1', '0', 144, NULL, '1', '0301606', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2791, '4', '1', '0', 156, NULL, '1', '0301606', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2792, '4', '1', '0', 168, NULL, '1', '0301606', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2793, '4', '1', '0', 180, NULL, '1', '0301606', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2794, '4', '1', '0', 192, NULL, '1', '0301606', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2795, '4', '1', '0', 168, NULL, '0', '0905088', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2796, '4', '1', '0', 168, NULL, '0', '0905079', '     ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2797, '4', '1', '0', 168, NULL, '0', '0905136', '     ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2798, '4', '1', '0', 168, NULL, '0', '0905137', '      ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2799, '4', '1', '0', 168, NULL, '0', '0905158', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2800, '4', '1', '0', 168, NULL, '0', '0905073', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2801, '4', '1', '0', 168, NULL, '0', '0905065', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2802, '4', '1', '0', 168, NULL, '0', '0905062', '    (3)  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2803, '4', '1', '0', 168, NULL, '0', '0905061', '     (-4) ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2804, '4', '1', '0', 168, NULL, '0', '0905066', '     ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2805, '4', '1', '0', 168, NULL, '0', '0905140', '     ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2806, '4', '1', '0', 12, NULL, '1', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2807, '4', '1', '0', 36, NULL, '1', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2808, '4', '1', '0', 48, NULL, '0', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-04-30', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2809, '4', '1', '0', 60, NULL, '0', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-04-30', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2810, '4', '1', '0', 72, NULL, '1', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2811, '4', '1', '0', 84, NULL, '1', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2812, '4', '1', '0', 96, NULL, '1', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2813, '4', '1', '0', 108, NULL, '1', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2814, '4', '1', '0', 120, NULL, '1', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2815, '4', '1', '0', 132, NULL, '1', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2816, '4', '1', '0', 156, NULL, '1', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2817, '4', '1', '0', 168, NULL, '1', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2818, '4', '1', '0', 180, NULL, '1', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2819, '4', '1', '0', 192, NULL, '1', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2820, '4', '1', '0', 108, NULL, '0', '0919003', '   ', NULL, '0', NULL, '2013-01-01', '2014-04-30', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2821, '4', '1', '0', 168, NULL, '0', '0919003', '   ', NULL, '0', NULL, '2013-01-01', '2014-04-30', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2822, '4', '1', '0', 12, NULL, '1', '0510007', ',     ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2823, '4', '1', '0', 84, NULL, '1', '0510007', ',     ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2824, '4', '1', '0', 120, NULL, '1', '0510007', ',     ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2825, '4', '1', '0', 168, NULL, '1', '0510007', ',     ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2826, '4', '1', '0', 180, NULL, '1', '0510007', ',     ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2827, '4', '1', '0', 192, NULL, '1', '0510007', ',     ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2828, '4', '1', '0', 12, NULL, '1', '0510001', ' ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2829, '4', '1', '0', 84, NULL, '1', '0510001', ' ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2830, '4', '1', '0', 120, NULL, '1', '0510001', ' ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2831, '4', '1', '0', 168, NULL, '1', '0510001', ' ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2832, '4', '1', '0', 180, NULL, '1', '0510001', ' ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2833, '4', '1', '0', 192, NULL, '1', '0510001', ' ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2834, '4', '1', '0', 1, NULL, '1', '0414000', '     ', NULL, '0', NULL, '2013-01-01', '2014-07-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2835, '4', '1', '0', 84, NULL, '1', '0414000', '     ', NULL, '0', NULL, '2013-01-01', '2014-07-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2836, '4', '1', '0', 168, NULL, '1', '0414000', '     ', NULL, '0', NULL, '2013-01-01', '2014-07-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2837, '4', '1', '0', 1, NULL, '0', '0422001', '   ', NULL, '0', NULL, '2013-01-01', '2014-11-30', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2838, '4', '1', '0', 84, NULL, '1', '0422001', '   ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2839, '4', '1', '0', 168, NULL, '1', '0422001', '   ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2840, '4', '1', '0', 1, NULL, '1', '0431003', '   ', NULL, '0', NULL, '2013-01-01', '2014-07-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2841, '4', '1', '0', 84, NULL, '1', '0431003', '   ', NULL, '0', NULL, '2013-01-01', '2014-07-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2842, '4', '1', '0', 168, NULL, '1', '0431003', '   ', NULL, '0', NULL, '2013-01-01', '2014-07-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2843, '4', '1', '0', 1, NULL, '1', '0428001', '  ', NULL, '0', NULL, '2013-01-01', '2014-07-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2844, '4', '1', '0', 84, NULL, '1', '0428001', '  ', NULL, '0', NULL, '2013-01-01', '2014-07-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2845, '4', '1', '0', 168, NULL, '1', '0428001', '  ', NULL, '0', NULL, '2013-01-01', '2014-07-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2846, '4', '1', '0', 1, NULL, '0', '0421001', '   ', NULL, '0', NULL, '2013-01-01', '2014-06-30', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2847, '4', '1', '0', 84, NULL, '0', '0421001', '   ', NULL, '0', NULL, '2013-01-01', '2014-06-30', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2848, '4', '1', '0', 168, NULL, '0', '0421001', '   ', NULL, '0', NULL, '2013-01-01', '2014-06-30', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2849, '4', '1', '1', 1, NULL, '0', '0421002', '   (, )', NULL, '0', NULL, '2013-01-01', '2014-11-30', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2850, '4', '1', '1', 84, NULL, '1', '0421002', '   (, )', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2851, '4', '1', '1', 168, NULL, '1', '0421002', '   (, )', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2852, '4', '1', '2', 1, NULL, '0', '0420001', '    ', NULL, '0', NULL, '2013-01-01', '2014-11-30', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2853, '4', '1', '2', 84, NULL, '1', '0420001', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2854, '4', '1', '2', 168, NULL, '1', '0420001', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2855, '4', '1', '2', 1, NULL, '0', '0420002', '  ', NULL, '0', NULL, '2013-01-01', '2014-11-30', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2856, '4', '1', '2', 84, NULL, '1', '0420002', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2857, '4', '1', '2', 168, NULL, '1', '0420002', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2858, '4', '1', '0', 1, NULL, '1', '0404001', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2859, '4', '1', '0', 84, NULL, '0', '0404001', '  ', NULL, '0', NULL, '2013-01-01', '2014-04-30', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2860, '4', '1', '0', 168, NULL, '0', '0404001', '  ', NULL, '0', NULL, '2013-01-01', '2014-04-30', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2861, '4', '1', '0', 1, NULL, '1', '0415001', '   ', NULL, '0', NULL, '2013-01-01', '2014-07-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2862, '4', '1', '0', 84, NULL, '1', '0415001', '   ', NULL, '0', NULL, '2013-01-01', '2014-07-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2863, '4', '1', '0', 168, NULL, '1', '0415001', '   ', NULL, '0', NULL, '2013-01-01', '2014-07-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2864, '4', '1', '0', 36, NULL, '1', '0403502', ' (, ) - ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2865, '4', '1', '0', 84, NULL, '1', '0403502', ' (, ) - ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2866, '4', '1', '0', 120, NULL, '1', '0403502', ' (, ) - ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2867, '4', '1', '0', 168, NULL, '1', '0403502', ' (, ) - ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2868, '4', '1', '0', 180, NULL, '1', '0403502', ' (, ) - ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2869, '4', '1', '0', 192, NULL, '1', '0403502', ' (, ) - ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2870, '4', '1', '0', 0, NULL, '1', '0403102', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2871, '4', '1', '0', 1, NULL, '1', '0403102', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2872, '4', '1', '0', 2, NULL, '1', '0403102', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2873, '4', '1', '0', 3, NULL, '1', '0403102', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2874, '4', '1', '0', 4, NULL, '1', '0403102', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2875, '4', '1', '0', 5, NULL, '1', '0403102', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2876, '4', '1', '0', 6, NULL, '1', '0403102', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2877, '4', '1', '0', 7, NULL, '1', '0403102', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2878, '4', '1', '0', 8, NULL, '1', '0403102', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2879, '4', '1', '0', 9, NULL, '1', '0403102', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2880, '4', '1', '0', 10, NULL, '1', '0403102', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2881, '4', '1', '0', 11, NULL, '1', '0403102', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2882, '4', '1', '0', 12, NULL, '1', '0403102', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2883, '4', '1', '0', 15, NULL, '1', '0403102', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2884, '4', '1', '0', 18, NULL, '1', '0403102', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2885, '4', '1', '0', 21, NULL, '1', '0403102', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2886, '4', '1', '0', 24, NULL, '1', '0403102', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2887, '4', '1', '0', 30, NULL, '1', '0403102', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2888, '4', '1', '0', 36, NULL, '1', '0403102', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2889, '4', '1', '0', 48, NULL, '1', '0403102', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2890, '4', '1', '0', 60, NULL, '1', '0403102', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2891, '4', '1', '0', 72, NULL, '1', '0403102', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2892, '4', '1', '0', 84, NULL, '1', '0403102', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2893, '4', '1', '0', 96, NULL, '1', '0403102', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2894, '4', '1', '0', 108, NULL, '1', '0403102', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2895, '4', '1', '0', 120, NULL, '1', '0403102', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2896, '4', '1', '0', 132, NULL, '1', '0403102', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2897, '4', '1', '0', 144, NULL, '1', '0403102', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2898, '4', '1', '0', 156, NULL, '1', '0403102', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2899, '4', '1', '0', 168, NULL, '1', '0403102', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2900, '4', '1', '0', 180, NULL, '1', '0403102', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2901, '4', '1', '0', 192, NULL, '1', '0403102', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2902, '4', '1', '0', 1, NULL, '1', '0402302', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2903, '4', '1', '0', 3, NULL, '1', '0402302', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2904, '4', '1', '0', 6, NULL, '1', '0402302', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2905, '4', '1', '0', 36, NULL, '1', '0402302', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2906, '4', '1', '0', 72, NULL, '1', '0402302', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2907, '4', '1', '0', 84, NULL, '1', '0402302', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2908, '4', '1', '0', 120, NULL, '1', '0402302', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2909, '4', '1', '0', 168, NULL, '1', '0402302', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2910, '4', '1', '0', 180, NULL, '1', '0402302', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2911, '4', '1', '0', 192, NULL, '1', '0402302', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2912, '4', '1', '0', 1, NULL, '1', '0402902', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2913, '4', '1', '0', 36, NULL, '1', '0402902', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2914, '4', '1', '0', 72, NULL, '1', '0402902', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2915, '4', '1', '0', 84, NULL, '1', '0402902', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2916, '4', '1', '0', 120, NULL, '1', '0402902', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2917, '4', '1', '0', 132, NULL, '1', '0402902', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2918, '4', '1', '0', 168, NULL, '1', '0402902', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2919, '4', '1', '0', 180, NULL, '1', '0402902', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2920, '4', '1', '0', 192, NULL, '1', '0402902', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2921, '4', '1', '0', 1, NULL, '1', '0401002', ' (, ) -  ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2922, '4', '1', '0', 6, NULL, '1', '0401002', ' (, ) -  ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2923, '4', '1', '0', 36, NULL, '1', '0401002', ' (, ) -  ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2924, '4', '1', '0', 48, NULL, '1', '0401002', ' (, ) -  ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2925, '4', '1', '0', 60, NULL, '1', '0401002', ' (, ) -  ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2926, '4', '1', '0', 84, NULL, '1', '0401002', ' (, ) -  ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2927, '4', '1', '0', 120, NULL, '1', '0401002', ' (, ) -  ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2928, '4', '1', '0', 132, NULL, '1', '0401002', ' (, ) -  ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2929, '4', '1', '0', 168, NULL, '0', '0401002', ' (, ) -  ', NULL, '1', NULL, '2013-01-01', '2014-04-30', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2930, '4', '1', '0', 180, NULL, '1', '0401002', ' (, ) -  ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2931, '4', '1', '0', 192, NULL, '1', '0401002', ' (, ) -  ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2932, '4', '1', '0', 36, NULL, '1', '0402802', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2933, '4', '1', '0', 84, NULL, '1', '0402802', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2934, '4', '1', '0', 120, NULL, '1', '0402802', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2935, '4', '1', '0', 168, NULL, '1', '0402802', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2936, '4', '1', '0', 180, NULL, '1', '0402802', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2937, '4', '1', '0', 192, NULL, '1', '0402802', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2938, '4', '1', '2', 36, NULL, '1', '0400102', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2939, '4', '1', '2', 84, NULL, '1', '0400102', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2940, '4', '1', '2', 120, NULL, '0', '0400102', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-04-30', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2941, '4', '1', '2', 144, NULL, '1', '0400102', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2942, '4', '1', '2', 168, NULL, '1', '0400102', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2943, '4', '1', '2', 180, NULL, '1', '0400102', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2944, '4', '1', '2', 192, NULL, '1', '0400102', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2945, '4', '1', '0', 36, NULL, '1', '0406402', ' (, ) -  ', NULL, '1', 2.5, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2946, '4', '1', '0', 72, NULL, '1', '0406402', ' (, ) -  ', NULL, '1', 2.5, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2947, '4', '1', '0', 84, NULL, '1', '0406402', ' (, ) -  ', NULL, '1', 2.5, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2948, '4', '1', '0', 120, NULL, '1', '0406402', ' (, ) -  ', NULL, '1', 2.5, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2949, '4', '1', '0', 168, NULL, '1', '0406402', ' (, ) -  ', NULL, '1', 2.5, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2950, '4', '1', '0', 180, NULL, '1', '0406402', ' (, ) -  ', NULL, '1', 2.5, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2951, '4', '1', '0', 192, NULL, '1', '0406402', ' (, ) -  ', NULL, '1', 2.5, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2952, '4', '1', '0', 3, NULL, '1', '0405002', ' (, ) -,  ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2953, '4', '1', '0', 84, NULL, '1', '0405002', ' (, ) -,  ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2954, '4', '1', '0', 120, NULL, '1', '0405002', ' (, ) -,  ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2955, '4', '1', '0', 180, NULL, '1', '0405002', ' (, ) -,  ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2956, '4', '1', '0', 192, NULL, '1', '0405002', ' (, ) -,  ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2957, '4', '1', '1', 36, NULL, '1', '0405302', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2958, '4', '1', '1', 84, NULL, '1', '0405302', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2959, '4', '1', '1', 120, NULL, '0', '0405302', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-04-30', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2960, '4', '1', '1', 144, NULL, '1', '0405302', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2961, '4', '1', '1', 168, NULL, '1', '0405302', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2962, '4', '1', '1', 180, NULL, '1', '0405302', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2963, '4', '1', '1', 192, NULL, '1', '0405302', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2964, '4', '1', '0', 120, NULL, '1', '0101101', ' (, ) -  ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2965, '4', '1', '0', 168, NULL, '1', '0101101', ' (, ) -  ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2966, '4', '1', '0', 180, NULL, '1', '0101101', ' (, ) -  ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2967, '4', '1', '0', 192, NULL, '1', '0101101', ' (, ) -  ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2968, '4', '1', '0', 180, NULL, '1', '0609007', ' ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2969, '4', '1', '0', 192, NULL, '1', '0609007', ' ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2970, '4', '1', '0', 1, NULL, '1', '0423001', '   ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2971, '4', '1', '0', 1, NULL, '1', '0412013', '   ', NULL, '0', NULL, '2013-01-01', '2014-10-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2972, '4', '1', '0', 84, NULL, '1', '0412013', '   ', NULL, '0', NULL, '2013-01-01', '2014-10-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2973, '4', '1', '0', 168, NULL, '1', '0412013', '   ', NULL, '0', NULL, '2013-01-01', '2014-10-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2974, '6', '1', '0', 1, NULL, '1', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2975, '6', '1', '0', 2, NULL, '1', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2976, '6', '1', '0', 3, NULL, '1', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2977, '6', '1', '0', 1, NULL, '1', '0301606', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2978, '6', '1', '0', 2, NULL, '1', '0301606', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2979, '6', '1', '0', 3, NULL, '1', '0301606', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2980, '6', '1', '0', 1, NULL, '1', '0403102', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2981, '6', '1', '0', 2, NULL, '1', '0403102', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2982, '6', '1', '0', 3, NULL, '1', '0403102', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2983, '5', '1', '0', 1, NULL, '1', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2984, '5', '1', '0', 2, NULL, '1', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2985, '5', '1', '0', 3, NULL, '1', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2986, '5', '1', '0', 1, NULL, '1', '0301606', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2987, '5', '1', '0', 2, NULL, '1', '0301606', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2988, '5', '1', '0', 3, NULL, '1', '0301606', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2989, '5', '1', '0', 1, NULL, '1', '0919003', '   ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2990, '5', '1', '0', 2, NULL, '1', '0919003', '   ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2991, '5', '1', '0', 3, NULL, '0', '0919003', '   ', NULL, '0', NULL, '2013-01-01', '2014-10-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2992, '5', '1', '0', 1, NULL, '1', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2993, '5', '1', '0', 2, NULL, '1', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2994, '5', '1', '0', 3, NULL, '1', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2995, '5', '1', '0', 1, NULL, '0', '0510007', ',     ', NULL, '0', NULL, '2013-01-01', '2014-06-30', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2996, '5', '1', '0', 2, NULL, '1', '0510007', ',     ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2997, '5', '1', '0', 3, NULL, '1', '0510007', ',     ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2998, '5', '1', '0', 1, NULL, '0', '0510001', ' ', NULL, '0', NULL, '2013-01-01', '2014-06-30', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (2999, '5', '1', '0', 2, NULL, '1', '0510001', ' ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3000, '5', '1', '0', 3, NULL, '1', '0510001', ' ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3001, '5', '1', '0', 2, NULL, '1', '0414000', '     ', NULL, '0', NULL, '2013-01-01', '2014-07-31', NULL, NULL); @
COMMIT WORK; @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3002, '5', '1', '0', 3, NULL, '1', '0414000', '     ', NULL, '0', NULL, '2013-01-01', '2014-07-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3003, '5', '1', '0', 2, NULL, '1', '0422001', '   ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3004, '5', '1', '0', 3, NULL, '1', '0422001', '   ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3005, '5', '1', '0', 2, NULL, '1', '0431003', '   ', NULL, '0', NULL, '2013-01-01', '2014-07-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3006, '5', '1', '0', 3, NULL, '1', '0431003', '   ', NULL, '0', NULL, '2013-01-01', '2014-07-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3007, '5', '1', '0', 2, NULL, '1', '0428001', '  ', NULL, '0', NULL, '2013-01-01', '2014-07-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3008, '5', '1', '0', 3, NULL, '1', '0428001', '  ', NULL, '0', NULL, '2013-01-01', '2014-07-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3009, '5', '1', '0', 2, NULL, '0', '0421001', '   ', NULL, '0', NULL, '2013-01-01', '2014-06-30', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3010, '5', '1', '0', 3, NULL, '0', '0421001', '   ', NULL, '0', NULL, '2013-01-01', '2014-06-30', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3011, '5', '1', '0', 2, NULL, '0', '0421002', '   (, )', NULL, '0', NULL, '2013-01-01', '2014-06-30', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3012, '5', '1', '0', 3, NULL, '0', '0421002', '   (, )', NULL, '0', NULL, '2013-01-01', '2014-06-30', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3013, '5', '1', '0', 2, NULL, '0', '0420001', '    ', NULL, '0', NULL, '2013-01-01', '2014-06-30', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3014, '5', '1', '0', 3, NULL, '0', '0420001', '    ', NULL, '0', NULL, '2013-01-01', '2014-06-30', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3015, '5', '1', '0', 2, NULL, '0', '0420002', '  ', NULL, '0', NULL, '2013-01-01', '2014-06-30', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3016, '5', '1', '0', 3, NULL, '0', '0420002', '  ', NULL, '0', NULL, '2013-01-01', '2014-06-30', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3017, '5', '1', '0', 2, NULL, '0', '0404001', '  ', NULL, '0', NULL, '2013-01-01', '2014-10-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3018, '5', '1', '0', 3, NULL, '0', '0404001', '  ', NULL, '0', NULL, '2013-01-01', '2014-10-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3019, '5', '1', '0', 2, NULL, '1', '0415001', '   ', NULL, '0', NULL, '2013-01-01', '2014-07-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3020, '5', '1', '0', 3, NULL, '1', '0415001', '   ', NULL, '0', NULL, '2013-01-01', '2014-07-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3021, '5', '1', '0', 2, NULL, '1', '0412013', '   ', NULL, '0', NULL, '2013-01-01', '2014-10-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3022, '5', '1', '0', 3, NULL, '1', '0412013', '   ', NULL, '0', NULL, '2013-01-01', '2014-10-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3023, '5', '1', '0', 1, NULL, '1', '0403502', ' (, ) - ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3024, '5', '1', '0', 2, NULL, '1', '0403502', ' (, ) - ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3025, '5', '1', '0', 3, NULL, '1', '0403502', ' (, ) - ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3026, '5', '1', '0', 1, NULL, '1', '0403102', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3027, '5', '1', '0', 2, NULL, '1', '0403102', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3028, '5', '1', '0', 3, NULL, '1', '0403102', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3029, '5', '1', '0', 1, NULL, '1', '0402302', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3030, '5', '1', '0', 2, NULL, '1', '0402302', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3031, '5', '1', '0', 3, NULL, '1', '0402302', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3032, '5', '1', '0', 1, NULL, '1', '0402902', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3033, '5', '1', '0', 2, NULL, '1', '0402902', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3034, '5', '1', '0', 3, NULL, '1', '0402902', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3035, '5', '1', '0', 1, NULL, '1', '0401002', ' (, ) -  ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3036, '5', '1', '0', 2, NULL, '1', '0401002', ' (, ) -  ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3037, '5', '1', '0', 3, NULL, '1', '0401002', ' (, ) -  ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3038, '5', '1', '0', 1, NULL, '1', '0402802', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3039, '5', '1', '0', 2, NULL, '1', '0402802', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3040, '5', '1', '0', 3, NULL, '1', '0402802', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3041, '5', '1', '2', 1, NULL, '1', '0400102', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3042, '5', '1', '2', 2, NULL, '1', '0400102', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3043, '5', '1', '2', 3, NULL, '1', '0400102', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3044, '5', '1', '0', 1, NULL, '1', '0406402', ' (, ) -  ', NULL, '1', 2.5, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3045, '5', '1', '0', 2, NULL, '1', '0406402', ' (, ) -  ', NULL, '1', 2.5, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3046, '5', '1', '0', 3, NULL, '1', '0406402', ' (, ) -  ', NULL, '1', 2.5, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3047, '5', '1', '0', 2, NULL, '1', '0405002', ' (, ) -,  ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3048, '5', '1', '0', 3, NULL, '1', '0405002', ' (, ) -,  ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3049, '5', '1', '1', 1, NULL, '1', '0405302', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3050, '5', '1', '1', 2, NULL, '1', '0405302', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3051, '5', '1', '1', 3, NULL, '1', '0405302', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3052, '5', '1', '0', 3, NULL, '1', '0101101', ' (, ) -  ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3053, '5', '1', '0', 3, NULL, '1', '0609007', ' ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3054, '7', '1', '0', 0, NULL, '1', '0107401', ' (, ) -   ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3055, '7', '1', '0', 1, NULL, '1', '0107401', ' (, ) -   ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3056, '7', '1', '0', 0, NULL, '0', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3057, '7', '1', '0', 1, NULL, '0', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3058, '7', '1', '0', 0, NULL, '0', '0905026', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3059, '7', '1', '0', 1, NULL, '0', '0905026', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3060, '7', '1', '0', 0, NULL, '1', '0201001', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3061, '7', '1', '0', 1, NULL, '1', '0201001', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3062, '7', '1', '0', 0, NULL, '0', '0201004', '    ()', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3063, '7', '1', '0', 1, NULL, '0', '0201004', '    ()', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3064, '7', '1', '0', 0, NULL, '1', '0203005', ' ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3065, '7', '1', '0', 1, NULL, '1', '0203005', ' ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3066, '7', '1', '0', 0, NULL, '1', '0212002', '     ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3067, '7', '1', '0', 1, NULL, '1', '0212002', '     ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3068, '7', '1', '0', 0, NULL, '0', '0209002', '   ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3069, '7', '1', '0', 1, NULL, '0', '0209002', '   ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3070, '7', '1', '0', 0, NULL, '0', '0510001', ' ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3071, '7', '1', '0', 1, NULL, '0', '0510001', ' ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3072, '7', '1', '0', 0, NULL, '0', '0510007', ',     ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3073, '7', '1', '0', 1, NULL, '0', '0510007', ',     ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3074, '7', '1', '0', 0, NULL, '0', '0331002', '', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3075, '7', '1', '0', 1, NULL, '0', '0331002', '', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3076, '7', '1', '0', 0, NULL, '0', '1209001', '     ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3077, '7', '1', '0', 1, NULL, '0', '1209001', '     ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3078, '7', '1', '0', 0, NULL, '0', '1209003', '      ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3079, '7', '1', '0', 1, NULL, '0', '1209003', '      ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3080, '7', '1', '0', 0, NULL, '0', '1225005', '', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3081, '7', '1', '0', 1, NULL, '0', '1225005', '', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3082, '7', '1', '0', 0, NULL, '0', '0905093', '   ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3083, '7', '1', '0', 1, NULL, '0', '0905093', '   ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3084, '7', '1', '0', 0, NULL, '0', '1213001', '   ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3085, '7', '1', '0', 1, NULL, '0', '1213001', '   ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3088, '7', '1', '0', 0, NULL, '0', '0203004', '', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3089, '7', '2', '0', 0, NULL, '1', '0107402', ' (, ) -   ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3090, '7', '2', '0', 1, NULL, '1', '0107402', ' (, ) -   ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3091, '4', '1', '0', 204, NULL, '1', '0301602', ' ()  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3092, '4', '1', '0', 204, NULL, '1', '0301606', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3093, '4', '1', '0', 204, NULL, '1', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3094, '4', '1', '0', 204, NULL, '1', '0510007', ',     ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3095, '4', '1', '0', 204, NULL, '1', '0510001', ' ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3096, '4', '1', '0', 204, NULL, '1', '0403502', ' (, ) - ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3097, '4', '1', '0', 204, NULL, '1', '0403102', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3098, '4', '1', '0', 204, NULL, '1', '0402302', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3099, '4', '1', '0', 204, NULL, '1', '0402902', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3100, '4', '1', '0', 204, NULL, '1', '0401002', ' (, ) -  ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3101, '4', '1', '0', 204, NULL, '1', '0402802', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3102, '4', '1', '2', 204, NULL, '1', '0400102', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3103, '4', '1', '0', 204, NULL, '1', '0406402', ' (, ) -  ', NULL, '1', 2.5, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3104, '4', '1', '0', 204, NULL, '1', '0405002', ' (, ) -,  ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3105, '4', '1', '1', 204, NULL, '1', '0405302', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3106, '4', '1', '0', 204, NULL, '1', '0101101', ' (, ) -  ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3107, '4', '1', '0', 204, NULL, '1', '0609007', ' ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3108, '4', '1', '0', 12, NULL, '1', '0403502', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-03-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3109, '4', '1', '0', 12, NULL, '1', '0402302', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3110, '4', '1', '0', 12, NULL, '1', '0402902', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3111, '4', '1', '0', 12, NULL, '1', '0401002', ' (, ) -  ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3112, '4', '1', '0', 12, NULL, '1', '0402802', ' (, ) - ', NULL, '1', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3113, '4', '1', '0', 12, NULL, '1', '0406402', ' (, ) -  ', NULL, '1', 2.5, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3114, '7', '1', '0', 0, NULL, '0', '0226004', '', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3115, '7', '1', '0', 1, NULL, '0', '0226004', '', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3116, '7', '1', '0', 0, NULL, '0', '0326008', '', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3117, '7', '1', '0', 1, NULL, '0', '0326008', '', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3118, '7', '1', '0', 0, NULL, '0', '0226015', ' ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3119, '7', '1', '0', 1, NULL, '0', '0226015', ' ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3120, '7', '1', '0', 0, NULL, '0', '0226024', '  , ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3121, '7', '1', '0', 1, NULL, '0', '0226024', '  , ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3122, '7', '2', '0', 0, NULL, '0', '0201001', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3123, '7', '2', '0', 1, NULL, '0', '0201001', '  ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3124, '7', '2', '0', 0, NULL, '0', '0201004', '    ()', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3125, '7', '2', '0', 1, NULL, '0', '0201004', '    ()', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3126, '7', '2', '0', 0, NULL, '0', '0203004', '', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3127, '7', '2', '0', 0, NULL, '0', '0203005', ' ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3128, '7', '2', '0', 1, NULL, '0', '0203005', ' ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3129, '7', '2', '0', 0, NULL, '0', '0209002', '   ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3130, '7', '2', '0', 1, NULL, '0', '0209002', '   ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3131, '7', '2', '0', 0, NULL, '0', '0212002', '     ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3132, '7', '2', '0', 1, NULL, '0', '0212002', '     ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3133, '7', '2', '0', 0, NULL, '0', '0226004', '', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3134, '7', '2', '0', 1, NULL, '0', '0226004', '', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3135, '7', '2', '0', 0, NULL, '0', '0226015', ' ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3136, '7', '2', '0', 1, NULL, '0', '0226015', ' ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3137, '7', '2', '0', 0, NULL, '0', '0226024', '  , ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3138, '7', '2', '0', 1, NULL, '0', '0226024', '  , ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3139, '7', '2', '0', 0, NULL, '0', '0326008', '', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3140, '7', '2', '0', 1, NULL, '0', '0326008', '', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3141, '7', '2', '0', 0, NULL, '0', '0331002', '', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3142, '7', '2', '0', 1, NULL, '0', '0331002', '', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3143, '7', '2', '0', 0, NULL, '0', '0510001', ' ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3144, '7', '2', '0', 1, NULL, '0', '0510001', ' ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3145, '7', '2', '0', 0, NULL, '0', '0510007', ',     ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3146, '7', '2', '0', 1, NULL, '0', '0510007', ',     ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3147, '7', '2', '0', 0, NULL, '0', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3148, '7', '2', '0', 1, NULL, '0', '0905023', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3149, '7', '2', '0', 0, NULL, '0', '0905026', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3150, '7', '2', '0', 1, NULL, '0', '0905026', '    ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3151, '7', '2', '0', 0, NULL, '0', '0905093', '   ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3152, '7', '2', '0', 1, NULL, '0', '0905093', '   ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3153, '7', '2', '0', 0, NULL, '0', '1209001', '     ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3154, '7', '2', '0', 1, NULL, '0', '1209001', '     ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3155, '7', '2', '0', 0, NULL, '0', '1209003', '      ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3156, '7', '2', '0', 1, NULL, '0', '1209003', '      ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3157, '7', '2', '0', 0, NULL, '0', '1213001', '   ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3158, '7', '2', '0', 1, NULL, '0', '1213001', '   ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3159, '7', '2', '0', 0, NULL, '0', '1225005', '', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3160, '7', '2', '0', 1, NULL, '0', '1225005', '', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3161, '7', '1', '0', 0, NULL, '0', '0406502', '  (, ) - ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3162, '7', '1', '0', 1, NULL, '0', '0406502', '  (, ) - ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3163, '7', '2', '0', 0, NULL, '0', '0406502', '  (, ) - ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3164, '7', '2', '0', 1, NULL, '0', '0406502', '  (, ) - ', NULL, '0', NULL, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3165, '2', '1', '1', 0, NULL, '1', '0301602', ' ()  ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3166, '2', '1', '1', 1, NULL, '1', '0301602', ' ()  ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3167, '2', '1', '1', 2, NULL, '1', '0301602', ' ()  ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3168, '2', '1', '1', 3, NULL, '1', '0301602', ' ()  ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3169, '2', '1', '1', 4, NULL, '1', '0301602', ' ()  ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3170, '2', '1', '1', 5, NULL, '1', '0301602', ' ()  ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3171, '2', '1', '1', 6, NULL, '1', '0301602', ' ()  ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3172, '2', '1', '1', 7, NULL, '1', '0301602', ' ()  ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3173, '2', '1', '1', 8, NULL, '1', '0301602', ' ()  ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3174, '2', '1', '1', 9, NULL, '1', '0301602', ' ()  ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3175, '2', '1', '1', 10, NULL, '1', '0301602', ' ()  ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3176, '2', '1', '1', 11, NULL, '1', '0301602', ' ()  ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3177, '2', '1', '1', 12, NULL, '1', '0301602', ' ()  ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3178, '2', '1', '1', 13, NULL, '1', '0301602', ' ()  ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3179, '2', '1', '1', 14, NULL, '1', '0301602', ' ()  ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3180, '2', '1', '1', 15, NULL, '1', '0301602', ' ()  ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3181, '2', '1', '1', 16, NULL, '1', '0301602', ' ()  ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3182, '2', '1', '1', 17, NULL, '1', '0301602', ' ()  ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3183, '2', '1', '1', 0, NULL, '1', '0301606', '  ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3184, '2', '1', '1', 1, NULL, '1', '0301606', '  ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3185, '2', '1', '1', 2, NULL, '1', '0301606', '  ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3186, '2', '1', '1', 3, NULL, '1', '0301606', '  ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3187, '2', '1', '1', 4, NULL, '1', '0301606', '  ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3188, '2', '1', '1', 5, NULL, '1', '0301606', '  ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3189, '2', '1', '1', 6, NULL, '1', '0301606', '  ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3190, '2', '1', '1', 7, NULL, '1', '0301606', '  ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3191, '2', '1', '1', 8, NULL, '1', '0301606', '  ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3192, '2', '1', '1', 9, NULL, '1', '0301606', '  ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3193, '2', '1', '1', 10, NULL, '1', '0301606', '  ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3194, '2', '1', '1', 11, NULL, '1', '0301606', '  ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3195, '2', '1', '1', 12, NULL, '1', '0301606', '  ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3196, '2', '1', '1', 13, NULL, '1', '0301606', '  ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3197, '2', '1', '1', 14, NULL, '1', '0301606', '  ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3198, '2', '1', '1', 15, NULL, '1', '0301606', '  ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3199, '2', '1', '1', 16, NULL, '1', '0301606', '  ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3200, '2', '1', '1', 17, NULL, '1', '0301606', '  ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3201, '2', '1', '1', 0, NULL, '1', '0510001', ' ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3202, '2', '1', '1', 1, NULL, '1', '0510001', ' ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3203, '2', '1', '1', 2, NULL, '1', '0510001', ' ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3204, '2', '1', '1', 3, NULL, '1', '0510001', ' ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3205, '2', '1', '1', 4, NULL, '1', '0510001', ' ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3206, '2', '1', '1', 6, NULL, '1', '0510001', ' ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3207, '2', '1', '1', 7, NULL, '1', '0510001', ' ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3208, '2', '1', '1', 8, NULL, '1', '0510001', ' ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3209, '2', '1', '1', 9, NULL, '1', '0510001', ' ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3210, '2', '1', '1', 10, NULL, '1', '0510001', ' ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3211, '2', '1', '1', 11, NULL, '1', '0510001', ' ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3212, '2', '1', '1', 12, NULL, '1', '0510001', ' ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3213, '2', '1', '1', 13, NULL, '1', '0510001', ' ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3214, '2', '1', '1', 14, NULL, '1', '0510001', ' ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3215, '2', '1', '1', 15, NULL, '1', '0510001', ' ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3216, '2', '1', '1', 16, NULL, '1', '0510001', ' ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3217, '2', '1', '1', 17, NULL, '1', '0510001', ' ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3218, '2', '1', '1', 0, NULL, '1', '0404001', '   ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3219, '2', '1', '1', 0, NULL, '1', '0428001', '  ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3220, '2', '1', '1', 1, NULL, '1', '0428001', '  ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3221, '2', '1', '1', 2, NULL, '1', '0428001', '  ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3222, '2', '1', '1', 3, NULL, '1', '0428001', '  ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3223, '2', '1', '1', 4, NULL, '1', '0428001', '  ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3224, '2', '1', '1', 5, NULL, '1', '0428001', '  ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3225, '2', '1', '1', 6, NULL, '1', '0428001', '  ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3226, '2', '1', '1', 7, NULL, '1', '0428001', '  ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3227, '2', '1', '1', 8, NULL, '1', '0428001', '  ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3228, '2', '1', '1', 9, NULL, '1', '0428001', '  ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3229, '2', '1', '1', 10, NULL, '1', '0428001', '  ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3230, '2', '1', '1', 11, NULL, '1', '0428001', '  ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3231, '2', '1', '1', 12, NULL, '1', '0428001', '  ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3232, '2', '1', '1', 13, NULL, '1', '0428001', '  ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3233, '2', '1', '1', 14, NULL, '1', '0428001', '  ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3234, '2', '1', '1', 15, NULL, '1', '0428001', '  ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3235, '2', '1', '1', 16, NULL, '1', '0428001', '  ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3236, '2', '1', '1', 17, NULL, '1', '0428001', '  ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3237, '2', '1', '1', 0, NULL, '1', '0414000', '     ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3238, '2', '1', '1', 1, NULL, '1', '0414000', '     ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3239, '2', '1', '1', 2, NULL, '1', '0414000', '     ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3240, '2', '1', '1', 3, NULL, '1', '0414000', '     ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3241, '2', '1', '1', 4, NULL, '1', '0414000', '     ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3242, '2', '1', '1', 5, NULL, '1', '0414000', '     ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3243, '2', '1', '1', 6, NULL, '1', '0414000', '     ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3244, '2', '1', '1', 7, NULL, '1', '0414000', '     ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3245, '2', '1', '1', 8, NULL, '1', '0414000', '     ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3246, '2', '1', '1', 9, NULL, '1', '0414000', '     ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3247, '2', '1', '1', 10, NULL, '1', '0414000', '     ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3248, '2', '1', '1', 11, NULL, '1', '0414000', '     ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3249, '2', '1', '1', 12, NULL, '1', '0414000', '     ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3250, '2', '1', '1', 13, NULL, '1', '0414000', '     ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3251, '2', '1', '1', 14, NULL, '1', '0414000', '     ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3252, '2', '1', '1', 15, NULL, '1', '0414000', '     ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3253, '2', '1', '1', 16, NULL, '1', '0414000', '     ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3254, '2', '1', '1', 17, NULL, '1', '0414000', '     ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3255, '2', '1', '1', 0, NULL, '1', '0410002', '', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3256, '2', '1', '1', 1, NULL, '1', '0410002', '', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3257, '2', '1', '1', 2, NULL, '1', '0410002', '', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3258, '2', '1', '1', 3, NULL, '1', '0410002', '', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3259, '2', '1', '1', 4, NULL, '1', '0410002', '', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3260, '2', '1', '1', 5, NULL, '1', '0410002', '', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3261, '2', '1', '1', 6, NULL, '1', '0410002', '', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3262, '2', '1', '1', 7, NULL, '1', '0410002', '', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3263, '2', '1', '1', 8, NULL, '1', '0410002', '', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3264, '2', '1', '1', 9, NULL, '1', '0410002', '', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3265, '2', '1', '1', 10, NULL, '1', '0410002', '', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3266, '2', '1', '1', 11, NULL, '1', '0410002', '', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3267, '2', '1', '1', 12, NULL, '1', '0410002', '', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3268, '2', '1', '1', 13, NULL, '1', '0410002', '', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3269, '2', '1', '1', 14, NULL, '1', '0410002', '', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3270, '2', '1', '1', 15, NULL, '1', '0410002', '', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3271, '2', '1', '1', 16, NULL, '1', '0410002', '', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3272, '2', '1', '1', 17, NULL, '1', '0410002', '', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3273, '2', '1', '1', 0, NULL, '1', '0403102', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3274, '2', '1', '1', 1, NULL, '1', '0403102', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3275, '2', '1', '1', 2, NULL, '1', '0403102', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3276, '2', '1', '1', 3, NULL, '1', '0403102', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3277, '2', '1', '1', 4, NULL, '1', '0403102', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3278, '2', '1', '1', 5, NULL, '1', '0403102', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3279, '2', '1', '1', 6, NULL, '1', '0403102', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3280, '2', '1', '1', 7, NULL, '1', '0403102', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3281, '2', '1', '1', 8, NULL, '1', '0403102', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3282, '2', '1', '1', 9, NULL, '1', '0403102', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3283, '2', '1', '1', 10, NULL, '1', '0403102', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3284, '2', '1', '1', 11, NULL, '1', '0403102', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3285, '2', '1', '1', 12, NULL, '1', '0403102', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3286, '2', '1', '1', 13, NULL, '1', '0403102', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3287, '2', '1', '1', 14, NULL, '1', '0403102', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3288, '2', '1', '1', 15, NULL, '1', '0403102', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3289, '2', '1', '1', 16, NULL, '1', '0403102', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3290, '2', '1', '1', 17, NULL, '1', '0403102', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3291, '2', '1', '1', 0, NULL, '1', '0402302', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3292, '2', '1', '1', 1, NULL, '1', '0402302', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3293, '2', '1', '1', 2, NULL, '1', '0402302', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3294, '2', '1', '1', 3, NULL, '1', '0402302', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3295, '2', '1', '1', 4, NULL, '1', '0402302', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3296, '2', '1', '1', 5, NULL, '1', '0402302', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3297, '2', '1', '1', 6, NULL, '1', '0402302', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3298, '2', '1', '1', 7, NULL, '1', '0402302', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3299, '2', '1', '1', 8, NULL, '1', '0402302', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3300, '2', '1', '1', 9, NULL, '1', '0402302', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3301, '2', '1', '1', 10, NULL, '1', '0402302', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3302, '2', '1', '1', 11, NULL, '1', '0402302', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3303, '2', '1', '1', 12, NULL, '1', '0402302', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3304, '2', '1', '1', 13, NULL, '1', '0402302', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3305, '2', '1', '1', 14, NULL, '1', '0402302', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3306, '2', '1', '1', 15, NULL, '1', '0402302', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3307, '2', '1', '1', 16, NULL, '1', '0402302', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3308, '2', '1', '1', 17, NULL, '1', '0402302', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3309, '2', '1', '1', 0, NULL, '1', '0402902', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3310, '2', '1', '1', 1, NULL, '1', '0402902', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3311, '2', '1', '1', 2, NULL, '1', '0402902', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3312, '2', '1', '1', 3, NULL, '1', '0402902', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3313, '2', '1', '1', 4, NULL, '1', '0402902', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3314, '2', '1', '1', 5, NULL, '1', '0402902', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3315, '2', '1', '1', 6, NULL, '1', '0402902', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3316, '2', '1', '1', 7, NULL, '1', '0402902', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3317, '2', '1', '1', 8, NULL, '1', '0402902', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3318, '2', '1', '1', 9, NULL, '1', '0402902', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3319, '2', '1', '1', 10, NULL, '1', '0402902', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3320, '2', '1', '1', 11, NULL, '1', '0402902', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3321, '2', '1', '1', 12, NULL, '1', '0402902', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3322, '2', '1', '1', 13, NULL, '1', '0402902', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3323, '2', '1', '1', 14, NULL, '1', '0402902', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3324, '2', '1', '1', 15, NULL, '1', '0402902', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3325, '2', '1', '1', 16, NULL, '1', '0402902', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3326, '2', '1', '1', 17, NULL, '1', '0402902', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3327, '2', '1', '1', 0, NULL, '1', '0401002', ' (, ) -  ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3328, '2', '1', '1', 1, NULL, '1', '0401002', ' (, ) -  ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3329, '2', '1', '1', 2, NULL, '1', '0401002', ' (, ) -  ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3330, '2', '1', '1', 3, NULL, '1', '0401002', ' (, ) -  ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3331, '2', '1', '1', 4, NULL, '1', '0401002', ' (, ) -  ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3332, '2', '1', '1', 5, NULL, '1', '0401002', ' (, ) -  ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3333, '2', '1', '1', 6, NULL, '1', '0401002', ' (, ) -  ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3334, '2', '1', '1', 7, NULL, '1', '0401002', ' (, ) -  ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3335, '2', '1', '1', 8, NULL, '1', '0401002', ' (, ) -  ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3336, '2', '1', '1', 9, NULL, '1', '0401002', ' (, ) -  ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3337, '2', '1', '1', 10, NULL, '1', '0401002', ' (, ) -  ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3338, '2', '1', '1', 11, NULL, '1', '0401002', ' (, ) -  ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3339, '2', '1', '1', 12, NULL, '1', '0401002', ' (, ) -  ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3340, '2', '1', '1', 13, NULL, '1', '0401002', ' (, ) -  ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3341, '2', '1', '1', 14, NULL, '1', '0401002', ' (, ) -  ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3342, '2', '1', '1', 15, NULL, '1', '0401002', ' (, ) -  ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3343, '2', '1', '1', 16, NULL, '1', '0401002', ' (, ) -  ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3344, '2', '1', '1', 17, NULL, '1', '0401002', ' (, ) -  ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3345, '2', '1', '1', 0, NULL, '1', '0402802', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3346, '2', '1', '1', 1, NULL, '1', '0402802', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3347, '2', '1', '1', 2, NULL, '1', '0402802', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3348, '2', '1', '1', 3, NULL, '1', '0402802', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3349, '2', '1', '1', 4, NULL, '1', '0402802', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3350, '2', '1', '1', 5, NULL, '1', '0402802', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3351, '2', '1', '1', 6, NULL, '1', '0402802', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3352, '2', '1', '1', 7, NULL, '1', '0402802', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3353, '2', '1', '1', 8, NULL, '1', '0402802', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3354, '2', '1', '1', 9, NULL, '1', '0402802', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3355, '2', '1', '1', 10, NULL, '1', '0402802', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3356, '2', '1', '1', 11, NULL, '1', '0402802', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3357, '2', '1', '1', 12, NULL, '1', '0402802', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3358, '2', '1', '1', 13, NULL, '1', '0402802', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3359, '2', '1', '1', 14, NULL, '1', '0402802', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3360, '2', '1', '1', 15, NULL, '1', '0402802', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3361, '2', '1', '1', 16, NULL, '1', '0402802', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3362, '2', '1', '1', 17, NULL, '1', '0402802', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3363, '2', '1', '1', 3, NULL, '1', '0406402', ' (, ) -  ', 0, '1', 2.5, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3364, '2', '1', '1', 4, NULL, '1', '0406402', ' (, ) -  ', 0, '1', 2.5, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3365, '2', '1', '1', 5, NULL, '1', '0406402', ' (, ) -  ', 0, '1', 2.5, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3366, '2', '1', '1', 6, NULL, '1', '0406402', ' (, ) -  ', 0, '1', 2.5, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3367, '2', '1', '1', 7, NULL, '1', '0406402', ' (, ) -  ', 0, '1', 2.5, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3368, '2', '1', '1', 8, NULL, '1', '0406402', ' (, ) -  ', 0, '1', 2.5, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3369, '2', '1', '1', 9, NULL, '1', '0406402', ' (, ) -  ', 0, '1', 2.5, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3370, '2', '1', '1', 10, NULL, '1', '0406402', ' (, ) -  ', 0, '1', 2.5, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3371, '2', '1', '1', 11, NULL, '1', '0406402', ' (, ) -  ', 0, '1', 2.5, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3372, '2', '1', '1', 12, NULL, '1', '0406402', ' (, ) -  ', 0, '1', 2.5, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3373, '2', '1', '1', 13, NULL, '1', '0406402', ' (, ) -  ', 0, '1', 2.5, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3374, '2', '1', '1', 14, NULL, '1', '0406402', ' (, ) -  ', 0, '1', 2.5, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3375, '2', '1', '1', 15, NULL, '1', '0406402', ' (, ) -  ', 0, '1', 2.5, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3376, '2', '1', '1', 16, NULL, '1', '0406402', ' (, ) -  ', 0, '1', 2.5, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3377, '2', '1', '1', 17, NULL, '1', '0406402', ' (, ) -  ', 0, '1', 2.5, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3378, '2', '1', '1', 0, NULL, '1', '0405002', ' (, ) -,  ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3379, '2', '1', '1', 1, NULL, '1', '0405002', ' (, ) -,  ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3380, '2', '1', '1', 2, NULL, '1', '0405002', ' (, ) -,  ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3381, '2', '1', '1', 3, NULL, '1', '0405002', ' (, ) -,  ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3382, '2', '1', '1', 4, NULL, '1', '0405002', ' (, ) -,  ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3383, '2', '1', '1', 5, NULL, '1', '0405002', ' (, ) -,  ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3384, '2', '1', '1', 6, NULL, '1', '0405002', ' (, ) -,  ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3385, '2', '1', '1', 7, NULL, '1', '0405002', ' (, ) -,  ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3386, '2', '1', '1', 8, NULL, '1', '0405002', ' (, ) -,  ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3387, '2', '1', '1', 9, NULL, '1', '0405002', ' (, ) -,  ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3388, '2', '1', '1', 10, NULL, '1', '0405002', ' (, ) -,  ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3389, '2', '1', '1', 11, NULL, '1', '0405002', ' (, ) -,  ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3390, '2', '1', '1', 12, NULL, '1', '0405002', ' (, ) -,  ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3391, '2', '1', '1', 13, NULL, '1', '0405002', ' (, ) -,  ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3392, '2', '1', '1', 14, NULL, '1', '0405002', ' (, ) -,  ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3393, '2', '1', '1', 15, NULL, '1', '0405002', ' (, ) -,  ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3394, '2', '1', '1', 16, NULL, '1', '0405002', ' (, ) -,  ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3395, '2', '1', '1', 17, NULL, '1', '0405002', ' (, ) -,  ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3396, '2', '1', '1', 0, NULL, '1', '0403502', ' (, ) - ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3397, '2', '1', '1', 1, NULL, '1', '0403502', ' (, ) - ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3398, '2', '1', '1', 2, NULL, '1', '0403502', ' (, ) - ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3399, '2', '1', '1', 3, NULL, '1', '0403502', ' (, ) - ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3400, '2', '1', '1', 4, NULL, '1', '0403502', ' (, ) - ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3401, '2', '1', '1', 5, NULL, '1', '0403502', ' (, ) - ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3402, '2', '1', '1', 6, NULL, '1', '0403502', ' (, ) - ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3403, '2', '1', '1', 7, NULL, '1', '0403502', ' (, ) - ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3404, '2', '1', '1', 8, NULL, '1', '0403502', ' (, ) - ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3405, '2', '1', '1', 9, NULL, '1', '0403502', ' (, ) - ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3406, '2', '1', '1', 10, NULL, '1', '0403502', ' (, ) - ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3407, '2', '1', '1', 11, NULL, '1', '0403502', ' (, ) - ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3408, '2', '1', '1', 12, NULL, '1', '0403502', ' (, ) - ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3409, '2', '1', '1', 13, NULL, '1', '0403502', ' (, ) - ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3410, '2', '1', '1', 14, NULL, '1', '0403502', ' (, ) - ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3411, '2', '1', '1', 15, NULL, '1', '0403502', ' (, ) - ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3412, '2', '1', '1', 16, NULL, '1', '0403502', ' (, ) - ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3413, '2', '1', '1', 17, NULL, '1', '0403502', ' (, ) - ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3414, '2', '1', '1', 0, NULL, '1', '0405302', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3415, '2', '1', '1', 1, NULL, '1', '0405302', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3416, '2', '1', '1', 2, NULL, '1', '0405302', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3417, '2', '1', '1', 3, NULL, '1', '0405302', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3418, '2', '1', '1', 4, NULL, '1', '0405302', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3419, '2', '1', '1', 5, NULL, '1', '0405302', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3420, '2', '1', '1', 6, NULL, '1', '0405302', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3421, '2', '1', '1', 7, NULL, '1', '0405302', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3422, '2', '1', '1', 8, NULL, '1', '0405302', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3423, '2', '1', '1', 9, NULL, '1', '0405302', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3424, '2', '1', '1', 10, NULL, '1', '0405302', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3425, '2', '1', '1', 11, NULL, '1', '0405302', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3426, '2', '1', '1', 12, NULL, '1', '0405302', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3427, '2', '1', '1', 13, NULL, '1', '0405302', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3428, '2', '1', '1', 14, NULL, '1', '0405302', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3429, '2', '1', '1', 15, NULL, '1', '0405302', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3430, '2', '1', '1', 16, NULL, '1', '0405302', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3431, '2', '1', '1', 17, NULL, '1', '0405302', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3432, '2', '1', '1', 5, NULL, '1', '0101101', ' (, ) -  ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3433, '2', '1', '1', 6, NULL, '1', '0101101', ' (, ) -  ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3434, '2', '1', '1', 7, NULL, '1', '0101101', ' (, ) -  ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3435, '2', '1', '1', 8, NULL, '1', '0101101', ' (, ) -  ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3436, '2', '1', '1', 9, NULL, '1', '0101101', ' (, ) -  ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3437, '2', '1', '1', 10, NULL, '1', '0101101', ' (, ) -  ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3438, '2', '1', '1', 11, NULL, '1', '0101101', ' (, ) -  ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3439, '2', '1', '1', 12, NULL, '1', '0101101', ' (, ) -  ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3440, '2', '1', '1', 13, NULL, '1', '0101101', ' (, ) -  ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3441, '2', '1', '1', 14, NULL, '1', '0101101', ' (, ) -  ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3442, '2', '1', '1', 15, NULL, '1', '0101101', ' (, ) -  ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3443, '2', '1', '1', 16, NULL, '1', '0101101', ' (, ) -  ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3444, '2', '1', '1', 17, NULL, '1', '0101101', ' (, ) -  ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3445, '2', '1', '1', 0, NULL, '1', '0905023', '    ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3446, '2', '1', '1', 1, NULL, '1', '0905023', '    ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3447, '2', '1', '1', 2, NULL, '1', '0905023', '    ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3448, '2', '1', '1', 3, NULL, '1', '0905023', '    ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3449, '2', '1', '1', 4, NULL, '1', '0905023', '    ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3450, '2', '1', '1', 5, NULL, '1', '0905023', '    ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3451, '2', '1', '1', 6, NULL, '1', '0905023', '    ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3452, '2', '1', '1', 7, NULL, '1', '0905023', '    ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3453, '2', '1', '1', 8, NULL, '1', '0905023', '    ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3454, '2', '1', '1', 9, NULL, '1', '0905023', '    ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3455, '2', '1', '1', 10, NULL, '1', '0905023', '    ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3456, '2', '1', '1', 11, NULL, '1', '0905023', '    ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3457, '2', '1', '1', 12, NULL, '1', '0905023', '    ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3458, '2', '1', '1', 13, NULL, '1', '0905023', '    ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3459, '2', '1', '1', 14, NULL, '1', '0905023', '    ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3460, '2', '1', '1', 15, NULL, '1', '0905023', '    ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3461, '2', '1', '1', 16, NULL, '1', '0905023', '    ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3462, '2', '1', '1', 17, NULL, '1', '0905023', '    ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3463, '2', '1', '1', 15, NULL, '0', '0609007', ' ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3464, '2', '1', '1', 16, NULL, '0', '0609007', ' ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3465, '2', '1', '1', 17, NULL, '0', '0609007', ' ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3466, '2', '1', '1', 7, NULL, '1', '0422001', '   ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3467, '2', '1', '1', 8, NULL, '1', '0422001', '   ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3468, '2', '1', '1', 9, NULL, '1', '0422001', '   ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3469, '2', '1', '1', 10, NULL, '1', '0422001', '   ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3470, '2', '1', '1', 11, NULL, '1', '0422001', '   ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3471, '2', '1', '1', 12, NULL, '1', '0422001', '   ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3472, '2', '1', '1', 13, NULL, '1', '0422001', '   ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3473, '2', '1', '1', 14, NULL, '1', '0422001', '   ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3474, '2', '1', '1', 15, NULL, '1', '0422001', '   ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3475, '2', '1', '1', 16, NULL, '1', '0422001', '   ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3476, '2', '1', '1', 17, NULL, '1', '0422001', '   ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3477, '2', '1', '1', 0, NULL, '1', '0423001', '   ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3478, '2', '1', '1', 7, NULL, '1', '0421001', '  ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3479, '2', '1', '1', 8, NULL, '1', '0421001', '  ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3480, '2', '1', '1', 9, NULL, '1', '0421001', '  ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3481, '2', '1', '1', 10, NULL, '1', '0421001', '  ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3482, '2', '1', '1', 11, NULL, '1', '0421001', '  ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3483, '2', '1', '1', 12, NULL, '1', '0421001', '  ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3484, '2', '1', '1', 13, NULL, '1', '0421001', '  ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3485, '2', '1', '1', 14, NULL, '1', '0421001', '  ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3486, '2', '1', '1', 15, NULL, '1', '0421001', '  ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3487, '2', '1', '1', 16, NULL, '1', '0421001', '  ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3488, '2', '1', '1', 17, NULL, '1', '0421001', '  ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3489, '2', '1', '1', 7, NULL, '1', '0421002', '   (, )', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3490, '2', '1', '1', 8, NULL, '1', '0421002', '   (, )', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3491, '2', '1', '1', 9, NULL, '1', '0421002', '   (, )', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3492, '2', '1', '1', 10, NULL, '1', '0421002', '   (, )', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3493, '2', '1', '1', 11, NULL, '1', '0421002', '   (, )', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3494, '2', '1', '1', 12, NULL, '1', '0421002', '   (, )', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3495, '2', '1', '1', 13, NULL, '1', '0421002', '   (, )', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3496, '2', '1', '1', 14, NULL, '1', '0421002', '   (, )', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3497, '2', '1', '1', 15, NULL, '1', '0421002', '   (, )', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3498, '2', '1', '1', 16, NULL, '1', '0421002', '   (, )', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3499, '2', '1', '1', 17, NULL, '1', '0421002', '   (, )', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3500, '2', '1', '1', 7, NULL, '1', '0421003', '   ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3501, '2', '1', '1', 8, NULL, '1', '0421003', '   ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3502, '2', '1', '1', 9, NULL, '1', '0421003', '   ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3503, '2', '1', '1', 10, NULL, '1', '0421003', '   ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3504, '2', '1', '1', 11, NULL, '1', '0421003', '   ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3505, '2', '1', '1', 12, NULL, '1', '0421003', '   ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3506, '2', '1', '1', 13, NULL, '1', '0421003', '   ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3507, '2', '1', '1', 14, NULL, '1', '0421003', '   ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3508, '2', '1', '1', 15, NULL, '1', '0421003', '   ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3509, '2', '1', '1', 16, NULL, '1', '0421003', '   ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3510, '2', '1', '1', 17, NULL, '1', '0421003', '   ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3511, '2', '1', '2', 0, NULL, '1', '0301602', ' ()  ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3512, '2', '1', '2', 1, NULL, '1', '0301602', ' ()  ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3513, '2', '1', '2', 2, NULL, '1', '0301602', ' ()  ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3514, '2', '1', '2', 3, NULL, '1', '0301602', ' ()  ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3515, '2', '1', '2', 4, NULL, '1', '0301602', ' ()  ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3516, '2', '1', '2', 5, NULL, '1', '0301602', ' ()  ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3517, '2', '1', '2', 6, NULL, '1', '0301602', ' ()  ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3518, '2', '1', '2', 7, NULL, '1', '0301602', ' ()  ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3519, '2', '1', '2', 8, NULL, '1', '0301602', ' ()  ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3520, '2', '1', '2', 9, NULL, '1', '0301602', ' ()  ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3521, '2', '1', '2', 10, NULL, '1', '0301602', ' ()  ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3522, '2', '1', '2', 11, NULL, '1', '0301602', ' ()  ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3523, '2', '1', '2', 12, NULL, '1', '0301602', ' ()  ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3524, '2', '1', '2', 13, NULL, '1', '0301602', ' ()  ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3525, '2', '1', '2', 14, NULL, '1', '0301602', ' ()  ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3526, '2', '1', '2', 15, NULL, '1', '0301602', ' ()  ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3527, '2', '1', '2', 16, NULL, '1', '0301602', ' ()  ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3528, '2', '1', '2', 17, NULL, '1', '0301602', ' ()  ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3529, '2', '1', '2', 0, NULL, '1', '0301606', '  ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3530, '2', '1', '2', 1, NULL, '1', '0301606', '  ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3531, '2', '1', '2', 2, NULL, '1', '0301606', '  ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3532, '2', '1', '2', 3, NULL, '1', '0301606', '  ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3533, '2', '1', '2', 4, NULL, '1', '0301606', '  ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3534, '2', '1', '2', 5, NULL, '1', '0301606', '  ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3535, '2', '1', '2', 6, NULL, '1', '0301606', '  ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3536, '2', '1', '2', 7, NULL, '1', '0301606', '  ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3537, '2', '1', '2', 8, NULL, '1', '0301606', '  ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3538, '2', '1', '2', 9, NULL, '1', '0301606', '  ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3539, '2', '1', '2', 10, NULL, '1', '0301606', '  ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3540, '2', '1', '2', 11, NULL, '1', '0301606', '  ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3541, '2', '1', '2', 12, NULL, '1', '0301606', '  ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3542, '2', '1', '2', 13, NULL, '1', '0301606', '  ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3543, '2', '1', '2', 14, NULL, '1', '0301606', '  ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3544, '2', '1', '2', 15, NULL, '1', '0301606', '  ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3545, '2', '1', '2', 16, NULL, '1', '0301606', '  ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3546, '2', '1', '2', 17, NULL, '1', '0301606', '  ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3547, '2', '1', '2', 0, NULL, '1', '0510001', ' ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3548, '2', '1', '2', 1, NULL, '1', '0510001', ' ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3549, '2', '1', '2', 2, NULL, '1', '0510001', ' ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3550, '2', '1', '2', 3, NULL, '1', '0510001', ' ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3551, '2', '1', '2', 4, NULL, '1', '0510001', ' ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3552, '2', '1', '2', 5, NULL, '1', '0510001', ' ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3553, '2', '1', '2', 6, NULL, '1', '0510001', ' ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3554, '2', '1', '2', 7, NULL, '1', '0510001', ' ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3555, '2', '1', '2', 8, NULL, '1', '0510001', ' ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3556, '2', '1', '2', 9, NULL, '1', '0510001', ' ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3557, '2', '1', '2', 10, NULL, '1', '0510001', ' ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3558, '2', '1', '2', 11, NULL, '1', '0510001', ' ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3559, '2', '1', '2', 12, NULL, '1', '0510001', ' ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3560, '2', '1', '2', 13, NULL, '1', '0510001', ' ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3561, '2', '1', '2', 14, NULL, '1', '0510001', ' ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3562, '2', '1', '2', 15, NULL, '1', '0510001', ' ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3563, '2', '1', '2', 16, NULL, '1', '0510001', ' ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3564, '2', '1', '2', 17, NULL, '1', '0510001', ' ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3565, '2', '1', '2', 0, NULL, '1', '0404001', '   ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3566, '2', '1', '2', 0, NULL, '1', '0428001', '  ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3567, '2', '1', '2', 1, NULL, '1', '0428001', '  ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3568, '2', '1', '2', 2, NULL, '1', '0428001', '  ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3569, '2', '1', '2', 3, NULL, '1', '0428001', '  ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3570, '2', '1', '2', 4, NULL, '1', '0428001', '  ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3571, '2', '1', '2', 5, NULL, '1', '0428001', '  ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3572, '2', '1', '2', 6, NULL, '1', '0428001', '  ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3573, '2', '1', '2', 7, NULL, '1', '0428001', '  ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3574, '2', '1', '2', 8, NULL, '1', '0428001', '  ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3575, '2', '1', '2', 9, NULL, '1', '0428001', '  ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3576, '2', '1', '2', 10, NULL, '1', '0428001', '  ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3577, '2', '1', '2', 11, NULL, '1', '0428001', '  ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3578, '2', '1', '2', 12, NULL, '1', '0428001', '  ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3579, '2', '1', '2', 13, NULL, '1', '0428001', '  ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3580, '2', '1', '2', 14, NULL, '1', '0428001', '  ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3581, '2', '1', '2', 15, NULL, '1', '0428001', '  ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3582, '2', '1', '2', 16, NULL, '1', '0428001', '  ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3583, '2', '1', '2', 17, NULL, '1', '0428001', '  ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3584, '2', '1', '2', 0, NULL, '1', '0414000', '     ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3585, '2', '1', '2', 1, NULL, '1', '0414000', '     ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3586, '2', '1', '2', 2, NULL, '1', '0414000', '     ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3587, '2', '1', '2', 3, NULL, '1', '0414000', '     ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3588, '2', '1', '2', 4, NULL, '1', '0414000', '     ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3589, '2', '1', '2', 5, NULL, '1', '0414000', '     ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3590, '2', '1', '2', 6, NULL, '1', '0414000', '     ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3591, '2', '1', '2', 7, NULL, '1', '0414000', '     ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3592, '2', '1', '2', 8, NULL, '1', '0414000', '     ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3593, '2', '1', '2', 9, NULL, '1', '0414000', '     ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3594, '2', '1', '2', 10, NULL, '1', '0414000', '     ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3595, '2', '1', '2', 11, NULL, '1', '0414000', '     ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3596, '2', '1', '2', 12, NULL, '1', '0414000', '     ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3597, '2', '1', '2', 13, NULL, '1', '0414000', '     ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3598, '2', '1', '2', 14, NULL, '1', '0414000', '     ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3599, '2', '1', '2', 15, NULL, '1', '0414000', '     ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3600, '2', '1', '2', 16, NULL, '1', '0414000', '     ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3601, '2', '1', '2', 17, NULL, '1', '0414000', '     ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3602, '2', '1', '2', 0, NULL, '1', '0410002', '', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3603, '2', '1', '2', 1, NULL, '1', '0410002', '', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3604, '2', '1', '2', 2, NULL, '1', '0410002', '', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3605, '2', '1', '2', 3, NULL, '1', '0410002', '', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3606, '2', '1', '2', 4, NULL, '1', '0410002', '', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3607, '2', '1', '2', 5, NULL, '1', '0410002', '', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3608, '2', '1', '2', 6, NULL, '1', '0410002', '', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3609, '2', '1', '2', 7, NULL, '1', '0410002', '', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3610, '2', '1', '2', 8, NULL, '1', '0410002', '', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3611, '2', '1', '2', 9, NULL, '1', '0410002', '', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3612, '2', '1', '2', 10, NULL, '1', '0410002', '', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3613, '2', '1', '2', 11, NULL, '1', '0410002', '', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3614, '2', '1', '2', 12, NULL, '1', '0410002', '', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3615, '2', '1', '2', 13, NULL, '1', '0410002', '', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3616, '2', '1', '2', 14, NULL, '1', '0410002', '', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3617, '2', '1', '2', 15, NULL, '1', '0410002', '', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3618, '2', '1', '2', 16, NULL, '1', '0410002', '', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3619, '2', '1', '2', 17, NULL, '1', '0410002', '', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3620, '2', '1', '2', 0, NULL, '1', '0403102', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3621, '2', '1', '2', 1, NULL, '1', '0403102', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3622, '2', '1', '2', 2, NULL, '1', '0403102', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3623, '2', '1', '2', 3, NULL, '1', '0403102', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3624, '2', '1', '2', 4, NULL, '1', '0403102', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3625, '2', '1', '2', 5, NULL, '1', '0403102', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3626, '2', '1', '2', 6, NULL, '1', '0403102', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3627, '2', '1', '2', 7, NULL, '1', '0403102', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3628, '2', '1', '2', 8, NULL, '1', '0403102', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3629, '2', '1', '2', 9, NULL, '1', '0403102', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3630, '2', '1', '2', 10, NULL, '1', '0403102', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3631, '2', '1', '2', 11, NULL, '1', '0403102', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3632, '2', '1', '2', 12, NULL, '1', '0403102', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3633, '2', '1', '2', 13, NULL, '1', '0403102', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3634, '2', '1', '2', 14, NULL, '1', '0403102', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3635, '2', '1', '2', 15, NULL, '1', '0403102', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3636, '2', '1', '2', 16, NULL, '1', '0403102', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3637, '2', '1', '2', 17, NULL, '1', '0403102', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3638, '2', '1', '2', 0, NULL, '1', '0402302', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3639, '2', '1', '2', 1, NULL, '1', '0402302', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3640, '2', '1', '2', 2, NULL, '1', '0402302', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3641, '2', '1', '2', 3, NULL, '1', '0402302', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3642, '2', '1', '2', 4, NULL, '1', '0402302', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3643, '2', '1', '2', 5, NULL, '1', '0402302', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3644, '2', '1', '2', 6, NULL, '1', '0402302', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3645, '2', '1', '2', 7, NULL, '1', '0402302', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3646, '2', '1', '2', 8, NULL, '1', '0402302', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3647, '2', '1', '2', 9, NULL, '1', '0402302', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3648, '2', '1', '2', 10, NULL, '1', '0402302', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3649, '2', '1', '2', 11, NULL, '1', '0402302', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3650, '2', '1', '2', 12, NULL, '1', '0402302', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3651, '2', '1', '2', 13, NULL, '1', '0402302', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3652, '2', '1', '2', 14, NULL, '1', '0402302', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3653, '2', '1', '2', 15, NULL, '1', '0402302', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3654, '2', '1', '2', 16, NULL, '1', '0402302', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3655, '2', '1', '2', 17, NULL, '1', '0402302', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3656, '2', '1', '2', 0, NULL, '1', '0402902', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3657, '2', '1', '2', 1, NULL, '1', '0402902', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3658, '2', '1', '2', 2, NULL, '1', '0402902', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3659, '2', '1', '2', 3, NULL, '1', '0402902', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3660, '2', '1', '2', 4, NULL, '1', '0402902', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3661, '2', '1', '2', 5, NULL, '1', '0402902', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3662, '2', '1', '2', 6, NULL, '1', '0402902', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3663, '2', '1', '2', 7, NULL, '1', '0402902', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3664, '2', '1', '2', 8, NULL, '1', '0402902', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3665, '2', '1', '2', 9, NULL, '1', '0402902', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3666, '2', '1', '2', 10, NULL, '1', '0402902', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3667, '2', '1', '2', 11, NULL, '1', '0402902', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3668, '2', '1', '2', 12, NULL, '1', '0402902', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3669, '2', '1', '2', 13, NULL, '1', '0402902', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3670, '2', '1', '2', 14, NULL, '1', '0402902', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3671, '2', '1', '2', 15, NULL, '1', '0402902', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3672, '2', '1', '2', 16, NULL, '1', '0402902', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3673, '2', '1', '2', 17, NULL, '1', '0402902', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3674, '2', '1', '2', 0, NULL, '1', '0401002', ' (, ) -  ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3675, '2', '1', '2', 1, NULL, '1', '0401002', ' (, ) -  ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3676, '2', '1', '2', 2, NULL, '1', '0401002', ' (, ) -  ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3677, '2', '1', '2', 3, NULL, '1', '0401002', ' (, ) -  ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3678, '2', '1', '2', 4, NULL, '1', '0401002', ' (, ) -  ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3679, '2', '1', '2', 5, NULL, '1', '0401002', ' (, ) -  ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3680, '2', '1', '2', 6, NULL, '1', '0401002', ' (, ) -  ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3681, '2', '1', '2', 7, NULL, '1', '0401002', ' (, ) -  ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3682, '2', '1', '2', 8, NULL, '1', '0401002', ' (, ) -  ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3683, '2', '1', '2', 9, NULL, '1', '0401002', ' (, ) -  ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3684, '2', '1', '2', 10, NULL, '1', '0401002', ' (, ) -  ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3685, '2', '1', '2', 11, NULL, '1', '0401002', ' (, ) -  ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3686, '2', '1', '2', 12, NULL, '1', '0401002', ' (, ) -  ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3687, '2', '1', '2', 13, NULL, '1', '0401002', ' (, ) -  ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3688, '2', '1', '2', 14, NULL, '1', '0401002', ' (, ) -  ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3689, '2', '1', '2', 15, NULL, '1', '0401002', ' (, ) -  ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3690, '2', '1', '2', 16, NULL, '1', '0401002', ' (, ) -  ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3691, '2', '1', '2', 17, NULL, '1', '0401002', ' (, ) -  ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3692, '2', '1', '2', 0, NULL, '1', '0402802', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3693, '2', '1', '2', 1, NULL, '1', '0402802', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3694, '2', '1', '2', 2, NULL, '1', '0402802', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3695, '2', '1', '2', 3, NULL, '1', '0402802', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3696, '2', '1', '2', 4, NULL, '1', '0402802', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3697, '2', '1', '2', 5, NULL, '1', '0402802', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3698, '2', '1', '2', 6, NULL, '1', '0402802', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3699, '2', '1', '2', 7, NULL, '1', '0402802', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3700, '2', '1', '2', 8, NULL, '1', '0402802', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3701, '2', '1', '2', 9, NULL, '1', '0402802', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3702, '2', '1', '2', 10, NULL, '1', '0402802', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3703, '2', '1', '2', 11, NULL, '1', '0402802', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3704, '2', '1', '2', 12, NULL, '1', '0402802', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3705, '2', '1', '2', 13, NULL, '1', '0402802', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3706, '2', '1', '2', 14, NULL, '1', '0402802', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3707, '2', '1', '2', 15, NULL, '1', '0402802', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3708, '2', '1', '2', 16, NULL, '1', '0402802', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3709, '2', '1', '2', 17, NULL, '1', '0402802', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3710, '2', '1', '2', 0, NULL, '1', '0400102', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3711, '2', '1', '2', 1, NULL, '1', '0400102', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3712, '2', '1', '2', 2, NULL, '1', '0400102', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3713, '2', '1', '2', 3, NULL, '1', '0400102', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3714, '2', '1', '2', 4, NULL, '1', '0400102', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3715, '2', '1', '2', 5, NULL, '1', '0400102', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3716, '2', '1', '2', 6, NULL, '1', '0400102', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3717, '2', '1', '2', 7, NULL, '1', '0400102', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3718, '2', '1', '2', 8, NULL, '1', '0400102', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3719, '2', '1', '2', 9, NULL, '1', '0400102', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3720, '2', '1', '2', 10, NULL, '1', '0400102', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3721, '2', '1', '2', 11, NULL, '1', '0400102', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3722, '2', '1', '2', 12, NULL, '1', '0400102', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3723, '2', '1', '2', 13, NULL, '1', '0400102', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3724, '2', '1', '2', 14, NULL, '1', '0400102', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3725, '2', '1', '2', 15, NULL, '1', '0400102', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3726, '2', '1', '2', 16, NULL, '1', '0400102', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3727, '2', '1', '2', 17, NULL, '1', '0400102', ' (, ) - ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3728, '2', '1', '2', 3, NULL, '1', '0406402', ' (, ) -  ', 0, '1', 2.5, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3729, '2', '1', '2', 4, NULL, '1', '0406402', ' (, ) -  ', 0, '1', 2.5, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3730, '2', '1', '2', 5, NULL, '1', '0406402', ' (, ) -  ', 0, '1', 2.5, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3731, '2', '1', '2', 6, NULL, '1', '0406402', ' (, ) -  ', 0, '1', 2.5, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3732, '2', '1', '2', 7, NULL, '1', '0406402', ' (, ) -  ', 0, '1', 2.5, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3733, '2', '1', '2', 8, NULL, '1', '0406402', ' (, ) -  ', 0, '1', 2.5, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3734, '2', '1', '2', 9, NULL, '1', '0406402', ' (, ) -  ', 0, '1', 2.5, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3735, '2', '1', '2', 10, NULL, '1', '0406402', ' (, ) -  ', 0, '1', 2.5, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3736, '2', '1', '2', 11, NULL, '1', '0406402', ' (, ) -  ', 0, '1', 2.5, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3737, '2', '1', '2', 12, NULL, '1', '0406402', ' (, ) -  ', 0, '1', 2.5, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3738, '2', '1', '2', 13, NULL, '1', '0406402', ' (, ) -  ', 0, '1', 2.5, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3739, '2', '1', '2', 14, NULL, '1', '0406402', ' (, ) -  ', 0, '1', 2.5, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3740, '2', '1', '2', 15, NULL, '1', '0406402', ' (, ) -  ', 0, '1', 2.5, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3741, '2', '1', '2', 16, NULL, '1', '0406402', ' (, ) -  ', 0, '1', 2.5, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3742, '2', '1', '2', 17, NULL, '1', '0406402', ' (, ) -  ', 0, '1', 2.5, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3743, '2', '1', '2', 0, NULL, '1', '0405002', ' (, ) -,  ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3744, '2', '1', '2', 1, NULL, '1', '0405002', ' (, ) -,  ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3745, '2', '1', '2', 2, NULL, '1', '0405002', ' (, ) -,  ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3746, '2', '1', '2', 3, NULL, '1', '0405002', ' (, ) -,  ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3747, '2', '1', '2', 4, NULL, '1', '0405002', ' (, ) -,  ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3748, '2', '1', '2', 5, NULL, '1', '0405002', ' (, ) -,  ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3749, '2', '1', '2', 6, NULL, '1', '0405002', ' (, ) -,  ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3750, '2', '1', '2', 7, NULL, '1', '0405002', ' (, ) -,  ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3751, '2', '1', '2', 8, NULL, '1', '0405002', ' (, ) -,  ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3752, '2', '1', '2', 9, NULL, '1', '0405002', ' (, ) -,  ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3753, '2', '1', '2', 10, NULL, '1', '0405002', ' (, ) -,  ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3754, '2', '1', '2', 11, NULL, '1', '0405002', ' (, ) -,  ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3755, '2', '1', '2', 12, NULL, '1', '0405002', ' (, ) -,  ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3756, '2', '1', '2', 13, NULL, '1', '0405002', ' (, ) -,  ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3757, '2', '1', '2', 14, NULL, '1', '0405002', ' (, ) -,  ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3758, '2', '1', '2', 15, NULL, '1', '0405002', ' (, ) -,  ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3759, '2', '1', '2', 16, NULL, '1', '0405002', ' (, ) -,  ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3760, '2', '1', '2', 17, NULL, '1', '0405002', ' (, ) -,  ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3761, '2', '1', '2', 0, NULL, '1', '0403502', ' (, ) - ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3762, '2', '1', '2', 1, NULL, '1', '0403502', ' (, ) - ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3763, '2', '1', '2', 2, NULL, '1', '0403502', ' (, ) - ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3764, '2', '1', '2', 3, NULL, '1', '0403502', ' (, ) - ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3765, '2', '1', '2', 4, NULL, '1', '0403502', ' (, ) - ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3766, '2', '1', '2', 5, NULL, '1', '0403502', ' (, ) - ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3767, '2', '1', '2', 6, NULL, '1', '0403502', ' (, ) - ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3768, '2', '1', '2', 7, NULL, '1', '0403502', ' (, ) - ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3769, '2', '1', '2', 8, NULL, '1', '0403502', ' (, ) - ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3770, '2', '1', '2', 9, NULL, '1', '0403502', ' (, ) - ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3771, '2', '1', '2', 10, NULL, '1', '0403502', ' (, ) - ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3772, '2', '1', '2', 11, NULL, '1', '0403502', ' (, ) - ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3773, '2', '1', '2', 12, NULL, '1', '0403502', ' (, ) - ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3774, '2', '1', '2', 13, NULL, '1', '0403502', ' (, ) - ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3775, '2', '1', '2', 14, NULL, '1', '0403502', ' (, ) - ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3776, '2', '1', '2', 15, NULL, '1', '0403502', ' (, ) - ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3777, '2', '1', '2', 16, NULL, '1', '0403502', ' (, ) - ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3778, '2', '1', '2', 17, NULL, '1', '0403502', ' (, ) - ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3779, '2', '1', '2', 5, NULL, '1', '0101101', ' (, ) -  ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3780, '2', '1', '2', 6, NULL, '1', '0101101', ' (, ) -  ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3781, '2', '1', '2', 7, NULL, '1', '0101101', ' (, ) -  ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3782, '2', '1', '2', 8, NULL, '1', '0101101', ' (, ) -  ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3783, '2', '1', '2', 9, NULL, '1', '0101101', ' (, ) -  ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3784, '2', '1', '2', 10, NULL, '1', '0101101', ' (, ) -  ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3785, '2', '1', '2', 11, NULL, '1', '0101101', ' (, ) -  ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3786, '2', '1', '2', 12, NULL, '1', '0101101', ' (, ) -  ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3787, '2', '1', '2', 13, NULL, '1', '0101101', ' (, ) -  ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3788, '2', '1', '2', 14, NULL, '1', '0101101', ' (, ) -  ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3789, '2', '1', '2', 15, NULL, '1', '0101101', ' (, ) -  ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3790, '2', '1', '2', 16, NULL, '1', '0101101', ' (, ) -  ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3791, '2', '1', '2', 17, NULL, '1', '0101101', ' (, ) -  ', 0, '1', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3792, '2', '1', '2', 0, NULL, '1', '0905023', '    ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3793, '2', '1', '2', 1, NULL, '1', '0905023', '    ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3794, '2', '1', '2', 2, NULL, '1', '0905023', '    ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3795, '2', '1', '2', 3, NULL, '1', '0905023', '    ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3796, '2', '1', '2', 4, NULL, '1', '0905023', '    ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3797, '2', '1', '2', 5, NULL, '1', '0905023', '    ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3798, '2', '1', '2', 6, NULL, '1', '0905023', '    ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3799, '2', '1', '2', 7, NULL, '1', '0905023', '    ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3800, '2', '1', '2', 8, NULL, '1', '0905023', '    ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3801, '2', '1', '2', 9, NULL, '1', '0905023', '    ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3802, '2', '1', '2', 10, NULL, '1', '0905023', '    ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3803, '2', '1', '2', 11, NULL, '1', '0905023', '    ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3804, '2', '1', '2', 12, NULL, '1', '0905023', '    ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3805, '2', '1', '2', 13, NULL, '1', '0905023', '    ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3806, '2', '1', '2', 14, NULL, '1', '0905023', '    ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3807, '2', '1', '2', 15, NULL, '1', '0905023', '    ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3808, '2', '1', '2', 16, NULL, '1', '0905023', '    ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3809, '2', '1', '2', 17, NULL, '1', '0905023', '    ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3810, '2', '1', '2', 15, NULL, '0', '0609007', ' ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3811, '2', '1', '2', 16, NULL, '0', '0609007', ' ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3812, '2', '1', '2', 17, NULL, '0', '0609007', ' ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3813, '2', '1', '2', 7, NULL, '1', '0422001', '   ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3814, '2', '1', '2', 8, NULL, '1', '0422001', '   ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3815, '2', '1', '2', 9, NULL, '1', '0422001', '   ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3816, '2', '1', '2', 10, NULL, '1', '0422001', '   ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3817, '2', '1', '2', 11, NULL, '1', '0422001', '   ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3818, '2', '1', '2', 12, NULL, '1', '0422001', '   ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3819, '2', '1', '2', 13, NULL, '1', '0422001', '   ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3820, '2', '1', '2', 14, NULL, '1', '0422001', '   ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3821, '2', '1', '2', 15, NULL, '1', '0422001', '   ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3822, '2', '1', '2', 16, NULL, '1', '0422001', '   ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3823, '2', '1', '2', 17, NULL, '1', '0422001', '   ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3824, '2', '1', '2', 0, NULL, '1', '0423001', '   ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3825, '2', '1', '2', 7, NULL, '1', '0420001', '    ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3826, '2', '1', '2', 8, NULL, '1', '0420001', '    ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3827, '2', '1', '2', 9, NULL, '1', '0420001', '    ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3828, '2', '1', '2', 10, NULL, '1', '0420001', '    ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3829, '2', '1', '2', 11, NULL, '1', '0420001', '    ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3830, '2', '1', '2', 12, NULL, '1', '0420001', '    ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3831, '2', '1', '2', 13, NULL, '1', '0420001', '    ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3832, '2', '1', '2', 14, NULL, '1', '0420001', '    ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3833, '2', '1', '2', 15, NULL, '1', '0420001', '    ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3834, '2', '1', '2', 16, NULL, '1', '0420001', '    ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3835, '2', '1', '2', 17, NULL, '1', '0420001', '    ', 0, '0', 0, '2013-01-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3836, '0', '2', '1', 21, NULL, '0', '0412005', '   ', 187.53, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3837, '0', '2', '1', 24, NULL, '0', '0412005', '   ', 187.53, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3838, '0', '2', '1', 27, NULL, '0', '0412005', '   ', 187.53, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3839, '0', '2', '1', 30, NULL, '0', '0412005', '   ', 187.53, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3840, '0', '2', '1', 33, NULL, '0', '0412005', '   ', 187.53, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3841, '0', '2', '1', 36, NULL, '0', '0412005', '   ', 187.53, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3842, '0', '2', '1', 39, NULL, '0', '0412005', '   ', 187.53, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3843, '0', '2', '1', 42, NULL, '0', '0412005', '   ', 187.53, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3844, '0', '2', '1', 45, NULL, '0', '0412005', '   ', 187.53, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3845, '0', '2', '1', 48, NULL, '0', '0412005', '   ', 187.53, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3846, '0', '2', '1', 51, NULL, '0', '0412005', '   ', 187.53, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3847, '0', '2', '1', 54, NULL, '0', '0412005', '   ', 187.53, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3848, '0', '2', '1', 57, NULL, '0', '0412005', '   ', 187.53, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3849, '0', '2', '1', 60, NULL, '0', '0412005', '   ', 187.53, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3850, '0', '2', '1', 63, NULL, '0', '0412005', '   ', 187.53, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3851, '0', '2', '1', 66, NULL, '0', '0412005', '   ', 187.53, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3852, '0', '2', '1', 69, NULL, '0', '0412005', '   ', 187.53, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3853, '0', '2', '1', 72, NULL, '0', '0412005', '   ', 187.53, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3854, '0', '2', '1', 75, NULL, '0', '0412005', '   ', 187.53, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3855, '0', '2', '1', 78, NULL, '0', '0412005', '   ', 187.53, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3856, '0', '2', '1', 81, NULL, '0', '0412005', '   ', 187.53, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3857, '0', '2', '1', 84, NULL, '0', '0412005', '   ', 187.53, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3858, '0', '2', '1', 87, NULL, '0', '0412005', '   ', 187.53, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3859, '0', '2', '1', 90, NULL, '0', '0412005', '   ', 187.53, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3860, '0', '2', '1', 93, NULL, '0', '0412005', '   ', 187.53, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3861, '0', '2', '1', 96, NULL, '0', '0412005', '   ', 187.53, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3862, '0', '2', '1', 99, NULL, '0', '0412005', '   ', 187.53, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3863, '0', '2', '1', 51, NULL, '0', '0316001', '', 107.16, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3864, '0', '2', '1', 54, NULL, '0', '0316001', '', 107.16, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3865, '0', '2', '1', 57, NULL, '0', '0316001', '', 107.16, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3866, '0', '2', '1', 60, NULL, '0', '0316001', '', 107.16, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3867, '0', '2', '1', 63, NULL, '0', '0316001', '', 107.16, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3868, '0', '2', '1', 66, NULL, '0', '0316001', '', 107.16, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3869, '0', '2', '1', 69, NULL, '0', '0316001', '', 107.16, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3870, '0', '2', '1', 72, NULL, '0', '0316001', '', 107.16, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3871, '0', '2', '1', 75, NULL, '0', '0316001', '', 107.16, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3872, '0', '2', '1', 78, NULL, '0', '0316001', '', 107.16, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3873, '0', '2', '1', 81, NULL, '0', '0316001', '', 107.16, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3874, '0', '2', '1', 84, NULL, '0', '0316001', '', 107.16, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3875, '0', '2', '1', 87, NULL, '0', '0316001', '', 107.16, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3876, '0', '2', '1', 90, NULL, '0', '0316001', '', 107.16, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3877, '0', '2', '1', 93, NULL, '0', '0316001', '', 107.16, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3878, '0', '2', '1', 96, NULL, '0', '0316001', '', 107.16, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3879, '0', '2', '1', 99, NULL, '0', '0316001', '', 107.16, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3880, '0', '2', '1', 21, NULL, '0', '0102301', ' (, ) -', 106.13, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3881, '0', '2', '1', 24, NULL, '0', '0102301', ' (, ) -', 106.13, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3882, '0', '2', '1', 27, NULL, '0', '0102301', ' (, ) -', 106.13, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3883, '0', '2', '1', 30, NULL, '0', '0102301', ' (, ) -', 106.13, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3884, '0', '2', '1', 33, NULL, '0', '0102301', ' (, ) -', 106.13, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3885, '0', '2', '1', 36, NULL, '0', '0102301', ' (, ) -', 106.13, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3886, '0', '2', '1', 39, NULL, '0', '0102301', ' (, ) -', 106.13, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3887, '0', '2', '1', 42, NULL, '0', '0102301', ' (, ) -', 106.13, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3888, '0', '2', '1', 45, NULL, '0', '0102301', ' (, ) -', 106.13, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3889, '0', '2', '1', 48, NULL, '0', '0102301', ' (, ) -', 106.13, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3890, '0', '2', '1', 51, NULL, '0', '0102301', ' (, ) -', 106.13, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3891, '0', '2', '1', 54, NULL, '0', '0102301', ' (, ) -', 106.13, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3892, '0', '2', '1', 57, NULL, '0', '0102301', ' (, ) -', 106.13, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3893, '0', '2', '1', 60, NULL, '0', '0102301', ' (, ) -', 106.13, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3894, '0', '2', '1', 63, NULL, '0', '0102301', ' (, ) -', 106.13, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3895, '0', '2', '1', 66, NULL, '0', '0102301', ' (, ) -', 106.13, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3896, '0', '2', '1', 69, NULL, '0', '0102301', ' (, ) -', 106.13, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3897, '0', '2', '1', 72, NULL, '0', '0102301', ' (, ) -', 106.13, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3898, '0', '2', '1', 75, NULL, '0', '0102301', ' (, ) -', 106.13, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3899, '0', '2', '1', 78, NULL, '0', '0102301', ' (, ) -', 106.13, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3900, '0', '2', '1', 81, NULL, '0', '0102301', ' (, ) -', 106.13, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3901, '0', '2', '1', 84, NULL, '0', '0102301', ' (, ) -', 106.13, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3902, '0', '2', '1', 87, NULL, '0', '0102301', ' (, ) -', 106.13, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3903, '0', '2', '1', 90, NULL, '0', '0102301', ' (, ) -', 106.13, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3904, '0', '2', '1', 93, NULL, '0', '0102301', ' (, ) -', 106.13, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3905, '0', '2', '1', 96, NULL, '0', '0102301', ' (, ) -', 106.13, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3906, '0', '2', '1', 99, NULL, '0', '0102301', ' (, ) -', 106.13, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3907, '0', '2', '1', 45, NULL, '0', '0105701', ' (, ) -', 123.66, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3908, '0', '2', '1', 48, NULL, '0', '0105701', ' (, ) -', 123.66, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3909, '0', '2', '1', 51, NULL, '0', '0105701', ' (, ) -', 123.66, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3910, '0', '2', '1', 54, NULL, '0', '0105701', ' (, ) -', 123.66, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3911, '0', '2', '1', 57, NULL, '0', '0105701', ' (, ) -', 123.66, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3912, '0', '2', '1', 60, NULL, '0', '0105701', ' (, ) -', 123.66, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3913, '0', '2', '1', 63, NULL, '0', '0105701', ' (, ) -', 123.66, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3914, '0', '2', '1', 66, NULL, '0', '0105701', ' (, ) -', 123.66, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3915, '0', '2', '1', 69, NULL, '0', '0105701', ' (, ) -', 123.66, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3916, '0', '2', '1', 72, NULL, '0', '0105701', ' (, ) -', 123.66, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3917, '0', '2', '1', 75, NULL, '0', '0105701', ' (, ) -', 123.66, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3918, '0', '2', '1', 78, NULL, '0', '0105701', ' (, ) -', 123.66, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3919, '0', '2', '1', 81, NULL, '0', '0105701', ' (, ) -', 123.66, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3920, '0', '2', '1', 84, NULL, '0', '0105701', ' (, ) -', 123.66, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3921, '0', '2', '1', 87, NULL, '0', '0105701', ' (, ) -', 123.66, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3922, '0', '2', '1', 90, NULL, '0', '0105701', ' (, ) -', 123.66, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3923, '0', '2', '1', 93, NULL, '0', '0105701', ' (, ) -', 123.66, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3924, '0', '2', '1', 96, NULL, '0', '0105701', ' (, ) -', 123.66, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3925, '0', '2', '1', 99, NULL, '0', '0105701', ' (, ) -', 123.66, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3926, '0', '2', '1', 45, NULL, '0', '0101801', ' (, ) - ', 344.93, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3927, '0', '2', '1', 48, NULL, '0', '0101801', ' (, ) - ', 344.93, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3928, '0', '2', '1', 51, NULL, '0', '0101801', ' (, ) - ', 344.93, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3929, '0', '2', '1', 54, NULL, '0', '0101801', ' (, ) - ', 344.93, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3930, '0', '2', '1', 57, NULL, '0', '0101801', ' (, ) - ', 344.93, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3931, '0', '2', '1', 60, NULL, '0', '0101801', ' (, ) - ', 344.93, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3932, '0', '2', '1', 63, NULL, '0', '0101801', ' (, ) - ', 344.93, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3933, '0', '2', '1', 66, NULL, '0', '0101801', ' (, ) - ', 344.93, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3934, '0', '2', '1', 69, NULL, '0', '0101801', ' (, ) - ', 344.93, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3935, '0', '2', '1', 72, NULL, '0', '0101801', ' (, ) - ', 344.93, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3936, '0', '2', '1', 75, NULL, '0', '0101801', ' (, ) - ', 344.93, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3937, '0', '2', '1', 78, NULL, '0', '0101801', ' (, ) - ', 344.93, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3938, '0', '2', '1', 81, NULL, '0', '0101801', ' (, ) - ', 344.93, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3939, '0', '2', '1', 84, NULL, '0', '0101801', ' (, ) - ', 344.93, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3940, '0', '2', '1', 87, NULL, '0', '0101801', ' (, ) - ', 344.93, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3941, '0', '2', '1', 90, NULL, '0', '0101801', ' (, ) - ', 344.93, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3942, '0', '2', '1', 93, NULL, '0', '0101801', ' (, ) - ', 344.93, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3943, '0', '2', '1', 96, NULL, '0', '0101801', ' (, ) - ', 344.93, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3944, '0', '2', '1', 99, NULL, '0', '0101801', ' (, ) - ', 344.93, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3945, '0', '2', '1', 51, NULL, '0', '0105301', ' (, ) -', 145.5, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3946, '0', '2', '1', 54, NULL, '0', '0105301', ' (, ) -', 145.5, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3947, '0', '2', '1', 57, NULL, '0', '0105301', ' (, ) -', 145.5, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3948, '0', '2', '1', 60, NULL, '0', '0105301', ' (, ) -', 145.5, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3949, '0', '2', '1', 63, NULL, '0', '0105301', ' (, ) -', 145.5, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3950, '0', '2', '1', 66, NULL, '0', '0105301', ' (, ) -', 145.5, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3951, '0', '2', '1', 69, NULL, '0', '0105301', ' (, ) -', 145.5, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3952, '0', '2', '1', 72, NULL, '0', '0105301', ' (, ) -', 145.5, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3953, '0', '2', '1', 75, NULL, '0', '0105301', ' (, ) -', 145.5, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3954, '0', '2', '1', 78, NULL, '0', '0105301', ' (, ) -', 145.5, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3955, '0', '2', '1', 81, NULL, '0', '0105301', ' (, ) -', 145.5, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3956, '0', '2', '1', 84, NULL, '0', '0105301', ' (, ) -', 145.5, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3957, '0', '2', '1', 87, NULL, '0', '0105301', ' (, ) -', 145.5, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3958, '0', '2', '1', 90, NULL, '0', '0105301', ' (, ) -', 145.5, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3959, '0', '2', '1', 93, NULL, '0', '0105301', ' (, ) -', 145.5, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3960, '0', '2', '1', 96, NULL, '0', '0105301', ' (, ) -', 145.5, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3961, '0', '2', '1', 99, NULL, '0', '0105301', ' (, ) -', 145.5, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3962, '0', '2', '1', 45, NULL, '0', '0319002', '', 71.44, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3963, '0', '2', '1', 48, NULL, '0', '0319002', '', 71.44, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3964, '0', '2', '1', 51, NULL, '0', '0319002', '', 71.44, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3965, '0', '2', '1', 54, NULL, '0', '0319002', '', 71.44, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3966, '0', '2', '1', 57, NULL, '0', '0319002', '', 71.44, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3967, '0', '2', '1', 60, NULL, '0', '0319002', '', 71.44, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3968, '0', '2', '1', 63, NULL, '0', '0319002', '', 71.44, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3969, '0', '2', '1', 66, NULL, '0', '0319002', '', 71.44, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3970, '0', '2', '1', 69, NULL, '0', '0319002', '', 71.44, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3971, '0', '2', '1', 72, NULL, '0', '0319002', '', 71.44, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3972, '0', '2', '1', 75, NULL, '0', '0319002', '', 71.44, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3973, '0', '2', '1', 78, NULL, '0', '0319002', '', 71.44, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3974, '0', '2', '1', 81, NULL, '0', '0319002', '', 71.44, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3975, '0', '2', '1', 84, NULL, '0', '0319002', '', 71.44, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3976, '0', '2', '1', 87, NULL, '0', '0319002', '', 71.44, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3977, '0', '2', '1', 90, NULL, '0', '0319002', '', 71.44, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3978, '0', '2', '1', 93, NULL, '0', '0319002', '', 71.44, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3979, '0', '2', '1', 96, NULL, '0', '0319002', '', 71.44, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3980, '0', '2', '1', 99, NULL, '0', '0319002', '', 71.44, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3981, '0', '2', '1', 21, NULL, '0', '0905084', '    ', 15.76, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3982, '0', '2', '1', 24, NULL, '0', '0905084', '    ', 15.76, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3983, '0', '2', '1', 27, NULL, '0', '0905084', '    ', 15.76, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3984, '0', '2', '1', 30, NULL, '0', '0905084', '    ', 15.76, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3985, '0', '2', '1', 33, NULL, '0', '0905084', '    ', 15.76, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3986, '0', '2', '1', 36, NULL, '0', '0905084', '    ', 15.76, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3987, '0', '2', '1', 39, NULL, '0', '0905084', '    ', 15.76, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3988, '0', '2', '1', 42, NULL, '0', '0905084', '    ', 15.76, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3989, '0', '2', '1', 45, NULL, '0', '0905084', '    ', 15.76, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3990, '0', '2', '1', 48, NULL, '0', '0905084', '    ', 15.76, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3991, '0', '2', '1', 51, NULL, '0', '0905084', '    ', 15.76, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3992, '0', '2', '1', 54, NULL, '0', '0905084', '    ', 15.76, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3993, '0', '2', '1', 57, NULL, '0', '0905084', '    ', 15.76, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3994, '0', '2', '1', 60, NULL, '0', '0905084', '    ', 15.76, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3995, '0', '2', '1', 63, NULL, '0', '0905084', '    ', 15.76, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3996, '0', '2', '1', 66, NULL, '0', '0905084', '    ', 15.76, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3997, '0', '2', '1', 69, NULL, '0', '0905084', '    ', 15.76, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3998, '0', '2', '1', 72, NULL, '0', '0905084', '    ', 15.76, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (3999, '0', '2', '1', 75, NULL, '0', '0905084', '    ', 15.76, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4000, '0', '2', '1', 78, NULL, '0', '0905084', '    ', 15.76, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4001, '0', '2', '1', 81, NULL, '0', '0905084', '    ', 15.76, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4002, '0', '2', '1', 84, NULL, '0', '0905084', '    ', 15.76, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4003, '0', '2', '1', 87, NULL, '0', '0905084', '    ', 15.76, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
COMMIT WORK; @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4004, '0', '2', '1', 90, NULL, '0', '0905084', '    ', 15.76, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4005, '0', '2', '1', 93, NULL, '0', '0905084', '    ', 15.76, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4006, '0', '2', '1', 96, NULL, '0', '0905084', '    ', 15.76, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4007, '0', '2', '1', 99, NULL, '0', '0905084', '    ', 15.76, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4008, '0', '2', '1', 39, NULL, '0', '0102901', ' (, ) -', 46.37, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4009, '0', '2', '1', 42, NULL, '0', '0102901', ' (, ) -', 46.37, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4010, '0', '2', '1', 45, NULL, '0', '0102901', ' (, ) -', 46.37, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4011, '0', '2', '1', 48, NULL, '0', '0102901', ' (, ) -', 46.37, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4012, '0', '2', '1', 51, NULL, '0', '0102901', ' (, ) -', 46.37, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4013, '0', '2', '1', 54, NULL, '0', '0102901', ' (, ) -', 46.37, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4014, '0', '2', '1', 57, NULL, '0', '0102901', ' (, ) -', 46.37, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4015, '0', '2', '1', 60, NULL, '0', '0102901', ' (, ) -', 46.37, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4016, '0', '2', '1', 63, NULL, '0', '0102901', ' (, ) -', 46.37, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4017, '0', '2', '1', 66, NULL, '0', '0102901', ' (, ) -', 46.37, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4018, '0', '2', '1', 69, NULL, '0', '0102901', ' (, ) -', 46.37, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4019, '0', '2', '1', 72, NULL, '0', '0102901', ' (, ) -', 46.37, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4020, '0', '2', '1', 75, NULL, '0', '0102901', ' (, ) -', 46.37, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4021, '0', '2', '1', 78, NULL, '0', '0102901', ' (, ) -', 46.37, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4022, '0', '2', '1', 81, NULL, '0', '0102901', ' (, ) -', 46.37, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4023, '0', '2', '1', 84, NULL, '0', '0102901', ' (, ) -', 46.37, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4024, '0', '2', '1', 87, NULL, '0', '0102901', ' (, ) -', 46.37, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4025, '0', '2', '1', 90, NULL, '0', '0102901', ' (, ) -', 46.37, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4026, '0', '2', '1', 93, NULL, '0', '0102901', ' (, ) -', 46.37, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4027, '0', '2', '1', 96, NULL, '0', '0102901', ' (, ) -', 46.37, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4028, '0', '2', '1', 99, NULL, '0', '0102901', ' (, ) -', 46.37, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4029, '0', '2', '1', 21, NULL, '1', '0104701', ' (, ) -', 114.8, '1', NULL, '2013-01-01', '2013-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4030, '0', '2', '1', 24, NULL, '1', '0104701', ' (, ) -', 114.8, '1', NULL, '2013-01-01', '2013-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4031, '0', '2', '1', 27, NULL, '1', '0104701', ' (, ) -', 114.8, '1', NULL, '2013-01-01', '2013-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4032, '0', '2', '1', 30, NULL, '1', '0104701', ' (, ) -', 114.8, '1', NULL, '2013-01-01', '2013-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4033, '0', '2', '1', 33, NULL, '1', '0104701', ' (, ) -', 114.8, '1', NULL, '2013-01-01', '2013-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4034, '0', '2', '1', 36, NULL, '1', '0104701', ' (, ) -', 114.8, '1', NULL, '2013-01-01', '2013-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4035, '0', '2', '1', 39, NULL, '1', '0104701', ' (, ) -', 114.8, '1', NULL, '2013-01-01', '2013-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4036, '0', '2', '1', 42, NULL, '1', '0104701', ' (, ) -', 114.8, '1', NULL, '2013-01-01', '2013-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4037, '0', '2', '1', 45, NULL, '1', '0104701', ' (, ) -', 114.8, '1', NULL, '2013-01-01', '2013-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4038, '0', '2', '1', 48, NULL, '1', '0104701', ' (, ) -', 114.8, '1', NULL, '2013-01-01', '2013-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4039, '0', '2', '1', 51, NULL, '1', '0104701', ' (, ) -', 114.8, '1', NULL, '2013-01-01', '2013-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4040, '0', '2', '1', 54, NULL, '1', '0104701', ' (, ) -', 114.8, '1', NULL, '2013-01-01', '2013-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4041, '0', '2', '1', 57, NULL, '1', '0104701', ' (, ) -', 114.8, '1', NULL, '2013-01-01', '2013-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4042, '0', '2', '1', 60, NULL, '1', '0104701', ' (, ) -', 114.8, '1', NULL, '2013-01-01', '2013-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4043, '0', '2', '1', 63, NULL, '1', '0104701', ' (, ) -', 114.8, '1', NULL, '2013-01-01', '2013-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4044, '0', '2', '1', 66, NULL, '1', '0104701', ' (, ) -', 114.8, '1', NULL, '2013-01-01', '2013-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4045, '0', '2', '1', 69, NULL, '1', '0104701', ' (, ) -', 114.8, '1', NULL, '2013-01-01', '2013-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4046, '0', '2', '1', 72, NULL, '1', '0104701', ' (, ) -', 114.8, '1', NULL, '2013-01-01', '2013-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4047, '0', '2', '1', 75, NULL, '1', '0104701', ' (, ) -', 114.8, '1', NULL, '2013-01-01', '2013-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4048, '0', '2', '1', 78, NULL, '1', '0104701', ' (, ) -', 114.8, '1', NULL, '2013-01-01', '2013-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4049, '0', '2', '1', 81, NULL, '1', '0104701', ' (, ) -', 114.8, '1', NULL, '2013-01-01', '2013-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4050, '0', '2', '1', 84, NULL, '1', '0104701', ' (, ) -', 114.8, '1', NULL, '2013-01-01', '2013-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4051, '0', '2', '1', 87, NULL, '1', '0104701', ' (, ) -', 114.8, '1', NULL, '2013-01-01', '2013-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4052, '0', '2', '1', 90, NULL, '1', '0104701', ' (, ) -', 114.8, '1', NULL, '2013-01-01', '2013-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4053, '0', '2', '1', 93, NULL, '1', '0104701', ' (, ) -', 114.8, '1', NULL, '2013-01-01', '2013-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4054, '0', '2', '1', 96, NULL, '1', '0104701', ' (, ) -', 114.8, '1', NULL, '2013-01-01', '2013-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4055, '0', '2', '1', 99, NULL, '1', '0104701', ' (, ) -', 114.8, '1', NULL, '2013-01-01', '2013-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4056, '0', '2', '1', 21, NULL, '0', '0905027', '    ', 25.4, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4057, '0', '2', '1', 24, NULL, '0', '0905027', '    ', 25.4, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4058, '0', '2', '1', 27, NULL, '0', '0905027', '    ', 25.4, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4059, '0', '2', '1', 30, NULL, '0', '0905027', '    ', 25.4, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4060, '0', '2', '1', 33, NULL, '0', '0905027', '    ', 25.4, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4061, '0', '2', '1', 36, NULL, '0', '0905027', '    ', 25.4, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4062, '0', '2', '1', 39, NULL, '0', '0905027', '    ', 25.4, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4063, '0', '2', '1', 42, NULL, '0', '0905027', '    ', 25.4, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4064, '0', '2', '1', 45, NULL, '0', '0905027', '    ', 25.4, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4065, '0', '2', '1', 48, NULL, '0', '0905027', '    ', 25.4, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4066, '0', '2', '1', 51, NULL, '0', '0905027', '    ', 25.4, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4067, '0', '2', '1', 54, NULL, '0', '0905027', '    ', 25.4, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4068, '0', '2', '1', 57, NULL, '0', '0905027', '    ', 25.4, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4069, '0', '2', '1', 60, NULL, '0', '0905027', '    ', 25.4, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4070, '0', '2', '1', 63, NULL, '0', '0905027', '    ', 25.4, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4071, '0', '2', '1', 66, NULL, '0', '0905027', '    ', 25.4, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4072, '0', '2', '1', 69, NULL, '0', '0905027', '    ', 25.4, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4073, '0', '2', '1', 72, NULL, '0', '0905027', '    ', 25.4, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4074, '0', '2', '1', 75, NULL, '0', '0905027', '    ', 25.4, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4075, '0', '2', '1', 78, NULL, '0', '0905027', '    ', 25.4, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4076, '0', '2', '1', 81, NULL, '0', '0905027', '    ', 25.4, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4077, '0', '2', '1', 84, NULL, '0', '0905027', '    ', 25.4, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4078, '0', '2', '1', 87, NULL, '0', '0905027', '    ', 25.4, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4079, '0', '2', '1', 90, NULL, '0', '0905027', '    ', 25.4, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4080, '0', '2', '1', 93, NULL, '0', '0905027', '    ', 25.4, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4081, '0', '2', '1', 96, NULL, '0', '0905027', '    ', 25.4, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4082, '0', '2', '1', 99, NULL, '0', '0905027', '    ', 25.4, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4083, '0', '2', '1', 21, NULL, '0', '0905028', '    ', 25.4, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4084, '0', '2', '1', 24, NULL, '0', '0905028', '    ', 25.4, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4085, '0', '2', '1', 27, NULL, '0', '0905028', '    ', 25.4, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4086, '0', '2', '1', 30, NULL, '0', '0905028', '    ', 25.4, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4087, '0', '2', '1', 33, NULL, '0', '0905028', '    ', 25.4, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4088, '0', '2', '1', 36, NULL, '0', '0905028', '    ', 25.4, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4089, '0', '2', '1', 39, NULL, '0', '0905028', '    ', 25.4, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4090, '0', '2', '1', 42, NULL, '0', '0905028', '    ', 25.4, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4091, '0', '2', '1', 45, NULL, '0', '0905028', '    ', 25.4, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4092, '0', '2', '1', 48, NULL, '0', '0905028', '    ', 25.4, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4093, '0', '2', '1', 51, NULL, '0', '0905028', '    ', 25.4, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4094, '0', '2', '1', 54, NULL, '0', '0905028', '    ', 25.4, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4095, '0', '2', '1', 57, NULL, '0', '0905028', '    ', 25.4, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4096, '0', '2', '1', 60, NULL, '0', '0905028', '    ', 25.4, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4097, '0', '2', '1', 63, NULL, '0', '0905028', '    ', 25.4, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4098, '0', '2', '1', 66, NULL, '0', '0905028', '    ', 25.4, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4099, '0', '2', '1', 69, NULL, '0', '0905028', '    ', 25.4, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4100, '0', '2', '1', 72, NULL, '0', '0905028', '    ', 25.4, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4101, '0', '2', '1', 75, NULL, '0', '0905028', '    ', 25.4, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4102, '0', '2', '1', 78, NULL, '0', '0905028', '    ', 25.4, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4103, '0', '2', '1', 81, NULL, '0', '0905028', '    ', 25.4, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4104, '0', '2', '1', 84, NULL, '0', '0905028', '    ', 25.4, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4105, '0', '2', '1', 87, NULL, '0', '0905028', '    ', 25.4, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4106, '0', '2', '1', 90, NULL, '0', '0905028', '    ', 25.4, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4107, '0', '2', '1', 93, NULL, '0', '0905028', '    ', 25.4, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4108, '0', '2', '1', 96, NULL, '0', '0905028', '    ', 25.4, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4109, '0', '2', '1', 99, NULL, '0', '0905028', '    ', 25.4, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4110, '0', '2', '1', 21, NULL, '0', '0905025', '    ', 7.88, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4111, '0', '2', '1', 24, NULL, '0', '0905025', '    ', 7.88, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4112, '0', '2', '1', 27, NULL, '0', '0905025', '    ', 7.88, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4113, '0', '2', '1', 30, NULL, '0', '0905025', '    ', 7.88, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4114, '0', '2', '1', 33, NULL, '0', '0905025', '    ', 7.88, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4115, '0', '2', '1', 36, NULL, '0', '0905025', '    ', 7.88, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4116, '0', '2', '1', 39, NULL, '0', '0905025', '    ', 7.88, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4117, '0', '2', '1', 42, NULL, '0', '0905025', '    ', 7.88, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4118, '0', '2', '1', 45, NULL, '0', '0905025', '    ', 7.88, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4119, '0', '2', '1', 48, NULL, '0', '0905025', '    ', 7.88, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4120, '0', '2', '1', 51, NULL, '0', '0905025', '    ', 7.88, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4121, '0', '2', '1', 54, NULL, '0', '0905025', '    ', 7.88, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4122, '0', '2', '1', 57, NULL, '0', '0905025', '    ', 7.88, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4123, '0', '2', '1', 60, NULL, '0', '0905025', '    ', 7.88, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4124, '0', '2', '1', 63, NULL, '0', '0905025', '    ', 7.88, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4125, '0', '2', '1', 66, NULL, '0', '0905025', '    ', 7.88, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4126, '0', '2', '1', 69, NULL, '0', '0905025', '    ', 7.88, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4127, '0', '2', '1', 72, NULL, '0', '0905025', '    ', 7.88, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4128, '0', '2', '1', 75, NULL, '0', '0905025', '    ', 7.88, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4129, '0', '2', '1', 78, NULL, '0', '0905025', '    ', 7.88, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4130, '0', '2', '1', 81, NULL, '0', '0905025', '    ', 7.88, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4131, '0', '2', '1', 84, NULL, '0', '0905025', '    ', 7.88, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4132, '0', '2', '1', 87, NULL, '0', '0905025', '    ', 7.88, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4133, '0', '2', '1', 90, NULL, '0', '0905025', '    ', 7.88, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4134, '0', '2', '1', 93, NULL, '0', '0905025', '    ', 7.88, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4135, '0', '2', '1', 96, NULL, '0', '0905025', '    ', 7.88, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4136, '0', '2', '1', 99, NULL, '0', '0905025', '    ', 7.88, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4137, '0', '2', '1', 21, NULL, '0', '0107401', '    /    ( )   ()     ', 384.87, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4138, '0', '2', '1', 24, NULL, '0', '0107401', '    /    ( )   ()     ', 384.87, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4139, '0', '2', '1', 27, NULL, '0', '0107401', '    /    ( )   ()     ', 384.87, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4140, '0', '2', '1', 30, NULL, '0', '0107401', '    /    ( )   ()     ', 384.87, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4141, '0', '2', '1', 33, NULL, '0', '0107401', '    /    ( )   ()     ', 384.87, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4142, '0', '2', '1', 36, NULL, '0', '0107401', '    /    ( )   ()     ', 384.87, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4143, '0', '2', '1', 39, NULL, '0', '0107401', '    /    ( )   ()     ', 384.87, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4144, '0', '2', '1', 42, NULL, '0', '0107401', '    /    ( )   ()     ', 384.87, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4145, '0', '2', '1', 45, NULL, '0', '0107401', '    /    ( )   ()     ', 384.87, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4146, '0', '2', '1', 48, NULL, '0', '0107401', '    /    ( )   ()     ', 384.87, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4147, '0', '2', '1', 51, NULL, '0', '0107401', '    /    ( )   ()     ', 384.87, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4148, '0', '2', '1', 54, NULL, '0', '0107401', '    /    ( )   ()     ', 384.87, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4149, '0', '2', '1', 57, NULL, '0', '0107401', '    /    ( )   ()     ', 384.87, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4150, '0', '2', '1', 60, NULL, '0', '0107401', '    /    ( )   ()     ', 384.87, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4151, '0', '2', '1', 63, NULL, '0', '0107401', '    /    ( )   ()     ', 384.87, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4152, '0', '2', '1', 66, NULL, '0', '0107401', '    /    ( )   ()     ', 384.87, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4153, '0', '2', '1', 69, NULL, '0', '0107401', '    /    ( )   ()     ', 384.87, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4154, '0', '2', '1', 72, NULL, '0', '0107401', '    /    ( )   ()     ', 384.87, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4155, '0', '2', '1', 75, NULL, '0', '0107401', '    /    ( )   ()     ', 384.87, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4156, '0', '2', '1', 78, NULL, '0', '0107401', '    /    ( )   ()     ', 384.87, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4157, '0', '2', '1', 81, NULL, '0', '0107401', '    /    ( )   ()     ', 384.87, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4158, '0', '2', '1', 84, NULL, '0', '0107401', '    /    ( )   ()     ', 384.87, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4159, '0', '2', '1', 87, NULL, '0', '0107401', '    /    ( )   ()     ', 384.87, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4160, '0', '2', '1', 90, NULL, '0', '0107401', '    /    ( )   ()     ', 384.87, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4161, '0', '2', '1', 93, NULL, '0', '0107401', '    /    ( )   ()     ', 384.87, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4162, '0', '2', '1', 96, NULL, '0', '0107401', '    /    ( )   ()     ', 384.87, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4163, '0', '2', '1', 99, NULL, '0', '0107401', '    /    ( )   ()     ', 384.87, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4164, '0', '2', '2', 21, NULL, '0', '0412005', '   ', 187.53, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4165, '0', '2', '2', 24, NULL, '0', '0412005', '   ', 187.53, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4166, '0', '2', '2', 27, NULL, '0', '0412005', '   ', 187.53, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4167, '0', '2', '2', 30, NULL, '0', '0412005', '   ', 187.53, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4168, '0', '2', '2', 33, NULL, '0', '0412005', '   ', 187.53, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4169, '0', '2', '2', 36, NULL, '0', '0412005', '   ', 187.53, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4170, '0', '2', '2', 39, NULL, '0', '0412005', '   ', 187.53, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4171, '0', '2', '2', 42, NULL, '0', '0412005', '   ', 187.53, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4172, '0', '2', '2', 45, NULL, '0', '0412005', '   ', 187.53, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4173, '0', '2', '2', 48, NULL, '0', '0412005', '   ', 187.53, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4174, '0', '2', '2', 51, NULL, '0', '0412005', '   ', 187.53, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4175, '0', '2', '2', 54, NULL, '0', '0412005', '   ', 187.53, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4176, '0', '2', '2', 57, NULL, '0', '0412005', '   ', 187.53, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4177, '0', '2', '2', 60, NULL, '0', '0412005', '   ', 187.53, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4178, '0', '2', '2', 63, NULL, '0', '0412005', '   ', 187.53, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4179, '0', '2', '2', 66, NULL, '0', '0412005', '   ', 187.53, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4180, '0', '2', '2', 69, NULL, '0', '0412005', '   ', 187.53, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4181, '0', '2', '2', 72, NULL, '0', '0412005', '   ', 187.53, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4182, '0', '2', '2', 75, NULL, '0', '0412005', '   ', 187.53, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4183, '0', '2', '2', 78, NULL, '0', '0412005', '   ', 187.53, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4184, '0', '2', '2', 81, NULL, '0', '0412005', '   ', 187.53, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4185, '0', '2', '2', 84, NULL, '0', '0412005', '   ', 187.53, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4186, '0', '2', '2', 87, NULL, '0', '0412005', '   ', 187.53, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4187, '0', '2', '2', 90, NULL, '0', '0412005', '   ', 187.53, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4188, '0', '2', '2', 93, NULL, '0', '0412005', '   ', 187.53, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4189, '0', '2', '2', 96, NULL, '0', '0412005', '   ', 187.53, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4190, '0', '2', '2', 99, NULL, '0', '0412005', '   ', 187.53, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4191, '0', '2', '2', 51, NULL, '0', '0316001', '', 107.16, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4192, '0', '2', '2', 54, NULL, '0', '0316001', '', 107.16, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4193, '0', '2', '2', 57, NULL, '0', '0316001', '', 107.16, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4194, '0', '2', '2', 60, NULL, '0', '0316001', '', 107.16, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4195, '0', '2', '2', 63, NULL, '0', '0316001', '', 107.16, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4196, '0', '2', '2', 66, NULL, '0', '0316001', '', 107.16, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4197, '0', '2', '2', 69, NULL, '0', '0316001', '', 107.16, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4198, '0', '2', '2', 72, NULL, '0', '0316001', '', 107.16, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4199, '0', '2', '2', 75, NULL, '0', '0316001', '', 107.16, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4200, '0', '2', '2', 78, NULL, '0', '0316001', '', 107.16, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4201, '0', '2', '2', 81, NULL, '0', '0316001', '', 107.16, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4202, '0', '2', '2', 84, NULL, '0', '0316001', '', 107.16, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4203, '0', '2', '2', 87, NULL, '0', '0316001', '', 107.16, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4204, '0', '2', '2', 90, NULL, '0', '0316001', '', 107.16, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4205, '0', '2', '2', 93, NULL, '0', '0316001', '', 107.16, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4206, '0', '2', '2', 96, NULL, '0', '0316001', '', 107.16, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4207, '0', '2', '2', 99, NULL, '0', '0316001', '', 107.16, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4208, '0', '2', '2', 21, NULL, '0', '0102301', ' (, ) -', 106.13, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4209, '0', '2', '2', 24, NULL, '0', '0102301', ' (, ) -', 106.13, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4210, '0', '2', '2', 27, NULL, '0', '0102301', ' (, ) -', 106.13, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4211, '0', '2', '2', 30, NULL, '0', '0102301', ' (, ) -', 106.13, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4212, '0', '2', '2', 33, NULL, '0', '0102301', ' (, ) -', 106.13, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4213, '0', '2', '2', 36, NULL, '0', '0102301', ' (, ) -', 106.13, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4214, '0', '2', '2', 39, NULL, '0', '0102301', ' (, ) -', 106.13, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4215, '0', '2', '2', 42, NULL, '0', '0102301', ' (, ) -', 106.13, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4216, '0', '2', '2', 45, NULL, '0', '0102301', ' (, ) -', 106.13, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4217, '0', '2', '2', 48, NULL, '0', '0102301', ' (, ) -', 106.13, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4218, '0', '2', '2', 51, NULL, '0', '0102301', ' (, ) -', 106.13, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4219, '0', '2', '2', 54, NULL, '0', '0102301', ' (, ) -', 106.13, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4220, '0', '2', '2', 57, NULL, '0', '0102301', ' (, ) -', 106.13, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4221, '0', '2', '2', 60, NULL, '0', '0102301', ' (, ) -', 106.13, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4222, '0', '2', '2', 63, NULL, '0', '0102301', ' (, ) -', 106.13, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4223, '0', '2', '2', 66, NULL, '0', '0102301', ' (, ) -', 106.13, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4224, '0', '2', '2', 69, NULL, '0', '0102301', ' (, ) -', 106.13, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4225, '0', '2', '2', 72, NULL, '0', '0102301', ' (, ) -', 106.13, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4226, '0', '2', '2', 75, NULL, '0', '0102301', ' (, ) -', 106.13, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4227, '0', '2', '2', 78, NULL, '0', '0102301', ' (, ) -', 106.13, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4228, '0', '2', '2', 81, NULL, '0', '0102301', ' (, ) -', 106.13, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4229, '0', '2', '2', 84, NULL, '0', '0102301', ' (, ) -', 106.13, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4230, '0', '2', '2', 87, NULL, '0', '0102301', ' (, ) -', 106.13, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4231, '0', '2', '2', 90, NULL, '0', '0102301', ' (, ) -', 106.13, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4232, '0', '2', '2', 93, NULL, '0', '0102301', ' (, ) -', 106.13, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4233, '0', '2', '2', 96, NULL, '0', '0102301', ' (, ) -', 106.13, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4234, '0', '2', '2', 99, NULL, '0', '0102301', ' (, ) -', 106.13, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4235, '0', '2', '2', 45, NULL, '0', '0105701', ' (, ) -', 123.66, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4236, '0', '2', '2', 48, NULL, '0', '0105701', ' (, ) -', 123.66, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4237, '0', '2', '2', 51, NULL, '0', '0105701', ' (, ) -', 123.66, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4238, '0', '2', '2', 54, NULL, '0', '0105701', ' (, ) -', 123.66, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4239, '0', '2', '2', 57, NULL, '0', '0105701', ' (, ) -', 123.66, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4240, '0', '2', '2', 60, NULL, '0', '0105701', ' (, ) -', 123.66, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4241, '0', '2', '2', 63, NULL, '0', '0105701', ' (, ) -', 123.66, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4242, '0', '2', '2', 66, NULL, '0', '0105701', ' (, ) -', 123.66, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4243, '0', '2', '2', 69, NULL, '0', '0105701', ' (, ) -', 123.66, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4244, '0', '2', '2', 72, NULL, '0', '0105701', ' (, ) -', 123.66, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4245, '0', '2', '2', 75, NULL, '0', '0105701', ' (, ) -', 123.66, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4246, '0', '2', '2', 78, NULL, '0', '0105701', ' (, ) -', 123.66, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4247, '0', '2', '2', 81, NULL, '0', '0105701', ' (, ) -', 123.66, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4248, '0', '2', '2', 84, NULL, '0', '0105701', ' (, ) -', 123.66, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4249, '0', '2', '2', 87, NULL, '0', '0105701', ' (, ) -', 123.66, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4250, '0', '2', '2', 90, NULL, '0', '0105701', ' (, ) -', 123.66, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4251, '0', '2', '2', 93, NULL, '0', '0105701', ' (, ) -', 123.66, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4252, '0', '2', '2', 96, NULL, '0', '0105701', ' (, ) -', 123.66, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4253, '0', '2', '2', 99, NULL, '0', '0105701', ' (, ) -', 123.66, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4254, '0', '2', '2', 45, NULL, '0', '0101801', ' (, ) - ', 344.93, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4255, '0', '2', '2', 48, NULL, '0', '0101801', ' (, ) - ', 344.93, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4256, '0', '2', '2', 51, NULL, '0', '0101801', ' (, ) - ', 344.93, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4257, '0', '2', '2', 54, NULL, '0', '0101801', ' (, ) - ', 344.93, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4258, '0', '2', '2', 57, NULL, '0', '0101801', ' (, ) - ', 344.93, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4259, '0', '2', '2', 60, NULL, '0', '0101801', ' (, ) - ', 344.93, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4260, '0', '2', '2', 63, NULL, '0', '0101801', ' (, ) - ', 344.93, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4261, '0', '2', '2', 66, NULL, '0', '0101801', ' (, ) - ', 344.93, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4262, '0', '2', '2', 69, NULL, '0', '0101801', ' (, ) - ', 344.93, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4263, '0', '2', '2', 72, NULL, '0', '0101801', ' (, ) - ', 344.93, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4264, '0', '2', '2', 75, NULL, '0', '0101801', ' (, ) - ', 344.93, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4265, '0', '2', '2', 78, NULL, '0', '0101801', ' (, ) - ', 344.93, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4266, '0', '2', '2', 81, NULL, '0', '0101801', ' (, ) - ', 344.93, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4267, '0', '2', '2', 84, NULL, '0', '0101801', ' (, ) - ', 344.93, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4268, '0', '2', '2', 87, NULL, '0', '0101801', ' (, ) - ', 344.93, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4269, '0', '2', '2', 90, NULL, '0', '0101801', ' (, ) - ', 344.93, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4270, '0', '2', '2', 93, NULL, '0', '0101801', ' (, ) - ', 344.93, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4271, '0', '2', '2', 96, NULL, '0', '0101801', ' (, ) - ', 344.93, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4272, '0', '2', '2', 99, NULL, '0', '0101801', ' (, ) - ', 344.93, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4273, '0', '2', '2', 45, NULL, '0', '0319002', '', 71.44, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4274, '0', '2', '2', 48, NULL, '0', '0319002', '', 71.44, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4275, '0', '2', '2', 51, NULL, '0', '0319002', '', 71.44, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4276, '0', '2', '2', 54, NULL, '0', '0319002', '', 71.44, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4277, '0', '2', '2', 57, NULL, '0', '0319002', '', 71.44, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4278, '0', '2', '2', 60, NULL, '0', '0319002', '', 71.44, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4279, '0', '2', '2', 63, NULL, '0', '0319002', '', 71.44, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4280, '0', '2', '2', 66, NULL, '0', '0319002', '', 71.44, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4281, '0', '2', '2', 69, NULL, '0', '0319002', '', 71.44, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4282, '0', '2', '2', 72, NULL, '0', '0319002', '', 71.44, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4283, '0', '2', '2', 75, NULL, '0', '0319002', '', 71.44, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4284, '0', '2', '2', 78, NULL, '0', '0319002', '', 71.44, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4285, '0', '2', '2', 81, NULL, '0', '0319002', '', 71.44, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4286, '0', '2', '2', 84, NULL, '0', '0319002', '', 71.44, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4287, '0', '2', '2', 87, NULL, '0', '0319002', '', 71.44, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4288, '0', '2', '2', 90, NULL, '0', '0319002', '', 71.44, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4289, '0', '2', '2', 93, NULL, '0', '0319002', '', 71.44, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4290, '0', '2', '2', 96, NULL, '0', '0319002', '', 71.44, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4291, '0', '2', '2', 99, NULL, '0', '0319002', '', 71.44, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4292, '0', '2', '2', 21, NULL, '0', '0100101', ' (, ) - ', 137.97, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4293, '0', '2', '2', 24, NULL, '0', '0100101', ' (, ) - ', 137.97, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4294, '0', '2', '2', 27, NULL, '0', '0100101', ' (, ) - ', 137.97, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4295, '0', '2', '2', 30, NULL, '0', '0100101', ' (, ) - ', 137.97, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4296, '0', '2', '2', 33, NULL, '0', '0100101', ' (, ) - ', 137.97, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4297, '0', '2', '2', 36, NULL, '0', '0100101', ' (, ) - ', 137.97, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4298, '0', '2', '2', 39, NULL, '0', '0100101', ' (, ) - ', 137.97, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4299, '0', '2', '2', 42, NULL, '0', '0100101', ' (, ) - ', 137.97, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4300, '0', '2', '2', 45, NULL, '0', '0100101', ' (, ) - ', 137.97, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4301, '0', '2', '2', 48, NULL, '0', '0100101', ' (, ) - ', 137.97, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4302, '0', '2', '2', 51, NULL, '0', '0100101', ' (, ) - ', 137.97, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4303, '0', '2', '2', 54, NULL, '0', '0100101', ' (, ) - ', 137.97, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4304, '0', '2', '2', 57, NULL, '0', '0100101', ' (, ) - ', 137.97, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4305, '0', '2', '2', 60, NULL, '0', '0100101', ' (, ) - ', 137.97, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4306, '0', '2', '2', 63, NULL, '0', '0100101', ' (, ) - ', 137.97, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4307, '0', '2', '2', 66, NULL, '0', '0100101', ' (, ) - ', 137.97, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4308, '0', '2', '2', 69, NULL, '0', '0100101', ' (, ) - ', 137.97, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4309, '0', '2', '2', 72, NULL, '0', '0100101', ' (, ) - ', 137.97, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4310, '0', '2', '2', 75, NULL, '0', '0100101', ' (, ) - ', 137.97, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4311, '0', '2', '2', 78, NULL, '0', '0100101', ' (, ) - ', 137.97, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4312, '0', '2', '2', 81, NULL, '0', '0100101', ' (, ) - ', 137.97, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4313, '0', '2', '2', 84, NULL, '0', '0100101', ' (, ) - ', 137.97, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4314, '0', '2', '2', 87, NULL, '0', '0100101', ' (, ) - ', 137.97, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4315, '0', '2', '2', 90, NULL, '0', '0100101', ' (, ) - ', 137.97, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4316, '0', '2', '2', 93, NULL, '0', '0100101', ' (, ) - ', 137.97, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4317, '0', '2', '2', 96, NULL, '0', '0100101', ' (, ) - ', 137.97, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4318, '0', '2', '2', 99, NULL, '0', '0100101', ' (, ) - ', 137.97, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4319, '0', '2', '2', 21, NULL, '0', '0905084', '    ', 15.76, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4320, '0', '2', '2', 24, NULL, '0', '0905084', '    ', 15.76, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4321, '0', '2', '2', 27, NULL, '0', '0905084', '    ', 15.76, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4322, '0', '2', '2', 30, NULL, '0', '0905084', '    ', 15.76, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4323, '0', '2', '2', 33, NULL, '0', '0905084', '    ', 15.76, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4324, '0', '2', '2', 36, NULL, '0', '0905084', '    ', 15.76, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4325, '0', '2', '2', 39, NULL, '0', '0905084', '    ', 15.76, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4326, '0', '2', '2', 42, NULL, '0', '0905084', '    ', 15.76, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4327, '0', '2', '2', 45, NULL, '0', '0905084', '    ', 15.76, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4328, '0', '2', '2', 48, NULL, '0', '0905084', '    ', 15.76, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4329, '0', '2', '2', 51, NULL, '0', '0905084', '    ', 15.76, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4330, '0', '2', '2', 54, NULL, '0', '0905084', '    ', 15.76, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4331, '0', '2', '2', 57, NULL, '0', '0905084', '    ', 15.76, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4332, '0', '2', '2', 60, NULL, '0', '0905084', '    ', 15.76, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4333, '0', '2', '2', 63, NULL, '0', '0905084', '    ', 15.76, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4334, '0', '2', '2', 66, NULL, '0', '0905084', '    ', 15.76, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4335, '0', '2', '2', 69, NULL, '0', '0905084', '    ', 15.76, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4336, '0', '2', '2', 72, NULL, '0', '0905084', '    ', 15.76, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4337, '0', '2', '2', 75, NULL, '0', '0905084', '    ', 15.76, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4338, '0', '2', '2', 78, NULL, '0', '0905084', '    ', 15.76, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4339, '0', '2', '2', 81, NULL, '0', '0905084', '    ', 15.76, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4340, '0', '2', '2', 84, NULL, '0', '0905084', '    ', 15.76, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4341, '0', '2', '2', 87, NULL, '0', '0905084', '    ', 15.76, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4342, '0', '2', '2', 90, NULL, '0', '0905084', '    ', 15.76, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4343, '0', '2', '2', 93, NULL, '0', '0905084', '    ', 15.76, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4344, '0', '2', '2', 96, NULL, '0', '0905084', '    ', 15.76, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4345, '0', '2', '2', 99, NULL, '0', '0905084', '    ', 15.76, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4346, '0', '2', '2', 39, NULL, '0', '0102901', ' (, ) -', 46.37, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4347, '0', '2', '2', 42, NULL, '0', '0102901', ' (, ) -', 46.37, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4348, '0', '2', '2', 45, NULL, '0', '0102901', ' (, ) -', 46.37, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4349, '0', '2', '2', 48, NULL, '0', '0102901', ' (, ) -', 46.37, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4350, '0', '2', '2', 51, NULL, '0', '0102901', ' (, ) -', 46.37, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4351, '0', '2', '2', 54, NULL, '0', '0102901', ' (, ) -', 46.37, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4352, '0', '2', '2', 57, NULL, '0', '0102901', ' (, ) -', 46.37, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4353, '0', '2', '2', 60, NULL, '0', '0102901', ' (, ) -', 46.37, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4354, '0', '2', '2', 63, NULL, '0', '0102901', ' (, ) -', 46.37, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4355, '0', '2', '2', 66, NULL, '0', '0102901', ' (, ) -', 46.37, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4356, '0', '2', '2', 69, NULL, '0', '0102901', ' (, ) -', 46.37, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4357, '0', '2', '2', 72, NULL, '0', '0102901', ' (, ) -', 46.37, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4358, '0', '2', '2', 75, NULL, '0', '0102901', ' (, ) -', 46.37, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4359, '0', '2', '2', 78, NULL, '0', '0102901', ' (, ) -', 46.37, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4360, '0', '2', '2', 81, NULL, '0', '0102901', ' (, ) -', 46.37, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4361, '0', '2', '2', 84, NULL, '0', '0102901', ' (, ) -', 46.37, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4362, '0', '2', '2', 87, NULL, '0', '0102901', ' (, ) -', 46.37, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4363, '0', '2', '2', 90, NULL, '0', '0102901', ' (, ) -', 46.37, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4364, '0', '2', '2', 93, NULL, '0', '0102901', ' (, ) -', 46.37, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4365, '0', '2', '2', 96, NULL, '0', '0102901', ' (, ) -', 46.37, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4366, '0', '2', '2', 99, NULL, '0', '0102901', ' (, ) -', 46.37, '1', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4367, '0', '2', '2', 21, NULL, '1', '0104701', ' (, ) -', 114.8, '1', NULL, '2013-01-01', '2013-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4368, '0', '2', '2', 24, NULL, '1', '0104701', ' (, ) -', 114.8, '1', NULL, '2013-01-01', '2013-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4369, '0', '2', '2', 27, NULL, '1', '0104701', ' (, ) -', 114.8, '1', NULL, '2013-01-01', '2013-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4370, '0', '2', '2', 30, NULL, '1', '0104701', ' (, ) -', 114.8, '1', NULL, '2013-01-01', '2013-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4371, '0', '2', '2', 33, NULL, '1', '0104701', ' (, ) -', 114.8, '1', NULL, '2013-01-01', '2013-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4372, '0', '2', '2', 36, NULL, '1', '0104701', ' (, ) -', 114.8, '1', NULL, '2013-01-01', '2013-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4373, '0', '2', '2', 39, NULL, '1', '0104701', ' (, ) -', 114.8, '1', NULL, '2013-01-01', '2013-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4374, '0', '2', '2', 42, NULL, '1', '0104701', ' (, ) -', 114.8, '1', NULL, '2013-01-01', '2013-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4375, '0', '2', '2', 45, NULL, '1', '0104701', ' (, ) -', 114.8, '1', NULL, '2013-01-01', '2013-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4376, '0', '2', '2', 48, NULL, '1', '0104701', ' (, ) -', 114.8, '1', NULL, '2013-01-01', '2013-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4377, '0', '2', '2', 51, NULL, '1', '0104701', ' (, ) -', 114.8, '1', NULL, '2013-01-01', '2013-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4378, '0', '2', '2', 54, NULL, '1', '0104701', ' (, ) -', 114.8, '1', NULL, '2013-01-01', '2013-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4379, '0', '2', '2', 57, NULL, '1', '0104701', ' (, ) -', 114.8, '1', NULL, '2013-01-01', '2013-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4380, '0', '2', '2', 60, NULL, '1', '0104701', ' (, ) -', 114.8, '1', NULL, '2013-01-01', '2013-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4381, '0', '2', '2', 63, NULL, '1', '0104701', ' (, ) -', 114.8, '1', NULL, '2013-01-01', '2013-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4382, '0', '2', '2', 66, NULL, '1', '0104701', ' (, ) -', 114.8, '1', NULL, '2013-01-01', '2013-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4383, '0', '2', '2', 69, NULL, '1', '0104701', ' (, ) -', 114.8, '1', NULL, '2013-01-01', '2013-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4384, '0', '2', '2', 72, NULL, '1', '0104701', ' (, ) -', 114.8, '1', NULL, '2013-01-01', '2013-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4385, '0', '2', '2', 75, NULL, '1', '0104701', ' (, ) -', 114.8, '1', NULL, '2013-01-01', '2013-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4386, '0', '2', '2', 78, NULL, '1', '0104701', ' (, ) -', 114.8, '1', NULL, '2013-01-01', '2013-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4387, '0', '2', '2', 81, NULL, '1', '0104701', ' (, ) -', 114.8, '1', NULL, '2013-01-01', '2013-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4388, '0', '2', '2', 84, NULL, '1', '0104701', ' (, ) -', 114.8, '1', NULL, '2013-01-01', '2013-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4389, '0', '2', '2', 87, NULL, '1', '0104701', ' (, ) -', 114.8, '1', NULL, '2013-01-01', '2013-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4390, '0', '2', '2', 90, NULL, '1', '0104701', ' (, ) -', 114.8, '1', NULL, '2013-01-01', '2013-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4391, '0', '2', '2', 93, NULL, '1', '0104701', ' (, ) -', 114.8, '1', NULL, '2013-01-01', '2013-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4392, '0', '2', '2', 96, NULL, '1', '0104701', ' (, ) -', 114.8, '1', NULL, '2013-01-01', '2013-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4393, '0', '2', '2', 99, NULL, '1', '0104701', ' (, ) -', 114.8, '1', NULL, '2013-01-01', '2013-12-31', NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4394, '0', '2', '2', 21, NULL, '0', '0905027', '    ', 25.4, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4395, '0', '2', '2', 24, NULL, '0', '0905027', '    ', 25.4, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4396, '0', '2', '2', 27, NULL, '0', '0905027', '    ', 25.4, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4397, '0', '2', '2', 30, NULL, '0', '0905027', '    ', 25.4, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4398, '0', '2', '2', 33, NULL, '0', '0905027', '    ', 25.4, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4399, '0', '2', '2', 36, NULL, '0', '0905027', '    ', 25.4, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4400, '0', '2', '2', 39, NULL, '0', '0905027', '    ', 25.4, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4401, '0', '2', '2', 42, NULL, '0', '0905027', '    ', 25.4, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4402, '0', '2', '2', 45, NULL, '0', '0905027', '    ', 25.4, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4403, '0', '2', '2', 48, NULL, '0', '0905027', '    ', 25.4, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4404, '0', '2', '2', 51, NULL, '0', '0905027', '    ', 25.4, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4405, '0', '2', '2', 54, NULL, '0', '0905027', '    ', 25.4, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4406, '0', '2', '2', 57, NULL, '0', '0905027', '    ', 25.4, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4407, '0', '2', '2', 60, NULL, '0', '0905027', '    ', 25.4, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4408, '0', '2', '2', 63, NULL, '0', '0905027', '    ', 25.4, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4409, '0', '2', '2', 66, NULL, '0', '0905027', '    ', 25.4, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4410, '0', '2', '2', 69, NULL, '0', '0905027', '    ', 25.4, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4411, '0', '2', '2', 72, NULL, '0', '0905027', '    ', 25.4, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4412, '0', '2', '2', 75, NULL, '0', '0905027', '    ', 25.4, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4413, '0', '2', '2', 78, NULL, '0', '0905027', '    ', 25.4, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4414, '0', '2', '2', 81, NULL, '0', '0905027', '    ', 25.4, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4415, '0', '2', '2', 84, NULL, '0', '0905027', '    ', 25.4, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4416, '0', '2', '2', 87, NULL, '0', '0905027', '    ', 25.4, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4417, '0', '2', '2', 90, NULL, '0', '0905027', '    ', 25.4, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4418, '0', '2', '2', 93, NULL, '0', '0905027', '    ', 25.4, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4419, '0', '2', '2', 96, NULL, '0', '0905027', '    ', 25.4, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4420, '0', '2', '2', 99, NULL, '0', '0905027', '    ', 25.4, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4421, '0', '2', '2', 21, NULL, '0', '0905028', '    ', 25.4, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4422, '0', '2', '2', 24, NULL, '0', '0905028', '    ', 25.4, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4423, '0', '2', '2', 27, NULL, '0', '0905028', '    ', 25.4, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4424, '0', '2', '2', 30, NULL, '0', '0905028', '    ', 25.4, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4425, '0', '2', '2', 33, NULL, '0', '0905028', '    ', 25.4, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4426, '0', '2', '2', 36, NULL, '0', '0905028', '    ', 25.4, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4427, '0', '2', '2', 39, NULL, '0', '0905028', '    ', 25.4, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4428, '0', '2', '2', 42, NULL, '0', '0905028', '    ', 25.4, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4429, '0', '2', '2', 45, NULL, '0', '0905028', '    ', 25.4, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4430, '0', '2', '2', 48, NULL, '0', '0905028', '    ', 25.4, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4431, '0', '2', '2', 51, NULL, '0', '0905028', '    ', 25.4, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4432, '0', '2', '2', 54, NULL, '0', '0905028', '    ', 25.4, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4433, '0', '2', '2', 57, NULL, '0', '0905028', '    ', 25.4, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4434, '0', '2', '2', 60, NULL, '0', '0905028', '    ', 25.4, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4435, '0', '2', '2', 63, NULL, '0', '0905028', '    ', 25.4, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4436, '0', '2', '2', 66, NULL, '0', '0905028', '    ', 25.4, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4437, '0', '2', '2', 69, NULL, '0', '0905028', '    ', 25.4, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4438, '0', '2', '2', 72, NULL, '0', '0905028', '    ', 25.4, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4439, '0', '2', '2', 75, NULL, '0', '0905028', '    ', 25.4, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4440, '0', '2', '2', 78, NULL, '0', '0905028', '    ', 25.4, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4441, '0', '2', '2', 81, NULL, '0', '0905028', '    ', 25.4, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4442, '0', '2', '2', 84, NULL, '0', '0905028', '    ', 25.4, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4443, '0', '2', '2', 87, NULL, '0', '0905028', '    ', 25.4, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4444, '0', '2', '2', 90, NULL, '0', '0905028', '    ', 25.4, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4445, '0', '2', '2', 93, NULL, '0', '0905028', '    ', 25.4, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4446, '0', '2', '2', 96, NULL, '0', '0905028', '    ', 25.4, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4447, '0', '2', '2', 99, NULL, '0', '0905028', '    ', 25.4, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4448, '0', '2', '2', 21, NULL, '0', '0905025', '    ', 7.88, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4449, '0', '2', '2', 24, NULL, '0', '0905025', '    ', 7.88, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4450, '0', '2', '2', 27, NULL, '0', '0905025', '    ', 7.88, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4451, '0', '2', '2', 30, NULL, '0', '0905025', '    ', 7.88, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4452, '0', '2', '2', 33, NULL, '0', '0905025', '    ', 7.88, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4453, '0', '2', '2', 36, NULL, '0', '0905025', '    ', 7.88, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4454, '0', '2', '2', 39, NULL, '0', '0905025', '    ', 7.88, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4455, '0', '2', '2', 42, NULL, '0', '0905025', '    ', 7.88, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4456, '0', '2', '2', 45, NULL, '0', '0905025', '    ', 7.88, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4457, '0', '2', '2', 48, NULL, '0', '0905025', '    ', 7.88, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4458, '0', '2', '2', 51, NULL, '0', '0905025', '    ', 7.88, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4459, '0', '2', '2', 54, NULL, '0', '0905025', '    ', 7.88, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4460, '0', '2', '2', 57, NULL, '0', '0905025', '    ', 7.88, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4461, '0', '2', '2', 60, NULL, '0', '0905025', '    ', 7.88, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4462, '0', '2', '2', 63, NULL, '0', '0905025', '    ', 7.88, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4463, '0', '2', '2', 66, NULL, '0', '0905025', '    ', 7.88, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4464, '0', '2', '2', 69, NULL, '0', '0905025', '    ', 7.88, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4465, '0', '2', '2', 72, NULL, '0', '0905025', '    ', 7.88, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4466, '0', '2', '2', 75, NULL, '0', '0905025', '    ', 7.88, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4467, '0', '2', '2', 78, NULL, '0', '0905025', '    ', 7.88, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4468, '0', '2', '2', 81, NULL, '0', '0905025', '    ', 7.88, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4469, '0', '2', '2', 84, NULL, '0', '0905025', '    ', 7.88, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4470, '0', '2', '2', 87, NULL, '0', '0905025', '    ', 7.88, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4471, '0', '2', '2', 90, NULL, '0', '0905025', '    ', 7.88, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4472, '0', '2', '2', 93, NULL, '0', '0905025', '    ', 7.88, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4473, '0', '2', '2', 96, NULL, '0', '0905025', '    ', 7.88, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4474, '0', '2', '2', 99, NULL, '0', '0905025', '    ', 7.88, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4475, '0', '2', '2', 21, NULL, '0', '0107401', '    /    ( )   ()     ', 384.87, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4476, '0', '2', '2', 24, NULL, '0', '0107401', '    /    ( )   ()     ', 384.87, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4477, '0', '2', '2', 27, NULL, '0', '0107401', '    /    ( )   ()     ', 384.87, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4478, '0', '2', '2', 30, NULL, '0', '0107401', '    /    ( )   ()     ', 384.87, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4479, '0', '2', '2', 33, NULL, '0', '0107401', '    /    ( )   ()     ', 384.87, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4480, '0', '2', '2', 36, NULL, '0', '0107401', '    /    ( )   ()     ', 384.87, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4481, '0', '2', '2', 39, NULL, '0', '0107401', '    /    ( )   ()     ', 384.87, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4482, '0', '2', '2', 42, NULL, '0', '0107401', '    /    ( )   ()     ', 384.87, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4483, '0', '2', '2', 45, NULL, '0', '0107401', '    /    ( )   ()     ', 384.87, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4484, '0', '2', '2', 48, NULL, '0', '0107401', '    /    ( )   ()     ', 384.87, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4485, '0', '2', '2', 51, NULL, '0', '0107401', '    /    ( )   ()     ', 384.87, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4486, '0', '2', '2', 54, NULL, '0', '0107401', '    /    ( )   ()     ', 384.87, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4487, '0', '2', '2', 57, NULL, '0', '0107401', '    /    ( )   ()     ', 384.87, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4488, '0', '2', '2', 60, NULL, '0', '0107401', '    /    ( )   ()     ', 384.87, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4489, '0', '2', '2', 63, NULL, '0', '0107401', '    /    ( )   ()     ', 384.87, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4490, '0', '2', '2', 66, NULL, '0', '0107401', '    /    ( )   ()     ', 384.87, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4491, '0', '2', '2', 69, NULL, '0', '0107401', '    /    ( )   ()     ', 384.87, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4492, '0', '2', '2', 72, NULL, '0', '0107401', '    /    ( )   ()     ', 384.87, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4493, '0', '2', '2', 75, NULL, '0', '0107401', '    /    ( )   ()     ', 384.87, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4494, '0', '2', '2', 78, NULL, '0', '0107401', '    /    ( )   ()     ', 384.87, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4495, '0', '2', '2', 81, NULL, '0', '0107401', '    /    ( )   ()     ', 384.87, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4496, '0', '2', '2', 84, NULL, '0', '0107401', '    /    ( )   ()     ', 384.87, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4497, '0', '2', '2', 87, NULL, '0', '0107401', '    /    ( )   ()     ', 384.87, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4498, '0', '2', '2', 90, NULL, '0', '0107401', '    /    ( )   ()     ', 384.87, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4499, '0', '2', '2', 93, NULL, '0', '0107401', '    /    ( )   ()     ', 384.87, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4500, '0', '2', '2', 96, NULL, '0', '0107401', '    /    ( )   ()     ', 384.87, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4501, '0', '2', '2', 99, NULL, '0', '0107401', '    /    ( )   ()     ', 384.87, '0', NULL, '2013-01-01', '2013-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4502, '3', '1', '0', 18, NULL, '0', '0404704', '  (, ) -', 0, '1', NULL, '2014-04-01', '2014-12-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4503, '3', '1', '0', 19, NULL, '0', '0404704', '  (, ) -', 0, '1', NULL, '2014-04-01', '2014-12-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4504, '3', '1', '0', 20, NULL, '0', '0404704', '  (, ) -', 0, '1', NULL, '2014-04-01', '2014-12-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4505, '3', '1', '0', 21, NULL, '0', '0404704', '  (, ) -', 0, '1', NULL, '2014-04-01', '2014-12-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4506, '3', '1', '0', 22, NULL, '0', '0404704', '  (, ) -', 0, '1', NULL, '2014-04-01', '2014-12-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4507, '3', '1', '0', 23, NULL, '0', '0404704', '  (, ) -', 0, '1', NULL, '2014-04-01', '2014-12-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4508, '3', '1', '0', 24, NULL, '0', '0404704', '  (, ) -', 0, '1', NULL, '2014-04-01', '2014-12-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4509, '3', '1', '0', 25, NULL, '0', '0404704', '  (, ) -', 0, '1', NULL, '2014-04-01', '2014-12-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4510, '3', '1', '0', 26, NULL, '0', '0404704', '  (, ) -', 0, '1', NULL, '2014-04-01', '2014-12-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4511, '3', '1', '0', 27, NULL, '0', '0404704', '  (, ) -', 0, '1', NULL, '2014-04-01', '2014-12-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4512, '3', '1', '0', 28, NULL, '0', '0404704', '  (, ) -', 0, '1', NULL, '2014-04-01', '2014-12-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4513, '3', '1', '0', 29, NULL, '0', '0404704', '  (, ) -', 0, '1', NULL, '2014-04-01', '2014-12-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4514, '3', '1', '0', 30, NULL, '0', '0404704', '  (, ) -', 0, '1', NULL, '2014-04-01', '2014-12-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4515, '3', '1', '0', 31, NULL, '0', '0404704', '  (, ) -', 0, '1', NULL, '2014-04-01', '2014-12-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4516, '3', '1', '0', 32, NULL, '0', '0404704', '  (, ) -', 0, '1', NULL, '2014-04-01', '2014-12-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4517, '3', '1', '0', 33, NULL, '0', '0404704', '  (, ) -', 0, '1', NULL, '2014-04-01', '2014-12-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4518, '3', '1', '0', 34, NULL, '0', '0404704', '  (, ) -', 0, '1', NULL, '2014-04-01', '2014-12-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4519, '3', '1', '0', 35, NULL, '0', '0404704', '  (, ) -', 0, '1', NULL, '2014-04-01', '2014-12-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4520, '3', '1', '0', 36, NULL, '0', '0404704', '  (, ) -', 0, '1', NULL, '2014-04-01', '2014-12-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4521, '3', '1', '0', 37, NULL, '0', '0404704', '  (, ) -', 0, '1', NULL, '2014-04-01', '2014-12-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4522, '3', '1', '0', 38, NULL, '0', '0404704', '  (, ) -', 0, '1', NULL, '2014-04-01', '2014-12-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4523, '3', '1', '0', 39, NULL, '0', '0404704', '  (, ) -', 0, '1', NULL, '2014-04-01', '2014-12-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4524, '3', '1', '0', 40, NULL, '0', '0404704', '  (, ) -', 0, '1', NULL, '2014-04-01', '2014-12-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4525, '3', '1', '0', 41, NULL, '0', '0404704', '  (, ) -', 0, '1', NULL, '2014-04-01', '2014-12-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4526, '3', '1', '0', 42, NULL, '0', '0404704', '  (, ) -', 0, '1', NULL, '2014-04-01', '2014-12-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4527, '3', '1', '0', 43, NULL, '0', '0404704', '  (, ) -', 0, '1', NULL, '2014-04-01', '2014-12-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4528, '3', '1', '0', 44, NULL, '0', '0404704', '  (, ) -', 0, '1', NULL, '2014-04-01', '2014-12-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4529, '3', '1', '0', 45, NULL, '0', '0404704', '  (, ) -', 0, '1', NULL, '2014-04-01', '2014-12-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4530, '3', '1', '0', 46, NULL, '0', '0404704', '  (, ) -', 0, '1', NULL, '2014-04-01', '2014-12-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4531, '3', '1', '0', 47, NULL, '0', '0404704', '  (, ) -', 0, '1', NULL, '2014-04-01', '2014-12-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4532, '3', '1', '0', 48, NULL, '0', '0404704', '  (, ) -', 0, '1', NULL, '2014-04-01', '2014-12-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4533, '3', '1', '0', 49, NULL, '0', '0404704', '  (, ) -', 0, '1', NULL, '2014-04-01', '2014-12-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4534, '3', '1', '0', 50, NULL, '0', '0404704', '  (, ) -', 0, '1', NULL, '2014-04-01', '2014-12-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4535, '3', '1', '0', 51, NULL, '0', '0404704', '  (, ) -', 0, '1', NULL, '2014-04-01', '2014-12-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4536, '3', '1', '0', 52, NULL, '0', '0404704', '  (, ) -', 0, '1', NULL, '2014-04-01', '2014-12-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4537, '3', '1', '0', 53, NULL, '0', '0404704', '  (, ) -', 0, '1', NULL, '2014-04-01', '2014-12-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4538, '3', '1', '0', 54, NULL, '0', '0404704', '  (, ) -', 0, '1', NULL, '2014-04-01', '2014-12-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4539, '3', '1', '0', 55, NULL, '0', '0404704', '  (, ) -', 0, '1', NULL, '2014-04-01', '2014-12-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4540, '3', '1', '0', 56, NULL, '0', '0404704', '  (, ) -', 0, '1', NULL, '2014-04-01', '2014-12-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4541, '3', '1', '0', 57, NULL, '0', '0404704', '  (, ) -', 0, '1', NULL, '2014-04-01', '2014-12-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4542, '3', '1', '0', 58, NULL, '0', '0404704', '  (, ) -', 0, '1', NULL, '2014-04-01', '2014-12-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4543, '3', '1', '0', 59, NULL, '0', '0404704', '  (, ) -', 0, '1', NULL, '2014-04-01', '2014-12-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4544, '3', '1', '0', 60, NULL, '0', '0404704', '  (, ) -', 0, '1', NULL, '2014-04-01', '2014-12-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4545, '3', '1', '0', 61, NULL, '0', '0404704', '  (, ) -', 0, '1', NULL, '2014-04-01', '2014-12-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4546, '3', '1', '0', 62, NULL, '0', '0404704', '  (, ) -', 0, '1', NULL, '2014-04-01', '2014-12-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4547, '3', '1', '0', 63, NULL, '0', '0404704', '  (, ) -', 0, '1', NULL, '2014-04-01', '2014-12-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4548, '3', '1', '0', 64, NULL, '0', '0404704', '  (, ) -', 0, '1', NULL, '2014-04-01', '2014-12-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4549, '3', '1', '0', 65, NULL, '0', '0404704', '  (, ) -', 0, '1', NULL, '2014-04-01', '2014-12-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4550, '3', '1', '0', 66, NULL, '0', '0404704', '  (, ) -', 0, '1', NULL, '2014-04-01', '2014-12-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4551, '3', '1', '0', 67, NULL, '0', '0404704', '  (, ) -', 0, '1', NULL, '2014-04-01', '2014-12-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4552, '3', '1', '0', 68, NULL, '0', '0404704', '  (, ) -', 0, '1', NULL, '2014-04-01', '2014-12-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4553, '3', '1', '0', 69, NULL, '0', '0404704', '  (, ) -', 0, '1', NULL, '2014-04-01', '2014-12-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4554, '3', '1', '0', 70, NULL, '0', '0404704', '  (, ) -', 0, '1', NULL, '2014-04-01', '2014-12-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4555, '3', '1', '0', 71, NULL, '0', '0404704', '  (, ) -', 0, '1', NULL, '2014-04-01', '2014-12-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4556, '3', '1', '0', 72, NULL, '0', '0404704', '  (, ) -', 0, '1', NULL, '2014-04-01', '2014-12-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4557, '3', '1', '0', 73, NULL, '0', '0404704', '  (, ) -', 0, '1', NULL, '2014-04-01', '2014-12-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4558, '3', '1', '0', 74, NULL, '0', '0404704', '  (, ) -', 0, '1', NULL, '2014-04-01', '2014-12-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4559, '3', '1', '0', 75, NULL, '0', '0404704', '  (, ) -', 0, '1', NULL, '2014-04-01', '2014-12-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4560, '3', '1', '0', 76, NULL, '0', '0404704', '  (, ) -', 0, '1', NULL, '2014-04-01', '2014-12-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4561, '3', '1', '0', 77, NULL, '0', '0404704', '  (, ) -', 0, '1', NULL, '2014-04-01', '2014-12-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4562, '3', '1', '0', 78, NULL, '0', '0404704', '  (, ) -', 0, '1', NULL, '2014-04-01', '2014-12-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4563, '3', '1', '0', 79, NULL, '0', '0404704', '  (, ) -', 0, '1', NULL, '2014-04-01', '2014-12-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4564, '3', '1', '0', 80, NULL, '0', '0404704', '  (, ) -', 0, '1', NULL, '2014-04-01', '2014-12-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4565, '3', '1', '0', 81, NULL, '0', '0404704', '  (, ) -', 0, '1', NULL, '2014-04-01', '2014-12-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4566, '3', '1', '0', 82, NULL, '0', '0404704', '  (, ) -', 0, '1', NULL, '2014-04-01', '2014-12-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4567, '3', '1', '0', 83, NULL, '0', '0404704', '  (, ) -', 0, '1', NULL, '2014-04-01', '2014-12-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4568, '3', '1', '0', 84, NULL, '0', '0404704', '  (, ) -', 0, '1', NULL, '2014-04-01', '2014-12-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4569, '3', '1', '0', 85, NULL, '0', '0404704', '  (, ) -', 0, '1', NULL, '2014-04-01', '2014-12-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4570, '3', '1', '0', 86, NULL, '0', '0404704', '  (, ) -', 0, '1', NULL, '2014-04-01', '2014-12-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4571, '3', '1', '0', 87, NULL, '0', '0404704', '  (, ) -', 0, '1', NULL, '2014-04-01', '2014-12-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4572, '3', '1', '0', 88, NULL, '0', '0404704', '  (, ) -', 0, '1', NULL, '2014-04-01', '2014-12-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4573, '3', '1', '0', 89, NULL, '0', '0404704', '  (, ) -', 0, '1', NULL, '2014-04-01', '2014-12-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4574, '3', '1', '0', 90, NULL, '0', '0404704', '  (, ) -', 0, '1', NULL, '2014-04-01', '2014-12-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4575, '3', '1', '0', 91, NULL, '0', '0404704', '  (, ) -', 0, '1', NULL, '2014-04-01', '2014-12-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4576, '3', '1', '0', 92, NULL, '0', '0404704', '  (, ) -', 0, '1', NULL, '2014-04-01', '2014-12-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4577, '3', '1', '0', 93, NULL, '0', '0404704', '  (, ) -', 0, '1', NULL, '2014-04-01', '2014-12-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4578, '3', '1', '0', 94, NULL, '0', '0404704', '  (, ) -', 0, '1', NULL, '2014-04-01', '2014-12-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4579, '3', '1', '0', 95, NULL, '0', '0404704', '  (, ) -', 0, '1', NULL, '2014-04-01', '2014-12-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4580, '3', '1', '0', 96, NULL, '0', '0404704', '  (, ) -', 0, '1', NULL, '2014-04-01', '2014-12-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4581, '3', '1', '0', 97, NULL, '0', '0404704', '  (, ) -', 0, '1', NULL, '2014-04-01', '2014-12-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4582, '3', '1', '0', 98, NULL, '0', '0404704', '  (, ) -', 0, '1', NULL, '2014-04-01', '2014-12-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4583, '3', '1', '0', 99, NULL, '0', '0404704', '  (, ) -', 0, '1', NULL, '2014-04-01', '2014-12-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4584, '3', '1', '0', 18, NULL, '0', '0905026', '    ', 15.49, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4585, '3', '1', '0', 19, NULL, '0', '0905026', '    ', 15.49, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4586, '3', '1', '0', 20, NULL, '0', '0905026', '    ', 15.49, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4587, '3', '1', '0', 21, NULL, '0', '0905026', '    ', 15.49, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4588, '3', '1', '0', 22, NULL, '0', '0905026', '    ', 15.49, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4589, '3', '1', '0', 23, NULL, '0', '0905026', '    ', 15.49, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4590, '3', '1', '0', 24, NULL, '0', '0905026', '    ', 15.49, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4591, '3', '1', '0', 25, NULL, '0', '0905026', '    ', 15.49, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4592, '3', '1', '0', 26, NULL, '0', '0905026', '    ', 15.49, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4593, '3', '1', '0', 27, NULL, '0', '0905026', '    ', 15.49, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4594, '3', '1', '0', 28, NULL, '0', '0905026', '    ', 15.49, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4595, '3', '1', '0', 29, NULL, '0', '0905026', '    ', 15.49, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4596, '3', '1', '0', 30, NULL, '0', '0905026', '    ', 15.49, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4597, '3', '1', '0', 31, NULL, '0', '0905026', '    ', 15.49, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4598, '3', '1', '0', 32, NULL, '0', '0905026', '    ', 15.49, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4599, '3', '1', '0', 33, NULL, '0', '0905026', '    ', 15.49, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4600, '3', '1', '0', 34, NULL, '0', '0905026', '    ', 15.49, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4601, '3', '1', '0', 35, NULL, '0', '0905026', '    ', 15.49, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4602, '3', '1', '0', 36, NULL, '0', '0905026', '    ', 15.49, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4603, '3', '1', '0', 37, NULL, '0', '0905026', '    ', 15.49, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4604, '3', '1', '0', 38, NULL, '0', '0905026', '    ', 15.49, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4605, '3', '1', '0', 39, NULL, '0', '0905026', '    ', 15.49, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4606, '3', '1', '0', 40, NULL, '0', '0905026', '    ', 15.49, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4607, '3', '1', '0', 41, NULL, '0', '0905026', '    ', 15.49, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4608, '3', '1', '0', 42, NULL, '0', '0905026', '    ', 15.49, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4609, '3', '1', '0', 43, NULL, '0', '0905026', '    ', 15.49, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4610, '3', '1', '0', 44, NULL, '0', '0905026', '    ', 15.49, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4611, '3', '1', '0', 45, NULL, '0', '0905026', '    ', 15.49, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4612, '3', '1', '0', 46, NULL, '0', '0905026', '    ', 15.49, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4613, '3', '1', '0', 47, NULL, '0', '0905026', '    ', 15.49, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4614, '3', '1', '0', 48, NULL, '0', '0905026', '    ', 15.49, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4615, '3', '1', '0', 49, NULL, '0', '0905026', '    ', 15.49, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4616, '3', '1', '0', 50, NULL, '0', '0905026', '    ', 15.49, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4617, '3', '1', '0', 51, NULL, '0', '0905026', '    ', 15.49, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4618, '3', '1', '0', 52, NULL, '0', '0905026', '    ', 15.49, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4619, '3', '1', '0', 53, NULL, '0', '0905026', '    ', 15.49, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4620, '3', '1', '0', 54, NULL, '0', '0905026', '    ', 15.49, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4621, '3', '1', '0', 55, NULL, '0', '0905026', '    ', 15.49, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4622, '3', '1', '0', 56, NULL, '0', '0905026', '    ', 15.49, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4623, '3', '1', '0', 57, NULL, '0', '0905026', '    ', 15.49, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4624, '3', '1', '0', 58, NULL, '0', '0905026', '    ', 15.49, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4625, '3', '1', '0', 59, NULL, '0', '0905026', '    ', 15.49, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4626, '3', '1', '0', 60, NULL, '0', '0905026', '    ', 15.49, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4627, '3', '1', '0', 61, NULL, '0', '0905026', '    ', 15.49, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4628, '3', '1', '0', 62, NULL, '0', '0905026', '    ', 15.49, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4629, '3', '1', '0', 63, NULL, '0', '0905026', '    ', 15.49, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4630, '3', '1', '0', 64, NULL, '0', '0905026', '    ', 15.49, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4631, '3', '1', '0', 65, NULL, '0', '0905026', '    ', 15.49, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4632, '3', '1', '0', 66, NULL, '0', '0905026', '    ', 15.49, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4633, '3', '1', '0', 67, NULL, '0', '0905026', '    ', 15.49, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4634, '3', '1', '0', 68, NULL, '0', '0905026', '    ', 15.49, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4635, '3', '1', '0', 69, NULL, '0', '0905026', '    ', 15.49, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4636, '3', '1', '0', 70, NULL, '0', '0905026', '    ', 15.49, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4637, '3', '1', '0', 71, NULL, '0', '0905026', '    ', 15.49, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4638, '3', '1', '0', 72, NULL, '0', '0905026', '    ', 15.49, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4639, '3', '1', '0', 73, NULL, '0', '0905026', '    ', 15.49, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4640, '3', '1', '0', 74, NULL, '0', '0905026', '    ', 15.49, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4641, '3', '1', '0', 75, NULL, '0', '0905026', '    ', 15.49, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4642, '3', '1', '0', 76, NULL, '0', '0905026', '    ', 15.49, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4643, '3', '1', '0', 77, NULL, '0', '0905026', '    ', 15.49, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4644, '3', '1', '0', 78, NULL, '0', '0905026', '    ', 15.49, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4645, '3', '1', '0', 79, NULL, '0', '0905026', '    ', 15.49, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4646, '3', '1', '0', 80, NULL, '0', '0905026', '    ', 15.49, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4647, '3', '1', '0', 81, NULL, '0', '0905026', '    ', 15.49, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4648, '3', '1', '0', 82, NULL, '0', '0905026', '    ', 15.49, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4649, '3', '1', '0', 83, NULL, '0', '0905026', '    ', 15.49, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4650, '3', '1', '0', 84, NULL, '0', '0905026', '    ', 15.49, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4651, '3', '1', '0', 85, NULL, '0', '0905026', '    ', 15.49, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4652, '3', '1', '0', 86, NULL, '0', '0905026', '    ', 15.49, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4653, '3', '1', '0', 87, NULL, '0', '0905026', '    ', 15.49, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4654, '3', '1', '0', 88, NULL, '0', '0905026', '    ', 15.49, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4655, '3', '1', '0', 89, NULL, '0', '0905026', '    ', 15.49, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4656, '3', '1', '0', 90, NULL, '0', '0905026', '    ', 15.49, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4657, '3', '1', '0', 91, NULL, '0', '0905026', '    ', 15.49, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4658, '3', '1', '0', 92, NULL, '0', '0905026', '    ', 15.49, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4659, '3', '1', '0', 93, NULL, '0', '0905026', '    ', 15.49, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4660, '3', '1', '0', 94, NULL, '0', '0905026', '    ', 15.49, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4661, '3', '1', '0', 95, NULL, '0', '0905026', '    ', 15.49, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4662, '3', '1', '0', 96, NULL, '0', '0905026', '    ', 15.49, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4663, '3', '1', '0', 97, NULL, '0', '0905026', '    ', 15.49, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4664, '3', '1', '0', 98, NULL, '0', '0905026', '    ', 15.49, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4665, '3', '1', '0', 99, NULL, '0', '0905026', '    ', 15.49, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4666, '3', '1', '0', 18, NULL, '0', '0905023', '    ', 32.12, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4667, '3', '1', '0', 19, NULL, '0', '0905023', '    ', 32.12, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4668, '3', '1', '0', 20, NULL, '0', '0905023', '    ', 32.12, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4669, '3', '1', '0', 21, NULL, '0', '0905023', '    ', 32.12, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4670, '3', '1', '0', 22, NULL, '0', '0905023', '    ', 32.12, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4671, '3', '1', '0', 23, NULL, '0', '0905023', '    ', 32.12, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4672, '3', '1', '0', 24, NULL, '0', '0905023', '    ', 32.12, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4673, '3', '1', '0', 25, NULL, '0', '0905023', '    ', 32.12, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4674, '3', '1', '0', 26, NULL, '0', '0905023', '    ', 32.12, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4675, '3', '1', '0', 27, NULL, '0', '0905023', '    ', 32.12, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4676, '3', '1', '0', 28, NULL, '0', '0905023', '    ', 32.12, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4677, '3', '1', '0', 29, NULL, '0', '0905023', '    ', 32.12, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4678, '3', '1', '0', 30, NULL, '0', '0905023', '    ', 32.12, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4679, '3', '1', '0', 31, NULL, '0', '0905023', '    ', 32.12, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4680, '3', '1', '0', 32, NULL, '0', '0905023', '    ', 32.12, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4681, '3', '1', '0', 33, NULL, '0', '0905023', '    ', 32.12, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4682, '3', '1', '0', 34, NULL, '0', '0905023', '    ', 32.12, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4683, '3', '1', '0', 35, NULL, '0', '0905023', '    ', 32.12, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4684, '3', '1', '0', 36, NULL, '0', '0905023', '    ', 32.12, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4685, '3', '1', '0', 37, NULL, '0', '0905023', '    ', 32.12, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4686, '3', '1', '0', 38, NULL, '0', '0905023', '    ', 32.12, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4687, '3', '1', '0', 39, NULL, '0', '0905023', '    ', 32.12, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4688, '3', '1', '0', 40, NULL, '0', '0905023', '    ', 32.12, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4689, '3', '1', '0', 41, NULL, '0', '0905023', '    ', 32.12, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4690, '3', '1', '0', 42, NULL, '0', '0905023', '    ', 32.12, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4691, '3', '1', '0', 43, NULL, '0', '0905023', '    ', 32.12, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4692, '3', '1', '0', 44, NULL, '0', '0905023', '    ', 32.12, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4693, '3', '1', '0', 45, NULL, '0', '0905023', '    ', 32.12, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4694, '3', '1', '0', 46, NULL, '0', '0905023', '    ', 32.12, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4695, '3', '1', '0', 47, NULL, '0', '0905023', '    ', 32.12, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4696, '3', '1', '0', 48, NULL, '0', '0905023', '    ', 32.12, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4697, '3', '1', '0', 49, NULL, '0', '0905023', '    ', 32.12, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4698, '3', '1', '0', 50, NULL, '0', '0905023', '    ', 32.12, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4699, '3', '1', '0', 51, NULL, '0', '0905023', '    ', 32.12, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4700, '3', '1', '0', 52, NULL, '0', '0905023', '    ', 32.12, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4701, '3', '1', '0', 53, NULL, '0', '0905023', '    ', 32.12, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4702, '3', '1', '0', 54, NULL, '0', '0905023', '    ', 32.12, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4703, '3', '1', '0', 55, NULL, '0', '0905023', '    ', 32.12, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4704, '3', '1', '0', 56, NULL, '0', '0905023', '    ', 32.12, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4705, '3', '1', '0', 57, NULL, '0', '0905023', '    ', 32.12, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4706, '3', '1', '0', 58, NULL, '0', '0905023', '    ', 32.12, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4707, '3', '1', '0', 59, NULL, '0', '0905023', '    ', 32.12, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4708, '3', '1', '0', 60, NULL, '0', '0905023', '    ', 32.12, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4709, '3', '1', '0', 61, NULL, '0', '0905023', '    ', 32.12, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4710, '3', '1', '0', 62, NULL, '0', '0905023', '    ', 32.12, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4711, '3', '1', '0', 63, NULL, '0', '0905023', '    ', 32.12, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4712, '3', '1', '0', 64, NULL, '0', '0905023', '    ', 32.12, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4713, '3', '1', '0', 65, NULL, '0', '0905023', '    ', 32.12, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4714, '3', '1', '0', 66, NULL, '0', '0905023', '    ', 32.12, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4715, '3', '1', '0', 67, NULL, '0', '0905023', '    ', 32.12, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4716, '3', '1', '0', 68, NULL, '0', '0905023', '    ', 32.12, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4717, '3', '1', '0', 69, NULL, '0', '0905023', '    ', 32.12, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4718, '3', '1', '0', 70, NULL, '0', '0905023', '    ', 32.12, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4719, '3', '1', '0', 71, NULL, '0', '0905023', '    ', 32.12, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4720, '3', '1', '0', 72, NULL, '0', '0905023', '    ', 32.12, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4721, '3', '1', '0', 73, NULL, '0', '0905023', '    ', 32.12, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4722, '3', '1', '0', 74, NULL, '0', '0905023', '    ', 32.12, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4723, '3', '1', '0', 75, NULL, '0', '0905023', '    ', 32.12, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4724, '3', '1', '0', 76, NULL, '0', '0905023', '    ', 32.12, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4725, '3', '1', '0', 77, NULL, '0', '0905023', '    ', 32.12, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4726, '3', '1', '0', 78, NULL, '0', '0905023', '    ', 32.12, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4727, '3', '1', '0', 79, NULL, '0', '0905023', '    ', 32.12, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4728, '3', '1', '0', 80, NULL, '0', '0905023', '    ', 32.12, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4729, '3', '1', '0', 81, NULL, '0', '0905023', '    ', 32.12, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4730, '3', '1', '0', 82, NULL, '0', '0905023', '    ', 32.12, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4731, '3', '1', '0', 83, NULL, '0', '0905023', '    ', 32.12, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4732, '3', '1', '0', 84, NULL, '0', '0905023', '    ', 32.12, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4733, '3', '1', '0', 85, NULL, '0', '0905023', '    ', 32.12, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4734, '3', '1', '0', 86, NULL, '0', '0905023', '    ', 32.12, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4735, '3', '1', '0', 87, NULL, '0', '0905023', '    ', 32.12, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4736, '3', '1', '0', 88, NULL, '0', '0905023', '    ', 32.12, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4737, '3', '1', '0', 89, NULL, '0', '0905023', '    ', 32.12, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4738, '3', '1', '0', 90, NULL, '0', '0905023', '    ', 32.12, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4739, '3', '1', '0', 91, NULL, '0', '0905023', '    ', 32.12, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4740, '3', '1', '0', 92, NULL, '0', '0905023', '    ', 32.12, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4741, '3', '1', '0', 93, NULL, '0', '0905023', '    ', 32.12, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4742, '3', '1', '0', 94, NULL, '0', '0905023', '    ', 32.12, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4743, '3', '1', '0', 95, NULL, '0', '0905023', '    ', 32.12, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4744, '3', '1', '0', 96, NULL, '0', '0905023', '    ', 32.12, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4745, '3', '1', '0', 97, NULL, '0', '0905023', '    ', 32.12, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4746, '3', '1', '0', 98, NULL, '0', '0905023', '    ', 32.12, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4747, '3', '1', '0', 99, NULL, '0', '0905023', '    ', 32.12, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4748, '3', '1', '0', 18, NULL, '0', '0609007', ' ', 170.65, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4749, '3', '1', '0', 19, NULL, '0', '0609007', ' ', 170.65, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4750, '3', '1', '0', 20, NULL, '0', '0609007', ' ', 170.65, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4751, '3', '1', '0', 21, NULL, '0', '0609007', ' ', 170.65, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4752, '3', '1', '0', 22, NULL, '0', '0609007', ' ', 170.65, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4753, '3', '1', '0', 23, NULL, '0', '0609007', ' ', 170.65, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4754, '3', '1', '0', 24, NULL, '0', '0609007', ' ', 170.65, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4755, '3', '1', '0', 25, NULL, '0', '0609007', ' ', 170.65, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4756, '3', '1', '0', 26, NULL, '0', '0609007', ' ', 170.65, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4757, '3', '1', '0', 27, NULL, '0', '0609007', ' ', 170.65, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4758, '3', '1', '0', 28, NULL, '0', '0609007', ' ', 170.65, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4759, '3', '1', '0', 29, NULL, '0', '0609007', ' ', 170.65, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4760, '3', '1', '0', 30, NULL, '0', '0609007', ' ', 170.65, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4761, '3', '1', '0', 31, NULL, '0', '0609007', ' ', 170.65, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4762, '3', '1', '0', 32, NULL, '0', '0609007', ' ', 170.65, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4763, '3', '1', '0', 33, NULL, '0', '0609007', ' ', 170.65, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4764, '3', '1', '0', 34, NULL, '0', '0609007', ' ', 170.65, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4765, '3', '1', '0', 35, NULL, '0', '0609007', ' ', 170.65, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4766, '3', '1', '0', 36, NULL, '0', '0609007', ' ', 170.65, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4767, '3', '1', '0', 37, NULL, '0', '0609007', ' ', 170.65, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4768, '3', '1', '0', 38, NULL, '0', '0609007', ' ', 170.65, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4769, '3', '1', '0', 39, NULL, '0', '0609007', ' ', 170.65, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4770, '3', '1', '0', 40, NULL, '0', '0609007', ' ', 170.65, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4771, '3', '1', '0', 41, NULL, '0', '0609007', ' ', 170.65, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4772, '3', '1', '0', 42, NULL, '0', '0609007', ' ', 170.65, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4773, '3', '1', '0', 43, NULL, '0', '0609007', ' ', 170.65, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4774, '3', '1', '0', 44, NULL, '0', '0609007', ' ', 170.65, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4775, '3', '1', '0', 45, NULL, '0', '0609007', ' ', 170.65, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4776, '3', '1', '0', 46, NULL, '0', '0609007', ' ', 170.65, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4777, '3', '1', '0', 47, NULL, '0', '0609007', ' ', 170.65, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4778, '3', '1', '0', 48, NULL, '0', '0609007', ' ', 170.65, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4779, '3', '1', '0', 49, NULL, '0', '0609007', ' ', 170.65, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4780, '3', '1', '0', 50, NULL, '0', '0609007', ' ', 170.65, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4781, '3', '1', '0', 51, NULL, '0', '0609007', ' ', 170.65, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4782, '3', '1', '0', 52, NULL, '0', '0609007', ' ', 170.65, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4783, '3', '1', '0', 53, NULL, '0', '0609007', ' ', 170.65, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4784, '3', '1', '0', 54, NULL, '0', '0609007', ' ', 170.65, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4785, '3', '1', '0', 55, NULL, '0', '0609007', ' ', 170.65, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4786, '3', '1', '0', 56, NULL, '0', '0609007', ' ', 170.65, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4787, '3', '1', '0', 57, NULL, '0', '0609007', ' ', 170.65, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4788, '3', '1', '0', 58, NULL, '0', '0609007', ' ', 170.65, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4789, '3', '1', '0', 59, NULL, '0', '0609007', ' ', 170.65, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4790, '3', '1', '0', 60, NULL, '0', '0609007', ' ', 170.65, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4791, '3', '1', '0', 61, NULL, '0', '0609007', ' ', 170.65, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4792, '3', '1', '0', 62, NULL, '0', '0609007', ' ', 170.65, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4793, '3', '1', '0', 63, NULL, '0', '0609007', ' ', 170.65, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4794, '3', '1', '0', 64, NULL, '0', '0609007', ' ', 170.65, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4795, '3', '1', '0', 65, NULL, '0', '0609007', ' ', 170.65, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4796, '3', '1', '0', 66, NULL, '0', '0609007', ' ', 170.65, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4797, '3', '1', '0', 67, NULL, '0', '0609007', ' ', 170.65, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4798, '3', '1', '0', 68, NULL, '0', '0609007', ' ', 170.65, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4799, '3', '1', '0', 69, NULL, '0', '0609007', ' ', 170.65, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4800, '3', '1', '0', 70, NULL, '0', '0609007', ' ', 170.65, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4801, '3', '1', '0', 71, NULL, '0', '0609007', ' ', 170.65, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4802, '3', '1', '0', 72, NULL, '0', '0609007', ' ', 170.65, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4803, '3', '1', '0', 73, NULL, '0', '0609007', ' ', 170.65, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4804, '3', '1', '0', 74, NULL, '0', '0609007', ' ', 170.65, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4805, '3', '1', '0', 75, NULL, '0', '0609007', ' ', 170.65, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4806, '3', '1', '0', 76, NULL, '0', '0609007', ' ', 170.65, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4807, '3', '1', '0', 77, NULL, '0', '0609007', ' ', 170.65, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4808, '3', '1', '0', 78, NULL, '0', '0609007', ' ', 170.65, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4809, '3', '1', '0', 79, NULL, '0', '0609007', ' ', 170.65, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4810, '3', '1', '0', 80, NULL, '0', '0609007', ' ', 170.65, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4811, '3', '1', '0', 81, NULL, '0', '0609007', ' ', 170.65, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4812, '3', '1', '0', 82, NULL, '0', '0609007', ' ', 170.65, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4813, '3', '1', '0', 83, NULL, '0', '0609007', ' ', 170.65, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4814, '3', '1', '0', 84, NULL, '0', '0609007', ' ', 170.65, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4815, '3', '1', '0', 85, NULL, '0', '0609007', ' ', 170.65, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4816, '3', '1', '0', 86, NULL, '0', '0609007', ' ', 170.65, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4817, '3', '1', '0', 87, NULL, '0', '0609007', ' ', 170.65, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4818, '3', '1', '0', 88, NULL, '0', '0609007', ' ', 170.65, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4819, '3', '1', '0', 89, NULL, '0', '0609007', ' ', 170.65, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4820, '3', '1', '0', 90, NULL, '0', '0609007', ' ', 170.65, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4821, '3', '1', '0', 91, NULL, '0', '0609007', ' ', 170.65, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4822, '3', '1', '0', 92, NULL, '0', '0609007', ' ', 170.65, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4823, '3', '1', '0', 93, NULL, '0', '0609007', ' ', 170.65, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4824, '3', '1', '0', 94, NULL, '0', '0609007', ' ', 170.65, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4825, '3', '1', '0', 95, NULL, '0', '0609007', ' ', 170.65, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4826, '3', '1', '0', 96, NULL, '0', '0609007', ' ', 170.65, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4827, '3', '1', '0', 97, NULL, '0', '0609007', ' ', 170.65, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4828, '3', '1', '0', 98, NULL, '0', '0609007', ' ', 170.65, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4829, '3', '1', '0', 99, NULL, '0', '0609007', ' ', 170.65, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4830, '3', '1', '0', 18, NULL, '0', '0805010', '        ', 7.55, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4831, '3', '1', '0', 19, NULL, '0', '0805010', '        ', 7.55, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4832, '3', '1', '0', 20, NULL, '0', '0805010', '        ', 7.55, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4833, '3', '1', '0', 21, NULL, '0', '0805010', '        ', 7.55, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4834, '3', '1', '0', 22, NULL, '0', '0805010', '        ', 7.55, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4835, '3', '1', '0', 23, NULL, '0', '0805010', '        ', 7.55, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4836, '3', '1', '0', 24, NULL, '0', '0805010', '        ', 7.55, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4837, '3', '1', '0', 25, NULL, '0', '0805010', '        ', 7.55, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4838, '3', '1', '0', 26, NULL, '0', '0805010', '        ', 7.55, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4839, '3', '1', '0', 27, NULL, '0', '0805010', '        ', 7.55, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4840, '3', '1', '0', 28, NULL, '0', '0805010', '        ', 7.55, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4841, '3', '1', '0', 29, NULL, '0', '0805010', '        ', 7.55, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4842, '3', '1', '0', 30, NULL, '0', '0805010', '        ', 7.55, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4843, '3', '1', '0', 31, NULL, '0', '0805010', '        ', 7.55, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4844, '3', '1', '0', 32, NULL, '0', '0805010', '        ', 7.55, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4845, '3', '1', '0', 33, NULL, '0', '0805010', '        ', 7.55, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4846, '3', '1', '0', 34, NULL, '0', '0805010', '        ', 7.55, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4847, '3', '1', '0', 35, NULL, '0', '0805010', '        ', 7.55, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4848, '3', '1', '0', 36, NULL, '0', '0805010', '        ', 7.55, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4849, '3', '1', '0', 37, NULL, '0', '0805010', '        ', 7.55, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4850, '3', '1', '0', 38, NULL, '0', '0805010', '        ', 7.55, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4851, '3', '1', '0', 39, NULL, '0', '0805010', '        ', 7.55, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4852, '3', '1', '0', 40, NULL, '0', '0805010', '        ', 7.55, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4853, '3', '1', '0', 41, NULL, '0', '0805010', '        ', 7.55, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4854, '3', '1', '0', 42, NULL, '0', '0805010', '        ', 7.55, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4855, '3', '1', '0', 43, NULL, '0', '0805010', '        ', 7.55, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4856, '3', '1', '0', 44, NULL, '0', '0805010', '        ', 7.55, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4857, '3', '1', '0', 45, NULL, '0', '0805010', '        ', 7.55, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4858, '3', '1', '0', 46, NULL, '0', '0805010', '        ', 7.55, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4859, '3', '1', '0', 47, NULL, '0', '0805010', '        ', 7.55, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4860, '3', '1', '0', 48, NULL, '0', '0805010', '        ', 7.55, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4861, '3', '1', '0', 49, NULL, '0', '0805010', '        ', 7.55, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4862, '3', '1', '0', 50, NULL, '0', '0805010', '        ', 7.55, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4863, '3', '1', '0', 51, NULL, '0', '0805010', '        ', 7.55, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4864, '3', '1', '0', 52, NULL, '0', '0805010', '        ', 7.55, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4865, '3', '1', '0', 53, NULL, '0', '0805010', '        ', 7.55, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4866, '3', '1', '0', 54, NULL, '0', '0805010', '        ', 7.55, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4867, '3', '1', '0', 55, NULL, '0', '0805010', '        ', 7.55, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4868, '3', '1', '0', 56, NULL, '0', '0805010', '        ', 7.55, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4869, '3', '1', '0', 57, NULL, '0', '0805010', '        ', 7.55, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4870, '3', '1', '0', 58, NULL, '0', '0805010', '        ', 7.55, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4871, '3', '1', '0', 59, NULL, '0', '0805010', '        ', 7.55, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4872, '3', '1', '0', 60, NULL, '0', '0805010', '        ', 7.55, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4873, '3', '1', '0', 61, NULL, '0', '0805010', '        ', 7.55, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4874, '3', '1', '0', 62, NULL, '0', '0805010', '        ', 7.55, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4875, '3', '1', '0', 63, NULL, '0', '0805010', '        ', 7.55, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4876, '3', '1', '0', 64, NULL, '0', '0805010', '        ', 7.55, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4877, '3', '1', '0', 65, NULL, '0', '0805010', '        ', 7.55, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4878, '3', '1', '0', 66, NULL, '0', '0805010', '        ', 7.55, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4879, '3', '1', '0', 67, NULL, '0', '0805010', '        ', 7.55, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4880, '3', '1', '0', 68, NULL, '0', '0805010', '        ', 7.55, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4881, '3', '1', '0', 69, NULL, '0', '0805010', '        ', 7.55, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4882, '3', '1', '0', 70, NULL, '0', '0805010', '        ', 7.55, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4883, '3', '1', '0', 71, NULL, '0', '0805010', '        ', 7.55, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4884, '3', '1', '0', 72, NULL, '0', '0805010', '        ', 7.55, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4885, '3', '1', '0', 73, NULL, '0', '0805010', '        ', 7.55, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4886, '3', '1', '0', 74, NULL, '0', '0805010', '        ', 7.55, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4887, '3', '1', '0', 75, NULL, '0', '0805010', '        ', 7.55, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4888, '3', '1', '0', 76, NULL, '0', '0805010', '        ', 7.55, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4889, '3', '1', '0', 77, NULL, '0', '0805010', '        ', 7.55, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4890, '3', '1', '0', 78, NULL, '0', '0805010', '        ', 7.55, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4891, '3', '1', '0', 79, NULL, '0', '0805010', '        ', 7.55, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4892, '3', '1', '0', 80, NULL, '0', '0805010', '        ', 7.55, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4893, '3', '1', '0', 81, NULL, '0', '0805010', '        ', 7.55, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4894, '3', '1', '0', 82, NULL, '0', '0805010', '        ', 7.55, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4895, '3', '1', '0', 83, NULL, '0', '0805010', '        ', 7.55, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4896, '3', '1', '0', 84, NULL, '0', '0805010', '        ', 7.55, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4897, '3', '1', '0', 85, NULL, '0', '0805010', '        ', 7.55, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4898, '3', '1', '0', 86, NULL, '0', '0805010', '        ', 7.55, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4899, '3', '1', '0', 87, NULL, '0', '0805010', '        ', 7.55, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4900, '3', '1', '0', 88, NULL, '0', '0805010', '        ', 7.55, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4901, '3', '1', '0', 89, NULL, '0', '0805010', '        ', 7.55, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4902, '3', '1', '0', 90, NULL, '0', '0805010', '        ', 7.55, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4903, '3', '1', '0', 91, NULL, '0', '0805010', '        ', 7.55, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4904, '3', '1', '0', 92, NULL, '0', '0805010', '        ', 7.55, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4905, '3', '1', '0', 93, NULL, '0', '0805010', '        ', 7.55, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4906, '3', '1', '0', 94, NULL, '0', '0805010', '        ', 7.55, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4907, '3', '1', '0', 95, NULL, '0', '0805010', '        ', 7.55, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4908, '3', '1', '0', 96, NULL, '0', '0805010', '        ', 7.55, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4909, '3', '1', '0', 97, NULL, '0', '0805010', '        ', 7.55, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4910, '3', '1', '0', 98, NULL, '0', '0805010', '        ', 7.55, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4911, '3', '1', '0', 99, NULL, '0', '0805010', '        ', 7.55, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4912, '3', '1', '0', 18, NULL, '0', '0805004', '    ', 19.27, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4913, '3', '1', '0', 19, NULL, '0', '0805004', '    ', 19.27, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4914, '3', '1', '0', 20, NULL, '0', '0805004', '    ', 19.27, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4915, '3', '1', '0', 21, NULL, '0', '0805004', '    ', 19.27, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4916, '3', '1', '0', 22, NULL, '0', '0805004', '    ', 19.27, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4917, '3', '1', '0', 23, NULL, '0', '0805004', '    ', 19.27, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4918, '3', '1', '0', 24, NULL, '0', '0805004', '    ', 19.27, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4919, '3', '1', '0', 25, NULL, '0', '0805004', '    ', 19.27, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4920, '3', '1', '0', 26, NULL, '0', '0805004', '    ', 19.27, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4921, '3', '1', '0', 27, NULL, '0', '0805004', '    ', 19.27, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4922, '3', '1', '0', 28, NULL, '0', '0805004', '    ', 19.27, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4923, '3', '1', '0', 29, NULL, '0', '0805004', '    ', 19.27, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4924, '3', '1', '0', 30, NULL, '0', '0805004', '    ', 19.27, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4925, '3', '1', '0', 31, NULL, '0', '0805004', '    ', 19.27, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4926, '3', '1', '0', 32, NULL, '0', '0805004', '    ', 19.27, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4927, '3', '1', '0', 33, NULL, '0', '0805004', '    ', 19.27, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4928, '3', '1', '0', 34, NULL, '0', '0805004', '    ', 19.27, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4929, '3', '1', '0', 35, NULL, '0', '0805004', '    ', 19.27, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4930, '3', '1', '0', 36, NULL, '0', '0805004', '    ', 19.27, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4931, '3', '1', '0', 37, NULL, '0', '0805004', '    ', 19.27, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4932, '3', '1', '0', 38, NULL, '0', '0805004', '    ', 19.27, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4933, '3', '1', '0', 39, NULL, '0', '0805004', '    ', 19.27, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4934, '3', '1', '0', 40, NULL, '0', '0805004', '    ', 19.27, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4935, '3', '1', '0', 41, NULL, '0', '0805004', '    ', 19.27, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4936, '3', '1', '0', 42, NULL, '0', '0805004', '    ', 19.27, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4937, '3', '1', '0', 43, NULL, '0', '0805004', '    ', 19.27, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4938, '3', '1', '0', 44, NULL, '0', '0805004', '    ', 19.27, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4939, '3', '1', '0', 45, NULL, '0', '0805004', '    ', 19.27, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4940, '3', '1', '0', 46, NULL, '0', '0805004', '    ', 19.27, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4941, '3', '1', '0', 47, NULL, '0', '0805004', '    ', 19.27, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4942, '3', '1', '0', 48, NULL, '0', '0805004', '    ', 19.27, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4943, '3', '1', '0', 49, NULL, '0', '0805004', '    ', 19.27, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4944, '3', '1', '0', 50, NULL, '0', '0805004', '    ', 19.27, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4945, '3', '1', '0', 51, NULL, '0', '0805004', '    ', 19.27, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4946, '3', '1', '0', 52, NULL, '0', '0805004', '    ', 19.27, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4947, '3', '1', '0', 53, NULL, '0', '0805004', '    ', 19.27, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4948, '3', '1', '0', 54, NULL, '0', '0805004', '    ', 19.27, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4949, '3', '1', '0', 55, NULL, '0', '0805004', '    ', 19.27, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4950, '3', '1', '0', 56, NULL, '0', '0805004', '    ', 19.27, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4951, '3', '1', '0', 57, NULL, '0', '0805004', '    ', 19.27, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4952, '3', '1', '0', 58, NULL, '0', '0805004', '    ', 19.27, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4953, '3', '1', '0', 59, NULL, '0', '0805004', '    ', 19.27, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4954, '3', '1', '0', 60, NULL, '0', '0805004', '    ', 19.27, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4955, '3', '1', '0', 61, NULL, '0', '0805004', '    ', 19.27, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4956, '3', '1', '0', 62, NULL, '0', '0805004', '    ', 19.27, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4957, '3', '1', '0', 63, NULL, '0', '0805004', '    ', 19.27, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4958, '3', '1', '0', 64, NULL, '0', '0805004', '    ', 19.27, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4959, '3', '1', '0', 65, NULL, '0', '0805004', '    ', 19.27, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4960, '3', '1', '0', 66, NULL, '0', '0805004', '    ', 19.27, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4961, '3', '1', '0', 67, NULL, '0', '0805004', '    ', 19.27, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4962, '3', '1', '0', 68, NULL, '0', '0805004', '    ', 19.27, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4963, '3', '1', '0', 69, NULL, '0', '0805004', '    ', 19.27, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4964, '3', '1', '0', 70, NULL, '0', '0805004', '    ', 19.27, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4965, '3', '1', '0', 71, NULL, '0', '0805004', '    ', 19.27, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4966, '3', '1', '0', 72, NULL, '0', '0805004', '    ', 19.27, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4967, '3', '1', '0', 73, NULL, '0', '0805004', '    ', 19.27, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4968, '3', '1', '0', 74, NULL, '0', '0805004', '    ', 19.27, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4969, '3', '1', '0', 75, NULL, '0', '0805004', '    ', 19.27, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4970, '3', '1', '0', 76, NULL, '0', '0805004', '    ', 19.27, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4971, '3', '1', '0', 77, NULL, '0', '0805004', '    ', 19.27, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4972, '3', '1', '0', 78, NULL, '0', '0805004', '    ', 19.27, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4973, '3', '1', '0', 79, NULL, '0', '0805004', '    ', 19.27, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4974, '3', '1', '0', 80, NULL, '0', '0805004', '    ', 19.27, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4975, '3', '1', '0', 81, NULL, '0', '0805004', '    ', 19.27, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4976, '3', '1', '0', 82, NULL, '0', '0805004', '    ', 19.27, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4977, '3', '1', '0', 83, NULL, '0', '0805004', '    ', 19.27, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4978, '3', '1', '0', 84, NULL, '0', '0805004', '    ', 19.27, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4979, '3', '1', '0', 85, NULL, '0', '0805004', '    ', 19.27, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4980, '3', '1', '0', 86, NULL, '0', '0805004', '    ', 19.27, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4981, '3', '1', '0', 87, NULL, '0', '0805004', '    ', 19.27, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4982, '3', '1', '0', 88, NULL, '0', '0805004', '    ', 19.27, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4983, '3', '1', '0', 89, NULL, '0', '0805004', '    ', 19.27, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4984, '3', '1', '0', 90, NULL, '0', '0805004', '    ', 19.27, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4985, '3', '1', '0', 91, NULL, '0', '0805004', '    ', 19.27, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4986, '3', '1', '0', 92, NULL, '0', '0805004', '    ', 19.27, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4987, '3', '1', '0', 93, NULL, '0', '0805004', '    ', 19.27, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4988, '3', '1', '0', 94, NULL, '0', '0805004', '    ', 19.27, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4989, '3', '1', '0', 95, NULL, '0', '0805004', '    ', 19.27, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4990, '3', '1', '0', 96, NULL, '0', '0805004', '    ', 19.27, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4991, '3', '1', '0', 97, NULL, '0', '0805004', '    ', 19.27, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4992, '3', '1', '0', 98, NULL, '0', '0805004', '    ', 19.27, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4993, '3', '1', '0', 99, NULL, '0', '0805004', '    ', 19.27, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4994, '3', '1', '0', 18, NULL, '0', '1205001', '  ', 9.64, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4995, '3', '1', '0', 19, NULL, '0', '1205001', '  ', 9.64, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4996, '3', '1', '0', 20, NULL, '0', '1205001', '  ', 9.64, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4997, '3', '1', '0', 21, NULL, '0', '1205001', '  ', 9.64, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4998, '3', '1', '0', 22, NULL, '0', '1205001', '  ', 9.64, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (4999, '3', '1', '0', 23, NULL, '0', '1205001', '  ', 9.64, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5000, '3', '1', '0', 24, NULL, '0', '1205001', '  ', 9.64, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5001, '3', '1', '0', 25, NULL, '0', '1205001', '  ', 9.64, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5002, '3', '1', '0', 26, NULL, '0', '1205001', '  ', 9.64, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5003, '3', '1', '0', 27, NULL, '0', '1205001', '  ', 9.64, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
COMMIT WORK; @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5004, '3', '1', '0', 28, NULL, '0', '1205001', '  ', 9.64, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5005, '3', '1', '0', 29, NULL, '0', '1205001', '  ', 9.64, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5006, '3', '1', '0', 30, NULL, '0', '1205001', '  ', 9.64, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5007, '3', '1', '0', 31, NULL, '0', '1205001', '  ', 9.64, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5008, '3', '1', '0', 32, NULL, '0', '1205001', '  ', 9.64, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5009, '3', '1', '0', 33, NULL, '0', '1205001', '  ', 9.64, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5010, '3', '1', '0', 34, NULL, '0', '1205001', '  ', 9.64, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5011, '3', '1', '0', 35, NULL, '0', '1205001', '  ', 9.64, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5012, '3', '1', '0', 36, NULL, '0', '1205001', '  ', 9.64, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5013, '3', '1', '0', 37, NULL, '0', '1205001', '  ', 9.64, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5014, '3', '1', '0', 38, NULL, '0', '1205001', '  ', 9.64, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5015, '3', '1', '0', 39, NULL, '0', '1205001', '  ', 9.64, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5016, '3', '1', '0', 40, NULL, '0', '1205001', '  ', 9.64, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5017, '3', '1', '0', 41, NULL, '0', '1205001', '  ', 9.64, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5018, '3', '1', '0', 42, NULL, '0', '1205001', '  ', 9.64, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5019, '3', '1', '0', 43, NULL, '0', '1205001', '  ', 9.64, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5020, '3', '1', '0', 44, NULL, '0', '1205001', '  ', 9.64, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5021, '3', '1', '0', 45, NULL, '0', '1205001', '  ', 9.64, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5022, '3', '1', '0', 46, NULL, '0', '1205001', '  ', 9.64, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5023, '3', '1', '0', 47, NULL, '0', '1205001', '  ', 9.64, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5024, '3', '1', '0', 48, NULL, '0', '1205001', '  ', 9.64, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5025, '3', '1', '0', 49, NULL, '0', '1205001', '  ', 9.64, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5026, '3', '1', '0', 50, NULL, '0', '1205001', '  ', 9.64, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5027, '3', '1', '0', 51, NULL, '0', '1205001', '  ', 9.64, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5028, '3', '1', '0', 52, NULL, '0', '1205001', '  ', 9.64, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5029, '3', '1', '0', 53, NULL, '0', '1205001', '  ', 9.64, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5030, '3', '1', '0', 54, NULL, '0', '1205001', '  ', 9.64, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5031, '3', '1', '0', 55, NULL, '0', '1205001', '  ', 9.64, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5032, '3', '1', '0', 56, NULL, '0', '1205001', '  ', 9.64, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5033, '3', '1', '0', 57, NULL, '0', '1205001', '  ', 9.64, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5034, '3', '1', '0', 58, NULL, '0', '1205001', '  ', 9.64, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5035, '3', '1', '0', 59, NULL, '0', '1205001', '  ', 9.64, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5036, '3', '1', '0', 60, NULL, '0', '1205001', '  ', 9.64, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5037, '3', '1', '0', 61, NULL, '0', '1205001', '  ', 9.64, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5038, '3', '1', '0', 62, NULL, '0', '1205001', '  ', 9.64, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5039, '3', '1', '0', 63, NULL, '0', '1205001', '  ', 9.64, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5040, '3', '1', '0', 64, NULL, '0', '1205001', '  ', 9.64, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5041, '3', '1', '0', 65, NULL, '0', '1205001', '  ', 9.64, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5042, '3', '1', '0', 66, NULL, '0', '1205001', '  ', 9.64, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5043, '3', '1', '0', 67, NULL, '0', '1205001', '  ', 9.64, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5044, '3', '1', '0', 68, NULL, '0', '1205001', '  ', 9.64, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5045, '3', '1', '0', 69, NULL, '0', '1205001', '  ', 9.64, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5046, '3', '1', '0', 70, NULL, '0', '1205001', '  ', 9.64, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5047, '3', '1', '0', 71, NULL, '0', '1205001', '  ', 9.64, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5048, '3', '1', '0', 72, NULL, '0', '1205001', '  ', 9.64, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5049, '3', '1', '0', 73, NULL, '0', '1205001', '  ', 9.64, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5050, '3', '1', '0', 74, NULL, '0', '1205001', '  ', 9.64, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5051, '3', '1', '0', 75, NULL, '0', '1205001', '  ', 9.64, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5052, '3', '1', '0', 76, NULL, '0', '1205001', '  ', 9.64, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5053, '3', '1', '0', 77, NULL, '0', '1205001', '  ', 9.64, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5054, '3', '1', '0', 78, NULL, '0', '1205001', '  ', 9.64, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5055, '3', '1', '0', 79, NULL, '0', '1205001', '  ', 9.64, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5056, '3', '1', '0', 80, NULL, '0', '1205001', '  ', 9.64, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5057, '3', '1', '0', 81, NULL, '0', '1205001', '  ', 9.64, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5058, '3', '1', '0', 82, NULL, '0', '1205001', '  ', 9.64, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5059, '3', '1', '0', 83, NULL, '0', '1205001', '  ', 9.64, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5060, '3', '1', '0', 84, NULL, '0', '1205001', '  ', 9.64, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5061, '3', '1', '0', 85, NULL, '0', '1205001', '  ', 9.64, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5062, '3', '1', '0', 86, NULL, '0', '1205001', '  ', 9.64, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5063, '3', '1', '0', 87, NULL, '0', '1205001', '  ', 9.64, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5064, '3', '1', '0', 88, NULL, '0', '1205001', '  ', 9.64, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5065, '3', '1', '0', 89, NULL, '0', '1205001', '  ', 9.64, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5066, '3', '1', '0', 90, NULL, '0', '1205001', '  ', 9.64, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5067, '3', '1', '0', 91, NULL, '0', '1205001', '  ', 9.64, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5068, '3', '1', '0', 92, NULL, '0', '1205001', '  ', 9.64, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5069, '3', '1', '0', 93, NULL, '0', '1205001', '  ', 9.64, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5070, '3', '1', '0', 94, NULL, '0', '1205001', '  ', 9.64, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5071, '3', '1', '0', 95, NULL, '0', '1205001', '  ', 9.64, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5072, '3', '1', '0', 96, NULL, '0', '1205001', '  ', 9.64, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5073, '3', '1', '0', 97, NULL, '0', '1205001', '  ', 9.64, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5074, '3', '1', '0', 98, NULL, '0', '1205001', '  ', 9.64, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5075, '3', '1', '0', 99, NULL, '0', '1205001', '  ', 9.64, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5076, '3', '1', '0', 45, NULL, '0', '0919002', '    ', 9.18, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5077, '3', '1', '0', 46, NULL, '0', '0919002', '    ', 9.18, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5078, '3', '1', '0', 47, NULL, '0', '0919002', '    ', 9.18, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5079, '3', '1', '0', 48, NULL, '0', '0919002', '    ', 9.18, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5080, '3', '1', '0', 49, NULL, '0', '0919002', '    ', 9.18, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5081, '3', '1', '0', 50, NULL, '0', '0919002', '    ', 9.18, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5082, '3', '1', '0', 51, NULL, '0', '0919002', '    ', 9.18, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5083, '3', '1', '0', 52, NULL, '0', '0919002', '    ', 9.18, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5084, '3', '1', '0', 53, NULL, '0', '0919002', '    ', 9.18, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5085, '3', '1', '0', 54, NULL, '0', '0919002', '    ', 9.18, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5086, '3', '1', '0', 55, NULL, '0', '0919002', '    ', 9.18, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5087, '3', '1', '0', 56, NULL, '0', '0919002', '    ', 9.18, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5088, '3', '1', '0', 57, NULL, '0', '0919002', '    ', 9.18, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5089, '3', '1', '0', 58, NULL, '0', '0919002', '    ', 9.18, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5090, '3', '1', '0', 59, NULL, '0', '0919002', '    ', 9.18, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5091, '3', '1', '0', 60, NULL, '0', '0919002', '    ', 9.18, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5092, '3', '1', '0', 61, NULL, '0', '0919002', '    ', 9.18, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5093, '3', '1', '0', 62, NULL, '0', '0919002', '    ', 9.18, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5094, '3', '1', '0', 63, NULL, '0', '0919002', '    ', 9.18, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5095, '3', '1', '0', 64, NULL, '0', '0919002', '    ', 9.18, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5096, '3', '1', '0', 65, NULL, '0', '0919002', '    ', 9.18, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5097, '3', '1', '0', 66, NULL, '0', '0919002', '    ', 9.18, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5098, '3', '1', '0', 67, NULL, '0', '0919002', '    ', 9.18, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5099, '3', '1', '0', 68, NULL, '0', '0919002', '    ', 9.18, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5100, '3', '1', '0', 69, NULL, '0', '0919002', '    ', 9.18, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5101, '3', '1', '0', 70, NULL, '0', '0919002', '    ', 9.18, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5102, '3', '1', '0', 71, NULL, '0', '0919002', '    ', 9.18, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5103, '3', '1', '0', 72, NULL, '0', '0919002', '    ', 9.18, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5104, '3', '1', '0', 73, NULL, '0', '0919002', '    ', 9.18, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5105, '3', '1', '0', 74, NULL, '0', '0919002', '    ', 9.18, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5106, '3', '1', '0', 75, NULL, '0', '0919002', '    ', 9.18, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5107, '3', '1', '0', 76, NULL, '0', '0919002', '    ', 9.18, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5108, '3', '1', '0', 77, NULL, '0', '0919002', '    ', 9.18, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5109, '3', '1', '0', 78, NULL, '0', '0919002', '    ', 9.18, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5110, '3', '1', '0', 79, NULL, '0', '0919002', '    ', 9.18, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5111, '3', '1', '0', 80, NULL, '0', '0919002', '    ', 9.18, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5112, '3', '1', '0', 81, NULL, '0', '0919002', '    ', 9.18, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5113, '3', '1', '0', 82, NULL, '0', '0919002', '    ', 9.18, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5114, '3', '1', '0', 83, NULL, '0', '0919002', '    ', 9.18, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5115, '3', '1', '0', 84, NULL, '0', '0919002', '    ', 9.18, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5116, '3', '1', '0', 85, NULL, '0', '0919002', '    ', 9.18, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5117, '3', '1', '0', 86, NULL, '0', '0919002', '    ', 9.18, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5118, '3', '1', '0', 87, NULL, '0', '0919002', '    ', 9.18, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5119, '3', '1', '0', 88, NULL, '0', '0919002', '    ', 9.18, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5120, '3', '1', '0', 89, NULL, '0', '0919002', '    ', 9.18, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5121, '3', '1', '0', 90, NULL, '0', '0919002', '    ', 9.18, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5122, '3', '1', '0', 91, NULL, '0', '0919002', '    ', 9.18, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5123, '3', '1', '0', 92, NULL, '0', '0919002', '    ', 9.18, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5124, '3', '1', '0', 93, NULL, '0', '0919002', '    ', 9.18, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5125, '3', '1', '0', 94, NULL, '0', '0919002', '    ', 9.18, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5126, '3', '1', '0', 95, NULL, '0', '0919002', '    ', 9.18, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5127, '3', '1', '0', 96, NULL, '0', '0919002', '    ', 9.18, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5128, '3', '1', '0', 97, NULL, '0', '0919002', '    ', 9.18, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5129, '3', '1', '0', 98, NULL, '0', '0919002', '    ', 9.18, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5130, '3', '1', '0', 99, NULL, '0', '0919002', '    ', 9.18, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5131, '3', '1', '0', 18, NULL, '1', '0404704', '  (, ) -', 0, '1', NULL, '2014-04-01', '2014-12-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5132, '3', '1', '0', 19, NULL, '1', '0404704', '  (, ) -', 0, '1', NULL, '2014-04-01', '2014-12-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5133, '3', '1', '0', 20, NULL, '1', '0404704', '  (, ) -', 0, '1', NULL, '2014-04-01', '2014-12-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5134, '3', '1', '0', 21, NULL, '1', '0404704', '  (, ) -', 0, '1', NULL, '2014-04-01', '2014-12-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5135, '3', '1', '0', 22, NULL, '1', '0404704', '  (, ) -', 0, '1', NULL, '2014-04-01', '2014-12-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5136, '3', '1', '0', 23, NULL, '1', '0404704', '  (, ) -', 0, '1', NULL, '2014-04-01', '2014-12-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5137, '3', '1', '0', 24, NULL, '1', '0404704', '  (, ) -', 0, '1', NULL, '2014-04-01', '2014-12-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5138, '3', '1', '0', 25, NULL, '1', '0404704', '  (, ) -', 0, '1', NULL, '2014-04-01', '2014-12-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5139, '3', '1', '0', 26, NULL, '1', '0404704', '  (, ) -', 0, '1', NULL, '2014-04-01', '2014-12-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5140, '3', '1', '0', 27, NULL, '1', '0404704', '  (, ) -', 0, '1', NULL, '2014-04-01', '2014-12-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5141, '3', '1', '0', 28, NULL, '1', '0404704', '  (, ) -', 0, '1', NULL, '2014-04-01', '2014-12-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5142, '3', '1', '0', 29, NULL, '1', '0404704', '  (, ) -', 0, '1', NULL, '2014-04-01', '2014-12-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5143, '3', '1', '0', 30, NULL, '1', '0404704', '  (, ) -', 0, '1', NULL, '2014-04-01', '2014-12-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5144, '3', '1', '0', 31, NULL, '1', '0404704', '  (, ) -', 0, '1', NULL, '2014-04-01', '2014-12-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5145, '3', '1', '0', 32, NULL, '1', '0404704', '  (, ) -', 0, '1', NULL, '2014-04-01', '2014-12-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5146, '3', '1', '0', 33, NULL, '1', '0404704', '  (, ) -', 0, '1', NULL, '2014-04-01', '2014-12-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5147, '3', '1', '0', 34, NULL, '1', '0404704', '  (, ) -', 0, '1', NULL, '2014-04-01', '2014-12-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5148, '3', '1', '0', 35, NULL, '1', '0404704', '  (, ) -', 0, '1', NULL, '2014-04-01', '2014-12-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5149, '3', '1', '0', 36, NULL, '1', '0404704', '  (, ) -', 0, '1', NULL, '2014-04-01', '2014-12-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5150, '3', '1', '0', 37, NULL, '1', '0404704', '  (, ) -', 0, '1', NULL, '2014-04-01', '2014-12-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5151, '3', '1', '0', 38, NULL, '1', '0404704', '  (, ) -', 0, '1', NULL, '2014-04-01', '2014-12-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5152, '3', '1', '0', 39, NULL, '1', '0404704', '  (, ) -', 0, '1', NULL, '2014-04-01', '2014-12-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5153, '3', '1', '0', 40, NULL, '1', '0404704', '  (, ) -', 0, '1', NULL, '2014-04-01', '2014-12-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5154, '3', '1', '0', 41, NULL, '1', '0404704', '  (, ) -', 0, '1', NULL, '2014-04-01', '2014-12-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5155, '3', '1', '0', 42, NULL, '1', '0404704', '  (, ) -', 0, '1', NULL, '2014-04-01', '2014-12-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5156, '3', '1', '0', 43, NULL, '1', '0404704', '  (, ) -', 0, '1', NULL, '2014-04-01', '2014-12-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5157, '3', '1', '0', 44, NULL, '1', '0404704', '  (, ) -', 0, '1', NULL, '2014-04-01', '2014-12-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5158, '3', '1', '0', 45, NULL, '1', '0404704', '  (, ) -', 0, '1', NULL, '2014-04-01', '2014-12-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5159, '3', '1', '0', 46, NULL, '1', '0404704', '  (, ) -', 0, '1', NULL, '2014-04-01', '2014-12-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5160, '3', '1', '0', 47, NULL, '1', '0404704', '  (, ) -', 0, '1', NULL, '2014-04-01', '2014-12-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5161, '3', '1', '0', 48, NULL, '1', '0404704', '  (, ) -', 0, '1', NULL, '2014-04-01', '2014-12-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5162, '3', '1', '0', 49, NULL, '1', '0404704', '  (, ) -', 0, '1', NULL, '2014-04-01', '2014-12-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5163, '3', '1', '0', 50, NULL, '1', '0404704', '  (, ) -', 0, '1', NULL, '2014-04-01', '2014-12-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5164, '3', '1', '0', 51, NULL, '1', '0404704', '  (, ) -', 0, '1', NULL, '2014-04-01', '2014-12-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5165, '3', '1', '0', 52, NULL, '1', '0404704', '  (, ) -', 0, '1', NULL, '2014-04-01', '2014-12-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5166, '3', '1', '0', 53, NULL, '1', '0404704', '  (, ) -', 0, '1', NULL, '2014-04-01', '2014-12-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5167, '3', '1', '0', 54, NULL, '1', '0404704', '  (, ) -', 0, '1', NULL, '2014-04-01', '2014-12-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5168, '3', '1', '0', 55, NULL, '1', '0404704', '  (, ) -', 0, '1', NULL, '2014-04-01', '2014-12-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5169, '3', '1', '0', 56, NULL, '1', '0404704', '  (, ) -', 0, '1', NULL, '2014-04-01', '2014-12-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5170, '3', '1', '0', 57, NULL, '1', '0404704', '  (, ) -', 0, '1', NULL, '2014-04-01', '2014-12-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5171, '3', '1', '0', 58, NULL, '1', '0404704', '  (, ) -', 0, '1', NULL, '2014-04-01', '2014-12-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5172, '3', '1', '0', 59, NULL, '1', '0404704', '  (, ) -', 0, '1', NULL, '2014-04-01', '2014-12-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5173, '3', '1', '0', 60, NULL, '1', '0404704', '  (, ) -', 0, '1', NULL, '2014-04-01', '2014-12-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5174, '3', '1', '0', 61, NULL, '1', '0404704', '  (, ) -', 0, '1', NULL, '2014-04-01', '2014-12-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5175, '3', '1', '0', 62, NULL, '1', '0404704', '  (, ) -', 0, '1', NULL, '2014-04-01', '2014-12-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5176, '3', '1', '0', 63, NULL, '1', '0404704', '  (, ) -', 0, '1', NULL, '2014-04-01', '2014-12-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5177, '3', '1', '0', 64, NULL, '1', '0404704', '  (, ) -', 0, '1', NULL, '2014-04-01', '2014-12-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5178, '3', '1', '0', 65, NULL, '1', '0404704', '  (, ) -', 0, '1', NULL, '2014-04-01', '2014-12-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5179, '3', '1', '0', 66, NULL, '1', '0404704', '  (, ) -', 0, '1', NULL, '2014-04-01', '2014-12-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5180, '3', '1', '0', 67, NULL, '1', '0404704', '  (, ) -', 0, '1', NULL, '2014-04-01', '2014-12-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5181, '3', '1', '0', 68, NULL, '1', '0404704', '  (, ) -', 0, '1', NULL, '2014-04-01', '2014-12-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5182, '3', '1', '0', 69, NULL, '1', '0404704', '  (, ) -', 0, '1', NULL, '2014-04-01', '2014-12-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5183, '3', '1', '0', 70, NULL, '1', '0404704', '  (, ) -', 0, '1', NULL, '2014-04-01', '2014-12-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5184, '3', '1', '0', 71, NULL, '1', '0404704', '  (, ) -', 0, '1', NULL, '2014-04-01', '2014-12-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5185, '3', '1', '0', 72, NULL, '1', '0404704', '  (, ) -', 0, '1', NULL, '2014-04-01', '2014-12-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5186, '3', '1', '0', 73, NULL, '1', '0404704', '  (, ) -', 0, '1', NULL, '2014-04-01', '2014-12-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5187, '3', '1', '0', 74, NULL, '1', '0404704', '  (, ) -', 0, '1', NULL, '2014-04-01', '2014-12-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5188, '3', '1', '0', 75, NULL, '1', '0404704', '  (, ) -', 0, '1', NULL, '2014-04-01', '2014-12-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5189, '3', '1', '0', 76, NULL, '1', '0404704', '  (, ) -', 0, '1', NULL, '2014-04-01', '2014-12-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5190, '3', '1', '0', 77, NULL, '1', '0404704', '  (, ) -', 0, '1', NULL, '2014-04-01', '2014-12-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5191, '3', '1', '0', 78, NULL, '1', '0404704', '  (, ) -', 0, '1', NULL, '2014-04-01', '2014-12-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5192, '3', '1', '0', 79, NULL, '1', '0404704', '  (, ) -', 0, '1', NULL, '2014-04-01', '2014-12-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5193, '3', '1', '0', 80, NULL, '1', '0404704', '  (, ) -', 0, '1', NULL, '2014-04-01', '2014-12-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5194, '3', '1', '0', 81, NULL, '1', '0404704', '  (, ) -', 0, '1', NULL, '2014-04-01', '2014-12-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5195, '3', '1', '0', 82, NULL, '1', '0404704', '  (, ) -', 0, '1', NULL, '2014-04-01', '2014-12-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5196, '3', '1', '0', 83, NULL, '1', '0404704', '  (, ) -', 0, '1', NULL, '2014-04-01', '2014-12-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5197, '3', '1', '0', 84, NULL, '1', '0404704', '  (, ) -', 0, '1', NULL, '2014-04-01', '2014-12-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5198, '3', '1', '0', 85, NULL, '1', '0404704', '  (, ) -', 0, '1', NULL, '2014-04-01', '2014-12-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5199, '3', '1', '0', 86, NULL, '1', '0404704', '  (, ) -', 0, '1', NULL, '2014-04-01', '2014-12-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5200, '3', '1', '0', 87, NULL, '1', '0404704', '  (, ) -', 0, '1', NULL, '2014-04-01', '2014-12-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5201, '3', '1', '0', 88, NULL, '1', '0404704', '  (, ) -', 0, '1', NULL, '2014-04-01', '2014-12-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5202, '3', '1', '0', 89, NULL, '1', '0404704', '  (, ) -', 0, '1', NULL, '2014-04-01', '2014-12-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5203, '3', '1', '0', 90, NULL, '1', '0404704', '  (, ) -', 0, '1', NULL, '2014-04-01', '2014-12-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5204, '3', '1', '0', 91, NULL, '1', '0404704', '  (, ) -', 0, '1', NULL, '2014-04-01', '2014-12-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5205, '3', '1', '0', 92, NULL, '1', '0404704', '  (, ) -', 0, '1', NULL, '2014-04-01', '2014-12-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5206, '3', '1', '0', 93, NULL, '1', '0404704', '  (, ) -', 0, '1', NULL, '2014-04-01', '2014-12-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5207, '3', '1', '0', 94, NULL, '1', '0404704', '  (, ) -', 0, '1', NULL, '2014-04-01', '2014-12-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5208, '3', '1', '0', 95, NULL, '1', '0404704', '  (, ) -', 0, '1', NULL, '2014-04-01', '2014-12-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5209, '3', '1', '0', 96, NULL, '1', '0404704', '  (, ) -', 0, '1', NULL, '2014-04-01', '2014-12-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5210, '3', '1', '0', 97, NULL, '1', '0404704', '  (, ) -', 0, '1', NULL, '2014-04-01', '2014-12-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5211, '3', '1', '0', 98, NULL, '1', '0404704', '  (, ) -', 0, '1', NULL, '2014-04-01', '2014-12-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5212, '3', '1', '0', 99, NULL, '1', '0404704', '  (, ) -', 0, '1', NULL, '2014-04-01', '2014-12-31', '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5213, '3', '1', '2', 39, NULL, '0', '0620006', '', 376.51, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5214, '3', '1', '2', 40, NULL, '0', '0620006', '', 376.51, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5215, '3', '1', '2', 41, NULL, '0', '0620006', '', 376.51, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5216, '3', '1', '2', 42, NULL, '0', '0620006', '', 376.51, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5217, '3', '1', '2', 43, NULL, '0', '0620006', '', 376.51, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5218, '3', '1', '2', 44, NULL, '0', '0620006', '', 376.51, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5219, '3', '1', '2', 45, NULL, '0', '0620006', '', 376.51, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5220, '3', '1', '2', 46, NULL, '0', '0620006', '', 376.51, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5221, '3', '1', '2', 47, NULL, '0', '0620006', '', 376.51, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5222, '3', '1', '2', 48, NULL, '0', '0620006', '', 376.51, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5223, '3', '1', '2', 49, NULL, '0', '0620006', '', 376.51, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5224, '3', '1', '2', 50, NULL, '0', '0620006', '', 376.51, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5225, '3', '1', '2', 51, NULL, '0', '0620006', '', 376.51, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5226, '3', '1', '2', 52, NULL, '0', '0620006', '', 376.51, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5227, '3', '1', '2', 53, NULL, '0', '0620006', '', 376.51, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5228, '3', '1', '2', 54, NULL, '0', '0620006', '', 376.51, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5229, '3', '1', '2', 55, NULL, '0', '0620006', '', 376.51, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5230, '3', '1', '2', 56, NULL, '0', '0620006', '', 376.51, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5231, '3', '1', '2', 57, NULL, '0', '0620006', '', 376.51, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5232, '3', '1', '2', 58, NULL, '0', '0620006', '', 376.51, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5233, '3', '1', '2', 59, NULL, '0', '0620006', '', 376.51, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5234, '3', '1', '2', 60, NULL, '0', '0620006', '', 376.51, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5235, '3', '1', '2', 61, NULL, '0', '0620006', '', 376.51, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5236, '3', '1', '2', 62, NULL, '0', '0620006', '', 376.51, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5237, '3', '1', '2', 63, NULL, '0', '0620006', '', 376.51, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5238, '3', '1', '2', 64, NULL, '0', '0620006', '', 376.51, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5239, '3', '1', '2', 65, NULL, '0', '0620006', '', 376.51, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5240, '3', '1', '2', 66, NULL, '0', '0620006', '', 376.51, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5241, '3', '1', '2', 67, NULL, '0', '0620006', '', 376.51, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5242, '3', '1', '2', 68, NULL, '0', '0620006', '', 376.51, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5243, '3', '1', '2', 69, NULL, '0', '0620006', '', 376.51, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5244, '3', '1', '2', 70, NULL, '0', '0620006', '', 376.51, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5245, '3', '1', '2', 71, NULL, '0', '0620006', '', 376.51, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5246, '3', '1', '2', 72, NULL, '0', '0620006', '', 376.51, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5247, '3', '1', '2', 73, NULL, '0', '0620006', '', 376.51, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5248, '3', '1', '2', 74, NULL, '0', '0620006', '', 376.51, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5249, '3', '1', '2', 75, NULL, '0', '0620006', '', 376.51, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5250, '3', '1', '2', 76, NULL, '0', '0620006', '', 376.51, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5251, '3', '1', '2', 77, NULL, '0', '0620006', '', 376.51, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5252, '3', '1', '2', 78, NULL, '0', '0620006', '', 376.51, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5253, '3', '1', '2', 79, NULL, '0', '0620006', '', 376.51, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5254, '3', '1', '2', 80, NULL, '0', '0620006', '', 376.51, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5255, '3', '1', '2', 81, NULL, '0', '0620006', '', 376.51, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5256, '3', '1', '2', 82, NULL, '0', '0620006', '', 376.51, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5257, '3', '1', '2', 83, NULL, '0', '0620006', '', 376.51, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5258, '3', '1', '2', 84, NULL, '0', '0620006', '', 376.51, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5259, '3', '1', '2', 85, NULL, '0', '0620006', '', 376.51, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5260, '3', '1', '2', 86, NULL, '0', '0620006', '', 376.51, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5261, '3', '1', '2', 87, NULL, '0', '0620006', '', 376.51, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5262, '3', '1', '2', 88, NULL, '0', '0620006', '', 376.51, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5263, '3', '1', '2', 89, NULL, '0', '0620006', '', 376.51, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5264, '3', '1', '2', 90, NULL, '0', '0620006', '', 376.51, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5265, '3', '1', '2', 91, NULL, '0', '0620006', '', 376.51, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5266, '3', '1', '2', 92, NULL, '0', '0620006', '', 376.51, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5267, '3', '1', '2', 93, NULL, '0', '0620006', '', 376.51, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5268, '3', '1', '2', 94, NULL, '0', '0620006', '', 376.51, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5269, '3', '1', '2', 95, NULL, '0', '0620006', '', 376.51, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5270, '3', '1', '2', 96, NULL, '0', '0620006', '', 376.51, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5271, '3', '1', '2', 97, NULL, '0', '0620006', '', 376.51, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5272, '3', '1', '2', 98, NULL, '0', '0620006', '', 376.51, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5273, '3', '1', '2', 99, NULL, '0', '0620006', '', 376.51, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5274, '4', '1', '0', 120, NULL, '0', '0919003', '   ', NULL, '0', NULL, '2014-04-01', '2014-04-30', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5275, '4', '1', '0', 120, NULL, '1', '0919003', '   ', NULL, '0', NULL, '2014-05-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5276, '4', '1', '0', 24, NULL, '0', '0406402', ' (, ) -  ', NULL, '1', 2.5, '2014-04-01', '2014-04-30', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5277, '4', '1', '0', 24, NULL, '1', '0406402', ' (, ) -  ', NULL, '1', 2.5, '2014-05-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5278, '4', '1', '0', 24, NULL, '0', '0301606', '  ', NULL, '0', NULL, '2014-04-01', '2014-04-30', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5279, '4', '1', '0', 24, NULL, '1', '0301606', '  ', NULL, '0', NULL, '2014-05-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5280, '4', '1', '0', 12, NULL, '1', '0403502', ' (, ) - ', NULL, '0', NULL, '2014-04-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5281, '4', '1', '1', 1, NULL, '1', '0421001', '   ', NULL, '0', NULL, '2014-07-01', '2014-07-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5282, '4', '1', '1', 84, NULL, '1', '0421001', '   ', NULL, '0', NULL, '2014-07-01', '2014-07-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5283, '4', '1', '1', 168, NULL, '1', '0421001', '   ', NULL, '0', NULL, '2014-07-01', '2014-07-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5284, '5', '1', '1', 2, NULL, '1', '0421001', '   ', NULL, '0', NULL, '2014-07-01', '2014-07-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5285, '5', '1', '1', 3, NULL, '1', '0421001', '   ', NULL, '0', NULL, '2014-07-01', '2014-07-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5286, '5', '1', '1', 2, NULL, '1', '0421002', '   (, )', NULL, '0', NULL, '2014-07-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5287, '5', '1', '1', 3, NULL, '1', '0421002', '   (, )', NULL, '0', NULL, '2014-07-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5289, '5', '1', '2', 2, NULL, '1', '0420001', '    ', NULL, '0', NULL, '2014-07-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5290, '5', '1', '2', 3, NULL, '1', '0420001', '    ', NULL, '0', NULL, '2014-07-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5291, '5', '1', '2', 2, NULL, '1', '0420002', '  ', NULL, '0', NULL, '2014-07-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5292, '5', '1', '2', 3, NULL, '1', '0420002', '  ', NULL, '0', NULL, '2014-07-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5293, '4', '1', '0', 1, NULL, '1', '03052001', '    ', NULL, '0', NULL, '2014-08-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5294, '4', '1', '0', 84, NULL, '1', '03052001', '    ', NULL, '0', NULL, '2014-08-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5295, '4', '1', '0', 168, NULL, '1', '03052001', '    ', NULL, '0', NULL, '2014-08-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5296, '5', '1', '0', 2, NULL, '1', '03052001', '    ', NULL, '0', NULL, '2014-08-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5297, '5', '1', '0', 3, NULL, '1', '03052001', '    ', NULL, '0', NULL, '2014-08-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5298, '4', '1', '0', 1, NULL, '1', '0410002', '', NULL, '0', NULL, '2014-11-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5299, '4', '1', '0', 84, NULL, '1', '0410002', '', NULL, '0', NULL, '2014-11-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5300, '4', '1', '0', 168, NULL, '1', '0410002', '', NULL, '0', NULL, '2014-11-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5301, '5', '1', '0', 2, NULL, '1', '0410002', '', NULL, '0', NULL, '2014-11-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5302, '5', '1', '0', 3, NULL, '1', '0410002', '', NULL, '0', NULL, '2014-11-01', '2014-12-31', NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5303, '0', '1', '0', 21, NULL, '1', 'A01.31.009', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5304, '0', '1', '0', 24, NULL, '1', 'A01.31.009', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5305, '0', '1', '0', 27, NULL, '1', 'A01.31.009', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5306, '0', '1', '0', 30, NULL, '1', 'A01.31.009', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5307, '0', '1', '0', 33, NULL, '1', 'A01.31.009', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5308, '0', '1', '0', 36, NULL, '1', 'A01.31.009', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5309, '0', '1', '0', 39, NULL, '1', 'A01.31.009', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5310, '0', '1', '0', 42, NULL, '1', 'A01.31.009', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5311, '0', '1', '0', 45, NULL, '1', 'A01.31.009', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5312, '0', '1', '0', 48, NULL, '1', 'A01.31.009', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5313, '0', '1', '0', 51, NULL, '1', 'A01.31.009', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5314, '0', '1', '0', 54, NULL, '1', 'A01.31.009', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5315, '0', '1', '0', 57, NULL, '1', 'A01.31.009', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5316, '0', '1', '0', 60, NULL, '1', 'A01.31.009', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5317, '0', '1', '0', 63, NULL, '1', 'A01.31.009', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5318, '0', '1', '0', 66, NULL, '1', 'A01.31.009', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5319, '0', '1', '0', 69, NULL, '1', 'A01.31.009', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5320, '0', '1', '0', 72, NULL, '1', 'A01.31.009', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5321, '0', '1', '0', 75, NULL, '1', 'A01.31.009', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5322, '0', '1', '0', 78, NULL, '1', 'A01.31.009', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5323, '0', '1', '0', 81, NULL, '1', 'A01.31.009', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5324, '0', '1', '0', 84, NULL, '1', 'A01.31.009', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5325, '0', '1', '0', 87, NULL, '1', 'A01.31.009', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5326, '0', '1', '0', 90, NULL, '1', 'A01.31.009', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5327, '0', '1', '0', 93, NULL, '1', 'A01.31.009', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5328, '0', '1', '0', 96, NULL, '1', 'A01.31.009', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5329, '0', '1', '0', 99, NULL, '1', 'A01.31.009', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5330, '0', '1', '0', 21, NULL, '0', 'A09.05.026', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5331, '0', '1', '0', 24, NULL, '0', 'A09.05.026', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5332, '0', '1', '0', 27, NULL, '0', 'A09.05.026', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5333, '0', '1', '0', 30, NULL, '0', 'A09.05.026', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5334, '0', '1', '0', 33, NULL, '0', 'A09.05.026', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5335, '0', '1', '0', 36, NULL, '0', 'A09.05.026', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5336, '0', '1', '0', 42, NULL, '0', 'A09.05.026', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5337, '0', '1', '0', 48, NULL, '0', 'A09.05.026', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5338, '0', '1', '0', 54, NULL, '0', 'A09.05.026', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5339, '0', '1', '0', 60, NULL, '0', 'A09.05.026', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5340, '0', '1', '0', 66, NULL, '0', 'A09.05.026', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5341, '0', '1', '0', 72, NULL, '0', 'A09.05.026', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5342, '0', '1', '0', 78, NULL, '0', 'A09.05.026', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5343, '0', '1', '0', 84, NULL, '0', 'A09.05.026', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5344, '0', '1', '0', 90, NULL, '0', 'A09.05.026', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5345, '0', '1', '0', 96, NULL, '0', 'A09.05.026', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5346, '0', '1', '0', 21, NULL, '0', 'A09.05.023', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5347, '0', '1', '0', 24, NULL, '0', 'A09.05.023', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5348, '0', '1', '0', 27, NULL, '0', 'A09.05.023', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5349, '0', '1', '0', 30, NULL, '0', 'A09.05.023', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5350, '0', '1', '0', 33, NULL, '0', 'A09.05.023', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5351, '0', '1', '0', 36, NULL, '0', 'A09.05.023', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5352, '0', '1', '0', 42, NULL, '0', 'A09.05.023', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5353, '0', '1', '0', 48, NULL, '0', 'A09.05.023', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5354, '0', '1', '0', 54, NULL, '0', 'A09.05.023', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5355, '0', '1', '0', 60, NULL, '0', 'A09.05.023', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5356, '0', '1', '0', 66, NULL, '0', 'A09.05.023', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5357, '0', '1', '0', 72, NULL, '0', 'A09.05.023', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5358, '0', '1', '0', 78, NULL, '0', 'A09.05.023', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5359, '0', '1', '0', 84, NULL, '0', 'A09.05.023', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5360, '0', '1', '0', 90, NULL, '0', 'A09.05.023', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5361, '0', '1', '0', 96, NULL, '0', 'A09.05.023', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5362, '0', '1', '1', 36, NULL, '0', 'A05.10.006', ' ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5363, '0', '1', '1', 39, NULL, '0', 'A05.10.006', ' ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5364, '0', '1', '1', 42, NULL, '0', 'A05.10.006', ' ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5365, '0', '1', '0', 45, NULL, '0', 'A05.10.006', ' ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5366, '0', '1', '0', 48, NULL, '0', 'A05.10.006', ' ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5367, '0', '1', '0', 51, NULL, '0', 'A05.10.006', ' ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5368, '0', '1', '0', 54, NULL, '0', 'A05.10.006', ' ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5369, '0', '1', '0', 57, NULL, '0', 'A05.10.006', ' ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5370, '0', '1', '0', 60, NULL, '0', 'A05.10.006', ' ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5371, '0', '1', '0', 63, NULL, '0', 'A05.10.006', ' ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5372, '0', '1', '0', 66, NULL, '0', 'A05.10.006', ' ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5373, '0', '1', '0', 69, NULL, '0', 'A05.10.006', ' ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5374, '0', '1', '0', 72, NULL, '0', 'A05.10.006', ' ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5375, '0', '1', '0', 75, NULL, '0', 'A05.10.006', ' ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5376, '0', '1', '0', 78, NULL, '0', 'A05.10.006', ' ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5377, '0', '1', '0', 81, NULL, '0', 'A05.10.006', ' ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5378, '0', '1', '0', 84, NULL, '0', 'A05.10.006', ' ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5379, '0', '1', '0', 87, NULL, '0', 'A05.10.006', ' ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5380, '0', '1', '0', 90, NULL, '0', 'A05.10.006', ' ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5381, '0', '1', '0', 93, NULL, '0', 'A05.10.006', ' ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5382, '0', '1', '0', 96, NULL, '0', 'A05.10.006', ' ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5383, '0', '1', '0', 99, NULL, '0', 'A05.10.006', ' ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5384, '0', '1', '1', 36, NULL, '0', 'A05.10.004', ',     ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5385, '0', '1', '1', 39, NULL, '0', 'A05.10.004', ',     ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5386, '0', '1', '1', 42, NULL, '0', 'A05.10.004', ',     ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5387, '0', '1', '0', 45, NULL, '0', 'A05.10.004', ',     ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5388, '0', '1', '0', 48, NULL, '0', 'A05.10.004', ',     ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5389, '0', '1', '0', 51, NULL, '0', 'A05.10.004', ',     ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5390, '0', '1', '0', 54, NULL, '0', 'A05.10.004', ',     ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5391, '0', '1', '0', 57, NULL, '0', 'A05.10.004', ',     ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5392, '0', '1', '0', 60, NULL, '0', 'A05.10.004', ',     ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5393, '0', '1', '0', 63, NULL, '0', 'A05.10.004', ',     ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5394, '0', '1', '0', 66, NULL, '0', 'A05.10.004', ',     ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5395, '0', '1', '0', 69, NULL, '0', 'A05.10.004', ',     ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5396, '0', '1', '0', 72, NULL, '0', 'A05.10.004', ',     ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5397, '0', '1', '0', 75, NULL, '0', 'A05.10.004', ',     ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5398, '0', '1', '0', 78, NULL, '0', 'A05.10.004', ',     ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5399, '0', '1', '0', 81, NULL, '0', 'A05.10.004', ',     ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5400, '0', '1', '0', 84, NULL, '0', 'A05.10.004', ',     ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5401, '0', '1', '0', 87, NULL, '0', 'A05.10.004', ',     ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5402, '0', '1', '0', 90, NULL, '0', 'A05.10.004', ',     ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5403, '0', '1', '0', 93, NULL, '0', 'A05.10.004', ',     ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5404, '0', '1', '0', 96, NULL, '0', 'A05.10.004', ',     ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5405, '0', '1', '0', 99, NULL, '0', 'A05.10.004', ',     ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5406, '0', '1', '0', 21, NULL, '0', 'A06.09.006', ' ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5407, '0', '1', '0', 24, NULL, '0', 'A06.09.006', ' ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5408, '0', '1', '0', 27, NULL, '0', 'A06.09.006', ' ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5409, '0', '1', '0', 30, NULL, '0', 'A06.09.006', ' ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5410, '0', '1', '0', 33, NULL, '0', 'A06.09.006', ' ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5411, '0', '1', '0', 36, NULL, '0', 'A06.09.006', ' ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5412, '0', '1', '0', 39, NULL, '0', 'A06.09.006', ' ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5413, '0', '1', '0', 42, NULL, '0', 'A06.09.006', ' ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5414, '0', '1', '0', 45, NULL, '0', 'A06.09.006', ' ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5415, '0', '1', '0', 48, NULL, '0', 'A06.09.006', ' ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5416, '0', '1', '0', 51, NULL, '0', 'A06.09.006', ' ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5417, '0', '1', '0', 54, NULL, '0', 'A06.09.006', ' ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5418, '0', '1', '0', 57, NULL, '0', 'A06.09.006', ' ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5419, '0', '1', '0', 60, NULL, '0', 'A06.09.006', ' ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5420, '0', '1', '0', 63, NULL, '0', 'A06.09.006', ' ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5421, '0', '1', '0', 66, NULL, '0', 'A06.09.006', ' ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5422, '0', '1', '0', 69, NULL, '0', 'A06.09.006', ' ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5423, '0', '1', '0', 72, NULL, '0', 'A06.09.006', ' ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5424, '0', '1', '0', 75, NULL, '0', 'A06.09.006', ' ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5425, '0', '1', '0', 78, NULL, '0', 'A06.09.006', ' ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5426, '0', '1', '0', 81, NULL, '0', 'A06.09.006', ' ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5427, '0', '1', '0', 84, NULL, '0', 'A06.09.006', ' ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5428, '0', '1', '0', 87, NULL, '0', 'A06.09.006', ' ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5429, '0', '1', '0', 90, NULL, '0', 'A06.09.006', ' ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5430, '0', '1', '0', 93, NULL, '0', 'A06.09.006', ' ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5431, '0', '1', '0', 96, NULL, '0', 'A06.09.006', ' ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5432, '0', '1', '0', 99, NULL, '0', 'A06.09.006', ' ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5433, '0', '1', '0', 21, NULL, '0', 'B03.016.002', ' ()  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5434, '0', '1', '0', 24, NULL, '0', 'B03.016.002', ' ()  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5435, '0', '1', '0', 27, NULL, '0', 'B03.016.002', ' ()  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5436, '0', '1', '0', 30, NULL, '0', 'B03.016.002', ' ()  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5437, '0', '1', '0', 33, NULL, '0', 'B03.016.002', ' ()  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5438, '0', '1', '0', 36, NULL, '0', 'B03.016.002', ' ()  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5439, '0', '1', '0', 42, NULL, '0', 'B03.016.002', ' ()  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5440, '0', '1', '0', 48, NULL, '0', 'B03.016.002', ' ()  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5441, '0', '1', '0', 54, NULL, '0', 'B03.016.002', ' ()  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5442, '0', '1', '0', 60, NULL, '0', 'B03.016.002', ' ()  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5443, '0', '1', '0', 66, NULL, '0', 'B03.016.002', ' ()  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5444, '0', '1', '0', 72, NULL, '0', 'B03.016.002', ' ()  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5445, '0', '1', '0', 78, NULL, '0', 'B03.016.002', ' ()  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5446, '0', '1', '0', 84, NULL, '0', 'B03.016.002', ' ()  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5447, '0', '1', '0', 90, NULL, '0', 'B03.016.002', ' ()  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5448, '0', '1', '0', 96, NULL, '0', 'B03.016.002', ' ()  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5449, '0', '1', '0', 21, NULL, '0', 'A08.05.004', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5450, '0', '1', '0', 24, NULL, '0', 'A08.05.004', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5451, '0', '1', '0', 27, NULL, '0', 'A08.05.004', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5452, '0', '1', '0', 30, NULL, '0', 'A08.05.004', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5453, '0', '1', '0', 33, NULL, '0', 'A08.05.004', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5454, '0', '1', '0', 36, NULL, '0', 'A08.05.004', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5455, '0', '1', '0', 42, NULL, '0', 'A08.05.004', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5456, '0', '1', '0', 48, NULL, '0', 'A08.05.004', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5457, '0', '1', '0', 54, NULL, '0', 'A08.05.004', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5458, '0', '1', '0', 60, NULL, '0', 'A08.05.004', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5459, '0', '1', '0', 66, NULL, '0', 'A08.05.004', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5460, '0', '1', '0', 72, NULL, '0', 'A08.05.004', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5461, '0', '1', '0', 78, NULL, '0', 'A08.05.004', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5462, '0', '1', '0', 84, NULL, '0', 'A08.05.004', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5463, '0', '1', '0', 90, NULL, '0', 'A08.05.004', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5464, '0', '1', '0', 96, NULL, '0', 'A08.05.004', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5465, '0', '1', '0', 21, NULL, '0', 'A09.05.003', '     ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5466, '0', '1', '0', 24, NULL, '0', 'A09.05.003', '     ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5467, '0', '1', '0', 27, NULL, '0', 'A09.05.003', '     ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5468, '0', '1', '0', 30, NULL, '0', 'A09.05.003', '     ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5469, '0', '1', '0', 33, NULL, '0', 'A09.05.003', '     ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5470, '0', '1', '0', 36, NULL, '0', 'A09.05.003', '     ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5471, '0', '1', '0', 42, NULL, '0', 'A09.05.003', '     ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5472, '0', '1', '0', 48, NULL, '0', 'A09.05.003', '     ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5473, '0', '1', '0', 54, NULL, '0', 'A09.05.003', '     ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5474, '0', '1', '0', 60, NULL, '0', 'A09.05.003', '     ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5475, '0', '1', '0', 66, NULL, '0', 'A09.05.003', '     ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5476, '0', '1', '0', 72, NULL, '0', 'A09.05.003', '     ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5477, '0', '1', '0', 78, NULL, '0', 'A09.05.003', '     ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5478, '0', '1', '0', 84, NULL, '0', 'A09.05.003', '     ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5479, '0', '1', '0', 90, NULL, '0', 'A09.05.003', '     ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5480, '0', '1', '0', 96, NULL, '0', 'A09.05.003', '     ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5481, '0', '1', '0', 21, NULL, '0', 'A12.05.001', '   ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5482, '0', '1', '0', 24, NULL, '0', 'A12.05.001', '   ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5483, '0', '1', '0', 27, NULL, '0', 'A12.05.001', '   ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5484, '0', '1', '0', 30, NULL, '0', 'A12.05.001', '   ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5485, '0', '1', '0', 33, NULL, '0', 'A12.05.001', '   ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5486, '0', '1', '0', 36, NULL, '0', 'A12.05.001', '   ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5487, '0', '1', '0', 42, NULL, '0', 'A12.05.001', '   ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5488, '0', '1', '0', 48, NULL, '0', 'A12.05.001', '   ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5489, '0', '1', '0', 54, NULL, '0', 'A12.05.001', '   ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5490, '0', '1', '0', 60, NULL, '0', 'A12.05.001', '   ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5491, '0', '1', '0', 66, NULL, '0', 'A12.05.001', '   ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5492, '0', '1', '0', 72, NULL, '0', 'A12.05.001', '   ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5493, '0', '1', '0', 78, NULL, '0', 'A12.05.001', '   ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5494, '0', '1', '0', 84, NULL, '0', 'A12.05.001', '   ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5495, '0', '1', '0', 90, NULL, '0', 'A12.05.001', '   ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5496, '0', '1', '0', 96, NULL, '0', 'A12.05.001', '   ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5497, '0', '1', '0', 39, NULL, '0', 'B03.016.003', ' ()   ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5498, '0', '1', '0', 45, NULL, '0', 'B03.016.003', ' ()   ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5499, '0', '1', '0', 51, NULL, '0', 'B03.016.003', ' ()   ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5500, '0', '1', '0', 57, NULL, '0', 'B03.016.003', ' ()   ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5501, '0', '1', '0', 63, NULL, '0', 'B03.016.003', ' ()   ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5502, '0', '1', '0', 69, NULL, '0', 'B03.016.003', ' ()   ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5503, '0', '1', '0', 75, NULL, '0', 'B03.016.003', ' ()   ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5504, '0', '1', '0', 81, NULL, '0', 'B03.016.003', ' ()   ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5505, '0', '1', '0', 87, NULL, '0', 'B03.016.003', ' ()   ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5506, '0', '1', '0', 93, NULL, '0', 'B03.016.003', ' ()   ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5507, '0', '1', '0', 99, NULL, '0', 'B03.016.003', ' ()   ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5508, '0', '1', '0', 39, NULL, '0', 'B03.016.004', '   ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5509, '0', '1', '0', 45, NULL, '0', 'B03.016.004', '   ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5510, '0', '1', '0', 51, NULL, '0', 'B03.016.004', '   ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5511, '0', '1', '0', 57, NULL, '0', 'B03.016.004', '   ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5512, '0', '1', '0', 63, NULL, '0', 'B03.016.004', '   ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5513, '0', '1', '0', 69, NULL, '0', 'B03.016.004', '   ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5514, '0', '1', '0', 75, NULL, '0', 'B03.016.004', '   ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5515, '0', '1', '0', 81, NULL, '0', 'B03.016.004', '   ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5516, '0', '1', '0', 87, NULL, '0', 'B03.016.004', '   ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5517, '0', '1', '0', 93, NULL, '0', 'B03.016.004', '   ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5518, '0', '1', '0', 99, NULL, '0', 'B03.016.004', '   ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5519, '0', '1', '0', 21, NULL, '0', 'B03.016.006', '  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5520, '0', '1', '0', 24, NULL, '0', 'B03.016.006', '  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5521, '0', '1', '0', 27, NULL, '0', 'B03.016.006', '  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5522, '0', '1', '0', 30, NULL, '0', 'B03.016.006', '  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5523, '0', '1', '0', 33, NULL, '0', 'B03.016.006', '  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5524, '0', '1', '0', 36, NULL, '0', 'B03.016.006', '  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5525, '0', '1', '0', 39, NULL, '0', 'B03.016.006', '  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5526, '0', '1', '0', 42, NULL, '0', 'B03.016.006', '  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5527, '0', '1', '0', 45, NULL, '0', 'B03.016.006', '  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5528, '0', '1', '0', 48, NULL, '0', 'B03.016.006', '  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5529, '0', '1', '0', 51, NULL, '0', 'B03.016.006', '  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5530, '0', '1', '0', 54, NULL, '0', 'B03.016.006', '  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5531, '0', '1', '0', 57, NULL, '0', 'B03.016.006', '  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5532, '0', '1', '0', 60, NULL, '0', 'B03.016.006', '  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5533, '0', '1', '0', 63, NULL, '0', 'B03.016.006', '  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5534, '0', '1', '0', 66, NULL, '0', 'B03.016.006', '  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5535, '0', '1', '0', 69, NULL, '0', 'B03.016.006', '  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5536, '0', '1', '0', 72, NULL, '0', 'B03.016.006', '  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5537, '0', '1', '0', 75, NULL, '0', 'B03.016.006', '  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5538, '0', '1', '0', 78, NULL, '0', 'B03.016.006', '  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5539, '0', '1', '0', 81, NULL, '0', 'B03.016.006', '  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5540, '0', '1', '0', 84, NULL, '0', 'B03.016.006', '  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5541, '0', '1', '0', 87, NULL, '0', 'B03.016.006', '  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5542, '0', '1', '0', 90, NULL, '0', 'B03.016.006', '  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5543, '0', '1', '0', 93, NULL, '0', 'B03.016.006', '  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5544, '0', '1', '0', 96, NULL, '0', 'B03.016.006', '  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5545, '0', '1', '0', 99, NULL, '0', 'B03.016.006', '  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5546, '0', '1', '0', 45, NULL, '0', 'A09.19.001', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5547, '0', '1', '0', 48, NULL, '0', 'A09.19.001', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5548, '0', '1', '0', 51, NULL, '0', 'A09.19.001', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5549, '0', '1', '0', 54, NULL, '0', 'A09.19.001', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5550, '0', '1', '0', 57, NULL, '0', 'A09.19.001', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5551, '0', '1', '0', 60, NULL, '0', 'A09.19.001', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5552, '0', '1', '0', 63, NULL, '0', 'A09.19.001', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5553, '0', '1', '0', 66, NULL, '0', 'A09.19.001', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5554, '0', '1', '0', 69, NULL, '0', 'A09.19.001', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5555, '0', '1', '0', 72, NULL, '0', 'A09.19.001', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5556, '0', '1', '0', 75, NULL, '0', 'A09.19.001', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5557, '0', '1', '0', 78, NULL, '0', 'A09.19.001', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5558, '0', '1', '0', 81, NULL, '0', 'A09.19.001', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5559, '0', '1', '0', 84, NULL, '0', 'A09.19.001', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5560, '0', '1', '0', 87, NULL, '0', 'A09.19.001', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5561, '0', '1', '0', 90, NULL, '0', 'A09.19.001', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5562, '0', '1', '0', 93, NULL, '0', 'A09.19.001', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5563, '0', '1', '0', 96, NULL, '0', 'A09.19.001', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5564, '0', '1', '0', 99, NULL, '0', 'A09.19.001', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5565, '0', '1', '1', 51, NULL, '0', 'A09.05.130', '     ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5566, '0', '1', '1', 54, NULL, '0', 'A09.05.130', '     ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5567, '0', '1', '1', 57, NULL, '0', 'A09.05.130', '     ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5568, '0', '1', '1', 60, NULL, '0', 'A09.05.130', '     ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5569, '0', '1', '1', 63, NULL, '0', 'A09.05.130', '     ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5570, '0', '1', '1', 66, NULL, '0', 'A09.05.130', '     ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5571, '0', '1', '1', 69, NULL, '0', 'A09.05.130', '     ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5572, '0', '1', '1', 72, NULL, '0', 'A09.05.130', '     ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5573, '0', '1', '1', 75, NULL, '0', 'A09.05.130', '     ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5574, '0', '1', '1', 78, NULL, '0', 'A09.05.130', '     ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5575, '0', '1', '1', 81, NULL, '0', 'A09.05.130', '     ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5576, '0', '1', '1', 84, NULL, '0', 'A09.05.130', '     ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5577, '0', '1', '1', 87, NULL, '0', 'A09.05.130', '     ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5578, '0', '1', '1', 90, NULL, '0', 'A09.05.130', '     ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5579, '0', '1', '1', 93, NULL, '0', 'A09.05.130', '     ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5580, '0', '1', '1', 96, NULL, '0', 'A09.05.130', '     ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5581, '0', '1', '1', 99, NULL, '0', 'A09.05.130', '     ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5582, '0', '1', '0', 39, NULL, '0', 'A04.14.001', '  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5583, '0', '1', '0', 45, NULL, '0', 'A04.14.001', '  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5584, '0', '1', '0', 51, NULL, '0', 'A04.14.001', '  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5585, '0', '1', '0', 57, NULL, '0', 'A04.14.001', '  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5586, '0', '1', '0', 63, NULL, '0', 'A04.14.001', '  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5587, '0', '1', '0', 69, NULL, '0', 'A04.14.001', '  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5588, '0', '1', '0', 75, NULL, '0', 'A04.14.001', '  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5589, '0', '1', '0', 81, NULL, '0', 'A04.14.001', '  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5590, '0', '1', '0', 87, NULL, '0', 'A04.14.001', '  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5591, '0', '1', '0', 93, NULL, '0', 'A04.14.001', '  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5592, '0', '1', '0', 99, NULL, '0', 'A04.14.001', '  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5593, '0', '1', '0', 39, NULL, '0', 'A04.14.002', '   ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5594, '0', '1', '0', 45, NULL, '0', 'A04.14.002', '   ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5595, '0', '1', '0', 51, NULL, '0', 'A04.14.002', '   ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5596, '0', '1', '0', 57, NULL, '0', 'A04.14.002', '   ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5597, '0', '1', '0', 63, NULL, '0', 'A04.14.002', '   ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5598, '0', '1', '0', 69, NULL, '0', 'A04.14.002', '   ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5599, '0', '1', '0', 75, NULL, '0', 'A04.14.002', '   ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5600, '0', '1', '0', 81, NULL, '0', 'A04.14.002', '   ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5601, '0', '1', '0', 87, NULL, '0', 'A04.14.002', '   ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5602, '0', '1', '0', 93, NULL, '0', 'A04.14.002', '   ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5603, '0', '1', '0', 99, NULL, '0', 'A04.14.002', '   ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5604, '0', '1', '0', 39, NULL, '0', 'A04.15.001', '   ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5605, '0', '1', '0', 45, NULL, '0', 'A04.15.001', '   ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5606, '0', '1', '0', 51, NULL, '0', 'A04.15.001', '   ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5607, '0', '1', '0', 57, NULL, '0', 'A04.15.001', '   ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5608, '0', '1', '0', 63, NULL, '0', 'A04.15.001', '   ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5609, '0', '1', '0', 69, NULL, '0', 'A04.15.001', '   ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5610, '0', '1', '0', 75, NULL, '0', 'A04.15.001', '   ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5611, '0', '1', '0', 81, NULL, '0', 'A04.15.001', '   ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5612, '0', '1', '0', 87, NULL, '0', 'A04.15.001', '   ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5613, '0', '1', '0', 93, NULL, '0', 'A04.15.001', '   ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5614, '0', '1', '0', 99, NULL, '0', 'A04.15.001', '   ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5615, '0', '1', '0', 39, NULL, '0', 'A04.28.002.001', '  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5616, '0', '1', '0', 45, NULL, '0', 'A04.28.002.001', '  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5617, '0', '1', '0', 51, NULL, '0', 'A04.28.002.001', '  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5618, '0', '1', '0', 57, NULL, '0', 'A04.28.002.001', '  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5619, '0', '1', '0', 63, NULL, '0', 'A04.28.002.001', '  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5620, '0', '1', '0', 69, NULL, '0', 'A04.28.002.001', '  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5621, '0', '1', '0', 75, NULL, '0', 'A04.28.002.001', '  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5622, '0', '1', '0', 81, NULL, '0', 'A04.28.002.001', '  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5623, '0', '1', '0', 87, NULL, '0', 'A04.28.002.001', '  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5624, '0', '1', '0', 93, NULL, '0', 'A04.28.002.001', '  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5625, '0', '1', '0', 99, NULL, '0', 'A04.28.002.001', '  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5626, '0', '1', '0', 39, NULL, '0', 'A02.26.015', ' ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5627, '0', '1', '0', 42, NULL, '0', 'A02.26.015', ' ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5628, '0', '1', '0', 45, NULL, '0', 'A02.26.015', ' ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5629, '0', '1', '0', 48, NULL, '0', 'A02.26.015', ' ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5630, '0', '1', '0', 51, NULL, '0', 'A02.26.015', ' ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5631, '0', '1', '0', 54, NULL, '0', 'A02.26.015', ' ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5632, '0', '1', '0', 57, NULL, '0', 'A02.26.015', ' ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5633, '0', '1', '0', 60, NULL, '0', 'A02.26.015', ' ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5634, '0', '1', '0', 63, NULL, '0', 'A02.26.015', ' ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5635, '0', '1', '0', 66, NULL, '0', 'A02.26.015', ' ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5636, '0', '1', '0', 69, NULL, '0', 'A02.26.015', ' ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5637, '0', '1', '0', 72, NULL, '0', 'A02.26.015', ' ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5638, '0', '1', '0', 75, NULL, '0', 'A02.26.015', ' ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5639, '0', '1', '0', 78, NULL, '0', 'A02.26.015', ' ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5640, '0', '1', '0', 81, NULL, '0', 'A02.26.015', ' ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5641, '0', '1', '0', 84, NULL, '0', 'A02.26.015', ' ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5642, '0', '1', '0', 87, NULL, '0', 'A02.26.015', ' ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5643, '0', '1', '0', 90, NULL, '0', 'A02.26.015', ' ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5644, '0', '1', '0', 93, NULL, '0', 'A02.26.015', ' ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5645, '0', '1', '0', 96, NULL, '0', 'A02.26.015', ' ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5646, '0', '1', '0', 99, NULL, '0', 'A02.26.015', ' ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5647, '0', '1', '0', 51, NULL, '0', 'B04.023.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5648, '0', '1', '0', 57, NULL, '0', 'B04.023.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5649, '0', '1', '0', 63, NULL, '0', 'B04.023.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5650, '0', '1', '0', 69, NULL, '0', 'B04.023.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5651, '0', '1', '0', 75, NULL, '0', 'B04.023.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5652, '0', '1', '0', 81, NULL, '0', 'B04.023.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5653, '0', '1', '0', 87, NULL, '0', 'B04.023.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5654, '0', '1', '0', 93, NULL, '0', 'B04.023.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5655, '0', '1', '0', 99, NULL, '0', 'B04.023.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5656, '0', '1', '0', 21, NULL, '1', 'B04.047.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5657, '0', '1', '0', 24, NULL, '1', 'B04.047.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5658, '0', '1', '0', 27, NULL, '1', 'B04.047.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5659, '0', '1', '0', 30, NULL, '1', 'B04.047.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5660, '0', '1', '0', 33, NULL, '1', 'B04.047.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5661, '0', '1', '0', 36, NULL, '1', 'B04.047.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5662, '0', '1', '0', 39, NULL, '1', 'B04.047.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5663, '0', '1', '0', 42, NULL, '1', 'B04.047.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5664, '0', '1', '0', 45, NULL, '1', 'B04.047.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5665, '0', '1', '0', 48, NULL, '1', 'B04.047.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5666, '0', '1', '0', 51, NULL, '1', 'B04.047.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5667, '0', '1', '0', 54, NULL, '1', 'B04.047.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5668, '0', '1', '0', 57, NULL, '1', 'B04.047.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5669, '0', '1', '0', 60, NULL, '1', 'B04.047.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5670, '0', '1', '0', 63, NULL, '1', 'B04.047.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5671, '0', '1', '0', 66, NULL, '1', 'B04.047.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5672, '0', '1', '0', 69, NULL, '1', 'B04.047.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5673, '0', '1', '0', 72, NULL, '1', 'B04.047.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5674, '0', '1', '0', 75, NULL, '1', 'B04.047.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5675, '0', '1', '0', 78, NULL, '1', 'B04.047.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5676, '0', '1', '0', 81, NULL, '1', 'B04.047.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5677, '0', '1', '0', 84, NULL, '1', 'B04.047.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5678, '0', '1', '0', 87, NULL, '1', 'B04.047.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5679, '0', '1', '0', 90, NULL, '1', 'B04.047.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5680, '0', '1', '0', 93, NULL, '1', 'B04.047.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5681, '0', '1', '0', 96, NULL, '1', 'B04.047.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5682, '0', '1', '0', 99, NULL, '1', 'B04.047.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5683, '0', '1', '2', 21, NULL, '0', 'B04.001.002', ' /          ( )', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5684, '0', '1', '2', 24, NULL, '0', 'B04.001.002', ' /          ( )', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5685, '0', '1', '2', 27, NULL, '0', 'B04.001.002', ' /          ( )', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5686, '0', '1', '2', 30, NULL, '0', 'B04.001.002', ' /          ( )', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5687, '0', '1', '2', 33, NULL, '0', 'B04.001.002', ' /          ( )', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5688, '0', '1', '2', 36, NULL, '0', 'B04.001.002', ' /          ( )', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5689, '0', '1', '2', 39, NULL, '0', 'B04.001.002', ' /          ( )', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5690, '0', '1', '2', 42, NULL, '0', 'B04.001.002', ' /          ( )', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5691, '0', '1', '2', 45, NULL, '0', 'B04.001.002', ' /          ( )', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5692, '0', '1', '2', 48, NULL, '0', 'B04.001.002', ' /          ( )', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5693, '0', '1', '2', 51, NULL, '0', 'B04.001.002', ' /          ( )', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5694, '0', '1', '2', 54, NULL, '0', 'B04.001.002', ' /          ( )', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5695, '0', '1', '2', 57, NULL, '0', 'B04.001.002', ' /          ( )', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5696, '0', '1', '2', 60, NULL, '0', 'B04.001.002', ' /          ( )', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5697, '0', '1', '2', 63, NULL, '0', 'B04.001.002', ' /          ( )', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5698, '0', '1', '2', 66, NULL, '0', 'B04.001.002', ' /          ( )', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5699, '0', '1', '2', 69, NULL, '0', 'B04.001.002', ' /          ( )', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5700, '0', '1', '2', 72, NULL, '0', 'B04.001.002', ' /          ( )', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5701, '0', '1', '2', 75, NULL, '0', 'B04.001.002', ' /          ( )', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5702, '0', '1', '2', 78, NULL, '0', 'B04.001.002', ' /          ( )', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5703, '0', '1', '2', 81, NULL, '0', 'B04.001.002', ' /          ( )', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5704, '0', '1', '2', 84, NULL, '0', 'B04.001.002', ' /          ( )', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5705, '0', '1', '2', 87, NULL, '0', 'B04.001.002', ' /          ( )', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5706, '0', '1', '2', 90, NULL, '0', 'B04.001.002', ' /          ( )', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5707, '0', '1', '2', 93, NULL, '0', 'B04.001.002', ' /          ( )', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5708, '0', '1', '2', 96, NULL, '0', 'B04.001.002', ' /          ( )', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5709, '0', '1', '2', 99, NULL, '0', 'B04.001.002', ' /          ( )', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5710, '0', '1', '2', 39, NULL, '0', 'A06.20.004', '', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5711, '0', '1', '2', 42, NULL, '0', 'A06.20.004', '', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5712, '0', '1', '2', 45, NULL, '0', 'A06.20.004', '', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5713, '0', '1', '2', 48, NULL, '0', 'A06.20.004', '', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5714, '0', '1', '2', 51, NULL, '0', 'A06.20.004', '', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5715, '0', '1', '2', 54, NULL, '0', 'A06.20.004', '', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5716, '0', '1', '2', 57, NULL, '0', 'A06.20.004', '', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5717, '0', '1', '2', 60, NULL, '0', 'A06.20.004', '', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5718, '0', '1', '2', 63, NULL, '0', 'A06.20.004', '', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5719, '0', '1', '2', 66, NULL, '0', 'A06.20.004', '', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5720, '0', '1', '2', 69, NULL, '0', 'A06.20.004', '', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5721, '0', '1', '2', 72, NULL, '0', 'A06.20.004', '', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5722, '0', '1', '2', 75, NULL, '0', 'A06.20.004', '', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5723, '0', '1', '2', 78, NULL, '0', 'A06.20.004', '', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5724, '0', '1', '2', 81, NULL, '0', 'A06.20.004', '', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5725, '0', '1', '2', 84, NULL, '0', 'A06.20.004', '', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5726, '0', '1', '2', 87, NULL, '0', 'A06.20.004', '', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5727, '0', '1', '2', 90, NULL, '0', 'A06.20.004', '', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5728, '0', '1', '2', 93, NULL, '0', 'A06.20.004', '', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5729, '0', '1', '2', 96, NULL, '0', 'A06.20.004', '', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5730, '0', '1', '2', 99, NULL, '0', 'A06.20.004', '', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5731, '0', '1', '1', NULL, NULL, '0', 'A05.10.006', ' ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5732, '0', '1', '1', NULL, NULL, '0', 'A05.10.004', ',     ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5733, '0', '2', '0', 21, NULL, '0', 'A04.12.005.002', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5734, '0', '2', '0', 24, NULL, '0', 'A04.12.005.002', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5735, '0', '2', '0', 27, NULL, '0', 'A04.12.005.002', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5736, '0', '2', '0', 30, NULL, '0', 'A04.12.005.002', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5737, '0', '2', '0', 33, NULL, '0', 'A04.12.005.002', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5738, '0', '2', '0', 36, NULL, '0', 'A04.12.005.002', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5739, '0', '2', '0', 39, NULL, '0', 'A04.12.005.002', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5740, '0', '2', '0', 42, NULL, '0', 'A04.12.005.002', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5741, '0', '2', '0', 45, NULL, '0', 'A04.12.005.002', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5742, '0', '2', '0', 48, NULL, '0', 'A04.12.005.002', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5743, '0', '2', '0', 51, NULL, '0', 'A04.12.005.002', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5744, '0', '2', '0', 54, NULL, '0', 'A04.12.005.002', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5745, '0', '2', '0', 57, NULL, '0', 'A04.12.005.002', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5746, '0', '2', '0', 60, NULL, '0', 'A04.12.005.002', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5747, '0', '2', '0', 63, NULL, '0', 'A04.12.005.002', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5748, '0', '2', '0', 66, NULL, '0', 'A04.12.005.002', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5749, '0', '2', '0', 69, NULL, '0', 'A04.12.005.002', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5750, '0', '2', '0', 72, NULL, '0', 'A04.12.005.002', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5751, '0', '2', '0', 75, NULL, '0', 'A04.12.005.002', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5752, '0', '2', '0', 78, NULL, '0', 'A04.12.005.002', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5753, '0', '2', '0', 81, NULL, '0', 'A04.12.005.002', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5754, '0', '2', '0', 84, NULL, '0', 'A04.12.005.002', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5755, '0', '2', '0', 87, NULL, '0', 'A04.12.005.002', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5756, '0', '2', '0', 90, NULL, '0', 'A04.12.005.002', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5757, '0', '2', '0', 93, NULL, '0', 'A04.12.005.002', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5758, '0', '2', '0', 96, NULL, '0', 'A04.12.005.002', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5759, '0', '2', '0', 99, NULL, '0', 'A04.12.005.002', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5760, '0', '2', '0', 51, NULL, '0', 'A03.16.001', '', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5761, '0', '2', '0', 54, NULL, '0', 'A03.16.001', '', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5762, '0', '2', '0', 57, NULL, '0', 'A03.16.001', '', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5763, '0', '2', '0', 60, NULL, '0', 'A03.16.001', '', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5764, '0', '2', '0', 63, NULL, '0', 'A03.16.001', '', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5765, '0', '2', '0', 66, NULL, '0', 'A03.16.001', '', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5766, '0', '2', '0', 69, NULL, '0', 'A03.16.001', '', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5767, '0', '2', '0', 72, NULL, '0', 'A03.16.001', '', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5768, '0', '2', '0', 75, NULL, '0', 'A03.16.001', '', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5769, '0', '2', '0', 78, NULL, '0', 'A03.16.001', '', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5770, '0', '2', '0', 81, NULL, '0', 'A03.16.001', '', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5771, '0', '2', '0', 84, NULL, '0', 'A03.16.001', '', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5772, '0', '2', '0', 87, NULL, '0', 'A03.16.001', '', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5773, '0', '2', '0', 90, NULL, '0', 'A03.16.001', '', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5774, '0', '2', '0', 93, NULL, '0', 'A03.16.001', '', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5775, '0', '2', '0', 96, NULL, '0', 'A03.16.001', '', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5776, '0', '2', '0', 99, NULL, '0', 'A03.16.001', '', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5777, '0', '2', '0', 21, NULL, '0', 'B01.023.001', ' (, ) - ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5778, '0', '2', '0', 24, NULL, '0', 'B01.023.001', ' (, ) - ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5779, '0', '2', '0', 27, NULL, '0', 'B01.023.001', ' (, ) - ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5780, '0', '2', '0', 30, NULL, '0', 'B01.023.001', ' (, ) - ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5781, '0', '2', '0', 33, NULL, '0', 'B01.023.001', ' (, ) - ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5782, '0', '2', '0', 36, NULL, '0', 'B01.023.001', ' (, ) - ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5783, '0', '2', '0', 39, NULL, '0', 'B01.023.001', ' (, ) - ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5784, '0', '2', '0', 42, NULL, '0', 'B01.023.001', ' (, ) - ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5785, '0', '2', '0', 45, NULL, '0', 'B01.023.001', ' (, ) - ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5786, '0', '2', '0', 48, NULL, '0', 'B01.023.001', ' (, ) - ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5787, '0', '2', '0', 51, NULL, '0', 'B01.023.001', ' (, ) - ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5788, '0', '2', '0', 54, NULL, '0', 'B01.023.001', ' (, ) - ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5789, '0', '2', '0', 57, NULL, '0', 'B01.023.001', ' (, ) - ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5790, '0', '2', '0', 60, NULL, '0', 'B01.023.001', ' (, ) - ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5791, '0', '2', '0', 63, NULL, '0', 'B01.023.001', ' (, ) - ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5792, '0', '2', '0', 66, NULL, '0', 'B01.023.001', ' (, ) - ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5793, '0', '2', '0', 69, NULL, '0', 'B01.023.001', ' (, ) - ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5794, '0', '2', '0', 72, NULL, '0', 'B01.023.001', ' (, ) - ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5795, '0', '2', '0', 75, NULL, '0', 'B01.023.001', ' (, ) - ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5796, '0', '2', '0', 78, NULL, '0', 'B01.023.001', ' (, ) - ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5797, '0', '2', '0', 81, NULL, '0', 'B01.023.001', ' (, ) - ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5798, '0', '2', '0', 84, NULL, '0', 'B01.023.001', ' (, ) - ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5799, '0', '2', '0', 87, NULL, '0', 'B01.023.001', ' (, ) - ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5800, '0', '2', '0', 90, NULL, '0', 'B01.023.001', ' (, ) - ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5801, '0', '2', '0', 93, NULL, '0', 'B01.023.001', ' (, ) - ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5802, '0', '2', '0', 96, NULL, '0', 'B01.023.001', ' (, ) - ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5803, '0', '2', '0', 99, NULL, '0', 'B01.023.001', ' (, ) - ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5804, '0', '2', '0', 45, NULL, '0', 'B01.057.001', ' (, ) - ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5805, '0', '2', '0', 48, NULL, '0', 'B01.057.001', ' (, ) - ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5806, '0', '2', '0', 51, NULL, '0', 'B01.057.001', ' (, ) - ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5807, '0', '2', '0', 54, NULL, '0', 'B01.057.001', ' (, ) - ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5808, '0', '2', '0', 57, NULL, '0', 'B01.057.001', ' (, ) - ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5809, '0', '2', '0', 60, NULL, '0', 'B01.057.001', ' (, ) - ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5810, '0', '2', '0', 63, NULL, '0', 'B01.057.001', ' (, ) - ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5811, '0', '2', '0', 66, NULL, '0', 'B01.057.001', ' (, ) - ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5812, '0', '2', '0', 69, NULL, '0', 'B01.057.001', ' (, ) - ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5813, '0', '2', '0', 72, NULL, '0', 'B01.057.001', ' (, ) - ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5814, '0', '2', '0', 75, NULL, '0', 'B01.057.001', ' (, ) - ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5815, '0', '2', '0', 78, NULL, '0', 'B01.057.001', ' (, ) - ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5816, '0', '2', '0', 81, NULL, '0', 'B01.057.001', ' (, ) - ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5817, '0', '2', '0', 84, NULL, '0', 'B01.057.001', ' (, ) - ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5818, '0', '2', '0', 87, NULL, '0', 'B01.057.001', ' (, ) - ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5819, '0', '2', '0', 90, NULL, '0', 'B01.057.001', ' (, ) - ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5820, '0', '2', '0', 93, NULL, '0', 'B01.057.001', ' (, ) - ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5821, '0', '2', '0', 96, NULL, '0', 'B01.057.001', ' (, ) - ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5822, '0', '2', '0', 99, NULL, '0', 'B01.057.001', ' (, ) - ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5823, '0', '2', '0', 45, NULL, '0', 'B01.018.001', ' (, ) - ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5824, '0', '2', '0', 48, NULL, '0', 'B01.018.001', ' (, ) - ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5825, '0', '2', '0', 51, NULL, '0', 'B01.018.001', ' (, ) - ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5826, '0', '2', '0', 54, NULL, '0', 'B01.018.001', ' (, ) - ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5827, '0', '2', '0', 57, NULL, '0', 'B01.018.001', ' (, ) - ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5828, '0', '2', '0', 60, NULL, '0', 'B01.018.001', ' (, ) - ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5829, '0', '2', '0', 63, NULL, '0', 'B01.018.001', ' (, ) - ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5830, '0', '2', '0', 66, NULL, '0', 'B01.018.001', ' (, ) - ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5831, '0', '2', '0', 69, NULL, '0', 'B01.018.001', ' (, ) - ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5832, '0', '2', '0', 72, NULL, '0', 'B01.018.001', ' (, ) - ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5833, '0', '2', '0', 75, NULL, '0', 'B01.018.001', ' (, ) - ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5834, '0', '2', '0', 78, NULL, '0', 'B01.018.001', ' (, ) - ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5835, '0', '2', '0', 81, NULL, '0', 'B01.018.001', ' (, ) - ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5836, '0', '2', '0', 84, NULL, '0', 'B01.018.001', ' (, ) - ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5837, '0', '2', '0', 87, NULL, '0', 'B01.018.001', ' (, ) - ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5838, '0', '2', '0', 90, NULL, '0', 'B01.018.001', ' (, ) - ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5839, '0', '2', '0', 93, NULL, '0', 'B01.018.001', ' (, ) - ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5840, '0', '2', '0', 96, NULL, '0', 'B01.018.001', ' (, ) - ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5841, '0', '2', '0', 99, NULL, '0', 'B01.018.001', ' (, ) - ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5842, '0', '2', '1', 51, NULL, '0', 'B01.053.001', ' (, ) - ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5843, '0', '2', '1', 54, NULL, '0', 'B01.053.001', ' (, ) - ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5844, '0', '2', '1', 57, NULL, '0', 'B01.053.001', ' (, ) - ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5845, '0', '2', '1', 60, NULL, '0', 'B01.053.001', ' (, ) - ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5846, '0', '2', '1', 63, NULL, '0', 'B01.053.001', ' (, ) - ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5847, '0', '2', '1', 66, NULL, '0', 'B01.053.001', ' (, ) - ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5848, '0', '2', '1', 69, NULL, '0', 'B01.053.001', ' (, ) - ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5849, '0', '2', '1', 72, NULL, '0', 'B01.053.001', ' (, ) - ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5850, '0', '2', '1', 75, NULL, '0', 'B01.053.001', ' (, ) - ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5851, '0', '2', '1', 78, NULL, '0', 'B01.053.001', ' (, ) - ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5852, '0', '2', '1', 81, NULL, '0', 'B01.053.001', ' (, ) - ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5853, '0', '2', '1', 84, NULL, '0', 'B01.053.001', ' (, ) - ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5854, '0', '2', '1', 87, NULL, '0', 'B01.053.001', ' (, ) - ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5855, '0', '2', '1', 90, NULL, '0', 'B01.053.001', ' (, ) - ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5856, '0', '2', '1', 93, NULL, '0', 'B01.053.001', ' (, ) - ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5857, '0', '2', '1', 96, NULL, '0', 'B01.053.001', ' (, ) - ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5858, '0', '2', '1', 99, NULL, '0', 'B01.053.001', ' (, ) - ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5859, '0', '2', '0', 45, NULL, '0', 'A03.19.002', '', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5860, '0', '2', '0', 48, NULL, '0', 'A03.19.002', '', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5861, '0', '2', '0', 51, NULL, '0', 'A03.19.002', '', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5862, '0', '2', '0', 54, NULL, '0', 'A03.19.002', '', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5863, '0', '2', '0', 57, NULL, '0', 'A03.19.002', '', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5864, '0', '2', '0', 60, NULL, '0', 'A03.19.002', '', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5865, '0', '2', '0', 63, NULL, '0', 'A03.19.002', '', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5866, '0', '2', '0', 66, NULL, '0', 'A03.19.002', '', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5867, '0', '2', '0', 69, NULL, '0', 'A03.19.002', '', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5868, '0', '2', '0', 72, NULL, '0', 'A03.19.002', '', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5869, '0', '2', '0', 75, NULL, '0', 'A03.19.002', '', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5870, '0', '2', '0', 78, NULL, '0', 'A03.19.002', '', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5871, '0', '2', '0', 81, NULL, '0', 'A03.19.002', '', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5872, '0', '2', '0', 84, NULL, '0', 'A03.19.002', '', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5873, '0', '2', '0', 87, NULL, '0', 'A03.19.002', '', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5874, '0', '2', '0', 90, NULL, '0', 'A03.19.002', '', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5875, '0', '2', '0', 93, NULL, '0', 'A03.19.002', '', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5876, '0', '2', '0', 96, NULL, '0', 'A03.19.002', '', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5877, '0', '2', '0', 99, NULL, '0', 'A03.19.002', '', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5878, '0', '2', '0', 21, NULL, '0', 'A09.05.083', '     ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5879, '0', '2', '0', 24, NULL, '0', 'A09.05.083', '     ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5880, '0', '2', '0', 27, NULL, '0', 'A09.05.083', '     ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5881, '0', '2', '0', 30, NULL, '0', 'A09.05.083', '     ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5882, '0', '2', '0', 33, NULL, '0', 'A09.05.083', '     ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5883, '0', '2', '0', 36, NULL, '0', 'A09.05.083', '     ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5884, '0', '2', '0', 39, NULL, '0', 'A09.05.083', '     ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5885, '0', '2', '0', 42, NULL, '0', 'A09.05.083', '     ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5886, '0', '2', '0', 45, NULL, '0', 'A09.05.083', '     ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5887, '0', '2', '0', 48, NULL, '0', 'A09.05.083', '     ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5888, '0', '2', '0', 51, NULL, '0', 'A09.05.083', '     ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5889, '0', '2', '0', 54, NULL, '0', 'A09.05.083', '     ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5890, '0', '2', '0', 57, NULL, '0', 'A09.05.083', '     ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5891, '0', '2', '0', 60, NULL, '0', 'A09.05.083', '     ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5892, '0', '2', '0', 63, NULL, '0', 'A09.05.083', '     ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5893, '0', '2', '0', 66, NULL, '0', 'A09.05.083', '     ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5894, '0', '2', '0', 69, NULL, '0', 'A09.05.083', '     ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5895, '0', '2', '0', 72, NULL, '0', 'A09.05.083', '     ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5896, '0', '2', '0', 75, NULL, '0', 'A09.05.083', '     ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5897, '0', '2', '0', 78, NULL, '0', 'A09.05.083', '     ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5898, '0', '2', '0', 81, NULL, '0', 'A09.05.083', '     ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5899, '0', '2', '0', 84, NULL, '0', 'A09.05.083', '     ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5900, '0', '2', '0', 87, NULL, '0', 'A09.05.083', '     ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5901, '0', '2', '0', 90, NULL, '0', 'A09.05.083', '     ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5902, '0', '2', '0', 93, NULL, '0', 'A09.05.083', '     ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5903, '0', '2', '0', 96, NULL, '0', 'A09.05.083', '     ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5904, '0', '2', '0', 99, NULL, '0', 'A09.05.083', '     ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5905, '0', '2', '0', 39, NULL, '0', 'B01.029.001', ' (, ) - ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5906, '0', '2', '0', 42, NULL, '0', 'B01.029.001', ' (, ) - ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5907, '0', '2', '0', 45, NULL, '0', 'B01.029.001', ' (, ) - ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5908, '0', '2', '0', 48, NULL, '0', 'B01.029.001', ' (, ) - ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5909, '0', '2', '0', 51, NULL, '0', 'B01.029.001', ' (, ) - ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5910, '0', '2', '0', 54, NULL, '0', 'B01.029.001', ' (, ) - ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5911, '0', '2', '0', 57, NULL, '0', 'B01.029.001', ' (, ) - ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5912, '0', '2', '0', 60, NULL, '0', 'B01.029.001', ' (, ) - ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5913, '0', '2', '0', 63, NULL, '0', 'B01.029.001', ' (, ) - ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5914, '0', '2', '0', 66, NULL, '0', 'B01.029.001', ' (, ) - ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5915, '0', '2', '0', 69, NULL, '0', 'B01.029.001', ' (, ) - ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5916, '0', '2', '0', 72, NULL, '0', 'B01.029.001', ' (, ) - ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5917, '0', '2', '0', 75, NULL, '0', 'B01.029.001', ' (, ) - ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5918, '0', '2', '0', 78, NULL, '0', 'B01.029.001', ' (, ) - ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5919, '0', '2', '0', 81, NULL, '0', 'B01.029.001', ' (, ) - ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5920, '0', '2', '0', 84, NULL, '0', 'B01.029.001', ' (, ) - ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5921, '0', '2', '0', 87, NULL, '0', 'B01.029.001', ' (, ) - ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5922, '0', '2', '0', 90, NULL, '0', 'B01.029.001', ' (, ) - ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5923, '0', '2', '0', 93, NULL, '0', 'B01.029.001', ' (, ) - ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5924, '0', '2', '0', 96, NULL, '0', 'B01.029.001', ' (, ) - ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5925, '0', '2', '0', 99, NULL, '0', 'B01.029.001', ' (, ) - ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5926, '0', '2', '0', 21, NULL, '1', 'B01.047.001', ' (, ) - ', 0, '1', NULL, '2015-01-01', NULL, NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5927, '0', '2', '0', 24, NULL, '1', 'B01.047.001', ' (, ) - ', 0, '1', NULL, '2015-01-01', NULL, NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5928, '0', '2', '0', 27, NULL, '1', 'B01.047.001', ' (, ) - ', 0, '1', NULL, '2015-01-01', NULL, NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5929, '0', '2', '0', 30, NULL, '1', 'B01.047.001', ' (, ) - ', 0, '1', NULL, '2015-01-01', NULL, NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5930, '0', '2', '0', 33, NULL, '1', 'B01.047.001', ' (, ) - ', 0, '1', NULL, '2015-01-01', NULL, NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5931, '0', '2', '0', 36, NULL, '1', 'B01.047.001', ' (, ) - ', 0, '1', NULL, '2015-01-01', NULL, NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5932, '0', '2', '0', 39, NULL, '1', 'B01.047.001', ' (, ) - ', 0, '1', NULL, '2015-01-01', NULL, NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5933, '0', '2', '0', 42, NULL, '1', 'B01.047.001', ' (, ) - ', 0, '1', NULL, '2015-01-01', NULL, NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5934, '0', '2', '0', 45, NULL, '1', 'B01.047.001', ' (, ) - ', 0, '1', NULL, '2015-01-01', NULL, NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5935, '0', '2', '0', 48, NULL, '1', 'B01.047.001', ' (, ) - ', 0, '1', NULL, '2015-01-01', NULL, NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5936, '0', '2', '0', 51, NULL, '1', 'B01.047.001', ' (, ) - ', 0, '1', NULL, '2015-01-01', NULL, NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5937, '0', '2', '0', 54, NULL, '1', 'B01.047.001', ' (, ) - ', 0, '1', NULL, '2015-01-01', NULL, NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5938, '0', '2', '0', 57, NULL, '1', 'B01.047.001', ' (, ) - ', 0, '1', NULL, '2015-01-01', NULL, NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5939, '0', '2', '0', 60, NULL, '1', 'B01.047.001', ' (, ) - ', 0, '1', NULL, '2015-01-01', NULL, NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5940, '0', '2', '0', 63, NULL, '1', 'B01.047.001', ' (, ) - ', 0, '1', NULL, '2015-01-01', NULL, NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5941, '0', '2', '0', 66, NULL, '1', 'B01.047.001', ' (, ) - ', 0, '1', NULL, '2015-01-01', NULL, NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5942, '0', '2', '0', 69, NULL, '1', 'B01.047.001', ' (, ) - ', 0, '1', NULL, '2015-01-01', NULL, NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5943, '0', '2', '0', 72, NULL, '1', 'B01.047.001', ' (, ) - ', 0, '1', NULL, '2015-01-01', NULL, NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5944, '0', '2', '0', 75, NULL, '1', 'B01.047.001', ' (, ) - ', 0, '1', NULL, '2015-01-01', NULL, NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5945, '0', '2', '0', 78, NULL, '1', 'B01.047.001', ' (, ) - ', 0, '1', NULL, '2015-01-01', NULL, NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5946, '0', '2', '0', 81, NULL, '1', 'B01.047.001', ' (, ) - ', 0, '1', NULL, '2015-01-01', NULL, NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5947, '0', '2', '0', 84, NULL, '1', 'B01.047.001', ' (, ) - ', 0, '1', NULL, '2015-01-01', NULL, NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5948, '0', '2', '0', 87, NULL, '1', 'B01.047.001', ' (, ) - ', 0, '1', NULL, '2015-01-01', NULL, NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5949, '0', '2', '0', 90, NULL, '1', 'B01.047.001', ' (, ) - ', 0, '1', NULL, '2015-01-01', NULL, NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5950, '0', '2', '0', 93, NULL, '1', 'B01.047.001', ' (, ) - ', 0, '1', NULL, '2015-01-01', NULL, NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5951, '0', '2', '0', 96, NULL, '1', 'B01.047.001', ' (, ) - ', 0, '1', NULL, '2015-01-01', NULL, NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5952, '0', '2', '0', 99, NULL, '1', 'B01.047.001', ' (, ) - ', 0, '1', NULL, '2015-01-01', NULL, NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5953, '0', '2', '0', 21, NULL, '0', 'A09.05.027', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5954, '0', '2', '0', 24, NULL, '0', 'A09.05.027', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5955, '0', '2', '0', 27, NULL, '0', 'A09.05.027', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5956, '0', '2', '0', 30, NULL, '0', 'A09.05.027', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5957, '0', '2', '0', 33, NULL, '0', 'A09.05.027', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5958, '0', '2', '0', 36, NULL, '0', 'A09.05.027', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5959, '0', '2', '0', 39, NULL, '0', 'A09.05.027', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5960, '0', '2', '0', 42, NULL, '0', 'A09.05.027', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5961, '0', '2', '0', 45, NULL, '0', 'A09.05.027', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5962, '0', '2', '0', 48, NULL, '0', 'A09.05.027', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5963, '0', '2', '0', 51, NULL, '0', 'A09.05.027', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5964, '0', '2', '0', 54, NULL, '0', 'A09.05.027', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5965, '0', '2', '0', 57, NULL, '0', 'A09.05.027', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5966, '0', '2', '0', 60, NULL, '0', 'A09.05.027', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5967, '0', '2', '0', 63, NULL, '0', 'A09.05.027', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5968, '0', '2', '0', 66, NULL, '0', 'A09.05.027', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5969, '0', '2', '0', 69, NULL, '0', 'A09.05.027', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5970, '0', '2', '0', 72, NULL, '0', 'A09.05.027', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5971, '0', '2', '0', 75, NULL, '0', 'A09.05.027', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5972, '0', '2', '0', 78, NULL, '0', 'A09.05.027', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5973, '0', '2', '0', 81, NULL, '0', 'A09.05.027', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5974, '0', '2', '0', 84, NULL, '0', 'A09.05.027', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5975, '0', '2', '0', 87, NULL, '0', 'A09.05.027', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5976, '0', '2', '0', 90, NULL, '0', 'A09.05.027', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5977, '0', '2', '0', 93, NULL, '0', 'A09.05.027', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5978, '0', '2', '0', 96, NULL, '0', 'A09.05.027', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5979, '0', '2', '0', 99, NULL, '0', 'A09.05.027', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5980, '0', '2', '0', 21, NULL, '0', 'A09.05.028', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5981, '0', '2', '0', 24, NULL, '0', 'A09.05.028', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5982, '0', '2', '0', 27, NULL, '0', 'A09.05.028', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5983, '0', '2', '0', 30, NULL, '0', 'A09.05.028', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5984, '0', '2', '0', 33, NULL, '0', 'A09.05.028', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5985, '0', '2', '0', 36, NULL, '0', 'A09.05.028', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5986, '0', '2', '0', 39, NULL, '0', 'A09.05.028', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5987, '0', '2', '0', 42, NULL, '0', 'A09.05.028', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5988, '0', '2', '0', 45, NULL, '0', 'A09.05.028', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5989, '0', '2', '0', 48, NULL, '0', 'A09.05.028', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5990, '0', '2', '0', 51, NULL, '0', 'A09.05.028', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5991, '0', '2', '0', 54, NULL, '0', 'A09.05.028', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5992, '0', '2', '0', 57, NULL, '0', 'A09.05.028', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5993, '0', '2', '0', 60, NULL, '0', 'A09.05.028', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5994, '0', '2', '0', 63, NULL, '0', 'A09.05.028', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5995, '0', '2', '0', 66, NULL, '0', 'A09.05.028', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5996, '0', '2', '0', 69, NULL, '0', 'A09.05.028', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5997, '0', '2', '0', 72, NULL, '0', 'A09.05.028', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5998, '0', '2', '0', 75, NULL, '0', 'A09.05.028', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (5999, '0', '2', '0', 78, NULL, '0', 'A09.05.028', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6000, '0', '2', '0', 81, NULL, '0', 'A09.05.028', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6001, '0', '2', '0', 84, NULL, '0', 'A09.05.028', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6002, '0', '2', '0', 87, NULL, '0', 'A09.05.028', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6003, '0', '2', '0', 90, NULL, '0', 'A09.05.028', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6004, '0', '2', '0', 93, NULL, '0', 'A09.05.028', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
COMMIT WORK; @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6005, '0', '2', '0', 96, NULL, '0', 'A09.05.028', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6006, '0', '2', '0', 99, NULL, '0', 'A09.05.028', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6007, '0', '2', '0', 21, NULL, '0', 'A09.05.025', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6008, '0', '2', '0', 24, NULL, '0', 'A09.05.025', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6009, '0', '2', '0', 27, NULL, '0', 'A09.05.025', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6010, '0', '2', '0', 30, NULL, '0', 'A09.05.025', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6011, '0', '2', '0', 33, NULL, '0', 'A09.05.025', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6012, '0', '2', '0', 36, NULL, '0', 'A09.05.025', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6013, '0', '2', '0', 39, NULL, '0', 'A09.05.025', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6014, '0', '2', '0', 42, NULL, '0', 'A09.05.025', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6015, '0', '2', '0', 45, NULL, '0', 'A09.05.025', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6016, '0', '2', '0', 48, NULL, '0', 'A09.05.025', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6017, '0', '2', '0', 51, NULL, '0', 'A09.05.025', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6018, '0', '2', '0', 54, NULL, '0', 'A09.05.025', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6019, '0', '2', '0', 57, NULL, '0', 'A09.05.025', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6020, '0', '2', '0', 60, NULL, '0', 'A09.05.025', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6021, '0', '2', '0', 63, NULL, '0', 'A09.05.025', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6022, '0', '2', '0', 66, NULL, '0', 'A09.05.025', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6023, '0', '2', '0', 69, NULL, '0', 'A09.05.025', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6024, '0', '2', '0', 72, NULL, '0', 'A09.05.025', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6025, '0', '2', '0', 75, NULL, '0', 'A09.05.025', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6026, '0', '2', '0', 78, NULL, '0', 'A09.05.025', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6027, '0', '2', '0', 81, NULL, '0', 'A09.05.025', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6028, '0', '2', '0', 84, NULL, '0', 'A09.05.025', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6029, '0', '2', '0', 87, NULL, '0', 'A09.05.025', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6030, '0', '2', '0', 90, NULL, '0', 'A09.05.025', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6031, '0', '2', '0', 93, NULL, '0', 'A09.05.025', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6032, '0', '2', '0', 96, NULL, '0', 'A09.05.025', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6033, '0', '2', '0', 99, NULL, '0', 'A09.05.025', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6034, '0', '2', '0', 21, NULL, '0', 'B01.069.004', ' (, )     ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6035, '0', '2', '0', 24, NULL, '0', 'B01.069.004', ' (, )     ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6036, '0', '2', '0', 27, NULL, '0', 'B01.069.004', ' (, )     ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6037, '0', '2', '0', 30, NULL, '0', 'B01.069.004', ' (, )     ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6038, '0', '2', '0', 33, NULL, '0', 'B01.069.004', ' (, )     ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6039, '0', '2', '0', 36, NULL, '0', 'B01.069.004', ' (, )     ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6040, '0', '2', '0', 39, NULL, '0', 'B01.069.004', ' (, )     ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6041, '0', '2', '0', 42, NULL, '0', 'B01.069.004', ' (, )     ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6042, '0', '2', '0', 45, NULL, '0', 'B01.069.004', ' (, )     ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6043, '0', '2', '0', 48, NULL, '0', 'B01.069.004', ' (, )     ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6044, '0', '2', '0', 51, NULL, '0', 'B01.069.004', ' (, )     ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6045, '0', '2', '0', 54, NULL, '0', 'B01.069.004', ' (, )     ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6046, '0', '2', '0', 57, NULL, '0', 'B01.069.004', ' (, )     ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6047, '0', '2', '0', 60, NULL, '0', 'B01.069.004', ' (, )     ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6048, '0', '2', '0', 63, NULL, '0', 'B01.069.004', ' (, )     ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6049, '0', '2', '0', 66, NULL, '0', 'B01.069.004', ' (, )     ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6050, '0', '2', '0', 69, NULL, '0', 'B01.069.004', ' (, )     ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6051, '0', '2', '0', 72, NULL, '0', 'B01.069.004', ' (, )     ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6052, '0', '2', '0', 75, NULL, '0', 'B01.069.004', ' (, )     ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6053, '0', '2', '0', 78, NULL, '0', 'B01.069.004', ' (, )     ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6054, '0', '2', '0', 81, NULL, '0', 'B01.069.004', ' (, )     ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6055, '0', '2', '0', 84, NULL, '0', 'B01.069.004', ' (, )     ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6056, '0', '2', '0', 87, NULL, '0', 'B01.069.004', ' (, )     ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6057, '0', '2', '0', 90, NULL, '0', 'B01.069.004', ' (, )     ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6058, '0', '2', '0', 93, NULL, '0', 'B01.069.004', ' (, )     ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6059, '0', '2', '0', 96, NULL, '0', 'B01.069.004', ' (, )     ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6060, '0', '2', '0', 99, NULL, '0', 'B01.069.004', ' (, )     ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6061, '0', '2', '2', 21, NULL, '0', 'B01.001.001', ' (, ) -- ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6062, '0', '2', '2', 24, NULL, '0', 'B01.001.001', ' (, ) -- ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6063, '0', '2', '2', 27, NULL, '0', 'B01.001.001', ' (, ) -- ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6064, '0', '2', '2', 30, NULL, '0', 'B01.001.001', ' (, ) -- ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6065, '0', '2', '2', 33, NULL, '0', 'B01.001.001', ' (, ) -- ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6066, '0', '2', '2', 36, NULL, '0', 'B01.001.001', ' (, ) -- ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6067, '0', '2', '2', 39, NULL, '0', 'B01.001.001', ' (, ) -- ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6068, '0', '2', '2', 42, NULL, '0', 'B01.001.001', ' (, ) -- ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6069, '0', '2', '2', 45, NULL, '0', 'B01.001.001', ' (, ) -- ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6070, '0', '2', '2', 48, NULL, '0', 'B01.001.001', ' (, ) -- ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6071, '0', '2', '2', 51, NULL, '0', 'B01.001.001', ' (, ) -- ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6072, '0', '2', '2', 54, NULL, '0', 'B01.001.001', ' (, ) -- ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6073, '0', '2', '2', 57, NULL, '0', 'B01.001.001', ' (, ) -- ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6074, '0', '2', '2', 60, NULL, '0', 'B01.001.001', ' (, ) -- ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6075, '0', '2', '2', 63, NULL, '0', 'B01.001.001', ' (, ) -- ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6076, '0', '2', '2', 66, NULL, '0', 'B01.001.001', ' (, ) -- ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6077, '0', '2', '2', 69, NULL, '0', 'B01.001.001', ' (, ) -- ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6078, '0', '2', '2', 72, NULL, '0', 'B01.001.001', ' (, ) -- ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6079, '0', '2', '2', 75, NULL, '0', 'B01.001.001', ' (, ) -- ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6080, '0', '2', '2', 78, NULL, '0', 'B01.001.001', ' (, ) -- ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6081, '0', '2', '2', 81, NULL, '0', 'B01.001.001', ' (, ) -- ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6082, '0', '2', '2', 84, NULL, '0', 'B01.001.001', ' (, ) -- ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6083, '0', '2', '2', 87, NULL, '0', 'B01.001.001', ' (, ) -- ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6084, '0', '2', '2', 90, NULL, '0', 'B01.001.001', ' (, ) -- ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6085, '0', '2', '2', 93, NULL, '0', 'B01.001.001', ' (, ) -- ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6086, '0', '2', '2', 96, NULL, '0', 'B01.001.001', ' (, ) -- ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6087, '0', '2', '2', 99, NULL, '0', 'B01.001.001', ' (, ) -- ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6088, '0', '1', '2', NULL, NULL, '0', 'A05.10.006', ' ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6089, '0', '1', '2', NULL, NULL, '0', 'A05.10.004', ',     ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6090, '1', '1', '0', 0, NULL, '1', 'B03.016.002', ' ()  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6091, '1', '1', '0', 1, NULL, '1', 'B03.016.002', ' ()  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6092, '1', '1', '0', 2, NULL, '1', 'B03.016.002', ' ()  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6093, '1', '1', '0', 3, NULL, '1', 'B03.016.002', ' ()  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6094, '1', '1', '0', 4, NULL, '1', 'B03.016.002', ' ()  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6095, '1', '1', '0', 5, NULL, '1', 'B03.016.002', ' ()  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6096, '1', '1', '0', 6, NULL, '1', 'B03.016.002', ' ()  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6097, '1', '1', '0', 7, NULL, '1', 'B03.016.002', ' ()  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6098, '1', '1', '0', 8, NULL, '1', 'B03.016.002', ' ()  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6099, '1', '1', '0', 9, NULL, '1', 'B03.016.002', ' ()  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6100, '1', '1', '0', 10, NULL, '1', 'B03.016.002', ' ()  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6101, '1', '1', '0', 11, NULL, '1', 'B03.016.002', ' ()  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6102, '1', '1', '0', 12, NULL, '1', 'B03.016.002', ' ()  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6103, '1', '1', '0', 13, NULL, '1', 'B03.016.002', ' ()  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6104, '1', '1', '0', 14, NULL, '1', 'B03.016.002', ' ()  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6105, '1', '1', '0', 15, NULL, '1', 'B03.016.002', ' ()  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6106, '1', '1', '0', 16, NULL, '1', 'B03.016.002', ' ()  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6107, '1', '1', '0', 17, NULL, '1', 'B03.016.002', ' ()  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6108, '1', '1', '0', 0, NULL, '1', 'B03.016.006', '  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6109, '1', '1', '0', 1, NULL, '1', 'B03.016.006', '  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6110, '1', '1', '0', 2, NULL, '1', 'B03.016.006', '  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6111, '1', '1', '0', 3, NULL, '1', 'B03.016.006', '  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6112, '1', '1', '0', 4, NULL, '1', 'B03.016.006', '  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6113, '1', '1', '0', 5, NULL, '1', 'B03.016.006', '  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6114, '1', '1', '0', 6, NULL, '1', 'B03.016.006', '  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6115, '1', '1', '0', 7, NULL, '1', 'B03.016.006', '  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6116, '1', '1', '0', 8, NULL, '1', 'B03.016.006', '  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6117, '1', '1', '0', 9, NULL, '1', 'B03.016.006', '  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6118, '1', '1', '0', 10, NULL, '1', 'B03.016.006', '  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6119, '1', '1', '0', 11, NULL, '1', 'B03.016.006', '  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6120, '1', '1', '0', 12, NULL, '1', 'B03.016.006', '  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6121, '1', '1', '0', 13, NULL, '1', 'B03.016.006', '  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6122, '1', '1', '0', 14, NULL, '1', 'B03.016.006', '  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6123, '1', '1', '0', 15, NULL, '1', 'B03.016.006', '  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6124, '1', '1', '0', 16, NULL, '1', 'B03.016.006', '  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6125, '1', '1', '0', 17, NULL, '1', 'B03.016.006', '  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6126, '1', '1', '0', 0, NULL, '1', 'A05.10.006', ' ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6127, '1', '1', '0', 1, NULL, '1', 'A05.10.006', ' ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6128, '1', '1', '0', 2, NULL, '1', 'A05.10.006', ' ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6129, '1', '1', '0', 3, NULL, '1', 'A05.10.006', ' ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6130, '1', '1', '0', 4, NULL, '1', 'A05.10.006', ' ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6131, '1', '1', '0', 6, NULL, '1', 'A05.10.006', ' ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6132, '1', '1', '0', 7, NULL, '1', 'A05.10.006', ' ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6133, '1', '1', '0', 8, NULL, '1', 'A05.10.006', ' ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6134, '1', '1', '0', 9, NULL, '1', 'A05.10.006', ' ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6135, '1', '1', '0', 10, NULL, '1', 'A05.10.006', ' ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6136, '1', '1', '0', 11, NULL, '1', 'A05.10.006', ' ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6137, '1', '1', '0', 12, NULL, '1', 'A05.10.006', ' ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6138, '1', '1', '0', 13, NULL, '1', 'A05.10.006', ' ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6139, '1', '1', '0', 14, NULL, '1', 'A05.10.006', ' ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6140, '1', '1', '0', 15, NULL, '1', 'A05.10.006', ' ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6141, '1', '1', '0', 16, NULL, '1', 'A05.10.006', ' ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6142, '1', '1', '0', 17, NULL, '1', 'A05.10.006', ' ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6143, '1', '1', '0', 0, NULL, '1', 'A04.04.001', '  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6144, '1', '1', '0', 0, NULL, '1', 'A04.28.002.001', '  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6145, '1', '1', '0', 1, NULL, '1', 'A04.28.002.001', '  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6146, '1', '1', '0', 2, NULL, '1', 'A04.28.002.001', '  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6147, '1', '1', '0', 3, NULL, '1', 'A04.28.002.001', '  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6148, '1', '1', '0', 4, NULL, '1', 'A04.28.002.001', '  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6149, '1', '1', '0', 5, NULL, '1', 'A04.28.002.001', '  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6150, '1', '1', '0', 6, NULL, '1', 'A04.28.002.001', '  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6151, '1', '1', '0', 7, NULL, '1', 'A04.28.002.001', '  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6152, '1', '1', '0', 8, NULL, '1', 'A04.28.002.001', '  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6153, '1', '1', '0', 9, NULL, '1', 'A04.28.002.001', '  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6154, '1', '1', '0', 10, NULL, '1', 'A04.28.002.001', '  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6155, '1', '1', '0', 11, NULL, '1', 'A04.28.002.001', '  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6156, '1', '1', '0', 12, NULL, '1', 'A04.28.002.001', '  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6157, '1', '1', '0', 13, NULL, '1', 'A04.28.002.001', '  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6158, '1', '1', '0', 14, NULL, '1', 'A04.28.002.001', '  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6159, '1', '1', '0', 15, NULL, '1', 'A04.28.002.001', '  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6160, '1', '1', '0', 16, NULL, '1', 'A04.28.002.001', '  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6161, '1', '1', '0', 17, NULL, '1', 'A04.28.002.001', '  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6162, '1', '1', '0', 0, NULL, '1', 'A04.16.001', '     ()', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6163, '1', '1', '0', 1, NULL, '1', 'A04.16.001', '     ()', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6164, '1', '1', '0', 2, NULL, '1', 'A04.16.001', '     ()', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6165, '1', '1', '0', 3, NULL, '1', 'A04.16.001', '     ()', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6166, '1', '1', '0', 4, NULL, '1', 'A04.16.001', '     ()', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6167, '1', '1', '0', 5, NULL, '1', 'A04.16.001', '     ()', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6168, '1', '1', '0', 6, NULL, '1', 'A04.16.001', '     ()', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6169, '1', '1', '0', 7, NULL, '1', 'A04.16.001', '     ()', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6170, '1', '1', '0', 8, NULL, '1', 'A04.16.001', '     ()', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6171, '1', '1', '0', 9, NULL, '1', 'A04.16.001', '     ()', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6172, '1', '1', '0', 10, NULL, '1', 'A04.16.001', '     ()', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6173, '1', '1', '0', 11, NULL, '1', 'A04.16.001', '     ()', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6174, '1', '1', '0', 12, NULL, '1', 'A04.16.001', '     ()', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6175, '1', '1', '0', 13, NULL, '1', 'A04.16.001', '     ()', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6176, '1', '1', '0', 14, NULL, '1', 'A04.16.001', '     ()', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6177, '1', '1', '0', 15, NULL, '1', 'A04.16.001', '     ()', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6178, '1', '1', '0', 16, NULL, '1', 'A04.16.001', '     ()', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6179, '1', '1', '0', 17, NULL, '1', 'A04.16.001', '     ()', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6180, '1', '1', '0', 0, NULL, '1', 'A04.10.002', '', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6181, '1', '1', '0', 1, NULL, '1', 'A04.10.002', '', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6182, '1', '1', '0', 2, NULL, '1', 'A04.10.002', '', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6183, '1', '1', '0', 3, NULL, '1', 'A04.10.002', '', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6184, '1', '1', '0', 4, NULL, '1', 'A04.10.002', '', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6185, '1', '1', '0', 5, NULL, '1', 'A04.10.002', '', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6186, '1', '1', '0', 6, NULL, '1', 'A04.10.002', '', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6187, '1', '1', '0', 7, NULL, '1', 'A04.10.002', '', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6188, '1', '1', '0', 8, NULL, '1', 'A04.10.002', '', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6189, '1', '1', '0', 9, NULL, '1', 'A04.10.002', '', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6190, '1', '1', '0', 10, NULL, '1', 'A04.10.002', '', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6191, '1', '1', '0', 11, NULL, '1', 'A04.10.002', '', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6192, '1', '1', '0', 12, NULL, '1', 'A04.10.002', '', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6193, '1', '1', '0', 13, NULL, '1', 'A04.10.002', '', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6194, '1', '1', '0', 14, NULL, '1', 'A04.10.002', '', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6195, '1', '1', '0', 15, NULL, '1', 'A04.10.002', '', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6196, '1', '1', '0', 16, NULL, '1', 'A04.10.002', '', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6197, '1', '1', '0', 17, NULL, '1', 'A04.10.002', '', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6198, '1', '1', '0', 0, NULL, '1', 'B04.031.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6199, '1', '1', '0', 1, NULL, '1', 'B04.031.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6200, '1', '1', '0', 2, NULL, '1', 'B04.031.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6201, '1', '1', '0', 3, NULL, '1', 'B04.031.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6202, '1', '1', '0', 4, NULL, '1', 'B04.031.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6203, '1', '1', '0', 5, NULL, '1', 'B04.031.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6204, '1', '1', '0', 6, NULL, '1', 'B04.031.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6205, '1', '1', '0', 7, NULL, '1', 'B04.031.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6206, '1', '1', '0', 8, NULL, '1', 'B04.031.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6207, '1', '1', '0', 9, NULL, '1', 'B04.031.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6208, '1', '1', '0', 10, NULL, '1', 'B04.031.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6209, '1', '1', '0', 11, NULL, '1', 'B04.031.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6210, '1', '1', '0', 12, NULL, '1', 'B04.031.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6211, '1', '1', '0', 13, NULL, '1', 'B04.031.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6212, '1', '1', '0', 14, NULL, '1', 'B04.031.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6213, '1', '1', '0', 15, NULL, '1', 'B04.031.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6214, '1', '1', '0', 16, NULL, '1', 'B04.031.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6215, '1', '1', '0', 17, NULL, '1', 'B04.031.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6216, '1', '1', '0', 0, NULL, '1', 'B04.023.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6217, '1', '1', '0', 1, NULL, '1', 'B04.023.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6218, '1', '1', '0', 2, NULL, '1', 'B04.023.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6219, '1', '1', '0', 3, NULL, '1', 'B04.023.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6220, '1', '1', '0', 4, NULL, '1', 'B04.023.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6221, '1', '1', '0', 5, NULL, '1', 'B04.023.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6222, '1', '1', '0', 6, NULL, '1', 'B04.023.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6223, '1', '1', '0', 7, NULL, '1', 'B04.023.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6224, '1', '1', '0', 8, NULL, '1', 'B04.023.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6225, '1', '1', '0', 9, NULL, '1', 'B04.023.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6226, '1', '1', '0', 10, NULL, '1', 'B04.023.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6227, '1', '1', '0', 11, NULL, '1', 'B04.023.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6228, '1', '1', '0', 12, NULL, '1', 'B04.023.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6229, '1', '1', '0', 13, NULL, '1', 'B04.023.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6230, '1', '1', '0', 14, NULL, '1', 'B04.023.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6231, '1', '1', '0', 15, NULL, '1', 'B04.023.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6232, '1', '1', '0', 16, NULL, '1', 'B04.023.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6233, '1', '1', '0', 17, NULL, '1', 'B04.023.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6234, '1', '1', '0', 0, NULL, '1', 'B04.029.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6235, '1', '1', '0', 1, NULL, '1', 'B04.029.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6236, '1', '1', '0', 2, NULL, '1', 'B04.029.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6237, '1', '1', '0', 3, NULL, '1', 'B04.029.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6238, '1', '1', '0', 4, NULL, '1', 'B04.029.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6239, '1', '1', '0', 5, NULL, '1', 'B04.029.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6240, '1', '1', '0', 6, NULL, '1', 'B04.029.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6241, '1', '1', '0', 7, NULL, '1', 'B04.029.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6242, '1', '1', '0', 8, NULL, '1', 'B04.029.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6243, '1', '1', '0', 9, NULL, '1', 'B04.029.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6244, '1', '1', '0', 10, NULL, '1', 'B04.029.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6245, '1', '1', '0', 11, NULL, '1', 'B04.029.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6246, '1', '1', '0', 12, NULL, '1', 'B04.029.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6247, '1', '1', '0', 13, NULL, '1', 'B04.029.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6248, '1', '1', '0', 14, NULL, '1', 'B04.029.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6249, '1', '1', '0', 15, NULL, '1', 'B04.029.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6250, '1', '1', '0', 16, NULL, '1', 'B04.029.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6251, '1', '1', '0', 17, NULL, '1', 'B04.029.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6252, '1', '1', '0', 0, NULL, '1', 'B04.010.002', '  (, )  -  ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6253, '1', '1', '0', 1, NULL, '1', 'B04.010.002', '  (, )  -  ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6254, '1', '1', '0', 2, NULL, '1', 'B04.010.002', '  (, )  -  ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6255, '1', '1', '0', 3, NULL, '1', 'B04.010.002', '  (, )  -  ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6256, '1', '1', '0', 4, NULL, '1', 'B04.010.002', '  (, )  -  ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6257, '1', '1', '0', 5, NULL, '1', 'B04.010.002', '  (, )  -  ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6258, '1', '1', '0', 6, NULL, '1', 'B04.010.002', '  (, )  -  ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6259, '1', '1', '0', 7, NULL, '1', 'B04.010.002', '  (, )  -  ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6260, '1', '1', '0', 8, NULL, '1', 'B04.010.002', '  (, )  -  ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6261, '1', '1', '0', 9, NULL, '1', 'B04.010.002', '  (, )  -  ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6262, '1', '1', '0', 10, NULL, '1', 'B04.010.002', '  (, )  -  ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6263, '1', '1', '0', 11, NULL, '1', 'B04.010.002', '  (, )  -  ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6264, '1', '1', '0', 12, NULL, '1', 'B04.010.002', '  (, )  -  ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6265, '1', '1', '0', 13, NULL, '1', 'B04.010.002', '  (, )  -  ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6266, '1', '1', '0', 14, NULL, '1', 'B04.010.002', '  (, )  -  ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6267, '1', '1', '0', 15, NULL, '1', 'B04.010.002', '  (, )  -  ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6268, '1', '1', '0', 16, NULL, '1', 'B04.010.002', '  (, )  -  ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6269, '1', '1', '0', 17, NULL, '1', 'B04.010.002', '  (, )  -  ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6270, '1', '1', '0', 0, NULL, '1', 'B04.028.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6271, '1', '1', '0', 1, NULL, '1', 'B04.028.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6272, '1', '1', '0', 2, NULL, '1', 'B04.028.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6273, '1', '1', '0', 3, NULL, '1', 'B04.028.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6274, '1', '1', '0', 4, NULL, '1', 'B04.028.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6275, '1', '1', '0', 5, NULL, '1', 'B04.028.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6276, '1', '1', '0', 6, NULL, '1', 'B04.028.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6277, '1', '1', '0', 7, NULL, '1', 'B04.028.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6278, '1', '1', '0', 8, NULL, '1', 'B04.028.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6279, '1', '1', '0', 9, NULL, '1', 'B04.028.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6280, '1', '1', '0', 10, NULL, '1', 'B04.028.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6281, '1', '1', '0', 11, NULL, '1', 'B04.028.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6282, '1', '1', '0', 12, NULL, '1', 'B04.028.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6283, '1', '1', '0', 13, NULL, '1', 'B04.028.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6284, '1', '1', '0', 14, NULL, '1', 'B04.028.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6285, '1', '1', '0', 15, NULL, '1', 'B04.028.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6286, '1', '1', '0', 16, NULL, '1', 'B04.028.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6287, '1', '1', '0', 17, NULL, '1', 'B04.028.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6288, '1', '1', '0', 3, NULL, '1', 'B04.064.002', '  (, ) - ', 0, '1', 2.5, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6289, '1', '1', '0', 4, NULL, '1', 'B04.064.002', '  (, ) - ', 0, '1', 2.5, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6290, '1', '1', '0', 5, NULL, '1', 'B04.064.002', '  (, ) - ', 0, '1', 2.5, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6291, '1', '1', '0', 6, NULL, '1', 'B04.064.002', '  (, ) - ', 0, '1', 2.5, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6292, '1', '1', '0', 7, NULL, '1', 'B04.064.002', '  (, ) - ', 0, '1', 2.5, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6293, '1', '1', '0', 8, NULL, '1', 'B04.064.002', '  (, ) - ', 0, '1', 2.5, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6294, '1', '1', '0', 9, NULL, '1', 'B04.064.002', '  (, ) - ', 0, '1', 2.5, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6295, '1', '1', '0', 10, NULL, '1', 'B04.064.002', '  (, ) - ', 0, '1', 2.5, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6296, '1', '1', '0', 11, NULL, '1', 'B04.064.002', '  (, ) - ', 0, '1', 2.5, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6297, '1', '1', '0', 12, NULL, '1', 'B04.064.002', '  (, ) - ', 0, '1', 2.5, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6298, '1', '1', '0', 13, NULL, '1', 'B04.064.002', '  (, ) - ', 0, '1', 2.5, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6299, '1', '1', '0', 14, NULL, '1', 'B04.064.002', '  (, ) - ', 0, '1', 2.5, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6300, '1', '1', '0', 15, NULL, '1', 'B04.064.002', '  (, ) - ', 0, '1', 2.5, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6301, '1', '1', '0', 16, NULL, '1', 'B04.064.002', '  (, ) - ', 0, '1', 2.5, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6302, '1', '1', '0', 17, NULL, '1', 'B04.064.002', '  (, ) - ', 0, '1', 2.5, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6303, '1', '1', '0', 0, NULL, '1', 'B04.050.002', '  (, ) --', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6304, '1', '1', '0', 1, NULL, '1', 'B04.050.002', '  (, ) --', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6305, '1', '1', '0', 2, NULL, '1', 'B04.050.002', '  (, ) --', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6306, '1', '1', '0', 3, NULL, '1', 'B04.050.002', '  (, ) --', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6307, '1', '1', '0', 4, NULL, '1', 'B04.050.002', '  (, ) --', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6308, '1', '1', '0', 5, NULL, '1', 'B04.050.002', '  (, ) --', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6309, '1', '1', '0', 6, NULL, '1', 'B04.050.002', '  (, ) --', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6310, '1', '1', '0', 7, NULL, '1', 'B04.050.002', '  (, ) --', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6311, '1', '1', '0', 8, NULL, '1', 'B04.050.002', '  (, ) --', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6312, '1', '1', '0', 9, NULL, '1', 'B04.050.002', '  (, ) --', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6313, '1', '1', '0', 10, NULL, '1', 'B04.050.002', '  (, ) --', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6314, '1', '1', '0', 11, NULL, '1', 'B04.050.002', '  (, ) --', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6315, '1', '1', '0', 12, NULL, '1', 'B04.050.002', '  (, ) --', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6316, '1', '1', '0', 13, NULL, '1', 'B04.050.002', '  (, ) --', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6317, '1', '1', '0', 14, NULL, '1', 'B04.050.002', '  (, ) --', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6318, '1', '1', '0', 15, NULL, '1', 'B04.050.002', '  (, ) --', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6319, '1', '1', '0', 16, NULL, '1', 'B04.050.002', '  (, ) --', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6320, '1', '1', '0', 17, NULL, '1', 'B04.050.002', '  (, ) --', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6321, '1', '1', '0', 0, NULL, '1', 'B04.035.002', '  (, ) -', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6322, '1', '1', '0', 1, NULL, '1', 'B04.035.002', '  (, ) -', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6323, '1', '1', '0', 2, NULL, '1', 'B04.035.002', '  (, ) -', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6324, '1', '1', '0', 3, NULL, '1', 'B04.035.002', '  (, ) -', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6325, '1', '1', '0', 4, NULL, '1', 'B04.035.002', '  (, ) -', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6326, '1', '1', '0', 5, NULL, '1', 'B04.035.002', '  (, ) -', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6327, '1', '1', '0', 6, NULL, '1', 'B04.035.002', '  (, ) -', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6328, '1', '1', '0', 7, NULL, '1', 'B04.035.002', '  (, ) -', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6329, '1', '1', '0', 8, NULL, '1', 'B04.035.002', '  (, ) -', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6330, '1', '1', '0', 9, NULL, '1', 'B04.035.002', '  (, ) -', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6331, '1', '1', '0', 10, NULL, '1', 'B04.035.002', '  (, ) -', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6332, '1', '1', '0', 11, NULL, '1', 'B04.035.002', '  (, ) -', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6333, '1', '1', '0', 12, NULL, '1', 'B04.035.002', '  (, ) -', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6334, '1', '1', '0', 13, NULL, '1', 'B04.035.002', '  (, ) -', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6335, '1', '1', '0', 14, NULL, '1', 'B04.035.002', '  (, ) -', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6336, '1', '1', '0', 15, NULL, '1', 'B04.035.002', '  (, ) -', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6337, '1', '1', '0', 16, NULL, '1', 'B04.035.002', '  (, ) -', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6338, '1', '1', '0', 17, NULL, '1', 'B04.035.002', '  (, ) -', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6339, '1', '1', '1', 0, NULL, '1', 'B04.053.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6340, '1', '1', '1', 1, NULL, '1', 'B04.053.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6341, '1', '1', '1', 2, NULL, '1', 'B04.053.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6342, '1', '1', '1', 3, NULL, '1', 'B04.053.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6343, '1', '1', '1', 4, NULL, '1', 'B04.053.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6344, '1', '1', '1', 5, NULL, '1', 'B04.053.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6345, '1', '1', '1', 6, NULL, '1', 'B04.053.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6346, '1', '1', '1', 7, NULL, '1', 'B04.053.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6347, '1', '1', '1', 8, NULL, '1', 'B04.053.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6348, '1', '1', '1', 9, NULL, '1', 'B04.053.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6349, '1', '1', '1', 10, NULL, '1', 'B04.053.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6350, '1', '1', '1', 11, NULL, '1', 'B04.053.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6351, '1', '1', '1', 12, NULL, '1', 'B04.053.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6352, '1', '1', '1', 13, NULL, '1', 'B04.053.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6353, '1', '1', '1', 14, NULL, '1', 'B04.053.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6354, '1', '1', '1', 15, NULL, '1', 'B04.053.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6355, '1', '1', '1', 16, NULL, '1', 'B04.053.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6356, '1', '1', '1', 17, NULL, '1', 'B04.053.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6357, '1', '1', '0', 5, NULL, '1', 'B01.058.003', ' (, )  -   ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6358, '1', '1', '0', 6, NULL, '1', 'B01.058.003', ' (, )  -   ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6359, '1', '1', '0', 7, NULL, '1', 'B01.058.003', ' (, )  -   ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6360, '1', '1', '0', 8, NULL, '1', 'B01.058.003', ' (, )  -   ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6361, '1', '1', '0', 9, NULL, '1', 'B01.058.003', ' (, )  -   ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6362, '1', '1', '0', 10, NULL, '1', 'B01.058.003', ' (, )  -   ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6363, '1', '1', '0', 11, NULL, '1', 'B01.058.003', ' (, )  -   ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6364, '1', '1', '0', 12, NULL, '1', 'B01.058.003', ' (, )  -   ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6365, '1', '1', '0', 13, NULL, '1', 'B01.058.003', ' (, )  -   ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6366, '1', '1', '0', 14, NULL, '1', 'B01.058.003', ' (, )  -   ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6367, '1', '1', '0', 15, NULL, '1', 'B01.058.003', ' (, )  -   ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6368, '1', '1', '0', 16, NULL, '1', 'B01.058.003', ' (, )  -   ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6369, '1', '1', '0', 17, NULL, '1', 'B01.058.003', ' (, )  -   ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6370, '1', '1', '0', 0, NULL, '1', 'A09.05.023', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6371, '1', '1', '0', 1, NULL, '1', 'A09.05.023', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6372, '1', '1', '0', 2, NULL, '1', 'A09.05.023', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6373, '1', '1', '0', 3, NULL, '1', 'A09.05.023', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6374, '1', '1', '0', 4, NULL, '1', 'A09.05.023', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6375, '1', '1', '0', 5, NULL, '1', 'A09.05.023', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6376, '1', '1', '0', 6, NULL, '1', 'A09.05.023', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6377, '1', '1', '0', 7, NULL, '1', 'A09.05.023', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6378, '1', '1', '0', 8, NULL, '1', 'A09.05.023', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6379, '1', '1', '0', 9, NULL, '1', 'A09.05.023', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6380, '1', '1', '0', 10, NULL, '1', 'A09.05.023', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6381, '1', '1', '0', 11, NULL, '1', 'A09.05.023', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6382, '1', '1', '0', 12, NULL, '1', 'A09.05.023', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6383, '1', '1', '0', 13, NULL, '1', 'A09.05.023', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6384, '1', '1', '0', 14, NULL, '1', 'A09.05.023', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6385, '1', '1', '0', 15, NULL, '1', 'A09.05.023', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6386, '1', '1', '0', 16, NULL, '1', 'A09.05.023', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6387, '1', '1', '0', 17, NULL, '1', 'A09.05.023', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6388, '1', '1', '0', 15, NULL, '0', 'A06.09.006', ' ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6389, '1', '1', '0', 16, NULL, '0', 'A06.09.006', ' ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6390, '1', '1', '0', 17, NULL, '0', 'A06.09.006', ' ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6391, '1', '1', '0', 7, NULL, '1', 'A04.22.001', '      ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6392, '1', '1', '0', 8, NULL, '1', 'A04.22.001', '      ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6393, '1', '1', '0', 9, NULL, '1', 'A04.22.001', '      ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6394, '1', '1', '0', 10, NULL, '1', 'A04.22.001', '      ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6395, '1', '1', '0', 11, NULL, '1', 'A04.22.001', '      ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6396, '1', '1', '0', 12, NULL, '1', 'A04.22.001', '      ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6397, '1', '1', '0', 13, NULL, '1', 'A04.22.001', '      ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6398, '1', '1', '0', 14, NULL, '1', 'A04.22.001', '      ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6399, '1', '1', '0', 15, NULL, '1', 'A04.22.001', '      ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6400, '1', '1', '0', 16, NULL, '1', 'A04.22.001', '      ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6401, '1', '1', '0', 17, NULL, '1', 'A04.22.001', '      ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6402, '1', '1', '0', 0, NULL, '1', 'A04.23.001.001', '   ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6403, '1', '1', '1', 7, NULL, '1', 'A04.21.001', '  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6404, '1', '1', '1', 8, NULL, '1', 'A04.21.001', '  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6405, '1', '1', '1', 9, NULL, '1', 'A04.21.001', '  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6406, '1', '1', '1', 10, NULL, '1', 'A04.21.001', '  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6407, '1', '1', '1', 11, NULL, '1', 'A04.21.001', '  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6408, '1', '1', '1', 12, NULL, '1', 'A04.21.001', '  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6409, '1', '1', '1', 13, NULL, '1', 'A04.21.001', '  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6410, '1', '1', '1', 14, NULL, '1', 'A04.21.001', '  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6411, '1', '1', '1', 15, NULL, '1', 'A04.21.001', '  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6412, '1', '1', '1', 16, NULL, '1', 'A04.21.001', '  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6413, '1', '1', '1', 17, NULL, '1', 'A04.21.001', '  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6414, '1', '1', '1', 7, NULL, '1', 'A04.28.003', '   ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6415, '1', '1', '1', 8, NULL, '1', 'A04.28.003', '   ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6416, '1', '1', '1', 9, NULL, '1', 'A04.28.003', '   ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6417, '1', '1', '1', 10, NULL, '1', 'A04.28.003', '   ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6418, '1', '1', '1', 11, NULL, '1', 'A04.28.003', '   ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6419, '1', '1', '1', 12, NULL, '1', 'A04.28.003', '   ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6420, '1', '1', '1', 13, NULL, '1', 'A04.28.003', '   ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6421, '1', '1', '1', 14, NULL, '1', 'A04.28.003', '   ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6422, '1', '1', '1', 15, NULL, '1', 'A04.28.003', '   ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6423, '1', '1', '1', 16, NULL, '1', 'A04.28.003', '   ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6424, '1', '1', '1', 17, NULL, '1', 'A04.28.003', '   ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6425, '1', '1', '1', 7, NULL, '1', 'A04.21.002', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6426, '1', '1', '1', 8, NULL, '1', 'A04.21.002', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6427, '1', '1', '1', 9, NULL, '1', 'A04.21.002', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6428, '1', '1', '1', 10, NULL, '1', 'A04.21.002', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6429, '1', '1', '1', 11, NULL, '1', 'A04.21.002', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6430, '1', '1', '1', 12, NULL, '1', 'A04.21.002', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6431, '1', '1', '1', 13, NULL, '1', 'A04.21.002', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6432, '1', '1', '1', 14, NULL, '1', 'A04.21.002', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6433, '1', '1', '1', 15, NULL, '1', 'A04.21.002', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6434, '1', '1', '1', 16, NULL, '1', 'A04.21.002', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6435, '1', '1', '1', 17, NULL, '1', 'A04.21.002', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6436, '1', '1', '2', 5, NULL, '1', 'A05.10.006', ' ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6437, '1', '1', '2', 0, NULL, '1', 'B04.001.002', '  (, ) --', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6438, '1', '1', '2', 1, NULL, '1', 'B04.001.002', '  (, ) --', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6439, '1', '1', '2', 2, NULL, '1', 'B04.001.002', '  (, ) --', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6440, '1', '1', '2', 3, NULL, '1', 'B04.001.002', '  (, ) --', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6441, '1', '1', '2', 4, NULL, '1', 'B04.001.002', '  (, ) --', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6442, '1', '1', '2', 5, NULL, '1', 'B04.001.002', '  (, ) --', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6443, '1', '1', '2', 6, NULL, '1', 'B04.001.002', '  (, ) --', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6444, '1', '1', '2', 7, NULL, '1', 'B04.001.002', '  (, ) --', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6445, '1', '1', '2', 8, NULL, '1', 'B04.001.002', '  (, ) --', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6446, '1', '1', '2', 9, NULL, '1', 'B04.001.002', '  (, ) --', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6447, '1', '1', '2', 10, NULL, '1', 'B04.001.002', '  (, ) --', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6448, '1', '1', '2', 11, NULL, '1', 'B04.001.002', '  (, ) --', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6449, '1', '1', '2', 12, NULL, '1', 'B04.001.002', '  (, ) --', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6450, '1', '1', '2', 13, NULL, '1', 'B04.001.002', '  (, ) --', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6451, '1', '1', '2', 14, NULL, '1', 'B04.001.002', '  (, ) --', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6452, '1', '1', '2', 15, NULL, '1', 'B04.001.002', '  (, ) --', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6453, '1', '1', '2', 16, NULL, '1', 'B04.001.002', '  (, ) --', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6454, '1', '1', '2', 17, NULL, '1', 'B04.001.002', '  (, ) --', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6455, '1', '1', '2', 7, NULL, '1', 'A04.20.001', '     ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6456, '1', '1', '2', 8, NULL, '1', 'A04.20.001', '     ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6457, '1', '1', '2', 9, NULL, '1', 'A04.20.001', '     ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6458, '1', '1', '2', 10, NULL, '1', 'A04.20.001', '     ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6459, '1', '1', '2', 11, NULL, '1', 'A04.20.001', '     ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6460, '1', '1', '2', 12, NULL, '1', 'A04.20.001', '     ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6461, '1', '1', '2', 13, NULL, '1', 'A04.20.001', '     ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6462, '1', '1', '2', 14, NULL, '1', 'A04.20.001', '     ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6463, '1', '1', '2', 15, NULL, '1', 'A04.20.001', '     ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6464, '1', '1', '2', 16, NULL, '1', 'A04.20.001', '     ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6465, '1', '1', '2', 17, NULL, '1', 'A04.20.001', '     ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6466, '0', '1', '0', 39, NULL, '0', 'A04.06.001', '  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6467, '0', '1', '0', 45, NULL, '0', 'A04.06.001', '  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6468, '0', '1', '0', 51, NULL, '0', 'A04.06.001', '  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6469, '0', '1', '0', 57, NULL, '0', 'A04.06.001', '  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6470, '0', '1', '0', 63, NULL, '0', 'A04.06.001', '  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6471, '0', '1', '0', 69, NULL, '0', 'A04.06.001', '  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6472, '0', '1', '0', 75, NULL, '0', 'A04.06.001', '  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6473, '0', '1', '0', 81, NULL, '0', 'A04.06.001', '  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6474, '0', '1', '0', 87, NULL, '0', 'A04.06.001', '  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6475, '0', '1', '0', 93, NULL, '0', 'A04.06.001', '  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6476, '0', '1', '0', 99, NULL, '0', 'A04.06.001', '  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6477, '4', '1', '0', 3, NULL, '1', 'B03.016.002', ' ()  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6478, '4', '1', '0', 6, NULL, '1', 'B03.016.002', ' ()  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6479, '4', '1', '0', 9, NULL, '1', 'B03.016.002', ' ()  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6480, '4', '1', '0', 12, NULL, '1', 'B03.016.002', ' ()  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6481, '4', '1', '0', 18, NULL, '1', 'B03.016.002', ' ()  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6482, '4', '1', '0', 24, NULL, '1', 'B03.016.002', ' ()  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6483, '4', '1', '0', 36, NULL, '1', 'B03.016.002', ' ()  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6484, '4', '1', '0', 48, NULL, '1', 'B03.016.002', ' ()  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6485, '4', '1', '0', 60, NULL, '1', 'B03.016.002', ' ()  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6486, '4', '1', '0', 72, NULL, '1', 'B03.016.002', ' ()  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6487, '4', '1', '0', 84, NULL, '1', 'B03.016.002', ' ()  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6488, '4', '1', '0', 96, NULL, '1', 'B03.016.002', ' ()  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6489, '4', '1', '0', 108, NULL, '1', 'B03.016.002', ' ()  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6490, '4', '1', '0', 120, NULL, '1', 'B03.016.002', ' ()  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6491, '4', '1', '0', 132, NULL, '1', 'B03.016.002', ' ()  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6492, '4', '1', '0', 144, NULL, '1', 'B03.016.002', ' ()  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6493, '4', '1', '0', 156, NULL, '1', 'B03.016.002', ' ()  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6494, '4', '1', '0', 168, NULL, '1', 'B03.016.002', ' ()  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6495, '4', '1', '0', 180, NULL, '1', 'B03.016.002', ' ()  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6496, '4', '1', '0', 192, NULL, '1', 'B03.016.002', ' ()  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6497, '4', '1', '0', 3, NULL, '1', 'B03.016.006', '  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6498, '4', '1', '0', 6, NULL, '1', 'B03.016.006', '  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6499, '4', '1', '0', 12, NULL, '1', 'B03.016.006', '  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6500, '4', '1', '0', 36, NULL, '1', 'B03.016.006', '  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6501, '4', '1', '0', 48, NULL, '1', 'B03.016.006', '  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6502, '4', '1', '0', 60, NULL, '1', 'B03.016.006', '  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6503, '4', '1', '0', 72, NULL, '1', 'B03.016.006', '  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6504, '4', '1', '0', 84, NULL, '1', 'B03.016.006', '  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6505, '4', '1', '0', 96, NULL, '1', 'B03.016.006', '  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6506, '4', '1', '0', 108, NULL, '1', 'B03.016.006', '  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6507, '4', '1', '0', 120, NULL, '1', 'B03.016.006', '  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6508, '4', '1', '0', 132, NULL, '1', 'B03.016.006', '  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6509, '4', '1', '0', 144, NULL, '1', 'B03.016.006', '  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6510, '4', '1', '0', 156, NULL, '1', 'B03.016.006', '  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6511, '4', '1', '0', 168, NULL, '1', 'B03.016.006', '  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6512, '4', '1', '0', 180, NULL, '1', 'B03.016.006', '  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6513, '4', '1', '0', 192, NULL, '1', 'B03.016.006', '  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6514, '4', '1', '0', 168, NULL, '0', 'A09.05.087', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6515, '4', '1', '0', 168, NULL, '0', 'A09.05.078', '     ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6516, '4', '1', '0', 168, NULL, '0', 'A09.05.131', '      ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6517, '4', '1', '0', 168, NULL, '0', 'A09.05.132', '      ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6518, '4', '1', '0', 168, NULL, '0', 'A09.05.153', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6519, '4', '1', '0', 168, NULL, '0', 'A09.05.072', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6520, '4', '1', '0', 168, NULL, '0', 'A09.05.065', '   ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6521, '4', '1', '0', 168, NULL, '0', 'A09.05.060', '    (T3)  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6522, '4', '1', '0', 168, NULL, '0', 'A09.05.064', '    (T4)  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6523, '4', '1', '0', 168, NULL, '0', 'A09.05.066', '     ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6524, '4', '1', '0', 168, NULL, '0', 'A09.05.135', '     ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6525, '4', '1', '0', 12, NULL, '1', 'A09.05.023', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6526, '4', '1', '0', 36, NULL, '1', 'A09.05.023', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6527, '4', '1', '0', 72, NULL, '1', 'A09.05.023', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6528, '4', '1', '0', 84, NULL, '1', 'A09.05.023', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6529, '4', '1', '0', 96, NULL, '1', 'A09.05.023', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6530, '4', '1', '0', 108, NULL, '1', 'A09.05.023', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6531, '4', '1', '0', 120, NULL, '1', 'A09.05.023', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6532, '4', '1', '0', 132, NULL, '1', 'A09.05.023', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6533, '4', '1', '0', 156, NULL, '1', 'A09.05.023', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6534, '4', '1', '0', 168, NULL, '1', 'A09.05.023', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6535, '4', '1', '0', 180, NULL, '1', 'A09.05.023', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6536, '4', '1', '0', 192, NULL, '1', 'A09.05.023', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6537, '4', '1', '0', 12, NULL, '1', 'A05.10.004', ',     ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6538, '4', '1', '0', 84, NULL, '1', 'A05.10.004', ',     ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6539, '4', '1', '0', 120, NULL, '1', 'A05.10.004', ',     ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6540, '4', '1', '0', 168, NULL, '1', 'A05.10.004', ',     ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6541, '4', '1', '0', 180, NULL, '1', 'A05.10.004', ',     ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6542, '4', '1', '0', 192, NULL, '1', 'A05.10.004', ',     ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6543, '4', '1', '0', 12, NULL, '1', 'A05.10.006', ' ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6544, '4', '1', '0', 84, NULL, '1', 'A05.10.006', ' ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6545, '4', '1', '0', 120, NULL, '1', 'A05.10.006', ' ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6546, '4', '1', '0', 168, NULL, '1', 'A05.10.006', ' ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6547, '4', '1', '0', 180, NULL, '1', 'A05.10.006', ' ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6548, '4', '1', '0', 192, NULL, '1', 'A05.10.006', ' ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6549, '4', '1', '0', 84, NULL, '1', 'A04.22.001', '      ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6550, '4', '1', '0', 168, NULL, '1', 'A04.22.001', '      ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6551, '4', '1', '1', 84, NULL, '1', 'A04.28.003', '   ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6552, '4', '1', '1', 168, NULL, '1', 'A04.28.003', '   ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6553, '4', '1', '2', 84, NULL, '1', 'A04.20.001', '     ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6554, '4', '1', '2', 168, NULL, '1', 'A04.20.001', '     ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6555, '4', '1', '2', 84, NULL, '1', 'A04.20.002', '   ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6556, '4', '1', '2', 168, NULL, '1', 'A04.20.002', '   ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6557, '4', '1', '0', 1, NULL, '1', 'A04.04.001', '  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6558, '4', '1', '0', 36, NULL, '1', 'B04.035.002', '  (, ) -', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6559, '4', '1', '0', 84, NULL, '1', 'B04.035.002', '  (, ) -', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6560, '4', '1', '0', 120, NULL, '1', 'B04.035.002', '  (, ) -', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6561, '4', '1', '0', 168, NULL, '1', 'B04.035.002', '  (, ) -', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6562, '4', '1', '0', 180, NULL, '1', 'B04.035.002', '  (, ) -', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6563, '4', '1', '0', 192, NULL, '1', 'B04.035.002', '  (, ) -', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6564, '4', '1', '0', 0, NULL, '1', 'B04.031.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6565, '4', '1', '0', 1, NULL, '1', 'B04.031.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6566, '4', '1', '0', 2, NULL, '1', 'B04.031.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6567, '4', '1', '0', 3, NULL, '1', 'B04.031.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6568, '4', '1', '0', 4, NULL, '1', 'B04.031.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6569, '4', '1', '0', 5, NULL, '1', 'B04.031.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6570, '4', '1', '0', 6, NULL, '1', 'B04.031.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6571, '4', '1', '0', 7, NULL, '1', 'B04.031.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6572, '4', '1', '0', 8, NULL, '1', 'B04.031.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6573, '4', '1', '0', 9, NULL, '1', 'B04.031.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6574, '4', '1', '0', 10, NULL, '1', 'B04.031.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6575, '4', '1', '0', 11, NULL, '1', 'B04.031.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6576, '4', '1', '0', 12, NULL, '1', 'B04.031.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6577, '4', '1', '0', 15, NULL, '1', 'B04.031.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6578, '4', '1', '0', 18, NULL, '1', 'B04.031.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6579, '4', '1', '0', 21, NULL, '1', 'B04.031.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6580, '4', '1', '0', 24, NULL, '1', 'B04.031.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6581, '4', '1', '0', 30, NULL, '1', 'B04.031.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6582, '4', '1', '0', 36, NULL, '1', 'B04.031.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6583, '4', '1', '0', 48, NULL, '1', 'B04.031.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6584, '4', '1', '0', 60, NULL, '1', 'B04.031.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6585, '4', '1', '0', 72, NULL, '1', 'B04.031.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6586, '4', '1', '0', 84, NULL, '1', 'B04.031.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6587, '4', '1', '0', 96, NULL, '1', 'B04.031.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6588, '4', '1', '0', 108, NULL, '1', 'B04.031.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6589, '4', '1', '0', 120, NULL, '1', 'B04.031.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6590, '4', '1', '0', 132, NULL, '1', 'B04.031.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6591, '4', '1', '0', 144, NULL, '1', 'B04.031.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6592, '4', '1', '0', 156, NULL, '1', 'B04.031.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6593, '4', '1', '0', 168, NULL, '1', 'B04.031.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6594, '4', '1', '0', 180, NULL, '1', 'B04.031.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6595, '4', '1', '0', 192, NULL, '1', 'B04.031.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6596, '4', '1', '0', 1, NULL, '1', 'B04.023.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6597, '4', '1', '0', 3, NULL, '1', 'B04.023.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6598, '4', '1', '0', 6, NULL, '1', 'B04.023.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6599, '4', '1', '0', 36, NULL, '1', 'B04.023.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6600, '4', '1', '0', 72, NULL, '1', 'B04.023.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6601, '4', '1', '0', 84, NULL, '1', 'B04.023.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6602, '4', '1', '0', 120, NULL, '1', 'B04.023.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6603, '4', '1', '0', 168, NULL, '1', 'B04.023.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6604, '4', '1', '0', 180, NULL, '1', 'B04.023.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6605, '4', '1', '0', 192, NULL, '1', 'B04.023.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6606, '4', '1', '0', 1, NULL, '1', 'B04.029.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6607, '4', '1', '0', 36, NULL, '1', 'B04.029.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6608, '4', '1', '0', 72, NULL, '1', 'B04.029.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6609, '4', '1', '0', 84, NULL, '1', 'B04.029.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6610, '4', '1', '0', 120, NULL, '1', 'B04.029.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6611, '4', '1', '0', 132, NULL, '1', 'B04.029.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6612, '4', '1', '0', 168, NULL, '1', 'B04.029.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6613, '4', '1', '0', 180, NULL, '1', 'B04.029.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6614, '4', '1', '0', 192, NULL, '1', 'B04.029.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6615, '4', '1', '0', 1, NULL, '1', 'B04.010.002', '  (, )  -  ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6616, '4', '1', '0', 6, NULL, '1', 'B04.010.002', '  (, )  -  ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6617, '4', '1', '0', 36, NULL, '1', 'B04.010.002', '  (, )  -  ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6618, '4', '1', '0', 48, NULL, '1', 'B04.010.002', '  (, )  -  ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6619, '4', '1', '0', 60, NULL, '1', 'B04.010.002', '  (, )  -  ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6620, '4', '1', '0', 84, NULL, '1', 'B04.010.002', '  (, )  -  ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6621, '4', '1', '0', 120, NULL, '1', 'B04.010.002', '  (, )  -  ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6622, '4', '1', '0', 132, NULL, '1', 'B04.010.002', '  (, )  -  ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6623, '4', '1', '0', 180, NULL, '1', 'B04.010.002', '  (, )  -  ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6624, '4', '1', '0', 192, NULL, '1', 'B04.010.002', '  (, )  -  ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6625, '4', '1', '0', 36, NULL, '1', 'B04.028.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6626, '4', '1', '0', 84, NULL, '1', 'B04.028.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6627, '4', '1', '0', 120, NULL, '1', 'B04.028.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6628, '4', '1', '0', 168, NULL, '1', 'B04.028.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6629, '4', '1', '0', 180, NULL, '1', 'B04.028.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6630, '4', '1', '0', 192, NULL, '1', 'B04.028.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6631, '4', '1', '2', 36, NULL, '1', 'B04.001.002', '  (, ) --', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6632, '4', '1', '2', 84, NULL, '1', 'B04.001.002', '  (, ) --', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6633, '4', '1', '2', 144, NULL, '1', 'B04.001.002', '  (, ) --', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6634, '4', '1', '2', 168, NULL, '1', 'B04.001.002', '  (, ) --', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6635, '4', '1', '2', 180, NULL, '1', 'B04.001.002', '  (, ) --', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6636, '4', '1', '2', 192, NULL, '1', 'B04.001.002', '  (, ) --', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6637, '4', '1', '0', 36, NULL, '1', 'B04.064.002', '  (, ) - ', 0, '1', 2.5, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6638, '4', '1', '0', 72, NULL, '1', 'B04.064.002', '  (, ) - ', 0, '1', 2.5, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6639, '4', '1', '0', 84, NULL, '1', 'B04.064.002', '  (, ) - ', 0, '1', 2.5, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6640, '4', '1', '0', 120, NULL, '1', 'B04.064.002', '  (, ) - ', 0, '1', 2.5, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6641, '4', '1', '0', 168, NULL, '1', 'B04.064.002', '  (, ) - ', 0, '1', 2.5, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6642, '4', '1', '0', 180, NULL, '1', 'B04.064.002', '  (, ) - ', 0, '1', 2.5, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6643, '4', '1', '0', 192, NULL, '1', 'B04.064.002', '  (, ) - ', 0, '1', 2.5, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6644, '4', '1', '0', 3, NULL, '1', 'B04.050.002', '  (, ) --', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6645, '4', '1', '0', 84, NULL, '1', 'B04.050.002', '  (, ) --', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6646, '4', '1', '0', 120, NULL, '1', 'B04.050.002', '  (, ) --', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6647, '4', '1', '0', 180, NULL, '1', 'B04.050.002', '  (, ) --', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6648, '4', '1', '0', 192, NULL, '1', 'B04.050.002', '  (, ) --', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6649, '4', '1', '1', 36, NULL, '1', 'B04.053.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6650, '4', '1', '1', 84, NULL, '1', 'B04.053.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6651, '4', '1', '1', 144, NULL, '1', 'B04.053.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6652, '4', '1', '1', 168, NULL, '1', 'B04.053.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6653, '4', '1', '1', 180, NULL, '1', 'B04.053.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6654, '4', '1', '1', 192, NULL, '1', 'B04.053.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6655, '4', '1', '0', 120, NULL, '1', 'B01.058.003', ' (, )  -   ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6656, '4', '1', '0', 168, NULL, '1', 'B01.058.003', ' (, )  -   ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6657, '4', '1', '0', 180, NULL, '1', 'B01.058.003', ' (, )  -   ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6658, '4', '1', '0', 192, NULL, '1', 'B01.058.003', ' (, )  -   ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6659, '4', '1', '0', 180, NULL, '1', 'A06.09.006', ' ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6660, '4', '1', '0', 192, NULL, '1', 'A06.09.006', ' ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6661, '4', '1', '0', 1, NULL, '1', 'A04.23.001.001', '   ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6662, '6', '1', '0', 1, NULL, '1', 'B03.016.002', ' ()  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6663, '6', '1', '0', 2, NULL, '1', 'B03.016.002', ' ()  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6664, '6', '1', '0', 3, NULL, '1', 'B03.016.002', ' ()  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6665, '6', '1', '0', 1, NULL, '1', 'B03.016.006', '  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6666, '6', '1', '0', 2, NULL, '1', 'B03.016.006', '  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6667, '6', '1', '0', 3, NULL, '1', 'B03.016.006', '  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6668, '6', '1', '0', 1, NULL, '1', 'B04.031.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6669, '6', '1', '0', 2, NULL, '1', 'B04.031.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6670, '6', '1', '0', 3, NULL, '1', 'B04.031.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6671, '5', '1', '0', 1, NULL, '1', 'B03.016.002', ' ()  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6672, '5', '1', '0', 2, NULL, '1', 'B03.016.002', ' ()  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6673, '5', '1', '0', 3, NULL, '1', 'B03.016.002', ' ()  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6674, '5', '1', '0', 1, NULL, '1', 'B03.016.006', '  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6675, '5', '1', '0', 2, NULL, '1', 'B03.016.006', '  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6676, '5', '1', '0', 3, NULL, '1', 'B03.016.006', '  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6677, '5', '1', '0', 1, NULL, '1', 'A09.19.002', '   ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6678, '5', '1', '0', 2, NULL, '1', 'A09.19.002', '   ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6679, '5', '1', '0', 1, NULL, '1', 'A09.05.023', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6680, '5', '1', '0', 2, NULL, '1', 'A09.05.023', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6681, '5', '1', '0', 3, NULL, '1', 'A09.05.023', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6682, '5', '1', '0', 2, NULL, '1', 'A05.10.004', ',     ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6683, '5', '1', '0', 3, NULL, '1', 'A05.10.004', ',     ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6684, '5', '1', '0', 2, NULL, '1', 'A05.10.006', ' ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6685, '5', '1', '0', 3, NULL, '1', 'A05.10.006', ' ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6686, '5', '1', '0', 2, NULL, '1', 'A04.22.001', '      ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6687, '5', '1', '0', 3, NULL, '1', 'A04.22.001', '      ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6688, '5', '1', '0', 1, NULL, '1', 'B04.035.002', '  (, ) -', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6689, '5', '1', '0', 2, NULL, '1', 'B04.035.002', '  (, ) -', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6690, '5', '1', '0', 3, NULL, '1', 'B04.035.002', '  (, ) -', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6691, '5', '1', '0', 1, NULL, '1', 'B04.031.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6692, '5', '1', '0', 2, NULL, '1', 'B04.031.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6693, '5', '1', '0', 3, NULL, '1', 'B04.031.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6694, '5', '1', '0', 1, NULL, '1', 'B04.023.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6695, '5', '1', '0', 2, NULL, '1', 'B04.023.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6696, '5', '1', '0', 3, NULL, '1', 'B04.023.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6697, '5', '1', '0', 1, NULL, '1', 'B04.029.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6698, '5', '1', '0', 2, NULL, '1', 'B04.029.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6699, '5', '1', '0', 3, NULL, '1', 'B04.029.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6700, '5', '1', '0', 1, NULL, '1', 'B04.010.002', '  (, )  -  ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6701, '5', '1', '0', 2, NULL, '1', 'B04.010.002', '  (, )  -  ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6702, '5', '1', '0', 3, NULL, '1', 'B04.010.002', '  (, )  -  ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6703, '5', '1', '0', 1, NULL, '1', 'B04.028.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6704, '5', '1', '0', 2, NULL, '1', 'B04.028.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6705, '5', '1', '0', 3, NULL, '1', 'B04.028.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6706, '5', '1', '2', 1, NULL, '1', 'B04.001.002', '  (, ) --', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6707, '5', '1', '2', 2, NULL, '1', 'B04.001.002', '  (, ) --', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6708, '5', '1', '2', 3, NULL, '1', 'B04.001.002', '  (, ) --', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6709, '5', '1', '0', 1, NULL, '1', 'B04.064.002', '  (, ) - ', 0, '1', 2.5, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6710, '5', '1', '0', 2, NULL, '1', 'B04.064.002', '  (, ) - ', 0, '1', 2.5, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6711, '5', '1', '0', 3, NULL, '1', 'B04.064.002', '  (, ) - ', 0, '1', 2.5, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6712, '5', '1', '0', 2, NULL, '1', 'B04.050.002', '  (, ) --', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6713, '5', '1', '0', 3, NULL, '1', 'B04.050.002', '  (, ) --', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6714, '5', '1', '1', 1, NULL, '1', 'B04.053.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6715, '5', '1', '1', 2, NULL, '1', 'B04.053.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6716, '5', '1', '1', 3, NULL, '1', 'B04.053.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6717, '5', '1', '0', 3, NULL, '1', 'B01.058.003', ' (, )  -   ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6718, '5', '1', '0', 3, NULL, '1', 'A06.09.006', ' ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6719, '7', '1', '0', 0, NULL, '1', 'B01.069.004', ' (, )     ', 0, '1', NULL, '2015-01-01', NULL, NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6720, '7', '1', '0', 1, NULL, '1', 'B01.069.004', ' (, )     ', 0, '1', NULL, '2015-01-01', NULL, NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6721, '7', '1', '0', 0, NULL, '0', 'A09.05.023', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6722, '7', '1', '0', 1, NULL, '0', 'A09.05.023', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6723, '7', '1', '0', 0, NULL, '0', 'A09.05.026', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6724, '7', '1', '0', 1, NULL, '0', 'A09.05.026', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6725, '7', '1', '0', 0, NULL, '1', 'A02.01.001', '  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6726, '7', '1', '0', 1, NULL, '1', 'A02.01.001', '  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6727, '7', '1', '0', 0, NULL, '0', 'A02.01.004', '    ()', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6728, '7', '1', '0', 1, NULL, '0', 'A02.01.004', '    ()', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6729, '7', '1', '0', 0, NULL, '1', 'A02.03.005', ' ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6730, '7', '1', '0', 1, NULL, '1', 'A02.03.005', ' ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6731, '7', '1', '0', 0, NULL, '1', 'A02.12.002', '     ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6732, '7', '1', '0', 1, NULL, '1', 'A02.12.002', '     ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6733, '7', '1', '0', 0, NULL, '0', 'A02.09.002', '   ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6734, '7', '1', '0', 1, NULL, '0', 'A02.09.002', '   ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6735, '7', '1', '0', 0, NULL, '0', 'A05.10.006', ' ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6736, '7', '1', '0', 1, NULL, '0', 'A05.10.006', ' ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6737, '7', '1', '0', 0, NULL, '0', 'A05.10.004', ',     ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6738, '7', '1', '0', 1, NULL, '0', 'A05.10.004', ',     ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6739, '7', '1', '0', 0, NULL, '0', 'A03.31.002', '', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6740, '7', '1', '0', 1, NULL, '0', 'A03.31.002', '', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6741, '7', '1', '0', 0, NULL, '0', 'A12.09.001', '     ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6742, '7', '1', '0', 1, NULL, '0', 'A12.09.001', '     ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6743, '7', '1', '0', 0, NULL, '0', 'A12.09.002.002', '      ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6744, '7', '1', '0', 1, NULL, '0', 'A12.09.002.002', '      ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6745, '7', '1', '0', 0, NULL, '0', 'A12.25.005', '', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6746, '7', '1', '0', 1, NULL, '0', 'A12.25.005', '', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6747, '7', '1', '0', 0, NULL, '0', 'A09.05.091', '   ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6748, '7', '1', '0', 1, NULL, '0', 'A09.05.091', '   ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6749, '7', '1', '0', 0, NULL, '0', 'A12.13.001', '   ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6750, '7', '1', '0', 1, NULL, '0', 'A12.13.001', '   ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6751, '7', '1', '0', 0, NULL, '0', 'A02.03.004', '', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6752, '7', '2', '0', 0, NULL, '1', 'B01.069.005', ' (, )     ', 0, '1', NULL, '2015-01-01', NULL, NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6753, '7', '2', '0', 1, NULL, '1', 'B01.069.005', ' (, )     ', 0, '1', NULL, '2015-01-01', NULL, NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6754, '4', '1', '0', 204, NULL, '1', 'B03.016.002', ' ()  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6755, '4', '1', '0', 204, NULL, '1', 'B03.016.006', '  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6756, '4', '1', '0', 204, NULL, '1', 'A09.05.023', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6757, '4', '1', '0', 204, NULL, '1', 'A05.10.004', ',     ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6758, '4', '1', '0', 204, NULL, '1', 'A05.10.006', ' ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6759, '4', '1', '0', 204, NULL, '1', 'B04.035.002', '  (, ) -', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6760, '4', '1', '0', 204, NULL, '1', 'B04.031.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6761, '4', '1', '0', 204, NULL, '1', 'B04.023.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6762, '4', '1', '0', 204, NULL, '1', 'B04.029.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6763, '4', '1', '0', 204, NULL, '1', 'B04.010.002', '  (, )  -  ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6764, '4', '1', '0', 204, NULL, '1', 'B04.028.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6765, '4', '1', '2', 204, NULL, '1', 'B04.001.002', '  (, ) --', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6766, '4', '1', '0', 204, NULL, '1', 'B04.064.002', '  (, ) - ', 0, '1', 2.5, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6767, '4', '1', '0', 204, NULL, '1', 'B04.050.002', '  (, ) --', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6768, '4', '1', '1', 204, NULL, '1', 'B04.053.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6769, '4', '1', '0', 204, NULL, '1', 'B01.058.003', ' (, )  -   ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6770, '4', '1', '0', 204, NULL, '1', 'A06.09.006', ' ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6771, '4', '1', '0', 12, NULL, '1', 'B04.023.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6772, '4', '1', '0', 12, NULL, '1', 'B04.029.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6773, '4', '1', '0', 12, NULL, '1', 'B04.010.002', '  (, )  -  ', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6774, '4', '1', '0', 12, NULL, '1', 'B04.028.002', '  (, ) -', 0, '1', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6775, '4', '1', '0', 12, NULL, '1', 'B04.064.002', '  (, ) - ', 0, '1', 2.5, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6776, '7', '1', '0', 0, NULL, '0', 'A02.26.004', '', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6777, '7', '1', '0', 1, NULL, '0', 'A02.26.004', '', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6778, '7', '1', '0', 0, NULL, '0', 'A03.26.008', '', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6779, '7', '1', '0', 1, NULL, '0', 'A03.26.008', '', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6780, '7', '1', '0', 0, NULL, '0', 'A02.26.015', ' ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6781, '7', '1', '0', 1, NULL, '0', 'A02.26.015', ' ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6782, '7', '1', '0', 0, NULL, '0', 'A02.26.024', '  , ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6783, '7', '1', '0', 1, NULL, '0', 'A02.26.024', '  , ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6784, '7', '2', '0', 0, NULL, '0', 'A02.01.001', '  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6785, '7', '2', '0', 1, NULL, '0', 'A02.01.001', '  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6786, '7', '2', '0', 0, NULL, '0', 'A02.01.004', '    ()', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6787, '7', '2', '0', 1, NULL, '0', 'A02.01.004', '    ()', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6788, '7', '2', '0', 0, NULL, '0', 'A02.03.004', '', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6789, '7', '2', '0', 0, NULL, '0', 'A02.03.005', ' ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6790, '7', '2', '0', 1, NULL, '0', 'A02.03.005', ' ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6791, '7', '2', '0', 0, NULL, '0', 'A02.09.002', '   ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6792, '7', '2', '0', 1, NULL, '0', 'A02.09.002', '   ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6793, '7', '2', '0', 0, NULL, '0', 'A02.12.002', '     ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6794, '7', '2', '0', 1, NULL, '0', 'A02.12.002', '     ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6795, '7', '2', '0', 0, NULL, '0', 'A02.26.004', '', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6796, '7', '2', '0', 1, NULL, '0', 'A02.26.004', '', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6797, '7', '2', '0', 0, NULL, '0', 'A02.26.015', ' ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6798, '7', '2', '0', 1, NULL, '0', 'A02.26.015', ' ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6799, '7', '2', '0', 0, NULL, '0', 'A02.26.024', '  , ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6800, '7', '2', '0', 1, NULL, '0', 'A02.26.024', '  , ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6801, '7', '2', '0', 0, NULL, '0', 'A03.26.008', '', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6802, '7', '2', '0', 1, NULL, '0', 'A03.26.008', '', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6803, '7', '2', '0', 0, NULL, '0', 'A03.31.002', '', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6804, '7', '2', '0', 1, NULL, '0', 'A03.31.002', '', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6805, '7', '2', '0', 0, NULL, '0', 'A05.10.006', ' ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6806, '7', '2', '0', 1, NULL, '0', 'A05.10.006', ' ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6807, '7', '2', '0', 0, NULL, '0', 'A05.10.004', ',     ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6808, '7', '2', '0', 1, NULL, '0', 'A05.10.004', ',     ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6809, '7', '2', '0', 0, NULL, '0', 'A09.05.023', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6810, '7', '2', '0', 1, NULL, '0', 'A09.05.023', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6811, '7', '2', '0', 0, NULL, '0', 'A09.05.026', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6812, '7', '2', '0', 1, NULL, '0', 'A09.05.026', '    ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6813, '7', '2', '0', 0, NULL, '0', 'A09.05.091', '   ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6814, '7', '2', '0', 1, NULL, '0', 'A09.05.091', '   ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6815, '7', '2', '0', 0, NULL, '0', 'A12.09.001', '     ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6816, '7', '2', '0', 1, NULL, '0', 'A12.09.001', '     ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6817, '7', '2', '0', 0, NULL, '0', 'A12.09.002.002', '      ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6818, '7', '2', '0', 1, NULL, '0', 'A12.09.002.002', '      ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6819, '7', '2', '0', 0, NULL, '0', 'A12.13.001', '   ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6820, '7', '2', '0', 1, NULL, '0', 'A12.13.001', '   ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6821, '7', '2', '0', 0, NULL, '0', 'A12.25.005', '', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6822, '7', '2', '0', 1, NULL, '0', 'A12.25.005', '', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6823, '7', '1', '0', 0, NULL, '0', 'B04.065.002', '  (, ) --', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6824, '7', '1', '0', 1, NULL, '0', 'B04.065.002', '  (, ) --', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6825, '7', '2', '0', 0, NULL, '0', 'B04.065.002', '  (, ) --', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6826, '7', '2', '0', 1, NULL, '0', 'B04.065.002', '  (, ) --', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6827, '2', '1', '0', 0, NULL, '1', 'B03.016.002', ' ()  ', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6828, '2', '1', '0', 1, NULL, '1', 'B03.016.002', ' ()  ', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6829, '2', '1', '0', 2, NULL, '1', 'B03.016.002', ' ()  ', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6830, '2', '1', '0', 3, NULL, '1', 'B03.016.002', ' ()  ', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6831, '2', '1', '0', 4, NULL, '1', 'B03.016.002', ' ()  ', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6832, '2', '1', '0', 5, NULL, '1', 'B03.016.002', ' ()  ', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6833, '2', '1', '0', 6, NULL, '1', 'B03.016.002', ' ()  ', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6834, '2', '1', '0', 7, NULL, '1', 'B03.016.002', ' ()  ', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6835, '2', '1', '0', 8, NULL, '1', 'B03.016.002', ' ()  ', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6836, '2', '1', '0', 9, NULL, '1', 'B03.016.002', ' ()  ', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6837, '2', '1', '0', 10, NULL, '1', 'B03.016.002', ' ()  ', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6838, '2', '1', '0', 11, NULL, '1', 'B03.016.002', ' ()  ', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6839, '2', '1', '0', 12, NULL, '1', 'B03.016.002', ' ()  ', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6840, '2', '1', '0', 13, NULL, '1', 'B03.016.002', ' ()  ', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6841, '2', '1', '0', 14, NULL, '1', 'B03.016.002', ' ()  ', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6842, '2', '1', '0', 15, NULL, '1', 'B03.016.002', ' ()  ', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6843, '2', '1', '0', 16, NULL, '1', 'B03.016.002', ' ()  ', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6844, '2', '1', '0', 17, NULL, '1', 'B03.016.002', ' ()  ', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6845, '2', '1', '0', 0, NULL, '1', 'B03.016.006', '  ', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6846, '2', '1', '0', 1, NULL, '1', 'B03.016.006', '  ', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6847, '2', '1', '0', 2, NULL, '1', 'B03.016.006', '  ', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6848, '2', '1', '0', 3, NULL, '1', 'B03.016.006', '  ', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6849, '2', '1', '0', 4, NULL, '1', 'B03.016.006', '  ', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6850, '2', '1', '0', 5, NULL, '1', 'B03.016.006', '  ', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6851, '2', '1', '0', 6, NULL, '1', 'B03.016.006', '  ', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6852, '2', '1', '0', 7, NULL, '1', 'B03.016.006', '  ', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6853, '2', '1', '0', 8, NULL, '1', 'B03.016.006', '  ', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6854, '2', '1', '0', 9, NULL, '1', 'B03.016.006', '  ', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6855, '2', '1', '0', 10, NULL, '1', 'B03.016.006', '  ', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6856, '2', '1', '0', 11, NULL, '1', 'B03.016.006', '  ', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6857, '2', '1', '0', 12, NULL, '1', 'B03.016.006', '  ', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6858, '2', '1', '0', 13, NULL, '1', 'B03.016.006', '  ', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6859, '2', '1', '0', 14, NULL, '1', 'B03.016.006', '  ', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6860, '2', '1', '0', 15, NULL, '1', 'B03.016.006', '  ', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6861, '2', '1', '0', 16, NULL, '1', 'B03.016.006', '  ', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6862, '2', '1', '0', 17, NULL, '1', 'B03.016.006', '  ', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6863, '2', '1', '0', 0, NULL, '1', 'A05.10.006', ' ', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6864, '2', '1', '0', 1, NULL, '1', 'A05.10.006', ' ', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6865, '2', '1', '0', 2, NULL, '1', 'A05.10.006', ' ', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6866, '2', '1', '0', 3, NULL, '1', 'A05.10.006', ' ', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6867, '2', '1', '0', 4, NULL, '1', 'A05.10.006', ' ', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6868, '2', '1', '0', 6, NULL, '1', 'A05.10.006', ' ', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6869, '2', '1', '0', 7, NULL, '1', 'A05.10.006', ' ', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6870, '2', '1', '0', 8, NULL, '1', 'A05.10.006', ' ', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6871, '2', '1', '0', 9, NULL, '1', 'A05.10.006', ' ', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6872, '2', '1', '0', 10, NULL, '1', 'A05.10.006', ' ', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6873, '2', '1', '0', 11, NULL, '1', 'A05.10.006', ' ', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6874, '2', '1', '0', 12, NULL, '1', 'A05.10.006', ' ', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6875, '2', '1', '0', 13, NULL, '1', 'A05.10.006', ' ', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6876, '2', '1', '0', 14, NULL, '1', 'A05.10.006', ' ', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6877, '2', '1', '0', 15, NULL, '1', 'A05.10.006', ' ', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6878, '2', '1', '0', 16, NULL, '1', 'A05.10.006', ' ', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6879, '2', '1', '0', 17, NULL, '1', 'A05.10.006', ' ', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6880, '2', '1', '0', 0, NULL, '1', 'A04.04.001', '  ', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6881, '2', '1', '0', 0, NULL, '1', 'A04.28.002.001', '  ', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6882, '2', '1', '0', 1, NULL, '1', 'A04.28.002.001', '  ', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6883, '2', '1', '0', 2, NULL, '1', 'A04.28.002.001', '  ', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6884, '2', '1', '0', 3, NULL, '1', 'A04.28.002.001', '  ', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6885, '2', '1', '0', 4, NULL, '1', 'A04.28.002.001', '  ', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6886, '2', '1', '0', 5, NULL, '1', 'A04.28.002.001', '  ', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6887, '2', '1', '0', 6, NULL, '1', 'A04.28.002.001', '  ', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6888, '2', '1', '0', 7, NULL, '1', 'A04.28.002.001', '  ', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6889, '2', '1', '0', 8, NULL, '1', 'A04.28.002.001', '  ', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6890, '2', '1', '0', 9, NULL, '1', 'A04.28.002.001', '  ', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6891, '2', '1', '0', 10, NULL, '1', 'A04.28.002.001', '  ', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6892, '2', '1', '0', 11, NULL, '1', 'A04.28.002.001', '  ', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6893, '2', '1', '0', 12, NULL, '1', 'A04.28.002.001', '  ', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6894, '2', '1', '0', 13, NULL, '1', 'A04.28.002.001', '  ', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6895, '2', '1', '0', 14, NULL, '1', 'A04.28.002.001', '  ', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6896, '2', '1', '0', 15, NULL, '1', 'A04.28.002.001', '  ', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6897, '2', '1', '0', 16, NULL, '1', 'A04.28.002.001', '  ', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6898, '2', '1', '0', 17, NULL, '1', 'A04.28.002.001', '  ', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6899, '2', '1', '0', 0, NULL, '1', 'A04.16.001', '     ()', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6900, '2', '1', '0', 1, NULL, '1', 'A04.16.001', '     ()', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6901, '2', '1', '0', 2, NULL, '1', 'A04.16.001', '     ()', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6902, '2', '1', '0', 3, NULL, '1', 'A04.16.001', '     ()', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6903, '2', '1', '0', 4, NULL, '1', 'A04.16.001', '     ()', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6904, '2', '1', '0', 5, NULL, '1', 'A04.16.001', '     ()', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6905, '2', '1', '0', 6, NULL, '1', 'A04.16.001', '     ()', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6906, '2', '1', '0', 7, NULL, '1', 'A04.16.001', '     ()', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6907, '2', '1', '0', 8, NULL, '1', 'A04.16.001', '     ()', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6908, '2', '1', '0', 9, NULL, '1', 'A04.16.001', '     ()', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6909, '2', '1', '0', 10, NULL, '1', 'A04.16.001', '     ()', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6910, '2', '1', '0', 11, NULL, '1', 'A04.16.001', '     ()', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6911, '2', '1', '0', 12, NULL, '1', 'A04.16.001', '     ()', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6912, '2', '1', '0', 13, NULL, '1', 'A04.16.001', '     ()', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6913, '2', '1', '0', 14, NULL, '1', 'A04.16.001', '     ()', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6914, '2', '1', '0', 15, NULL, '1', 'A04.16.001', '     ()', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6915, '2', '1', '0', 16, NULL, '1', 'A04.16.001', '     ()', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6916, '2', '1', '0', 17, NULL, '1', 'A04.16.001', '     ()', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6917, '2', '1', '0', 0, NULL, '1', 'A04.10.002', '', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6918, '2', '1', '0', 1, NULL, '1', 'A04.10.002', '', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6919, '2', '1', '0', 2, NULL, '1', 'A04.10.002', '', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6920, '2', '1', '0', 3, NULL, '1', 'A04.10.002', '', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6921, '2', '1', '0', 4, NULL, '1', 'A04.10.002', '', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6922, '2', '1', '0', 5, NULL, '1', 'A04.10.002', '', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6923, '2', '1', '0', 6, NULL, '1', 'A04.10.002', '', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6924, '2', '1', '0', 7, NULL, '1', 'A04.10.002', '', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6925, '2', '1', '0', 8, NULL, '1', 'A04.10.002', '', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6926, '2', '1', '0', 9, NULL, '1', 'A04.10.002', '', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6927, '2', '1', '0', 10, NULL, '1', 'A04.10.002', '', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6928, '2', '1', '0', 11, NULL, '1', 'A04.10.002', '', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6929, '2', '1', '0', 12, NULL, '1', 'A04.10.002', '', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6930, '2', '1', '0', 13, NULL, '1', 'A04.10.002', '', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6931, '2', '1', '0', 14, NULL, '1', 'A04.10.002', '', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6932, '2', '1', '0', 15, NULL, '1', 'A04.10.002', '', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6933, '2', '1', '0', 16, NULL, '1', 'A04.10.002', '', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6934, '2', '1', '0', 17, NULL, '1', 'A04.10.002', '', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6935, '2', '1', '0', 0, NULL, '1', 'B04.031.002', '  (, ) -', 0, '1', 0, '2015-01-01', NULL, NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6936, '2', '1', '0', 1, NULL, '1', 'B04.031.002', '  (, ) -', 0, '1', 0, '2015-01-01', NULL, NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6937, '2', '1', '0', 2, NULL, '1', 'B04.031.002', '  (, ) -', 0, '1', 0, '2015-01-01', NULL, NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6938, '2', '1', '0', 3, NULL, '1', 'B04.031.002', '  (, ) -', 0, '1', 0, '2015-01-01', NULL, NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6939, '2', '1', '0', 4, NULL, '1', 'B04.031.002', '  (, ) -', 0, '1', 0, '2015-01-01', NULL, NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6940, '2', '1', '0', 5, NULL, '1', 'B04.031.002', '  (, ) -', 0, '1', 0, '2015-01-01', NULL, NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6941, '2', '1', '0', 6, NULL, '1', 'B04.031.002', '  (, ) -', 0, '1', 0, '2015-01-01', NULL, NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6942, '2', '1', '0', 7, NULL, '1', 'B04.031.002', '  (, ) -', 0, '1', 0, '2015-01-01', NULL, NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6943, '2', '1', '0', 8, NULL, '1', 'B04.031.002', '  (, ) -', 0, '1', 0, '2015-01-01', NULL, NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6944, '2', '1', '0', 9, NULL, '1', 'B04.031.002', '  (, ) -', 0, '1', 0, '2015-01-01', NULL, NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6945, '2', '1', '0', 10, NULL, '1', 'B04.031.002', '  (, ) -', 0, '1', 0, '2015-01-01', NULL, NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6946, '2', '1', '0', 11, NULL, '1', 'B04.031.002', '  (, ) -', 0, '1', 0, '2015-01-01', NULL, NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6947, '2', '1', '0', 12, NULL, '1', 'B04.031.002', '  (, ) -', 0, '1', 0, '2015-01-01', NULL, NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6948, '2', '1', '0', 13, NULL, '1', 'B04.031.002', '  (, ) -', 0, '1', 0, '2015-01-01', NULL, NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6949, '2', '1', '0', 14, NULL, '1', 'B04.031.002', '  (, ) -', 0, '1', 0, '2015-01-01', NULL, NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6950, '2', '1', '0', 15, NULL, '1', 'B04.031.002', '  (, ) -', 0, '1', 0, '2015-01-01', NULL, NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6951, '2', '1', '0', 16, NULL, '1', 'B04.031.002', '  (, ) -', 0, '1', 0, '2015-01-01', NULL, NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6952, '2', '1', '0', 17, NULL, '1', 'B04.031.002', '  (, ) -', 0, '1', 0, '2015-01-01', NULL, NULL, '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6953, '2', '1', '0', 0, NULL, '1', 'B04.023.002', '  (, ) -', 0, '1', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6954, '2', '1', '0', 1, NULL, '1', 'B04.023.002', '  (, ) -', 0, '1', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6955, '2', '1', '0', 2, NULL, '1', 'B04.023.002', '  (, ) -', 0, '1', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6956, '2', '1', '0', 3, NULL, '1', 'B04.023.002', '  (, ) -', 0, '1', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6957, '2', '1', '0', 4, NULL, '1', 'B04.023.002', '  (, ) -', 0, '1', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6958, '2', '1', '0', 5, NULL, '1', 'B04.023.002', '  (, ) -', 0, '1', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6959, '2', '1', '0', 6, NULL, '1', 'B04.023.002', '  (, ) -', 0, '1', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6960, '2', '1', '0', 7, NULL, '1', 'B04.023.002', '  (, ) -', 0, '1', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6961, '2', '1', '0', 8, NULL, '1', 'B04.023.002', '  (, ) -', 0, '1', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6962, '2', '1', '0', 9, NULL, '1', 'B04.023.002', '  (, ) -', 0, '1', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6963, '2', '1', '0', 10, NULL, '1', 'B04.023.002', '  (, ) -', 0, '1', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6964, '2', '1', '0', 11, NULL, '1', 'B04.023.002', '  (, ) -', 0, '1', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6965, '2', '1', '0', 12, NULL, '1', 'B04.023.002', '  (, ) -', 0, '1', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6966, '2', '1', '0', 13, NULL, '1', 'B04.023.002', '  (, ) -', 0, '1', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6967, '2', '1', '0', 14, NULL, '1', 'B04.023.002', '  (, ) -', 0, '1', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6968, '2', '1', '0', 15, NULL, '1', 'B04.023.002', '  (, ) -', 0, '1', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6969, '2', '1', '0', 16, NULL, '1', 'B04.023.002', '  (, ) -', 0, '1', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6970, '2', '1', '0', 17, NULL, '1', 'B04.023.002', '  (, ) -', 0, '1', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6971, '2', '1', '0', 0, NULL, '1', 'B04.029.002', '  (, ) -', 0, '1', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6972, '2', '1', '0', 1, NULL, '1', 'B04.029.002', '  (, ) -', 0, '1', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6973, '2', '1', '0', 2, NULL, '1', 'B04.029.002', '  (, ) -', 0, '1', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6974, '2', '1', '0', 3, NULL, '1', 'B04.029.002', '  (, ) -', 0, '1', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6975, '2', '1', '0', 4, NULL, '1', 'B04.029.002', '  (, ) -', 0, '1', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6976, '2', '1', '0', 5, NULL, '1', 'B04.029.002', '  (, ) -', 0, '1', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6977, '2', '1', '0', 6, NULL, '1', 'B04.029.002', '  (, ) -', 0, '1', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6978, '2', '1', '0', 7, NULL, '1', 'B04.029.002', '  (, ) -', 0, '1', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6979, '2', '1', '0', 8, NULL, '1', 'B04.029.002', '  (, ) -', 0, '1', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6980, '2', '1', '0', 9, NULL, '1', 'B04.029.002', '  (, ) -', 0, '1', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6981, '2', '1', '0', 10, NULL, '1', 'B04.029.002', '  (, ) -', 0, '1', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6982, '2', '1', '0', 11, NULL, '1', 'B04.029.002', '  (, ) -', 0, '1', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6983, '2', '1', '0', 12, NULL, '1', 'B04.029.002', '  (, ) -', 0, '1', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6984, '2', '1', '0', 13, NULL, '1', 'B04.029.002', '  (, ) -', 0, '1', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6985, '2', '1', '0', 14, NULL, '1', 'B04.029.002', '  (, ) -', 0, '1', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6986, '2', '1', '0', 15, NULL, '1', 'B04.029.002', '  (, ) -', 0, '1', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6987, '2', '1', '0', 16, NULL, '1', 'B04.029.002', '  (, ) -', 0, '1', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6988, '2', '1', '0', 17, NULL, '1', 'B04.029.002', '  (, ) -', 0, '1', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6989, '2', '1', '0', 0, NULL, '1', 'B04.010.002', '  (, )  -  ', 0, '1', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6990, '2', '1', '0', 1, NULL, '1', 'B04.010.002', '  (, )  -  ', 0, '1', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6991, '2', '1', '0', 2, NULL, '1', 'B04.010.002', '  (, )  -  ', 0, '1', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6992, '2', '1', '0', 3, NULL, '1', 'B04.010.002', '  (, )  -  ', 0, '1', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6993, '2', '1', '0', 4, NULL, '1', 'B04.010.002', '  (, )  -  ', 0, '1', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6994, '2', '1', '0', 5, NULL, '1', 'B04.010.002', '  (, )  -  ', 0, '1', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6995, '2', '1', '0', 6, NULL, '1', 'B04.010.002', '  (, )  -  ', 0, '1', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6996, '2', '1', '0', 7, NULL, '1', 'B04.010.002', '  (, )  -  ', 0, '1', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6997, '2', '1', '0', 8, NULL, '1', 'B04.010.002', '  (, )  -  ', 0, '1', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6998, '2', '1', '0', 9, NULL, '1', 'B04.010.002', '  (, )  -  ', 0, '1', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (6999, '2', '1', '0', 10, NULL, '1', 'B04.010.002', '  (, )  -  ', 0, '1', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7000, '2', '1', '0', 11, NULL, '1', 'B04.010.002', '  (, )  -  ', 0, '1', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7001, '2', '1', '0', 12, NULL, '1', 'B04.010.002', '  (, )  -  ', 0, '1', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7002, '2', '1', '0', 13, NULL, '1', 'B04.010.002', '  (, )  -  ', 0, '1', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7003, '2', '1', '0', 14, NULL, '1', 'B04.010.002', '  (, )  -  ', 0, '1', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7004, '2', '1', '0', 15, NULL, '1', 'B04.010.002', '  (, )  -  ', 0, '1', 0, '2015-01-01', NULL, NULL, NULL); @
COMMIT WORK; @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7005, '2', '1', '0', 16, NULL, '1', 'B04.010.002', '  (, )  -  ', 0, '1', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7006, '2', '1', '0', 17, NULL, '1', 'B04.010.002', '  (, )  -  ', 0, '1', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7007, '2', '1', '0', 0, NULL, '1', 'B04.028.002', '  (, ) -', 0, '1', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7008, '2', '1', '0', 1, NULL, '1', 'B04.028.002', '  (, ) -', 0, '1', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7009, '2', '1', '0', 2, NULL, '1', 'B04.028.002', '  (, ) -', 0, '1', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7010, '2', '1', '0', 3, NULL, '1', 'B04.028.002', '  (, ) -', 0, '1', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7011, '2', '1', '0', 4, NULL, '1', 'B04.028.002', '  (, ) -', 0, '1', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7012, '2', '1', '0', 5, NULL, '1', 'B04.028.002', '  (, ) -', 0, '1', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7013, '2', '1', '0', 6, NULL, '1', 'B04.028.002', '  (, ) -', 0, '1', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7014, '2', '1', '0', 7, NULL, '1', 'B04.028.002', '  (, ) -', 0, '1', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7015, '2', '1', '0', 8, NULL, '1', 'B04.028.002', '  (, ) -', 0, '1', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7016, '2', '1', '0', 9, NULL, '1', 'B04.028.002', '  (, ) -', 0, '1', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7017, '2', '1', '0', 10, NULL, '1', 'B04.028.002', '  (, ) -', 0, '1', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7018, '2', '1', '0', 11, NULL, '1', 'B04.028.002', '  (, ) -', 0, '1', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7019, '2', '1', '0', 12, NULL, '1', 'B04.028.002', '  (, ) -', 0, '1', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7020, '2', '1', '0', 13, NULL, '1', 'B04.028.002', '  (, ) -', 0, '1', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7021, '2', '1', '0', 14, NULL, '1', 'B04.028.002', '  (, ) -', 0, '1', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7022, '2', '1', '0', 15, NULL, '1', 'B04.028.002', '  (, ) -', 0, '1', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7023, '2', '1', '0', 16, NULL, '1', 'B04.028.002', '  (, ) -', 0, '1', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7024, '2', '1', '0', 17, NULL, '1', 'B04.028.002', '  (, ) -', 0, '1', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7025, '2', '1', '0', 3, NULL, '1', 'B04.064.002', '  (, ) - ', 0, '1', 2.5, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7026, '2', '1', '0', 4, NULL, '1', 'B04.064.002', '  (, ) - ', 0, '1', 2.5, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7027, '2', '1', '0', 5, NULL, '1', 'B04.064.002', '  (, ) - ', 0, '1', 2.5, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7028, '2', '1', '0', 6, NULL, '1', 'B04.064.002', '  (, ) - ', 0, '1', 2.5, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7029, '2', '1', '0', 7, NULL, '1', 'B04.064.002', '  (, ) - ', 0, '1', 2.5, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7030, '2', '1', '0', 8, NULL, '1', 'B04.064.002', '  (, ) - ', 0, '1', 2.5, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7031, '2', '1', '0', 9, NULL, '1', 'B04.064.002', '  (, ) - ', 0, '1', 2.5, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7032, '2', '1', '0', 10, NULL, '1', 'B04.064.002', '  (, ) - ', 0, '1', 2.5, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7033, '2', '1', '0', 11, NULL, '1', 'B04.064.002', '  (, ) - ', 0, '1', 2.5, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7034, '2', '1', '0', 12, NULL, '1', 'B04.064.002', '  (, ) - ', 0, '1', 2.5, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7035, '2', '1', '0', 13, NULL, '1', 'B04.064.002', '  (, ) - ', 0, '1', 2.5, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7036, '2', '1', '0', 14, NULL, '1', 'B04.064.002', '  (, ) - ', 0, '1', 2.5, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7037, '2', '1', '0', 15, NULL, '1', 'B04.064.002', '  (, ) - ', 0, '1', 2.5, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7038, '2', '1', '0', 16, NULL, '1', 'B04.064.002', '  (, ) - ', 0, '1', 2.5, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7039, '2', '1', '0', 17, NULL, '1', 'B04.064.002', '  (, ) - ', 0, '1', 2.5, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7040, '2', '1', '0', 0, NULL, '1', 'B04.050.002', '  (, ) --', 0, '1', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7041, '2', '1', '0', 1, NULL, '1', 'B04.050.002', '  (, ) --', 0, '1', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7042, '2', '1', '0', 2, NULL, '1', 'B04.050.002', '  (, ) --', 0, '1', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7043, '2', '1', '0', 3, NULL, '1', 'B04.050.002', '  (, ) --', 0, '1', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7044, '2', '1', '0', 4, NULL, '1', 'B04.050.002', '  (, ) --', 0, '1', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7045, '2', '1', '0', 5, NULL, '1', 'B04.050.002', '  (, ) --', 0, '1', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7046, '2', '1', '0', 6, NULL, '1', 'B04.050.002', '  (, ) --', 0, '1', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7047, '2', '1', '0', 7, NULL, '1', 'B04.050.002', '  (, ) --', 0, '1', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7048, '2', '1', '0', 8, NULL, '1', 'B04.050.002', '  (, ) --', 0, '1', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7049, '2', '1', '0', 9, NULL, '1', 'B04.050.002', '  (, ) --', 0, '1', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7050, '2', '1', '0', 10, NULL, '1', 'B04.050.002', '  (, ) --', 0, '1', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7051, '2', '1', '0', 11, NULL, '1', 'B04.050.002', '  (, ) --', 0, '1', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7052, '2', '1', '0', 12, NULL, '1', 'B04.050.002', '  (, ) --', 0, '1', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7053, '2', '1', '0', 13, NULL, '1', 'B04.050.002', '  (, ) --', 0, '1', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7054, '2', '1', '0', 14, NULL, '1', 'B04.050.002', '  (, ) --', 0, '1', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7055, '2', '1', '0', 15, NULL, '1', 'B04.050.002', '  (, ) --', 0, '1', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7056, '2', '1', '0', 16, NULL, '1', 'B04.050.002', '  (, ) --', 0, '1', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7057, '2', '1', '0', 17, NULL, '1', 'B04.050.002', '  (, ) --', 0, '1', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7058, '2', '1', '0', 0, NULL, '1', 'B04.035.002', '  (, ) -', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7059, '2', '1', '0', 1, NULL, '1', 'B04.035.002', '  (, ) -', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7060, '2', '1', '0', 2, NULL, '1', 'B04.035.002', '  (, ) -', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7061, '2', '1', '0', 3, NULL, '1', 'B04.035.002', '  (, ) -', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7062, '2', '1', '0', 4, NULL, '1', 'B04.035.002', '  (, ) -', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7063, '2', '1', '0', 5, NULL, '1', 'B04.035.002', '  (, ) -', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7064, '2', '1', '0', 6, NULL, '1', 'B04.035.002', '  (, ) -', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7065, '2', '1', '0', 7, NULL, '1', 'B04.035.002', '  (, ) -', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7066, '2', '1', '0', 8, NULL, '1', 'B04.035.002', '  (, ) -', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7067, '2', '1', '0', 9, NULL, '1', 'B04.035.002', '  (, ) -', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7068, '2', '1', '0', 10, NULL, '1', 'B04.035.002', '  (, ) -', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7069, '2', '1', '0', 11, NULL, '1', 'B04.035.002', '  (, ) -', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7070, '2', '1', '0', 12, NULL, '1', 'B04.035.002', '  (, ) -', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7071, '2', '1', '0', 13, NULL, '1', 'B04.035.002', '  (, ) -', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7072, '2', '1', '0', 14, NULL, '1', 'B04.035.002', '  (, ) -', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7073, '2', '1', '0', 15, NULL, '1', 'B04.035.002', '  (, ) -', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7074, '2', '1', '0', 16, NULL, '1', 'B04.035.002', '  (, ) -', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7075, '2', '1', '0', 17, NULL, '1', 'B04.035.002', '  (, ) -', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7076, '2', '1', '1', 0, NULL, '1', 'B04.053.002', '  (, ) -', 0, '1', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7077, '2', '1', '1', 1, NULL, '1', 'B04.053.002', '  (, ) -', 0, '1', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7078, '2', '1', '1', 2, NULL, '1', 'B04.053.002', '  (, ) -', 0, '1', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7079, '2', '1', '1', 3, NULL, '1', 'B04.053.002', '  (, ) -', 0, '1', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7080, '2', '1', '1', 4, NULL, '1', 'B04.053.002', '  (, ) -', 0, '1', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7081, '2', '1', '1', 5, NULL, '1', 'B04.053.002', '  (, ) -', 0, '1', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7082, '2', '1', '1', 6, NULL, '1', 'B04.053.002', '  (, ) -', 0, '1', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7083, '2', '1', '1', 7, NULL, '1', 'B04.053.002', '  (, ) -', 0, '1', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7084, '2', '1', '1', 8, NULL, '1', 'B04.053.002', '  (, ) -', 0, '1', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7085, '2', '1', '1', 9, NULL, '1', 'B04.053.002', '  (, ) -', 0, '1', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7086, '2', '1', '1', 10, NULL, '1', 'B04.053.002', '  (, ) -', 0, '1', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7087, '2', '1', '1', 11, NULL, '1', 'B04.053.002', '  (, ) -', 0, '1', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7088, '2', '1', '1', 12, NULL, '1', 'B04.053.002', '  (, ) -', 0, '1', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7089, '2', '1', '1', 13, NULL, '1', 'B04.053.002', '  (, ) -', 0, '1', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7090, '2', '1', '1', 14, NULL, '1', 'B04.053.002', '  (, ) -', 0, '1', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7091, '2', '1', '1', 15, NULL, '1', 'B04.053.002', '  (, ) -', 0, '1', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7092, '2', '1', '1', 16, NULL, '1', 'B04.053.002', '  (, ) -', 0, '1', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7093, '2', '1', '1', 17, NULL, '1', 'B04.053.002', '  (, ) -', 0, '1', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7094, '2', '1', '0', 5, NULL, '1', 'B01.058.003', ' (, )  -   ', 0, '1', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7095, '2', '1', '0', 6, NULL, '1', 'B01.058.003', ' (, )  -   ', 0, '1', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7096, '2', '1', '0', 7, NULL, '1', 'B01.058.003', ' (, )  -   ', 0, '1', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7097, '2', '1', '0', 8, NULL, '1', 'B01.058.003', ' (, )  -   ', 0, '1', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7098, '2', '1', '0', 9, NULL, '1', 'B01.058.003', ' (, )  -   ', 0, '1', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7099, '2', '1', '0', 10, NULL, '1', 'B01.058.003', ' (, )  -   ', 0, '1', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7100, '2', '1', '0', 11, NULL, '1', 'B01.058.003', ' (, )  -   ', 0, '1', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7101, '2', '1', '0', 12, NULL, '1', 'B01.058.003', ' (, )  -   ', 0, '1', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7102, '2', '1', '0', 13, NULL, '1', 'B01.058.003', ' (, )  -   ', 0, '1', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7103, '2', '1', '0', 14, NULL, '1', 'B01.058.003', ' (, )  -   ', 0, '1', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7104, '2', '1', '0', 15, NULL, '1', 'B01.058.003', ' (, )  -   ', 0, '1', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7105, '2', '1', '0', 16, NULL, '1', 'B01.058.003', ' (, )  -   ', 0, '1', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7106, '2', '1', '0', 17, NULL, '1', 'B01.058.003', ' (, )  -   ', 0, '1', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7107, '2', '1', '0', 0, NULL, '1', 'A09.05.023', '    ', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7108, '2', '1', '0', 1, NULL, '1', 'A09.05.023', '    ', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7109, '2', '1', '0', 2, NULL, '1', 'A09.05.023', '    ', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7110, '2', '1', '0', 3, NULL, '1', 'A09.05.023', '    ', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7111, '2', '1', '0', 4, NULL, '1', 'A09.05.023', '    ', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7112, '2', '1', '0', 5, NULL, '1', 'A09.05.023', '    ', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7113, '2', '1', '0', 6, NULL, '1', 'A09.05.023', '    ', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7114, '2', '1', '0', 7, NULL, '1', 'A09.05.023', '    ', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7115, '2', '1', '0', 8, NULL, '1', 'A09.05.023', '    ', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7116, '2', '1', '0', 9, NULL, '1', 'A09.05.023', '    ', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7117, '2', '1', '0', 10, NULL, '1', 'A09.05.023', '    ', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7118, '2', '1', '0', 11, NULL, '1', 'A09.05.023', '    ', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7119, '2', '1', '0', 12, NULL, '1', 'A09.05.023', '    ', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7120, '2', '1', '0', 13, NULL, '1', 'A09.05.023', '    ', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7121, '2', '1', '0', 14, NULL, '1', 'A09.05.023', '    ', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7122, '2', '1', '0', 15, NULL, '1', 'A09.05.023', '    ', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7123, '2', '1', '0', 16, NULL, '1', 'A09.05.023', '    ', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7124, '2', '1', '0', 17, NULL, '1', 'A09.05.023', '    ', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7125, '2', '1', '0', 15, NULL, '0', 'A06.09.006', ' ', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7126, '2', '1', '0', 16, NULL, '0', 'A06.09.006', ' ', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7127, '2', '1', '0', 17, NULL, '0', 'A06.09.006', ' ', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7128, '2', '1', '0', 7, NULL, '1', 'A04.22.001', '      ', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7129, '2', '1', '0', 8, NULL, '1', 'A04.22.001', '      ', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7130, '2', '1', '0', 9, NULL, '1', 'A04.22.001', '      ', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7131, '2', '1', '0', 10, NULL, '1', 'A04.22.001', '      ', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7132, '2', '1', '0', 11, NULL, '1', 'A04.22.001', '      ', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7133, '2', '1', '0', 12, NULL, '1', 'A04.22.001', '      ', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7134, '2', '1', '0', 13, NULL, '1', 'A04.22.001', '      ', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7135, '2', '1', '0', 14, NULL, '1', 'A04.22.001', '      ', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7136, '2', '1', '0', 15, NULL, '1', 'A04.22.001', '      ', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7137, '2', '1', '0', 16, NULL, '1', 'A04.22.001', '      ', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7138, '2', '1', '0', 17, NULL, '1', 'A04.22.001', '      ', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7139, '2', '1', '0', 0, NULL, '1', 'A04.23.001.001', '   ', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7140, '2', '1', '1', 7, NULL, '1', 'A04.21.001', '  ', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7141, '2', '1', '1', 8, NULL, '1', 'A04.21.001', '  ', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7142, '2', '1', '1', 9, NULL, '1', 'A04.21.001', '  ', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7143, '2', '1', '1', 10, NULL, '1', 'A04.21.001', '  ', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7144, '2', '1', '1', 11, NULL, '1', 'A04.21.001', '  ', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7145, '2', '1', '1', 12, NULL, '1', 'A04.21.001', '  ', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7146, '2', '1', '1', 13, NULL, '1', 'A04.21.001', '  ', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7147, '2', '1', '1', 14, NULL, '1', 'A04.21.001', '  ', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7148, '2', '1', '1', 15, NULL, '1', 'A04.21.001', '  ', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7149, '2', '1', '1', 16, NULL, '1', 'A04.21.001', '  ', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7150, '2', '1', '1', 17, NULL, '1', 'A04.21.001', '  ', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7151, '2', '1', '1', 7, NULL, '1', 'A04.28.003', '   ', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7152, '2', '1', '1', 8, NULL, '1', 'A04.28.003', '   ', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7153, '2', '1', '1', 9, NULL, '1', 'A04.28.003', '   ', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7154, '2', '1', '1', 10, NULL, '1', 'A04.28.003', '   ', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7155, '2', '1', '1', 11, NULL, '1', 'A04.28.003', '   ', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7156, '2', '1', '1', 12, NULL, '1', 'A04.28.003', '   ', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7157, '2', '1', '1', 13, NULL, '1', 'A04.28.003', '   ', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7158, '2', '1', '1', 14, NULL, '1', 'A04.28.003', '   ', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7159, '2', '1', '1', 15, NULL, '1', 'A04.28.003', '   ', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7160, '2', '1', '1', 16, NULL, '1', 'A04.28.003', '   ', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7161, '2', '1', '1', 17, NULL, '1', 'A04.28.003', '   ', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7162, '2', '1', '1', 7, NULL, '1', 'A04.21.002', '    ', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7163, '2', '1', '1', 8, NULL, '1', 'A04.21.002', '    ', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7164, '2', '1', '1', 9, NULL, '1', 'A04.21.002', '    ', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7165, '2', '1', '1', 10, NULL, '1', 'A04.21.002', '    ', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7166, '2', '1', '1', 11, NULL, '1', 'A04.21.002', '    ', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7167, '2', '1', '1', 12, NULL, '1', 'A04.21.002', '    ', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7168, '2', '1', '1', 13, NULL, '1', 'A04.21.002', '    ', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7169, '2', '1', '1', 14, NULL, '1', 'A04.21.002', '    ', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7170, '2', '1', '1', 15, NULL, '1', 'A04.21.002', '    ', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7171, '2', '1', '1', 16, NULL, '1', 'A04.21.002', '    ', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7172, '2', '1', '1', 17, NULL, '1', 'A04.21.002', '    ', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7173, '2', '1', '2', 5, NULL, '1', 'A05.10.006', ' ', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7174, '2', '1', '2', 0, NULL, '1', 'B04.001.002', '  (, ) --', 0, '1', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7175, '2', '1', '2', 1, NULL, '1', 'B04.001.002', '  (, ) --', 0, '1', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7176, '2', '1', '2', 2, NULL, '1', 'B04.001.002', '  (, ) --', 0, '1', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7177, '2', '1', '2', 3, NULL, '1', 'B04.001.002', '  (, ) --', 0, '1', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7178, '2', '1', '2', 4, NULL, '1', 'B04.001.002', '  (, ) --', 0, '1', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7179, '2', '1', '2', 5, NULL, '1', 'B04.001.002', '  (, ) --', 0, '1', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7180, '2', '1', '2', 6, NULL, '1', 'B04.001.002', '  (, ) --', 0, '1', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7181, '2', '1', '2', 7, NULL, '1', 'B04.001.002', '  (, ) --', 0, '1', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7182, '2', '1', '2', 8, NULL, '1', 'B04.001.002', '  (, ) --', 0, '1', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7183, '2', '1', '2', 9, NULL, '1', 'B04.001.002', '  (, ) --', 0, '1', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7184, '2', '1', '2', 10, NULL, '1', 'B04.001.002', '  (, ) --', 0, '1', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7185, '2', '1', '2', 11, NULL, '1', 'B04.001.002', '  (, ) --', 0, '1', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7186, '2', '1', '2', 12, NULL, '1', 'B04.001.002', '  (, ) --', 0, '1', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7187, '2', '1', '2', 13, NULL, '1', 'B04.001.002', '  (, ) --', 0, '1', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7188, '2', '1', '2', 14, NULL, '1', 'B04.001.002', '  (, ) --', 0, '1', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7189, '2', '1', '2', 15, NULL, '1', 'B04.001.002', '  (, ) --', 0, '1', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7190, '2', '1', '2', 16, NULL, '1', 'B04.001.002', '  (, ) --', 0, '1', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7191, '2', '1', '2', 17, NULL, '1', 'B04.001.002', '  (, ) --', 0, '1', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7192, '2', '1', '2', 7, NULL, '1', 'A04.20.001', '     ', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7193, '2', '1', '2', 8, NULL, '1', 'A04.20.001', '     ', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7194, '2', '1', '2', 9, NULL, '1', 'A04.20.001', '     ', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7195, '2', '1', '2', 10, NULL, '1', 'A04.20.001', '     ', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7196, '2', '1', '2', 11, NULL, '1', 'A04.20.001', '     ', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7197, '2', '1', '2', 12, NULL, '1', 'A04.20.001', '     ', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7198, '2', '1', '2', 13, NULL, '1', 'A04.20.001', '     ', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7199, '2', '1', '2', 14, NULL, '1', 'A04.20.001', '     ', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7200, '2', '1', '2', 15, NULL, '1', 'A04.20.001', '     ', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7201, '2', '1', '2', 16, NULL, '1', 'A04.20.001', '     ', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7202, '2', '1', '2', 17, NULL, '1', 'A04.20.001', '     ', 0, '0', 0, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7203, '3', '1', '0', 18, NULL, '0', 'B04.047.004', ' (, ) -  ', 0, '1', NULL, '2015-01-01', NULL, '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7204, '3', '1', '0', 19, NULL, '0', 'B04.047.004', ' (, ) -  ', 0, '1', NULL, '2015-01-01', NULL, '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7205, '3', '1', '0', 20, NULL, '0', 'B04.047.004', ' (, ) -  ', 0, '1', NULL, '2015-01-01', NULL, '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7206, '3', '1', '0', 21, NULL, '0', 'B04.047.004', ' (, ) -  ', 0, '1', NULL, '2015-01-01', NULL, '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7207, '3', '1', '0', 22, NULL, '0', 'B04.047.004', ' (, ) -  ', 0, '1', NULL, '2015-01-01', NULL, '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7208, '3', '1', '0', 23, NULL, '0', 'B04.047.004', ' (, ) -  ', 0, '1', NULL, '2015-01-01', NULL, '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7209, '3', '1', '0', 24, NULL, '0', 'B04.047.004', ' (, ) -  ', 0, '1', NULL, '2015-01-01', NULL, '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7210, '3', '1', '0', 25, NULL, '0', 'B04.047.004', ' (, ) -  ', 0, '1', NULL, '2015-01-01', NULL, '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7211, '3', '1', '0', 26, NULL, '0', 'B04.047.004', ' (, ) -  ', 0, '1', NULL, '2015-01-01', NULL, '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7212, '3', '1', '0', 27, NULL, '0', 'B04.047.004', ' (, ) -  ', 0, '1', NULL, '2015-01-01', NULL, '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7213, '3', '1', '0', 28, NULL, '0', 'B04.047.004', ' (, ) -  ', 0, '1', NULL, '2015-01-01', NULL, '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7214, '3', '1', '0', 29, NULL, '0', 'B04.047.004', ' (, ) -  ', 0, '1', NULL, '2015-01-01', NULL, '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7215, '3', '1', '0', 30, NULL, '0', 'B04.047.004', ' (, ) -  ', 0, '1', NULL, '2015-01-01', NULL, '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7216, '3', '1', '0', 31, NULL, '0', 'B04.047.004', ' (, ) -  ', 0, '1', NULL, '2015-01-01', NULL, '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7217, '3', '1', '0', 32, NULL, '0', 'B04.047.004', ' (, ) -  ', 0, '1', NULL, '2015-01-01', NULL, '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7218, '3', '1', '0', 33, NULL, '0', 'B04.047.004', ' (, ) -  ', 0, '1', NULL, '2015-01-01', NULL, '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7219, '3', '1', '0', 34, NULL, '0', 'B04.047.004', ' (, ) -  ', 0, '1', NULL, '2015-01-01', NULL, '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7220, '3', '1', '0', 35, NULL, '0', 'B04.047.004', ' (, ) -  ', 0, '1', NULL, '2015-01-01', NULL, '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7221, '3', '1', '0', 36, NULL, '0', 'B04.047.004', ' (, ) -  ', 0, '1', NULL, '2015-01-01', NULL, '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7222, '3', '1', '0', 37, NULL, '0', 'B04.047.004', ' (, ) -  ', 0, '1', NULL, '2015-01-01', NULL, '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7223, '3', '1', '0', 38, NULL, '0', 'B04.047.004', ' (, ) -  ', 0, '1', NULL, '2015-01-01', NULL, '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7224, '3', '1', '0', 39, NULL, '0', 'B04.047.004', ' (, ) -  ', 0, '1', NULL, '2015-01-01', NULL, '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7225, '3', '1', '0', 40, NULL, '0', 'B04.047.004', ' (, ) -  ', 0, '1', NULL, '2015-01-01', NULL, '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7226, '3', '1', '0', 41, NULL, '0', 'B04.047.004', ' (, ) -  ', 0, '1', NULL, '2015-01-01', NULL, '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7227, '3', '1', '0', 42, NULL, '0', 'B04.047.004', ' (, ) -  ', 0, '1', NULL, '2015-01-01', NULL, '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7228, '3', '1', '0', 43, NULL, '0', 'B04.047.004', ' (, ) -  ', 0, '1', NULL, '2015-01-01', NULL, '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7229, '3', '1', '0', 44, NULL, '0', 'B04.047.004', ' (, ) -  ', 0, '1', NULL, '2015-01-01', NULL, '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7230, '3', '1', '0', 45, NULL, '0', 'B04.047.004', ' (, ) -  ', 0, '1', NULL, '2015-01-01', NULL, '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7231, '3', '1', '0', 46, NULL, '0', 'B04.047.004', ' (, ) -  ', 0, '1', NULL, '2015-01-01', NULL, '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7232, '3', '1', '0', 47, NULL, '0', 'B04.047.004', ' (, ) -  ', 0, '1', NULL, '2015-01-01', NULL, '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7233, '3', '1', '0', 48, NULL, '0', 'B04.047.004', ' (, ) -  ', 0, '1', NULL, '2015-01-01', NULL, '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7234, '3', '1', '0', 49, NULL, '0', 'B04.047.004', ' (, ) -  ', 0, '1', NULL, '2015-01-01', NULL, '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7235, '3', '1', '0', 50, NULL, '0', 'B04.047.004', ' (, ) -  ', 0, '1', NULL, '2015-01-01', NULL, '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7236, '3', '1', '0', 51, NULL, '0', 'B04.047.004', ' (, ) -  ', 0, '1', NULL, '2015-01-01', NULL, '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7237, '3', '1', '0', 52, NULL, '0', 'B04.047.004', ' (, ) -  ', 0, '1', NULL, '2015-01-01', NULL, '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7238, '3', '1', '0', 53, NULL, '0', 'B04.047.004', ' (, ) -  ', 0, '1', NULL, '2015-01-01', NULL, '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7239, '3', '1', '0', 54, NULL, '0', 'B04.047.004', ' (, ) -  ', 0, '1', NULL, '2015-01-01', NULL, '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7240, '3', '1', '0', 55, NULL, '0', 'B04.047.004', ' (, ) -  ', 0, '1', NULL, '2015-01-01', NULL, '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7241, '3', '1', '0', 56, NULL, '0', 'B04.047.004', ' (, ) -  ', 0, '1', NULL, '2015-01-01', NULL, '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7242, '3', '1', '0', 57, NULL, '0', 'B04.047.004', ' (, ) -  ', 0, '1', NULL, '2015-01-01', NULL, '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7243, '3', '1', '0', 58, NULL, '0', 'B04.047.004', ' (, ) -  ', 0, '1', NULL, '2015-01-01', NULL, '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7244, '3', '1', '0', 59, NULL, '0', 'B04.047.004', ' (, ) -  ', 0, '1', NULL, '2015-01-01', NULL, '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7245, '3', '1', '0', 60, NULL, '0', 'B04.047.004', ' (, ) -  ', 0, '1', NULL, '2015-01-01', NULL, '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7246, '3', '1', '0', 61, NULL, '0', 'B04.047.004', ' (, ) -  ', 0, '1', NULL, '2015-01-01', NULL, '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7247, '3', '1', '0', 62, NULL, '0', 'B04.047.004', ' (, ) -  ', 0, '1', NULL, '2015-01-01', NULL, '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7248, '3', '1', '0', 63, NULL, '0', 'B04.047.004', ' (, ) -  ', 0, '1', NULL, '2015-01-01', NULL, '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7249, '3', '1', '0', 64, NULL, '0', 'B04.047.004', ' (, ) -  ', 0, '1', NULL, '2015-01-01', NULL, '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7250, '3', '1', '0', 65, NULL, '0', 'B04.047.004', ' (, ) -  ', 0, '1', NULL, '2015-01-01', NULL, '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7251, '3', '1', '0', 66, NULL, '0', 'B04.047.004', ' (, ) -  ', 0, '1', NULL, '2015-01-01', NULL, '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7252, '3', '1', '0', 67, NULL, '0', 'B04.047.004', ' (, ) -  ', 0, '1', NULL, '2015-01-01', NULL, '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7253, '3', '1', '0', 68, NULL, '0', 'B04.047.004', ' (, ) -  ', 0, '1', NULL, '2015-01-01', NULL, '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7254, '3', '1', '0', 69, NULL, '0', 'B04.047.004', ' (, ) -  ', 0, '1', NULL, '2015-01-01', NULL, '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7255, '3', '1', '0', 70, NULL, '0', 'B04.047.004', ' (, ) -  ', 0, '1', NULL, '2015-01-01', NULL, '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7256, '3', '1', '0', 71, NULL, '0', 'B04.047.004', ' (, ) -  ', 0, '1', NULL, '2015-01-01', NULL, '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7257, '3', '1', '0', 72, NULL, '0', 'B04.047.004', ' (, ) -  ', 0, '1', NULL, '2015-01-01', NULL, '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7258, '3', '1', '0', 73, NULL, '0', 'B04.047.004', ' (, ) -  ', 0, '1', NULL, '2015-01-01', NULL, '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7259, '3', '1', '0', 74, NULL, '0', 'B04.047.004', ' (, ) -  ', 0, '1', NULL, '2015-01-01', NULL, '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7260, '3', '1', '0', 75, NULL, '0', 'B04.047.004', ' (, ) -  ', 0, '1', NULL, '2015-01-01', NULL, '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7261, '3', '1', '0', 76, NULL, '0', 'B04.047.004', ' (, ) -  ', 0, '1', NULL, '2015-01-01', NULL, '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7262, '3', '1', '0', 77, NULL, '0', 'B04.047.004', ' (, ) -  ', 0, '1', NULL, '2015-01-01', NULL, '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7263, '3', '1', '0', 78, NULL, '0', 'B04.047.004', ' (, ) -  ', 0, '1', NULL, '2015-01-01', NULL, '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7264, '3', '1', '0', 79, NULL, '0', 'B04.047.004', ' (, ) -  ', 0, '1', NULL, '2015-01-01', NULL, '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7265, '3', '1', '0', 80, NULL, '0', 'B04.047.004', ' (, ) -  ', 0, '1', NULL, '2015-01-01', NULL, '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7266, '3', '1', '0', 81, NULL, '0', 'B04.047.004', ' (, ) -  ', 0, '1', NULL, '2015-01-01', NULL, '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7267, '3', '1', '0', 82, NULL, '0', 'B04.047.004', ' (, ) -  ', 0, '1', NULL, '2015-01-01', NULL, '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7268, '3', '1', '0', 83, NULL, '0', 'B04.047.004', ' (, ) -  ', 0, '1', NULL, '2015-01-01', NULL, '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7269, '3', '1', '0', 84, NULL, '0', 'B04.047.004', ' (, ) -  ', 0, '1', NULL, '2015-01-01', NULL, '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7270, '3', '1', '0', 85, NULL, '0', 'B04.047.004', ' (, ) -  ', 0, '1', NULL, '2015-01-01', NULL, '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7271, '3', '1', '0', 86, NULL, '0', 'B04.047.004', ' (, ) -  ', 0, '1', NULL, '2015-01-01', NULL, '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7272, '3', '1', '0', 87, NULL, '0', 'B04.047.004', ' (, ) -  ', 0, '1', NULL, '2015-01-01', NULL, '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7273, '3', '1', '0', 88, NULL, '0', 'B04.047.004', ' (, ) -  ', 0, '1', NULL, '2015-01-01', NULL, '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7274, '3', '1', '0', 89, NULL, '0', 'B04.047.004', ' (, ) -  ', 0, '1', NULL, '2015-01-01', NULL, '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7275, '3', '1', '0', 90, NULL, '0', 'B04.047.004', ' (, ) -  ', 0, '1', NULL, '2015-01-01', NULL, '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7276, '3', '1', '0', 91, NULL, '0', 'B04.047.004', ' (, ) -  ', 0, '1', NULL, '2015-01-01', NULL, '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7277, '3', '1', '0', 92, NULL, '0', 'B04.047.004', ' (, ) -  ', 0, '1', NULL, '2015-01-01', NULL, '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7278, '3', '1', '0', 93, NULL, '0', 'B04.047.004', ' (, ) -  ', 0, '1', NULL, '2015-01-01', NULL, '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7279, '3', '1', '0', 94, NULL, '0', 'B04.047.004', ' (, ) -  ', 0, '1', NULL, '2015-01-01', NULL, '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7280, '3', '1', '0', 95, NULL, '0', 'B04.047.004', ' (, ) -  ', 0, '1', NULL, '2015-01-01', NULL, '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7281, '3', '1', '0', 96, NULL, '0', 'B04.047.004', ' (, ) -  ', 0, '1', NULL, '2015-01-01', NULL, '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7282, '3', '1', '0', 97, NULL, '0', 'B04.047.004', ' (, ) -  ', 0, '1', NULL, '2015-01-01', NULL, '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7283, '3', '1', '0', 98, NULL, '0', 'B04.047.004', ' (, ) -  ', 0, '1', NULL, '2015-01-01', NULL, '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7284, '3', '1', '0', 99, NULL, '0', 'B04.047.004', ' (, ) -  ', 0, '1', NULL, '2015-01-01', NULL, '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7285, '3', '1', '0', 18, NULL, '0', 'A09.05.026', '    ', 23.1, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7286, '3', '1', '0', 19, NULL, '0', 'A09.05.026', '    ', 23.1, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7287, '3', '1', '0', 20, NULL, '0', 'A09.05.026', '    ', 23.1, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7288, '3', '1', '0', 21, NULL, '0', 'A09.05.026', '    ', 23.1, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7289, '3', '1', '0', 22, NULL, '0', 'A09.05.026', '    ', 23.1, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7290, '3', '1', '0', 23, NULL, '0', 'A09.05.026', '    ', 23.1, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7291, '3', '1', '0', 24, NULL, '0', 'A09.05.026', '    ', 23.1, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7292, '3', '1', '0', 25, NULL, '0', 'A09.05.026', '    ', 23.1, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7293, '3', '1', '0', 26, NULL, '0', 'A09.05.026', '    ', 23.1, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7294, '3', '1', '0', 27, NULL, '0', 'A09.05.026', '    ', 23.1, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7295, '3', '1', '0', 28, NULL, '0', 'A09.05.026', '    ', 23.1, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7296, '3', '1', '0', 29, NULL, '0', 'A09.05.026', '    ', 23.1, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7297, '3', '1', '0', 30, NULL, '0', 'A09.05.026', '    ', 23.1, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7298, '3', '1', '0', 31, NULL, '0', 'A09.05.026', '    ', 23.1, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7299, '3', '1', '0', 32, NULL, '0', 'A09.05.026', '    ', 23.1, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7300, '3', '1', '0', 33, NULL, '0', 'A09.05.026', '    ', 23.1, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7301, '3', '1', '0', 34, NULL, '0', 'A09.05.026', '    ', 23.1, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7302, '3', '1', '0', 35, NULL, '0', 'A09.05.026', '    ', 23.1, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7303, '3', '1', '0', 36, NULL, '0', 'A09.05.026', '    ', 23.1, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7304, '3', '1', '0', 37, NULL, '0', 'A09.05.026', '    ', 23.1, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7305, '3', '1', '0', 38, NULL, '0', 'A09.05.026', '    ', 23.1, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7306, '3', '1', '0', 39, NULL, '0', 'A09.05.026', '    ', 23.1, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7307, '3', '1', '0', 40, NULL, '0', 'A09.05.026', '    ', 23.1, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7308, '3', '1', '0', 41, NULL, '0', 'A09.05.026', '    ', 23.1, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7309, '3', '1', '0', 42, NULL, '0', 'A09.05.026', '    ', 23.1, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7310, '3', '1', '0', 43, NULL, '0', 'A09.05.026', '    ', 23.1, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7311, '3', '1', '0', 44, NULL, '0', 'A09.05.026', '    ', 23.1, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7312, '3', '1', '0', 45, NULL, '0', 'A09.05.026', '    ', 23.1, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7313, '3', '1', '0', 46, NULL, '0', 'A09.05.026', '    ', 23.1, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7314, '3', '1', '0', 47, NULL, '0', 'A09.05.026', '    ', 23.1, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7315, '3', '1', '0', 48, NULL, '0', 'A09.05.026', '    ', 23.1, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7316, '3', '1', '0', 49, NULL, '0', 'A09.05.026', '    ', 23.1, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7317, '3', '1', '0', 50, NULL, '0', 'A09.05.026', '    ', 23.1, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7318, '3', '1', '0', 51, NULL, '0', 'A09.05.026', '    ', 23.1, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7319, '3', '1', '0', 52, NULL, '0', 'A09.05.026', '    ', 23.1, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7320, '3', '1', '0', 53, NULL, '0', 'A09.05.026', '    ', 23.1, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7321, '3', '1', '0', 54, NULL, '0', 'A09.05.026', '    ', 23.1, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7322, '3', '1', '0', 55, NULL, '0', 'A09.05.026', '    ', 23.1, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7323, '3', '1', '0', 56, NULL, '0', 'A09.05.026', '    ', 23.1, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7324, '3', '1', '0', 57, NULL, '0', 'A09.05.026', '    ', 23.1, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7325, '3', '1', '0', 58, NULL, '0', 'A09.05.026', '    ', 23.1, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7326, '3', '1', '0', 59, NULL, '0', 'A09.05.026', '    ', 23.1, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7327, '3', '1', '0', 60, NULL, '0', 'A09.05.026', '    ', 23.1, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7328, '3', '1', '0', 61, NULL, '0', 'A09.05.026', '    ', 23.1, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7329, '3', '1', '0', 62, NULL, '0', 'A09.05.026', '    ', 23.1, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7330, '3', '1', '0', 63, NULL, '0', 'A09.05.026', '    ', 23.1, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7331, '3', '1', '0', 64, NULL, '0', 'A09.05.026', '    ', 23.1, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7332, '3', '1', '0', 65, NULL, '0', 'A09.05.026', '    ', 23.1, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7333, '3', '1', '0', 66, NULL, '0', 'A09.05.026', '    ', 23.1, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7334, '3', '1', '0', 67, NULL, '0', 'A09.05.026', '    ', 23.1, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7335, '3', '1', '0', 68, NULL, '0', 'A09.05.026', '    ', 23.1, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7336, '3', '1', '0', 69, NULL, '0', 'A09.05.026', '    ', 23.1, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7337, '3', '1', '0', 70, NULL, '0', 'A09.05.026', '    ', 23.1, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7338, '3', '1', '0', 71, NULL, '0', 'A09.05.026', '    ', 23.1, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7339, '3', '1', '0', 72, NULL, '0', 'A09.05.026', '    ', 23.1, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7340, '3', '1', '0', 73, NULL, '0', 'A09.05.026', '    ', 23.1, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7341, '3', '1', '0', 74, NULL, '0', 'A09.05.026', '    ', 23.1, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7342, '3', '1', '0', 75, NULL, '0', 'A09.05.026', '    ', 23.1, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7343, '3', '1', '0', 76, NULL, '0', 'A09.05.026', '    ', 23.1, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7344, '3', '1', '0', 77, NULL, '0', 'A09.05.026', '    ', 23.1, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7345, '3', '1', '0', 78, NULL, '0', 'A09.05.026', '    ', 23.1, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7346, '3', '1', '0', 79, NULL, '0', 'A09.05.026', '    ', 23.1, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7347, '3', '1', '0', 80, NULL, '0', 'A09.05.026', '    ', 23.1, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7348, '3', '1', '0', 81, NULL, '0', 'A09.05.026', '    ', 23.1, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7349, '3', '1', '0', 82, NULL, '0', 'A09.05.026', '    ', 23.1, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7350, '3', '1', '0', 83, NULL, '0', 'A09.05.026', '    ', 23.1, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7351, '3', '1', '0', 84, NULL, '0', 'A09.05.026', '    ', 23.1, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7352, '3', '1', '0', 85, NULL, '0', 'A09.05.026', '    ', 23.1, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7353, '3', '1', '0', 86, NULL, '0', 'A09.05.026', '    ', 23.1, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7354, '3', '1', '0', 87, NULL, '0', 'A09.05.026', '    ', 23.1, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7355, '3', '1', '0', 88, NULL, '0', 'A09.05.026', '    ', 23.1, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7356, '3', '1', '0', 89, NULL, '0', 'A09.05.026', '    ', 23.1, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7357, '3', '1', '0', 90, NULL, '0', 'A09.05.026', '    ', 23.1, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7358, '3', '1', '0', 91, NULL, '0', 'A09.05.026', '    ', 23.1, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7359, '3', '1', '0', 92, NULL, '0', 'A09.05.026', '    ', 23.1, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7360, '3', '1', '0', 93, NULL, '0', 'A09.05.026', '    ', 23.1, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7361, '3', '1', '0', 94, NULL, '0', 'A09.05.026', '    ', 23.1, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7362, '3', '1', '0', 95, NULL, '0', 'A09.05.026', '    ', 23.1, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7363, '3', '1', '0', 96, NULL, '0', 'A09.05.026', '    ', 23.1, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7364, '3', '1', '0', 97, NULL, '0', 'A09.05.026', '    ', 23.1, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7365, '3', '1', '0', 98, NULL, '0', 'A09.05.026', '    ', 23.1, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7366, '3', '1', '0', 99, NULL, '0', 'A09.05.026', '    ', 23.1, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7367, '3', '1', '0', 18, NULL, '0', 'A09.05.023', '    ', 46.2, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7368, '3', '1', '0', 19, NULL, '0', 'A09.05.023', '    ', 46.2, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7369, '3', '1', '0', 20, NULL, '0', 'A09.05.023', '    ', 46.2, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7370, '3', '1', '0', 21, NULL, '0', 'A09.05.023', '    ', 46.2, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7371, '3', '1', '0', 22, NULL, '0', 'A09.05.023', '    ', 46.2, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7372, '3', '1', '0', 23, NULL, '0', 'A09.05.023', '    ', 46.2, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7373, '3', '1', '0', 24, NULL, '0', 'A09.05.023', '    ', 46.2, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7374, '3', '1', '0', 25, NULL, '0', 'A09.05.023', '    ', 46.2, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7375, '3', '1', '0', 26, NULL, '0', 'A09.05.023', '    ', 46.2, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7376, '3', '1', '0', 27, NULL, '0', 'A09.05.023', '    ', 46.2, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7377, '3', '1', '0', 28, NULL, '0', 'A09.05.023', '    ', 46.2, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7378, '3', '1', '0', 29, NULL, '0', 'A09.05.023', '    ', 46.2, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7379, '3', '1', '0', 30, NULL, '0', 'A09.05.023', '    ', 46.2, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7380, '3', '1', '0', 31, NULL, '0', 'A09.05.023', '    ', 46.2, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7381, '3', '1', '0', 32, NULL, '0', 'A09.05.023', '    ', 46.2, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7382, '3', '1', '0', 33, NULL, '0', 'A09.05.023', '    ', 46.2, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7383, '3', '1', '0', 34, NULL, '0', 'A09.05.023', '    ', 46.2, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7384, '3', '1', '0', 35, NULL, '0', 'A09.05.023', '    ', 46.2, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7385, '3', '1', '0', 36, NULL, '0', 'A09.05.023', '    ', 46.2, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7386, '3', '1', '0', 37, NULL, '0', 'A09.05.023', '    ', 46.2, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7387, '3', '1', '0', 38, NULL, '0', 'A09.05.023', '    ', 46.2, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7388, '3', '1', '0', 39, NULL, '0', 'A09.05.023', '    ', 46.2, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7389, '3', '1', '0', 40, NULL, '0', 'A09.05.023', '    ', 46.2, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7390, '3', '1', '0', 41, NULL, '0', 'A09.05.023', '    ', 46.2, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7391, '3', '1', '0', 42, NULL, '0', 'A09.05.023', '    ', 46.2, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7392, '3', '1', '0', 43, NULL, '0', 'A09.05.023', '    ', 46.2, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7393, '3', '1', '0', 44, NULL, '0', 'A09.05.023', '    ', 46.2, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7394, '3', '1', '0', 45, NULL, '0', 'A09.05.023', '    ', 46.2, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7395, '3', '1', '0', 46, NULL, '0', 'A09.05.023', '    ', 46.2, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7396, '3', '1', '0', 47, NULL, '0', 'A09.05.023', '    ', 46.2, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7397, '3', '1', '0', 48, NULL, '0', 'A09.05.023', '    ', 46.2, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7398, '3', '1', '0', 49, NULL, '0', 'A09.05.023', '    ', 46.2, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7399, '3', '1', '0', 50, NULL, '0', 'A09.05.023', '    ', 46.2, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7400, '3', '1', '0', 51, NULL, '0', 'A09.05.023', '    ', 46.2, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7401, '3', '1', '0', 52, NULL, '0', 'A09.05.023', '    ', 46.2, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7402, '3', '1', '0', 53, NULL, '0', 'A09.05.023', '    ', 46.2, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7403, '3', '1', '0', 54, NULL, '0', 'A09.05.023', '    ', 46.2, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7404, '3', '1', '0', 55, NULL, '0', 'A09.05.023', '    ', 46.2, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7405, '3', '1', '0', 56, NULL, '0', 'A09.05.023', '    ', 46.2, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7406, '3', '1', '0', 57, NULL, '0', 'A09.05.023', '    ', 46.2, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7407, '3', '1', '0', 58, NULL, '0', 'A09.05.023', '    ', 46.2, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7408, '3', '1', '0', 59, NULL, '0', 'A09.05.023', '    ', 46.2, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7409, '3', '1', '0', 60, NULL, '0', 'A09.05.023', '    ', 46.2, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7410, '3', '1', '0', 61, NULL, '0', 'A09.05.023', '    ', 46.2, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7411, '3', '1', '0', 62, NULL, '0', 'A09.05.023', '    ', 46.2, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7412, '3', '1', '0', 63, NULL, '0', 'A09.05.023', '    ', 46.2, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7413, '3', '1', '0', 64, NULL, '0', 'A09.05.023', '    ', 46.2, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7414, '3', '1', '0', 65, NULL, '0', 'A09.05.023', '    ', 46.2, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7415, '3', '1', '0', 66, NULL, '0', 'A09.05.023', '    ', 46.2, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7416, '3', '1', '0', 67, NULL, '0', 'A09.05.023', '    ', 46.2, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7417, '3', '1', '0', 68, NULL, '0', 'A09.05.023', '    ', 46.2, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7418, '3', '1', '0', 69, NULL, '0', 'A09.05.023', '    ', 46.2, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7419, '3', '1', '0', 70, NULL, '0', 'A09.05.023', '    ', 46.2, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7420, '3', '1', '0', 71, NULL, '0', 'A09.05.023', '    ', 46.2, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7421, '3', '1', '0', 72, NULL, '0', 'A09.05.023', '    ', 46.2, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7422, '3', '1', '0', 73, NULL, '0', 'A09.05.023', '    ', 46.2, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7423, '3', '1', '0', 74, NULL, '0', 'A09.05.023', '    ', 46.2, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7424, '3', '1', '0', 75, NULL, '0', 'A09.05.023', '    ', 46.2, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7425, '3', '1', '0', 76, NULL, '0', 'A09.05.023', '    ', 46.2, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7426, '3', '1', '0', 77, NULL, '0', 'A09.05.023', '    ', 46.2, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7427, '3', '1', '0', 78, NULL, '0', 'A09.05.023', '    ', 46.2, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7428, '3', '1', '0', 79, NULL, '0', 'A09.05.023', '    ', 46.2, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7429, '3', '1', '0', 80, NULL, '0', 'A09.05.023', '    ', 46.2, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7430, '3', '1', '0', 81, NULL, '0', 'A09.05.023', '    ', 46.2, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7431, '3', '1', '0', 82, NULL, '0', 'A09.05.023', '    ', 46.2, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7432, '3', '1', '0', 83, NULL, '0', 'A09.05.023', '    ', 46.2, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7433, '3', '1', '0', 84, NULL, '0', 'A09.05.023', '    ', 46.2, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7434, '3', '1', '0', 85, NULL, '0', 'A09.05.023', '    ', 46.2, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7435, '3', '1', '0', 86, NULL, '0', 'A09.05.023', '    ', 46.2, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7436, '3', '1', '0', 87, NULL, '0', 'A09.05.023', '    ', 46.2, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7437, '3', '1', '0', 88, NULL, '0', 'A09.05.023', '    ', 46.2, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7438, '3', '1', '0', 89, NULL, '0', 'A09.05.023', '    ', 46.2, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7439, '3', '1', '0', 90, NULL, '0', 'A09.05.023', '    ', 46.2, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7440, '3', '1', '0', 91, NULL, '0', 'A09.05.023', '    ', 46.2, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7441, '3', '1', '0', 92, NULL, '0', 'A09.05.023', '    ', 46.2, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7442, '3', '1', '0', 93, NULL, '0', 'A09.05.023', '    ', 46.2, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7443, '3', '1', '0', 94, NULL, '0', 'A09.05.023', '    ', 46.2, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7444, '3', '1', '0', 95, NULL, '0', 'A09.05.023', '    ', 46.2, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7445, '3', '1', '0', 96, NULL, '0', 'A09.05.023', '    ', 46.2, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7446, '3', '1', '0', 97, NULL, '0', 'A09.05.023', '    ', 46.2, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7447, '3', '1', '0', 98, NULL, '0', 'A09.05.023', '    ', 46.2, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7448, '3', '1', '0', 99, NULL, '0', 'A09.05.023', '    ', 46.2, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7449, '3', '1', '0', 18, NULL, '0', 'A06.09.006', ' ', 245.7, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7450, '3', '1', '0', 19, NULL, '0', 'A06.09.006', ' ', 245.7, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7451, '3', '1', '0', 20, NULL, '0', 'A06.09.006', ' ', 245.7, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7452, '3', '1', '0', 21, NULL, '0', 'A06.09.006', ' ', 245.7, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7453, '3', '1', '0', 22, NULL, '0', 'A06.09.006', ' ', 245.7, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7454, '3', '1', '0', 23, NULL, '0', 'A06.09.006', ' ', 245.7, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7455, '3', '1', '0', 24, NULL, '0', 'A06.09.006', ' ', 245.7, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7456, '3', '1', '0', 25, NULL, '0', 'A06.09.006', ' ', 245.7, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7457, '3', '1', '0', 26, NULL, '0', 'A06.09.006', ' ', 245.7, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7458, '3', '1', '0', 27, NULL, '0', 'A06.09.006', ' ', 245.7, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7459, '3', '1', '0', 28, NULL, '0', 'A06.09.006', ' ', 245.7, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7460, '3', '1', '0', 29, NULL, '0', 'A06.09.006', ' ', 245.7, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7461, '3', '1', '0', 30, NULL, '0', 'A06.09.006', ' ', 245.7, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7462, '3', '1', '0', 31, NULL, '0', 'A06.09.006', ' ', 245.7, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7463, '3', '1', '0', 32, NULL, '0', 'A06.09.006', ' ', 245.7, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7464, '3', '1', '0', 33, NULL, '0', 'A06.09.006', ' ', 245.7, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7465, '3', '1', '0', 34, NULL, '0', 'A06.09.006', ' ', 245.7, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7466, '3', '1', '0', 35, NULL, '0', 'A06.09.006', ' ', 245.7, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7467, '3', '1', '0', 36, NULL, '0', 'A06.09.006', ' ', 245.7, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7468, '3', '1', '0', 37, NULL, '0', 'A06.09.006', ' ', 245.7, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7469, '3', '1', '0', 38, NULL, '0', 'A06.09.006', ' ', 245.7, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7470, '3', '1', '0', 39, NULL, '0', 'A06.09.006', ' ', 245.7, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7471, '3', '1', '0', 40, NULL, '0', 'A06.09.006', ' ', 245.7, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7472, '3', '1', '0', 41, NULL, '0', 'A06.09.006', ' ', 245.7, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7473, '3', '1', '0', 42, NULL, '0', 'A06.09.006', ' ', 245.7, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7474, '3', '1', '0', 43, NULL, '0', 'A06.09.006', ' ', 245.7, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7475, '3', '1', '0', 44, NULL, '0', 'A06.09.006', ' ', 245.7, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7476, '3', '1', '0', 45, NULL, '0', 'A06.09.006', ' ', 245.7, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7477, '3', '1', '0', 46, NULL, '0', 'A06.09.006', ' ', 245.7, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7478, '3', '1', '0', 47, NULL, '0', 'A06.09.006', ' ', 245.7, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7479, '3', '1', '0', 48, NULL, '0', 'A06.09.006', ' ', 245.7, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7480, '3', '1', '0', 49, NULL, '0', 'A06.09.006', ' ', 245.7, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7481, '3', '1', '0', 50, NULL, '0', 'A06.09.006', ' ', 245.7, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7482, '3', '1', '0', 51, NULL, '0', 'A06.09.006', ' ', 245.7, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7483, '3', '1', '0', 52, NULL, '0', 'A06.09.006', ' ', 245.7, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7484, '3', '1', '0', 53, NULL, '0', 'A06.09.006', ' ', 245.7, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7485, '3', '1', '0', 54, NULL, '0', 'A06.09.006', ' ', 245.7, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7486, '3', '1', '0', 55, NULL, '0', 'A06.09.006', ' ', 245.7, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7487, '3', '1', '0', 56, NULL, '0', 'A06.09.006', ' ', 245.7, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7488, '3', '1', '0', 57, NULL, '0', 'A06.09.006', ' ', 245.7, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7489, '3', '1', '0', 58, NULL, '0', 'A06.09.006', ' ', 245.7, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7490, '3', '1', '0', 59, NULL, '0', 'A06.09.006', ' ', 245.7, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7491, '3', '1', '0', 60, NULL, '0', 'A06.09.006', ' ', 245.7, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7492, '3', '1', '0', 61, NULL, '0', 'A06.09.006', ' ', 245.7, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7493, '3', '1', '0', 62, NULL, '0', 'A06.09.006', ' ', 245.7, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7494, '3', '1', '0', 63, NULL, '0', 'A06.09.006', ' ', 245.7, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7495, '3', '1', '0', 64, NULL, '0', 'A06.09.006', ' ', 245.7, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7496, '3', '1', '0', 65, NULL, '0', 'A06.09.006', ' ', 245.7, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7497, '3', '1', '0', 66, NULL, '0', 'A06.09.006', ' ', 245.7, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7498, '3', '1', '0', 67, NULL, '0', 'A06.09.006', ' ', 245.7, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7499, '3', '1', '0', 68, NULL, '0', 'A06.09.006', ' ', 245.7, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7500, '3', '1', '0', 69, NULL, '0', 'A06.09.006', ' ', 245.7, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7501, '3', '1', '0', 70, NULL, '0', 'A06.09.006', ' ', 245.7, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7502, '3', '1', '0', 71, NULL, '0', 'A06.09.006', ' ', 245.7, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7503, '3', '1', '0', 72, NULL, '0', 'A06.09.006', ' ', 245.7, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7504, '3', '1', '0', 73, NULL, '0', 'A06.09.006', ' ', 245.7, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7505, '3', '1', '0', 74, NULL, '0', 'A06.09.006', ' ', 245.7, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7506, '3', '1', '0', 75, NULL, '0', 'A06.09.006', ' ', 245.7, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7507, '3', '1', '0', 76, NULL, '0', 'A06.09.006', ' ', 245.7, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7508, '3', '1', '0', 77, NULL, '0', 'A06.09.006', ' ', 245.7, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7509, '3', '1', '0', 78, NULL, '0', 'A06.09.006', ' ', 245.7, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7510, '3', '1', '0', 79, NULL, '0', 'A06.09.006', ' ', 245.7, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7511, '3', '1', '0', 80, NULL, '0', 'A06.09.006', ' ', 245.7, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7512, '3', '1', '0', 81, NULL, '0', 'A06.09.006', ' ', 245.7, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7513, '3', '1', '0', 82, NULL, '0', 'A06.09.006', ' ', 245.7, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7514, '3', '1', '0', 83, NULL, '0', 'A06.09.006', ' ', 245.7, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7515, '3', '1', '0', 84, NULL, '0', 'A06.09.006', ' ', 245.7, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7516, '3', '1', '0', 85, NULL, '0', 'A06.09.006', ' ', 245.7, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7517, '3', '1', '0', 86, NULL, '0', 'A06.09.006', ' ', 245.7, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7518, '3', '1', '0', 87, NULL, '0', 'A06.09.006', ' ', 245.7, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7519, '3', '1', '0', 88, NULL, '0', 'A06.09.006', ' ', 245.7, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7520, '3', '1', '0', 89, NULL, '0', 'A06.09.006', ' ', 245.7, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7521, '3', '1', '0', 90, NULL, '0', 'A06.09.006', ' ', 245.7, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7522, '3', '1', '0', 91, NULL, '0', 'A06.09.006', ' ', 245.7, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7523, '3', '1', '0', 92, NULL, '0', 'A06.09.006', ' ', 245.7, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7524, '3', '1', '0', 93, NULL, '0', 'A06.09.006', ' ', 245.7, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7525, '3', '1', '0', 94, NULL, '0', 'A06.09.006', ' ', 245.7, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7526, '3', '1', '0', 95, NULL, '0', 'A06.09.006', ' ', 245.7, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7527, '3', '1', '0', 96, NULL, '0', 'A06.09.006', ' ', 245.7, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7528, '3', '1', '0', 97, NULL, '0', 'A06.09.006', ' ', 245.7, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7529, '3', '1', '0', 98, NULL, '0', 'A06.09.006', ' ', 245.7, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7530, '3', '1', '0', 99, NULL, '0', 'A06.09.006', ' ', 245.7, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7531, '3', '1', '0', 18, NULL, '0', 'A08.05.010', '        ', 10.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7532, '3', '1', '0', 19, NULL, '0', 'A08.05.010', '        ', 10.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7533, '3', '1', '0', 20, NULL, '0', 'A08.05.010', '        ', 10.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7534, '3', '1', '0', 21, NULL, '0', 'A08.05.010', '        ', 10.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7535, '3', '1', '0', 22, NULL, '0', 'A08.05.010', '        ', 10.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7536, '3', '1', '0', 23, NULL, '0', 'A08.05.010', '        ', 10.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7537, '3', '1', '0', 24, NULL, '0', 'A08.05.010', '        ', 10.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7538, '3', '1', '0', 25, NULL, '0', 'A08.05.010', '        ', 10.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7539, '3', '1', '0', 26, NULL, '0', 'A08.05.010', '        ', 10.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7540, '3', '1', '0', 27, NULL, '0', 'A08.05.010', '        ', 10.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7541, '3', '1', '0', 28, NULL, '0', 'A08.05.010', '        ', 10.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7542, '3', '1', '0', 29, NULL, '0', 'A08.05.010', '        ', 10.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7543, '3', '1', '0', 30, NULL, '0', 'A08.05.010', '        ', 10.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7544, '3', '1', '0', 31, NULL, '0', 'A08.05.010', '        ', 10.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7545, '3', '1', '0', 32, NULL, '0', 'A08.05.010', '        ', 10.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7546, '3', '1', '0', 33, NULL, '0', 'A08.05.010', '        ', 10.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7547, '3', '1', '0', 34, NULL, '0', 'A08.05.010', '        ', 10.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7548, '3', '1', '0', 35, NULL, '0', 'A08.05.010', '        ', 10.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7549, '3', '1', '0', 36, NULL, '0', 'A08.05.010', '        ', 10.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7550, '3', '1', '0', 37, NULL, '0', 'A08.05.010', '        ', 10.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7551, '3', '1', '0', 38, NULL, '0', 'A08.05.010', '        ', 10.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7552, '3', '1', '0', 39, NULL, '0', 'A08.05.010', '        ', 10.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7553, '3', '1', '0', 40, NULL, '0', 'A08.05.010', '        ', 10.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7554, '3', '1', '0', 41, NULL, '0', 'A08.05.010', '        ', 10.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7555, '3', '1', '0', 42, NULL, '0', 'A08.05.010', '        ', 10.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7556, '3', '1', '0', 43, NULL, '0', 'A08.05.010', '        ', 10.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7557, '3', '1', '0', 44, NULL, '0', 'A08.05.010', '        ', 10.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7558, '3', '1', '0', 45, NULL, '0', 'A08.05.010', '        ', 10.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7559, '3', '1', '0', 46, NULL, '0', 'A08.05.010', '        ', 10.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7560, '3', '1', '0', 47, NULL, '0', 'A08.05.010', '        ', 10.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7561, '3', '1', '0', 48, NULL, '0', 'A08.05.010', '        ', 10.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7562, '3', '1', '0', 49, NULL, '0', 'A08.05.010', '        ', 10.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7563, '3', '1', '0', 50, NULL, '0', 'A08.05.010', '        ', 10.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7564, '3', '1', '0', 51, NULL, '0', 'A08.05.010', '        ', 10.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7565, '3', '1', '0', 52, NULL, '0', 'A08.05.010', '        ', 10.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7566, '3', '1', '0', 53, NULL, '0', 'A08.05.010', '        ', 10.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7567, '3', '1', '0', 54, NULL, '0', 'A08.05.010', '        ', 10.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7568, '3', '1', '0', 55, NULL, '0', 'A08.05.010', '        ', 10.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7569, '3', '1', '0', 56, NULL, '0', 'A08.05.010', '        ', 10.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7570, '3', '1', '0', 57, NULL, '0', 'A08.05.010', '        ', 10.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7571, '3', '1', '0', 58, NULL, '0', 'A08.05.010', '        ', 10.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7572, '3', '1', '0', 59, NULL, '0', 'A08.05.010', '        ', 10.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7573, '3', '1', '0', 60, NULL, '0', 'A08.05.010', '        ', 10.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7574, '3', '1', '0', 61, NULL, '0', 'A08.05.010', '        ', 10.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7575, '3', '1', '0', 62, NULL, '0', 'A08.05.010', '        ', 10.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7576, '3', '1', '0', 63, NULL, '0', 'A08.05.010', '        ', 10.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7577, '3', '1', '0', 64, NULL, '0', 'A08.05.010', '        ', 10.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7578, '3', '1', '0', 65, NULL, '0', 'A08.05.010', '        ', 10.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7579, '3', '1', '0', 66, NULL, '0', 'A08.05.010', '        ', 10.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7580, '3', '1', '0', 67, NULL, '0', 'A08.05.010', '        ', 10.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7581, '3', '1', '0', 68, NULL, '0', 'A08.05.010', '        ', 10.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7582, '3', '1', '0', 69, NULL, '0', 'A08.05.010', '        ', 10.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7583, '3', '1', '0', 70, NULL, '0', 'A08.05.010', '        ', 10.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7584, '3', '1', '0', 71, NULL, '0', 'A08.05.010', '        ', 10.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7585, '3', '1', '0', 72, NULL, '0', 'A08.05.010', '        ', 10.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7586, '3', '1', '0', 73, NULL, '0', 'A08.05.010', '        ', 10.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7587, '3', '1', '0', 74, NULL, '0', 'A08.05.010', '        ', 10.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7588, '3', '1', '0', 75, NULL, '0', 'A08.05.010', '        ', 10.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7589, '3', '1', '0', 76, NULL, '0', 'A08.05.010', '        ', 10.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7590, '3', '1', '0', 77, NULL, '0', 'A08.05.010', '        ', 10.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7591, '3', '1', '0', 78, NULL, '0', 'A08.05.010', '        ', 10.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7592, '3', '1', '0', 79, NULL, '0', 'A08.05.010', '        ', 10.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7593, '3', '1', '0', 80, NULL, '0', 'A08.05.010', '        ', 10.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7594, '3', '1', '0', 81, NULL, '0', 'A08.05.010', '        ', 10.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7595, '3', '1', '0', 82, NULL, '0', 'A08.05.010', '        ', 10.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7596, '3', '1', '0', 83, NULL, '0', 'A08.05.010', '        ', 10.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7597, '3', '1', '0', 84, NULL, '0', 'A08.05.010', '        ', 10.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7598, '3', '1', '0', 85, NULL, '0', 'A08.05.010', '        ', 10.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7599, '3', '1', '0', 86, NULL, '0', 'A08.05.010', '        ', 10.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7600, '3', '1', '0', 87, NULL, '0', 'A08.05.010', '        ', 10.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7601, '3', '1', '0', 88, NULL, '0', 'A08.05.010', '        ', 10.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7602, '3', '1', '0', 89, NULL, '0', 'A08.05.010', '        ', 10.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7603, '3', '1', '0', 90, NULL, '0', 'A08.05.010', '        ', 10.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7604, '3', '1', '0', 91, NULL, '0', 'A08.05.010', '        ', 10.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7605, '3', '1', '0', 92, NULL, '0', 'A08.05.010', '        ', 10.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7606, '3', '1', '0', 93, NULL, '0', 'A08.05.010', '        ', 10.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7607, '3', '1', '0', 94, NULL, '0', 'A08.05.010', '        ', 10.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7608, '3', '1', '0', 95, NULL, '0', 'A08.05.010', '        ', 10.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7609, '3', '1', '0', 96, NULL, '0', 'A08.05.010', '        ', 10.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7610, '3', '1', '0', 97, NULL, '0', 'A08.05.010', '        ', 10.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7611, '3', '1', '0', 98, NULL, '0', 'A08.05.010', '        ', 10.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7612, '3', '1', '0', 99, NULL, '0', 'A08.05.010', '        ', 10.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7613, '3', '1', '0', 18, NULL, '0', 'A08.05.004', '    ', 46.2, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7614, '3', '1', '0', 19, NULL, '0', 'A08.05.004', '    ', 46.2, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7615, '3', '1', '0', 20, NULL, '0', 'A08.05.004', '    ', 46.2, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7616, '3', '1', '0', 21, NULL, '0', 'A08.05.004', '    ', 46.2, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7617, '3', '1', '0', 22, NULL, '0', 'A08.05.004', '    ', 46.2, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7618, '3', '1', '0', 23, NULL, '0', 'A08.05.004', '    ', 46.2, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7619, '3', '1', '0', 24, NULL, '0', 'A08.05.004', '    ', 46.2, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7620, '3', '1', '0', 25, NULL, '0', 'A08.05.004', '    ', 46.2, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7621, '3', '1', '0', 26, NULL, '0', 'A08.05.004', '    ', 46.2, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7622, '3', '1', '0', 27, NULL, '0', 'A08.05.004', '    ', 46.2, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7623, '3', '1', '0', 28, NULL, '0', 'A08.05.004', '    ', 46.2, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7624, '3', '1', '0', 29, NULL, '0', 'A08.05.004', '    ', 46.2, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7625, '3', '1', '0', 30, NULL, '0', 'A08.05.004', '    ', 46.2, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7626, '3', '1', '0', 31, NULL, '0', 'A08.05.004', '    ', 46.2, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7627, '3', '1', '0', 32, NULL, '0', 'A08.05.004', '    ', 46.2, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7628, '3', '1', '0', 33, NULL, '0', 'A08.05.004', '    ', 46.2, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7629, '3', '1', '0', 34, NULL, '0', 'A08.05.004', '    ', 46.2, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7630, '3', '1', '0', 35, NULL, '0', 'A08.05.004', '    ', 46.2, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7631, '3', '1', '0', 36, NULL, '0', 'A08.05.004', '    ', 46.2, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7632, '3', '1', '0', 37, NULL, '0', 'A08.05.004', '    ', 46.2, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7633, '3', '1', '0', 38, NULL, '0', 'A08.05.004', '    ', 46.2, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7634, '3', '1', '0', 39, NULL, '0', 'A08.05.004', '    ', 46.2, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7635, '3', '1', '0', 40, NULL, '0', 'A08.05.004', '    ', 46.2, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7636, '3', '1', '0', 41, NULL, '0', 'A08.05.004', '    ', 46.2, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7637, '3', '1', '0', 42, NULL, '0', 'A08.05.004', '    ', 46.2, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7638, '3', '1', '0', 43, NULL, '0', 'A08.05.004', '    ', 46.2, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7639, '3', '1', '0', 44, NULL, '0', 'A08.05.004', '    ', 46.2, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7640, '3', '1', '0', 45, NULL, '0', 'A08.05.004', '    ', 46.2, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7641, '3', '1', '0', 46, NULL, '0', 'A08.05.004', '    ', 46.2, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7642, '3', '1', '0', 47, NULL, '0', 'A08.05.004', '    ', 46.2, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7643, '3', '1', '0', 48, NULL, '0', 'A08.05.004', '    ', 46.2, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7644, '3', '1', '0', 49, NULL, '0', 'A08.05.004', '    ', 46.2, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7645, '3', '1', '0', 50, NULL, '0', 'A08.05.004', '    ', 46.2, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7646, '3', '1', '0', 51, NULL, '0', 'A08.05.004', '    ', 46.2, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7647, '3', '1', '0', 52, NULL, '0', 'A08.05.004', '    ', 46.2, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7648, '3', '1', '0', 53, NULL, '0', 'A08.05.004', '    ', 46.2, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7649, '3', '1', '0', 54, NULL, '0', 'A08.05.004', '    ', 46.2, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7650, '3', '1', '0', 55, NULL, '0', 'A08.05.004', '    ', 46.2, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7651, '3', '1', '0', 56, NULL, '0', 'A08.05.004', '    ', 46.2, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7652, '3', '1', '0', 57, NULL, '0', 'A08.05.004', '    ', 46.2, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7653, '3', '1', '0', 58, NULL, '0', 'A08.05.004', '    ', 46.2, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7654, '3', '1', '0', 59, NULL, '0', 'A08.05.004', '    ', 46.2, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7655, '3', '1', '0', 60, NULL, '0', 'A08.05.004', '    ', 46.2, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7656, '3', '1', '0', 61, NULL, '0', 'A08.05.004', '    ', 46.2, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7657, '3', '1', '0', 62, NULL, '0', 'A08.05.004', '    ', 46.2, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7658, '3', '1', '0', 63, NULL, '0', 'A08.05.004', '    ', 46.2, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7659, '3', '1', '0', 64, NULL, '0', 'A08.05.004', '    ', 46.2, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7660, '3', '1', '0', 65, NULL, '0', 'A08.05.004', '    ', 46.2, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7661, '3', '1', '0', 66, NULL, '0', 'A08.05.004', '    ', 46.2, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7662, '3', '1', '0', 67, NULL, '0', 'A08.05.004', '    ', 46.2, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7663, '3', '1', '0', 68, NULL, '0', 'A08.05.004', '    ', 46.2, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7664, '3', '1', '0', 69, NULL, '0', 'A08.05.004', '    ', 46.2, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7665, '3', '1', '0', 70, NULL, '0', 'A08.05.004', '    ', 46.2, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7666, '3', '1', '0', 71, NULL, '0', 'A08.05.004', '    ', 46.2, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7667, '3', '1', '0', 72, NULL, '0', 'A08.05.004', '    ', 46.2, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7668, '3', '1', '0', 73, NULL, '0', 'A08.05.004', '    ', 46.2, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7669, '3', '1', '0', 74, NULL, '0', 'A08.05.004', '    ', 46.2, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7670, '3', '1', '0', 75, NULL, '0', 'A08.05.004', '    ', 46.2, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7671, '3', '1', '0', 76, NULL, '0', 'A08.05.004', '    ', 46.2, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7672, '3', '1', '0', 77, NULL, '0', 'A08.05.004', '    ', 46.2, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7673, '3', '1', '0', 78, NULL, '0', 'A08.05.004', '    ', 46.2, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7674, '3', '1', '0', 79, NULL, '0', 'A08.05.004', '    ', 46.2, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7675, '3', '1', '0', 80, NULL, '0', 'A08.05.004', '    ', 46.2, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7676, '3', '1', '0', 81, NULL, '0', 'A08.05.004', '    ', 46.2, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7677, '3', '1', '0', 82, NULL, '0', 'A08.05.004', '    ', 46.2, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7678, '3', '1', '0', 83, NULL, '0', 'A08.05.004', '    ', 46.2, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7679, '3', '1', '0', 84, NULL, '0', 'A08.05.004', '    ', 46.2, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7680, '3', '1', '0', 85, NULL, '0', 'A08.05.004', '    ', 46.2, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7681, '3', '1', '0', 86, NULL, '0', 'A08.05.004', '    ', 46.2, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7682, '3', '1', '0', 87, NULL, '0', 'A08.05.004', '    ', 46.2, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7683, '3', '1', '0', 88, NULL, '0', 'A08.05.004', '    ', 46.2, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7684, '3', '1', '0', 89, NULL, '0', 'A08.05.004', '    ', 46.2, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7685, '3', '1', '0', 90, NULL, '0', 'A08.05.004', '    ', 46.2, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7686, '3', '1', '0', 91, NULL, '0', 'A08.05.004', '    ', 46.2, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7687, '3', '1', '0', 92, NULL, '0', 'A08.05.004', '    ', 46.2, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7688, '3', '1', '0', 93, NULL, '0', 'A08.05.004', '    ', 46.2, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7689, '3', '1', '0', 94, NULL, '0', 'A08.05.004', '    ', 46.2, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7690, '3', '1', '0', 95, NULL, '0', 'A08.05.004', '    ', 46.2, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7691, '3', '1', '0', 96, NULL, '0', 'A08.05.004', '    ', 46.2, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7692, '3', '1', '0', 97, NULL, '0', 'A08.05.004', '    ', 46.2, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7693, '3', '1', '0', 98, NULL, '0', 'A08.05.004', '    ', 46.2, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7694, '3', '1', '0', 99, NULL, '0', 'A08.05.004', '    ', 46.2, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7695, '3', '1', '0', 18, NULL, '0', 'A12.05.001', '   ', 13.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7696, '3', '1', '0', 19, NULL, '0', 'A12.05.001', '   ', 13.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7697, '3', '1', '0', 20, NULL, '0', 'A12.05.001', '   ', 13.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7698, '3', '1', '0', 21, NULL, '0', 'A12.05.001', '   ', 13.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7699, '3', '1', '0', 22, NULL, '0', 'A12.05.001', '   ', 13.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7700, '3', '1', '0', 23, NULL, '0', 'A12.05.001', '   ', 13.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7701, '3', '1', '0', 24, NULL, '0', 'A12.05.001', '   ', 13.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7702, '3', '1', '0', 25, NULL, '0', 'A12.05.001', '   ', 13.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7703, '3', '1', '0', 26, NULL, '0', 'A12.05.001', '   ', 13.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7704, '3', '1', '0', 27, NULL, '0', 'A12.05.001', '   ', 13.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7705, '3', '1', '0', 28, NULL, '0', 'A12.05.001', '   ', 13.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7706, '3', '1', '0', 29, NULL, '0', 'A12.05.001', '   ', 13.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7707, '3', '1', '0', 30, NULL, '0', 'A12.05.001', '   ', 13.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7708, '3', '1', '0', 31, NULL, '0', 'A12.05.001', '   ', 13.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7709, '3', '1', '0', 32, NULL, '0', 'A12.05.001', '   ', 13.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7710, '3', '1', '0', 33, NULL, '0', 'A12.05.001', '   ', 13.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7711, '3', '1', '0', 34, NULL, '0', 'A12.05.001', '   ', 13.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7712, '3', '1', '0', 35, NULL, '0', 'A12.05.001', '   ', 13.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7713, '3', '1', '0', 36, NULL, '0', 'A12.05.001', '   ', 13.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7714, '3', '1', '0', 37, NULL, '0', 'A12.05.001', '   ', 13.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7715, '3', '1', '0', 38, NULL, '0', 'A12.05.001', '   ', 13.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7716, '3', '1', '0', 39, NULL, '0', 'A12.05.001', '   ', 13.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7717, '3', '1', '0', 40, NULL, '0', 'A12.05.001', '   ', 13.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7718, '3', '1', '0', 41, NULL, '0', 'A12.05.001', '   ', 13.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7719, '3', '1', '0', 42, NULL, '0', 'A12.05.001', '   ', 13.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7720, '3', '1', '0', 43, NULL, '0', 'A12.05.001', '   ', 13.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7721, '3', '1', '0', 44, NULL, '0', 'A12.05.001', '   ', 13.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7722, '3', '1', '0', 45, NULL, '0', 'A12.05.001', '   ', 13.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7723, '3', '1', '0', 46, NULL, '0', 'A12.05.001', '   ', 13.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7724, '3', '1', '0', 47, NULL, '0', 'A12.05.001', '   ', 13.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7725, '3', '1', '0', 48, NULL, '0', 'A12.05.001', '   ', 13.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7726, '3', '1', '0', 49, NULL, '0', 'A12.05.001', '   ', 13.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7727, '3', '1', '0', 50, NULL, '0', 'A12.05.001', '   ', 13.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7728, '3', '1', '0', 51, NULL, '0', 'A12.05.001', '   ', 13.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7729, '3', '1', '0', 52, NULL, '0', 'A12.05.001', '   ', 13.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7730, '3', '1', '0', 53, NULL, '0', 'A12.05.001', '   ', 13.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7731, '3', '1', '0', 54, NULL, '0', 'A12.05.001', '   ', 13.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7732, '3', '1', '0', 55, NULL, '0', 'A12.05.001', '   ', 13.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7733, '3', '1', '0', 56, NULL, '0', 'A12.05.001', '   ', 13.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7734, '3', '1', '0', 57, NULL, '0', 'A12.05.001', '   ', 13.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7735, '3', '1', '0', 58, NULL, '0', 'A12.05.001', '   ', 13.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7736, '3', '1', '0', 59, NULL, '0', 'A12.05.001', '   ', 13.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7737, '3', '1', '0', 60, NULL, '0', 'A12.05.001', '   ', 13.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7738, '3', '1', '0', 61, NULL, '0', 'A12.05.001', '   ', 13.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7739, '3', '1', '0', 62, NULL, '0', 'A12.05.001', '   ', 13.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7740, '3', '1', '0', 63, NULL, '0', 'A12.05.001', '   ', 13.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7741, '3', '1', '0', 64, NULL, '0', 'A12.05.001', '   ', 13.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7742, '3', '1', '0', 65, NULL, '0', 'A12.05.001', '   ', 13.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7743, '3', '1', '0', 66, NULL, '0', 'A12.05.001', '   ', 13.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7744, '3', '1', '0', 67, NULL, '0', 'A12.05.001', '   ', 13.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7745, '3', '1', '0', 68, NULL, '0', 'A12.05.001', '   ', 13.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7746, '3', '1', '0', 69, NULL, '0', 'A12.05.001', '   ', 13.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7747, '3', '1', '0', 70, NULL, '0', 'A12.05.001', '   ', 13.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7748, '3', '1', '0', 71, NULL, '0', 'A12.05.001', '   ', 13.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7749, '3', '1', '0', 72, NULL, '0', 'A12.05.001', '   ', 13.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7750, '3', '1', '0', 73, NULL, '0', 'A12.05.001', '   ', 13.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7751, '3', '1', '0', 74, NULL, '0', 'A12.05.001', '   ', 13.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7752, '3', '1', '0', 75, NULL, '0', 'A12.05.001', '   ', 13.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7753, '3', '1', '0', 76, NULL, '0', 'A12.05.001', '   ', 13.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7754, '3', '1', '0', 77, NULL, '0', 'A12.05.001', '   ', 13.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7755, '3', '1', '0', 78, NULL, '0', 'A12.05.001', '   ', 13.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7756, '3', '1', '0', 79, NULL, '0', 'A12.05.001', '   ', 13.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7757, '3', '1', '0', 80, NULL, '0', 'A12.05.001', '   ', 13.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7758, '3', '1', '0', 81, NULL, '0', 'A12.05.001', '   ', 13.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7759, '3', '1', '0', 82, NULL, '0', 'A12.05.001', '   ', 13.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7760, '3', '1', '0', 83, NULL, '0', 'A12.05.001', '   ', 13.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7761, '3', '1', '0', 84, NULL, '0', 'A12.05.001', '   ', 13.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7762, '3', '1', '0', 85, NULL, '0', 'A12.05.001', '   ', 13.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7763, '3', '1', '0', 86, NULL, '0', 'A12.05.001', '   ', 13.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7764, '3', '1', '0', 87, NULL, '0', 'A12.05.001', '   ', 13.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7765, '3', '1', '0', 88, NULL, '0', 'A12.05.001', '   ', 13.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7766, '3', '1', '0', 89, NULL, '0', 'A12.05.001', '   ', 13.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7767, '3', '1', '0', 90, NULL, '0', 'A12.05.001', '   ', 13.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7768, '3', '1', '0', 91, NULL, '0', 'A12.05.001', '   ', 13.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7769, '3', '1', '0', 92, NULL, '0', 'A12.05.001', '   ', 13.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7770, '3', '1', '0', 93, NULL, '0', 'A12.05.001', '   ', 13.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7771, '3', '1', '0', 94, NULL, '0', 'A12.05.001', '   ', 13.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7772, '3', '1', '0', 95, NULL, '0', 'A12.05.001', '   ', 13.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7773, '3', '1', '0', 96, NULL, '0', 'A12.05.001', '   ', 13.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7774, '3', '1', '0', 97, NULL, '0', 'A12.05.001', '   ', 13.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7775, '3', '1', '0', 98, NULL, '0', 'A12.05.001', '   ', 13.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7776, '3', '1', '0', 99, NULL, '0', 'A12.05.001', '   ', 13.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7777, '3', '1', '0', 45, NULL, '0', 'A09.19.001', '    ', 13.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7778, '3', '1', '0', 46, NULL, '0', 'A09.19.001', '    ', 13.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7779, '3', '1', '0', 47, NULL, '0', 'A09.19.001', '    ', 13.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7780, '3', '1', '0', 48, NULL, '0', 'A09.19.001', '    ', 13.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7781, '3', '1', '0', 49, NULL, '0', 'A09.19.001', '    ', 13.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7782, '3', '1', '0', 50, NULL, '0', 'A09.19.001', '    ', 13.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7783, '3', '1', '0', 51, NULL, '0', 'A09.19.001', '    ', 13.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7784, '3', '1', '0', 52, NULL, '0', 'A09.19.001', '    ', 13.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7785, '3', '1', '0', 53, NULL, '0', 'A09.19.001', '    ', 13.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7786, '3', '1', '0', 54, NULL, '0', 'A09.19.001', '    ', 13.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7787, '3', '1', '0', 55, NULL, '0', 'A09.19.001', '    ', 13.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7788, '3', '1', '0', 56, NULL, '0', 'A09.19.001', '    ', 13.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7789, '3', '1', '0', 57, NULL, '0', 'A09.19.001', '    ', 13.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7790, '3', '1', '0', 58, NULL, '0', 'A09.19.001', '    ', 13.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7791, '3', '1', '0', 59, NULL, '0', 'A09.19.001', '    ', 13.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7792, '3', '1', '0', 60, NULL, '0', 'A09.19.001', '    ', 13.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7793, '3', '1', '0', 61, NULL, '0', 'A09.19.001', '    ', 13.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7794, '3', '1', '0', 62, NULL, '0', 'A09.19.001', '    ', 13.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7795, '3', '1', '0', 63, NULL, '0', 'A09.19.001', '    ', 13.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7796, '3', '1', '0', 64, NULL, '0', 'A09.19.001', '    ', 13.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7797, '3', '1', '0', 65, NULL, '0', 'A09.19.001', '    ', 13.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7798, '3', '1', '0', 66, NULL, '0', 'A09.19.001', '    ', 13.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7799, '3', '1', '0', 67, NULL, '0', 'A09.19.001', '    ', 13.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7800, '3', '1', '0', 68, NULL, '0', 'A09.19.001', '    ', 13.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7801, '3', '1', '0', 69, NULL, '0', 'A09.19.001', '    ', 13.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7802, '3', '1', '0', 70, NULL, '0', 'A09.19.001', '    ', 13.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7803, '3', '1', '0', 71, NULL, '0', 'A09.19.001', '    ', 13.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7804, '3', '1', '0', 72, NULL, '0', 'A09.19.001', '    ', 13.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7805, '3', '1', '0', 73, NULL, '0', 'A09.19.001', '    ', 13.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7806, '3', '1', '0', 74, NULL, '0', 'A09.19.001', '    ', 13.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7807, '3', '1', '0', 75, NULL, '0', 'A09.19.001', '    ', 13.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7808, '3', '1', '0', 76, NULL, '0', 'A09.19.001', '    ', 13.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7809, '3', '1', '0', 77, NULL, '0', 'A09.19.001', '    ', 13.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7810, '3', '1', '0', 78, NULL, '0', 'A09.19.001', '    ', 13.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7811, '3', '1', '0', 79, NULL, '0', 'A09.19.001', '    ', 13.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7812, '3', '1', '0', 80, NULL, '0', 'A09.19.001', '    ', 13.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7813, '3', '1', '0', 81, NULL, '0', 'A09.19.001', '    ', 13.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7814, '3', '1', '0', 82, NULL, '0', 'A09.19.001', '    ', 13.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7815, '3', '1', '0', 83, NULL, '0', 'A09.19.001', '    ', 13.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7816, '3', '1', '0', 84, NULL, '0', 'A09.19.001', '    ', 13.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7817, '3', '1', '0', 85, NULL, '0', 'A09.19.001', '    ', 13.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7818, '3', '1', '0', 86, NULL, '0', 'A09.19.001', '    ', 13.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7819, '3', '1', '0', 87, NULL, '0', 'A09.19.001', '    ', 13.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7820, '3', '1', '0', 88, NULL, '0', 'A09.19.001', '    ', 13.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7821, '3', '1', '0', 89, NULL, '0', 'A09.19.001', '    ', 13.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7822, '3', '1', '0', 90, NULL, '0', 'A09.19.001', '    ', 13.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7823, '3', '1', '0', 91, NULL, '0', 'A09.19.001', '    ', 13.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7824, '3', '1', '0', 92, NULL, '0', 'A09.19.001', '    ', 13.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7825, '3', '1', '0', 93, NULL, '0', 'A09.19.001', '    ', 13.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7826, '3', '1', '0', 94, NULL, '0', 'A09.19.001', '    ', 13.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7827, '3', '1', '0', 95, NULL, '0', 'A09.19.001', '    ', 13.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7828, '3', '1', '0', 96, NULL, '0', 'A09.19.001', '    ', 13.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7829, '3', '1', '0', 97, NULL, '0', 'A09.19.001', '    ', 13.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7830, '3', '1', '0', 98, NULL, '0', 'A09.19.001', '    ', 13.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7831, '3', '1', '0', 99, NULL, '0', 'A09.19.001', '    ', 13.86, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7832, '3', '1', '0', 18, NULL, '1', 'B04.047.004', ' (, ) -  ', 0, '1', NULL, '2015-01-01', NULL, '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7833, '3', '1', '0', 19, NULL, '1', 'B04.047.004', ' (, ) -  ', 0, '1', NULL, '2015-01-01', NULL, '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7834, '3', '1', '0', 20, NULL, '1', 'B04.047.004', ' (, ) -  ', 0, '1', NULL, '2015-01-01', NULL, '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7835, '3', '1', '0', 21, NULL, '1', 'B04.047.004', ' (, ) -  ', 0, '1', NULL, '2015-01-01', NULL, '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7836, '3', '1', '0', 22, NULL, '1', 'B04.047.004', ' (, ) -  ', 0, '1', NULL, '2015-01-01', NULL, '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7837, '3', '1', '0', 23, NULL, '1', 'B04.047.004', ' (, ) -  ', 0, '1', NULL, '2015-01-01', NULL, '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7838, '3', '1', '0', 24, NULL, '1', 'B04.047.004', ' (, ) -  ', 0, '1', NULL, '2015-01-01', NULL, '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7839, '3', '1', '0', 25, NULL, '1', 'B04.047.004', ' (, ) -  ', 0, '1', NULL, '2015-01-01', NULL, '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7840, '3', '1', '0', 26, NULL, '1', 'B04.047.004', ' (, ) -  ', 0, '1', NULL, '2015-01-01', NULL, '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7841, '3', '1', '0', 27, NULL, '1', 'B04.047.004', ' (, ) -  ', 0, '1', NULL, '2015-01-01', NULL, '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7842, '3', '1', '0', 28, NULL, '1', 'B04.047.004', ' (, ) -  ', 0, '1', NULL, '2015-01-01', NULL, '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7843, '3', '1', '0', 29, NULL, '1', 'B04.047.004', ' (, ) -  ', 0, '1', NULL, '2015-01-01', NULL, '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7844, '3', '1', '0', 30, NULL, '1', 'B04.047.004', ' (, ) -  ', 0, '1', NULL, '2015-01-01', NULL, '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7845, '3', '1', '0', 31, NULL, '1', 'B04.047.004', ' (, ) -  ', 0, '1', NULL, '2015-01-01', NULL, '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7846, '3', '1', '0', 32, NULL, '1', 'B04.047.004', ' (, ) -  ', 0, '1', NULL, '2015-01-01', NULL, '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7847, '3', '1', '0', 33, NULL, '1', 'B04.047.004', ' (, ) -  ', 0, '1', NULL, '2015-01-01', NULL, '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7848, '3', '1', '0', 34, NULL, '1', 'B04.047.004', ' (, ) -  ', 0, '1', NULL, '2015-01-01', NULL, '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7849, '3', '1', '0', 35, NULL, '1', 'B04.047.004', ' (, ) -  ', 0, '1', NULL, '2015-01-01', NULL, '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7850, '3', '1', '0', 36, NULL, '1', 'B04.047.004', ' (, ) -  ', 0, '1', NULL, '2015-01-01', NULL, '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7851, '3', '1', '0', 37, NULL, '1', 'B04.047.004', ' (, ) -  ', 0, '1', NULL, '2015-01-01', NULL, '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7852, '3', '1', '0', 38, NULL, '1', 'B04.047.004', ' (, ) -  ', 0, '1', NULL, '2015-01-01', NULL, '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7853, '3', '1', '0', 39, NULL, '1', 'B04.047.004', ' (, ) -  ', 0, '1', NULL, '2015-01-01', NULL, '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7854, '3', '1', '0', 40, NULL, '1', 'B04.047.004', ' (, ) -  ', 0, '1', NULL, '2015-01-01', NULL, '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7855, '3', '1', '0', 41, NULL, '1', 'B04.047.004', ' (, ) -  ', 0, '1', NULL, '2015-01-01', NULL, '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7856, '3', '1', '0', 42, NULL, '1', 'B04.047.004', ' (, ) -  ', 0, '1', NULL, '2015-01-01', NULL, '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7857, '3', '1', '0', 43, NULL, '1', 'B04.047.004', ' (, ) -  ', 0, '1', NULL, '2015-01-01', NULL, '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7858, '3', '1', '0', 44, NULL, '1', 'B04.047.004', ' (, ) -  ', 0, '1', NULL, '2015-01-01', NULL, '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7859, '3', '1', '0', 45, NULL, '1', 'B04.047.004', ' (, ) -  ', 0, '1', NULL, '2015-01-01', NULL, '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7860, '3', '1', '0', 46, NULL, '1', 'B04.047.004', ' (, ) -  ', 0, '1', NULL, '2015-01-01', NULL, '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7861, '3', '1', '0', 47, NULL, '1', 'B04.047.004', ' (, ) -  ', 0, '1', NULL, '2015-01-01', NULL, '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7862, '3', '1', '0', 48, NULL, '1', 'B04.047.004', ' (, ) -  ', 0, '1', NULL, '2015-01-01', NULL, '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7863, '3', '1', '0', 49, NULL, '1', 'B04.047.004', ' (, ) -  ', 0, '1', NULL, '2015-01-01', NULL, '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7864, '3', '1', '0', 50, NULL, '1', 'B04.047.004', ' (, ) -  ', 0, '1', NULL, '2015-01-01', NULL, '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7865, '3', '1', '0', 51, NULL, '1', 'B04.047.004', ' (, ) -  ', 0, '1', NULL, '2015-01-01', NULL, '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7866, '3', '1', '0', 52, NULL, '1', 'B04.047.004', ' (, ) -  ', 0, '1', NULL, '2015-01-01', NULL, '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7867, '3', '1', '0', 53, NULL, '1', 'B04.047.004', ' (, ) -  ', 0, '1', NULL, '2015-01-01', NULL, '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7868, '3', '1', '0', 54, NULL, '1', 'B04.047.004', ' (, ) -  ', 0, '1', NULL, '2015-01-01', NULL, '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7869, '3', '1', '0', 55, NULL, '1', 'B04.047.004', ' (, ) -  ', 0, '1', NULL, '2015-01-01', NULL, '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7870, '3', '1', '0', 56, NULL, '1', 'B04.047.004', ' (, ) -  ', 0, '1', NULL, '2015-01-01', NULL, '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7871, '3', '1', '0', 57, NULL, '1', 'B04.047.004', ' (, ) -  ', 0, '1', NULL, '2015-01-01', NULL, '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7872, '3', '1', '0', 58, NULL, '1', 'B04.047.004', ' (, ) -  ', 0, '1', NULL, '2015-01-01', NULL, '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7873, '3', '1', '0', 59, NULL, '1', 'B04.047.004', ' (, ) -  ', 0, '1', NULL, '2015-01-01', NULL, '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7874, '3', '1', '0', 60, NULL, '1', 'B04.047.004', ' (, ) -  ', 0, '1', NULL, '2015-01-01', NULL, '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7875, '3', '1', '0', 61, NULL, '1', 'B04.047.004', ' (, ) -  ', 0, '1', NULL, '2015-01-01', NULL, '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7876, '3', '1', '0', 62, NULL, '1', 'B04.047.004', ' (, ) -  ', 0, '1', NULL, '2015-01-01', NULL, '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7877, '3', '1', '0', 63, NULL, '1', 'B04.047.004', ' (, ) -  ', 0, '1', NULL, '2015-01-01', NULL, '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7878, '3', '1', '0', 64, NULL, '1', 'B04.047.004', ' (, ) -  ', 0, '1', NULL, '2015-01-01', NULL, '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7879, '3', '1', '0', 65, NULL, '1', 'B04.047.004', ' (, ) -  ', 0, '1', NULL, '2015-01-01', NULL, '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7880, '3', '1', '0', 66, NULL, '1', 'B04.047.004', ' (, ) -  ', 0, '1', NULL, '2015-01-01', NULL, '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7881, '3', '1', '0', 67, NULL, '1', 'B04.047.004', ' (, ) -  ', 0, '1', NULL, '2015-01-01', NULL, '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7882, '3', '1', '0', 68, NULL, '1', 'B04.047.004', ' (, ) -  ', 0, '1', NULL, '2015-01-01', NULL, '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7883, '3', '1', '0', 69, NULL, '1', 'B04.047.004', ' (, ) -  ', 0, '1', NULL, '2015-01-01', NULL, '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7884, '3', '1', '0', 70, NULL, '1', 'B04.047.004', ' (, ) -  ', 0, '1', NULL, '2015-01-01', NULL, '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7885, '3', '1', '0', 71, NULL, '1', 'B04.047.004', ' (, ) -  ', 0, '1', NULL, '2015-01-01', NULL, '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7886, '3', '1', '0', 72, NULL, '1', 'B04.047.004', ' (, ) -  ', 0, '1', NULL, '2015-01-01', NULL, '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7887, '3', '1', '0', 73, NULL, '1', 'B04.047.004', ' (, ) -  ', 0, '1', NULL, '2015-01-01', NULL, '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7888, '3', '1', '0', 74, NULL, '1', 'B04.047.004', ' (, ) -  ', 0, '1', NULL, '2015-01-01', NULL, '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7889, '3', '1', '0', 75, NULL, '1', 'B04.047.004', ' (, ) -  ', 0, '1', NULL, '2015-01-01', NULL, '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7890, '3', '1', '0', 76, NULL, '1', 'B04.047.004', ' (, ) -  ', 0, '1', NULL, '2015-01-01', NULL, '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7891, '3', '1', '0', 77, NULL, '1', 'B04.047.004', ' (, ) -  ', 0, '1', NULL, '2015-01-01', NULL, '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7892, '3', '1', '0', 78, NULL, '1', 'B04.047.004', ' (, ) -  ', 0, '1', NULL, '2015-01-01', NULL, '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7893, '3', '1', '0', 79, NULL, '1', 'B04.047.004', ' (, ) -  ', 0, '1', NULL, '2015-01-01', NULL, '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7894, '3', '1', '0', 80, NULL, '1', 'B04.047.004', ' (, ) -  ', 0, '1', NULL, '2015-01-01', NULL, '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7895, '3', '1', '0', 81, NULL, '1', 'B04.047.004', ' (, ) -  ', 0, '1', NULL, '2015-01-01', NULL, '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7896, '3', '1', '0', 82, NULL, '1', 'B04.047.004', ' (, ) -  ', 0, '1', NULL, '2015-01-01', NULL, '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7897, '3', '1', '0', 83, NULL, '1', 'B04.047.004', ' (, ) -  ', 0, '1', NULL, '2015-01-01', NULL, '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7898, '3', '1', '0', 84, NULL, '1', 'B04.047.004', ' (, ) -  ', 0, '1', NULL, '2015-01-01', NULL, '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7899, '3', '1', '0', 85, NULL, '1', 'B04.047.004', ' (, ) -  ', 0, '1', NULL, '2015-01-01', NULL, '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7900, '3', '1', '0', 86, NULL, '1', 'B04.047.004', ' (, ) -  ', 0, '1', NULL, '2015-01-01', NULL, '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7901, '3', '1', '0', 87, NULL, '1', 'B04.047.004', ' (, ) -  ', 0, '1', NULL, '2015-01-01', NULL, '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7902, '3', '1', '0', 88, NULL, '1', 'B04.047.004', ' (, ) -  ', 0, '1', NULL, '2015-01-01', NULL, '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7903, '3', '1', '0', 89, NULL, '1', 'B04.047.004', ' (, ) -  ', 0, '1', NULL, '2015-01-01', NULL, '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7904, '3', '1', '0', 90, NULL, '1', 'B04.047.004', ' (, ) -  ', 0, '1', NULL, '2015-01-01', NULL, '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7905, '3', '1', '0', 91, NULL, '1', 'B04.047.004', ' (, ) -  ', 0, '1', NULL, '2015-01-01', NULL, '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7906, '3', '1', '0', 92, NULL, '1', 'B04.047.004', ' (, ) -  ', 0, '1', NULL, '2015-01-01', NULL, '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7907, '3', '1', '0', 93, NULL, '1', 'B04.047.004', ' (, ) -  ', 0, '1', NULL, '2015-01-01', NULL, '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7908, '3', '1', '0', 94, NULL, '1', 'B04.047.004', ' (, ) -  ', 0, '1', NULL, '2015-01-01', NULL, '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7909, '3', '1', '0', 95, NULL, '1', 'B04.047.004', ' (, ) -  ', 0, '1', NULL, '2015-01-01', NULL, '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7910, '3', '1', '0', 96, NULL, '1', 'B04.047.004', ' (, ) -  ', 0, '1', NULL, '2015-01-01', NULL, '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7911, '3', '1', '0', 97, NULL, '1', 'B04.047.004', ' (, ) -  ', 0, '1', NULL, '2015-01-01', NULL, '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7912, '3', '1', '0', 98, NULL, '1', 'B04.047.004', ' (, ) -  ', 0, '1', NULL, '2015-01-01', NULL, '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7913, '3', '1', '0', 99, NULL, '1', 'B04.047.004', ' (, ) -  ', 0, '1', NULL, '2015-01-01', NULL, '1', '1'); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7914, '3', '1', '2', 39, NULL, '0', 'A06.20.004', '', 542.1, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7915, '3', '1', '2', 40, NULL, '0', 'A06.20.004', '', 542.1, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7916, '3', '1', '2', 41, NULL, '0', 'A06.20.004', '', 542.1, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7917, '3', '1', '2', 42, NULL, '0', 'A06.20.004', '', 542.1, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7918, '3', '1', '2', 43, NULL, '0', 'A06.20.004', '', 542.1, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7919, '3', '1', '2', 44, NULL, '0', 'A06.20.004', '', 542.1, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7920, '3', '1', '2', 45, NULL, '0', 'A06.20.004', '', 542.1, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7921, '3', '1', '2', 46, NULL, '0', 'A06.20.004', '', 542.1, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7922, '3', '1', '2', 47, NULL, '0', 'A06.20.004', '', 542.1, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7923, '3', '1', '2', 48, NULL, '0', 'A06.20.004', '', 542.1, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7924, '3', '1', '2', 49, NULL, '0', 'A06.20.004', '', 542.1, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7925, '3', '1', '2', 50, NULL, '0', 'A06.20.004', '', 542.1, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7926, '3', '1', '2', 51, NULL, '0', 'A06.20.004', '', 542.1, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7927, '3', '1', '2', 52, NULL, '0', 'A06.20.004', '', 542.1, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7928, '3', '1', '2', 53, NULL, '0', 'A06.20.004', '', 542.1, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7929, '3', '1', '2', 54, NULL, '0', 'A06.20.004', '', 542.1, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7930, '3', '1', '2', 55, NULL, '0', 'A06.20.004', '', 542.1, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7931, '3', '1', '2', 56, NULL, '0', 'A06.20.004', '', 542.1, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7932, '3', '1', '2', 57, NULL, '0', 'A06.20.004', '', 542.1, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7933, '3', '1', '2', 58, NULL, '0', 'A06.20.004', '', 542.1, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7934, '3', '1', '2', 59, NULL, '0', 'A06.20.004', '', 542.1, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7935, '3', '1', '2', 60, NULL, '0', 'A06.20.004', '', 542.1, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7936, '3', '1', '2', 61, NULL, '0', 'A06.20.004', '', 542.1, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7937, '3', '1', '2', 62, NULL, '0', 'A06.20.004', '', 542.1, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7938, '3', '1', '2', 63, NULL, '0', 'A06.20.004', '', 542.1, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7939, '3', '1', '2', 64, NULL, '0', 'A06.20.004', '', 542.1, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7940, '3', '1', '2', 65, NULL, '0', 'A06.20.004', '', 542.1, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7941, '3', '1', '2', 66, NULL, '0', 'A06.20.004', '', 542.1, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7942, '3', '1', '2', 67, NULL, '0', 'A06.20.004', '', 542.1, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7943, '3', '1', '2', 68, NULL, '0', 'A06.20.004', '', 542.1, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7944, '3', '1', '2', 69, NULL, '0', 'A06.20.004', '', 542.1, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7945, '3', '1', '2', 70, NULL, '0', 'A06.20.004', '', 542.1, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7946, '3', '1', '2', 71, NULL, '0', 'A06.20.004', '', 542.1, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7947, '3', '1', '2', 72, NULL, '0', 'A06.20.004', '', 542.1, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7948, '3', '1', '2', 73, NULL, '0', 'A06.20.004', '', 542.1, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7949, '3', '1', '2', 74, NULL, '0', 'A06.20.004', '', 542.1, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7950, '3', '1', '2', 75, NULL, '0', 'A06.20.004', '', 542.1, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7951, '3', '1', '2', 76, NULL, '0', 'A06.20.004', '', 542.1, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7952, '3', '1', '2', 77, NULL, '0', 'A06.20.004', '', 542.1, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7953, '3', '1', '2', 78, NULL, '0', 'A06.20.004', '', 542.1, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7954, '3', '1', '2', 79, NULL, '0', 'A06.20.004', '', 542.1, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7955, '3', '1', '2', 80, NULL, '0', 'A06.20.004', '', 542.1, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7956, '3', '1', '2', 81, NULL, '0', 'A06.20.004', '', 542.1, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7957, '3', '1', '2', 82, NULL, '0', 'A06.20.004', '', 542.1, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7958, '3', '1', '2', 83, NULL, '0', 'A06.20.004', '', 542.1, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7959, '3', '1', '2', 84, NULL, '0', 'A06.20.004', '', 542.1, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7960, '3', '1', '2', 85, NULL, '0', 'A06.20.004', '', 542.1, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7961, '3', '1', '2', 86, NULL, '0', 'A06.20.004', '', 542.1, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7962, '3', '1', '2', 87, NULL, '0', 'A06.20.004', '', 542.1, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7963, '3', '1', '2', 88, NULL, '0', 'A06.20.004', '', 542.1, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7964, '3', '1', '2', 89, NULL, '0', 'A06.20.004', '', 542.1, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7965, '3', '1', '2', 90, NULL, '0', 'A06.20.004', '', 542.1, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7966, '3', '1', '2', 91, NULL, '0', 'A06.20.004', '', 542.1, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7967, '3', '1', '2', 92, NULL, '0', 'A06.20.004', '', 542.1, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7968, '3', '1', '2', 93, NULL, '0', 'A06.20.004', '', 542.1, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7969, '3', '1', '2', 94, NULL, '0', 'A06.20.004', '', 542.1, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7970, '3', '1', '2', 95, NULL, '0', 'A06.20.004', '', 542.1, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7971, '3', '1', '2', 96, NULL, '0', 'A06.20.004', '', 542.1, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7972, '3', '1', '2', 97, NULL, '0', 'A06.20.004', '', 542.1, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7973, '3', '1', '2', 98, NULL, '0', 'A06.20.004', '', 542.1, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7974, '3', '1', '2', 99, NULL, '0', 'A06.20.004', '', 542.1, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7975, '4', '1', '0', 120, NULL, '1', 'A09.19.002', '   ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7976, '4', '1', '0', 24, NULL, '1', 'B04.064.002', '  (, ) - ', 0, '1', 2.5, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7977, '4', '1', '0', 24, NULL, '1', 'B03.016.006', '  ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7978, '4', '1', '0', 12, NULL, '1', 'B04.035.002', '  (, ) -', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7979, '5', '1', '1', 2, NULL, '1', 'A04.28.003', '   ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7980, '5', '1', '1', 3, NULL, '1', 'A04.28.003', '   ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7981, '5', '1', '2', 2, NULL, '1', 'A04.20.001', '     ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7982, '5', '1', '2', 3, NULL, '1', 'A04.20.001', '     ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7983, '5', '1', '2', 2, NULL, '1', 'A04.20.002', '   ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7984, '5', '1', '2', 3, NULL, '1', 'A04.20.002', '   ', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7985, '4', '1', '0', 1, NULL, '1', 'A04.16.001', '     ()', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7986, '4', '1', '0', 84, NULL, '1', 'A04.16.001', '     ()', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7987, '4', '1', '0', 168, NULL, '1', 'A04.16.001', '     ()', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7988, '5', '1', '0', 2, NULL, '1', 'A04.16.001', '     ()', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7989, '5', '1', '0', 3, NULL, '1', 'A04.16.001', '     ()', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7990, '4', '1', '0', 1, NULL, '1', 'A04.10.002', '', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7991, '4', '1', '0', 84, NULL, '1', 'A04.10.002', '', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7992, '4', '1', '0', 168, NULL, '1', 'A04.10.002', '', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7993, '5', '1', '0', 2, NULL, '1', 'A04.10.002', '', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @
INSERT INTO USL (ID, TD, STAGE, W, AGE, FIRST_SL, OBYAZ, USL_CODE, USL_NAME, SUMV_USL, IS_DOP_TARIF, YET_COUNT, DATE_1, DATE_2, IS_FYS, IS_FINAL_MD)
         VALUES (7994, '5', '1', '0', 3, NULL, '1', 'A04.10.002', '', 0, '0', NULL, '2015-01-01', NULL, NULL, NULL); @

COMMIT WORK; @

CREATE OR ALTER procedure UPDATE_2015
as
declare variable IDK integer; 
begin
  insert into KARTA_TO_TWO (IDK, ID_USL)
  select K.IDK, U.ID
  from KARTA K
  inner join USL U on ((U.STAGE = '2') and
        (U.TD = '0') and
        (U.W = K.W) and
        (U.AGE = K.AGE) and
        (K.TO_TWO like '%|' || U.ID || '|%'))
  where (K.STAGE = '1') and
        (K.TD = '0') and
        (K.TO_TWO <> '') and
        (K.TO_TWO <> '||') and
        (not K.TO_TWO is null)
  order by K.IDK, U.ID;

  insert into KARTA_RISK (IDK, ID_RISK)
  select K.IDK, F.ID_RISK
  from KARTA K
  inner join FRISK F on K.RISK containing '|' || F.ID_RISK || '|'
  where (K.STAGE = '1') and
        ((K.TD = '0') or (K.TD = '3')) and
        (K.RISK <> '') and
        (K.RISK <> '||') and
        (not K.RISK is null)
  order by K.IDK, F.ID_RISK;

  for select K.IDK
      from KARTA K
      where K.DATE_1 >= '01.01.2015'
      into :IDK
  do
  begin
    update KARTA_USL KU
    set KU.ID_USL = (select TC.ID_NEW_FIELD
                     from TMP_COMPARE TC
                     where TC.ID_OLD_FIELD = KU.ID_USL)
    where KU.IDK = :IDK; 

    update KARTA_TO_TWO T
    set T.ID_USL = (select TC.ID_NEW_FIELD
                    from TMP_COMPARE TC
                    where TC.ID_OLD_FIELD = T.ID_USL)
    where T.IDK = :IDK; 
  end

end; @

CREATE INDEX KARTA_IDX_TMP_UPD ON KARTA (STAGE, TD, TO_TWO); @

COMMIT WORK; @

INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1, 5303); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2, 5304); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3, 5305); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4, 5306); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5, 5307); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 6, 5308); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 7, 5309); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 8, 5310); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 9, 5311); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 10, 5312); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 11, 5313); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 12, 5314); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 13, 5315); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 14, 5316); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 15, 5317); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 16, 5318); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 17, 5319); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 18, 5320); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 19, 5321); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 20, 5322); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 21, 5323); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 22, 5324); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 23, 5325); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 24, 5326); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 25, 5327); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 26, 5328); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 27, 5329); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 28, 5330); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 29, 5331); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 30, 5332); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 31, 5333); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 32, 5334); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 33, 5335); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 34, 5336); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 35, 5337); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 36, 5338); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 37, 5339); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 38, 5340); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 39, 5341); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 40, 5342); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 41, 5343); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 42, 5344); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 43, 5345); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 44, 5346); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 45, 5347); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 46, 5348); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 47, 5349); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 48, 5350); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 49, 5351); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 50, 5352); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 51, 5353); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 52, 5354); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 53, 5355); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 54, 5356); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 55, 5357); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 56, 5358); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 57, 5359); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 58, 5360); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 59, 5361); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 60, 5362); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 61, 5363); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 62, 5364); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 63, 5365); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 64, 5366); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 65, 5367); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 66, 5368); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 67, 5369); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 68, 5370); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 69, 5371); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 70, 5372); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 71, 5373); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 72, 5374); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 73, 5375); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 74, 5376); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 75, 5377); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 76, 5378); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 77, 5379); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 78, 5380); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 79, 5381); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 80, 5382); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 81, 5383); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 82, 5384); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 83, 5385); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 84, 5386); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 85, 5387); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 86, 5388); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 87, 5389); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 88, 5390); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 89, 5391); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 90, 5392); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 91, 5393); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 92, 5394); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 93, 5395); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 94, 5396); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 95, 5397); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 96, 5398); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 97, 5399); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 98, 5400); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 99, 5401); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 100, 5402); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 101, 5403); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 102, 5404); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 103, 5405); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 104, 5406); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 105, 5407); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 106, 5408); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 107, 5409); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 108, 5410); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 109, 5411); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 110, 5412); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 111, 5413); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 112, 5414); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 113, 5415); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 114, 5416); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 115, 5417); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 116, 5418); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 117, 5419); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 118, 5420); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 119, 5421); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 120, 5422); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 121, 5423); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 122, 5424); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 123, 5425); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 124, 5426); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 125, 5427); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 126, 5428); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 127, 5429); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 128, 5430); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 129, 5431); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 130, 5432); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 131, 5433); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 132, 5434); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 133, 5435); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 134, 5436); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 135, 5437); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 136, 5438); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 137, 5439); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 138, 5440); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 139, 5441); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 140, 5442); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 141, 5443); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 142, 5444); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 143, 5445); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 144, 5446); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 145, 5447); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 146, 5448); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 147, 5449); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 148, 5450); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 149, 5451); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 150, 5452); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 151, 5453); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 152, 5454); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 153, 5455); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 154, 5456); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 155, 5457); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 156, 5458); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 157, 5459); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 158, 5460); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 159, 5461); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 160, 5462); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 161, 5463); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 162, 5464); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 163, 5465); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 164, 5466); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 165, 5467); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 166, 5468); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 167, 5469); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 168, 5470); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 169, 5471); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 170, 5472); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 171, 5473); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 172, 5474); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 173, 5475); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 174, 5476); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 175, 5477); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 176, 5478); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 177, 5479); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 178, 5480); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 179, 5481); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 180, 5482); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 181, 5483); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 182, 5484); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 183, 5485); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 184, 5486); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 185, 5487); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 186, 5488); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 187, 5489); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 188, 5490); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 189, 5491); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 190, 5492); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 191, 5493); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 192, 5494); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 193, 5495); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 194, 5496); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 195, 5497); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 196, 5498); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 197, 5499); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 198, 5500); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 199, 5501); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 200, 5502); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 201, 5503); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 202, 5504); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 203, 5505); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 204, 5506); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 205, 5507); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 206, 5508); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 207, 5509); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 208, 5510); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 209, 5511); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 210, 5512); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 211, 5513); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 212, 5514); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 213, 5515); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 214, 5516); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 215, 5517); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 216, 5518); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 217, 5519); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 218, 5520); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 219, 5521); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 220, 5522); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 221, 5523); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 222, 5524); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 223, 5525); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 224, 5526); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 225, 5527); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 226, 5528); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 227, 5529); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 228, 5530); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 229, 5531); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 230, 5532); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 231, 5533); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 232, 5534); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 233, 5535); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 234, 5536); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 235, 5537); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 236, 5538); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 237, 5539); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 238, 5540); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 239, 5541); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 240, 5542); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 241, 5543); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 242, 5544); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 243, 5545); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 244, 5546); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 245, 5547); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 246, 5548); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 247, 5549); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 248, 5550); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 249, 5551); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 250, 5552); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 251, 5553); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 252, 5554); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 253, 5555); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 254, 5556); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 255, 5557); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 256, 5558); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 257, 5559); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 258, 5560); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 259, 5561); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 260, 5562); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 261, 5563); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 262, 5564); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 263, 5565); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 264, 5566); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 265, 5567); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 266, 5568); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 267, 5569); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 268, 5570); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 269, 5571); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 270, 5572); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 271, 5573); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 272, 5574); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 273, 5575); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 274, 5576); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 275, 5577); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 276, 5578); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 277, 5579); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 278, 5580); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 279, 5581); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 280, 5582); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 281, 5583); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 282, 5584); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 283, 5585); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 284, 5586); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 285, 5587); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 286, 5588); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 287, 5589); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 288, 5590); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 289, 5591); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 290, 5592); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 291, 5593); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 292, 5594); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 293, 5595); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 294, 5596); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 295, 5597); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 296, 5598); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 297, 5599); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 298, 5600); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 299, 5601); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 300, 5602); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 301, 5603); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 302, 5604); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 303, 5605); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 304, 5606); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 305, 5607); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 306, 5608); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 307, 5609); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 308, 5610); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 309, 5611); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 310, 5612); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 311, 5613); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 312, 5614); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 313, 5615); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 314, 5616); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 315, 5617); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 316, 5618); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 317, 5619); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 318, 5620); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 319, 5621); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 320, 5622); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 321, 5623); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 322, 5624); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 323, 5625); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 324, 5626); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 325, 5627); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 326, 5628); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 327, 5629); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 328, 5630); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 329, 5631); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 330, 5632); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 331, 5633); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 332, 5634); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 333, 5635); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 334, 5636); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 335, 5637); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 336, 5638); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 337, 5639); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 338, 5640); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 339, 5641); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 340, 5642); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 341, 5643); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 342, 5644); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 343, 5645); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 344, 5646); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 345, 5647); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 346, 5648); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 347, 5649); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 348, 5650); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 349, 5651); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 350, 5652); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 351, 5653); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 352, 5654); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 353, 5655); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 354, 5656); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 355, 5657); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 356, 5658); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 357, 5659); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 358, 5660); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 359, 5661); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 360, 5662); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 361, 5663); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 362, 5664); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 363, 5665); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 364, 5666); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 365, 5667); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 366, 5668); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 367, 5669); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 368, 5670); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 369, 5671); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 370, 5672); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 371, 5673); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 372, 5674); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 373, 5675); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 374, 5676); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 375, 5677); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 376, 5678); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 377, 5679); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 378, 5680); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 379, 5681); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 380, 5682); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 381, 5303); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 382, 5304); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 383, 5305); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 384, 5306); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 385, 5307); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 386, 5308); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 387, 5309); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 388, 5310); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 389, 5311); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 390, 5312); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 391, 5313); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 392, 5314); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 393, 5315); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 394, 5316); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 395, 5317); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 396, 5318); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 397, 5319); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 398, 5320); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 399, 5321); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 400, 5322); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 401, 5323); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 402, 5324); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 403, 5325); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 404, 5326); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 405, 5327); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 406, 5328); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 407, 5329); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 408, 5330); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 409, 5331); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 410, 5332); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 411, 5333); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 412, 5334); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 413, 5335); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 414, 5336); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 415, 5337); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 416, 5338); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 417, 5339); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 418, 5340); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 419, 5341); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 420, 5342); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 421, 5343); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 422, 5344); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 423, 5345); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 424, 5346); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 425, 5347); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 426, 5348); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 427, 5349); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 428, 5350); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 429, 5351); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 430, 5352); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 431, 5353); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 432, 5354); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 433, 5355); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 434, 5356); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 435, 5357); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 436, 5358); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 437, 5359); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 438, 5360); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 439, 5361); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 440, 5365); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 441, 5366); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 442, 5367); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 443, 5368); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 444, 5369); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 445, 5370); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 446, 5371); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 447, 5372); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 448, 5373); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 449, 5374); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 450, 5375); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 451, 5376); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 452, 5377); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 453, 5378); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 454, 5379); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 455, 5380); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 456, 5381); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 457, 5382); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 458, 5383); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 459, 5387); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 460, 5388); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 461, 5389); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 462, 5390); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 463, 5391); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 464, 5392); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 465, 5393); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 466, 5394); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 467, 5395); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 468, 5396); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 469, 5397); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 470, 5398); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 471, 5399); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 472, 5400); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 473, 5401); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 474, 5402); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 475, 5403); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 476, 5404); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 477, 5405); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 478, 5683); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 479, 5684); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 480, 5685); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 481, 5686); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 482, 5687); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 483, 5688); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 484, 5689); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 485, 5690); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 486, 5691); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 487, 5692); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 488, 5693); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 489, 5694); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 490, 5695); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 491, 5696); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 492, 5697); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 493, 5698); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 494, 5699); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 495, 5700); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 496, 5701); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 497, 5702); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 498, 5703); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 499, 5704); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 500, 5705); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 501, 5706); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 502, 5707); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 503, 5708); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 504, 5709); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 505, 5406); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 506, 5407); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 507, 5408); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 508, 5409); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 509, 5410); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 510, 5411); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 511, 5412); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 512, 5413); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 513, 5414); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 514, 5415); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 515, 5416); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 516, 5417); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 517, 5418); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 518, 5419); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 519, 5420); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 520, 5421); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 521, 5422); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 522, 5423); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 523, 5424); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 524, 5425); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 525, 5426); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 526, 5427); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 527, 5428); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 528, 5429); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 529, 5430); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 530, 5431); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 531, 5432); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 532, 5710); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 533, 5711); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 534, 5712); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 535, 5713); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 536, 5714); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 537, 5715); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 538, 5716); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 539, 5717); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 540, 5718); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 541, 5719); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 542, 5720); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 543, 5721); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 544, 5722); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 545, 5723); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 546, 5724); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 547, 5725); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 548, 5726); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 549, 5727); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 550, 5728); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 551, 5729); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 552, 5730); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 553, 5433); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 554, 5434); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 555, 5435); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 556, 5436); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 557, 5437); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 558, 5438); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 559, 5439); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 560, 5440); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 561, 5441); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 562, 5442); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 563, 5443); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 564, 5444); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 565, 5445); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 566, 5446); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 567, 5447); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 568, 5448); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 569, 5449); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 570, 5450); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 571, 5451); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 572, 5452); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 573, 5453); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 574, 5454); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 575, 5455); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 576, 5456); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 577, 5457); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 578, 5458); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 579, 5459); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 580, 5460); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 581, 5461); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 582, 5462); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 583, 5463); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 584, 5464); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 585, 5465); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 586, 5466); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 587, 5467); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 588, 5468); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 589, 5469); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 590, 5470); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 591, 5471); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 592, 5472); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 593, 5473); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 594, 5474); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 595, 5475); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 596, 5476); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 597, 5477); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 598, 5478); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 599, 5479); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 600, 5480); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 601, 5481); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 602, 5482); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 603, 5483); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 604, 5484); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 605, 5485); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 606, 5486); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 607, 5487); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 608, 5488); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 609, 5489); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 610, 5490); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 611, 5491); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 612, 5492); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 613, 5493); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 614, 5494); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 615, 5495); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 616, 5496); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 617, 5497); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 618, 5498); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 619, 5499); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 620, 5500); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 621, 5501); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 622, 5502); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 623, 5503); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 624, 5504); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 625, 5505); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 626, 5506); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 627, 5507); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 628, 5508); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 629, 5509); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 630, 5510); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 631, 5511); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 632, 5512); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 633, 5513); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 634, 5514); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 635, 5515); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 636, 5516); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 637, 5517); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 638, 5518); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 639, 5519); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 640, 5520); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 641, 5521); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 642, 5522); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 643, 5523); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 644, 5524); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 645, 5525); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 646, 5526); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 647, 5527); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 648, 5528); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 649, 5529); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 650, 5530); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 651, 5531); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 652, 5532); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 653, 5533); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 654, 5534); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 655, 5535); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 656, 5536); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 657, 5537); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 658, 5538); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 659, 5539); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 660, 5540); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 661, 5541); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 662, 5542); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 663, 5543); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 664, 5544); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 665, 5545); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 666, 5546); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 667, 5547); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 668, 5548); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 669, 5549); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 670, 5550); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 671, 5551); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 672, 5552); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 673, 5553); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 674, 5554); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 675, 5555); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 676, 5556); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 677, 5557); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 678, 5558); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 679, 5559); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 680, 5560); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 681, 5561); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 682, 5562); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 683, 5563); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 684, 5564); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 685, 5582); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 686, 5583); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 687, 5584); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 688, 5585); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 689, 5586); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 690, 5587); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 691, 5588); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 692, 5589); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 693, 5590); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 694, 5591); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 695, 5592); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 696, 5593); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 697, 5594); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 698, 5595); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 699, 5596); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 700, 5597); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 701, 5598); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 702, 5599); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 703, 5600); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 704, 5601); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 705, 5602); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 706, 5603); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 707, 5604); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 708, 5605); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 709, 5606); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 710, 5607); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 711, 5608); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 712, 5609); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 713, 5610); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 714, 5611); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 715, 5612); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 716, 5613); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 717, 5614); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 718, 5615); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 719, 5616); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 720, 5617); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 721, 5618); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 722, 5619); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 723, 5620); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 724, 5621); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 725, 5622); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 726, 5623); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 727, 5624); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 728, 5625); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 729, 5626); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 730, 5627); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 731, 5628); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 732, 5629); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 733, 5630); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 734, 5631); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 735, 5632); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 736, 5633); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 737, 5634); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 738, 5635); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 739, 5636); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 740, 5637); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 741, 5638); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 742, 5639); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 743, 5640); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 744, 5641); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 745, 5642); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 746, 5643); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 747, 5644); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 748, 5645); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 749, 5646); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 750, 5647); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 751, 5648); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 752, 5649); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 753, 5650); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 754, 5651); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 755, 5652); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 756, 5653); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 757, 5654); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 758, 5655); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 759, 5656); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 760, 5657); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 761, 5658); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 762, 5659); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 763, 5660); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 764, 5661); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 765, 5662); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 766, 5663); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 767, 5664); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 768, 5665); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 769, 5666); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 770, 5667); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 771, 5668); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 772, 5669); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 773, 5670); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 774, 5671); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 775, 5672); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 776, 5673); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 777, 5674); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 778, 5675); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 779, 5676); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 780, 5677); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 781, 5678); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 782, 5679); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 783, 5680); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 784, 5681); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 785, 5682); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 786, 5731); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 787, 5732); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 788, 5733); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 789, 5734); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 790, 5735); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 791, 5736); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 792, 5737); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 793, 5738); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 794, 5739); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 795, 5740); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 796, 5741); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 797, 5742); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 798, 5743); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 799, 5744); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 800, 5745); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 801, 5746); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 802, 5747); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 803, 5748); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 804, 5749); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 805, 5750); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 806, 5751); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 807, 5752); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 808, 5753); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 809, 5754); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 810, 5755); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 811, 5756); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 812, 5757); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 813, 5758); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 814, 5759); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 815, 5760); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 816, 5761); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 817, 5762); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 818, 5763); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 819, 5764); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 820, 5765); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 821, 5766); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 822, 5767); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 823, 5768); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 824, 5769); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 825, 5770); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 826, 5771); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 827, 5772); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 828, 5773); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 829, 5774); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 830, 5775); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 831, 5776); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 832, 5777); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 833, 5778); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 834, 5779); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 835, 5780); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 836, 5781); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 837, 5782); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 838, 5783); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 839, 5784); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 840, 5785); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 841, 5786); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 842, 5787); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 843, 5788); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 844, 5789); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 845, 5790); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 846, 5791); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 847, 5792); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 848, 5793); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 849, 5794); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 850, 5795); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 851, 5796); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 852, 5797); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 853, 5798); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 854, 5799); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 855, 5800); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 856, 5801); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 857, 5802); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 858, 5803); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 859, 5804); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 860, 5805); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 861, 5806); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 862, 5807); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 863, 5808); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 864, 5809); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 865, 5810); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 866, 5811); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 867, 5812); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 868, 5813); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 869, 5814); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 870, 5815); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 871, 5816); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 872, 5817); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 873, 5818); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 874, 5819); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 875, 5820); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 876, 5821); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 877, 5822); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 878, 5823); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 879, 5824); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 880, 5825); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 881, 5826); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 882, 5827); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 883, 5828); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 884, 5829); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 885, 5830); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 886, 5831); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 887, 5832); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 888, 5833); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 889, 5834); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 890, 5835); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 891, 5836); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 892, 5837); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 893, 5838); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 894, 5839); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 895, 5840); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 896, 5841); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 897, 5842); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 898, 5843); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 899, 5844); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 900, 5845); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 901, 5846); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 902, 5847); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 903, 5848); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 904, 5849); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 905, 5850); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 906, 5851); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 907, 5852); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 908, 5853); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 909, 5854); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 910, 5855); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 911, 5856); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 912, 5857); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 913, 5858); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 914, 5859); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 915, 5860); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 916, 5861); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 917, 5862); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 918, 5863); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 919, 5864); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 920, 5865); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 921, 5866); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 922, 5867); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 923, 5868); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 924, 5869); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 925, 5870); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 926, 5871); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 927, 5872); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 928, 5873); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 929, 5874); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 930, 5875); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 931, 5876); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 932, 5877); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 933, 5878); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 934, 5879); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 935, 5880); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 936, 5881); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 937, 5882); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 938, 5883); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 939, 5884); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 940, 5885); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 941, 5886); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 942, 5887); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 943, 5888); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 944, 5889); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 945, 5890); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 946, 5891); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 947, 5892); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 948, 5893); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 949, 5894); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 950, 5895); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 951, 5896); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 952, 5897); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 953, 5898); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 954, 5899); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 955, 5900); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 956, 5901); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 957, 5902); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 958, 5903); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 959, 5904); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 960, 5905); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 961, 5906); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 962, 5907); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 963, 5908); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 964, 5909); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 965, 5910); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 966, 5911); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 967, 5912); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 968, 5913); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 969, 5914); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 970, 5915); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 971, 5916); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 972, 5917); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 973, 5918); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 974, 5919); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 975, 5920); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 976, 5921); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 977, 5922); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 978, 5923); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 979, 5924); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 980, 5925); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 981, 5926); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 982, 5927); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 983, 5928); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 984, 5929); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 985, 5930); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 986, 5931); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 987, 5932); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 988, 5933); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 989, 5934); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 990, 5935); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 991, 5936); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 992, 5937); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 993, 5938); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 994, 5939); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 995, 5940); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 996, 5941); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 997, 5942); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 998, 5943); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 999, 5944); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1000, 5945); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1001, 5946); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1002, 5947); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1003, 5948); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1004, 5949); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1005, 5950); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1006, 5951); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1007, 5952); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1008, 5953); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1009, 5954); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1010, 5955); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1011, 5956); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1012, 5957); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1013, 5958); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1014, 5959); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1015, 5960); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1016, 5961); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1017, 5962); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1018, 5963); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1019, 5964); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1020, 5965); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1021, 5966); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1022, 5967); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1023, 5968); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1024, 5969); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1025, 5970); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1026, 5971); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1027, 5972); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1028, 5973); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1029, 5974); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1030, 5975); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1031, 5976); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1032, 5977); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1033, 5978); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1034, 5979); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1035, 5980); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1036, 5981); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1037, 5982); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1038, 5983); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1039, 5984); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1040, 5985); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1041, 5986); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1042, 5987); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1043, 5988); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1044, 5989); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1045, 5990); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1046, 5991); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1047, 5992); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1048, 5993); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1049, 5994); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1050, 5995); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1051, 5996); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1052, 5997); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1053, 5998); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1054, 5999); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1055, 6000); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1056, 6001); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1057, 6002); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1058, 6003); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1059, 6004); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1060, 6005); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1061, 6006); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1062, 6007); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1063, 6008); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1064, 6009); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1065, 6010); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1066, 6011); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1067, 6012); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1068, 6013); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1069, 6014); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1070, 6015); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1071, 6016); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1072, 6017); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1073, 6018); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1074, 6019); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1075, 6020); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1076, 6021); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1077, 6022); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1078, 6023); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1079, 6024); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1080, 6025); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1081, 6026); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1082, 6027); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1083, 6028); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1084, 6029); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1085, 6030); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1086, 6031); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1087, 6032); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1088, 6033); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1089, 6034); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1090, 6035); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1091, 6036); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1092, 6037); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1093, 6038); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1094, 6039); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1095, 6040); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1096, 6041); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1097, 6042); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1098, 6043); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1099, 6044); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1100, 6045); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1101, 6046); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1102, 6047); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1103, 6048); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1104, 6049); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1105, 6050); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1106, 6051); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1107, 6052); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1108, 6053); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1109, 6054); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1110, 6055); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1111, 6056); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1112, 6057); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1113, 6058); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1114, 6059); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1115, 6060); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1116, 5733); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1117, 5734); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1118, 5735); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1119, 5736); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1120, 5737); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1121, 5738); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1122, 5739); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1123, 5740); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1124, 5741); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1125, 5742); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1126, 5743); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1127, 5744); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1128, 5745); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1129, 5746); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1130, 5747); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1131, 5748); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1132, 5749); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1133, 5750); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1134, 5751); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1135, 5752); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1136, 5753); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1137, 5754); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1138, 5755); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1139, 5756); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1140, 5757); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1141, 5758); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1142, 5759); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1143, 5760); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1144, 5761); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1145, 5762); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1146, 5763); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1147, 5764); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1148, 5765); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1149, 5766); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1150, 5767); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1151, 5768); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1152, 5769); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1153, 5770); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1154, 5771); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1155, 5772); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1156, 5773); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1157, 5774); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1158, 5775); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1159, 5776); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1160, 5777); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1161, 5778); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1162, 5779); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1163, 5780); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1164, 5781); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1165, 5782); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1166, 5783); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1167, 5784); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1168, 5785); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1169, 5786); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1170, 5787); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1171, 5788); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1172, 5789); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1173, 5790); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1174, 5791); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1175, 5792); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1176, 5793); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1177, 5794); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1178, 5795); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1179, 5796); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1180, 5797); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1181, 5798); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1182, 5799); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1183, 5800); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1184, 5801); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1185, 5802); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1186, 5803); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1187, 5804); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1188, 5805); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1189, 5806); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1190, 5807); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1191, 5808); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1192, 5809); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1193, 5810); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1194, 5811); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1195, 5812); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1196, 5813); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1197, 5814); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1198, 5815); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1199, 5816); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1200, 5817); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1201, 5818); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1202, 5819); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1203, 5820); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1204, 5821); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1205, 5822); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1206, 5823); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1207, 5824); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1208, 5825); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1209, 5826); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1210, 5827); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1211, 5828); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1212, 5829); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1213, 5830); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1214, 5831); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1215, 5832); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1216, 5833); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1217, 5834); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1218, 5835); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1219, 5836); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1220, 5837); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1221, 5838); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1222, 5839); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1223, 5840); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1224, 5841); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1225, 5859); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1226, 5860); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1227, 5861); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1228, 5862); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1229, 5863); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1230, 5864); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1231, 5865); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1232, 5866); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1233, 5867); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1234, 5868); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1235, 5869); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1236, 5870); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1237, 5871); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1238, 5872); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1239, 5873); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1240, 5874); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1241, 5875); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1242, 5876); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1243, 5877); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1244, 6061); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1245, 6062); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1246, 6063); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1247, 6064); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1248, 6065); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1249, 6066); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1250, 6067); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1251, 6068); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1252, 6069); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1253, 6070); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1254, 6071); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1255, 6072); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1256, 6073); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1257, 6074); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1258, 6075); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1259, 6076); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1260, 6077); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1261, 6078); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1262, 6079); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1263, 6080); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1264, 6081); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1265, 6082); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1266, 6083); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1267, 6084); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1268, 6085); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1269, 6086); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1270, 6087); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1271, 5878); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1272, 5879); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1273, 5880); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1274, 5881); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1275, 5882); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1276, 5883); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1277, 5884); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1278, 5885); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1279, 5886); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1280, 5887); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1281, 5888); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1282, 5889); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1283, 5890); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1284, 5891); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1285, 5892); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1286, 5893); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1287, 5894); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1288, 5895); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1289, 5896); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1290, 5897); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1291, 5898); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1292, 5899); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1293, 5900); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1294, 5901); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1295, 5902); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1296, 5903); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1297, 5904); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1298, 5905); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1299, 5906); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1300, 5907); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1301, 5908); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1302, 5909); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1303, 5910); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1304, 5911); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1305, 5912); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1306, 5913); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1307, 5914); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1308, 5915); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1309, 5916); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1310, 5917); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1311, 5918); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1312, 5919); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1313, 5920); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1314, 5921); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1315, 5922); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1316, 5923); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1317, 5924); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1318, 5925); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1319, 5926); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1320, 5927); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1321, 5928); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1322, 5929); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1323, 5930); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1324, 5931); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1325, 5932); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1326, 5933); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1327, 5934); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1328, 5935); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1329, 5936); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1330, 5937); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1331, 5938); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1332, 5939); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1333, 5940); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1334, 5941); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1335, 5942); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1336, 5943); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1337, 5944); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1338, 5945); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1339, 5946); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1340, 5947); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1341, 5948); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1342, 5949); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1343, 5950); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1344, 5951); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1345, 5952); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1346, 5953); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1347, 5954); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1348, 5955); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1349, 5956); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1350, 5957); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1351, 5958); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1352, 5959); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1353, 5960); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1354, 5961); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1355, 5962); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1356, 5963); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1357, 5964); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1358, 5965); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1359, 5966); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1360, 5967); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1361, 5968); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1362, 5969); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1363, 5970); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1364, 5971); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1365, 5972); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1366, 5973); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1367, 5974); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1368, 5975); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1369, 5976); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1370, 5977); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1371, 5978); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1372, 5979); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1373, 5980); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1374, 5981); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1375, 5982); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1376, 5983); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1377, 5984); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1378, 5985); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1379, 5986); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1380, 5987); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1381, 5988); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1382, 5989); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1383, 5990); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1384, 5991); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1385, 5992); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1386, 5993); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1387, 5994); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1388, 5995); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1389, 5996); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1390, 5997); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1391, 5998); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1392, 5999); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1393, 6000); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1394, 6001); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1395, 6002); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1396, 6003); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1397, 6004); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1398, 6005); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1399, 6006); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1400, 6007); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1401, 6008); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1402, 6009); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1403, 6010); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1404, 6011); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1405, 6012); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1406, 6013); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1407, 6014); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1408, 6015); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1409, 6016); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1410, 6017); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1411, 6018); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1412, 6019); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1413, 6020); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1414, 6021); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1415, 6022); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1416, 6023); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1417, 6024); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1418, 6025); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1419, 6026); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1420, 6027); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1421, 6028); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1422, 6029); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1423, 6030); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1424, 6031); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1425, 6032); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1426, 6033); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1427, 6034); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1428, 6035); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1429, 6036); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1430, 6037); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1431, 6038); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1432, 6039); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1433, 6040); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1434, 6041); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1435, 6042); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1436, 6043); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1437, 6044); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1438, 6045); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1439, 6046); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1440, 6047); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1441, 6048); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1442, 6049); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1443, 6050); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1444, 6051); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1445, 6052); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1446, 6053); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1447, 6054); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1448, 6055); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1449, 6056); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1450, 6057); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1451, 6058); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1452, 6059); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1453, 6060); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1454, 6088); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1455, 6089); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1456, 6090); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1457, 6091); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1458, 6092); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1459, 6093); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1460, 6094); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1461, 6095); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1462, 6096); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1463, 6097); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1464, 6098); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1465, 6099); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1466, 6100); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1467, 6101); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1468, 6102); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1469, 6103); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1470, 6104); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1471, 6105); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1472, 6106); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1473, 6107); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1474, 6108); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1475, 6109); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1476, 6110); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1477, 6111); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1478, 6112); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1479, 6113); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1480, 6114); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1481, 6115); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1482, 6116); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1483, 6117); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1484, 6118); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1485, 6119); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1486, 6120); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1487, 6121); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1488, 6122); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1489, 6123); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1490, 6124); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1491, 6125); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1492, 6126); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1493, 6127); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1494, 6128); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1495, 6129); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1496, 6130); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1498, 6131); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1499, 6132); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1500, 6133); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1501, 6134); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1502, 6135); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1503, 6136); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1504, 6137); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1505, 6138); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1506, 6139); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1507, 6140); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1508, 6141); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1509, 6142); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1510, 6143); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1511, 6144); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1512, 6145); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1513, 6146); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1514, 6147); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1515, 6148); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1516, 6149); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1517, 6150); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1518, 6151); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1519, 6152); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1520, 6153); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1521, 6154); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1522, 6155); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1523, 6156); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1524, 6157); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1525, 6158); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1526, 6159); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1527, 6160); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1528, 6161); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1529, 6162); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1530, 6163); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1531, 6164); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1532, 6165); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1533, 6166); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1534, 6167); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1535, 6168); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1536, 6169); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1537, 6170); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1538, 6171); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1539, 6172); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1540, 6173); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1541, 6174); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1542, 6175); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1543, 6176); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1544, 6177); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1545, 6178); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1546, 6179); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1547, 6180); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1548, 6181); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1549, 6182); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1550, 6183); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1551, 6184); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1552, 6185); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1553, 6186); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1554, 6187); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1555, 6188); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1556, 6189); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1557, 6190); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1558, 6191); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1559, 6192); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1560, 6193); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1561, 6194); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1562, 6195); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1563, 6196); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1564, 6197); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1565, 6198); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1566, 6199); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1567, 6200); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1568, 6201); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1569, 6202); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1570, 6203); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1571, 6204); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1572, 6205); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1573, 6206); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1574, 6207); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1575, 6208); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1576, 6209); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1577, 6210); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1578, 6211); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1579, 6212); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1580, 6213); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1581, 6214); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1582, 6215); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1583, 6216); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1584, 6217); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1585, 6218); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1586, 6219); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1587, 6220); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1588, 6221); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1589, 6222); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1590, 6223); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1591, 6224); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1592, 6225); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1593, 6226); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1594, 6227); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1595, 6228); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1596, 6229); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1597, 6230); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1598, 6231); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1599, 6232); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1600, 6233); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1601, 6234); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1602, 6235); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1603, 6236); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1604, 6237); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1605, 6238); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1606, 6239); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1607, 6240); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1608, 6241); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1609, 6242); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1610, 6243); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1611, 6244); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1612, 6245); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1613, 6246); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1614, 6247); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1615, 6248); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1616, 6249); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1617, 6250); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1618, 6251); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1619, 6252); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1620, 6253); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1621, 6254); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1622, 6255); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1623, 6256); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1624, 6257); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1625, 6258); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1626, 6259); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1627, 6260); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1628, 6261); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1629, 6262); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1630, 6263); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1631, 6264); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1632, 6265); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1633, 6266); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1634, 6267); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1635, 6268); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1636, 6269); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1637, 6270); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1638, 6271); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1639, 6272); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1640, 6273); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1641, 6274); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1642, 6275); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1643, 6276); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1644, 6277); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1645, 6278); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1646, 6279); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1647, 6280); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1648, 6281); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1649, 6282); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1650, 6283); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1651, 6284); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1652, 6285); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1653, 6286); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1654, 6287); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1655, 6288); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1656, 6289); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1657, 6290); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1658, 6291); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1659, 6292); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1660, 6293); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1661, 6294); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1662, 6295); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1663, 6296); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1664, 6297); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1665, 6298); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1666, 6299); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1667, 6300); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1668, 6301); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1669, 6302); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1670, 6303); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1671, 6304); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1672, 6305); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1673, 6306); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1674, 6307); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1675, 6308); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1676, 6309); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1677, 6310); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1678, 6311); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1679, 6312); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1680, 6313); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1681, 6314); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1682, 6315); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1683, 6316); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1684, 6317); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1685, 6318); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1686, 6319); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1687, 6320); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1688, 6321); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1689, 6322); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1690, 6323); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1691, 6324); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1692, 6325); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1693, 6326); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1694, 6327); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1695, 6328); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1696, 6329); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1697, 6330); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1698, 6331); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1699, 6332); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1700, 6333); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1701, 6334); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1702, 6335); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1703, 6336); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1704, 6337); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1705, 6338); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1706, 6339); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1707, 6340); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1708, 6341); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1709, 6342); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1710, 6343); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1711, 6344); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1712, 6345); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1713, 6346); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1714, 6347); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1715, 6348); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1716, 6349); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1717, 6350); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1718, 6351); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1719, 6352); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1720, 6353); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1721, 6354); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1722, 6355); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1723, 6356); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1724, 6357); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1725, 6358); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1726, 6359); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1727, 6360); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1728, 6361); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1729, 6362); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1730, 6363); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1731, 6364); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1732, 6365); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1733, 6366); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1734, 6367); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1735, 6368); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1736, 6369); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1737, 6370); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1738, 6371); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1739, 6372); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1740, 6373); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1741, 6374); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1742, 6375); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1743, 6376); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1744, 6377); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1745, 6378); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1746, 6379); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1747, 6380); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1748, 6381); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1749, 6382); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1750, 6383); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1751, 6384); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1752, 6385); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1753, 6386); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1754, 6387); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1755, 6388); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1756, 6389); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1757, 6390); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1758, 6391); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1759, 6392); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1760, 6393); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1761, 6394); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1762, 6395); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1763, 6396); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1764, 6397); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1765, 6398); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1766, 6399); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1767, 6400); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1768, 6401); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1769, 6402); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1770, 6403); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1771, 6404); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1772, 6405); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1773, 6406); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1774, 6407); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1775, 6408); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1776, 6409); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1777, 6410); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1778, 6411); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1779, 6412); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1780, 6413); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1781, 6414); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1782, 6415); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1783, 6416); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1784, 6417); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1785, 6418); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1786, 6419); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1787, 6420); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1788, 6421); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1789, 6422); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1790, 6423); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1791, 6424); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1792, 6425); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1793, 6426); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1794, 6427); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1795, 6428); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1796, 6429); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1797, 6430); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1798, 6431); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1799, 6432); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1800, 6433); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1801, 6434); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1802, 6435); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1803, 6090); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1804, 6091); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1805, 6092); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1806, 6093); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1807, 6094); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1808, 6095); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1809, 6096); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1810, 6097); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1811, 6098); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1812, 6099); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1813, 6100); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1814, 6101); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1815, 6102); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1816, 6103); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1817, 6104); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1818, 6105); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1819, 6106); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1820, 6107); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1821, 6108); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1822, 6109); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1823, 6110); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1824, 6111); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1825, 6112); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1826, 6113); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1827, 6114); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1828, 6115); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1829, 6116); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1830, 6117); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1831, 6118); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1832, 6119); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1833, 6120); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1834, 6121); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1835, 6122); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1836, 6123); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1837, 6124); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1838, 6125); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1839, 6126); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1840, 6127); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1841, 6128); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1842, 6129); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1843, 6130); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1844, 6436); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1845, 6131); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1846, 6132); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1847, 6133); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1848, 6134); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1849, 6135); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1850, 6136); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1851, 6137); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1852, 6138); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1853, 6139); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1854, 6140); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1855, 6141); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1856, 6142); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1857, 6143); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1858, 6144); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1859, 6145); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1860, 6146); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1861, 6147); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1862, 6148); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1863, 6149); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1864, 6150); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1865, 6151); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1866, 6152); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1867, 6153); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1868, 6154); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1869, 6155); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1870, 6156); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1871, 6157); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1872, 6158); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1873, 6159); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1874, 6160); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1875, 6161); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1876, 6162); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1877, 6163); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1878, 6164); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1879, 6165); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1880, 6166); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1881, 6167); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1882, 6168); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1883, 6169); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1884, 6170); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1885, 6171); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1886, 6172); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1887, 6173); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1888, 6174); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1889, 6175); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1890, 6176); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1891, 6177); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1892, 6178); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1893, 6179); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1894, 6180); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1895, 6181); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1896, 6182); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1897, 6183); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1898, 6184); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1899, 6185); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1900, 6186); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1901, 6187); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1902, 6188); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1903, 6189); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1904, 6190); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1905, 6191); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1906, 6192); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1907, 6193); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1908, 6194); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1909, 6195); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1910, 6196); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1911, 6197); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1912, 6198); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1913, 6199); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1914, 6200); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1915, 6201); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1916, 6202); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1917, 6203); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1918, 6204); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1919, 6205); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1920, 6206); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1921, 6207); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1922, 6208); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1923, 6209); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1924, 6210); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1925, 6211); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1926, 6212); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1927, 6213); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1928, 6214); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1929, 6215); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1930, 6216); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1931, 6217); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1932, 6218); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1933, 6219); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1934, 6220); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1935, 6221); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1936, 6222); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1937, 6223); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1938, 6224); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1939, 6225); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1940, 6226); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1941, 6227); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1942, 6228); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1943, 6229); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1944, 6230); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1945, 6231); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1946, 6232); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1947, 6233); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1948, 6234); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1949, 6235); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1950, 6236); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1951, 6237); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1952, 6238); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1953, 6239); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1954, 6240); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1955, 6241); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1956, 6242); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1957, 6243); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1958, 6244); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1959, 6245); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1960, 6246); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1961, 6247); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1962, 6248); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1963, 6249); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1964, 6250); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1965, 6251); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1966, 6252); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1967, 6253); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1968, 6254); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1969, 6255); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1970, 6256); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1971, 6257); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1972, 6258); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1973, 6259); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1974, 6260); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1975, 6261); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1976, 6262); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1977, 6263); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1978, 6264); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1979, 6265); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1980, 6266); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1981, 6267); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1982, 6268); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1983, 6269); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1984, 6270); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1985, 6271); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1986, 6272); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1987, 6273); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1988, 6274); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1989, 6275); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1990, 6276); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1991, 6277); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1992, 6278); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1993, 6279); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1994, 6280); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1995, 6281); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1996, 6282); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1997, 6283); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1998, 6284); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 1999, 6285); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2000, 6286); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2001, 6287); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2002, 6437); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2003, 6438); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2004, 6439); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2005, 6440); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2006, 6441); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2007, 6442); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2008, 6443); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2009, 6444); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2010, 6445); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2011, 6446); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2012, 6447); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2013, 6448); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2014, 6449); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2015, 6450); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2016, 6451); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2017, 6452); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2018, 6453); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2019, 6454); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2020, 6288); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2021, 6289); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2022, 6290); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2023, 6291); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2024, 6292); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2025, 6293); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2026, 6294); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2027, 6295); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2028, 6296); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2029, 6297); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2030, 6298); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2031, 6299); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2032, 6300); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2033, 6301); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2034, 6302); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2035, 6303); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2036, 6304); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2037, 6305); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2038, 6306); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2039, 6307); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2040, 6308); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2041, 6309); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2042, 6310); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2043, 6311); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2044, 6312); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2045, 6313); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2046, 6314); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2047, 6315); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2048, 6316); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2049, 6317); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2050, 6318); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2051, 6319); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2052, 6320); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2053, 6321); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2054, 6322); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2055, 6323); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2056, 6324); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2057, 6325); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2058, 6326); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2059, 6327); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2060, 6328); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2061, 6329); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2062, 6330); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2063, 6331); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2064, 6332); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2065, 6333); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2066, 6334); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2067, 6335); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2068, 6336); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2069, 6337); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2070, 6338); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2071, 6357); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2072, 6358); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2073, 6359); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2074, 6360); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2075, 6361); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2076, 6362); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2077, 6363); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2078, 6364); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2079, 6365); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2080, 6366); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2081, 6367); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2082, 6368); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2083, 6369); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2084, 6370); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2085, 6371); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2086, 6372); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2087, 6373); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2088, 6374); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2089, 6375); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2090, 6376); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2091, 6377); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2092, 6378); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2093, 6379); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2094, 6380); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2095, 6381); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2096, 6382); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2097, 6383); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2098, 6384); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2099, 6385); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2100, 6386); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2101, 6387); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2102, 6388); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2103, 6389); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2104, 6390); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2105, 6391); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2106, 6392); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2107, 6393); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2108, 6394); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2109, 6395); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2110, 6396); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2111, 6397); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2112, 6398); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2113, 6399); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2114, 6400); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2115, 6401); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2116, 6402); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2117, 6455); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2118, 6456); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2119, 6457); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2120, 6458); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2121, 6459); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2122, 6460); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2123, 6461); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2124, 6462); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2125, 6463); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2126, 6464); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2127, 6465); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2128, 6466); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2129, 6467); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2130, 6468); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2131, 6469); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2132, 6470); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2133, 6471); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2134, 6472); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2135, 6473); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2136, 6474); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2137, 6475); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2138, 6476); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2139, 6466); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2140, 6467); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2141, 6468); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2142, 6469); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2143, 6470); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2144, 6471); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2145, 6472); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2146, 6473); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2147, 6474); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2148, 6475); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2149, 6476); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2758, 6477); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2759, 6478); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2760, 6479); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2761, 6480); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2762, 6481); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2763, 6482); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2764, 6483); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2765, 6484); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2766, 6485); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2767, 6486); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2768, 6487); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2769, 6488); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2770, 6489); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2771, 6490); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2772, 6491); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2773, 6492); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2774, 6493); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2775, 6494); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2776, 6495); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2777, 6496); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2778, 6497); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2779, 6498); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2780, 6499); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2781, 6500); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2782, 6501); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2783, 6502); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2784, 6503); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2785, 6504); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2786, 6505); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2787, 6506); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2788, 6507); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2789, 6508); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2790, 6509); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2791, 6510); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2792, 6511); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2793, 6512); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2794, 6513); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2795, 6514); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2796, 6515); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2797, 6516); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2798, 6517); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2799, 6518); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2800, 6519); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2801, 6520); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2802, 6521); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2803, 6522); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2804, 6523); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2805, 6524); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2806, 6525); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2807, 6526); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2810, 6527); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2811, 6528); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2812, 6529); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2813, 6530); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2814, 6531); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2815, 6532); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2816, 6533); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2817, 6534); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2818, 6535); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2819, 6536); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2822, 6537); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2823, 6538); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2824, 6539); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2825, 6540); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2826, 6541); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2827, 6542); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2828, 6543); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2829, 6544); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2830, 6545); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2831, 6546); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2832, 6547); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2833, 6548); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2838, 6549); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2839, 6550); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2850, 6551); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2851, 6552); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2853, 6553); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2854, 6554); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2856, 6555); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2857, 6556); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2858, 6557); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2864, 6558); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2865, 6559); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2866, 6560); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2867, 6561); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2868, 6562); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2869, 6563); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2870, 6564); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2871, 6565); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2872, 6566); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2873, 6567); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2874, 6568); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2875, 6569); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2876, 6570); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2877, 6571); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2878, 6572); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2879, 6573); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2880, 6574); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2881, 6575); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2882, 6576); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2883, 6577); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2884, 6578); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2885, 6579); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2886, 6580); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2887, 6581); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2888, 6582); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2889, 6583); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2890, 6584); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2891, 6585); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2892, 6586); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2893, 6587); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2894, 6588); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2895, 6589); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2896, 6590); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2897, 6591); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2898, 6592); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2899, 6593); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2900, 6594); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2901, 6595); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2902, 6596); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2903, 6597); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2904, 6598); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2905, 6599); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2906, 6600); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2907, 6601); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2908, 6602); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2909, 6603); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2910, 6604); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2911, 6605); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2912, 6606); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2913, 6607); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2914, 6608); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2915, 6609); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2916, 6610); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2917, 6611); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2918, 6612); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2919, 6613); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2920, 6614); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2921, 6615); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2922, 6616); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2923, 6617); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2924, 6618); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2925, 6619); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2926, 6620); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2927, 6621); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2928, 6622); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2930, 6623); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2931, 6624); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2932, 6625); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2933, 6626); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2934, 6627); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2935, 6628); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2936, 6629); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2937, 6630); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2938, 6631); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2939, 6632); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2941, 6633); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2942, 6634); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2943, 6635); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2944, 6636); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2945, 6637); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2946, 6638); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2947, 6639); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2948, 6640); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2949, 6641); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2950, 6642); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2951, 6643); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2952, 6644); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2953, 6645); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2954, 6646); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2955, 6647); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2956, 6648); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2957, 6649); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2958, 6650); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2960, 6651); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2961, 6652); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2962, 6653); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2963, 6654); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2964, 6655); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2965, 6656); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2966, 6657); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2967, 6658); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2968, 6659); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2969, 6660); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2970, 6661); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2974, 6662); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2975, 6663); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2976, 6664); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2977, 6665); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2978, 6666); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2979, 6667); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2980, 6668); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2981, 6669); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2982, 6670); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2983, 6671); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2984, 6672); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2985, 6673); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2986, 6674); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2987, 6675); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2988, 6676); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2989, 6677); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2990, 6678); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2992, 6679); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2993, 6680); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2994, 6681); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2996, 6682); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2997, 6683); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 2999, 6684); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3000, 6685); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3003, 6686); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3004, 6687); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3023, 6688); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3024, 6689); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3025, 6690); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3026, 6691); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3027, 6692); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3028, 6693); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3029, 6694); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3030, 6695); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3031, 6696); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3032, 6697); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3033, 6698); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3034, 6699); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3035, 6700); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3036, 6701); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3037, 6702); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3038, 6703); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3039, 6704); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3040, 6705); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3041, 6706); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3042, 6707); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3043, 6708); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3044, 6709); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3045, 6710); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3046, 6711); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3047, 6712); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3048, 6713); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3049, 6714); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3050, 6715); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3051, 6716); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3052, 6717); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3053, 6718); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3054, 6719); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3055, 6720); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3056, 6721); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3057, 6722); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3058, 6723); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3059, 6724); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3060, 6725); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3061, 6726); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3062, 6727); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3063, 6728); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3064, 6729); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3065, 6730); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3066, 6731); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3067, 6732); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3068, 6733); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3069, 6734); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3070, 6735); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3071, 6736); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3072, 6737); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3073, 6738); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3074, 6739); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3075, 6740); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3076, 6741); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3077, 6742); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3078, 6743); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3079, 6744); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3080, 6745); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3081, 6746); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3082, 6747); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3083, 6748); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3084, 6749); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3085, 6750); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3088, 6751); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3089, 6752); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3090, 6753); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3091, 6754); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3092, 6755); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3093, 6756); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3094, 6757); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3095, 6758); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3096, 6759); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3097, 6760); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3098, 6761); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3099, 6762); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3100, 6763); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3101, 6764); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3102, 6765); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3103, 6766); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3104, 6767); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3105, 6768); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3106, 6769); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3107, 6770); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3109, 6771); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3110, 6772); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3111, 6773); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3112, 6774); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3113, 6775); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3114, 6776); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3115, 6777); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3116, 6778); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3117, 6779); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3118, 6780); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3119, 6781); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3120, 6782); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3121, 6783); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3122, 6784); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3123, 6785); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3124, 6786); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3125, 6787); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3126, 6788); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3127, 6789); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3128, 6790); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3129, 6791); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3130, 6792); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3131, 6793); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3132, 6794); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3133, 6795); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3134, 6796); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3135, 6797); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3136, 6798); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3137, 6799); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3138, 6800); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3139, 6801); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3140, 6802); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3141, 6803); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3142, 6804); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3143, 6805); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3144, 6806); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3145, 6807); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3146, 6808); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3147, 6809); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3148, 6810); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3149, 6811); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3150, 6812); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3151, 6813); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3152, 6814); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3153, 6815); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3154, 6816); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3155, 6817); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3156, 6818); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3157, 6819); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3158, 6820); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3159, 6821); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3160, 6822); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3161, 6823); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3162, 6824); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3163, 6825); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3164, 6826); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3165, 6827); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3166, 6828); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3167, 6829); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3168, 6830); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3169, 6831); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3170, 6832); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3171, 6833); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3172, 6834); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3173, 6835); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3174, 6836); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3175, 6837); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3176, 6838); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3177, 6839); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3178, 6840); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3179, 6841); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3180, 6842); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3181, 6843); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3182, 6844); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3183, 6845); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3184, 6846); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3185, 6847); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3186, 6848); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3187, 6849); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3188, 6850); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3189, 6851); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3190, 6852); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3191, 6853); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3192, 6854); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3193, 6855); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3194, 6856); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3195, 6857); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3196, 6858); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3197, 6859); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3198, 6860); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3199, 6861); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3200, 6862); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3201, 6863); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3202, 6864); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3203, 6865); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3204, 6866); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3205, 6867); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3206, 6868); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3207, 6869); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3208, 6870); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3209, 6871); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3210, 6872); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3211, 6873); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3212, 6874); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3213, 6875); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3214, 6876); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3215, 6877); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3216, 6878); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3217, 6879); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3218, 6880); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3219, 6881); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3220, 6882); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3221, 6883); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3222, 6884); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3223, 6885); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3224, 6886); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3225, 6887); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3226, 6888); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3227, 6889); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3228, 6890); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3229, 6891); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3230, 6892); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3231, 6893); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3232, 6894); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3233, 6895); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3234, 6896); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3235, 6897); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3236, 6898); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3237, 6899); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3238, 6900); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3239, 6901); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3240, 6902); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3241, 6903); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3242, 6904); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3243, 6905); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3244, 6906); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3245, 6907); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3246, 6908); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3247, 6909); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3248, 6910); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3249, 6911); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3250, 6912); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3251, 6913); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3252, 6914); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3253, 6915); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3254, 6916); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3255, 6917); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3256, 6918); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3257, 6919); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3258, 6920); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3259, 6921); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3260, 6922); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3261, 6923); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3262, 6924); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3263, 6925); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3264, 6926); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3265, 6927); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3266, 6928); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3267, 6929); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3268, 6930); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3269, 6931); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3270, 6932); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3271, 6933); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3272, 6934); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3273, 6935); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3274, 6936); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3275, 6937); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3276, 6938); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3277, 6939); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3278, 6940); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3279, 6941); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3280, 6942); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3281, 6943); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3282, 6944); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3283, 6945); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3284, 6946); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3285, 6947); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3286, 6948); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3287, 6949); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3288, 6950); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3289, 6951); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3290, 6952); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3291, 6953); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3292, 6954); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3293, 6955); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3294, 6956); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3295, 6957); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3296, 6958); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3297, 6959); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3298, 6960); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3299, 6961); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3300, 6962); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3301, 6963); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3302, 6964); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3303, 6965); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3304, 6966); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3305, 6967); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3306, 6968); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3307, 6969); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3308, 6970); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3309, 6971); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3310, 6972); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3311, 6973); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3312, 6974); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3313, 6975); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3314, 6976); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3315, 6977); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3316, 6978); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3317, 6979); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3318, 6980); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3319, 6981); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3320, 6982); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3321, 6983); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3322, 6984); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3323, 6985); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3324, 6986); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3325, 6987); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3326, 6988); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3327, 6989); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3328, 6990); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3329, 6991); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3330, 6992); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3331, 6993); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3332, 6994); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3333, 6995); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3334, 6996); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3335, 6997); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3336, 6998); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3337, 6999); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3338, 7000); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3339, 7001); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3340, 7002); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3341, 7003); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3342, 7004); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3343, 7005); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3344, 7006); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3345, 7007); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3346, 7008); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3347, 7009); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3348, 7010); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3349, 7011); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3350, 7012); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3351, 7013); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3352, 7014); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3353, 7015); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3354, 7016); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3355, 7017); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3356, 7018); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3357, 7019); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3358, 7020); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3359, 7021); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3360, 7022); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3361, 7023); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3362, 7024); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3363, 7025); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3364, 7026); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3365, 7027); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3366, 7028); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3367, 7029); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3368, 7030); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3369, 7031); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3370, 7032); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3371, 7033); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3372, 7034); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3373, 7035); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3374, 7036); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3375, 7037); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3376, 7038); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3377, 7039); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3378, 7040); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3379, 7041); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3380, 7042); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3381, 7043); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3382, 7044); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3383, 7045); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3384, 7046); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3385, 7047); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3386, 7048); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3387, 7049); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3388, 7050); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3389, 7051); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3390, 7052); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3391, 7053); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3392, 7054); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3393, 7055); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3394, 7056); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3395, 7057); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3396, 7058); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3397, 7059); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3398, 7060); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3399, 7061); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3400, 7062); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3401, 7063); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3402, 7064); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3403, 7065); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3404, 7066); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3405, 7067); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3406, 7068); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3407, 7069); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3408, 7070); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3409, 7071); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3410, 7072); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3411, 7073); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3412, 7074); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3413, 7075); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3414, 7076); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3415, 7077); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3416, 7078); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3417, 7079); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3418, 7080); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3419, 7081); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3420, 7082); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3421, 7083); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3422, 7084); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3423, 7085); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3424, 7086); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3425, 7087); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3426, 7088); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3427, 7089); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3428, 7090); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3429, 7091); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3430, 7092); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3431, 7093); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3432, 7094); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3433, 7095); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3434, 7096); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3435, 7097); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3436, 7098); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3437, 7099); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3438, 7100); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3439, 7101); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3440, 7102); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3441, 7103); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3442, 7104); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3443, 7105); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3444, 7106); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3445, 7107); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3446, 7108); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3447, 7109); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3448, 7110); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3449, 7111); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3450, 7112); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3451, 7113); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3452, 7114); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3453, 7115); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3454, 7116); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3455, 7117); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3456, 7118); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3457, 7119); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3458, 7120); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3459, 7121); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3460, 7122); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3461, 7123); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3462, 7124); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3463, 7125); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3464, 7126); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3465, 7127); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3466, 7128); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3467, 7129); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3468, 7130); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3469, 7131); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3470, 7132); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3471, 7133); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3472, 7134); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3473, 7135); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3474, 7136); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3475, 7137); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3476, 7138); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3477, 7139); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3478, 7140); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3479, 7141); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3480, 7142); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3481, 7143); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3482, 7144); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3483, 7145); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3484, 7146); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3485, 7147); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3486, 7148); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3487, 7149); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3488, 7150); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3489, 7151); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3490, 7152); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3491, 7153); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3492, 7154); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3493, 7155); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3494, 7156); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3495, 7157); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3496, 7158); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3497, 7159); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3498, 7160); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3499, 7161); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3500, 7162); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3501, 7163); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3502, 7164); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3503, 7165); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3504, 7166); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3505, 7167); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3506, 7168); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3507, 7169); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3508, 7170); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3509, 7171); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3510, 7172); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3511, 6827); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3512, 6828); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3513, 6829); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3514, 6830); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3515, 6831); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3516, 6832); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3517, 6833); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3518, 6834); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3519, 6835); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3520, 6836); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3521, 6837); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3522, 6838); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3523, 6839); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3524, 6840); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3525, 6841); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3526, 6842); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3527, 6843); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3528, 6844); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3529, 6845); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3530, 6846); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3531, 6847); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3532, 6848); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3533, 6849); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3534, 6850); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3535, 6851); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3536, 6852); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3537, 6853); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3538, 6854); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3539, 6855); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3540, 6856); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3541, 6857); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3542, 6858); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3543, 6859); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3544, 6860); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3545, 6861); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3546, 6862); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3547, 6863); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3548, 6864); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3549, 6865); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3550, 6866); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3551, 6867); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3552, 7173); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3553, 6868); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3554, 6869); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3555, 6870); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3556, 6871); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3557, 6872); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3558, 6873); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3559, 6874); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3560, 6875); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3561, 6876); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3562, 6877); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3563, 6878); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3564, 6879); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3565, 6880); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3566, 6881); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3567, 6882); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3568, 6883); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3569, 6884); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3570, 6885); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3571, 6886); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3572, 6887); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3573, 6888); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3574, 6889); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3575, 6890); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3576, 6891); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3577, 6892); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3578, 6893); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3579, 6894); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3580, 6895); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3581, 6896); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3582, 6897); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3583, 6898); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3584, 6899); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3585, 6900); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3586, 6901); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3587, 6902); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3588, 6903); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3589, 6904); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3590, 6905); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3591, 6906); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3592, 6907); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3593, 6908); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3594, 6909); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3595, 6910); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3596, 6911); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3597, 6912); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3598, 6913); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3599, 6914); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3600, 6915); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3601, 6916); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3602, 6917); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3603, 6918); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3604, 6919); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3605, 6920); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3606, 6921); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3607, 6922); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3608, 6923); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3609, 6924); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3610, 6925); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3611, 6926); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3612, 6927); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3613, 6928); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3614, 6929); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3615, 6930); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3616, 6931); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3617, 6932); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3618, 6933); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3619, 6934); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3620, 6935); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3621, 6936); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3622, 6937); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3623, 6938); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3624, 6939); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3625, 6940); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3626, 6941); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3627, 6942); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3628, 6943); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3629, 6944); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3630, 6945); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3631, 6946); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3632, 6947); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3633, 6948); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3634, 6949); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3635, 6950); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3636, 6951); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3637, 6952); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3638, 6953); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3639, 6954); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3640, 6955); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3641, 6956); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3642, 6957); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3643, 6958); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3644, 6959); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3645, 6960); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3646, 6961); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3647, 6962); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3648, 6963); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3649, 6964); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3650, 6965); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3651, 6966); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3652, 6967); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3653, 6968); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3654, 6969); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3655, 6970); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3656, 6971); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3657, 6972); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3658, 6973); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3659, 6974); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3660, 6975); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3661, 6976); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3662, 6977); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3663, 6978); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3664, 6979); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3665, 6980); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3666, 6981); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3667, 6982); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3668, 6983); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3669, 6984); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3670, 6985); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3671, 6986); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3672, 6987); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3673, 6988); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3674, 6989); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3675, 6990); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3676, 6991); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3677, 6992); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3678, 6993); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3679, 6994); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3680, 6995); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3681, 6996); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3682, 6997); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3683, 6998); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3684, 6999); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3685, 7000); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3686, 7001); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3687, 7002); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3688, 7003); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3689, 7004); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3690, 7005); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3691, 7006); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3692, 7007); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3693, 7008); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3694, 7009); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3695, 7010); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3696, 7011); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3697, 7012); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3698, 7013); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3699, 7014); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3700, 7015); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3701, 7016); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3702, 7017); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3703, 7018); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3704, 7019); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3705, 7020); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3706, 7021); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3707, 7022); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3708, 7023); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3709, 7024); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3710, 7174); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3711, 7175); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3712, 7176); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3713, 7177); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3714, 7178); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3715, 7179); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3716, 7180); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3717, 7181); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3718, 7182); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3719, 7183); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3720, 7184); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3721, 7185); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3722, 7186); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3723, 7187); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3724, 7188); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3725, 7189); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3726, 7190); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3727, 7191); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3728, 7025); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3729, 7026); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3730, 7027); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3731, 7028); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3732, 7029); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3733, 7030); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3734, 7031); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3735, 7032); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3736, 7033); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3737, 7034); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3738, 7035); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3739, 7036); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3740, 7037); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3741, 7038); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3742, 7039); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3743, 7040); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3744, 7041); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3745, 7042); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3746, 7043); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3747, 7044); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3748, 7045); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3749, 7046); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3750, 7047); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3751, 7048); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3752, 7049); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3753, 7050); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3754, 7051); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3755, 7052); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3756, 7053); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3757, 7054); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3758, 7055); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3759, 7056); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3760, 7057); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3761, 7058); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3762, 7059); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3763, 7060); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3764, 7061); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3765, 7062); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3766, 7063); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3767, 7064); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3768, 7065); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3769, 7066); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3770, 7067); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3771, 7068); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3772, 7069); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3773, 7070); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3774, 7071); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3775, 7072); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3776, 7073); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3777, 7074); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3778, 7075); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3779, 7094); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3780, 7095); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3781, 7096); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3782, 7097); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3783, 7098); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3784, 7099); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3785, 7100); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3786, 7101); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3787, 7102); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3788, 7103); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3789, 7104); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3790, 7105); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3791, 7106); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3792, 7107); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3793, 7108); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3794, 7109); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3795, 7110); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3796, 7111); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3797, 7112); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3798, 7113); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3799, 7114); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3800, 7115); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3801, 7116); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3802, 7117); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3803, 7118); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3804, 7119); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3805, 7120); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3806, 7121); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3807, 7122); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3808, 7123); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3809, 7124); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3810, 7125); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3811, 7126); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3812, 7127); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3813, 7128); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3814, 7129); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3815, 7130); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3816, 7131); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3817, 7132); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3818, 7133); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3819, 7134); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3820, 7135); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3821, 7136); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3822, 7137); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3823, 7138); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3824, 7139); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3825, 7192); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3826, 7193); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3827, 7194); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3828, 7195); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3829, 7196); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3830, 7197); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3831, 7198); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3832, 7199); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3833, 7200); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3834, 7201); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 3835, 7202); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4502, 7203); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4503, 7204); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4504, 7205); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4505, 7206); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4506, 7207); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4507, 7208); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4508, 7209); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4509, 7210); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4510, 7211); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4511, 7212); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4512, 7213); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4513, 7214); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4514, 7215); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4515, 7216); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4516, 7217); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4517, 7218); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4518, 7219); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4519, 7220); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4520, 7221); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4521, 7222); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4522, 7223); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4523, 7224); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4524, 7225); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4525, 7226); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4526, 7227); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4527, 7228); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4528, 7229); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4529, 7230); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4530, 7231); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4531, 7232); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4532, 7233); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4533, 7234); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4534, 7235); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4535, 7236); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4536, 7237); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4537, 7238); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4538, 7239); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4539, 7240); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4540, 7241); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4541, 7242); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4542, 7243); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4543, 7244); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4544, 7245); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4545, 7246); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4546, 7247); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4547, 7248); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4548, 7249); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4549, 7250); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4550, 7251); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4551, 7252); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4552, 7253); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4553, 7254); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4554, 7255); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4555, 7256); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4556, 7257); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4557, 7258); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4558, 7259); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4559, 7260); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4560, 7261); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4561, 7262); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4562, 7263); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4563, 7264); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4564, 7265); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4565, 7266); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4566, 7267); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4567, 7268); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4568, 7269); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4569, 7270); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4570, 7271); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4571, 7272); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4572, 7273); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4573, 7274); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4574, 7275); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4575, 7276); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4576, 7277); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4577, 7278); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4578, 7279); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4579, 7280); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4580, 7281); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4581, 7282); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4582, 7283); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4583, 7284); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4584, 7285); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4585, 7286); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4586, 7287); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4587, 7288); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4588, 7289); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4589, 7290); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4590, 7291); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4591, 7292); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4592, 7293); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4593, 7294); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4594, 7295); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4595, 7296); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4596, 7297); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4597, 7298); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4598, 7299); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4599, 7300); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4600, 7301); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4601, 7302); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4602, 7303); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4603, 7304); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4604, 7305); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4605, 7306); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4606, 7307); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4607, 7308); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4608, 7309); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4609, 7310); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4610, 7311); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4611, 7312); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4612, 7313); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4613, 7314); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4614, 7315); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4615, 7316); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4616, 7317); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4617, 7318); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4618, 7319); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4619, 7320); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4620, 7321); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4621, 7322); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4622, 7323); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4623, 7324); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4624, 7325); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4625, 7326); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4626, 7327); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4627, 7328); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4628, 7329); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4629, 7330); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4630, 7331); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4631, 7332); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4632, 7333); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4633, 7334); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4634, 7335); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4635, 7336); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4636, 7337); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4637, 7338); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4638, 7339); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4639, 7340); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4640, 7341); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4641, 7342); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4642, 7343); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4643, 7344); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4644, 7345); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4645, 7346); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4646, 7347); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4647, 7348); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4648, 7349); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4649, 7350); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4650, 7351); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4651, 7352); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4652, 7353); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4653, 7354); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4654, 7355); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4655, 7356); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4656, 7357); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4657, 7358); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4658, 7359); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4659, 7360); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4660, 7361); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4661, 7362); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4662, 7363); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4663, 7364); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4664, 7365); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4665, 7366); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4666, 7367); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4667, 7368); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4668, 7369); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4669, 7370); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4670, 7371); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4671, 7372); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4672, 7373); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4673, 7374); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4674, 7375); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4675, 7376); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4676, 7377); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4677, 7378); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4678, 7379); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4679, 7380); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4680, 7381); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4681, 7382); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4682, 7383); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4683, 7384); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4684, 7385); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4685, 7386); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4686, 7387); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4687, 7388); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4688, 7389); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4689, 7390); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4690, 7391); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4691, 7392); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4692, 7393); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4693, 7394); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4694, 7395); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4695, 7396); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4696, 7397); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4697, 7398); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4698, 7399); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4699, 7400); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4700, 7401); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4701, 7402); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4702, 7403); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4703, 7404); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4704, 7405); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4705, 7406); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4706, 7407); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4707, 7408); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4708, 7409); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4709, 7410); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4710, 7411); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4711, 7412); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4712, 7413); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4713, 7414); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4714, 7415); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4715, 7416); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4716, 7417); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4717, 7418); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4718, 7419); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4719, 7420); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4720, 7421); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4721, 7422); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4722, 7423); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4723, 7424); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4724, 7425); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4725, 7426); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4726, 7427); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4727, 7428); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4728, 7429); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4729, 7430); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4730, 7431); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4731, 7432); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4732, 7433); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4733, 7434); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4734, 7435); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4735, 7436); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4736, 7437); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4737, 7438); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4738, 7439); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4739, 7440); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4740, 7441); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4741, 7442); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4742, 7443); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4743, 7444); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4744, 7445); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4745, 7446); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4746, 7447); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4747, 7448); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4748, 7449); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4749, 7450); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4750, 7451); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4751, 7452); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4752, 7453); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4753, 7454); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4754, 7455); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4755, 7456); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4756, 7457); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4757, 7458); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4758, 7459); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4759, 7460); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4760, 7461); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4761, 7462); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4762, 7463); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4763, 7464); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4764, 7465); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4765, 7466); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4766, 7467); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4767, 7468); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4768, 7469); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4769, 7470); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4770, 7471); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4771, 7472); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4772, 7473); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4773, 7474); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4774, 7475); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4775, 7476); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4776, 7477); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4777, 7478); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4778, 7479); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4779, 7480); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4780, 7481); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4781, 7482); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4782, 7483); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4783, 7484); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4784, 7485); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4785, 7486); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4786, 7487); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4787, 7488); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4788, 7489); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4789, 7490); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4790, 7491); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4791, 7492); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4792, 7493); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4793, 7494); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4794, 7495); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4795, 7496); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4796, 7497); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4797, 7498); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4798, 7499); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4799, 7500); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4800, 7501); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4801, 7502); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4802, 7503); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4803, 7504); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4804, 7505); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4805, 7506); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4806, 7507); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4807, 7508); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4808, 7509); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4809, 7510); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4810, 7511); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4811, 7512); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4812, 7513); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4813, 7514); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4814, 7515); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4815, 7516); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4816, 7517); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4817, 7518); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4818, 7519); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4819, 7520); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4820, 7521); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4821, 7522); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4822, 7523); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4823, 7524); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4824, 7525); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4825, 7526); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4826, 7527); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4827, 7528); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4828, 7529); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4829, 7530); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4830, 7531); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4831, 7532); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4832, 7533); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4833, 7534); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4834, 7535); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4835, 7536); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4836, 7537); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4837, 7538); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4838, 7539); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4839, 7540); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4840, 7541); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4841, 7542); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4842, 7543); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4843, 7544); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4844, 7545); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4845, 7546); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4846, 7547); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4847, 7548); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4848, 7549); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4849, 7550); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4850, 7551); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4851, 7552); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4852, 7553); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4853, 7554); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4854, 7555); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4855, 7556); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4856, 7557); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4857, 7558); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4858, 7559); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4859, 7560); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4860, 7561); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4861, 7562); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4862, 7563); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4863, 7564); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4864, 7565); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4865, 7566); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4866, 7567); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4867, 7568); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4868, 7569); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4869, 7570); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4870, 7571); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4871, 7572); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4872, 7573); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4873, 7574); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4874, 7575); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4875, 7576); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4876, 7577); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4877, 7578); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4878, 7579); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4879, 7580); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4880, 7581); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4881, 7582); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4882, 7583); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4883, 7584); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4884, 7585); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4885, 7586); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4886, 7587); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4887, 7588); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4888, 7589); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4889, 7590); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4890, 7591); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4891, 7592); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4892, 7593); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4893, 7594); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4894, 7595); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4895, 7596); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4896, 7597); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4897, 7598); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4898, 7599); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4899, 7600); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4900, 7601); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4901, 7602); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4902, 7603); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4903, 7604); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4904, 7605); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4905, 7606); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4906, 7607); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4907, 7608); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4908, 7609); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4909, 7610); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4910, 7611); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4911, 7612); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4912, 7613); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4913, 7614); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4914, 7615); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4915, 7616); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4916, 7617); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4917, 7618); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4918, 7619); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4919, 7620); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4920, 7621); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4921, 7622); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4922, 7623); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4923, 7624); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4924, 7625); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4925, 7626); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4926, 7627); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4927, 7628); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4928, 7629); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4929, 7630); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4930, 7631); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4931, 7632); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4932, 7633); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4933, 7634); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4934, 7635); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4935, 7636); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4936, 7637); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4937, 7638); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4938, 7639); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4939, 7640); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4940, 7641); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4941, 7642); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4942, 7643); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4943, 7644); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4944, 7645); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4945, 7646); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4946, 7647); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4947, 7648); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4948, 7649); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4949, 7650); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4950, 7651); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4951, 7652); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4952, 7653); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4953, 7654); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4954, 7655); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4955, 7656); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4956, 7657); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4957, 7658); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4958, 7659); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4959, 7660); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4960, 7661); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4961, 7662); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4962, 7663); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4963, 7664); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4964, 7665); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4965, 7666); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4966, 7667); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4967, 7668); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4968, 7669); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4969, 7670); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4970, 7671); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4971, 7672); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4972, 7673); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4973, 7674); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4974, 7675); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4975, 7676); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4976, 7677); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4977, 7678); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4978, 7679); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4979, 7680); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4980, 7681); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4981, 7682); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4982, 7683); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4983, 7684); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4984, 7685); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4985, 7686); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4986, 7687); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4987, 7688); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4988, 7689); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4989, 7690); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4990, 7691); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4991, 7692); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4992, 7693); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4993, 7694); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4994, 7695); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4995, 7696); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4996, 7697); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4997, 7698); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4998, 7699); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 4999, 7700); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5000, 7701); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5001, 7702); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5002, 7703); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5003, 7704); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5004, 7705); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5005, 7706); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5006, 7707); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5007, 7708); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5008, 7709); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5009, 7710); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5010, 7711); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5011, 7712); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5012, 7713); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5013, 7714); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5014, 7715); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5015, 7716); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5016, 7717); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5017, 7718); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5018, 7719); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5019, 7720); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5020, 7721); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5021, 7722); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5022, 7723); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5023, 7724); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5024, 7725); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5025, 7726); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5026, 7727); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5027, 7728); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5028, 7729); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5029, 7730); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5030, 7731); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5031, 7732); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5032, 7733); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5033, 7734); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5034, 7735); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5035, 7736); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5036, 7737); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5037, 7738); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5038, 7739); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5039, 7740); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5040, 7741); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5041, 7742); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5042, 7743); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5043, 7744); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5044, 7745); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5045, 7746); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5046, 7747); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5047, 7748); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5048, 7749); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5049, 7750); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5050, 7751); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5051, 7752); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5052, 7753); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5053, 7754); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5054, 7755); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5055, 7756); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5056, 7757); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5057, 7758); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5058, 7759); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5059, 7760); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5060, 7761); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5061, 7762); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5062, 7763); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5063, 7764); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5064, 7765); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5065, 7766); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5066, 7767); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5067, 7768); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5068, 7769); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5069, 7770); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5070, 7771); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5071, 7772); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5072, 7773); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5073, 7774); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5074, 7775); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5075, 7776); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5076, 7777); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5077, 7778); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5078, 7779); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5079, 7780); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5080, 7781); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5081, 7782); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5082, 7783); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5083, 7784); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5084, 7785); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5085, 7786); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5086, 7787); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5087, 7788); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5088, 7789); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5089, 7790); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5090, 7791); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5091, 7792); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5092, 7793); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5093, 7794); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5094, 7795); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5095, 7796); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5096, 7797); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5097, 7798); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5098, 7799); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5099, 7800); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5100, 7801); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5101, 7802); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5102, 7803); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5103, 7804); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5104, 7805); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5105, 7806); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5106, 7807); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5107, 7808); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5108, 7809); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5109, 7810); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5110, 7811); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5111, 7812); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5112, 7813); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5113, 7814); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5114, 7815); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5115, 7816); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5116, 7817); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5117, 7818); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5118, 7819); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5119, 7820); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5120, 7821); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5121, 7822); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5122, 7823); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5123, 7824); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5124, 7825); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5125, 7826); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5126, 7827); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5127, 7828); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5128, 7829); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5129, 7830); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5130, 7831); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5131, 7832); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5132, 7833); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5133, 7834); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5134, 7835); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5135, 7836); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5136, 7837); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5137, 7838); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5138, 7839); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5139, 7840); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5140, 7841); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5141, 7842); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5142, 7843); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5143, 7844); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5144, 7845); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5145, 7846); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5146, 7847); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5147, 7848); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5148, 7849); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5149, 7850); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5150, 7851); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5151, 7852); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5152, 7853); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5153, 7854); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5154, 7855); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5155, 7856); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5156, 7857); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5157, 7858); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5158, 7859); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5159, 7860); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5160, 7861); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5161, 7862); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5162, 7863); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5163, 7864); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5164, 7865); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5165, 7866); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5166, 7867); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5167, 7868); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5168, 7869); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5169, 7870); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5170, 7871); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5171, 7872); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5172, 7873); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5173, 7874); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5174, 7875); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5175, 7876); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5176, 7877); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5177, 7878); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5178, 7879); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5179, 7880); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5180, 7881); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5181, 7882); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5182, 7883); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5183, 7884); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5184, 7885); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5185, 7886); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5186, 7887); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5187, 7888); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5188, 7889); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5189, 7890); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5190, 7891); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5191, 7892); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5192, 7893); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5193, 7894); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5194, 7895); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5195, 7896); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5196, 7897); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5197, 7898); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5198, 7899); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5199, 7900); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5200, 7901); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5201, 7902); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5202, 7903); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5203, 7904); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5204, 7905); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5205, 7906); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5206, 7907); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5207, 7908); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5208, 7909); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5209, 7910); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5210, 7911); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5211, 7912); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5212, 7913); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5213, 7914); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5214, 7915); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5215, 7916); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5216, 7917); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5217, 7918); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5218, 7919); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5219, 7920); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5220, 7921); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5221, 7922); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5222, 7923); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5223, 7924); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5224, 7925); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5225, 7926); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5226, 7927); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5227, 7928); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5228, 7929); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5229, 7930); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5230, 7931); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5231, 7932); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5232, 7933); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5233, 7934); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5234, 7935); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5235, 7936); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5236, 7937); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5237, 7938); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5238, 7939); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5239, 7940); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5240, 7941); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5241, 7942); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5242, 7943); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5243, 7944); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5244, 7945); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5245, 7946); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5246, 7947); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5247, 7948); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5248, 7949); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5249, 7950); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5250, 7951); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5251, 7952); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5252, 7953); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5253, 7954); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5254, 7955); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5255, 7956); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5256, 7957); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5257, 7958); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5258, 7959); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5259, 7960); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5260, 7961); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5261, 7962); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5262, 7963); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5263, 7964); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5264, 7965); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5265, 7966); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5266, 7967); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5267, 7968); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5268, 7969); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5269, 7970); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5270, 7971); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5271, 7972); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5272, 7973); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5273, 7974); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5275, 7975); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5277, 7976); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5279, 7977); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5280, 7978); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5286, 7979); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5287, 7980); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5289, 7981); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5290, 7982); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5291, 7983); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5292, 7984); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5293, 7985); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5294, 7986); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5295, 7987); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5296, 7988); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5297, 7989); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5298, 7990); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5299, 7991); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5300, 7992); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5301, 7993); @
INSERT INTO TMP_COMPARE (TIP, ID_OLD_FIELD, ID_NEW_FIELD)
                   VALUES (0, 5302, 7994); @

execute procedure update_2015; @

COMMIT WORK; @

DROP PROCEDURE UPDATE_2015; @    

DROP INDEX KARTA_IDX_TMP_UPD; @        

DELETE FROM TARIF; @

INSERT INTO TARIF (ID, TD, STAGE, W, AGE_FROM, AGE_TO, DATE_1, DATE_2, SUMV)
           VALUES (1, '0', '1', '1', 21, 99, '2013-01-01', '2013-05-31', 646.97); @
INSERT INTO TARIF (ID, TD, STAGE, W, AGE_FROM, AGE_TO, DATE_1, DATE_2, SUMV)
           VALUES (2, '0', '1', '2', 21, 99, '2013-01-01', '2013-05-31', 911.03); @
INSERT INTO TARIF (ID, TD, STAGE, W, AGE_FROM, AGE_TO, DATE_1, DATE_2, SUMV)
           VALUES (3, '0', '1', '1', 21, 21, '2013-06-01', '2014-12-31', 695.75); @
INSERT INTO TARIF (ID, TD, STAGE, W, AGE_FROM, AGE_TO, DATE_1, DATE_2, SUMV)
           VALUES (4, '0', '1', '2', 21, 21, '2013-06-01', '2014-12-31', 869.39); @
INSERT INTO TARIF (ID, TD, STAGE, W, AGE_FROM, AGE_TO, DATE_1, DATE_2, SUMV)
           VALUES (5, '0', '1', '1', 24, 24, '2013-06-01', '2014-12-31', 583.49); @
INSERT INTO TARIF (ID, TD, STAGE, W, AGE_FROM, AGE_TO, DATE_1, DATE_2, SUMV)
           VALUES (6, '0', '1', '2', 24, 24, '2013-06-01', '2014-12-31', 757.13); @
INSERT INTO TARIF (ID, TD, STAGE, W, AGE_FROM, AGE_TO, DATE_1, DATE_2, SUMV)
           VALUES (7, '0', '1', '1', 27, 27, '2013-06-01', '2014-12-31', 583.49); @
INSERT INTO TARIF (ID, TD, STAGE, W, AGE_FROM, AGE_TO, DATE_1, DATE_2, SUMV)
           VALUES (8, '0', '1', '2', 27, 27, '2013-06-01', '2014-12-31', 757.13); @
INSERT INTO TARIF (ID, TD, STAGE, W, AGE_FROM, AGE_TO, DATE_1, DATE_2, SUMV)
           VALUES (9, '0', '1', '1', 30, 30, '2013-06-01', '2014-12-31', 583.49); @
INSERT INTO TARIF (ID, TD, STAGE, W, AGE_FROM, AGE_TO, DATE_1, DATE_2, SUMV)
           VALUES (10, '0', '1', '2', 30, 30, '2013-06-01', '2014-12-31', 757.13); @
INSERT INTO TARIF (ID, TD, STAGE, W, AGE_FROM, AGE_TO, DATE_1, DATE_2, SUMV)
           VALUES (11, '0', '1', '1', 33, 33, '2013-06-01', '2014-12-31', 583.49); @
INSERT INTO TARIF (ID, TD, STAGE, W, AGE_FROM, AGE_TO, DATE_1, DATE_2, SUMV)
           VALUES (12, '0', '1', '2', 33, 33, '2013-06-01', '2014-12-31', 757.13); @
INSERT INTO TARIF (ID, TD, STAGE, W, AGE_FROM, AGE_TO, DATE_1, DATE_2, SUMV)
           VALUES (13, '0', '1', '1', 36, 36, '2013-06-01', '2014-12-31', 695.75); @
INSERT INTO TARIF (ID, TD, STAGE, W, AGE_FROM, AGE_TO, DATE_1, DATE_2, SUMV)
           VALUES (14, '0', '1', '2', 36, 36, '2013-06-01', '2014-12-31', 757.13); @
INSERT INTO TARIF (ID, TD, STAGE, W, AGE_FROM, AGE_TO, DATE_1, DATE_2, SUMV)
           VALUES (15, '0', '1', '1', 39, 39, '2013-06-01', '2014-12-31', 831.32); @
INSERT INTO TARIF (ID, TD, STAGE, W, AGE_FROM, AGE_TO, DATE_1, DATE_2, SUMV)
           VALUES (16, '0', '1', '2', 39, 39, '2013-06-01', '2014-12-31', 1306.44); @
INSERT INTO TARIF (ID, TD, STAGE, W, AGE_FROM, AGE_TO, DATE_1, DATE_2, SUMV)
           VALUES (17, '0', '1', '1', 42, 42, '2013-06-01', '2014-12-31', 748.4); @
INSERT INTO TARIF (ID, TD, STAGE, W, AGE_FROM, AGE_TO, DATE_1, DATE_2, SUMV)
           VALUES (18, '0', '1', '2', 42, 42, '2013-06-01', '2014-12-31', 1223.52); @
INSERT INTO TARIF (ID, TD, STAGE, W, AGE_FROM, AGE_TO, DATE_1, DATE_2, SUMV)
           VALUES (19, '0', '1', '1', 45, 45, '2013-06-01', '2014-12-31', 1498.26); @
INSERT INTO TARIF (ID, TD, STAGE, W, AGE_FROM, AGE_TO, DATE_1, DATE_2, SUMV)
           VALUES (20, '0', '1', '2', 45, 45, '2013-06-01', '2014-12-31', 2085.65); @
INSERT INTO TARIF (ID, TD, STAGE, W, AGE_FROM, AGE_TO, DATE_1, DATE_2, SUMV)
           VALUES (21, '0', '1', '1', 48, 48, '2013-06-01', '2014-12-31', 758.99); @
INSERT INTO TARIF (ID, TD, STAGE, W, AGE_FROM, AGE_TO, DATE_1, DATE_2, SUMV)
           VALUES (22, '0', '1', '2', 48, 48, '2013-06-01', '2014-12-31', 1346.37); @
INSERT INTO TARIF (ID, TD, STAGE, W, AGE_FROM, AGE_TO, DATE_1, DATE_2, SUMV)
           VALUES (23, '0', '1', '1', 51, 51, '2013-06-01', '2014-12-31', 1781.84); @
INSERT INTO TARIF (ID, TD, STAGE, W, AGE_FROM, AGE_TO, DATE_1, DATE_2, SUMV)
           VALUES (24, '0', '1', '2', 51, 51, '2013-06-01', '2014-12-31', 2244.84); @
INSERT INTO TARIF (ID, TD, STAGE, W, AGE_FROM, AGE_TO, DATE_1, DATE_2, SUMV)
           VALUES (25, '0', '1', '1', 54, 54, '2013-06-01', '2014-12-31', 883.37); @
INSERT INTO TARIF (ID, TD, STAGE, W, AGE_FROM, AGE_TO, DATE_1, DATE_2, SUMV)
           VALUES (26, '0', '1', '2', 54, 54, '2013-06-01', '2014-12-31', 1346.37); @
INSERT INTO TARIF (ID, TD, STAGE, W, AGE_FROM, AGE_TO, DATE_1, DATE_2, SUMV)
           VALUES (27, '0', '1', '1', 57, 57, '2013-06-01', '2014-12-31', 1781.84); @
INSERT INTO TARIF (ID, TD, STAGE, W, AGE_FROM, AGE_TO, DATE_1, DATE_2, SUMV)
           VALUES (28, '0', '1', '2', 57, 57, '2013-06-01', '2014-12-31', 2244.84); @
INSERT INTO TARIF (ID, TD, STAGE, W, AGE_FROM, AGE_TO, DATE_1, DATE_2, SUMV)
           VALUES (29, '0', '1', '1', 60, 60, '2013-06-01', '2014-12-31', 883.37); @
INSERT INTO TARIF (ID, TD, STAGE, W, AGE_FROM, AGE_TO, DATE_1, DATE_2, SUMV)
           VALUES (30, '0', '1', '2', 60, 60, '2013-06-01', '2014-12-31', 1346.37); @
INSERT INTO TARIF (ID, TD, STAGE, W, AGE_FROM, AGE_TO, DATE_1, DATE_2, SUMV)
           VALUES (31, '0', '1', '1', 63, 63, '2013-06-01', '2014-12-31', 1781.84); @
INSERT INTO TARIF (ID, TD, STAGE, W, AGE_FROM, AGE_TO, DATE_1, DATE_2, SUMV)
           VALUES (32, '0', '1', '2', 63, 63, '2013-06-01', '2014-12-31', 2244.84); @
INSERT INTO TARIF (ID, TD, STAGE, W, AGE_FROM, AGE_TO, DATE_1, DATE_2, SUMV)
           VALUES (33, '0', '1', '1', 66, 66, '2013-06-01', '2014-12-31', 883.37); @
INSERT INTO TARIF (ID, TD, STAGE, W, AGE_FROM, AGE_TO, DATE_1, DATE_2, SUMV)
           VALUES (34, '0', '1', '2', 66, 66, '2013-06-01', '2014-12-31', 1346.37); @
INSERT INTO TARIF (ID, TD, STAGE, W, AGE_FROM, AGE_TO, DATE_1, DATE_2, SUMV)
           VALUES (35, '0', '1', '1', 69, 69, '2013-06-01', '2014-12-31', 1781.84); @
INSERT INTO TARIF (ID, TD, STAGE, W, AGE_FROM, AGE_TO, DATE_1, DATE_2, SUMV)
           VALUES (36, '0', '1', '2', 69, 69, '2013-06-01', '2014-12-31', 2244.84); @
INSERT INTO TARIF (ID, TD, STAGE, W, AGE_FROM, AGE_TO, DATE_1, DATE_2, SUMV)
           VALUES (37, '0', '1', '1', 72, 72, '2013-06-01', '2014-12-31', 883.37); @
INSERT INTO TARIF (ID, TD, STAGE, W, AGE_FROM, AGE_TO, DATE_1, DATE_2, SUMV)
           VALUES (38, '0', '1', '2', 72, 72, '2013-06-01', '2014-12-31', 1346.37); @
INSERT INTO TARIF (ID, TD, STAGE, W, AGE_FROM, AGE_TO, DATE_1, DATE_2, SUMV)
           VALUES (39, '0', '1', '1', 75, 75, '2013-06-01', '2014-12-31', 883.37); @
INSERT INTO TARIF (ID, TD, STAGE, W, AGE_FROM, AGE_TO, DATE_1, DATE_2, SUMV)
           VALUES (40, '0', '1', '2', 75, 75, '2013-06-01', '2014-12-31', 1346.37); @
INSERT INTO TARIF (ID, TD, STAGE, W, AGE_FROM, AGE_TO, DATE_1, DATE_2, SUMV)
           VALUES (41, '0', '1', '1', 78, 78, '2013-06-01', '2014-12-31', 883.37); @
INSERT INTO TARIF (ID, TD, STAGE, W, AGE_FROM, AGE_TO, DATE_1, DATE_2, SUMV)
           VALUES (42, '0', '1', '2', 78, 78, '2013-06-01', '2014-12-31', 1346.37); @
INSERT INTO TARIF (ID, TD, STAGE, W, AGE_FROM, AGE_TO, DATE_1, DATE_2, SUMV)
           VALUES (43, '0', '1', '1', 81, 81, '2013-06-01', '2014-12-31', 883.37); @
INSERT INTO TARIF (ID, TD, STAGE, W, AGE_FROM, AGE_TO, DATE_1, DATE_2, SUMV)
           VALUES (44, '0', '1', '2', 81, 81, '2013-06-01', '2014-12-31', 1346.37); @
INSERT INTO TARIF (ID, TD, STAGE, W, AGE_FROM, AGE_TO, DATE_1, DATE_2, SUMV)
           VALUES (45, '0', '1', '1', 84, 84, '2013-06-01', '2014-12-31', 883.37); @
INSERT INTO TARIF (ID, TD, STAGE, W, AGE_FROM, AGE_TO, DATE_1, DATE_2, SUMV)
           VALUES (46, '0', '1', '2', 84, 84, '2013-06-01', '2014-12-31', 1346.37); @
INSERT INTO TARIF (ID, TD, STAGE, W, AGE_FROM, AGE_TO, DATE_1, DATE_2, SUMV)
           VALUES (47, '0', '1', '1', 87, 87, '2013-06-01', '2014-12-31', 883.37); @
INSERT INTO TARIF (ID, TD, STAGE, W, AGE_FROM, AGE_TO, DATE_1, DATE_2, SUMV)
           VALUES (48, '0', '1', '2', 87, 87, '2013-06-01', '2014-12-31', 1346.37); @
INSERT INTO TARIF (ID, TD, STAGE, W, AGE_FROM, AGE_TO, DATE_1, DATE_2, SUMV)
           VALUES (49, '0', '1', '1', 90, 90, '2013-06-01', '2014-12-31', 883.37); @
INSERT INTO TARIF (ID, TD, STAGE, W, AGE_FROM, AGE_TO, DATE_1, DATE_2, SUMV)
           VALUES (50, '0', '1', '2', 90, 90, '2013-06-01', '2014-12-31', 1346.37); @
INSERT INTO TARIF (ID, TD, STAGE, W, AGE_FROM, AGE_TO, DATE_1, DATE_2, SUMV)
           VALUES (51, '0', '1', '1', 93, 93, '2013-06-01', '2014-12-31', 883.37); @
INSERT INTO TARIF (ID, TD, STAGE, W, AGE_FROM, AGE_TO, DATE_1, DATE_2, SUMV)
           VALUES (52, '0', '1', '2', 93, 93, '2013-06-01', '2014-12-31', 1346.37); @
INSERT INTO TARIF (ID, TD, STAGE, W, AGE_FROM, AGE_TO, DATE_1, DATE_2, SUMV)
           VALUES (53, '0', '1', '1', 96, 96, '2013-06-01', '2014-12-31', 883.37); @
INSERT INTO TARIF (ID, TD, STAGE, W, AGE_FROM, AGE_TO, DATE_1, DATE_2, SUMV)
           VALUES (54, '0', '1', '2', 96, 96, '2013-06-01', '2014-12-31', 1346.37); @
INSERT INTO TARIF (ID, TD, STAGE, W, AGE_FROM, AGE_TO, DATE_1, DATE_2, SUMV)
           VALUES (55, '0', '1', '1', 99, 99, '2013-06-01', '2014-12-31', 883.37); @
INSERT INTO TARIF (ID, TD, STAGE, W, AGE_FROM, AGE_TO, DATE_1, DATE_2, SUMV)
           VALUES (56, '0', '1', '2', 99, 99, '2013-06-01', '2014-12-31', 1346.37); @
INSERT INTO TARIF (ID, TD, STAGE, W, AGE_FROM, AGE_TO, DATE_1, DATE_2, SUMV)
           VALUES (57, '1', '1', '1', 0, 4, '2013-01-01', '2014-05-31', 2313); @
INSERT INTO TARIF (ID, TD, STAGE, W, AGE_FROM, AGE_TO, DATE_1, DATE_2, SUMV)
           VALUES (58, '1', '1', '2', 0, 4, '2013-01-01', '2014-05-31', 2313); @
INSERT INTO TARIF (ID, TD, STAGE, W, AGE_FROM, AGE_TO, DATE_1, DATE_2, SUMV)
           VALUES (59, '1', '1', '1', 5, 17, '2013-01-01', '2014-05-31', 2900); @
INSERT INTO TARIF (ID, TD, STAGE, W, AGE_FROM, AGE_TO, DATE_1, DATE_2, SUMV)
           VALUES (60, '1', '1', '2', 5, 17, '2013-01-01', '2014-05-31', 2900); @
INSERT INTO TARIF (ID, TD, STAGE, W, AGE_FROM, AGE_TO, DATE_1, DATE_2, SUMV)
           VALUES (61, '2', '1', '1', 0, 4, '2013-01-01', '2014-05-31', 2313); @
INSERT INTO TARIF (ID, TD, STAGE, W, AGE_FROM, AGE_TO, DATE_1, DATE_2, SUMV)
           VALUES (62, '2', '1', '2', 0, 4, '2013-01-01', '2014-05-31', 2313); @
INSERT INTO TARIF (ID, TD, STAGE, W, AGE_FROM, AGE_TO, DATE_1, DATE_2, SUMV)
           VALUES (63, '2', '1', '1', 5, 17, '2013-01-01', '2014-05-31', 2900); @
INSERT INTO TARIF (ID, TD, STAGE, W, AGE_FROM, AGE_TO, DATE_1, DATE_2, SUMV)
           VALUES (64, '2', '1', '2', 5, 17, '2013-01-01', '2014-05-31', 2900); @
INSERT INTO TARIF (ID, TD, STAGE, W, AGE_FROM, AGE_TO, DATE_1, DATE_2, SUMV)
           VALUES (65, '7', '1', '0', 0, 17, '2014-01-01', '2014-12-31', 694.95); @
INSERT INTO TARIF (ID, TD, STAGE, W, AGE_FROM, AGE_TO, DATE_1, DATE_2, SUMV)
           VALUES (66, '7', '1', '0', 18, 120, '2014-01-01', '2014-12-31', 639.52); @
INSERT INTO TARIF (ID, TD, STAGE, W, AGE_FROM, AGE_TO, DATE_1, DATE_2, SUMV)
           VALUES (67, '7', '2', '0', 0, 17, '2014-01-01', '2014-12-31', 499.96); @
INSERT INTO TARIF (ID, TD, STAGE, W, AGE_FROM, AGE_TO, DATE_1, DATE_2, SUMV)
           VALUES (68, '7', '2', '0', 18, 120, '2014-01-01', '2014-12-31', 444.53); @
INSERT INTO TARIF (ID, TD, STAGE, W, AGE_FROM, AGE_TO, DATE_1, DATE_2, SUMV)
           VALUES (70, '1', '1', '1', 0, 2, '2014-06-01', '2014-12-31', 2800.97); @
INSERT INTO TARIF (ID, TD, STAGE, W, AGE_FROM, AGE_TO, DATE_1, DATE_2, SUMV)
           VALUES (71, '1', '1', '2', 0, 2, '2014-06-01', '2014-12-31', 2809.89); @
INSERT INTO TARIF (ID, TD, STAGE, W, AGE_FROM, AGE_TO, DATE_1, DATE_2, SUMV)
           VALUES (72, '1', '1', '1', 3, 4, '2014-06-01', '2014-12-31', 2745.37); @
INSERT INTO TARIF (ID, TD, STAGE, W, AGE_FROM, AGE_TO, DATE_1, DATE_2, SUMV)
           VALUES (73, '1', '1', '2', 3, 4, '2014-06-01', '2014-12-31', 2754.29); @
INSERT INTO TARIF (ID, TD, STAGE, W, AGE_FROM, AGE_TO, DATE_1, DATE_2, SUMV)
           VALUES (74, '1', '1', '1', 5, 6, '2014-06-01', '2014-12-31', 3194.93); @
INSERT INTO TARIF (ID, TD, STAGE, W, AGE_FROM, AGE_TO, DATE_1, DATE_2, SUMV)
           VALUES (75, '1', '1', '2', 5, 6, '2014-06-01', '2014-12-31', 3203.85); @
INSERT INTO TARIF (ID, TD, STAGE, W, AGE_FROM, AGE_TO, DATE_1, DATE_2, SUMV)
           VALUES (76, '1', '1', '1', 7, 14, '2014-06-01', '2014-12-31', 3463.7); @
INSERT INTO TARIF (ID, TD, STAGE, W, AGE_FROM, AGE_TO, DATE_1, DATE_2, SUMV)
           VALUES (77, '1', '1', '2', 7, 14, '2014-06-01', '2014-12-31', 3415.78); @
INSERT INTO TARIF (ID, TD, STAGE, W, AGE_FROM, AGE_TO, DATE_1, DATE_2, SUMV)
           VALUES (78, '1', '1', '1', 15, 17, '2014-06-01', '2014-12-31', 3463.7); @
INSERT INTO TARIF (ID, TD, STAGE, W, AGE_FROM, AGE_TO, DATE_1, DATE_2, SUMV)
           VALUES (79, '1', '1', '2', 15, 17, '2014-06-01', '2014-12-31', 3415.78); @
INSERT INTO TARIF (ID, TD, STAGE, W, AGE_FROM, AGE_TO, DATE_1, DATE_2, SUMV)
           VALUES (80, '2', '1', '1', 0, 2, '2014-06-01', '2014-12-31', 2800.97); @
INSERT INTO TARIF (ID, TD, STAGE, W, AGE_FROM, AGE_TO, DATE_1, DATE_2, SUMV)
           VALUES (81, '2', '1', '2', 0, 2, '2014-06-01', '2014-12-31', 2809.89); @
INSERT INTO TARIF (ID, TD, STAGE, W, AGE_FROM, AGE_TO, DATE_1, DATE_2, SUMV)
           VALUES (82, '2', '1', '1', 3, 4, '2014-06-01', '2014-12-31', 2745.37); @
INSERT INTO TARIF (ID, TD, STAGE, W, AGE_FROM, AGE_TO, DATE_1, DATE_2, SUMV)
           VALUES (83, '2', '1', '2', 3, 4, '2014-06-01', '2014-12-31', 2754.29); @
INSERT INTO TARIF (ID, TD, STAGE, W, AGE_FROM, AGE_TO, DATE_1, DATE_2, SUMV)
           VALUES (84, '2', '1', '1', 5, 6, '2014-06-01', '2014-12-31', 3194.93); @
INSERT INTO TARIF (ID, TD, STAGE, W, AGE_FROM, AGE_TO, DATE_1, DATE_2, SUMV)
           VALUES (85, '2', '1', '2', 5, 6, '2014-06-01', '2014-12-31', 3203.85); @
INSERT INTO TARIF (ID, TD, STAGE, W, AGE_FROM, AGE_TO, DATE_1, DATE_2, SUMV)
           VALUES (86, '2', '1', '1', 7, 14, '2014-06-01', '2014-12-31', 3463.7); @
INSERT INTO TARIF (ID, TD, STAGE, W, AGE_FROM, AGE_TO, DATE_1, DATE_2, SUMV)
           VALUES (87, '2', '1', '2', 7, 14, '2014-06-01', '2014-12-31', 3415.78); @
INSERT INTO TARIF (ID, TD, STAGE, W, AGE_FROM, AGE_TO, DATE_1, DATE_2, SUMV)
           VALUES (88, '2', '1', '1', 15, 17, '2014-06-01', '2014-12-31', 3463.7); @
INSERT INTO TARIF (ID, TD, STAGE, W, AGE_FROM, AGE_TO, DATE_1, DATE_2, SUMV)
           VALUES (89, '2', '1', '2', 15, 17, '2014-06-01', '2014-12-31', 3415.78); @
INSERT INTO TARIF (ID, TD, STAGE, W, AGE_FROM, AGE_TO, DATE_1, DATE_2, SUMV)
           VALUES (90, '0', '1', '1', 21, 21, '2015-01-01', NULL, 686.84); @
INSERT INTO TARIF (ID, TD, STAGE, W, AGE_FROM, AGE_TO, DATE_1, DATE_2, SUMV)
           VALUES (91, '0', '1', '1', 24, 24, '2015-01-01', NULL, 686.84); @
INSERT INTO TARIF (ID, TD, STAGE, W, AGE_FROM, AGE_TO, DATE_1, DATE_2, SUMV)
           VALUES (92, '0', '1', '1', 27, 27, '2015-01-01', NULL, 686.84); @
INSERT INTO TARIF (ID, TD, STAGE, W, AGE_FROM, AGE_TO, DATE_1, DATE_2, SUMV)
           VALUES (93, '0', '1', '1', 30, 30, '2015-01-01', NULL, 686.84); @
INSERT INTO TARIF (ID, TD, STAGE, W, AGE_FROM, AGE_TO, DATE_1, DATE_2, SUMV)
           VALUES (94, '0', '1', '1', 33, 33, '2015-01-01', NULL, 686.84); @
INSERT INTO TARIF (ID, TD, STAGE, W, AGE_FROM, AGE_TO, DATE_1, DATE_2, SUMV)
           VALUES (95, '0', '1', '1', 36, 36, '2015-01-01', NULL, 873.27); @
INSERT INTO TARIF (ID, TD, STAGE, W, AGE_FROM, AGE_TO, DATE_1, DATE_2, SUMV)
           VALUES (96, '0', '1', '1', 39, 39, '2015-01-01', NULL, 1916.71); @
INSERT INTO TARIF (ID, TD, STAGE, W, AGE_FROM, AGE_TO, DATE_1, DATE_2, SUMV)
           VALUES (97, '0', '1', '1', 42, 42, '2015-01-01', NULL, 899.79); @
INSERT INTO TARIF (ID, TD, STAGE, W, AGE_FROM, AGE_TO, DATE_1, DATE_2, SUMV)
           VALUES (98, '0', '1', '1', 45, 45, '2015-01-01', NULL, 1930.57); @
INSERT INTO TARIF (ID, TD, STAGE, W, AGE_FROM, AGE_TO, DATE_1, DATE_2, SUMV)
           VALUES (99, '0', '1', '1', 48, 48, '2015-01-01', NULL, 913.65); @
INSERT INTO TARIF (ID, TD, STAGE, W, AGE_FROM, AGE_TO, DATE_1, DATE_2, SUMV)
           VALUES (100, '0', '1', '1', 51, 51, '2015-01-01', NULL, 2297.35); @
INSERT INTO TARIF (ID, TD, STAGE, W, AGE_FROM, AGE_TO, DATE_1, DATE_2, SUMV)
           VALUES (101, '0', '1', '1', 54, 54, '2015-01-01', NULL, 1076.55); @
INSERT INTO TARIF (ID, TD, STAGE, W, AGE_FROM, AGE_TO, DATE_1, DATE_2, SUMV)
           VALUES (102, '0', '1', '1', 57, 57, '2015-01-01', NULL, 2297.35); @
INSERT INTO TARIF (ID, TD, STAGE, W, AGE_FROM, AGE_TO, DATE_1, DATE_2, SUMV)
           VALUES (103, '0', '1', '1', 60, 60, '2015-01-01', NULL, 1076.55); @
INSERT INTO TARIF (ID, TD, STAGE, W, AGE_FROM, AGE_TO, DATE_1, DATE_2, SUMV)
           VALUES (104, '0', '1', '1', 63, 63, '2015-01-01', NULL, 2297.35); @
INSERT INTO TARIF (ID, TD, STAGE, W, AGE_FROM, AGE_TO, DATE_1, DATE_2, SUMV)
           VALUES (105, '0', '1', '1', 66, 66, '2015-01-01', NULL, 1076.55); @
INSERT INTO TARIF (ID, TD, STAGE, W, AGE_FROM, AGE_TO, DATE_1, DATE_2, SUMV)
           VALUES (106, '0', '1', '1', 69, 69, '2015-01-01', NULL, 2297.35); @
INSERT INTO TARIF (ID, TD, STAGE, W, AGE_FROM, AGE_TO, DATE_1, DATE_2, SUMV)
           VALUES (107, '0', '1', '1', 72, 72, '2015-01-01', NULL, 1076.55); @
INSERT INTO TARIF (ID, TD, STAGE, W, AGE_FROM, AGE_TO, DATE_1, DATE_2, SUMV)
           VALUES (108, '0', '1', '1', 75, 75, '2015-01-01', NULL, 2297.35); @
INSERT INTO TARIF (ID, TD, STAGE, W, AGE_FROM, AGE_TO, DATE_1, DATE_2, SUMV)
           VALUES (109, '0', '1', '1', 78, 78, '2015-01-01', NULL, 1076.55); @
INSERT INTO TARIF (ID, TD, STAGE, W, AGE_FROM, AGE_TO, DATE_1, DATE_2, SUMV)
           VALUES (110, '0', '1', '1', 81, 81, '2015-01-01', NULL, 2157.79); @
INSERT INTO TARIF (ID, TD, STAGE, W, AGE_FROM, AGE_TO, DATE_1, DATE_2, SUMV)
           VALUES (111, '0', '1', '1', 84, 84, '2015-01-01', NULL, 1076.55); @
INSERT INTO TARIF (ID, TD, STAGE, W, AGE_FROM, AGE_TO, DATE_1, DATE_2, SUMV)
           VALUES (112, '0', '1', '1', 87, 87, '2015-01-01', NULL, 2157.79); @
INSERT INTO TARIF (ID, TD, STAGE, W, AGE_FROM, AGE_TO, DATE_1, DATE_2, SUMV)
           VALUES (113, '0', '1', '1', 90, 90, '2015-01-01', NULL, 1076.55); @
INSERT INTO TARIF (ID, TD, STAGE, W, AGE_FROM, AGE_TO, DATE_1, DATE_2, SUMV)
           VALUES (114, '0', '1', '1', 93, 93, '2015-01-01', NULL, 2157.79); @
INSERT INTO TARIF (ID, TD, STAGE, W, AGE_FROM, AGE_TO, DATE_1, DATE_2, SUMV)
           VALUES (115, '0', '1', '1', 96, 96, '2015-01-01', NULL, 1076.55); @
INSERT INTO TARIF (ID, TD, STAGE, W, AGE_FROM, AGE_TO, DATE_1, DATE_2, SUMV)
           VALUES (116, '0', '1', '1', 99, 99, '2015-01-01', NULL, 2157.79); @
INSERT INTO TARIF (ID, TD, STAGE, W, AGE_FROM, AGE_TO, DATE_1, DATE_2, SUMV)
           VALUES (117, '0', '1', '2', 21, 21, '2015-01-01', NULL, 951.89); @
INSERT INTO TARIF (ID, TD, STAGE, W, AGE_FROM, AGE_TO, DATE_1, DATE_2, SUMV)
           VALUES (118, '0', '1', '2', 24, 24, '2015-01-01', NULL, 951.89); @
INSERT INTO TARIF (ID, TD, STAGE, W, AGE_FROM, AGE_TO, DATE_1, DATE_2, SUMV)
           VALUES (119, '0', '1', '2', 27, 27, '2015-01-01', NULL, 951.89); @
INSERT INTO TARIF (ID, TD, STAGE, W, AGE_FROM, AGE_TO, DATE_1, DATE_2, SUMV)
           VALUES (120, '0', '1', '2', 30, 30, '2015-01-01', NULL, 951.89); @
INSERT INTO TARIF (ID, TD, STAGE, W, AGE_FROM, AGE_TO, DATE_1, DATE_2, SUMV)
           VALUES (121, '0', '1', '2', 33, 33, '2015-01-01', NULL, 951.89); @
INSERT INTO TARIF (ID, TD, STAGE, W, AGE_FROM, AGE_TO, DATE_1, DATE_2, SUMV)
           VALUES (122, '0', '1', '2', 36, 36, '2015-01-01', NULL, 951.89); @
INSERT INTO TARIF (ID, TD, STAGE, W, AGE_FROM, AGE_TO, DATE_1, DATE_2, SUMV)
           VALUES (123, '0', '1', '2', 39, 39, '2015-01-01', NULL, 2537.43); @
INSERT INTO TARIF (ID, TD, STAGE, W, AGE_FROM, AGE_TO, DATE_1, DATE_2, SUMV)
           VALUES (124, '0', '1', '2', 42, 42, '2015-01-01', NULL, 1520.51); @
INSERT INTO TARIF (ID, TD, STAGE, W, AGE_FROM, AGE_TO, DATE_1, DATE_2, SUMV)
           VALUES (125, '0', '1', '2', 45, 45, '2015-01-01', NULL, 2737.72); @
INSERT INTO TARIF (ID, TD, STAGE, W, AGE_FROM, AGE_TO, DATE_1, DATE_2, SUMV)
           VALUES (126, '0', '1', '2', 48, 48, '2015-01-01', NULL, 1720.8); @
INSERT INTO TARIF (ID, TD, STAGE, W, AGE_FROM, AGE_TO, DATE_1, DATE_2, SUMV)
           VALUES (127, '0', '1', '2', 51, 51, '2015-01-01', NULL, 2941.6); @
INSERT INTO TARIF (ID, TD, STAGE, W, AGE_FROM, AGE_TO, DATE_1, DATE_2, SUMV)
           VALUES (128, '0', '1', '2', 54, 54, '2015-01-01', NULL, 1720.8); @
INSERT INTO TARIF (ID, TD, STAGE, W, AGE_FROM, AGE_TO, DATE_1, DATE_2, SUMV)
           VALUES (129, '0', '1', '2', 57, 57, '2015-01-01', NULL, 2941.6); @
INSERT INTO TARIF (ID, TD, STAGE, W, AGE_FROM, AGE_TO, DATE_1, DATE_2, SUMV)
           VALUES (130, '0', '1', '2', 60, 60, '2015-01-01', NULL, 1720.8); @
INSERT INTO TARIF (ID, TD, STAGE, W, AGE_FROM, AGE_TO, DATE_1, DATE_2, SUMV)
           VALUES (131, '0', '1', '2', 63, 63, '2015-01-01', NULL, 2941.6); @
INSERT INTO TARIF (ID, TD, STAGE, W, AGE_FROM, AGE_TO, DATE_1, DATE_2, SUMV)
           VALUES (132, '0', '1', '2', 66, 66, '2015-01-01', NULL, 1720.8); @
INSERT INTO TARIF (ID, TD, STAGE, W, AGE_FROM, AGE_TO, DATE_1, DATE_2, SUMV)
           VALUES (133, '0', '1', '2', 69, 69, '2015-01-01', NULL, 2941.6); @
INSERT INTO TARIF (ID, TD, STAGE, W, AGE_FROM, AGE_TO, DATE_1, DATE_2, SUMV)
           VALUES (134, '0', '1', '2', 72, 72, '2015-01-01', NULL, 1720.8); @
INSERT INTO TARIF (ID, TD, STAGE, W, AGE_FROM, AGE_TO, DATE_1, DATE_2, SUMV)
           VALUES (135, '0', '1', '2', 75, 75, '2015-01-01', NULL, 2941.6); @
INSERT INTO TARIF (ID, TD, STAGE, W, AGE_FROM, AGE_TO, DATE_1, DATE_2, SUMV)
           VALUES (136, '0', '1', '2', 78, 78, '2015-01-01', NULL, 1720.8); @
INSERT INTO TARIF (ID, TD, STAGE, W, AGE_FROM, AGE_TO, DATE_1, DATE_2, SUMV)
           VALUES (137, '0', '1', '2', 81, 81, '2015-01-01', NULL, 2941.6); @
INSERT INTO TARIF (ID, TD, STAGE, W, AGE_FROM, AGE_TO, DATE_1, DATE_2, SUMV)
           VALUES (138, '0', '1', '2', 84, 84, '2015-01-01', NULL, 1720.8); @
INSERT INTO TARIF (ID, TD, STAGE, W, AGE_FROM, AGE_TO, DATE_1, DATE_2, SUMV)
           VALUES (139, '0', '1', '2', 87, 87, '2015-01-01', NULL, 2941.6); @
INSERT INTO TARIF (ID, TD, STAGE, W, AGE_FROM, AGE_TO, DATE_1, DATE_2, SUMV)
           VALUES (140, '0', '1', '2', 90, 90, '2015-01-01', NULL, 1720.8); @
INSERT INTO TARIF (ID, TD, STAGE, W, AGE_FROM, AGE_TO, DATE_1, DATE_2, SUMV)
           VALUES (141, '0', '1', '2', 93, 93, '2015-01-01', NULL, 2941.6); @
INSERT INTO TARIF (ID, TD, STAGE, W, AGE_FROM, AGE_TO, DATE_1, DATE_2, SUMV)
           VALUES (142, '0', '1', '2', 96, 96, '2015-01-01', NULL, 1720.8); @
INSERT INTO TARIF (ID, TD, STAGE, W, AGE_FROM, AGE_TO, DATE_1, DATE_2, SUMV)
           VALUES (143, '0', '1', '2', 99, 99, '2015-01-01', NULL, 2941.6); @
INSERT INTO TARIF (ID, TD, STAGE, W, AGE_FROM, AGE_TO, DATE_1, DATE_2, SUMV)
           VALUES (144, '1', '1', '1', 0, 2, '2015-01-01', NULL, 4353.61); @
INSERT INTO TARIF (ID, TD, STAGE, W, AGE_FROM, AGE_TO, DATE_1, DATE_2, SUMV)
           VALUES (145, '1', '1', '2', 0, 2, '2015-01-01', NULL, 4368.44); @
INSERT INTO TARIF (ID, TD, STAGE, W, AGE_FROM, AGE_TO, DATE_1, DATE_2, SUMV)
           VALUES (146, '1', '1', '1', 3, 4, '2015-01-01', NULL, 4210.74); @
INSERT INTO TARIF (ID, TD, STAGE, W, AGE_FROM, AGE_TO, DATE_1, DATE_2, SUMV)
           VALUES (147, '1', '1', '2', 3, 4, '2015-01-01', NULL, 4225.57); @
INSERT INTO TARIF (ID, TD, STAGE, W, AGE_FROM, AGE_TO, DATE_1, DATE_2, SUMV)
           VALUES (148, '1', '1', '1', 5, 6, '2015-01-01', NULL, 4958.45); @
INSERT INTO TARIF (ID, TD, STAGE, W, AGE_FROM, AGE_TO, DATE_1, DATE_2, SUMV)
           VALUES (149, '1', '1', '2', 5, 6, '2015-01-01', NULL, 4973.28); @
INSERT INTO TARIF (ID, TD, STAGE, W, AGE_FROM, AGE_TO, DATE_1, DATE_2, SUMV)
           VALUES (150, '1', '1', '1', 7, 14, '2015-01-01', NULL, 5445.89); @
INSERT INTO TARIF (ID, TD, STAGE, W, AGE_FROM, AGE_TO, DATE_1, DATE_2, SUMV)
           VALUES (151, '1', '1', '2', 7, 14, '2015-01-01', NULL, 5360.14); @
INSERT INTO TARIF (ID, TD, STAGE, W, AGE_FROM, AGE_TO, DATE_1, DATE_2, SUMV)
           VALUES (152, '1', '1', '1', 15, 17, '2015-01-01', NULL, 5445.89); @
INSERT INTO TARIF (ID, TD, STAGE, W, AGE_FROM, AGE_TO, DATE_1, DATE_2, SUMV)
           VALUES (153, '1', '1', '2', 15, 17, '2015-01-01', NULL, 5360.14); @
INSERT INTO TARIF (ID, TD, STAGE, W, AGE_FROM, AGE_TO, DATE_1, DATE_2, SUMV)
           VALUES (154, '2', '1', '1', 0, 2, '2015-01-01', NULL, 4353.61); @
INSERT INTO TARIF (ID, TD, STAGE, W, AGE_FROM, AGE_TO, DATE_1, DATE_2, SUMV)
           VALUES (155, '2', '1', '2', 0, 2, '2015-01-01', NULL, 4368.44); @
INSERT INTO TARIF (ID, TD, STAGE, W, AGE_FROM, AGE_TO, DATE_1, DATE_2, SUMV)
           VALUES (156, '2', '1', '1', 3, 4, '2015-01-01', NULL, 4210.74); @
INSERT INTO TARIF (ID, TD, STAGE, W, AGE_FROM, AGE_TO, DATE_1, DATE_2, SUMV)
           VALUES (157, '2', '1', '2', 3, 4, '2015-01-01', NULL, 4225.57); @
INSERT INTO TARIF (ID, TD, STAGE, W, AGE_FROM, AGE_TO, DATE_1, DATE_2, SUMV)
           VALUES (158, '2', '1', '1', 5, 6, '2015-01-01', NULL, 4958.45); @
INSERT INTO TARIF (ID, TD, STAGE, W, AGE_FROM, AGE_TO, DATE_1, DATE_2, SUMV)
           VALUES (159, '2', '1', '2', 5, 6, '2015-01-01', NULL, 4973.28); @
INSERT INTO TARIF (ID, TD, STAGE, W, AGE_FROM, AGE_TO, DATE_1, DATE_2, SUMV)
           VALUES (160, '2', '1', '1', 7, 14, '2015-01-01', NULL, 5445.89); @
INSERT INTO TARIF (ID, TD, STAGE, W, AGE_FROM, AGE_TO, DATE_1, DATE_2, SUMV)
           VALUES (161, '2', '1', '2', 7, 14, '2015-01-01', NULL, 5360.14); @
INSERT INTO TARIF (ID, TD, STAGE, W, AGE_FROM, AGE_TO, DATE_1, DATE_2, SUMV)
           VALUES (162, '2', '1', '1', 15, 17, '2015-01-01', NULL, 5445.89); @
INSERT INTO TARIF (ID, TD, STAGE, W, AGE_FROM, AGE_TO, DATE_1, DATE_2, SUMV)
           VALUES (163, '2', '1', '2', 15, 17, '2015-01-01', NULL, 5360.14); @
INSERT INTO TARIF (ID, TD, STAGE, W, AGE_FROM, AGE_TO, DATE_1, DATE_2, SUMV)
           VALUES (164, '7', '1', '0', 0, 17, '2015-01-01', NULL, 1103.31); @
INSERT INTO TARIF (ID, TD, STAGE, W, AGE_FROM, AGE_TO, DATE_1, DATE_2, SUMV)
           VALUES (165, '7', '1', '0', 18, 120, '2015-01-01', NULL, 1015.31); @
INSERT INTO TARIF (ID, TD, STAGE, W, AGE_FROM, AGE_TO, DATE_1, DATE_2, SUMV)
           VALUES (166, '7', '2', '0', 0, 17, '2015-01-01', NULL, 793.74); @
INSERT INTO TARIF (ID, TD, STAGE, W, AGE_FROM, AGE_TO, DATE_1, DATE_2, SUMV)
           VALUES (167, '7', '2', '0', 18, 120, '2015-01-01', NULL, 705.74); @

COMMIT WORK; @       